#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 3224
#define LARGE_STATE_COUNT 630
#define SYMBOL_COUNT 310
#define ALIAS_COUNT 8
#define TOKEN_COUNT 143
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 38
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  sym_jsx_text = 48,
  sym_jsx_identifier = 49,
  anon_sym_DOT = 50,
  anon_sym_class = 51,
  anon_sym_async = 52,
  anon_sym_function = 53,
  anon_sym_EQ_GT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_QMARK = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_GT_GT = 72,
  anon_sym_GT_GT_GT = 73,
  anon_sym_LT_LT = 74,
  anon_sym_AMP = 75,
  anon_sym_CARET = 76,
  anon_sym_PIPE = 77,
  anon_sym_PLUS = 78,
  anon_sym_DASH = 79,
  anon_sym_PERCENT = 80,
  anon_sym_STAR_STAR = 81,
  anon_sym_LT_EQ = 82,
  anon_sym_EQ_EQ = 83,
  anon_sym_EQ_EQ_EQ = 84,
  anon_sym_BANG_EQ = 85,
  anon_sym_BANG_EQ_EQ = 86,
  anon_sym_GT_EQ = 87,
  anon_sym_QMARK_QMARK = 88,
  anon_sym_instanceof = 89,
  anon_sym_BANG = 90,
  anon_sym_TILDE = 91,
  anon_sym_void = 92,
  anon_sym_delete = 93,
  anon_sym_PLUS_PLUS = 94,
  anon_sym_DASH_DASH = 95,
  anon_sym_DQUOTE = 96,
  aux_sym_string_token1 = 97,
  anon_sym_SQUOTE = 98,
  aux_sym_string_token2 = 99,
  sym_escape_sequence = 100,
  sym_comment = 101,
  anon_sym_BQUOTE = 102,
  anon_sym_DOLLAR_LBRACE = 103,
  anon_sym_SLASH2 = 104,
  sym_regex_pattern = 105,
  sym_regex_flags = 106,
  sym_number = 107,
  anon_sym_target = 108,
  sym_this = 109,
  sym_super = 110,
  sym_true = 111,
  sym_false = 112,
  sym_null = 113,
  sym_undefined = 114,
  anon_sym_AT = 115,
  anon_sym_static = 116,
  anon_sym_abstract = 117,
  anon_sym_get = 118,
  anon_sym_set = 119,
  anon_sym_declare = 120,
  anon_sym_public = 121,
  anon_sym_private = 122,
  anon_sym_protected = 123,
  anon_sym_module = 124,
  anon_sym_any = 125,
  anon_sym_number = 126,
  anon_sym_boolean = 127,
  anon_sym_string = 128,
  anon_sym_symbol = 129,
  anon_sym_require = 130,
  anon_sym_implements = 131,
  anon_sym_global = 132,
  anon_sym_interface = 133,
  anon_sym_extends = 134,
  anon_sym_enum = 135,
  sym_readonly = 136,
  anon_sym_is = 137,
  anon_sym_keyof = 138,
  anon_sym_LBRACE_PIPE = 139,
  anon_sym_PIPE_RBRACE = 140,
  sym__automatic_semicolon = 141,
  sym__template_chars = 142,
  sym_program = 143,
  sym_export_statement = 144,
  sym_export_clause = 145,
  sym__import_export_specifier = 146,
  sym__declaration = 147,
  sym_import = 148,
  sym_import_statement = 149,
  sym_import_clause = 150,
  sym__from_clause = 151,
  sym_namespace_import = 152,
  sym_named_imports = 153,
  sym_expression_statement = 154,
  sym_variable_declaration = 155,
  sym_lexical_declaration = 156,
  sym_variable_declarator = 157,
  sym_statement_block = 158,
  sym_if_statement = 159,
  sym_switch_statement = 160,
  sym_for_statement = 161,
  sym_for_in_statement = 162,
  sym__for_header = 163,
  sym_while_statement = 164,
  sym_do_statement = 165,
  sym_try_statement = 166,
  sym_with_statement = 167,
  sym_break_statement = 168,
  sym_continue_statement = 169,
  sym_debugger_statement = 170,
  sym_return_statement = 171,
  sym_throw_statement = 172,
  sym_empty_statement = 173,
  sym_labeled_statement = 174,
  sym_switch_body = 175,
  sym_switch_case = 176,
  sym_switch_default = 177,
  sym_catch_clause = 178,
  sym_finally_clause = 179,
  sym_parenthesized_expression = 180,
  sym__expression = 181,
  sym_yield_expression = 182,
  sym_object = 183,
  sym_assignment_pattern = 184,
  sym_array = 185,
  sym_jsx_element = 186,
  sym_jsx_fragment = 187,
  sym_jsx_expression = 188,
  sym_jsx_opening_element = 189,
  sym_nested_identifier = 190,
  sym_jsx_namespace_name = 191,
  sym_jsx_closing_element = 192,
  sym_jsx_self_closing_element = 193,
  sym_jsx_attribute = 194,
  sym_class = 195,
  sym_class_declaration = 196,
  sym_class_heritage = 197,
  sym_function = 198,
  sym_function_declaration = 199,
  sym_generator_function = 200,
  sym_generator_function_declaration = 201,
  sym_arrow_function = 202,
  sym__call_signature = 203,
  sym_call_expression = 204,
  sym_new_expression = 205,
  sym_await_expression = 206,
  sym_member_expression = 207,
  sym_subscript_expression = 208,
  sym_assignment_expression = 209,
  sym_augmented_assignment_expression = 210,
  sym__initializer = 211,
  sym_spread_element = 212,
  sym_ternary_expression = 213,
  sym_binary_expression = 214,
  sym_unary_expression = 215,
  sym_update_expression = 216,
  sym_sequence_expression = 217,
  sym_string = 218,
  sym_template_string = 219,
  sym_template_substitution = 220,
  sym_regex = 221,
  sym_meta_property = 222,
  sym_arguments = 223,
  sym_decorator = 224,
  sym_decorator_member_expression = 225,
  sym_decorator_call_expression = 226,
  sym_class_body = 227,
  sym_public_field_definition = 228,
  sym_formal_parameters = 229,
  sym_rest_parameter = 230,
  sym_method_definition = 231,
  sym_pair = 232,
  sym__property_name = 233,
  sym_computed_property_name = 234,
  sym_non_null_expression = 235,
  sym_method_signature = 236,
  sym_abstract_method_signature = 237,
  sym_function_signature = 238,
  sym_as_expression = 239,
  sym_import_require_clause = 240,
  sym_implements_clause = 241,
  sym_ambient_declaration = 242,
  sym_abstract_class_declaration = 243,
  sym_module = 244,
  sym_internal_module = 245,
  sym__module = 246,
  sym_import_alias = 247,
  sym_nested_type_identifier = 248,
  sym_interface_declaration = 249,
  sym_extends_clause = 250,
  sym_enum_declaration = 251,
  sym_enum_body = 252,
  sym_enum_assignment = 253,
  sym_type_alias_declaration = 254,
  sym_accessibility_modifier = 255,
  sym_required_parameter = 256,
  sym_optional_parameter = 257,
  sym__parameter_name = 258,
  sym_type_annotation = 259,
  sym__type = 260,
  sym_constructor_type = 261,
  sym__primary_type = 262,
  sym_generic_type = 263,
  sym_type_predicate = 264,
  sym_type_query = 265,
  sym_index_type_query = 266,
  sym_lookup_type = 267,
  sym_mapped_type_clause = 268,
  sym_literal_type = 269,
  sym__number = 270,
  sym_existential_type = 271,
  sym_flow_maybe_type = 272,
  sym_parenthesized_type = 273,
  sym_predefined_type = 274,
  sym_type_arguments = 275,
  sym_object_type = 276,
  sym_call_signature = 277,
  sym_property_signature = 278,
  sym_type_parameters = 279,
  sym_type_parameter = 280,
  sym_default_type = 281,
  sym_constraint = 282,
  sym_construct_signature = 283,
  sym_index_signature = 284,
  sym_array_type = 285,
  sym_tuple_type = 286,
  sym_union_type = 287,
  sym_intersection_type = 288,
  sym_function_type = 289,
  aux_sym_program_repeat1 = 290,
  aux_sym_export_statement_repeat1 = 291,
  aux_sym_export_clause_repeat1 = 292,
  aux_sym_named_imports_repeat1 = 293,
  aux_sym_variable_declaration_repeat1 = 294,
  aux_sym_switch_body_repeat1 = 295,
  aux_sym_object_repeat1 = 296,
  aux_sym_array_repeat1 = 297,
  aux_sym_jsx_element_repeat1 = 298,
  aux_sym_jsx_opening_element_repeat1 = 299,
  aux_sym_string_repeat1 = 300,
  aux_sym_string_repeat2 = 301,
  aux_sym_template_string_repeat1 = 302,
  aux_sym_class_body_repeat1 = 303,
  aux_sym_formal_parameters_repeat1 = 304,
  aux_sym_implements_clause_repeat1 = 305,
  aux_sym_extends_clause_repeat1 = 306,
  aux_sym_enum_body_repeat1 = 307,
  aux_sym_object_type_repeat1 = 308,
  aux_sym_type_parameters_repeat1 = 309,
  alias_sym_array_pattern = 310,
  alias_sym_export_specifier = 311,
  alias_sym_import_specifier = 312,
  alias_sym_object_pattern = 313,
  alias_sym_property_identifier = 314,
  alias_sym_shorthand_property_identifier = 315,
  alias_sym_statement_identifier = 316,
  alias_sym_type_identifier = 317,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "??",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH2,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_enum] = anon_sym_enum,
  [sym_readonly] = sym_readonly,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_clause] = sym_extends_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_type_annotation] = sym_type_annotation,
  [sym__type] = sym__type,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_jsx_opening_element_repeat1] = aux_sym_jsx_opening_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_export_specifier] = alias_sym_export_specifier,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_module = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_return_type = 32,
  field_right = 33,
  field_source = 34,
  field_type = 35,
  field_type_arguments = 36,
  field_type_parameters = 37,
  field_value = 38,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[190] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 1},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 27, .length = 2},
  [28] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 33, .length = 2},
  [32] = {.index = 31, .length = 2},
  [33] = {.index = 33, .length = 2},
  [34] = {.index = 31, .length = 2},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 2},
  [38] = {.index = 39, .length = 3},
  [41] = {.index = 42, .length = 1},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 2},
  [46] = {.index = 51, .length = 1},
  [47] = {.index = 52, .length = 1},
  [48] = {.index = 53, .length = 1},
  [49] = {.index = 54, .length = 1},
  [50] = {.index = 55, .length = 2},
  [52] = {.index = 57, .length = 1},
  [53] = {.index = 58, .length = 2},
  [54] = {.index = 60, .length = 4},
  [55] = {.index = 64, .length = 2},
  [56] = {.index = 64, .length = 2},
  [57] = {.index = 22, .length = 2},
  [58] = {.index = 25, .length = 2},
  [59] = {.index = 27, .length = 2},
  [60] = {.index = 66, .length = 3},
  [61] = {.index = 10, .length = 2},
  [62] = {.index = 55, .length = 2},
  [63] = {.index = 69, .length = 3},
  [64] = {.index = 22, .length = 2},
  [65] = {.index = 22, .length = 2},
  [66] = {.index = 72, .length = 2},
  [67] = {.index = 74, .length = 4},
  [68] = {.index = 78, .length = 3},
  [69] = {.index = 81, .length = 2},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 1},
  [72] = {.index = 85, .length = 1},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 22, .length = 2},
  [75] = {.index = 88, .length = 2},
  [76] = {.index = 90, .length = 5},
  [77] = {.index = 86, .length = 2},
  [78] = {.index = 95, .length = 1},
  [79] = {.index = 96, .length = 3},
  [80] = {.index = 96, .length = 3},
  [81] = {.index = 96, .length = 3},
  [82] = {.index = 99, .length = 2},
  [83] = {.index = 101, .length = 3},
  [87] = {.index = 104, .length = 1},
  [88] = {.index = 105, .length = 3},
  [89] = {.index = 108, .length = 2},
  [90] = {.index = 110, .length = 2},
  [91] = {.index = 112, .length = 2},
  [92] = {.index = 114, .length = 2},
  [93] = {.index = 116, .length = 4},
  [94] = {.index = 120, .length = 2},
  [95] = {.index = 122, .length = 3},
  [96] = {.index = 125, .length = 3},
  [97] = {.index = 128, .length = 2},
  [98] = {.index = 130, .length = 2},
  [99] = {.index = 132, .length = 4},
  [100] = {.index = 130, .length = 2},
  [101] = {.index = 136, .length = 4},
  [102] = {.index = 140, .length = 4},
  [103] = {.index = 144, .length = 5},
  [104] = {.index = 149, .length = 2},
  [105] = {.index = 99, .length = 2},
  [106] = {.index = 151, .length = 3},
  [107] = {.index = 154, .length = 2},
  [108] = {.index = 156, .length = 3},
  [109] = {.index = 159, .length = 2},
  [110] = {.index = 161, .length = 5},
  [111] = {.index = 166, .length = 2},
  [112] = {.index = 168, .length = 1},
  [113] = {.index = 169, .length = 3},
  [114] = {.index = 172, .length = 1},
  [115] = {.index = 173, .length = 1},
  [116] = {.index = 174, .length = 1},
  [117] = {.index = 175, .length = 2},
  [118] = {.index = 177, .length = 3},
  [119] = {.index = 180, .length = 1},
  [120] = {.index = 181, .length = 2},
  [121] = {.index = 183, .length = 2},
  [122] = {.index = 185, .length = 4},
  [123] = {.index = 189, .length = 2},
  [124] = {.index = 191, .length = 2},
  [125] = {.index = 193, .length = 3},
  [126] = {.index = 196, .length = 2},
  [127] = {.index = 198, .length = 4},
  [128] = {.index = 202, .length = 4},
  [129] = {.index = 206, .length = 5},
  [130] = {.index = 211, .length = 2},
  [131] = {.index = 213, .length = 3},
  [132] = {.index = 216, .length = 3},
  [133] = {.index = 219, .length = 2},
  [134] = {.index = 221, .length = 3},
  [135] = {.index = 224, .length = 4},
  [136] = {.index = 228, .length = 3},
  [137] = {.index = 231, .length = 2},
  [138] = {.index = 233, .length = 5},
  [139] = {.index = 238, .length = 3},
  [140] = {.index = 241, .length = 2},
  [141] = {.index = 241, .length = 2},
  [142] = {.index = 243, .length = 3},
  [143] = {.index = 241, .length = 2},
  [144] = {.index = 241, .length = 2},
  [145] = {.index = 246, .length = 2},
  [146] = {.index = 248, .length = 4},
  [147] = {.index = 252, .length = 2},
  [148] = {.index = 254, .length = 2},
  [149] = {.index = 256, .length = 2},
  [150] = {.index = 258, .length = 2},
  [151] = {.index = 260, .length = 3},
  [152] = {.index = 263, .length = 3},
  [153] = {.index = 266, .length = 1},
  [154] = {.index = 267, .length = 5},
  [155] = {.index = 272, .length = 3},
  [157] = {.index = 275, .length = 4},
  [158] = {.index = 279, .length = 5},
  [159] = {.index = 284, .length = 2},
  [160] = {.index = 284, .length = 2},
  [161] = {.index = 284, .length = 2},
  [162] = {.index = 284, .length = 2},
  [163] = {.index = 286, .length = 4},
  [164] = {.index = 290, .length = 2},
  [165] = {.index = 290, .length = 2},
  [166] = {.index = 290, .length = 2},
  [167] = {.index = 292, .length = 4},
  [168] = {.index = 296, .length = 4},
  [169] = {.index = 300, .length = 2},
  [170] = {.index = 302, .length = 2},
  [171] = {.index = 304, .length = 3},
  [172] = {.index = 307, .length = 3},
  [173] = {.index = 310, .length = 2},
  [174] = {.index = 312, .length = 2},
  [175] = {.index = 314, .length = 5},
  [176] = {.index = 319, .length = 5},
  [177] = {.index = 324, .length = 4},
  [178] = {.index = 328, .length = 4},
  [179] = {.index = 332, .length = 3},
  [180] = {.index = 335, .length = 2},
  [181] = {.index = 337, .length = 2},
  [182] = {.index = 339, .length = 3},
  [183] = {.index = 342, .length = 5},
  [184] = {.index = 347, .length = 5},
  [185] = {.index = 352, .length = 4},
  [186] = {.index = 356, .length = 4},
  [187] = {.index = 360, .length = 3},
  [188] = {.index = 363, .length = 5},
  [189] = {.index = 368, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [16] =
    {field_parameters, 0},
    {field_return_type, 1},
  [18] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [20] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_label, 0},
  [25] =
    {field_object, 0},
    {field_property, 2},
  [27] =
    {field_body, 2},
    {field_parameter, 0},
  [29] =
    {field_body, 1},
    {field_name, 0},
  [31] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [33] =
    {field_name, 0},
    {field_type, 1},
  [35] =
    {field_condition, 1},
    {field_consequence, 2},
  [37] =
    {field_body, 2},
    {field_value, 1},
  [39] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [42] =
    {field_value, 1, .inherited = true},
  [43] =
    {field_body, 2},
    {field_condition, 1},
  [45] =
    {field_body, 1},
    {field_handler, 2},
  [47] =
    {field_body, 1},
    {field_finalizer, 2},
  [49] =
    {field_body, 2},
    {field_object, 1},
  [51] =
    {field_label, 1},
  [52] =
    {field_name, 1},
  [53] =
    {field_attribute, 0},
  [54] =
    {field_pattern, 1},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_body, 2},
  [58] =
    {field_body, 2},
    {field_type_parameters, 1},
  [60] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [64] =
    {field_arguments, 2},
    {field_constructor, 1},
  [66] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [69] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [72] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [74] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [78] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [81] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [83] =
    {field_source, 1},
  [84] =
    {field_source, 2, .inherited = true},
  [85] =
    {field_value, 2},
  [86] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [88] =
    {field_key, 0},
    {field_value, 2},
  [90] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [95] =
    {field_value, 1},
  [96] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [99] =
    {field_body, 3},
    {field_name, 2},
  [101] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [104] =
    {field_value, 2, .inherited = true},
  [105] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [108] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [110] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [112] =
    {field_name, 1},
    {field_type_arguments, 2},
  [114] =
    {field_flags, 3},
    {field_pattern, 1},
  [116] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [120] =
    {field_body, 3},
    {field_name, 1},
  [122] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [125] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [128] =
    {field_body, 3},
    {field_type_parameters, 1},
  [130] =
    {field_body, 3},
    {field_parameter, 1},
  [132] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [136] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [140] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [144] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [149] =
    {field_index, 2},
    {field_object, 0},
  [151] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [154] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [156] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [159] =
    {field_alias, 2},
    {field_name, 0},
  [161] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [166] =
    {field_name, 1},
    {field_value, 3},
  [168] =
    {field_source, 3, .inherited = true},
  [169] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [172] =
    {field_decorator, 1, .inherited = true},
  [173] =
    {field_decorator, 2, .inherited = true},
  [174] =
    {field_value, 3, .inherited = true},
  [175] =
    {field_body, 1},
    {field_condition, 3},
  [177] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [180] =
    {field_name, 2},
  [181] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [183] =
    {field_name, 1},
    {field_type, 2},
  [185] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [189] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [191] =
    {field_name, 0},
    {field_type, 2},
  [193] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [196] =
    {field_module, 0},
    {field_name, 2},
  [198] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [202] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [206] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [211] =
    {field_body, 4},
    {field_name, 2},
  [213] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [216] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [219] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [221] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [224] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [228] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [231] =
    {field_alias, 3},
    {field_name, 1},
  [233] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [238] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [241] =
    {field_left, 1},
    {field_right, 3},
  [243] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [246] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [248] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [252] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [254] =
    {field_name, 2},
    {field_type, 3},
  [256] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [258] =
    {field_name, 1},
    {field_type, 3},
  [260] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [263] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [266] =
    {field_name, 3},
  [267] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [272] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [275] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [279] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [284] =
    {field_left, 2},
    {field_right, 4},
  [286] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [290] =
    {field_body, 4},
    {field_parameter, 2},
  [292] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [296] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [300] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [302] =
    {field_name, 2},
    {field_type, 4},
  [304] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [307] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [310] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [312] =
    {field_name, 3},
    {field_type, 4},
  [314] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [319] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [324] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [328] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [332] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [335] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [337] =
    {field_name, 3},
    {field_type, 5},
  [339] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [342] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [347] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [352] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [356] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [360] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [363] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [368] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[190][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [24] = {
    [0] = sym_identifier,
  },
  [25] = {
    [0] = alias_sym_statement_identifier,
  },
  [26] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_object_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [35] = {
    [0] = alias_sym_array_pattern,
  },
  [39] = {
    [1] = alias_sym_object_pattern,
  },
  [40] = {
    [1] = alias_sym_array_pattern,
  },
  [46] = {
    [1] = alias_sym_statement_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [55] = {
    [1] = sym_identifier,
  },
  [58] = {
    [2] = alias_sym_property_identifier,
  },
  [61] = {
    [0] = sym_identifier,
  },
  [64] = {
    [0] = alias_sym_object_pattern,
  },
  [65] = {
    [0] = alias_sym_array_pattern,
  },
  [73] = {
    [1] = alias_sym_export_specifier,
  },
  [74] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [77] = {
    [1] = alias_sym_import_specifier,
  },
  [80] = {
    [0] = alias_sym_object_pattern,
  },
  [81] = {
    [0] = alias_sym_array_pattern,
  },
  [84] = {
    [2] = sym_identifier,
  },
  [85] = {
    [2] = alias_sym_object_pattern,
  },
  [86] = {
    [2] = alias_sym_array_pattern,
  },
  [94] = {
    [1] = alias_sym_type_identifier,
  },
  [95] = {
    [1] = alias_sym_type_identifier,
  },
  [98] = {
    [1] = sym_identifier,
  },
  [105] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [2] = alias_sym_type_identifier,
  },
  [111] = {
    [1] = alias_sym_type_identifier,
  },
  [125] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [2] = alias_sym_type_identifier,
  },
  [130] = {
    [2] = alias_sym_type_identifier,
  },
  [131] = {
    [2] = alias_sym_type_identifier,
  },
  [134] = {
    [2] = alias_sym_type_identifier,
  },
  [135] = {
    [2] = alias_sym_type_identifier,
  },
  [139] = {
    [1] = alias_sym_type_identifier,
  },
  [140] = {
    [1] = sym_identifier,
  },
  [143] = {
    [1] = alias_sym_object_pattern,
  },
  [144] = {
    [1] = alias_sym_array_pattern,
  },
  [155] = {
    [2] = alias_sym_type_identifier,
  },
  [156] = {
    [3] = alias_sym_property_identifier,
  },
  [157] = {
    [2] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = sym_identifier,
  },
  [161] = {
    [2] = alias_sym_object_pattern,
  },
  [162] = {
    [2] = alias_sym_array_pattern,
  },
  [165] = {
    [2] = alias_sym_object_pattern,
  },
  [166] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(64)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0) ADVANCE(199);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(170);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(166);
      if (lookahead == '\r') ADVANCE(173);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(172);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(163);
      if (lookahead != 0) ADVANCE(164);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(159);
      if (lookahead == '\r') ADVANCE(174);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(172);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(28)
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(184);
      if (lookahead != 0) ADVANCE(185);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(199);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(199);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(199);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(199);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(199);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(199);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(199);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(68);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(153);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(199);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(199);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(199);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(46);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(197);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead)) ADVANCE(199);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 20:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(197);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead)) ADVANCE(199);
      END_STATE();
    case 22:
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(180);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(114);
      END_STATE();
    case 28:
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(28)
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 30:
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 31:
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == ']') ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(172);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(172);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(182);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 43:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(190);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(191);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(199);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(192);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(175);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 62:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 63:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(185);
      END_STATE();
    case 64:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(64)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0) ADVANCE(199);
      END_STATE();
    case 65:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(154);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(65)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(199);
      END_STATE();
    case 66:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(153);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(199);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(144);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(147);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(201);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(180);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(180);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(94);
      if (lookahead == '/') ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(93);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead != 0) ADVANCE(94);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(93);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead != 0) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(152);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(117);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(118);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(118);
      if (lookahead == '}') ADVANCE(202);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(118);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(118);
      if (lookahead == '}') ADVANCE(202);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(202);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(156);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(156);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(157);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(162);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(164);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(161);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(169);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(166);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(159);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(199);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(172);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(176);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(180);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(185);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(33);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(199);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(196);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(44);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(51);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(187);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(196);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(187);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(199);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(199);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 66},
  [2] = {.lex_state = 66},
  [3] = {.lex_state = 66},
  [4] = {.lex_state = 66},
  [5] = {.lex_state = 66},
  [6] = {.lex_state = 66},
  [7] = {.lex_state = 66},
  [8] = {.lex_state = 66},
  [9] = {.lex_state = 66},
  [10] = {.lex_state = 66},
  [11] = {.lex_state = 66},
  [12] = {.lex_state = 66},
  [13] = {.lex_state = 66},
  [14] = {.lex_state = 66},
  [15] = {.lex_state = 66},
  [16] = {.lex_state = 66},
  [17] = {.lex_state = 66},
  [18] = {.lex_state = 66},
  [19] = {.lex_state = 66},
  [20] = {.lex_state = 66},
  [21] = {.lex_state = 66},
  [22] = {.lex_state = 66},
  [23] = {.lex_state = 66},
  [24] = {.lex_state = 66},
  [25] = {.lex_state = 66},
  [26] = {.lex_state = 66},
  [27] = {.lex_state = 66},
  [28] = {.lex_state = 66},
  [29] = {.lex_state = 66},
  [30] = {.lex_state = 66},
  [31] = {.lex_state = 66},
  [32] = {.lex_state = 66},
  [33] = {.lex_state = 66},
  [34] = {.lex_state = 66},
  [35] = {.lex_state = 66},
  [36] = {.lex_state = 66},
  [37] = {.lex_state = 66},
  [38] = {.lex_state = 66},
  [39] = {.lex_state = 66},
  [40] = {.lex_state = 66},
  [41] = {.lex_state = 66},
  [42] = {.lex_state = 66},
  [43] = {.lex_state = 66},
  [44] = {.lex_state = 66},
  [45] = {.lex_state = 66},
  [46] = {.lex_state = 66},
  [47] = {.lex_state = 66},
  [48] = {.lex_state = 66},
  [49] = {.lex_state = 66},
  [50] = {.lex_state = 66},
  [51] = {.lex_state = 66},
  [52] = {.lex_state = 66},
  [53] = {.lex_state = 66},
  [54] = {.lex_state = 66},
  [55] = {.lex_state = 66},
  [56] = {.lex_state = 66},
  [57] = {.lex_state = 6, .external_lex_state = 2},
  [58] = {.lex_state = 6, .external_lex_state = 3},
  [59] = {.lex_state = 6, .external_lex_state = 2},
  [60] = {.lex_state = 6, .external_lex_state = 2},
  [61] = {.lex_state = 6, .external_lex_state = 3},
  [62] = {.lex_state = 6, .external_lex_state = 2},
  [63] = {.lex_state = 6, .external_lex_state = 3},
  [64] = {.lex_state = 6, .external_lex_state = 2},
  [65] = {.lex_state = 6, .external_lex_state = 2},
  [66] = {.lex_state = 6, .external_lex_state = 2},
  [67] = {.lex_state = 6, .external_lex_state = 2},
  [68] = {.lex_state = 6, .external_lex_state = 2},
  [69] = {.lex_state = 6, .external_lex_state = 2},
  [70] = {.lex_state = 6, .external_lex_state = 3},
  [71] = {.lex_state = 6, .external_lex_state = 3},
  [72] = {.lex_state = 6, .external_lex_state = 2},
  [73] = {.lex_state = 6, .external_lex_state = 3},
  [74] = {.lex_state = 6, .external_lex_state = 3},
  [75] = {.lex_state = 6, .external_lex_state = 2},
  [76] = {.lex_state = 6, .external_lex_state = 3},
  [77] = {.lex_state = 6, .external_lex_state = 3},
  [78] = {.lex_state = 6, .external_lex_state = 3},
  [79] = {.lex_state = 6, .external_lex_state = 3},
  [80] = {.lex_state = 6, .external_lex_state = 2},
  [81] = {.lex_state = 7, .external_lex_state = 3},
  [82] = {.lex_state = 6, .external_lex_state = 3},
  [83] = {.lex_state = 7, .external_lex_state = 3},
  [84] = {.lex_state = 7, .external_lex_state = 3},
  [85] = {.lex_state = 6, .external_lex_state = 3},
  [86] = {.lex_state = 6, .external_lex_state = 3},
  [87] = {.lex_state = 6, .external_lex_state = 3},
  [88] = {.lex_state = 6, .external_lex_state = 2},
  [89] = {.lex_state = 6, .external_lex_state = 3},
  [90] = {.lex_state = 6, .external_lex_state = 3},
  [91] = {.lex_state = 14},
  [92] = {.lex_state = 14},
  [93] = {.lex_state = 14},
  [94] = {.lex_state = 14},
  [95] = {.lex_state = 14},
  [96] = {.lex_state = 14},
  [97] = {.lex_state = 14},
  [98] = {.lex_state = 14},
  [99] = {.lex_state = 14},
  [100] = {.lex_state = 65, .external_lex_state = 3},
  [101] = {.lex_state = 65, .external_lex_state = 2},
  [102] = {.lex_state = 14},
  [103] = {.lex_state = 14},
  [104] = {.lex_state = 14},
  [105] = {.lex_state = 14},
  [106] = {.lex_state = 14},
  [107] = {.lex_state = 14},
  [108] = {.lex_state = 14},
  [109] = {.lex_state = 65, .external_lex_state = 3},
  [110] = {.lex_state = 8, .external_lex_state = 3},
  [111] = {.lex_state = 65, .external_lex_state = 2},
  [112] = {.lex_state = 65, .external_lex_state = 3},
  [113] = {.lex_state = 65, .external_lex_state = 2},
  [114] = {.lex_state = 65, .external_lex_state = 2},
  [115] = {.lex_state = 65, .external_lex_state = 2},
  [116] = {.lex_state = 65, .external_lex_state = 2},
  [117] = {.lex_state = 65, .external_lex_state = 2},
  [118] = {.lex_state = 65, .external_lex_state = 2},
  [119] = {.lex_state = 65, .external_lex_state = 2},
  [120] = {.lex_state = 65, .external_lex_state = 2},
  [121] = {.lex_state = 65, .external_lex_state = 2},
  [122] = {.lex_state = 65, .external_lex_state = 2},
  [123] = {.lex_state = 65, .external_lex_state = 2},
  [124] = {.lex_state = 65, .external_lex_state = 2},
  [125] = {.lex_state = 65, .external_lex_state = 2},
  [126] = {.lex_state = 65, .external_lex_state = 2},
  [127] = {.lex_state = 65, .external_lex_state = 2},
  [128] = {.lex_state = 65, .external_lex_state = 2},
  [129] = {.lex_state = 65, .external_lex_state = 2},
  [130] = {.lex_state = 65, .external_lex_state = 2},
  [131] = {.lex_state = 65, .external_lex_state = 2},
  [132] = {.lex_state = 65, .external_lex_state = 2},
  [133] = {.lex_state = 65, .external_lex_state = 2},
  [134] = {.lex_state = 65, .external_lex_state = 2},
  [135] = {.lex_state = 65, .external_lex_state = 2},
  [136] = {.lex_state = 65, .external_lex_state = 2},
  [137] = {.lex_state = 65, .external_lex_state = 2},
  [138] = {.lex_state = 65, .external_lex_state = 2},
  [139] = {.lex_state = 65, .external_lex_state = 2},
  [140] = {.lex_state = 66},
  [141] = {.lex_state = 66},
  [142] = {.lex_state = 66},
  [143] = {.lex_state = 66},
  [144] = {.lex_state = 66},
  [145] = {.lex_state = 66},
  [146] = {.lex_state = 66},
  [147] = {.lex_state = 66},
  [148] = {.lex_state = 66},
  [149] = {.lex_state = 66},
  [150] = {.lex_state = 66},
  [151] = {.lex_state = 66},
  [152] = {.lex_state = 66},
  [153] = {.lex_state = 66},
  [154] = {.lex_state = 66},
  [155] = {.lex_state = 66},
  [156] = {.lex_state = 66},
  [157] = {.lex_state = 66},
  [158] = {.lex_state = 66},
  [159] = {.lex_state = 66},
  [160] = {.lex_state = 66},
  [161] = {.lex_state = 66},
  [162] = {.lex_state = 66},
  [163] = {.lex_state = 66},
  [164] = {.lex_state = 66},
  [165] = {.lex_state = 66},
  [166] = {.lex_state = 66},
  [167] = {.lex_state = 66},
  [168] = {.lex_state = 66, .external_lex_state = 4},
  [169] = {.lex_state = 66},
  [170] = {.lex_state = 66},
  [171] = {.lex_state = 66},
  [172] = {.lex_state = 66},
  [173] = {.lex_state = 6, .external_lex_state = 2},
  [174] = {.lex_state = 6, .external_lex_state = 2},
  [175] = {.lex_state = 66},
  [176] = {.lex_state = 6, .external_lex_state = 2},
  [177] = {.lex_state = 66},
  [178] = {.lex_state = 66},
  [179] = {.lex_state = 66},
  [180] = {.lex_state = 66},
  [181] = {.lex_state = 66},
  [182] = {.lex_state = 66},
  [183] = {.lex_state = 66},
  [184] = {.lex_state = 66},
  [185] = {.lex_state = 66},
  [186] = {.lex_state = 66},
  [187] = {.lex_state = 66},
  [188] = {.lex_state = 66},
  [189] = {.lex_state = 66},
  [190] = {.lex_state = 66},
  [191] = {.lex_state = 66},
  [192] = {.lex_state = 66},
  [193] = {.lex_state = 66},
  [194] = {.lex_state = 66},
  [195] = {.lex_state = 66},
  [196] = {.lex_state = 66},
  [197] = {.lex_state = 66},
  [198] = {.lex_state = 66},
  [199] = {.lex_state = 66},
  [200] = {.lex_state = 66},
  [201] = {.lex_state = 66},
  [202] = {.lex_state = 66},
  [203] = {.lex_state = 66},
  [204] = {.lex_state = 66},
  [205] = {.lex_state = 66},
  [206] = {.lex_state = 66},
  [207] = {.lex_state = 66},
  [208] = {.lex_state = 66},
  [209] = {.lex_state = 66},
  [210] = {.lex_state = 66},
  [211] = {.lex_state = 66},
  [212] = {.lex_state = 66},
  [213] = {.lex_state = 66},
  [214] = {.lex_state = 66},
  [215] = {.lex_state = 66},
  [216] = {.lex_state = 66},
  [217] = {.lex_state = 66},
  [218] = {.lex_state = 66},
  [219] = {.lex_state = 66},
  [220] = {.lex_state = 66},
  [221] = {.lex_state = 66},
  [222] = {.lex_state = 66},
  [223] = {.lex_state = 66},
  [224] = {.lex_state = 66},
  [225] = {.lex_state = 66},
  [226] = {.lex_state = 66},
  [227] = {.lex_state = 66},
  [228] = {.lex_state = 66},
  [229] = {.lex_state = 66},
  [230] = {.lex_state = 66},
  [231] = {.lex_state = 66},
  [232] = {.lex_state = 66},
  [233] = {.lex_state = 66},
  [234] = {.lex_state = 66},
  [235] = {.lex_state = 66},
  [236] = {.lex_state = 66},
  [237] = {.lex_state = 66},
  [238] = {.lex_state = 66},
  [239] = {.lex_state = 66},
  [240] = {.lex_state = 66},
  [241] = {.lex_state = 66},
  [242] = {.lex_state = 66},
  [243] = {.lex_state = 66},
  [244] = {.lex_state = 66},
  [245] = {.lex_state = 66},
  [246] = {.lex_state = 66},
  [247] = {.lex_state = 66},
  [248] = {.lex_state = 66},
  [249] = {.lex_state = 66},
  [250] = {.lex_state = 66},
  [251] = {.lex_state = 66},
  [252] = {.lex_state = 66},
  [253] = {.lex_state = 66},
  [254] = {.lex_state = 66},
  [255] = {.lex_state = 66},
  [256] = {.lex_state = 66},
  [257] = {.lex_state = 66},
  [258] = {.lex_state = 66},
  [259] = {.lex_state = 66},
  [260] = {.lex_state = 66},
  [261] = {.lex_state = 66},
  [262] = {.lex_state = 66},
  [263] = {.lex_state = 66},
  [264] = {.lex_state = 66},
  [265] = {.lex_state = 66},
  [266] = {.lex_state = 66},
  [267] = {.lex_state = 66},
  [268] = {.lex_state = 66},
  [269] = {.lex_state = 66},
  [270] = {.lex_state = 66},
  [271] = {.lex_state = 66},
  [272] = {.lex_state = 66},
  [273] = {.lex_state = 66},
  [274] = {.lex_state = 66},
  [275] = {.lex_state = 66},
  [276] = {.lex_state = 66},
  [277] = {.lex_state = 66},
  [278] = {.lex_state = 66},
  [279] = {.lex_state = 66},
  [280] = {.lex_state = 66},
  [281] = {.lex_state = 66},
  [282] = {.lex_state = 66},
  [283] = {.lex_state = 66},
  [284] = {.lex_state = 66},
  [285] = {.lex_state = 66},
  [286] = {.lex_state = 66},
  [287] = {.lex_state = 66},
  [288] = {.lex_state = 66},
  [289] = {.lex_state = 66},
  [290] = {.lex_state = 66},
  [291] = {.lex_state = 66},
  [292] = {.lex_state = 66},
  [293] = {.lex_state = 66},
  [294] = {.lex_state = 66},
  [295] = {.lex_state = 66},
  [296] = {.lex_state = 66},
  [297] = {.lex_state = 66},
  [298] = {.lex_state = 66},
  [299] = {.lex_state = 66},
  [300] = {.lex_state = 66},
  [301] = {.lex_state = 66},
  [302] = {.lex_state = 66},
  [303] = {.lex_state = 6, .external_lex_state = 2},
  [304] = {.lex_state = 66},
  [305] = {.lex_state = 66},
  [306] = {.lex_state = 66},
  [307] = {.lex_state = 66},
  [308] = {.lex_state = 66},
  [309] = {.lex_state = 66},
  [310] = {.lex_state = 66},
  [311] = {.lex_state = 66},
  [312] = {.lex_state = 66},
  [313] = {.lex_state = 66},
  [314] = {.lex_state = 6, .external_lex_state = 2},
  [315] = {.lex_state = 66},
  [316] = {.lex_state = 66},
  [317] = {.lex_state = 66},
  [318] = {.lex_state = 66},
  [319] = {.lex_state = 66},
  [320] = {.lex_state = 66},
  [321] = {.lex_state = 66},
  [322] = {.lex_state = 66},
  [323] = {.lex_state = 66},
  [324] = {.lex_state = 66},
  [325] = {.lex_state = 66},
  [326] = {.lex_state = 66},
  [327] = {.lex_state = 66},
  [328] = {.lex_state = 66},
  [329] = {.lex_state = 66},
  [330] = {.lex_state = 66},
  [331] = {.lex_state = 66},
  [332] = {.lex_state = 66},
  [333] = {.lex_state = 66},
  [334] = {.lex_state = 66},
  [335] = {.lex_state = 66},
  [336] = {.lex_state = 66},
  [337] = {.lex_state = 66},
  [338] = {.lex_state = 66},
  [339] = {.lex_state = 66},
  [340] = {.lex_state = 66},
  [341] = {.lex_state = 66},
  [342] = {.lex_state = 66},
  [343] = {.lex_state = 66},
  [344] = {.lex_state = 66},
  [345] = {.lex_state = 66},
  [346] = {.lex_state = 66},
  [347] = {.lex_state = 66},
  [348] = {.lex_state = 66},
  [349] = {.lex_state = 66},
  [350] = {.lex_state = 66},
  [351] = {.lex_state = 66},
  [352] = {.lex_state = 66},
  [353] = {.lex_state = 66},
  [354] = {.lex_state = 66},
  [355] = {.lex_state = 66},
  [356] = {.lex_state = 66},
  [357] = {.lex_state = 66},
  [358] = {.lex_state = 66},
  [359] = {.lex_state = 66},
  [360] = {.lex_state = 66},
  [361] = {.lex_state = 66},
  [362] = {.lex_state = 66},
  [363] = {.lex_state = 66},
  [364] = {.lex_state = 66},
  [365] = {.lex_state = 66},
  [366] = {.lex_state = 66},
  [367] = {.lex_state = 66},
  [368] = {.lex_state = 66},
  [369] = {.lex_state = 66},
  [370] = {.lex_state = 66},
  [371] = {.lex_state = 66},
  [372] = {.lex_state = 66},
  [373] = {.lex_state = 66},
  [374] = {.lex_state = 66},
  [375] = {.lex_state = 66},
  [376] = {.lex_state = 66},
  [377] = {.lex_state = 66},
  [378] = {.lex_state = 66},
  [379] = {.lex_state = 66},
  [380] = {.lex_state = 66},
  [381] = {.lex_state = 66},
  [382] = {.lex_state = 6, .external_lex_state = 2},
  [383] = {.lex_state = 66},
  [384] = {.lex_state = 66},
  [385] = {.lex_state = 66},
  [386] = {.lex_state = 66},
  [387] = {.lex_state = 6, .external_lex_state = 2},
  [388] = {.lex_state = 66},
  [389] = {.lex_state = 66},
  [390] = {.lex_state = 66},
  [391] = {.lex_state = 66},
  [392] = {.lex_state = 66},
  [393] = {.lex_state = 66},
  [394] = {.lex_state = 66},
  [395] = {.lex_state = 66},
  [396] = {.lex_state = 66},
  [397] = {.lex_state = 66},
  [398] = {.lex_state = 66},
  [399] = {.lex_state = 6, .external_lex_state = 2},
  [400] = {.lex_state = 66},
  [401] = {.lex_state = 66},
  [402] = {.lex_state = 66},
  [403] = {.lex_state = 66},
  [404] = {.lex_state = 66},
  [405] = {.lex_state = 66},
  [406] = {.lex_state = 6, .external_lex_state = 2},
  [407] = {.lex_state = 66},
  [408] = {.lex_state = 66},
  [409] = {.lex_state = 66},
  [410] = {.lex_state = 66},
  [411] = {.lex_state = 66},
  [412] = {.lex_state = 66},
  [413] = {.lex_state = 66},
  [414] = {.lex_state = 66},
  [415] = {.lex_state = 66},
  [416] = {.lex_state = 66},
  [417] = {.lex_state = 66},
  [418] = {.lex_state = 66},
  [419] = {.lex_state = 66},
  [420] = {.lex_state = 66},
  [421] = {.lex_state = 66},
  [422] = {.lex_state = 66},
  [423] = {.lex_state = 6, .external_lex_state = 2},
  [424] = {.lex_state = 6, .external_lex_state = 2},
  [425] = {.lex_state = 6, .external_lex_state = 2},
  [426] = {.lex_state = 6, .external_lex_state = 2},
  [427] = {.lex_state = 66},
  [428] = {.lex_state = 6, .external_lex_state = 2},
  [429] = {.lex_state = 66},
  [430] = {.lex_state = 6, .external_lex_state = 2},
  [431] = {.lex_state = 66},
  [432] = {.lex_state = 66},
  [433] = {.lex_state = 66},
  [434] = {.lex_state = 66},
  [435] = {.lex_state = 66},
  [436] = {.lex_state = 66},
  [437] = {.lex_state = 66},
  [438] = {.lex_state = 66},
  [439] = {.lex_state = 66},
  [440] = {.lex_state = 66},
  [441] = {.lex_state = 66},
  [442] = {.lex_state = 66},
  [443] = {.lex_state = 66},
  [444] = {.lex_state = 66},
  [445] = {.lex_state = 66},
  [446] = {.lex_state = 66},
  [447] = {.lex_state = 66},
  [448] = {.lex_state = 66},
  [449] = {.lex_state = 66},
  [450] = {.lex_state = 66},
  [451] = {.lex_state = 66},
  [452] = {.lex_state = 66},
  [453] = {.lex_state = 66},
  [454] = {.lex_state = 66},
  [455] = {.lex_state = 66},
  [456] = {.lex_state = 6, .external_lex_state = 2},
  [457] = {.lex_state = 6, .external_lex_state = 2},
  [458] = {.lex_state = 6, .external_lex_state = 2},
  [459] = {.lex_state = 6, .external_lex_state = 2},
  [460] = {.lex_state = 6, .external_lex_state = 2},
  [461] = {.lex_state = 6, .external_lex_state = 2},
  [462] = {.lex_state = 6, .external_lex_state = 2},
  [463] = {.lex_state = 6, .external_lex_state = 2},
  [464] = {.lex_state = 6, .external_lex_state = 2},
  [465] = {.lex_state = 66},
  [466] = {.lex_state = 6, .external_lex_state = 3},
  [467] = {.lex_state = 66},
  [468] = {.lex_state = 66},
  [469] = {.lex_state = 66},
  [470] = {.lex_state = 66, .external_lex_state = 4},
  [471] = {.lex_state = 66, .external_lex_state = 4},
  [472] = {.lex_state = 66},
  [473] = {.lex_state = 66},
  [474] = {.lex_state = 66, .external_lex_state = 4},
  [475] = {.lex_state = 66, .external_lex_state = 4},
  [476] = {.lex_state = 66, .external_lex_state = 4},
  [477] = {.lex_state = 6, .external_lex_state = 2},
  [478] = {.lex_state = 6, .external_lex_state = 3},
  [479] = {.lex_state = 15},
  [480] = {.lex_state = 66, .external_lex_state = 4},
  [481] = {.lex_state = 15},
  [482] = {.lex_state = 66, .external_lex_state = 4},
  [483] = {.lex_state = 66},
  [484] = {.lex_state = 15},
  [485] = {.lex_state = 6, .external_lex_state = 2},
  [486] = {.lex_state = 15},
  [487] = {.lex_state = 6, .external_lex_state = 2},
  [488] = {.lex_state = 66, .external_lex_state = 4},
  [489] = {.lex_state = 66},
  [490] = {.lex_state = 15},
  [491] = {.lex_state = 66},
  [492] = {.lex_state = 66},
  [493] = {.lex_state = 6, .external_lex_state = 2},
  [494] = {.lex_state = 66},
  [495] = {.lex_state = 66},
  [496] = {.lex_state = 6, .external_lex_state = 2},
  [497] = {.lex_state = 66},
  [498] = {.lex_state = 66},
  [499] = {.lex_state = 66},
  [500] = {.lex_state = 6, .external_lex_state = 3},
  [501] = {.lex_state = 66},
  [502] = {.lex_state = 6, .external_lex_state = 2},
  [503] = {.lex_state = 66},
  [504] = {.lex_state = 6, .external_lex_state = 2},
  [505] = {.lex_state = 7, .external_lex_state = 3},
  [506] = {.lex_state = 66},
  [507] = {.lex_state = 6, .external_lex_state = 2},
  [508] = {.lex_state = 6, .external_lex_state = 2},
  [509] = {.lex_state = 6, .external_lex_state = 3},
  [510] = {.lex_state = 66, .external_lex_state = 4},
  [511] = {.lex_state = 66, .external_lex_state = 4},
  [512] = {.lex_state = 6, .external_lex_state = 3},
  [513] = {.lex_state = 66, .external_lex_state = 4},
  [514] = {.lex_state = 66, .external_lex_state = 4},
  [515] = {.lex_state = 6, .external_lex_state = 3},
  [516] = {.lex_state = 66, .external_lex_state = 4},
  [517] = {.lex_state = 66, .external_lex_state = 4},
  [518] = {.lex_state = 6, .external_lex_state = 3},
  [519] = {.lex_state = 7, .external_lex_state = 3},
  [520] = {.lex_state = 66},
  [521] = {.lex_state = 66, .external_lex_state = 4},
  [522] = {.lex_state = 66, .external_lex_state = 4},
  [523] = {.lex_state = 6, .external_lex_state = 3},
  [524] = {.lex_state = 66, .external_lex_state = 4},
  [525] = {.lex_state = 66, .external_lex_state = 4},
  [526] = {.lex_state = 66},
  [527] = {.lex_state = 66, .external_lex_state = 4},
  [528] = {.lex_state = 66},
  [529] = {.lex_state = 66, .external_lex_state = 4},
  [530] = {.lex_state = 6, .external_lex_state = 3},
  [531] = {.lex_state = 6, .external_lex_state = 2},
  [532] = {.lex_state = 66},
  [533] = {.lex_state = 6, .external_lex_state = 3},
  [534] = {.lex_state = 6, .external_lex_state = 3},
  [535] = {.lex_state = 66},
  [536] = {.lex_state = 66},
  [537] = {.lex_state = 66},
  [538] = {.lex_state = 66},
  [539] = {.lex_state = 66},
  [540] = {.lex_state = 66},
  [541] = {.lex_state = 66},
  [542] = {.lex_state = 66},
  [543] = {.lex_state = 66},
  [544] = {.lex_state = 66},
  [545] = {.lex_state = 66},
  [546] = {.lex_state = 66},
  [547] = {.lex_state = 66},
  [548] = {.lex_state = 66},
  [549] = {.lex_state = 66},
  [550] = {.lex_state = 66},
  [551] = {.lex_state = 66},
  [552] = {.lex_state = 66},
  [553] = {.lex_state = 66},
  [554] = {.lex_state = 66},
  [555] = {.lex_state = 66},
  [556] = {.lex_state = 66},
  [557] = {.lex_state = 66},
  [558] = {.lex_state = 66},
  [559] = {.lex_state = 66},
  [560] = {.lex_state = 66},
  [561] = {.lex_state = 66},
  [562] = {.lex_state = 66},
  [563] = {.lex_state = 66},
  [564] = {.lex_state = 66},
  [565] = {.lex_state = 66},
  [566] = {.lex_state = 66},
  [567] = {.lex_state = 66},
  [568] = {.lex_state = 66},
  [569] = {.lex_state = 66},
  [570] = {.lex_state = 66},
  [571] = {.lex_state = 66},
  [572] = {.lex_state = 66},
  [573] = {.lex_state = 66},
  [574] = {.lex_state = 6, .external_lex_state = 3},
  [575] = {.lex_state = 66},
  [576] = {.lex_state = 66},
  [577] = {.lex_state = 66},
  [578] = {.lex_state = 66},
  [579] = {.lex_state = 66},
  [580] = {.lex_state = 66},
  [581] = {.lex_state = 66},
  [582] = {.lex_state = 6, .external_lex_state = 2},
  [583] = {.lex_state = 66},
  [584] = {.lex_state = 66},
  [585] = {.lex_state = 66},
  [586] = {.lex_state = 66},
  [587] = {.lex_state = 66},
  [588] = {.lex_state = 66},
  [589] = {.lex_state = 66},
  [590] = {.lex_state = 66},
  [591] = {.lex_state = 66},
  [592] = {.lex_state = 66},
  [593] = {.lex_state = 66},
  [594] = {.lex_state = 66},
  [595] = {.lex_state = 66},
  [596] = {.lex_state = 66},
  [597] = {.lex_state = 66},
  [598] = {.lex_state = 66},
  [599] = {.lex_state = 66},
  [600] = {.lex_state = 66},
  [601] = {.lex_state = 66},
  [602] = {.lex_state = 66},
  [603] = {.lex_state = 66},
  [604] = {.lex_state = 66},
  [605] = {.lex_state = 66},
  [606] = {.lex_state = 66},
  [607] = {.lex_state = 66},
  [608] = {.lex_state = 66},
  [609] = {.lex_state = 66},
  [610] = {.lex_state = 66},
  [611] = {.lex_state = 66},
  [612] = {.lex_state = 66},
  [613] = {.lex_state = 66},
  [614] = {.lex_state = 66},
  [615] = {.lex_state = 66},
  [616] = {.lex_state = 6, .external_lex_state = 3},
  [617] = {.lex_state = 6, .external_lex_state = 3},
  [618] = {.lex_state = 6, .external_lex_state = 3},
  [619] = {.lex_state = 6, .external_lex_state = 3},
  [620] = {.lex_state = 66},
  [621] = {.lex_state = 66},
  [622] = {.lex_state = 66},
  [623] = {.lex_state = 66},
  [624] = {.lex_state = 66},
  [625] = {.lex_state = 66},
  [626] = {.lex_state = 66},
  [627] = {.lex_state = 66},
  [628] = {.lex_state = 66},
  [629] = {.lex_state = 66},
  [630] = {.lex_state = 6, .external_lex_state = 3},
  [631] = {.lex_state = 6, .external_lex_state = 2},
  [632] = {.lex_state = 6, .external_lex_state = 2},
  [633] = {.lex_state = 6, .external_lex_state = 2},
  [634] = {.lex_state = 6, .external_lex_state = 2},
  [635] = {.lex_state = 6, .external_lex_state = 2},
  [636] = {.lex_state = 6, .external_lex_state = 2},
  [637] = {.lex_state = 6, .external_lex_state = 2},
  [638] = {.lex_state = 6, .external_lex_state = 3},
  [639] = {.lex_state = 6, .external_lex_state = 2},
  [640] = {.lex_state = 7, .external_lex_state = 3},
  [641] = {.lex_state = 6, .external_lex_state = 2},
  [642] = {.lex_state = 6, .external_lex_state = 2},
  [643] = {.lex_state = 6, .external_lex_state = 2},
  [644] = {.lex_state = 6, .external_lex_state = 2},
  [645] = {.lex_state = 6, .external_lex_state = 2},
  [646] = {.lex_state = 6, .external_lex_state = 2},
  [647] = {.lex_state = 6, .external_lex_state = 3},
  [648] = {.lex_state = 6, .external_lex_state = 3},
  [649] = {.lex_state = 6, .external_lex_state = 2},
  [650] = {.lex_state = 66},
  [651] = {.lex_state = 66},
  [652] = {.lex_state = 6, .external_lex_state = 3},
  [653] = {.lex_state = 6, .external_lex_state = 2},
  [654] = {.lex_state = 66},
  [655] = {.lex_state = 66},
  [656] = {.lex_state = 66},
  [657] = {.lex_state = 6, .external_lex_state = 3},
  [658] = {.lex_state = 66},
  [659] = {.lex_state = 6, .external_lex_state = 3},
  [660] = {.lex_state = 66},
  [661] = {.lex_state = 7, .external_lex_state = 3},
  [662] = {.lex_state = 6, .external_lex_state = 3},
  [663] = {.lex_state = 6, .external_lex_state = 3},
  [664] = {.lex_state = 6, .external_lex_state = 2},
  [665] = {.lex_state = 6, .external_lex_state = 3},
  [666] = {.lex_state = 6, .external_lex_state = 3},
  [667] = {.lex_state = 6, .external_lex_state = 3},
  [668] = {.lex_state = 6, .external_lex_state = 2},
  [669] = {.lex_state = 6, .external_lex_state = 3},
  [670] = {.lex_state = 6, .external_lex_state = 3},
  [671] = {.lex_state = 6, .external_lex_state = 3},
  [672] = {.lex_state = 6, .external_lex_state = 2},
  [673] = {.lex_state = 6, .external_lex_state = 3},
  [674] = {.lex_state = 6, .external_lex_state = 2},
  [675] = {.lex_state = 6, .external_lex_state = 2},
  [676] = {.lex_state = 6, .external_lex_state = 3},
  [677] = {.lex_state = 6, .external_lex_state = 3},
  [678] = {.lex_state = 6, .external_lex_state = 3},
  [679] = {.lex_state = 6, .external_lex_state = 2},
  [680] = {.lex_state = 6, .external_lex_state = 3},
  [681] = {.lex_state = 15},
  [682] = {.lex_state = 6, .external_lex_state = 2},
  [683] = {.lex_state = 6, .external_lex_state = 3},
  [684] = {.lex_state = 6, .external_lex_state = 2},
  [685] = {.lex_state = 6, .external_lex_state = 3},
  [686] = {.lex_state = 6, .external_lex_state = 3},
  [687] = {.lex_state = 6, .external_lex_state = 2},
  [688] = {.lex_state = 6, .external_lex_state = 2},
  [689] = {.lex_state = 6, .external_lex_state = 2},
  [690] = {.lex_state = 66},
  [691] = {.lex_state = 6, .external_lex_state = 2},
  [692] = {.lex_state = 6, .external_lex_state = 2},
  [693] = {.lex_state = 15},
  [694] = {.lex_state = 6, .external_lex_state = 3},
  [695] = {.lex_state = 15},
  [696] = {.lex_state = 66},
  [697] = {.lex_state = 6, .external_lex_state = 3},
  [698] = {.lex_state = 6, .external_lex_state = 2},
  [699] = {.lex_state = 15},
  [700] = {.lex_state = 15},
  [701] = {.lex_state = 6, .external_lex_state = 3},
  [702] = {.lex_state = 6, .external_lex_state = 3},
  [703] = {.lex_state = 15},
  [704] = {.lex_state = 7, .external_lex_state = 3},
  [705] = {.lex_state = 15},
  [706] = {.lex_state = 6, .external_lex_state = 2},
  [707] = {.lex_state = 15},
  [708] = {.lex_state = 15},
  [709] = {.lex_state = 6, .external_lex_state = 2},
  [710] = {.lex_state = 15},
  [711] = {.lex_state = 6, .external_lex_state = 2},
  [712] = {.lex_state = 15},
  [713] = {.lex_state = 6, .external_lex_state = 3},
  [714] = {.lex_state = 7, .external_lex_state = 3},
  [715] = {.lex_state = 6, .external_lex_state = 3},
  [716] = {.lex_state = 15},
  [717] = {.lex_state = 6, .external_lex_state = 3},
  [718] = {.lex_state = 15},
  [719] = {.lex_state = 6, .external_lex_state = 3},
  [720] = {.lex_state = 17},
  [721] = {.lex_state = 6, .external_lex_state = 2},
  [722] = {.lex_state = 15},
  [723] = {.lex_state = 15},
  [724] = {.lex_state = 15},
  [725] = {.lex_state = 15},
  [726] = {.lex_state = 15},
  [727] = {.lex_state = 15},
  [728] = {.lex_state = 6, .external_lex_state = 2},
  [729] = {.lex_state = 15},
  [730] = {.lex_state = 6, .external_lex_state = 2},
  [731] = {.lex_state = 15},
  [732] = {.lex_state = 15},
  [733] = {.lex_state = 6, .external_lex_state = 3},
  [734] = {.lex_state = 6, .external_lex_state = 2},
  [735] = {.lex_state = 15},
  [736] = {.lex_state = 15},
  [737] = {.lex_state = 15},
  [738] = {.lex_state = 15},
  [739] = {.lex_state = 6, .external_lex_state = 2},
  [740] = {.lex_state = 15},
  [741] = {.lex_state = 15},
  [742] = {.lex_state = 15},
  [743] = {.lex_state = 6, .external_lex_state = 3},
  [744] = {.lex_state = 15},
  [745] = {.lex_state = 15},
  [746] = {.lex_state = 15},
  [747] = {.lex_state = 15},
  [748] = {.lex_state = 15},
  [749] = {.lex_state = 15},
  [750] = {.lex_state = 15},
  [751] = {.lex_state = 15},
  [752] = {.lex_state = 6, .external_lex_state = 2},
  [753] = {.lex_state = 15},
  [754] = {.lex_state = 15},
  [755] = {.lex_state = 6, .external_lex_state = 2},
  [756] = {.lex_state = 15},
  [757] = {.lex_state = 15},
  [758] = {.lex_state = 15},
  [759] = {.lex_state = 6, .external_lex_state = 2},
  [760] = {.lex_state = 15},
  [761] = {.lex_state = 15},
  [762] = {.lex_state = 15},
  [763] = {.lex_state = 6, .external_lex_state = 2},
  [764] = {.lex_state = 6, .external_lex_state = 2},
  [765] = {.lex_state = 6, .external_lex_state = 3},
  [766] = {.lex_state = 15},
  [767] = {.lex_state = 15},
  [768] = {.lex_state = 15},
  [769] = {.lex_state = 15},
  [770] = {.lex_state = 6, .external_lex_state = 2},
  [771] = {.lex_state = 15},
  [772] = {.lex_state = 15},
  [773] = {.lex_state = 15},
  [774] = {.lex_state = 15},
  [775] = {.lex_state = 7, .external_lex_state = 3},
  [776] = {.lex_state = 15},
  [777] = {.lex_state = 15},
  [778] = {.lex_state = 15},
  [779] = {.lex_state = 15},
  [780] = {.lex_state = 15},
  [781] = {.lex_state = 15},
  [782] = {.lex_state = 15},
  [783] = {.lex_state = 15},
  [784] = {.lex_state = 15},
  [785] = {.lex_state = 6, .external_lex_state = 2},
  [786] = {.lex_state = 15},
  [787] = {.lex_state = 7, .external_lex_state = 3},
  [788] = {.lex_state = 15},
  [789] = {.lex_state = 6, .external_lex_state = 2},
  [790] = {.lex_state = 15},
  [791] = {.lex_state = 15},
  [792] = {.lex_state = 15},
  [793] = {.lex_state = 15},
  [794] = {.lex_state = 6, .external_lex_state = 2},
  [795] = {.lex_state = 15},
  [796] = {.lex_state = 6, .external_lex_state = 2},
  [797] = {.lex_state = 15},
  [798] = {.lex_state = 15},
  [799] = {.lex_state = 15},
  [800] = {.lex_state = 15},
  [801] = {.lex_state = 15},
  [802] = {.lex_state = 15},
  [803] = {.lex_state = 6, .external_lex_state = 2},
  [804] = {.lex_state = 7, .external_lex_state = 3},
  [805] = {.lex_state = 15},
  [806] = {.lex_state = 6, .external_lex_state = 3},
  [807] = {.lex_state = 6, .external_lex_state = 2},
  [808] = {.lex_state = 15},
  [809] = {.lex_state = 15},
  [810] = {.lex_state = 15},
  [811] = {.lex_state = 6, .external_lex_state = 2},
  [812] = {.lex_state = 15},
  [813] = {.lex_state = 6, .external_lex_state = 3},
  [814] = {.lex_state = 6, .external_lex_state = 2},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 6, .external_lex_state = 3},
  [817] = {.lex_state = 15},
  [818] = {.lex_state = 15},
  [819] = {.lex_state = 6, .external_lex_state = 2},
  [820] = {.lex_state = 6, .external_lex_state = 2},
  [821] = {.lex_state = 6, .external_lex_state = 2},
  [822] = {.lex_state = 15},
  [823] = {.lex_state = 6, .external_lex_state = 3},
  [824] = {.lex_state = 15},
  [825] = {.lex_state = 15},
  [826] = {.lex_state = 15},
  [827] = {.lex_state = 15},
  [828] = {.lex_state = 15},
  [829] = {.lex_state = 15},
  [830] = {.lex_state = 6, .external_lex_state = 3},
  [831] = {.lex_state = 15},
  [832] = {.lex_state = 15},
  [833] = {.lex_state = 15},
  [834] = {.lex_state = 15},
  [835] = {.lex_state = 15},
  [836] = {.lex_state = 15},
  [837] = {.lex_state = 15},
  [838] = {.lex_state = 15},
  [839] = {.lex_state = 15},
  [840] = {.lex_state = 15},
  [841] = {.lex_state = 15},
  [842] = {.lex_state = 15},
  [843] = {.lex_state = 15},
  [844] = {.lex_state = 15},
  [845] = {.lex_state = 15},
  [846] = {.lex_state = 15},
  [847] = {.lex_state = 6, .external_lex_state = 2},
  [848] = {.lex_state = 15},
  [849] = {.lex_state = 15},
  [850] = {.lex_state = 6, .external_lex_state = 2},
  [851] = {.lex_state = 15},
  [852] = {.lex_state = 15},
  [853] = {.lex_state = 15},
  [854] = {.lex_state = 15},
  [855] = {.lex_state = 6, .external_lex_state = 3},
  [856] = {.lex_state = 6, .external_lex_state = 2},
  [857] = {.lex_state = 6, .external_lex_state = 3},
  [858] = {.lex_state = 15},
  [859] = {.lex_state = 6, .external_lex_state = 2},
  [860] = {.lex_state = 15},
  [861] = {.lex_state = 15},
  [862] = {.lex_state = 15},
  [863] = {.lex_state = 6, .external_lex_state = 3},
  [864] = {.lex_state = 15},
  [865] = {.lex_state = 7, .external_lex_state = 3},
  [866] = {.lex_state = 7, .external_lex_state = 3},
  [867] = {.lex_state = 6, .external_lex_state = 3},
  [868] = {.lex_state = 6, .external_lex_state = 3},
  [869] = {.lex_state = 6, .external_lex_state = 2},
  [870] = {.lex_state = 6, .external_lex_state = 2},
  [871] = {.lex_state = 6, .external_lex_state = 3},
  [872] = {.lex_state = 6, .external_lex_state = 3},
  [873] = {.lex_state = 6, .external_lex_state = 3},
  [874] = {.lex_state = 6, .external_lex_state = 2},
  [875] = {.lex_state = 6, .external_lex_state = 3},
  [876] = {.lex_state = 6, .external_lex_state = 2},
  [877] = {.lex_state = 6, .external_lex_state = 3},
  [878] = {.lex_state = 6, .external_lex_state = 2},
  [879] = {.lex_state = 6, .external_lex_state = 3},
  [880] = {.lex_state = 6, .external_lex_state = 3},
  [881] = {.lex_state = 6, .external_lex_state = 3},
  [882] = {.lex_state = 6, .external_lex_state = 2},
  [883] = {.lex_state = 6, .external_lex_state = 3},
  [884] = {.lex_state = 7, .external_lex_state = 3},
  [885] = {.lex_state = 6, .external_lex_state = 3},
  [886] = {.lex_state = 7, .external_lex_state = 3},
  [887] = {.lex_state = 6, .external_lex_state = 3},
  [888] = {.lex_state = 6, .external_lex_state = 3},
  [889] = {.lex_state = 6, .external_lex_state = 2},
  [890] = {.lex_state = 7, .external_lex_state = 3},
  [891] = {.lex_state = 6, .external_lex_state = 2},
  [892] = {.lex_state = 6, .external_lex_state = 3},
  [893] = {.lex_state = 6, .external_lex_state = 3},
  [894] = {.lex_state = 6, .external_lex_state = 2},
  [895] = {.lex_state = 7, .external_lex_state = 3},
  [896] = {.lex_state = 7, .external_lex_state = 3},
  [897] = {.lex_state = 7, .external_lex_state = 3},
  [898] = {.lex_state = 6, .external_lex_state = 2},
  [899] = {.lex_state = 7, .external_lex_state = 3},
  [900] = {.lex_state = 7, .external_lex_state = 3},
  [901] = {.lex_state = 6, .external_lex_state = 3},
  [902] = {.lex_state = 6, .external_lex_state = 3},
  [903] = {.lex_state = 7, .external_lex_state = 3},
  [904] = {.lex_state = 6, .external_lex_state = 3},
  [905] = {.lex_state = 7, .external_lex_state = 3},
  [906] = {.lex_state = 6, .external_lex_state = 3},
  [907] = {.lex_state = 6, .external_lex_state = 2},
  [908] = {.lex_state = 6, .external_lex_state = 2},
  [909] = {.lex_state = 6, .external_lex_state = 3},
  [910] = {.lex_state = 6, .external_lex_state = 2},
  [911] = {.lex_state = 7, .external_lex_state = 3},
  [912] = {.lex_state = 6, .external_lex_state = 3},
  [913] = {.lex_state = 6, .external_lex_state = 3},
  [914] = {.lex_state = 6, .external_lex_state = 3},
  [915] = {.lex_state = 7, .external_lex_state = 3},
  [916] = {.lex_state = 6, .external_lex_state = 3},
  [917] = {.lex_state = 7, .external_lex_state = 3},
  [918] = {.lex_state = 6, .external_lex_state = 3},
  [919] = {.lex_state = 6, .external_lex_state = 3},
  [920] = {.lex_state = 6, .external_lex_state = 3},
  [921] = {.lex_state = 6, .external_lex_state = 3},
  [922] = {.lex_state = 6, .external_lex_state = 3},
  [923] = {.lex_state = 6, .external_lex_state = 2},
  [924] = {.lex_state = 6, .external_lex_state = 3},
  [925] = {.lex_state = 6, .external_lex_state = 3},
  [926] = {.lex_state = 66},
  [927] = {.lex_state = 66, .external_lex_state = 4},
  [928] = {.lex_state = 65, .external_lex_state = 2},
  [929] = {.lex_state = 66, .external_lex_state = 4},
  [930] = {.lex_state = 66},
  [931] = {.lex_state = 66, .external_lex_state = 4},
  [932] = {.lex_state = 66},
  [933] = {.lex_state = 66},
  [934] = {.lex_state = 66, .external_lex_state = 4},
  [935] = {.lex_state = 6, .external_lex_state = 3},
  [936] = {.lex_state = 66},
  [937] = {.lex_state = 66, .external_lex_state = 4},
  [938] = {.lex_state = 66, .external_lex_state = 4},
  [939] = {.lex_state = 66},
  [940] = {.lex_state = 66},
  [941] = {.lex_state = 66},
  [942] = {.lex_state = 66},
  [943] = {.lex_state = 66},
  [944] = {.lex_state = 66},
  [945] = {.lex_state = 66},
  [946] = {.lex_state = 66},
  [947] = {.lex_state = 66},
  [948] = {.lex_state = 66},
  [949] = {.lex_state = 66},
  [950] = {.lex_state = 66},
  [951] = {.lex_state = 66},
  [952] = {.lex_state = 66},
  [953] = {.lex_state = 66},
  [954] = {.lex_state = 65, .external_lex_state = 3},
  [955] = {.lex_state = 66},
  [956] = {.lex_state = 66},
  [957] = {.lex_state = 66},
  [958] = {.lex_state = 66},
  [959] = {.lex_state = 65, .external_lex_state = 3},
  [960] = {.lex_state = 66},
  [961] = {.lex_state = 66},
  [962] = {.lex_state = 65, .external_lex_state = 3},
  [963] = {.lex_state = 65, .external_lex_state = 3},
  [964] = {.lex_state = 65, .external_lex_state = 3},
  [965] = {.lex_state = 65, .external_lex_state = 2},
  [966] = {.lex_state = 65, .external_lex_state = 2},
  [967] = {.lex_state = 65, .external_lex_state = 3},
  [968] = {.lex_state = 65, .external_lex_state = 3},
  [969] = {.lex_state = 65, .external_lex_state = 3},
  [970] = {.lex_state = 65, .external_lex_state = 3},
  [971] = {.lex_state = 65, .external_lex_state = 3},
  [972] = {.lex_state = 65, .external_lex_state = 3},
  [973] = {.lex_state = 65, .external_lex_state = 3},
  [974] = {.lex_state = 65, .external_lex_state = 3},
  [975] = {.lex_state = 65, .external_lex_state = 3},
  [976] = {.lex_state = 65, .external_lex_state = 3},
  [977] = {.lex_state = 65, .external_lex_state = 2},
  [978] = {.lex_state = 65, .external_lex_state = 3},
  [979] = {.lex_state = 65, .external_lex_state = 3},
  [980] = {.lex_state = 65, .external_lex_state = 3},
  [981] = {.lex_state = 65, .external_lex_state = 3},
  [982] = {.lex_state = 65, .external_lex_state = 3},
  [983] = {.lex_state = 65, .external_lex_state = 3},
  [984] = {.lex_state = 65, .external_lex_state = 2},
  [985] = {.lex_state = 65, .external_lex_state = 3},
  [986] = {.lex_state = 65, .external_lex_state = 3},
  [987] = {.lex_state = 65, .external_lex_state = 3},
  [988] = {.lex_state = 65, .external_lex_state = 3},
  [989] = {.lex_state = 65, .external_lex_state = 3},
  [990] = {.lex_state = 65, .external_lex_state = 3},
  [991] = {.lex_state = 65, .external_lex_state = 3},
  [992] = {.lex_state = 65, .external_lex_state = 3},
  [993] = {.lex_state = 65, .external_lex_state = 3},
  [994] = {.lex_state = 65, .external_lex_state = 3},
  [995] = {.lex_state = 65, .external_lex_state = 3},
  [996] = {.lex_state = 65, .external_lex_state = 3},
  [997] = {.lex_state = 65, .external_lex_state = 3},
  [998] = {.lex_state = 65, .external_lex_state = 3},
  [999] = {.lex_state = 65, .external_lex_state = 2},
  [1000] = {.lex_state = 65, .external_lex_state = 3},
  [1001] = {.lex_state = 65, .external_lex_state = 2},
  [1002] = {.lex_state = 65, .external_lex_state = 3},
  [1003] = {.lex_state = 65, .external_lex_state = 3},
  [1004] = {.lex_state = 65, .external_lex_state = 2},
  [1005] = {.lex_state = 65, .external_lex_state = 3},
  [1006] = {.lex_state = 65, .external_lex_state = 3},
  [1007] = {.lex_state = 65, .external_lex_state = 3},
  [1008] = {.lex_state = 65, .external_lex_state = 3},
  [1009] = {.lex_state = 65, .external_lex_state = 3},
  [1010] = {.lex_state = 65, .external_lex_state = 3},
  [1011] = {.lex_state = 65, .external_lex_state = 2},
  [1012] = {.lex_state = 65, .external_lex_state = 3},
  [1013] = {.lex_state = 65, .external_lex_state = 2},
  [1014] = {.lex_state = 65, .external_lex_state = 3},
  [1015] = {.lex_state = 65, .external_lex_state = 3},
  [1016] = {.lex_state = 65, .external_lex_state = 3},
  [1017] = {.lex_state = 65, .external_lex_state = 3},
  [1018] = {.lex_state = 65, .external_lex_state = 3},
  [1019] = {.lex_state = 65, .external_lex_state = 3},
  [1020] = {.lex_state = 65, .external_lex_state = 3},
  [1021] = {.lex_state = 65, .external_lex_state = 3},
  [1022] = {.lex_state = 65, .external_lex_state = 2},
  [1023] = {.lex_state = 65, .external_lex_state = 3},
  [1024] = {.lex_state = 65, .external_lex_state = 2},
  [1025] = {.lex_state = 65, .external_lex_state = 3},
  [1026] = {.lex_state = 65, .external_lex_state = 3},
  [1027] = {.lex_state = 65, .external_lex_state = 3},
  [1028] = {.lex_state = 65, .external_lex_state = 3},
  [1029] = {.lex_state = 65, .external_lex_state = 3},
  [1030] = {.lex_state = 65, .external_lex_state = 3},
  [1031] = {.lex_state = 15},
  [1032] = {.lex_state = 65, .external_lex_state = 3},
  [1033] = {.lex_state = 65, .external_lex_state = 3},
  [1034] = {.lex_state = 65, .external_lex_state = 3},
  [1035] = {.lex_state = 65, .external_lex_state = 3},
  [1036] = {.lex_state = 15},
  [1037] = {.lex_state = 65, .external_lex_state = 3},
  [1038] = {.lex_state = 65, .external_lex_state = 3},
  [1039] = {.lex_state = 15},
  [1040] = {.lex_state = 65, .external_lex_state = 2},
  [1041] = {.lex_state = 65, .external_lex_state = 3},
  [1042] = {.lex_state = 65, .external_lex_state = 3},
  [1043] = {.lex_state = 65, .external_lex_state = 3},
  [1044] = {.lex_state = 65, .external_lex_state = 3},
  [1045] = {.lex_state = 65, .external_lex_state = 3},
  [1046] = {.lex_state = 65, .external_lex_state = 3},
  [1047] = {.lex_state = 65, .external_lex_state = 3},
  [1048] = {.lex_state = 65, .external_lex_state = 3},
  [1049] = {.lex_state = 65, .external_lex_state = 2},
  [1050] = {.lex_state = 65, .external_lex_state = 3},
  [1051] = {.lex_state = 65, .external_lex_state = 3},
  [1052] = {.lex_state = 65, .external_lex_state = 3},
  [1053] = {.lex_state = 65, .external_lex_state = 3},
  [1054] = {.lex_state = 65, .external_lex_state = 3},
  [1055] = {.lex_state = 65, .external_lex_state = 3},
  [1056] = {.lex_state = 65, .external_lex_state = 3},
  [1057] = {.lex_state = 65, .external_lex_state = 3},
  [1058] = {.lex_state = 65, .external_lex_state = 3},
  [1059] = {.lex_state = 65, .external_lex_state = 3},
  [1060] = {.lex_state = 65, .external_lex_state = 3},
  [1061] = {.lex_state = 65, .external_lex_state = 3},
  [1062] = {.lex_state = 65, .external_lex_state = 3},
  [1063] = {.lex_state = 65, .external_lex_state = 3},
  [1064] = {.lex_state = 65, .external_lex_state = 3},
  [1065] = {.lex_state = 65, .external_lex_state = 3},
  [1066] = {.lex_state = 65, .external_lex_state = 3},
  [1067] = {.lex_state = 65, .external_lex_state = 3},
  [1068] = {.lex_state = 65, .external_lex_state = 3},
  [1069] = {.lex_state = 65, .external_lex_state = 3},
  [1070] = {.lex_state = 65, .external_lex_state = 2},
  [1071] = {.lex_state = 65, .external_lex_state = 3},
  [1072] = {.lex_state = 65, .external_lex_state = 3},
  [1073] = {.lex_state = 65, .external_lex_state = 3},
  [1074] = {.lex_state = 65, .external_lex_state = 3},
  [1075] = {.lex_state = 65, .external_lex_state = 3},
  [1076] = {.lex_state = 15},
  [1077] = {.lex_state = 65, .external_lex_state = 3},
  [1078] = {.lex_state = 65, .external_lex_state = 3},
  [1079] = {.lex_state = 65, .external_lex_state = 2},
  [1080] = {.lex_state = 65, .external_lex_state = 2},
  [1081] = {.lex_state = 65, .external_lex_state = 3},
  [1082] = {.lex_state = 65, .external_lex_state = 2},
  [1083] = {.lex_state = 65, .external_lex_state = 3},
  [1084] = {.lex_state = 65, .external_lex_state = 3},
  [1085] = {.lex_state = 65, .external_lex_state = 3},
  [1086] = {.lex_state = 65, .external_lex_state = 3},
  [1087] = {.lex_state = 65, .external_lex_state = 2},
  [1088] = {.lex_state = 65, .external_lex_state = 3},
  [1089] = {.lex_state = 65, .external_lex_state = 3},
  [1090] = {.lex_state = 65, .external_lex_state = 3},
  [1091] = {.lex_state = 65, .external_lex_state = 3},
  [1092] = {.lex_state = 65, .external_lex_state = 3},
  [1093] = {.lex_state = 65, .external_lex_state = 3},
  [1094] = {.lex_state = 65, .external_lex_state = 3},
  [1095] = {.lex_state = 65, .external_lex_state = 3},
  [1096] = {.lex_state = 65, .external_lex_state = 3},
  [1097] = {.lex_state = 65, .external_lex_state = 3},
  [1098] = {.lex_state = 65, .external_lex_state = 3},
  [1099] = {.lex_state = 65, .external_lex_state = 3},
  [1100] = {.lex_state = 65, .external_lex_state = 2},
  [1101] = {.lex_state = 65, .external_lex_state = 3},
  [1102] = {.lex_state = 65, .external_lex_state = 3},
  [1103] = {.lex_state = 65, .external_lex_state = 3},
  [1104] = {.lex_state = 65, .external_lex_state = 3},
  [1105] = {.lex_state = 65, .external_lex_state = 2},
  [1106] = {.lex_state = 15},
  [1107] = {.lex_state = 65, .external_lex_state = 3},
  [1108] = {.lex_state = 65, .external_lex_state = 3},
  [1109] = {.lex_state = 65, .external_lex_state = 3},
  [1110] = {.lex_state = 65, .external_lex_state = 2},
  [1111] = {.lex_state = 65, .external_lex_state = 3},
  [1112] = {.lex_state = 65, .external_lex_state = 3},
  [1113] = {.lex_state = 65, .external_lex_state = 2},
  [1114] = {.lex_state = 65, .external_lex_state = 2},
  [1115] = {.lex_state = 65, .external_lex_state = 3},
  [1116] = {.lex_state = 65, .external_lex_state = 2},
  [1117] = {.lex_state = 65, .external_lex_state = 3},
  [1118] = {.lex_state = 65, .external_lex_state = 2},
  [1119] = {.lex_state = 65, .external_lex_state = 3},
  [1120] = {.lex_state = 65, .external_lex_state = 2},
  [1121] = {.lex_state = 65, .external_lex_state = 2},
  [1122] = {.lex_state = 65, .external_lex_state = 2},
  [1123] = {.lex_state = 65, .external_lex_state = 3},
  [1124] = {.lex_state = 65, .external_lex_state = 3},
  [1125] = {.lex_state = 65, .external_lex_state = 2},
  [1126] = {.lex_state = 65, .external_lex_state = 3},
  [1127] = {.lex_state = 65, .external_lex_state = 3},
  [1128] = {.lex_state = 65, .external_lex_state = 3},
  [1129] = {.lex_state = 65, .external_lex_state = 3},
  [1130] = {.lex_state = 65, .external_lex_state = 3},
  [1131] = {.lex_state = 65, .external_lex_state = 2},
  [1132] = {.lex_state = 65, .external_lex_state = 3},
  [1133] = {.lex_state = 65, .external_lex_state = 2},
  [1134] = {.lex_state = 65, .external_lex_state = 2},
  [1135] = {.lex_state = 65, .external_lex_state = 2},
  [1136] = {.lex_state = 65, .external_lex_state = 3},
  [1137] = {.lex_state = 65, .external_lex_state = 2},
  [1138] = {.lex_state = 65, .external_lex_state = 2},
  [1139] = {.lex_state = 65, .external_lex_state = 2},
  [1140] = {.lex_state = 65, .external_lex_state = 2},
  [1141] = {.lex_state = 65, .external_lex_state = 2},
  [1142] = {.lex_state = 65, .external_lex_state = 2},
  [1143] = {.lex_state = 65, .external_lex_state = 2},
  [1144] = {.lex_state = 65, .external_lex_state = 2},
  [1145] = {.lex_state = 65, .external_lex_state = 3},
  [1146] = {.lex_state = 65, .external_lex_state = 2},
  [1147] = {.lex_state = 65, .external_lex_state = 3},
  [1148] = {.lex_state = 65, .external_lex_state = 2},
  [1149] = {.lex_state = 65, .external_lex_state = 3},
  [1150] = {.lex_state = 15},
  [1151] = {.lex_state = 65, .external_lex_state = 2},
  [1152] = {.lex_state = 15},
  [1153] = {.lex_state = 8, .external_lex_state = 3},
  [1154] = {.lex_state = 65, .external_lex_state = 3},
  [1155] = {.lex_state = 65, .external_lex_state = 2},
  [1156] = {.lex_state = 65, .external_lex_state = 3},
  [1157] = {.lex_state = 65, .external_lex_state = 3},
  [1158] = {.lex_state = 65, .external_lex_state = 2},
  [1159] = {.lex_state = 65, .external_lex_state = 2},
  [1160] = {.lex_state = 65, .external_lex_state = 3},
  [1161] = {.lex_state = 65, .external_lex_state = 3},
  [1162] = {.lex_state = 65, .external_lex_state = 3},
  [1163] = {.lex_state = 65, .external_lex_state = 3},
  [1164] = {.lex_state = 65, .external_lex_state = 2},
  [1165] = {.lex_state = 65, .external_lex_state = 3},
  [1166] = {.lex_state = 65, .external_lex_state = 2},
  [1167] = {.lex_state = 65, .external_lex_state = 2},
  [1168] = {.lex_state = 65, .external_lex_state = 3},
  [1169] = {.lex_state = 65, .external_lex_state = 3},
  [1170] = {.lex_state = 65, .external_lex_state = 3},
  [1171] = {.lex_state = 65, .external_lex_state = 3},
  [1172] = {.lex_state = 65, .external_lex_state = 3},
  [1173] = {.lex_state = 65, .external_lex_state = 3},
  [1174] = {.lex_state = 65, .external_lex_state = 3},
  [1175] = {.lex_state = 65, .external_lex_state = 2},
  [1176] = {.lex_state = 65, .external_lex_state = 2},
  [1177] = {.lex_state = 65, .external_lex_state = 3},
  [1178] = {.lex_state = 8, .external_lex_state = 3},
  [1179] = {.lex_state = 8, .external_lex_state = 3},
  [1180] = {.lex_state = 65, .external_lex_state = 3},
  [1181] = {.lex_state = 8, .external_lex_state = 3},
  [1182] = {.lex_state = 65, .external_lex_state = 3},
  [1183] = {.lex_state = 65, .external_lex_state = 3},
  [1184] = {.lex_state = 8, .external_lex_state = 3},
  [1185] = {.lex_state = 65, .external_lex_state = 3},
  [1186] = {.lex_state = 65, .external_lex_state = 3},
  [1187] = {.lex_state = 65, .external_lex_state = 3},
  [1188] = {.lex_state = 8, .external_lex_state = 3},
  [1189] = {.lex_state = 8, .external_lex_state = 3},
  [1190] = {.lex_state = 65, .external_lex_state = 3},
  [1191] = {.lex_state = 65, .external_lex_state = 2},
  [1192] = {.lex_state = 65, .external_lex_state = 3},
  [1193] = {.lex_state = 65, .external_lex_state = 3},
  [1194] = {.lex_state = 65, .external_lex_state = 2},
  [1195] = {.lex_state = 65, .external_lex_state = 3},
  [1196] = {.lex_state = 65, .external_lex_state = 3},
  [1197] = {.lex_state = 65, .external_lex_state = 3},
  [1198] = {.lex_state = 65, .external_lex_state = 3},
  [1199] = {.lex_state = 65, .external_lex_state = 3},
  [1200] = {.lex_state = 65, .external_lex_state = 3},
  [1201] = {.lex_state = 65, .external_lex_state = 3},
  [1202] = {.lex_state = 9, .external_lex_state = 3},
  [1203] = {.lex_state = 8, .external_lex_state = 3},
  [1204] = {.lex_state = 65, .external_lex_state = 3},
  [1205] = {.lex_state = 65, .external_lex_state = 3},
  [1206] = {.lex_state = 65, .external_lex_state = 3},
  [1207] = {.lex_state = 65, .external_lex_state = 3},
  [1208] = {.lex_state = 65, .external_lex_state = 3},
  [1209] = {.lex_state = 65, .external_lex_state = 2},
  [1210] = {.lex_state = 65, .external_lex_state = 3},
  [1211] = {.lex_state = 8, .external_lex_state = 3},
  [1212] = {.lex_state = 8, .external_lex_state = 3},
  [1213] = {.lex_state = 8, .external_lex_state = 3},
  [1214] = {.lex_state = 8, .external_lex_state = 3},
  [1215] = {.lex_state = 65, .external_lex_state = 2},
  [1216] = {.lex_state = 8, .external_lex_state = 3},
  [1217] = {.lex_state = 65, .external_lex_state = 3},
  [1218] = {.lex_state = 65, .external_lex_state = 3},
  [1219] = {.lex_state = 8, .external_lex_state = 3},
  [1220] = {.lex_state = 65, .external_lex_state = 2},
  [1221] = {.lex_state = 8, .external_lex_state = 3},
  [1222] = {.lex_state = 65, .external_lex_state = 2},
  [1223] = {.lex_state = 65, .external_lex_state = 2},
  [1224] = {.lex_state = 65, .external_lex_state = 2},
  [1225] = {.lex_state = 65, .external_lex_state = 3},
  [1226] = {.lex_state = 65, .external_lex_state = 2},
  [1227] = {.lex_state = 65, .external_lex_state = 2},
  [1228] = {.lex_state = 66},
  [1229] = {.lex_state = 66},
  [1230] = {.lex_state = 8, .external_lex_state = 3},
  [1231] = {.lex_state = 65, .external_lex_state = 3},
  [1232] = {.lex_state = 65, .external_lex_state = 2},
  [1233] = {.lex_state = 65, .external_lex_state = 3},
  [1234] = {.lex_state = 65, .external_lex_state = 2},
  [1235] = {.lex_state = 8, .external_lex_state = 3},
  [1236] = {.lex_state = 65, .external_lex_state = 2},
  [1237] = {.lex_state = 65, .external_lex_state = 3},
  [1238] = {.lex_state = 65, .external_lex_state = 3},
  [1239] = {.lex_state = 8, .external_lex_state = 3},
  [1240] = {.lex_state = 65, .external_lex_state = 3},
  [1241] = {.lex_state = 65, .external_lex_state = 2},
  [1242] = {.lex_state = 8, .external_lex_state = 3},
  [1243] = {.lex_state = 8, .external_lex_state = 3},
  [1244] = {.lex_state = 65, .external_lex_state = 2},
  [1245] = {.lex_state = 65, .external_lex_state = 3},
  [1246] = {.lex_state = 65, .external_lex_state = 3},
  [1247] = {.lex_state = 65, .external_lex_state = 3},
  [1248] = {.lex_state = 8, .external_lex_state = 3},
  [1249] = {.lex_state = 65, .external_lex_state = 2},
  [1250] = {.lex_state = 65, .external_lex_state = 3},
  [1251] = {.lex_state = 65, .external_lex_state = 3},
  [1252] = {.lex_state = 65, .external_lex_state = 3},
  [1253] = {.lex_state = 8, .external_lex_state = 3},
  [1254] = {.lex_state = 8, .external_lex_state = 3},
  [1255] = {.lex_state = 8, .external_lex_state = 3},
  [1256] = {.lex_state = 65, .external_lex_state = 3},
  [1257] = {.lex_state = 65, .external_lex_state = 3},
  [1258] = {.lex_state = 8, .external_lex_state = 3},
  [1259] = {.lex_state = 65, .external_lex_state = 3},
  [1260] = {.lex_state = 8, .external_lex_state = 3},
  [1261] = {.lex_state = 65, .external_lex_state = 3},
  [1262] = {.lex_state = 65, .external_lex_state = 2},
  [1263] = {.lex_state = 8, .external_lex_state = 3},
  [1264] = {.lex_state = 65, .external_lex_state = 3},
  [1265] = {.lex_state = 65, .external_lex_state = 3},
  [1266] = {.lex_state = 8, .external_lex_state = 3},
  [1267] = {.lex_state = 65, .external_lex_state = 3},
  [1268] = {.lex_state = 65, .external_lex_state = 3},
  [1269] = {.lex_state = 65, .external_lex_state = 3},
  [1270] = {.lex_state = 65, .external_lex_state = 2},
  [1271] = {.lex_state = 66},
  [1272] = {.lex_state = 65, .external_lex_state = 2},
  [1273] = {.lex_state = 65, .external_lex_state = 3},
  [1274] = {.lex_state = 65, .external_lex_state = 3},
  [1275] = {.lex_state = 65, .external_lex_state = 3},
  [1276] = {.lex_state = 65, .external_lex_state = 3},
  [1277] = {.lex_state = 65, .external_lex_state = 3},
  [1278] = {.lex_state = 65, .external_lex_state = 3},
  [1279] = {.lex_state = 65, .external_lex_state = 3},
  [1280] = {.lex_state = 65, .external_lex_state = 3},
  [1281] = {.lex_state = 65, .external_lex_state = 3},
  [1282] = {.lex_state = 8, .external_lex_state = 3},
  [1283] = {.lex_state = 8, .external_lex_state = 3},
  [1284] = {.lex_state = 65, .external_lex_state = 3},
  [1285] = {.lex_state = 65, .external_lex_state = 3},
  [1286] = {.lex_state = 65, .external_lex_state = 3},
  [1287] = {.lex_state = 8, .external_lex_state = 3},
  [1288] = {.lex_state = 65, .external_lex_state = 3},
  [1289] = {.lex_state = 65, .external_lex_state = 3},
  [1290] = {.lex_state = 65, .external_lex_state = 2},
  [1291] = {.lex_state = 66},
  [1292] = {.lex_state = 65, .external_lex_state = 3},
  [1293] = {.lex_state = 65, .external_lex_state = 3},
  [1294] = {.lex_state = 65, .external_lex_state = 3},
  [1295] = {.lex_state = 65, .external_lex_state = 3},
  [1296] = {.lex_state = 65, .external_lex_state = 3},
  [1297] = {.lex_state = 65, .external_lex_state = 2},
  [1298] = {.lex_state = 65, .external_lex_state = 3},
  [1299] = {.lex_state = 65, .external_lex_state = 3},
  [1300] = {.lex_state = 66},
  [1301] = {.lex_state = 65, .external_lex_state = 2},
  [1302] = {.lex_state = 65, .external_lex_state = 3},
  [1303] = {.lex_state = 8, .external_lex_state = 3},
  [1304] = {.lex_state = 65, .external_lex_state = 3},
  [1305] = {.lex_state = 65, .external_lex_state = 2},
  [1306] = {.lex_state = 65, .external_lex_state = 2},
  [1307] = {.lex_state = 65, .external_lex_state = 3},
  [1308] = {.lex_state = 65, .external_lex_state = 2},
  [1309] = {.lex_state = 65, .external_lex_state = 2},
  [1310] = {.lex_state = 66},
  [1311] = {.lex_state = 66, .external_lex_state = 4},
  [1312] = {.lex_state = 66, .external_lex_state = 4},
  [1313] = {.lex_state = 66, .external_lex_state = 4},
  [1314] = {.lex_state = 66},
  [1315] = {.lex_state = 65, .external_lex_state = 2},
  [1316] = {.lex_state = 66, .external_lex_state = 4},
  [1317] = {.lex_state = 66, .external_lex_state = 4},
  [1318] = {.lex_state = 66, .external_lex_state = 4},
  [1319] = {.lex_state = 65, .external_lex_state = 2},
  [1320] = {.lex_state = 65, .external_lex_state = 2},
  [1321] = {.lex_state = 65, .external_lex_state = 3},
  [1322] = {.lex_state = 65, .external_lex_state = 2},
  [1323] = {.lex_state = 65, .external_lex_state = 2},
  [1324] = {.lex_state = 65, .external_lex_state = 2},
  [1325] = {.lex_state = 65, .external_lex_state = 2},
  [1326] = {.lex_state = 65, .external_lex_state = 2},
  [1327] = {.lex_state = 65, .external_lex_state = 2},
  [1328] = {.lex_state = 66},
  [1329] = {.lex_state = 66},
  [1330] = {.lex_state = 65, .external_lex_state = 2},
  [1331] = {.lex_state = 66},
  [1332] = {.lex_state = 66},
  [1333] = {.lex_state = 9, .external_lex_state = 2},
  [1334] = {.lex_state = 66},
  [1335] = {.lex_state = 66},
  [1336] = {.lex_state = 66},
  [1337] = {.lex_state = 65, .external_lex_state = 3},
  [1338] = {.lex_state = 65, .external_lex_state = 3},
  [1339] = {.lex_state = 66},
  [1340] = {.lex_state = 65, .external_lex_state = 3},
  [1341] = {.lex_state = 66},
  [1342] = {.lex_state = 65, .external_lex_state = 3},
  [1343] = {.lex_state = 65, .external_lex_state = 2},
  [1344] = {.lex_state = 65, .external_lex_state = 2},
  [1345] = {.lex_state = 65, .external_lex_state = 2},
  [1346] = {.lex_state = 66, .external_lex_state = 4},
  [1347] = {.lex_state = 66, .external_lex_state = 4},
  [1348] = {.lex_state = 66, .external_lex_state = 4},
  [1349] = {.lex_state = 65, .external_lex_state = 3},
  [1350] = {.lex_state = 65, .external_lex_state = 2},
  [1351] = {.lex_state = 65, .external_lex_state = 2},
  [1352] = {.lex_state = 65, .external_lex_state = 2},
  [1353] = {.lex_state = 65, .external_lex_state = 2},
  [1354] = {.lex_state = 65, .external_lex_state = 3},
  [1355] = {.lex_state = 65, .external_lex_state = 2},
  [1356] = {.lex_state = 65, .external_lex_state = 2},
  [1357] = {.lex_state = 65, .external_lex_state = 2},
  [1358] = {.lex_state = 65, .external_lex_state = 2},
  [1359] = {.lex_state = 65, .external_lex_state = 2},
  [1360] = {.lex_state = 65, .external_lex_state = 2},
  [1361] = {.lex_state = 65, .external_lex_state = 2},
  [1362] = {.lex_state = 65, .external_lex_state = 2},
  [1363] = {.lex_state = 65, .external_lex_state = 2},
  [1364] = {.lex_state = 65, .external_lex_state = 3},
  [1365] = {.lex_state = 65, .external_lex_state = 2},
  [1366] = {.lex_state = 65, .external_lex_state = 2},
  [1367] = {.lex_state = 66},
  [1368] = {.lex_state = 65, .external_lex_state = 2},
  [1369] = {.lex_state = 65, .external_lex_state = 2},
  [1370] = {.lex_state = 65, .external_lex_state = 2},
  [1371] = {.lex_state = 65, .external_lex_state = 2},
  [1372] = {.lex_state = 65, .external_lex_state = 2},
  [1373] = {.lex_state = 66},
  [1374] = {.lex_state = 65, .external_lex_state = 2},
  [1375] = {.lex_state = 65, .external_lex_state = 2},
  [1376] = {.lex_state = 8, .external_lex_state = 3},
  [1377] = {.lex_state = 66},
  [1378] = {.lex_state = 65, .external_lex_state = 2},
  [1379] = {.lex_state = 8, .external_lex_state = 2},
  [1380] = {.lex_state = 65, .external_lex_state = 2},
  [1381] = {.lex_state = 8, .external_lex_state = 3},
  [1382] = {.lex_state = 66, .external_lex_state = 4},
  [1383] = {.lex_state = 66, .external_lex_state = 4},
  [1384] = {.lex_state = 66, .external_lex_state = 4},
  [1385] = {.lex_state = 65, .external_lex_state = 2},
  [1386] = {.lex_state = 65, .external_lex_state = 3},
  [1387] = {.lex_state = 65, .external_lex_state = 3},
  [1388] = {.lex_state = 65, .external_lex_state = 3},
  [1389] = {.lex_state = 65, .external_lex_state = 3},
  [1390] = {.lex_state = 65, .external_lex_state = 3},
  [1391] = {.lex_state = 65, .external_lex_state = 3},
  [1392] = {.lex_state = 65, .external_lex_state = 3},
  [1393] = {.lex_state = 65, .external_lex_state = 3},
  [1394] = {.lex_state = 65, .external_lex_state = 3},
  [1395] = {.lex_state = 8, .external_lex_state = 3},
  [1396] = {.lex_state = 8, .external_lex_state = 3},
  [1397] = {.lex_state = 65, .external_lex_state = 2},
  [1398] = {.lex_state = 65, .external_lex_state = 2},
  [1399] = {.lex_state = 65, .external_lex_state = 2},
  [1400] = {.lex_state = 65, .external_lex_state = 2},
  [1401] = {.lex_state = 65, .external_lex_state = 2},
  [1402] = {.lex_state = 65, .external_lex_state = 2},
  [1403] = {.lex_state = 65, .external_lex_state = 2},
  [1404] = {.lex_state = 65, .external_lex_state = 2},
  [1405] = {.lex_state = 65, .external_lex_state = 2},
  [1406] = {.lex_state = 65, .external_lex_state = 3},
  [1407] = {.lex_state = 65, .external_lex_state = 3},
  [1408] = {.lex_state = 65, .external_lex_state = 3},
  [1409] = {.lex_state = 65, .external_lex_state = 3},
  [1410] = {.lex_state = 65, .external_lex_state = 2},
  [1411] = {.lex_state = 65, .external_lex_state = 2},
  [1412] = {.lex_state = 65, .external_lex_state = 3},
  [1413] = {.lex_state = 65, .external_lex_state = 2},
  [1414] = {.lex_state = 65, .external_lex_state = 2},
  [1415] = {.lex_state = 65, .external_lex_state = 2},
  [1416] = {.lex_state = 65, .external_lex_state = 2},
  [1417] = {.lex_state = 65, .external_lex_state = 2},
  [1418] = {.lex_state = 66, .external_lex_state = 4},
  [1419] = {.lex_state = 65, .external_lex_state = 2},
  [1420] = {.lex_state = 65, .external_lex_state = 2},
  [1421] = {.lex_state = 65, .external_lex_state = 2},
  [1422] = {.lex_state = 65, .external_lex_state = 2},
  [1423] = {.lex_state = 65, .external_lex_state = 2},
  [1424] = {.lex_state = 65, .external_lex_state = 3},
  [1425] = {.lex_state = 65, .external_lex_state = 2},
  [1426] = {.lex_state = 66, .external_lex_state = 4},
  [1427] = {.lex_state = 65, .external_lex_state = 3},
  [1428] = {.lex_state = 65, .external_lex_state = 2},
  [1429] = {.lex_state = 65, .external_lex_state = 3},
  [1430] = {.lex_state = 65, .external_lex_state = 2},
  [1431] = {.lex_state = 65, .external_lex_state = 3},
  [1432] = {.lex_state = 65, .external_lex_state = 2},
  [1433] = {.lex_state = 65, .external_lex_state = 2},
  [1434] = {.lex_state = 65, .external_lex_state = 2},
  [1435] = {.lex_state = 65, .external_lex_state = 3},
  [1436] = {.lex_state = 65, .external_lex_state = 2},
  [1437] = {.lex_state = 65, .external_lex_state = 2},
  [1438] = {.lex_state = 65, .external_lex_state = 2},
  [1439] = {.lex_state = 65, .external_lex_state = 3},
  [1440] = {.lex_state = 65, .external_lex_state = 2},
  [1441] = {.lex_state = 65, .external_lex_state = 3},
  [1442] = {.lex_state = 65, .external_lex_state = 2},
  [1443] = {.lex_state = 65, .external_lex_state = 2},
  [1444] = {.lex_state = 65, .external_lex_state = 2},
  [1445] = {.lex_state = 65, .external_lex_state = 2},
  [1446] = {.lex_state = 65, .external_lex_state = 2},
  [1447] = {.lex_state = 65, .external_lex_state = 2},
  [1448] = {.lex_state = 66, .external_lex_state = 4},
  [1449] = {.lex_state = 65, .external_lex_state = 2},
  [1450] = {.lex_state = 65, .external_lex_state = 2},
  [1451] = {.lex_state = 65, .external_lex_state = 2},
  [1452] = {.lex_state = 65, .external_lex_state = 3},
  [1453] = {.lex_state = 65, .external_lex_state = 2},
  [1454] = {.lex_state = 65, .external_lex_state = 2},
  [1455] = {.lex_state = 65, .external_lex_state = 2},
  [1456] = {.lex_state = 65, .external_lex_state = 2},
  [1457] = {.lex_state = 8, .external_lex_state = 3},
  [1458] = {.lex_state = 8, .external_lex_state = 3},
  [1459] = {.lex_state = 65, .external_lex_state = 3},
  [1460] = {.lex_state = 65, .external_lex_state = 3},
  [1461] = {.lex_state = 8, .external_lex_state = 3},
  [1462] = {.lex_state = 65, .external_lex_state = 3},
  [1463] = {.lex_state = 65, .external_lex_state = 2},
  [1464] = {.lex_state = 8, .external_lex_state = 3},
  [1465] = {.lex_state = 8, .external_lex_state = 3},
  [1466] = {.lex_state = 8, .external_lex_state = 2},
  [1467] = {.lex_state = 8, .external_lex_state = 3},
  [1468] = {.lex_state = 65, .external_lex_state = 2},
  [1469] = {.lex_state = 65, .external_lex_state = 3},
  [1470] = {.lex_state = 65, .external_lex_state = 3},
  [1471] = {.lex_state = 65, .external_lex_state = 3},
  [1472] = {.lex_state = 65, .external_lex_state = 2},
  [1473] = {.lex_state = 65, .external_lex_state = 2},
  [1474] = {.lex_state = 65, .external_lex_state = 3},
  [1475] = {.lex_state = 65, .external_lex_state = 2},
  [1476] = {.lex_state = 8, .external_lex_state = 3},
  [1477] = {.lex_state = 65, .external_lex_state = 2},
  [1478] = {.lex_state = 9, .external_lex_state = 3},
  [1479] = {.lex_state = 8, .external_lex_state = 3},
  [1480] = {.lex_state = 8, .external_lex_state = 3},
  [1481] = {.lex_state = 65, .external_lex_state = 2},
  [1482] = {.lex_state = 8, .external_lex_state = 3},
  [1483] = {.lex_state = 8, .external_lex_state = 3},
  [1484] = {.lex_state = 8, .external_lex_state = 3},
  [1485] = {.lex_state = 65, .external_lex_state = 3},
  [1486] = {.lex_state = 65, .external_lex_state = 2},
  [1487] = {.lex_state = 65, .external_lex_state = 2},
  [1488] = {.lex_state = 65, .external_lex_state = 2},
  [1489] = {.lex_state = 8, .external_lex_state = 3},
  [1490] = {.lex_state = 8, .external_lex_state = 3},
  [1491] = {.lex_state = 65, .external_lex_state = 2},
  [1492] = {.lex_state = 65, .external_lex_state = 2},
  [1493] = {.lex_state = 65, .external_lex_state = 2},
  [1494] = {.lex_state = 8, .external_lex_state = 2},
  [1495] = {.lex_state = 65, .external_lex_state = 2},
  [1496] = {.lex_state = 65, .external_lex_state = 2},
  [1497] = {.lex_state = 65, .external_lex_state = 2},
  [1498] = {.lex_state = 65, .external_lex_state = 2},
  [1499] = {.lex_state = 65, .external_lex_state = 2},
  [1500] = {.lex_state = 65, .external_lex_state = 2},
  [1501] = {.lex_state = 66, .external_lex_state = 4},
  [1502] = {.lex_state = 65, .external_lex_state = 3},
  [1503] = {.lex_state = 65, .external_lex_state = 2},
  [1504] = {.lex_state = 65, .external_lex_state = 2},
  [1505] = {.lex_state = 65, .external_lex_state = 2},
  [1506] = {.lex_state = 65, .external_lex_state = 2},
  [1507] = {.lex_state = 65, .external_lex_state = 2},
  [1508] = {.lex_state = 66, .external_lex_state = 4},
  [1509] = {.lex_state = 11, .external_lex_state = 3},
  [1510] = {.lex_state = 65, .external_lex_state = 2},
  [1511] = {.lex_state = 65, .external_lex_state = 2},
  [1512] = {.lex_state = 65, .external_lex_state = 2},
  [1513] = {.lex_state = 65, .external_lex_state = 2},
  [1514] = {.lex_state = 65, .external_lex_state = 2},
  [1515] = {.lex_state = 65, .external_lex_state = 2},
  [1516] = {.lex_state = 65, .external_lex_state = 2},
  [1517] = {.lex_state = 65, .external_lex_state = 2},
  [1518] = {.lex_state = 65, .external_lex_state = 2},
  [1519] = {.lex_state = 65, .external_lex_state = 2},
  [1520] = {.lex_state = 65, .external_lex_state = 2},
  [1521] = {.lex_state = 65, .external_lex_state = 2},
  [1522] = {.lex_state = 65, .external_lex_state = 2},
  [1523] = {.lex_state = 65, .external_lex_state = 2},
  [1524] = {.lex_state = 65, .external_lex_state = 2},
  [1525] = {.lex_state = 65, .external_lex_state = 2},
  [1526] = {.lex_state = 66, .external_lex_state = 4},
  [1527] = {.lex_state = 65, .external_lex_state = 2},
  [1528] = {.lex_state = 65, .external_lex_state = 2},
  [1529] = {.lex_state = 66, .external_lex_state = 4},
  [1530] = {.lex_state = 65, .external_lex_state = 3},
  [1531] = {.lex_state = 66, .external_lex_state = 4},
  [1532] = {.lex_state = 65, .external_lex_state = 2},
  [1533] = {.lex_state = 65, .external_lex_state = 2},
  [1534] = {.lex_state = 65, .external_lex_state = 3},
  [1535] = {.lex_state = 65, .external_lex_state = 2},
  [1536] = {.lex_state = 65, .external_lex_state = 2},
  [1537] = {.lex_state = 65, .external_lex_state = 2},
  [1538] = {.lex_state = 65, .external_lex_state = 2},
  [1539] = {.lex_state = 65, .external_lex_state = 2},
  [1540] = {.lex_state = 65, .external_lex_state = 2},
  [1541] = {.lex_state = 65, .external_lex_state = 2},
  [1542] = {.lex_state = 65, .external_lex_state = 2},
  [1543] = {.lex_state = 65, .external_lex_state = 3},
  [1544] = {.lex_state = 65, .external_lex_state = 2},
  [1545] = {.lex_state = 65, .external_lex_state = 2},
  [1546] = {.lex_state = 66, .external_lex_state = 4},
  [1547] = {.lex_state = 65, .external_lex_state = 3},
  [1548] = {.lex_state = 65, .external_lex_state = 2},
  [1549] = {.lex_state = 65, .external_lex_state = 2},
  [1550] = {.lex_state = 65, .external_lex_state = 2},
  [1551] = {.lex_state = 65, .external_lex_state = 2},
  [1552] = {.lex_state = 65, .external_lex_state = 2},
  [1553] = {.lex_state = 65, .external_lex_state = 2},
  [1554] = {.lex_state = 65, .external_lex_state = 3},
  [1555] = {.lex_state = 65, .external_lex_state = 3},
  [1556] = {.lex_state = 65, .external_lex_state = 3},
  [1557] = {.lex_state = 8, .external_lex_state = 3},
  [1558] = {.lex_state = 65, .external_lex_state = 2},
  [1559] = {.lex_state = 65, .external_lex_state = 2},
  [1560] = {.lex_state = 8, .external_lex_state = 3},
  [1561] = {.lex_state = 8, .external_lex_state = 3},
  [1562] = {.lex_state = 66, .external_lex_state = 4},
  [1563] = {.lex_state = 66, .external_lex_state = 4},
  [1564] = {.lex_state = 65, .external_lex_state = 3},
  [1565] = {.lex_state = 8, .external_lex_state = 3},
  [1566] = {.lex_state = 8, .external_lex_state = 3},
  [1567] = {.lex_state = 8, .external_lex_state = 3},
  [1568] = {.lex_state = 8, .external_lex_state = 3},
  [1569] = {.lex_state = 8, .external_lex_state = 3},
  [1570] = {.lex_state = 8, .external_lex_state = 3},
  [1571] = {.lex_state = 8, .external_lex_state = 3},
  [1572] = {.lex_state = 8, .external_lex_state = 3},
  [1573] = {.lex_state = 8, .external_lex_state = 3},
  [1574] = {.lex_state = 8, .external_lex_state = 3},
  [1575] = {.lex_state = 65, .external_lex_state = 2},
  [1576] = {.lex_state = 8, .external_lex_state = 3},
  [1577] = {.lex_state = 8, .external_lex_state = 3},
  [1578] = {.lex_state = 66, .external_lex_state = 4},
  [1579] = {.lex_state = 8, .external_lex_state = 3},
  [1580] = {.lex_state = 8, .external_lex_state = 3},
  [1581] = {.lex_state = 8, .external_lex_state = 3},
  [1582] = {.lex_state = 8, .external_lex_state = 3},
  [1583] = {.lex_state = 8, .external_lex_state = 3},
  [1584] = {.lex_state = 8, .external_lex_state = 3},
  [1585] = {.lex_state = 8, .external_lex_state = 3},
  [1586] = {.lex_state = 8, .external_lex_state = 3},
  [1587] = {.lex_state = 8, .external_lex_state = 3},
  [1588] = {.lex_state = 65, .external_lex_state = 3},
  [1589] = {.lex_state = 8, .external_lex_state = 3},
  [1590] = {.lex_state = 8, .external_lex_state = 3},
  [1591] = {.lex_state = 8, .external_lex_state = 3},
  [1592] = {.lex_state = 8, .external_lex_state = 3},
  [1593] = {.lex_state = 8, .external_lex_state = 3},
  [1594] = {.lex_state = 8, .external_lex_state = 3},
  [1595] = {.lex_state = 8, .external_lex_state = 3},
  [1596] = {.lex_state = 8, .external_lex_state = 3},
  [1597] = {.lex_state = 8, .external_lex_state = 3},
  [1598] = {.lex_state = 65, .external_lex_state = 3},
  [1599] = {.lex_state = 8, .external_lex_state = 3},
  [1600] = {.lex_state = 8, .external_lex_state = 3},
  [1601] = {.lex_state = 8, .external_lex_state = 3},
  [1602] = {.lex_state = 8, .external_lex_state = 3},
  [1603] = {.lex_state = 8, .external_lex_state = 3},
  [1604] = {.lex_state = 66, .external_lex_state = 4},
  [1605] = {.lex_state = 66, .external_lex_state = 4},
  [1606] = {.lex_state = 8, .external_lex_state = 3},
  [1607] = {.lex_state = 8, .external_lex_state = 3},
  [1608] = {.lex_state = 66, .external_lex_state = 4},
  [1609] = {.lex_state = 8, .external_lex_state = 3},
  [1610] = {.lex_state = 66, .external_lex_state = 4},
  [1611] = {.lex_state = 8, .external_lex_state = 3},
  [1612] = {.lex_state = 8, .external_lex_state = 3},
  [1613] = {.lex_state = 66, .external_lex_state = 4},
  [1614] = {.lex_state = 8, .external_lex_state = 3},
  [1615] = {.lex_state = 8, .external_lex_state = 3},
  [1616] = {.lex_state = 8, .external_lex_state = 3},
  [1617] = {.lex_state = 65, .external_lex_state = 3},
  [1618] = {.lex_state = 8, .external_lex_state = 3},
  [1619] = {.lex_state = 65, .external_lex_state = 3},
  [1620] = {.lex_state = 66, .external_lex_state = 4},
  [1621] = {.lex_state = 66, .external_lex_state = 4},
  [1622] = {.lex_state = 8, .external_lex_state = 3},
  [1623] = {.lex_state = 66, .external_lex_state = 4},
  [1624] = {.lex_state = 66, .external_lex_state = 4},
  [1625] = {.lex_state = 8, .external_lex_state = 3},
  [1626] = {.lex_state = 8, .external_lex_state = 3},
  [1627] = {.lex_state = 66, .external_lex_state = 4},
  [1628] = {.lex_state = 8, .external_lex_state = 3},
  [1629] = {.lex_state = 8, .external_lex_state = 3},
  [1630] = {.lex_state = 8, .external_lex_state = 3},
  [1631] = {.lex_state = 8, .external_lex_state = 3},
  [1632] = {.lex_state = 8, .external_lex_state = 3},
  [1633] = {.lex_state = 8, .external_lex_state = 3},
  [1634] = {.lex_state = 8, .external_lex_state = 3},
  [1635] = {.lex_state = 8, .external_lex_state = 3},
  [1636] = {.lex_state = 65, .external_lex_state = 2},
  [1637] = {.lex_state = 8, .external_lex_state = 3},
  [1638] = {.lex_state = 65, .external_lex_state = 2},
  [1639] = {.lex_state = 8, .external_lex_state = 3},
  [1640] = {.lex_state = 8, .external_lex_state = 3},
  [1641] = {.lex_state = 8, .external_lex_state = 3},
  [1642] = {.lex_state = 8, .external_lex_state = 3},
  [1643] = {.lex_state = 66, .external_lex_state = 4},
  [1644] = {.lex_state = 8, .external_lex_state = 3},
  [1645] = {.lex_state = 8, .external_lex_state = 3},
  [1646] = {.lex_state = 8, .external_lex_state = 3},
  [1647] = {.lex_state = 66, .external_lex_state = 4},
  [1648] = {.lex_state = 65, .external_lex_state = 3},
  [1649] = {.lex_state = 8, .external_lex_state = 3},
  [1650] = {.lex_state = 8, .external_lex_state = 3},
  [1651] = {.lex_state = 66, .external_lex_state = 4},
  [1652] = {.lex_state = 8, .external_lex_state = 3},
  [1653] = {.lex_state = 8, .external_lex_state = 3},
  [1654] = {.lex_state = 8, .external_lex_state = 3},
  [1655] = {.lex_state = 8, .external_lex_state = 3},
  [1656] = {.lex_state = 8, .external_lex_state = 3},
  [1657] = {.lex_state = 8, .external_lex_state = 3},
  [1658] = {.lex_state = 66, .external_lex_state = 4},
  [1659] = {.lex_state = 8, .external_lex_state = 3},
  [1660] = {.lex_state = 66, .external_lex_state = 4},
  [1661] = {.lex_state = 8, .external_lex_state = 3},
  [1662] = {.lex_state = 65, .external_lex_state = 2},
  [1663] = {.lex_state = 8, .external_lex_state = 3},
  [1664] = {.lex_state = 8, .external_lex_state = 3},
  [1665] = {.lex_state = 8, .external_lex_state = 3},
  [1666] = {.lex_state = 65, .external_lex_state = 3},
  [1667] = {.lex_state = 8, .external_lex_state = 3},
  [1668] = {.lex_state = 8, .external_lex_state = 3},
  [1669] = {.lex_state = 66, .external_lex_state = 4},
  [1670] = {.lex_state = 8, .external_lex_state = 3},
  [1671] = {.lex_state = 8, .external_lex_state = 3},
  [1672] = {.lex_state = 8, .external_lex_state = 3},
  [1673] = {.lex_state = 65, .external_lex_state = 3},
  [1674] = {.lex_state = 66, .external_lex_state = 4},
  [1675] = {.lex_state = 8, .external_lex_state = 3},
  [1676] = {.lex_state = 8, .external_lex_state = 3},
  [1677] = {.lex_state = 8, .external_lex_state = 3},
  [1678] = {.lex_state = 66, .external_lex_state = 4},
  [1679] = {.lex_state = 8, .external_lex_state = 3},
  [1680] = {.lex_state = 8, .external_lex_state = 3},
  [1681] = {.lex_state = 66, .external_lex_state = 4},
  [1682] = {.lex_state = 8, .external_lex_state = 3},
  [1683] = {.lex_state = 66, .external_lex_state = 4},
  [1684] = {.lex_state = 8, .external_lex_state = 3},
  [1685] = {.lex_state = 8, .external_lex_state = 3},
  [1686] = {.lex_state = 8, .external_lex_state = 3},
  [1687] = {.lex_state = 66, .external_lex_state = 4},
  [1688] = {.lex_state = 8, .external_lex_state = 3},
  [1689] = {.lex_state = 8, .external_lex_state = 3},
  [1690] = {.lex_state = 8, .external_lex_state = 3},
  [1691] = {.lex_state = 8, .external_lex_state = 3},
  [1692] = {.lex_state = 8, .external_lex_state = 3},
  [1693] = {.lex_state = 66, .external_lex_state = 4},
  [1694] = {.lex_state = 8, .external_lex_state = 3},
  [1695] = {.lex_state = 8, .external_lex_state = 3},
  [1696] = {.lex_state = 66},
  [1697] = {.lex_state = 66},
  [1698] = {.lex_state = 65, .external_lex_state = 3},
  [1699] = {.lex_state = 66, .external_lex_state = 4},
  [1700] = {.lex_state = 65, .external_lex_state = 3},
  [1701] = {.lex_state = 66, .external_lex_state = 4},
  [1702] = {.lex_state = 65, .external_lex_state = 3},
  [1703] = {.lex_state = 66, .external_lex_state = 4},
  [1704] = {.lex_state = 66, .external_lex_state = 4},
  [1705] = {.lex_state = 66, .external_lex_state = 4},
  [1706] = {.lex_state = 66, .external_lex_state = 4},
  [1707] = {.lex_state = 66, .external_lex_state = 4},
  [1708] = {.lex_state = 65, .external_lex_state = 3},
  [1709] = {.lex_state = 66, .external_lex_state = 4},
  [1710] = {.lex_state = 66},
  [1711] = {.lex_state = 66, .external_lex_state = 4},
  [1712] = {.lex_state = 66, .external_lex_state = 4},
  [1713] = {.lex_state = 66},
  [1714] = {.lex_state = 65, .external_lex_state = 3},
  [1715] = {.lex_state = 65, .external_lex_state = 3},
  [1716] = {.lex_state = 66},
  [1717] = {.lex_state = 66, .external_lex_state = 4},
  [1718] = {.lex_state = 66, .external_lex_state = 4},
  [1719] = {.lex_state = 66},
  [1720] = {.lex_state = 66, .external_lex_state = 4},
  [1721] = {.lex_state = 66},
  [1722] = {.lex_state = 66},
  [1723] = {.lex_state = 66},
  [1724] = {.lex_state = 66, .external_lex_state = 4},
  [1725] = {.lex_state = 66},
  [1726] = {.lex_state = 66, .external_lex_state = 4},
  [1727] = {.lex_state = 66, .external_lex_state = 4},
  [1728] = {.lex_state = 66},
  [1729] = {.lex_state = 65, .external_lex_state = 3},
  [1730] = {.lex_state = 66, .external_lex_state = 4},
  [1731] = {.lex_state = 66, .external_lex_state = 4},
  [1732] = {.lex_state = 66},
  [1733] = {.lex_state = 66, .external_lex_state = 4},
  [1734] = {.lex_state = 66},
  [1735] = {.lex_state = 66},
  [1736] = {.lex_state = 66},
  [1737] = {.lex_state = 66},
  [1738] = {.lex_state = 66},
  [1739] = {.lex_state = 66},
  [1740] = {.lex_state = 66},
  [1741] = {.lex_state = 66},
  [1742] = {.lex_state = 66},
  [1743] = {.lex_state = 66},
  [1744] = {.lex_state = 66},
  [1745] = {.lex_state = 66},
  [1746] = {.lex_state = 66, .external_lex_state = 4},
  [1747] = {.lex_state = 66},
  [1748] = {.lex_state = 66},
  [1749] = {.lex_state = 66},
  [1750] = {.lex_state = 66},
  [1751] = {.lex_state = 66},
  [1752] = {.lex_state = 66},
  [1753] = {.lex_state = 66},
  [1754] = {.lex_state = 66},
  [1755] = {.lex_state = 66},
  [1756] = {.lex_state = 66},
  [1757] = {.lex_state = 66},
  [1758] = {.lex_state = 66},
  [1759] = {.lex_state = 66},
  [1760] = {.lex_state = 66},
  [1761] = {.lex_state = 66},
  [1762] = {.lex_state = 66},
  [1763] = {.lex_state = 66},
  [1764] = {.lex_state = 66},
  [1765] = {.lex_state = 66},
  [1766] = {.lex_state = 66},
  [1767] = {.lex_state = 66},
  [1768] = {.lex_state = 66},
  [1769] = {.lex_state = 66},
  [1770] = {.lex_state = 66},
  [1771] = {.lex_state = 66},
  [1772] = {.lex_state = 66},
  [1773] = {.lex_state = 66},
  [1774] = {.lex_state = 66},
  [1775] = {.lex_state = 66},
  [1776] = {.lex_state = 66},
  [1777] = {.lex_state = 66},
  [1778] = {.lex_state = 66},
  [1779] = {.lex_state = 66},
  [1780] = {.lex_state = 66},
  [1781] = {.lex_state = 66},
  [1782] = {.lex_state = 66},
  [1783] = {.lex_state = 66},
  [1784] = {.lex_state = 66},
  [1785] = {.lex_state = 66},
  [1786] = {.lex_state = 66},
  [1787] = {.lex_state = 66},
  [1788] = {.lex_state = 66},
  [1789] = {.lex_state = 66},
  [1790] = {.lex_state = 66},
  [1791] = {.lex_state = 66},
  [1792] = {.lex_state = 66},
  [1793] = {.lex_state = 66, .external_lex_state = 4},
  [1794] = {.lex_state = 66, .external_lex_state = 4},
  [1795] = {.lex_state = 66, .external_lex_state = 4},
  [1796] = {.lex_state = 66, .external_lex_state = 4},
  [1797] = {.lex_state = 66},
  [1798] = {.lex_state = 66},
  [1799] = {.lex_state = 66},
  [1800] = {.lex_state = 66},
  [1801] = {.lex_state = 66, .external_lex_state = 4},
  [1802] = {.lex_state = 66},
  [1803] = {.lex_state = 66, .external_lex_state = 4},
  [1804] = {.lex_state = 66},
  [1805] = {.lex_state = 66},
  [1806] = {.lex_state = 66},
  [1807] = {.lex_state = 66, .external_lex_state = 4},
  [1808] = {.lex_state = 66},
  [1809] = {.lex_state = 66, .external_lex_state = 4},
  [1810] = {.lex_state = 66, .external_lex_state = 4},
  [1811] = {.lex_state = 66, .external_lex_state = 4},
  [1812] = {.lex_state = 66},
  [1813] = {.lex_state = 66, .external_lex_state = 4},
  [1814] = {.lex_state = 66, .external_lex_state = 4},
  [1815] = {.lex_state = 66, .external_lex_state = 4},
  [1816] = {.lex_state = 66},
  [1817] = {.lex_state = 66, .external_lex_state = 4},
  [1818] = {.lex_state = 66, .external_lex_state = 4},
  [1819] = {.lex_state = 66, .external_lex_state = 4},
  [1820] = {.lex_state = 66, .external_lex_state = 4},
  [1821] = {.lex_state = 66},
  [1822] = {.lex_state = 66},
  [1823] = {.lex_state = 66},
  [1824] = {.lex_state = 66},
  [1825] = {.lex_state = 66},
  [1826] = {.lex_state = 66},
  [1827] = {.lex_state = 66},
  [1828] = {.lex_state = 66},
  [1829] = {.lex_state = 66},
  [1830] = {.lex_state = 66},
  [1831] = {.lex_state = 66},
  [1832] = {.lex_state = 66},
  [1833] = {.lex_state = 66},
  [1834] = {.lex_state = 66},
  [1835] = {.lex_state = 66},
  [1836] = {.lex_state = 66},
  [1837] = {.lex_state = 66},
  [1838] = {.lex_state = 66},
  [1839] = {.lex_state = 66},
  [1840] = {.lex_state = 66},
  [1841] = {.lex_state = 66},
  [1842] = {.lex_state = 66},
  [1843] = {.lex_state = 66},
  [1844] = {.lex_state = 66},
  [1845] = {.lex_state = 66},
  [1846] = {.lex_state = 66},
  [1847] = {.lex_state = 66},
  [1848] = {.lex_state = 66},
  [1849] = {.lex_state = 66},
  [1850] = {.lex_state = 66},
  [1851] = {.lex_state = 66},
  [1852] = {.lex_state = 66},
  [1853] = {.lex_state = 66},
  [1854] = {.lex_state = 66},
  [1855] = {.lex_state = 66},
  [1856] = {.lex_state = 66},
  [1857] = {.lex_state = 66},
  [1858] = {.lex_state = 66},
  [1859] = {.lex_state = 66},
  [1860] = {.lex_state = 66},
  [1861] = {.lex_state = 66},
  [1862] = {.lex_state = 66},
  [1863] = {.lex_state = 66},
  [1864] = {.lex_state = 66},
  [1865] = {.lex_state = 66},
  [1866] = {.lex_state = 66},
  [1867] = {.lex_state = 66},
  [1868] = {.lex_state = 66},
  [1869] = {.lex_state = 21},
  [1870] = {.lex_state = 21},
  [1871] = {.lex_state = 21},
  [1872] = {.lex_state = 21},
  [1873] = {.lex_state = 21},
  [1874] = {.lex_state = 66, .external_lex_state = 4},
  [1875] = {.lex_state = 66, .external_lex_state = 4},
  [1876] = {.lex_state = 21},
  [1877] = {.lex_state = 21},
  [1878] = {.lex_state = 66},
  [1879] = {.lex_state = 66, .external_lex_state = 4},
  [1880] = {.lex_state = 66, .external_lex_state = 4},
  [1881] = {.lex_state = 66, .external_lex_state = 4},
  [1882] = {.lex_state = 66, .external_lex_state = 4},
  [1883] = {.lex_state = 66, .external_lex_state = 4},
  [1884] = {.lex_state = 21},
  [1885] = {.lex_state = 66, .external_lex_state = 4},
  [1886] = {.lex_state = 66, .external_lex_state = 4},
  [1887] = {.lex_state = 21},
  [1888] = {.lex_state = 66, .external_lex_state = 4},
  [1889] = {.lex_state = 66, .external_lex_state = 4},
  [1890] = {.lex_state = 21},
  [1891] = {.lex_state = 66, .external_lex_state = 4},
  [1892] = {.lex_state = 66, .external_lex_state = 4},
  [1893] = {.lex_state = 66, .external_lex_state = 4},
  [1894] = {.lex_state = 66},
  [1895] = {.lex_state = 66, .external_lex_state = 4},
  [1896] = {.lex_state = 66, .external_lex_state = 4},
  [1897] = {.lex_state = 66, .external_lex_state = 4},
  [1898] = {.lex_state = 66},
  [1899] = {.lex_state = 66, .external_lex_state = 4},
  [1900] = {.lex_state = 66, .external_lex_state = 4},
  [1901] = {.lex_state = 66, .external_lex_state = 4},
  [1902] = {.lex_state = 66, .external_lex_state = 4},
  [1903] = {.lex_state = 21},
  [1904] = {.lex_state = 66, .external_lex_state = 4},
  [1905] = {.lex_state = 66, .external_lex_state = 4},
  [1906] = {.lex_state = 66, .external_lex_state = 4},
  [1907] = {.lex_state = 66, .external_lex_state = 4},
  [1908] = {.lex_state = 21},
  [1909] = {.lex_state = 66, .external_lex_state = 4},
  [1910] = {.lex_state = 66, .external_lex_state = 4},
  [1911] = {.lex_state = 66, .external_lex_state = 4},
  [1912] = {.lex_state = 21},
  [1913] = {.lex_state = 66, .external_lex_state = 4},
  [1914] = {.lex_state = 66, .external_lex_state = 4},
  [1915] = {.lex_state = 66, .external_lex_state = 4},
  [1916] = {.lex_state = 66, .external_lex_state = 4},
  [1917] = {.lex_state = 66},
  [1918] = {.lex_state = 66, .external_lex_state = 4},
  [1919] = {.lex_state = 21},
  [1920] = {.lex_state = 21},
  [1921] = {.lex_state = 66, .external_lex_state = 4},
  [1922] = {.lex_state = 66, .external_lex_state = 4},
  [1923] = {.lex_state = 66},
  [1924] = {.lex_state = 66, .external_lex_state = 4},
  [1925] = {.lex_state = 66, .external_lex_state = 4},
  [1926] = {.lex_state = 66, .external_lex_state = 4},
  [1927] = {.lex_state = 66},
  [1928] = {.lex_state = 66},
  [1929] = {.lex_state = 66, .external_lex_state = 4},
  [1930] = {.lex_state = 66},
  [1931] = {.lex_state = 66},
  [1932] = {.lex_state = 66, .external_lex_state = 4},
  [1933] = {.lex_state = 66, .external_lex_state = 4},
  [1934] = {.lex_state = 66, .external_lex_state = 4},
  [1935] = {.lex_state = 66, .external_lex_state = 4},
  [1936] = {.lex_state = 66, .external_lex_state = 4},
  [1937] = {.lex_state = 66, .external_lex_state = 4},
  [1938] = {.lex_state = 66, .external_lex_state = 4},
  [1939] = {.lex_state = 66, .external_lex_state = 4},
  [1940] = {.lex_state = 21},
  [1941] = {.lex_state = 66, .external_lex_state = 4},
  [1942] = {.lex_state = 66, .external_lex_state = 4},
  [1943] = {.lex_state = 66},
  [1944] = {.lex_state = 66, .external_lex_state = 4},
  [1945] = {.lex_state = 66},
  [1946] = {.lex_state = 66, .external_lex_state = 4},
  [1947] = {.lex_state = 66, .external_lex_state = 4},
  [1948] = {.lex_state = 66, .external_lex_state = 4},
  [1949] = {.lex_state = 66, .external_lex_state = 4},
  [1950] = {.lex_state = 66, .external_lex_state = 4},
  [1951] = {.lex_state = 66, .external_lex_state = 4},
  [1952] = {.lex_state = 66, .external_lex_state = 4},
  [1953] = {.lex_state = 21},
  [1954] = {.lex_state = 66, .external_lex_state = 4},
  [1955] = {.lex_state = 66},
  [1956] = {.lex_state = 66, .external_lex_state = 4},
  [1957] = {.lex_state = 66},
  [1958] = {.lex_state = 66, .external_lex_state = 4},
  [1959] = {.lex_state = 66, .external_lex_state = 4},
  [1960] = {.lex_state = 66, .external_lex_state = 4},
  [1961] = {.lex_state = 66},
  [1962] = {.lex_state = 66},
  [1963] = {.lex_state = 66},
  [1964] = {.lex_state = 66, .external_lex_state = 4},
  [1965] = {.lex_state = 21},
  [1966] = {.lex_state = 66, .external_lex_state = 4},
  [1967] = {.lex_state = 66, .external_lex_state = 4},
  [1968] = {.lex_state = 66},
  [1969] = {.lex_state = 66},
  [1970] = {.lex_state = 66, .external_lex_state = 4},
  [1971] = {.lex_state = 66, .external_lex_state = 4},
  [1972] = {.lex_state = 66, .external_lex_state = 4},
  [1973] = {.lex_state = 66},
  [1974] = {.lex_state = 66, .external_lex_state = 4},
  [1975] = {.lex_state = 66, .external_lex_state = 4},
  [1976] = {.lex_state = 66, .external_lex_state = 4},
  [1977] = {.lex_state = 66, .external_lex_state = 4},
  [1978] = {.lex_state = 66, .external_lex_state = 4},
  [1979] = {.lex_state = 66, .external_lex_state = 4},
  [1980] = {.lex_state = 66, .external_lex_state = 4},
  [1981] = {.lex_state = 66},
  [1982] = {.lex_state = 66},
  [1983] = {.lex_state = 66},
  [1984] = {.lex_state = 21},
  [1985] = {.lex_state = 21},
  [1986] = {.lex_state = 21},
  [1987] = {.lex_state = 66},
  [1988] = {.lex_state = 29},
  [1989] = {.lex_state = 66},
  [1990] = {.lex_state = 66},
  [1991] = {.lex_state = 21},
  [1992] = {.lex_state = 66},
  [1993] = {.lex_state = 66, .external_lex_state = 4},
  [1994] = {.lex_state = 21},
  [1995] = {.lex_state = 29},
  [1996] = {.lex_state = 21},
  [1997] = {.lex_state = 21},
  [1998] = {.lex_state = 66},
  [1999] = {.lex_state = 21},
  [2000] = {.lex_state = 21},
  [2001] = {.lex_state = 29},
  [2002] = {.lex_state = 66},
  [2003] = {.lex_state = 21},
  [2004] = {.lex_state = 66},
  [2005] = {.lex_state = 21},
  [2006] = {.lex_state = 66},
  [2007] = {.lex_state = 66},
  [2008] = {.lex_state = 29},
  [2009] = {.lex_state = 66},
  [2010] = {.lex_state = 29},
  [2011] = {.lex_state = 21},
  [2012] = {.lex_state = 66},
  [2013] = {.lex_state = 29},
  [2014] = {.lex_state = 29},
  [2015] = {.lex_state = 66},
  [2016] = {.lex_state = 66},
  [2017] = {.lex_state = 66},
  [2018] = {.lex_state = 66},
  [2019] = {.lex_state = 29},
  [2020] = {.lex_state = 66},
  [2021] = {.lex_state = 66, .external_lex_state = 4},
  [2022] = {.lex_state = 66, .external_lex_state = 4},
  [2023] = {.lex_state = 29},
  [2024] = {.lex_state = 29},
  [2025] = {.lex_state = 66},
  [2026] = {.lex_state = 21},
  [2027] = {.lex_state = 29},
  [2028] = {.lex_state = 66},
  [2029] = {.lex_state = 29},
  [2030] = {.lex_state = 29},
  [2031] = {.lex_state = 66},
  [2032] = {.lex_state = 29},
  [2033] = {.lex_state = 66},
  [2034] = {.lex_state = 66},
  [2035] = {.lex_state = 66},
  [2036] = {.lex_state = 66, .external_lex_state = 4},
  [2037] = {.lex_state = 29},
  [2038] = {.lex_state = 21},
  [2039] = {.lex_state = 29},
  [2040] = {.lex_state = 66},
  [2041] = {.lex_state = 29},
  [2042] = {.lex_state = 66, .external_lex_state = 4},
  [2043] = {.lex_state = 29},
  [2044] = {.lex_state = 66},
  [2045] = {.lex_state = 21},
  [2046] = {.lex_state = 66},
  [2047] = {.lex_state = 66, .external_lex_state = 4},
  [2048] = {.lex_state = 29},
  [2049] = {.lex_state = 66},
  [2050] = {.lex_state = 66},
  [2051] = {.lex_state = 66},
  [2052] = {.lex_state = 66},
  [2053] = {.lex_state = 66},
  [2054] = {.lex_state = 66, .external_lex_state = 4},
  [2055] = {.lex_state = 66, .external_lex_state = 4},
  [2056] = {.lex_state = 66, .external_lex_state = 4},
  [2057] = {.lex_state = 66},
  [2058] = {.lex_state = 66, .external_lex_state = 4},
  [2059] = {.lex_state = 66, .external_lex_state = 4},
  [2060] = {.lex_state = 66},
  [2061] = {.lex_state = 66},
  [2062] = {.lex_state = 66, .external_lex_state = 4},
  [2063] = {.lex_state = 66},
  [2064] = {.lex_state = 66},
  [2065] = {.lex_state = 66},
  [2066] = {.lex_state = 0, .external_lex_state = 4},
  [2067] = {.lex_state = 0, .external_lex_state = 4},
  [2068] = {.lex_state = 66},
  [2069] = {.lex_state = 0, .external_lex_state = 4},
  [2070] = {.lex_state = 66},
  [2071] = {.lex_state = 66},
  [2072] = {.lex_state = 0, .external_lex_state = 4},
  [2073] = {.lex_state = 14},
  [2074] = {.lex_state = 66, .external_lex_state = 4},
  [2075] = {.lex_state = 66},
  [2076] = {.lex_state = 66, .external_lex_state = 4},
  [2077] = {.lex_state = 66, .external_lex_state = 4},
  [2078] = {.lex_state = 66},
  [2079] = {.lex_state = 66},
  [2080] = {.lex_state = 66},
  [2081] = {.lex_state = 66},
  [2082] = {.lex_state = 66, .external_lex_state = 4},
  [2083] = {.lex_state = 66},
  [2084] = {.lex_state = 66},
  [2085] = {.lex_state = 66},
  [2086] = {.lex_state = 66},
  [2087] = {.lex_state = 66},
  [2088] = {.lex_state = 0, .external_lex_state = 4},
  [2089] = {.lex_state = 0, .external_lex_state = 4},
  [2090] = {.lex_state = 0, .external_lex_state = 4},
  [2091] = {.lex_state = 66},
  [2092] = {.lex_state = 66},
  [2093] = {.lex_state = 66},
  [2094] = {.lex_state = 66},
  [2095] = {.lex_state = 66},
  [2096] = {.lex_state = 66},
  [2097] = {.lex_state = 66},
  [2098] = {.lex_state = 0, .external_lex_state = 4},
  [2099] = {.lex_state = 66},
  [2100] = {.lex_state = 66},
  [2101] = {.lex_state = 14},
  [2102] = {.lex_state = 66},
  [2103] = {.lex_state = 66},
  [2104] = {.lex_state = 66},
  [2105] = {.lex_state = 66},
  [2106] = {.lex_state = 66},
  [2107] = {.lex_state = 66},
  [2108] = {.lex_state = 66},
  [2109] = {.lex_state = 66},
  [2110] = {.lex_state = 66, .external_lex_state = 4},
  [2111] = {.lex_state = 66},
  [2112] = {.lex_state = 66},
  [2113] = {.lex_state = 66},
  [2114] = {.lex_state = 66, .external_lex_state = 4},
  [2115] = {.lex_state = 66, .external_lex_state = 4},
  [2116] = {.lex_state = 66, .external_lex_state = 4},
  [2117] = {.lex_state = 66, .external_lex_state = 4},
  [2118] = {.lex_state = 21},
  [2119] = {.lex_state = 66},
  [2120] = {.lex_state = 66, .external_lex_state = 4},
  [2121] = {.lex_state = 66},
  [2122] = {.lex_state = 0, .external_lex_state = 4},
  [2123] = {.lex_state = 66, .external_lex_state = 4},
  [2124] = {.lex_state = 66, .external_lex_state = 4},
  [2125] = {.lex_state = 66, .external_lex_state = 4},
  [2126] = {.lex_state = 66},
  [2127] = {.lex_state = 66},
  [2128] = {.lex_state = 66, .external_lex_state = 4},
  [2129] = {.lex_state = 66},
  [2130] = {.lex_state = 66},
  [2131] = {.lex_state = 66},
  [2132] = {.lex_state = 66},
  [2133] = {.lex_state = 66},
  [2134] = {.lex_state = 66},
  [2135] = {.lex_state = 66},
  [2136] = {.lex_state = 66},
  [2137] = {.lex_state = 66},
  [2138] = {.lex_state = 17},
  [2139] = {.lex_state = 66},
  [2140] = {.lex_state = 66},
  [2141] = {.lex_state = 66},
  [2142] = {.lex_state = 66},
  [2143] = {.lex_state = 66},
  [2144] = {.lex_state = 66},
  [2145] = {.lex_state = 21},
  [2146] = {.lex_state = 0, .external_lex_state = 4},
  [2147] = {.lex_state = 66},
  [2148] = {.lex_state = 66},
  [2149] = {.lex_state = 19, .external_lex_state = 5},
  [2150] = {.lex_state = 19, .external_lex_state = 5},
  [2151] = {.lex_state = 66},
  [2152] = {.lex_state = 19, .external_lex_state = 5},
  [2153] = {.lex_state = 66},
  [2154] = {.lex_state = 0, .external_lex_state = 4},
  [2155] = {.lex_state = 0, .external_lex_state = 4},
  [2156] = {.lex_state = 66},
  [2157] = {.lex_state = 66},
  [2158] = {.lex_state = 66},
  [2159] = {.lex_state = 0, .external_lex_state = 4},
  [2160] = {.lex_state = 66},
  [2161] = {.lex_state = 66},
  [2162] = {.lex_state = 66},
  [2163] = {.lex_state = 0, .external_lex_state = 4},
  [2164] = {.lex_state = 66},
  [2165] = {.lex_state = 0, .external_lex_state = 4},
  [2166] = {.lex_state = 0, .external_lex_state = 4},
  [2167] = {.lex_state = 19, .external_lex_state = 5},
  [2168] = {.lex_state = 0, .external_lex_state = 4},
  [2169] = {.lex_state = 66},
  [2170] = {.lex_state = 66},
  [2171] = {.lex_state = 66},
  [2172] = {.lex_state = 0, .external_lex_state = 4},
  [2173] = {.lex_state = 66},
  [2174] = {.lex_state = 0, .external_lex_state = 4},
  [2175] = {.lex_state = 66},
  [2176] = {.lex_state = 17},
  [2177] = {.lex_state = 66},
  [2178] = {.lex_state = 17},
  [2179] = {.lex_state = 66},
  [2180] = {.lex_state = 66},
  [2181] = {.lex_state = 66},
  [2182] = {.lex_state = 66},
  [2183] = {.lex_state = 19, .external_lex_state = 5},
  [2184] = {.lex_state = 66},
  [2185] = {.lex_state = 66},
  [2186] = {.lex_state = 66},
  [2187] = {.lex_state = 14},
  [2188] = {.lex_state = 19, .external_lex_state = 5},
  [2189] = {.lex_state = 0, .external_lex_state = 4},
  [2190] = {.lex_state = 66},
  [2191] = {.lex_state = 66},
  [2192] = {.lex_state = 0, .external_lex_state = 4},
  [2193] = {.lex_state = 66},
  [2194] = {.lex_state = 0, .external_lex_state = 4},
  [2195] = {.lex_state = 66},
  [2196] = {.lex_state = 66},
  [2197] = {.lex_state = 0},
  [2198] = {.lex_state = 0, .external_lex_state = 4},
  [2199] = {.lex_state = 66, .external_lex_state = 4},
  [2200] = {.lex_state = 19, .external_lex_state = 5},
  [2201] = {.lex_state = 66},
  [2202] = {.lex_state = 66},
  [2203] = {.lex_state = 0, .external_lex_state = 4},
  [2204] = {.lex_state = 66},
  [2205] = {.lex_state = 66},
  [2206] = {.lex_state = 0, .external_lex_state = 4},
  [2207] = {.lex_state = 0, .external_lex_state = 4},
  [2208] = {.lex_state = 0, .external_lex_state = 4},
  [2209] = {.lex_state = 0, .external_lex_state = 4},
  [2210] = {.lex_state = 21},
  [2211] = {.lex_state = 66},
  [2212] = {.lex_state = 66},
  [2213] = {.lex_state = 0, .external_lex_state = 4},
  [2214] = {.lex_state = 0, .external_lex_state = 4},
  [2215] = {.lex_state = 66},
  [2216] = {.lex_state = 17},
  [2217] = {.lex_state = 66},
  [2218] = {.lex_state = 0, .external_lex_state = 4},
  [2219] = {.lex_state = 66},
  [2220] = {.lex_state = 0, .external_lex_state = 4},
  [2221] = {.lex_state = 66},
  [2222] = {.lex_state = 21},
  [2223] = {.lex_state = 66},
  [2224] = {.lex_state = 66, .external_lex_state = 4},
  [2225] = {.lex_state = 0, .external_lex_state = 4},
  [2226] = {.lex_state = 17},
  [2227] = {.lex_state = 66},
  [2228] = {.lex_state = 17},
  [2229] = {.lex_state = 66},
  [2230] = {.lex_state = 66},
  [2231] = {.lex_state = 66},
  [2232] = {.lex_state = 66},
  [2233] = {.lex_state = 66},
  [2234] = {.lex_state = 66},
  [2235] = {.lex_state = 0, .external_lex_state = 4},
  [2236] = {.lex_state = 17},
  [2237] = {.lex_state = 0, .external_lex_state = 4},
  [2238] = {.lex_state = 66},
  [2239] = {.lex_state = 0, .external_lex_state = 4},
  [2240] = {.lex_state = 0, .external_lex_state = 4},
  [2241] = {.lex_state = 0, .external_lex_state = 4},
  [2242] = {.lex_state = 21},
  [2243] = {.lex_state = 66},
  [2244] = {.lex_state = 66},
  [2245] = {.lex_state = 66},
  [2246] = {.lex_state = 0, .external_lex_state = 4},
  [2247] = {.lex_state = 66},
  [2248] = {.lex_state = 0, .external_lex_state = 4},
  [2249] = {.lex_state = 0, .external_lex_state = 4},
  [2250] = {.lex_state = 66},
  [2251] = {.lex_state = 0},
  [2252] = {.lex_state = 0, .external_lex_state = 4},
  [2253] = {.lex_state = 66},
  [2254] = {.lex_state = 0, .external_lex_state = 4},
  [2255] = {.lex_state = 21},
  [2256] = {.lex_state = 0, .external_lex_state = 4},
  [2257] = {.lex_state = 0, .external_lex_state = 4},
  [2258] = {.lex_state = 17},
  [2259] = {.lex_state = 66},
  [2260] = {.lex_state = 0, .external_lex_state = 4},
  [2261] = {.lex_state = 0, .external_lex_state = 4},
  [2262] = {.lex_state = 0, .external_lex_state = 4},
  [2263] = {.lex_state = 0, .external_lex_state = 4},
  [2264] = {.lex_state = 0, .external_lex_state = 4},
  [2265] = {.lex_state = 66},
  [2266] = {.lex_state = 66},
  [2267] = {.lex_state = 0, .external_lex_state = 4},
  [2268] = {.lex_state = 0, .external_lex_state = 4},
  [2269] = {.lex_state = 0, .external_lex_state = 4},
  [2270] = {.lex_state = 66},
  [2271] = {.lex_state = 0, .external_lex_state = 4},
  [2272] = {.lex_state = 0, .external_lex_state = 4},
  [2273] = {.lex_state = 7},
  [2274] = {.lex_state = 0, .external_lex_state = 4},
  [2275] = {.lex_state = 66},
  [2276] = {.lex_state = 0, .external_lex_state = 4},
  [2277] = {.lex_state = 66},
  [2278] = {.lex_state = 0, .external_lex_state = 4},
  [2279] = {.lex_state = 0, .external_lex_state = 4},
  [2280] = {.lex_state = 66},
  [2281] = {.lex_state = 66},
  [2282] = {.lex_state = 21},
  [2283] = {.lex_state = 0, .external_lex_state = 4},
  [2284] = {.lex_state = 0, .external_lex_state = 4},
  [2285] = {.lex_state = 66},
  [2286] = {.lex_state = 66},
  [2287] = {.lex_state = 0, .external_lex_state = 4},
  [2288] = {.lex_state = 0, .external_lex_state = 4},
  [2289] = {.lex_state = 66},
  [2290] = {.lex_state = 0, .external_lex_state = 4},
  [2291] = {.lex_state = 66},
  [2292] = {.lex_state = 66},
  [2293] = {.lex_state = 0, .external_lex_state = 4},
  [2294] = {.lex_state = 66},
  [2295] = {.lex_state = 0, .external_lex_state = 4},
  [2296] = {.lex_state = 66},
  [2297] = {.lex_state = 66},
  [2298] = {.lex_state = 0, .external_lex_state = 4},
  [2299] = {.lex_state = 66},
  [2300] = {.lex_state = 21},
  [2301] = {.lex_state = 0, .external_lex_state = 4},
  [2302] = {.lex_state = 66, .external_lex_state = 4},
  [2303] = {.lex_state = 66},
  [2304] = {.lex_state = 21},
  [2305] = {.lex_state = 0, .external_lex_state = 4},
  [2306] = {.lex_state = 0, .external_lex_state = 4},
  [2307] = {.lex_state = 0, .external_lex_state = 4},
  [2308] = {.lex_state = 0, .external_lex_state = 4},
  [2309] = {.lex_state = 66},
  [2310] = {.lex_state = 66, .external_lex_state = 4},
  [2311] = {.lex_state = 0, .external_lex_state = 4},
  [2312] = {.lex_state = 0, .external_lex_state = 4},
  [2313] = {.lex_state = 0, .external_lex_state = 4},
  [2314] = {.lex_state = 66},
  [2315] = {.lex_state = 0, .external_lex_state = 4},
  [2316] = {.lex_state = 66},
  [2317] = {.lex_state = 0, .external_lex_state = 4},
  [2318] = {.lex_state = 0, .external_lex_state = 4},
  [2319] = {.lex_state = 17},
  [2320] = {.lex_state = 66, .external_lex_state = 4},
  [2321] = {.lex_state = 0, .external_lex_state = 4},
  [2322] = {.lex_state = 66},
  [2323] = {.lex_state = 66},
  [2324] = {.lex_state = 66, .external_lex_state = 4},
  [2325] = {.lex_state = 0, .external_lex_state = 4},
  [2326] = {.lex_state = 0, .external_lex_state = 4},
  [2327] = {.lex_state = 66},
  [2328] = {.lex_state = 66, .external_lex_state = 4},
  [2329] = {.lex_state = 66},
  [2330] = {.lex_state = 7},
  [2331] = {.lex_state = 66},
  [2332] = {.lex_state = 0, .external_lex_state = 4},
  [2333] = {.lex_state = 66},
  [2334] = {.lex_state = 17},
  [2335] = {.lex_state = 0, .external_lex_state = 4},
  [2336] = {.lex_state = 66},
  [2337] = {.lex_state = 17},
  [2338] = {.lex_state = 0},
  [2339] = {.lex_state = 66},
  [2340] = {.lex_state = 66},
  [2341] = {.lex_state = 0, .external_lex_state = 4},
  [2342] = {.lex_state = 17},
  [2343] = {.lex_state = 66},
  [2344] = {.lex_state = 21},
  [2345] = {.lex_state = 21},
  [2346] = {.lex_state = 66},
  [2347] = {.lex_state = 0, .external_lex_state = 4},
  [2348] = {.lex_state = 66},
  [2349] = {.lex_state = 0, .external_lex_state = 4},
  [2350] = {.lex_state = 66},
  [2351] = {.lex_state = 0, .external_lex_state = 4},
  [2352] = {.lex_state = 66},
  [2353] = {.lex_state = 66},
  [2354] = {.lex_state = 0, .external_lex_state = 4},
  [2355] = {.lex_state = 66},
  [2356] = {.lex_state = 66},
  [2357] = {.lex_state = 0, .external_lex_state = 4},
  [2358] = {.lex_state = 0, .external_lex_state = 4},
  [2359] = {.lex_state = 66},
  [2360] = {.lex_state = 0, .external_lex_state = 4},
  [2361] = {.lex_state = 0, .external_lex_state = 4},
  [2362] = {.lex_state = 66},
  [2363] = {.lex_state = 66, .external_lex_state = 4},
  [2364] = {.lex_state = 0, .external_lex_state = 4},
  [2365] = {.lex_state = 66},
  [2366] = {.lex_state = 0, .external_lex_state = 4},
  [2367] = {.lex_state = 0, .external_lex_state = 4},
  [2368] = {.lex_state = 0, .external_lex_state = 4},
  [2369] = {.lex_state = 0, .external_lex_state = 4},
  [2370] = {.lex_state = 21},
  [2371] = {.lex_state = 66},
  [2372] = {.lex_state = 66},
  [2373] = {.lex_state = 0, .external_lex_state = 4},
  [2374] = {.lex_state = 0, .external_lex_state = 4},
  [2375] = {.lex_state = 66},
  [2376] = {.lex_state = 66},
  [2377] = {.lex_state = 21},
  [2378] = {.lex_state = 66},
  [2379] = {.lex_state = 0, .external_lex_state = 4},
  [2380] = {.lex_state = 0, .external_lex_state = 4},
  [2381] = {.lex_state = 66},
  [2382] = {.lex_state = 0, .external_lex_state = 4},
  [2383] = {.lex_state = 66},
  [2384] = {.lex_state = 0, .external_lex_state = 4},
  [2385] = {.lex_state = 66},
  [2386] = {.lex_state = 0, .external_lex_state = 4},
  [2387] = {.lex_state = 0, .external_lex_state = 4},
  [2388] = {.lex_state = 0, .external_lex_state = 4},
  [2389] = {.lex_state = 0, .external_lex_state = 4},
  [2390] = {.lex_state = 0, .external_lex_state = 4},
  [2391] = {.lex_state = 66},
  [2392] = {.lex_state = 17},
  [2393] = {.lex_state = 17},
  [2394] = {.lex_state = 66},
  [2395] = {.lex_state = 66},
  [2396] = {.lex_state = 17},
  [2397] = {.lex_state = 0, .external_lex_state = 4},
  [2398] = {.lex_state = 66},
  [2399] = {.lex_state = 66},
  [2400] = {.lex_state = 0, .external_lex_state = 4},
  [2401] = {.lex_state = 66},
  [2402] = {.lex_state = 66},
  [2403] = {.lex_state = 66},
  [2404] = {.lex_state = 66},
  [2405] = {.lex_state = 0, .external_lex_state = 4},
  [2406] = {.lex_state = 66},
  [2407] = {.lex_state = 66},
  [2408] = {.lex_state = 0, .external_lex_state = 4},
  [2409] = {.lex_state = 17},
  [2410] = {.lex_state = 14},
  [2411] = {.lex_state = 66},
  [2412] = {.lex_state = 66},
  [2413] = {.lex_state = 21},
  [2414] = {.lex_state = 0, .external_lex_state = 4},
  [2415] = {.lex_state = 66},
  [2416] = {.lex_state = 66, .external_lex_state = 4},
  [2417] = {.lex_state = 66, .external_lex_state = 4},
  [2418] = {.lex_state = 66, .external_lex_state = 4},
  [2419] = {.lex_state = 66},
  [2420] = {.lex_state = 66},
  [2421] = {.lex_state = 0, .external_lex_state = 4},
  [2422] = {.lex_state = 66},
  [2423] = {.lex_state = 66},
  [2424] = {.lex_state = 0, .external_lex_state = 4},
  [2425] = {.lex_state = 21},
  [2426] = {.lex_state = 66},
  [2427] = {.lex_state = 0, .external_lex_state = 4},
  [2428] = {.lex_state = 66},
  [2429] = {.lex_state = 17},
  [2430] = {.lex_state = 66},
  [2431] = {.lex_state = 0, .external_lex_state = 4},
  [2432] = {.lex_state = 21},
  [2433] = {.lex_state = 66},
  [2434] = {.lex_state = 21},
  [2435] = {.lex_state = 0, .external_lex_state = 4},
  [2436] = {.lex_state = 66, .external_lex_state = 4},
  [2437] = {.lex_state = 66},
  [2438] = {.lex_state = 0, .external_lex_state = 4},
  [2439] = {.lex_state = 66},
  [2440] = {.lex_state = 66},
  [2441] = {.lex_state = 0, .external_lex_state = 4},
  [2442] = {.lex_state = 66},
  [2443] = {.lex_state = 66},
  [2444] = {.lex_state = 66, .external_lex_state = 4},
  [2445] = {.lex_state = 14},
  [2446] = {.lex_state = 0, .external_lex_state = 4},
  [2447] = {.lex_state = 66},
  [2448] = {.lex_state = 0, .external_lex_state = 4},
  [2449] = {.lex_state = 66},
  [2450] = {.lex_state = 0, .external_lex_state = 4},
  [2451] = {.lex_state = 66},
  [2452] = {.lex_state = 0, .external_lex_state = 4},
  [2453] = {.lex_state = 0, .external_lex_state = 4},
  [2454] = {.lex_state = 66},
  [2455] = {.lex_state = 66},
  [2456] = {.lex_state = 0, .external_lex_state = 4},
  [2457] = {.lex_state = 66},
  [2458] = {.lex_state = 66},
  [2459] = {.lex_state = 0, .external_lex_state = 4},
  [2460] = {.lex_state = 66},
  [2461] = {.lex_state = 0, .external_lex_state = 4},
  [2462] = {.lex_state = 66, .external_lex_state = 4},
  [2463] = {.lex_state = 66},
  [2464] = {.lex_state = 1},
  [2465] = {.lex_state = 3},
  [2466] = {.lex_state = 17},
  [2467] = {.lex_state = 66},
  [2468] = {.lex_state = 0, .external_lex_state = 4},
  [2469] = {.lex_state = 66},
  [2470] = {.lex_state = 66, .external_lex_state = 4},
  [2471] = {.lex_state = 17},
  [2472] = {.lex_state = 66},
  [2473] = {.lex_state = 66},
  [2474] = {.lex_state = 66},
  [2475] = {.lex_state = 1},
  [2476] = {.lex_state = 66},
  [2477] = {.lex_state = 3},
  [2478] = {.lex_state = 17},
  [2479] = {.lex_state = 66},
  [2480] = {.lex_state = 3},
  [2481] = {.lex_state = 3},
  [2482] = {.lex_state = 1},
  [2483] = {.lex_state = 1},
  [2484] = {.lex_state = 66},
  [2485] = {.lex_state = 0},
  [2486] = {.lex_state = 0},
  [2487] = {.lex_state = 17},
  [2488] = {.lex_state = 66},
  [2489] = {.lex_state = 3},
  [2490] = {.lex_state = 66},
  [2491] = {.lex_state = 66},
  [2492] = {.lex_state = 3},
  [2493] = {.lex_state = 1},
  [2494] = {.lex_state = 0},
  [2495] = {.lex_state = 0},
  [2496] = {.lex_state = 66},
  [2497] = {.lex_state = 17},
  [2498] = {.lex_state = 66, .external_lex_state = 4},
  [2499] = {.lex_state = 17},
  [2500] = {.lex_state = 3},
  [2501] = {.lex_state = 66},
  [2502] = {.lex_state = 0},
  [2503] = {.lex_state = 1},
  [2504] = {.lex_state = 66},
  [2505] = {.lex_state = 66, .external_lex_state = 4},
  [2506] = {.lex_state = 66},
  [2507] = {.lex_state = 66},
  [2508] = {.lex_state = 66, .external_lex_state = 4},
  [2509] = {.lex_state = 1},
  [2510] = {.lex_state = 66, .external_lex_state = 4},
  [2511] = {.lex_state = 66, .external_lex_state = 4},
  [2512] = {.lex_state = 66},
  [2513] = {.lex_state = 66},
  [2514] = {.lex_state = 66},
  [2515] = {.lex_state = 66, .external_lex_state = 4},
  [2516] = {.lex_state = 66},
  [2517] = {.lex_state = 66, .external_lex_state = 4},
  [2518] = {.lex_state = 0},
  [2519] = {.lex_state = 0, .external_lex_state = 4},
  [2520] = {.lex_state = 0, .external_lex_state = 4},
  [2521] = {.lex_state = 66, .external_lex_state = 4},
  [2522] = {.lex_state = 3},
  [2523] = {.lex_state = 66, .external_lex_state = 4},
  [2524] = {.lex_state = 19, .external_lex_state = 5},
  [2525] = {.lex_state = 1},
  [2526] = {.lex_state = 66},
  [2527] = {.lex_state = 0, .external_lex_state = 4},
  [2528] = {.lex_state = 3},
  [2529] = {.lex_state = 1},
  [2530] = {.lex_state = 0},
  [2531] = {.lex_state = 3},
  [2532] = {.lex_state = 1},
  [2533] = {.lex_state = 3},
  [2534] = {.lex_state = 1},
  [2535] = {.lex_state = 1},
  [2536] = {.lex_state = 66},
  [2537] = {.lex_state = 0},
  [2538] = {.lex_state = 0},
  [2539] = {.lex_state = 3},
  [2540] = {.lex_state = 1},
  [2541] = {.lex_state = 66, .external_lex_state = 4},
  [2542] = {.lex_state = 66, .external_lex_state = 4},
  [2543] = {.lex_state = 3},
  [2544] = {.lex_state = 1},
  [2545] = {.lex_state = 3},
  [2546] = {.lex_state = 66},
  [2547] = {.lex_state = 0},
  [2548] = {.lex_state = 0},
  [2549] = {.lex_state = 0, .external_lex_state = 4},
  [2550] = {.lex_state = 66, .external_lex_state = 4},
  [2551] = {.lex_state = 0},
  [2552] = {.lex_state = 0, .external_lex_state = 4},
  [2553] = {.lex_state = 0, .external_lex_state = 4},
  [2554] = {.lex_state = 66},
  [2555] = {.lex_state = 66},
  [2556] = {.lex_state = 66},
  [2557] = {.lex_state = 0},
  [2558] = {.lex_state = 0, .external_lex_state = 4},
  [2559] = {.lex_state = 66},
  [2560] = {.lex_state = 66},
  [2561] = {.lex_state = 1},
  [2562] = {.lex_state = 3},
  [2563] = {.lex_state = 0},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 0},
  [2566] = {.lex_state = 66},
  [2567] = {.lex_state = 0},
  [2568] = {.lex_state = 66, .external_lex_state = 4},
  [2569] = {.lex_state = 0},
  [2570] = {.lex_state = 0},
  [2571] = {.lex_state = 66},
  [2572] = {.lex_state = 0},
  [2573] = {.lex_state = 0},
  [2574] = {.lex_state = 66},
  [2575] = {.lex_state = 29},
  [2576] = {.lex_state = 66},
  [2577] = {.lex_state = 66},
  [2578] = {.lex_state = 66},
  [2579] = {.lex_state = 66},
  [2580] = {.lex_state = 66},
  [2581] = {.lex_state = 66},
  [2582] = {.lex_state = 0},
  [2583] = {.lex_state = 66},
  [2584] = {.lex_state = 66},
  [2585] = {.lex_state = 0},
  [2586] = {.lex_state = 66},
  [2587] = {.lex_state = 0},
  [2588] = {.lex_state = 0},
  [2589] = {.lex_state = 0},
  [2590] = {.lex_state = 0},
  [2591] = {.lex_state = 0, .external_lex_state = 4},
  [2592] = {.lex_state = 66},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0},
  [2595] = {.lex_state = 0},
  [2596] = {.lex_state = 0},
  [2597] = {.lex_state = 66},
  [2598] = {.lex_state = 66, .external_lex_state = 4},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 0},
  [2601] = {.lex_state = 0, .external_lex_state = 4},
  [2602] = {.lex_state = 0},
  [2603] = {.lex_state = 0},
  [2604] = {.lex_state = 0},
  [2605] = {.lex_state = 0},
  [2606] = {.lex_state = 66},
  [2607] = {.lex_state = 0},
  [2608] = {.lex_state = 29},
  [2609] = {.lex_state = 0},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 0},
  [2612] = {.lex_state = 0},
  [2613] = {.lex_state = 66},
  [2614] = {.lex_state = 0},
  [2615] = {.lex_state = 7},
  [2616] = {.lex_state = 66},
  [2617] = {.lex_state = 0},
  [2618] = {.lex_state = 0, .external_lex_state = 4},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 66},
  [2621] = {.lex_state = 0},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 0},
  [2626] = {.lex_state = 0, .external_lex_state = 4},
  [2627] = {.lex_state = 0},
  [2628] = {.lex_state = 0, .external_lex_state = 4},
  [2629] = {.lex_state = 0, .external_lex_state = 4},
  [2630] = {.lex_state = 66},
  [2631] = {.lex_state = 0},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 66, .external_lex_state = 4},
  [2634] = {.lex_state = 0, .external_lex_state = 4},
  [2635] = {.lex_state = 0},
  [2636] = {.lex_state = 0, .external_lex_state = 4},
  [2637] = {.lex_state = 29},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 66},
  [2641] = {.lex_state = 0, .external_lex_state = 4},
  [2642] = {.lex_state = 66},
  [2643] = {.lex_state = 0, .external_lex_state = 4},
  [2644] = {.lex_state = 0},
  [2645] = {.lex_state = 66},
  [2646] = {.lex_state = 0},
  [2647] = {.lex_state = 66},
  [2648] = {.lex_state = 66, .external_lex_state = 4},
  [2649] = {.lex_state = 0},
  [2650] = {.lex_state = 66},
  [2651] = {.lex_state = 66},
  [2652] = {.lex_state = 66},
  [2653] = {.lex_state = 66, .external_lex_state = 4},
  [2654] = {.lex_state = 0},
  [2655] = {.lex_state = 0},
  [2656] = {.lex_state = 66},
  [2657] = {.lex_state = 66},
  [2658] = {.lex_state = 0},
  [2659] = {.lex_state = 29},
  [2660] = {.lex_state = 66},
  [2661] = {.lex_state = 29},
  [2662] = {.lex_state = 0, .external_lex_state = 4},
  [2663] = {.lex_state = 0},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 66},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 66},
  [2669] = {.lex_state = 66},
  [2670] = {.lex_state = 29},
  [2671] = {.lex_state = 29},
  [2672] = {.lex_state = 0},
  [2673] = {.lex_state = 0},
  [2674] = {.lex_state = 0},
  [2675] = {.lex_state = 0},
  [2676] = {.lex_state = 0},
  [2677] = {.lex_state = 0},
  [2678] = {.lex_state = 0},
  [2679] = {.lex_state = 7},
  [2680] = {.lex_state = 0},
  [2681] = {.lex_state = 0},
  [2682] = {.lex_state = 66},
  [2683] = {.lex_state = 0},
  [2684] = {.lex_state = 66},
  [2685] = {.lex_state = 0},
  [2686] = {.lex_state = 0},
  [2687] = {.lex_state = 0, .external_lex_state = 4},
  [2688] = {.lex_state = 0},
  [2689] = {.lex_state = 66},
  [2690] = {.lex_state = 0},
  [2691] = {.lex_state = 0, .external_lex_state = 4},
  [2692] = {.lex_state = 0},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 66},
  [2695] = {.lex_state = 66},
  [2696] = {.lex_state = 66},
  [2697] = {.lex_state = 0},
  [2698] = {.lex_state = 66},
  [2699] = {.lex_state = 66},
  [2700] = {.lex_state = 0},
  [2701] = {.lex_state = 66},
  [2702] = {.lex_state = 0},
  [2703] = {.lex_state = 0},
  [2704] = {.lex_state = 66},
  [2705] = {.lex_state = 0, .external_lex_state = 4},
  [2706] = {.lex_state = 66},
  [2707] = {.lex_state = 66},
  [2708] = {.lex_state = 0},
  [2709] = {.lex_state = 0, .external_lex_state = 4},
  [2710] = {.lex_state = 29},
  [2711] = {.lex_state = 0, .external_lex_state = 4},
  [2712] = {.lex_state = 0},
  [2713] = {.lex_state = 0},
  [2714] = {.lex_state = 66},
  [2715] = {.lex_state = 66},
  [2716] = {.lex_state = 0, .external_lex_state = 4},
  [2717] = {.lex_state = 0, .external_lex_state = 4},
  [2718] = {.lex_state = 0, .external_lex_state = 4},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 0, .external_lex_state = 4},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 0, .external_lex_state = 4},
  [2723] = {.lex_state = 0, .external_lex_state = 4},
  [2724] = {.lex_state = 0, .external_lex_state = 4},
  [2725] = {.lex_state = 0, .external_lex_state = 4},
  [2726] = {.lex_state = 0, .external_lex_state = 4},
  [2727] = {.lex_state = 66},
  [2728] = {.lex_state = 0, .external_lex_state = 4},
  [2729] = {.lex_state = 0, .external_lex_state = 4},
  [2730] = {.lex_state = 29},
  [2731] = {.lex_state = 66},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 66},
  [2736] = {.lex_state = 0},
  [2737] = {.lex_state = 0},
  [2738] = {.lex_state = 0},
  [2739] = {.lex_state = 0},
  [2740] = {.lex_state = 66},
  [2741] = {.lex_state = 29},
  [2742] = {.lex_state = 0},
  [2743] = {.lex_state = 66},
  [2744] = {.lex_state = 0, .external_lex_state = 4},
  [2745] = {.lex_state = 66},
  [2746] = {.lex_state = 66},
  [2747] = {.lex_state = 66},
  [2748] = {.lex_state = 66, .external_lex_state = 4},
  [2749] = {.lex_state = 66},
  [2750] = {.lex_state = 66},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 0, .external_lex_state = 4},
  [2754] = {.lex_state = 0},
  [2755] = {.lex_state = 0, .external_lex_state = 4},
  [2756] = {.lex_state = 66, .external_lex_state = 4},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 29},
  [2759] = {.lex_state = 0},
  [2760] = {.lex_state = 0},
  [2761] = {.lex_state = 0},
  [2762] = {.lex_state = 0},
  [2763] = {.lex_state = 0, .external_lex_state = 4},
  [2764] = {.lex_state = 66},
  [2765] = {.lex_state = 7},
  [2766] = {.lex_state = 0, .external_lex_state = 4},
  [2767] = {.lex_state = 66},
  [2768] = {.lex_state = 66},
  [2769] = {.lex_state = 66},
  [2770] = {.lex_state = 0, .external_lex_state = 4},
  [2771] = {.lex_state = 0},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 0},
  [2776] = {.lex_state = 0, .external_lex_state = 4},
  [2777] = {.lex_state = 0},
  [2778] = {.lex_state = 66},
  [2779] = {.lex_state = 0},
  [2780] = {.lex_state = 0},
  [2781] = {.lex_state = 66},
  [2782] = {.lex_state = 0, .external_lex_state = 4},
  [2783] = {.lex_state = 66},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 66},
  [2786] = {.lex_state = 0},
  [2787] = {.lex_state = 0},
  [2788] = {.lex_state = 0},
  [2789] = {.lex_state = 66},
  [2790] = {.lex_state = 66},
  [2791] = {.lex_state = 66},
  [2792] = {.lex_state = 0},
  [2793] = {.lex_state = 66},
  [2794] = {.lex_state = 0},
  [2795] = {.lex_state = 0},
  [2796] = {.lex_state = 66},
  [2797] = {.lex_state = 0},
  [2798] = {.lex_state = 66},
  [2799] = {.lex_state = 66},
  [2800] = {.lex_state = 0},
  [2801] = {.lex_state = 66},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 66},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 0},
  [2806] = {.lex_state = 0, .external_lex_state = 4},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 66},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 0, .external_lex_state = 4},
  [2811] = {.lex_state = 66},
  [2812] = {.lex_state = 66},
  [2813] = {.lex_state = 0},
  [2814] = {.lex_state = 0},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 66},
  [2817] = {.lex_state = 66},
  [2818] = {.lex_state = 66},
  [2819] = {.lex_state = 66},
  [2820] = {.lex_state = 66},
  [2821] = {.lex_state = 0},
  [2822] = {.lex_state = 66},
  [2823] = {.lex_state = 0},
  [2824] = {.lex_state = 0, .external_lex_state = 4},
  [2825] = {.lex_state = 66},
  [2826] = {.lex_state = 66},
  [2827] = {.lex_state = 66},
  [2828] = {.lex_state = 0},
  [2829] = {.lex_state = 66},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 66},
  [2832] = {.lex_state = 0},
  [2833] = {.lex_state = 0},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 66},
  [2836] = {.lex_state = 66},
  [2837] = {.lex_state = 66},
  [2838] = {.lex_state = 0, .external_lex_state = 4},
  [2839] = {.lex_state = 66},
  [2840] = {.lex_state = 66},
  [2841] = {.lex_state = 66},
  [2842] = {.lex_state = 66},
  [2843] = {.lex_state = 0},
  [2844] = {.lex_state = 66},
  [2845] = {.lex_state = 66},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 66},
  [2848] = {.lex_state = 66},
  [2849] = {.lex_state = 66},
  [2850] = {.lex_state = 66},
  [2851] = {.lex_state = 66},
  [2852] = {.lex_state = 66},
  [2853] = {.lex_state = 66},
  [2854] = {.lex_state = 66},
  [2855] = {.lex_state = 17},
  [2856] = {.lex_state = 0},
  [2857] = {.lex_state = 66},
  [2858] = {.lex_state = 66},
  [2859] = {.lex_state = 66},
  [2860] = {.lex_state = 66},
  [2861] = {.lex_state = 0, .external_lex_state = 4},
  [2862] = {.lex_state = 66},
  [2863] = {.lex_state = 66},
  [2864] = {.lex_state = 66},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 66},
  [2867] = {.lex_state = 66},
  [2868] = {.lex_state = 0},
  [2869] = {.lex_state = 66},
  [2870] = {.lex_state = 66},
  [2871] = {.lex_state = 0},
  [2872] = {.lex_state = 66},
  [2873] = {.lex_state = 0},
  [2874] = {.lex_state = 66},
  [2875] = {.lex_state = 66},
  [2876] = {.lex_state = 66},
  [2877] = {.lex_state = 66},
  [2878] = {.lex_state = 0},
  [2879] = {.lex_state = 0},
  [2880] = {.lex_state = 66},
  [2881] = {.lex_state = 66},
  [2882] = {.lex_state = 66},
  [2883] = {.lex_state = 0},
  [2884] = {.lex_state = 66},
  [2885] = {.lex_state = 66},
  [2886] = {.lex_state = 0},
  [2887] = {.lex_state = 66},
  [2888] = {.lex_state = 66},
  [2889] = {.lex_state = 66},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 66},
  [2892] = {.lex_state = 66},
  [2893] = {.lex_state = 0},
  [2894] = {.lex_state = 66},
  [2895] = {.lex_state = 0},
  [2896] = {.lex_state = 0},
  [2897] = {.lex_state = 66},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 66},
  [2900] = {.lex_state = 0, .external_lex_state = 4},
  [2901] = {.lex_state = 0},
  [2902] = {.lex_state = 0, .external_lex_state = 4},
  [2903] = {.lex_state = 66},
  [2904] = {.lex_state = 66},
  [2905] = {.lex_state = 66},
  [2906] = {.lex_state = 66},
  [2907] = {.lex_state = 66},
  [2908] = {.lex_state = 66},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 66},
  [2911] = {.lex_state = 0},
  [2912] = {.lex_state = 66},
  [2913] = {.lex_state = 66},
  [2914] = {.lex_state = 66},
  [2915] = {.lex_state = 0},
  [2916] = {.lex_state = 66},
  [2917] = {.lex_state = 0},
  [2918] = {.lex_state = 0},
  [2919] = {.lex_state = 66},
  [2920] = {.lex_state = 66},
  [2921] = {.lex_state = 66},
  [2922] = {.lex_state = 0, .external_lex_state = 4},
  [2923] = {.lex_state = 66},
  [2924] = {.lex_state = 0},
  [2925] = {.lex_state = 66},
  [2926] = {.lex_state = 66},
  [2927] = {.lex_state = 66},
  [2928] = {.lex_state = 66},
  [2929] = {.lex_state = 66},
  [2930] = {.lex_state = 66},
  [2931] = {.lex_state = 66},
  [2932] = {.lex_state = 66},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 66},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 66},
  [2937] = {.lex_state = 0, .external_lex_state = 4},
  [2938] = {.lex_state = 66},
  [2939] = {.lex_state = 66},
  [2940] = {.lex_state = 66},
  [2941] = {.lex_state = 66},
  [2942] = {.lex_state = 66},
  [2943] = {.lex_state = 66},
  [2944] = {.lex_state = 0, .external_lex_state = 4},
  [2945] = {.lex_state = 66},
  [2946] = {.lex_state = 0, .external_lex_state = 4},
  [2947] = {.lex_state = 66},
  [2948] = {.lex_state = 66},
  [2949] = {.lex_state = 66},
  [2950] = {.lex_state = 66},
  [2951] = {.lex_state = 66},
  [2952] = {.lex_state = 66},
  [2953] = {.lex_state = 66},
  [2954] = {.lex_state = 66},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 66},
  [2957] = {.lex_state = 0},
  [2958] = {.lex_state = 0, .external_lex_state = 4},
  [2959] = {.lex_state = 66},
  [2960] = {.lex_state = 66},
  [2961] = {.lex_state = 0, .external_lex_state = 4},
  [2962] = {.lex_state = 0, .external_lex_state = 4},
  [2963] = {.lex_state = 0, .external_lex_state = 4},
  [2964] = {.lex_state = 0, .external_lex_state = 4},
  [2965] = {.lex_state = 66},
  [2966] = {.lex_state = 0},
  [2967] = {.lex_state = 66},
  [2968] = {.lex_state = 66},
  [2969] = {.lex_state = 66},
  [2970] = {.lex_state = 66},
  [2971] = {.lex_state = 0},
  [2972] = {.lex_state = 66},
  [2973] = {.lex_state = 66},
  [2974] = {.lex_state = 66},
  [2975] = {.lex_state = 66},
  [2976] = {.lex_state = 66},
  [2977] = {.lex_state = 66},
  [2978] = {.lex_state = 66},
  [2979] = {.lex_state = 0},
  [2980] = {.lex_state = 0},
  [2981] = {.lex_state = 66},
  [2982] = {.lex_state = 66},
  [2983] = {.lex_state = 66},
  [2984] = {.lex_state = 66},
  [2985] = {.lex_state = 0},
  [2986] = {.lex_state = 66},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 66},
  [2989] = {.lex_state = 66},
  [2990] = {.lex_state = 0},
  [2991] = {.lex_state = 66},
  [2992] = {.lex_state = 66},
  [2993] = {.lex_state = 0},
  [2994] = {.lex_state = 66},
  [2995] = {.lex_state = 66},
  [2996] = {.lex_state = 0},
  [2997] = {.lex_state = 0},
  [2998] = {.lex_state = 0},
  [2999] = {.lex_state = 0},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 66},
  [3002] = {.lex_state = 0},
  [3003] = {.lex_state = 15},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 5},
  [3007] = {.lex_state = 66},
  [3008] = {.lex_state = 15},
  [3009] = {.lex_state = 0},
  [3010] = {.lex_state = 66},
  [3011] = {.lex_state = 66},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 66},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 66},
  [3016] = {.lex_state = 66},
  [3017] = {.lex_state = 0},
  [3018] = {.lex_state = 66},
  [3019] = {.lex_state = 66},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 66},
  [3022] = {.lex_state = 0},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 0},
  [3026] = {.lex_state = 0},
  [3027] = {.lex_state = 66},
  [3028] = {.lex_state = 0},
  [3029] = {.lex_state = 0},
  [3030] = {.lex_state = 66},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 66},
  [3033] = {.lex_state = 66},
  [3034] = {.lex_state = 66},
  [3035] = {.lex_state = 0},
  [3036] = {.lex_state = 0},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 66},
  [3039] = {.lex_state = 0},
  [3040] = {.lex_state = 66},
  [3041] = {.lex_state = 66},
  [3042] = {.lex_state = 0},
  [3043] = {.lex_state = 0},
  [3044] = {.lex_state = 0},
  [3045] = {.lex_state = 0},
  [3046] = {.lex_state = 66},
  [3047] = {.lex_state = 66},
  [3048] = {.lex_state = 66},
  [3049] = {.lex_state = 0},
  [3050] = {.lex_state = 66},
  [3051] = {.lex_state = 0},
  [3052] = {.lex_state = 0},
  [3053] = {.lex_state = 66},
  [3054] = {.lex_state = 5},
  [3055] = {.lex_state = 66},
  [3056] = {.lex_state = 66},
  [3057] = {.lex_state = 66},
  [3058] = {.lex_state = 0},
  [3059] = {.lex_state = 0},
  [3060] = {.lex_state = 66},
  [3061] = {.lex_state = 0},
  [3062] = {.lex_state = 0},
  [3063] = {.lex_state = 66},
  [3064] = {.lex_state = 0},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 66},
  [3067] = {.lex_state = 66},
  [3068] = {.lex_state = 66},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 66},
  [3071] = {.lex_state = 0},
  [3072] = {.lex_state = 0},
  [3073] = {.lex_state = 0},
  [3074] = {.lex_state = 0},
  [3075] = {.lex_state = 0},
  [3076] = {.lex_state = 66},
  [3077] = {.lex_state = 66},
  [3078] = {.lex_state = 66},
  [3079] = {.lex_state = 66},
  [3080] = {.lex_state = 66},
  [3081] = {.lex_state = 0},
  [3082] = {.lex_state = 66},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 0},
  [3085] = {.lex_state = 66},
  [3086] = {.lex_state = 0},
  [3087] = {.lex_state = 66},
  [3088] = {.lex_state = 0},
  [3089] = {.lex_state = 66},
  [3090] = {.lex_state = 0},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 66},
  [3093] = {.lex_state = 66},
  [3094] = {.lex_state = 66},
  [3095] = {.lex_state = 66},
  [3096] = {.lex_state = 0},
  [3097] = {.lex_state = 0},
  [3098] = {.lex_state = 66},
  [3099] = {.lex_state = 0},
  [3100] = {.lex_state = 0},
  [3101] = {.lex_state = 66},
  [3102] = {.lex_state = 66},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 0},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 66},
  [3107] = {.lex_state = 66},
  [3108] = {.lex_state = 66},
  [3109] = {.lex_state = 66},
  [3110] = {.lex_state = 5},
  [3111] = {.lex_state = 66},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 0},
  [3114] = {.lex_state = 0},
  [3115] = {.lex_state = 66},
  [3116] = {.lex_state = 66},
  [3117] = {.lex_state = 0},
  [3118] = {.lex_state = 0},
  [3119] = {.lex_state = 0},
  [3120] = {.lex_state = 0},
  [3121] = {.lex_state = 66},
  [3122] = {.lex_state = 66},
  [3123] = {.lex_state = 66},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 66},
  [3126] = {.lex_state = 0},
  [3127] = {.lex_state = 0},
  [3128] = {.lex_state = 0},
  [3129] = {.lex_state = 66},
  [3130] = {.lex_state = 66},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 0},
  [3133] = {.lex_state = 66},
  [3134] = {.lex_state = 66},
  [3135] = {.lex_state = 66},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 0},
  [3138] = {.lex_state = 66},
  [3139] = {.lex_state = 66},
  [3140] = {.lex_state = 66},
  [3141] = {.lex_state = 66},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 66},
  [3144] = {.lex_state = 0},
  [3145] = {.lex_state = 15},
  [3146] = {.lex_state = 0},
  [3147] = {.lex_state = 0},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 0},
  [3150] = {.lex_state = 0},
  [3151] = {.lex_state = 0},
  [3152] = {.lex_state = 66},
  [3153] = {.lex_state = 0},
  [3154] = {.lex_state = 0},
  [3155] = {.lex_state = 0},
  [3156] = {.lex_state = 0},
  [3157] = {.lex_state = 0},
  [3158] = {.lex_state = 66},
  [3159] = {.lex_state = 15},
  [3160] = {.lex_state = 66},
  [3161] = {.lex_state = 66},
  [3162] = {.lex_state = 66},
  [3163] = {.lex_state = 0},
  [3164] = {.lex_state = 0},
  [3165] = {.lex_state = 0},
  [3166] = {.lex_state = 0},
  [3167] = {.lex_state = 0},
  [3168] = {.lex_state = 66},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 0},
  [3172] = {.lex_state = 66},
  [3173] = {.lex_state = 66},
  [3174] = {.lex_state = 66},
  [3175] = {.lex_state = 0},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 0},
  [3178] = {.lex_state = 66},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 66},
  [3181] = {.lex_state = 66},
  [3182] = {.lex_state = 66},
  [3183] = {.lex_state = 66},
  [3184] = {.lex_state = 5},
  [3185] = {.lex_state = 66},
  [3186] = {.lex_state = 66},
  [3187] = {.lex_state = 0},
  [3188] = {.lex_state = 0},
  [3189] = {.lex_state = 66},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 0},
  [3192] = {.lex_state = 66},
  [3193] = {.lex_state = 66},
  [3194] = {.lex_state = 66},
  [3195] = {.lex_state = 66},
  [3196] = {.lex_state = 0},
  [3197] = {.lex_state = 66},
  [3198] = {.lex_state = 66},
  [3199] = {.lex_state = 0},
  [3200] = {.lex_state = 66},
  [3201] = {.lex_state = 66},
  [3202] = {.lex_state = 66},
  [3203] = {.lex_state = 66},
  [3204] = {.lex_state = 66},
  [3205] = {.lex_state = 0},
  [3206] = {.lex_state = 0},
  [3207] = {.lex_state = 66},
  [3208] = {.lex_state = 66},
  [3209] = {.lex_state = 66},
  [3210] = {.lex_state = 66},
  [3211] = {.lex_state = 66},
  [3212] = {.lex_state = 66},
  [3213] = {.lex_state = 66},
  [3214] = {.lex_state = 66},
  [3215] = {.lex_state = 66},
  [3216] = {.lex_state = 66},
  [3217] = {.lex_state = 0},
  [3218] = {.lex_state = 66},
  [3219] = {.lex_state = 66},
  [3220] = {.lex_state = 0},
  [3221] = {.lex_state = 0},
  [3222] = {.lex_state = 66},
  [3223] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3171),
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(17),
    [sym_lexical_declaration] = STATE(17),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(17),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(17),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(17),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(17),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(17),
    [sym_abstract_class_declaration] = STATE(17),
    [sym_module] = STATE(17),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(17),
    [sym_interface_declaration] = STATE(17),
    [sym_enum_declaration] = STATE(17),
    [sym_type_alias_declaration] = STATE(17),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [2] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1514),
    [sym_assignment_pattern] = STATE(2678),
    [sym_array] = STATE(1515),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2678),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1549),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_method_definition] = STATE(2678),
    [sym_pair] = STATE(2678),
    [sym__property_name] = STATE(2106),
    [sym_computed_property_name] = STATE(2106),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_accessibility_modifier] = STATE(1837),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [aux_sym_object_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [3] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1514),
    [sym_assignment_pattern] = STATE(2678),
    [sym_array] = STATE(1515),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2678),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1549),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_method_definition] = STATE(2678),
    [sym_pair] = STATE(2678),
    [sym__property_name] = STATE(2106),
    [sym_computed_property_name] = STATE(2106),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(14),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(14),
    [sym_abstract_class_declaration] = STATE(14),
    [sym_module] = STATE(14),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_type_alias_declaration] = STATE(14),
    [sym_accessibility_modifier] = STATE(1837),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [aux_sym_object_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [4] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1514),
    [sym_assignment_pattern] = STATE(2678),
    [sym_array] = STATE(1515),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2678),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1549),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_method_definition] = STATE(2678),
    [sym_pair] = STATE(2678),
    [sym__property_name] = STATE(2106),
    [sym_computed_property_name] = STATE(2106),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(14),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(14),
    [sym_abstract_class_declaration] = STATE(14),
    [sym_module] = STATE(14),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_type_alias_declaration] = STATE(14),
    [sym_accessibility_modifier] = STATE(1837),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [aux_sym_object_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [5] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1514),
    [sym_assignment_pattern] = STATE(2665),
    [sym_array] = STATE(1515),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2665),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1549),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_method_definition] = STATE(2665),
    [sym_pair] = STATE(2665),
    [sym__property_name] = STATE(2106),
    [sym_computed_property_name] = STATE(2106),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(20),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_accessibility_modifier] = STATE(1837),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(151),
    [anon_sym_export] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_type] = ACTIONS(159),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(161),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(165),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(167),
    [anon_sym_declare] = ACTIONS(169),
    [anon_sym_public] = ACTIONS(171),
    [anon_sym_private] = ACTIONS(171),
    [anon_sym_protected] = ACTIONS(171),
    [anon_sym_module] = ACTIONS(173),
    [anon_sym_any] = ACTIONS(175),
    [anon_sym_number] = ACTIONS(175),
    [anon_sym_boolean] = ACTIONS(175),
    [anon_sym_string] = ACTIONS(175),
    [anon_sym_symbol] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(177),
  },
  [6] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1514),
    [sym_assignment_pattern] = STATE(2619),
    [sym_array] = STATE(1515),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2619),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1549),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_method_definition] = STATE(2619),
    [sym_pair] = STATE(2619),
    [sym__property_name] = STATE(2106),
    [sym_computed_property_name] = STATE(2106),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(25),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_accessibility_modifier] = STATE(1837),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [aux_sym_object_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_export] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_type] = ACTIONS(187),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(189),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(191),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(195),
    [anon_sym_set] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(197),
    [anon_sym_public] = ACTIONS(199),
    [anon_sym_private] = ACTIONS(199),
    [anon_sym_protected] = ACTIONS(199),
    [anon_sym_module] = ACTIONS(201),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(205),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_export] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_namespace] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(226),
    [anon_sym_import] = ACTIONS(229),
    [anon_sym_var] = ACTIONS(232),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(244),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_await] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(256),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_break] = ACTIONS(268),
    [anon_sym_continue] = ACTIONS(271),
    [anon_sym_debugger] = ACTIONS(274),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_BANG] = ACTIONS(313),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_void] = ACTIONS(316),
    [anon_sym_delete] = ACTIONS(226),
    [anon_sym_PLUS_PLUS] = ACTIONS(319),
    [anon_sym_DASH_DASH] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_SQUOTE] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [sym_number] = ACTIONS(331),
    [sym_this] = ACTIONS(334),
    [sym_super] = ACTIONS(337),
    [sym_true] = ACTIONS(334),
    [sym_false] = ACTIONS(334),
    [sym_null] = ACTIONS(334),
    [sym_undefined] = ACTIONS(334),
    [anon_sym_AT] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(346),
    [anon_sym_get] = ACTIONS(343),
    [anon_sym_set] = ACTIONS(343),
    [anon_sym_declare] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(343),
    [anon_sym_private] = ACTIONS(343),
    [anon_sym_protected] = ACTIONS(343),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_any] = ACTIONS(343),
    [anon_sym_number] = ACTIONS(343),
    [anon_sym_boolean] = ACTIONS(343),
    [anon_sym_string] = ACTIONS(343),
    [anon_sym_symbol] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(355),
    [anon_sym_enum] = ACTIONS(358),
    [sym_readonly] = ACTIONS(343),
  },
  [8] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(9),
    [sym_lexical_declaration] = STATE(9),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(9),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(9),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(9),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(9),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(9),
    [sym_abstract_class_declaration] = STATE(9),
    [sym_module] = STATE(9),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(9),
    [sym_interface_declaration] = STATE(9),
    [sym_enum_declaration] = STATE(9),
    [sym_type_alias_declaration] = STATE(9),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [10] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(11),
    [sym_lexical_declaration] = STATE(11),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(11),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(11),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(11),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(11),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(11),
    [sym_abstract_class_declaration] = STATE(11),
    [sym_module] = STATE(11),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(11),
    [sym_interface_declaration] = STATE(11),
    [sym_enum_declaration] = STATE(11),
    [sym_type_alias_declaration] = STATE(11),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [11] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [12] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(27),
    [sym_lexical_declaration] = STATE(27),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(27),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(27),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(27),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(27),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(27),
    [sym_abstract_class_declaration] = STATE(27),
    [sym_module] = STATE(27),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(27),
    [sym_interface_declaration] = STATE(27),
    [sym_enum_declaration] = STATE(27),
    [sym_type_alias_declaration] = STATE(27),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [13] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(14),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(14),
    [sym_abstract_class_declaration] = STATE(14),
    [sym_module] = STATE(14),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_type_alias_declaration] = STATE(14),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [14] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [15] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [ts_builtin_sym_end] = ACTIONS(383),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [16] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [17] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [18] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(20),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [19] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(23),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(23),
    [sym_abstract_class_declaration] = STATE(23),
    [sym_module] = STATE(23),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(23),
    [sym_interface_declaration] = STATE(23),
    [sym_enum_declaration] = STATE(23),
    [sym_type_alias_declaration] = STATE(23),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [21] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(22),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(22),
    [sym_abstract_class_declaration] = STATE(22),
    [sym_module] = STATE(22),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(22),
    [sym_interface_declaration] = STATE(22),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(22),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [22] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [23] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [24] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(25),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [26] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [27] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [28] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(15),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [29] = {
    [sym_export_statement] = STATE(595),
    [sym__declaration] = STATE(595),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(595),
    [sym_expression_statement] = STATE(595),
    [sym_variable_declaration] = STATE(595),
    [sym_lexical_declaration] = STATE(595),
    [sym_statement_block] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_switch_statement] = STATE(595),
    [sym_for_statement] = STATE(595),
    [sym_for_in_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_do_statement] = STATE(595),
    [sym_try_statement] = STATE(595),
    [sym_with_statement] = STATE(595),
    [sym_break_statement] = STATE(595),
    [sym_continue_statement] = STATE(595),
    [sym_debugger_statement] = STATE(595),
    [sym_return_statement] = STATE(595),
    [sym_throw_statement] = STATE(595),
    [sym_empty_statement] = STATE(595),
    [sym_labeled_statement] = STATE(595),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(595),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(595),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(595),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(595),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(595),
    [sym_abstract_class_declaration] = STATE(595),
    [sym_module] = STATE(595),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(595),
    [sym_interface_declaration] = STATE(595),
    [sym_enum_declaration] = STATE(595),
    [sym_type_alias_declaration] = STATE(595),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [30] = {
    [sym_export_statement] = STATE(598),
    [sym__declaration] = STATE(598),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(598),
    [sym_expression_statement] = STATE(598),
    [sym_variable_declaration] = STATE(598),
    [sym_lexical_declaration] = STATE(598),
    [sym_statement_block] = STATE(598),
    [sym_if_statement] = STATE(598),
    [sym_switch_statement] = STATE(598),
    [sym_for_statement] = STATE(598),
    [sym_for_in_statement] = STATE(598),
    [sym_while_statement] = STATE(598),
    [sym_do_statement] = STATE(598),
    [sym_try_statement] = STATE(598),
    [sym_with_statement] = STATE(598),
    [sym_break_statement] = STATE(598),
    [sym_continue_statement] = STATE(598),
    [sym_debugger_statement] = STATE(598),
    [sym_return_statement] = STATE(598),
    [sym_throw_statement] = STATE(598),
    [sym_empty_statement] = STATE(598),
    [sym_labeled_statement] = STATE(598),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(598),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(598),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(598),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(598),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(598),
    [sym_abstract_class_declaration] = STATE(598),
    [sym_module] = STATE(598),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(598),
    [sym_interface_declaration] = STATE(598),
    [sym_enum_declaration] = STATE(598),
    [sym_type_alias_declaration] = STATE(598),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [31] = {
    [sym_export_statement] = STATE(608),
    [sym__declaration] = STATE(608),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(608),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(608),
    [sym_lexical_declaration] = STATE(608),
    [sym_statement_block] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_switch_statement] = STATE(608),
    [sym_for_statement] = STATE(608),
    [sym_for_in_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_do_statement] = STATE(608),
    [sym_try_statement] = STATE(608),
    [sym_with_statement] = STATE(608),
    [sym_break_statement] = STATE(608),
    [sym_continue_statement] = STATE(608),
    [sym_debugger_statement] = STATE(608),
    [sym_return_statement] = STATE(608),
    [sym_throw_statement] = STATE(608),
    [sym_empty_statement] = STATE(608),
    [sym_labeled_statement] = STATE(608),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(608),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(608),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(608),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(608),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(608),
    [sym_abstract_class_declaration] = STATE(608),
    [sym_module] = STATE(608),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(608),
    [sym_interface_declaration] = STATE(608),
    [sym_enum_declaration] = STATE(608),
    [sym_type_alias_declaration] = STATE(608),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [32] = {
    [sym_export_statement] = STATE(594),
    [sym__declaration] = STATE(594),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(594),
    [sym_expression_statement] = STATE(594),
    [sym_variable_declaration] = STATE(594),
    [sym_lexical_declaration] = STATE(594),
    [sym_statement_block] = STATE(594),
    [sym_if_statement] = STATE(594),
    [sym_switch_statement] = STATE(594),
    [sym_for_statement] = STATE(594),
    [sym_for_in_statement] = STATE(594),
    [sym_while_statement] = STATE(594),
    [sym_do_statement] = STATE(594),
    [sym_try_statement] = STATE(594),
    [sym_with_statement] = STATE(594),
    [sym_break_statement] = STATE(594),
    [sym_continue_statement] = STATE(594),
    [sym_debugger_statement] = STATE(594),
    [sym_return_statement] = STATE(594),
    [sym_throw_statement] = STATE(594),
    [sym_empty_statement] = STATE(594),
    [sym_labeled_statement] = STATE(594),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(594),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(594),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(594),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(594),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(594),
    [sym_abstract_class_declaration] = STATE(594),
    [sym_module] = STATE(594),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(594),
    [sym_interface_declaration] = STATE(594),
    [sym_enum_declaration] = STATE(594),
    [sym_type_alias_declaration] = STATE(594),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [33] = {
    [sym_export_statement] = STATE(598),
    [sym__declaration] = STATE(598),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(598),
    [sym_expression_statement] = STATE(598),
    [sym_variable_declaration] = STATE(598),
    [sym_lexical_declaration] = STATE(598),
    [sym_statement_block] = STATE(598),
    [sym_if_statement] = STATE(598),
    [sym_switch_statement] = STATE(598),
    [sym_for_statement] = STATE(598),
    [sym_for_in_statement] = STATE(598),
    [sym_while_statement] = STATE(598),
    [sym_do_statement] = STATE(598),
    [sym_try_statement] = STATE(598),
    [sym_with_statement] = STATE(598),
    [sym_break_statement] = STATE(598),
    [sym_continue_statement] = STATE(598),
    [sym_debugger_statement] = STATE(598),
    [sym_return_statement] = STATE(598),
    [sym_throw_statement] = STATE(598),
    [sym_empty_statement] = STATE(598),
    [sym_labeled_statement] = STATE(598),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(598),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(598),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(598),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(598),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(598),
    [sym_abstract_class_declaration] = STATE(598),
    [sym_module] = STATE(598),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(598),
    [sym_interface_declaration] = STATE(598),
    [sym_enum_declaration] = STATE(598),
    [sym_type_alias_declaration] = STATE(598),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [34] = {
    [sym_export_statement] = STATE(567),
    [sym__declaration] = STATE(567),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(567),
    [sym_expression_statement] = STATE(567),
    [sym_variable_declaration] = STATE(567),
    [sym_lexical_declaration] = STATE(567),
    [sym_statement_block] = STATE(567),
    [sym_if_statement] = STATE(567),
    [sym_switch_statement] = STATE(567),
    [sym_for_statement] = STATE(567),
    [sym_for_in_statement] = STATE(567),
    [sym_while_statement] = STATE(567),
    [sym_do_statement] = STATE(567),
    [sym_try_statement] = STATE(567),
    [sym_with_statement] = STATE(567),
    [sym_break_statement] = STATE(567),
    [sym_continue_statement] = STATE(567),
    [sym_debugger_statement] = STATE(567),
    [sym_return_statement] = STATE(567),
    [sym_throw_statement] = STATE(567),
    [sym_empty_statement] = STATE(567),
    [sym_labeled_statement] = STATE(567),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(567),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(567),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(567),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(567),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(567),
    [sym_abstract_class_declaration] = STATE(567),
    [sym_module] = STATE(567),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(567),
    [sym_interface_declaration] = STATE(567),
    [sym_enum_declaration] = STATE(567),
    [sym_type_alias_declaration] = STATE(567),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [35] = {
    [sym_export_statement] = STATE(608),
    [sym__declaration] = STATE(608),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(608),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(608),
    [sym_lexical_declaration] = STATE(608),
    [sym_statement_block] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_switch_statement] = STATE(608),
    [sym_for_statement] = STATE(608),
    [sym_for_in_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_do_statement] = STATE(608),
    [sym_try_statement] = STATE(608),
    [sym_with_statement] = STATE(608),
    [sym_break_statement] = STATE(608),
    [sym_continue_statement] = STATE(608),
    [sym_debugger_statement] = STATE(608),
    [sym_return_statement] = STATE(608),
    [sym_throw_statement] = STATE(608),
    [sym_empty_statement] = STATE(608),
    [sym_labeled_statement] = STATE(608),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(608),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(608),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(608),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(608),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(608),
    [sym_abstract_class_declaration] = STATE(608),
    [sym_module] = STATE(608),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(608),
    [sym_interface_declaration] = STATE(608),
    [sym_enum_declaration] = STATE(608),
    [sym_type_alias_declaration] = STATE(608),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [36] = {
    [sym_export_statement] = STATE(595),
    [sym__declaration] = STATE(595),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(595),
    [sym_expression_statement] = STATE(595),
    [sym_variable_declaration] = STATE(595),
    [sym_lexical_declaration] = STATE(595),
    [sym_statement_block] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_switch_statement] = STATE(595),
    [sym_for_statement] = STATE(595),
    [sym_for_in_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_do_statement] = STATE(595),
    [sym_try_statement] = STATE(595),
    [sym_with_statement] = STATE(595),
    [sym_break_statement] = STATE(595),
    [sym_continue_statement] = STATE(595),
    [sym_debugger_statement] = STATE(595),
    [sym_return_statement] = STATE(595),
    [sym_throw_statement] = STATE(595),
    [sym_empty_statement] = STATE(595),
    [sym_labeled_statement] = STATE(595),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(595),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(595),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(595),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(595),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(595),
    [sym_abstract_class_declaration] = STATE(595),
    [sym_module] = STATE(595),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(595),
    [sym_interface_declaration] = STATE(595),
    [sym_enum_declaration] = STATE(595),
    [sym_type_alias_declaration] = STATE(595),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [37] = {
    [sym_export_statement] = STATE(3021),
    [sym__declaration] = STATE(3021),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(3021),
    [sym_expression_statement] = STATE(3021),
    [sym_variable_declaration] = STATE(3021),
    [sym_lexical_declaration] = STATE(3021),
    [sym_statement_block] = STATE(3021),
    [sym_if_statement] = STATE(3021),
    [sym_switch_statement] = STATE(3021),
    [sym_for_statement] = STATE(3021),
    [sym_for_in_statement] = STATE(3021),
    [sym_while_statement] = STATE(3021),
    [sym_do_statement] = STATE(3021),
    [sym_try_statement] = STATE(3021),
    [sym_with_statement] = STATE(3021),
    [sym_break_statement] = STATE(3021),
    [sym_continue_statement] = STATE(3021),
    [sym_debugger_statement] = STATE(3021),
    [sym_return_statement] = STATE(3021),
    [sym_throw_statement] = STATE(3021),
    [sym_empty_statement] = STATE(3021),
    [sym_labeled_statement] = STATE(3021),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(3021),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(3021),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(3021),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(3021),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(3021),
    [sym_abstract_class_declaration] = STATE(3021),
    [sym_module] = STATE(3021),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(3021),
    [sym_interface_declaration] = STATE(3021),
    [sym_enum_declaration] = STATE(3021),
    [sym_type_alias_declaration] = STATE(3021),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [38] = {
    [sym_export_statement] = STATE(594),
    [sym__declaration] = STATE(594),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(594),
    [sym_expression_statement] = STATE(594),
    [sym_variable_declaration] = STATE(594),
    [sym_lexical_declaration] = STATE(594),
    [sym_statement_block] = STATE(594),
    [sym_if_statement] = STATE(594),
    [sym_switch_statement] = STATE(594),
    [sym_for_statement] = STATE(594),
    [sym_for_in_statement] = STATE(594),
    [sym_while_statement] = STATE(594),
    [sym_do_statement] = STATE(594),
    [sym_try_statement] = STATE(594),
    [sym_with_statement] = STATE(594),
    [sym_break_statement] = STATE(594),
    [sym_continue_statement] = STATE(594),
    [sym_debugger_statement] = STATE(594),
    [sym_return_statement] = STATE(594),
    [sym_throw_statement] = STATE(594),
    [sym_empty_statement] = STATE(594),
    [sym_labeled_statement] = STATE(594),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(594),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(594),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(594),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(594),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(594),
    [sym_abstract_class_declaration] = STATE(594),
    [sym_module] = STATE(594),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(594),
    [sym_interface_declaration] = STATE(594),
    [sym_enum_declaration] = STATE(594),
    [sym_type_alias_declaration] = STATE(594),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [39] = {
    [sym_export_statement] = STATE(610),
    [sym__declaration] = STATE(610),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(610),
    [sym_expression_statement] = STATE(610),
    [sym_variable_declaration] = STATE(610),
    [sym_lexical_declaration] = STATE(610),
    [sym_statement_block] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_switch_statement] = STATE(610),
    [sym_for_statement] = STATE(610),
    [sym_for_in_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_do_statement] = STATE(610),
    [sym_try_statement] = STATE(610),
    [sym_with_statement] = STATE(610),
    [sym_break_statement] = STATE(610),
    [sym_continue_statement] = STATE(610),
    [sym_debugger_statement] = STATE(610),
    [sym_return_statement] = STATE(610),
    [sym_throw_statement] = STATE(610),
    [sym_empty_statement] = STATE(610),
    [sym_labeled_statement] = STATE(610),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(610),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(610),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(610),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(610),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(610),
    [sym_abstract_class_declaration] = STATE(610),
    [sym_module] = STATE(610),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(610),
    [sym_interface_declaration] = STATE(610),
    [sym_enum_declaration] = STATE(610),
    [sym_type_alias_declaration] = STATE(610),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [40] = {
    [sym_export_statement] = STATE(567),
    [sym__declaration] = STATE(567),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(567),
    [sym_expression_statement] = STATE(567),
    [sym_variable_declaration] = STATE(567),
    [sym_lexical_declaration] = STATE(567),
    [sym_statement_block] = STATE(567),
    [sym_if_statement] = STATE(567),
    [sym_switch_statement] = STATE(567),
    [sym_for_statement] = STATE(567),
    [sym_for_in_statement] = STATE(567),
    [sym_while_statement] = STATE(567),
    [sym_do_statement] = STATE(567),
    [sym_try_statement] = STATE(567),
    [sym_with_statement] = STATE(567),
    [sym_break_statement] = STATE(567),
    [sym_continue_statement] = STATE(567),
    [sym_debugger_statement] = STATE(567),
    [sym_return_statement] = STATE(567),
    [sym_throw_statement] = STATE(567),
    [sym_empty_statement] = STATE(567),
    [sym_labeled_statement] = STATE(567),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(567),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(567),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(567),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(567),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(567),
    [sym_abstract_class_declaration] = STATE(567),
    [sym_module] = STATE(567),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(567),
    [sym_interface_declaration] = STATE(567),
    [sym_enum_declaration] = STATE(567),
    [sym_type_alias_declaration] = STATE(567),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [41] = {
    [sym_export_statement] = STATE(608),
    [sym__declaration] = STATE(608),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(608),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(608),
    [sym_lexical_declaration] = STATE(608),
    [sym_statement_block] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_switch_statement] = STATE(608),
    [sym_for_statement] = STATE(608),
    [sym_for_in_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_do_statement] = STATE(608),
    [sym_try_statement] = STATE(608),
    [sym_with_statement] = STATE(608),
    [sym_break_statement] = STATE(608),
    [sym_continue_statement] = STATE(608),
    [sym_debugger_statement] = STATE(608),
    [sym_return_statement] = STATE(608),
    [sym_throw_statement] = STATE(608),
    [sym_empty_statement] = STATE(608),
    [sym_labeled_statement] = STATE(608),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(608),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(608),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(608),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(608),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(608),
    [sym_abstract_class_declaration] = STATE(608),
    [sym_module] = STATE(608),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(608),
    [sym_interface_declaration] = STATE(608),
    [sym_enum_declaration] = STATE(608),
    [sym_type_alias_declaration] = STATE(608),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [42] = {
    [sym_export_statement] = STATE(583),
    [sym__declaration] = STATE(583),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(583),
    [sym_expression_statement] = STATE(583),
    [sym_variable_declaration] = STATE(583),
    [sym_lexical_declaration] = STATE(583),
    [sym_statement_block] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_switch_statement] = STATE(583),
    [sym_for_statement] = STATE(583),
    [sym_for_in_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_do_statement] = STATE(583),
    [sym_try_statement] = STATE(583),
    [sym_with_statement] = STATE(583),
    [sym_break_statement] = STATE(583),
    [sym_continue_statement] = STATE(583),
    [sym_debugger_statement] = STATE(583),
    [sym_return_statement] = STATE(583),
    [sym_throw_statement] = STATE(583),
    [sym_empty_statement] = STATE(583),
    [sym_labeled_statement] = STATE(583),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(583),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(583),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(583),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(583),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(583),
    [sym_abstract_class_declaration] = STATE(583),
    [sym_module] = STATE(583),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(583),
    [sym_interface_declaration] = STATE(583),
    [sym_enum_declaration] = STATE(583),
    [sym_type_alias_declaration] = STATE(583),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [43] = {
    [sym_export_statement] = STATE(567),
    [sym__declaration] = STATE(567),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(567),
    [sym_expression_statement] = STATE(567),
    [sym_variable_declaration] = STATE(567),
    [sym_lexical_declaration] = STATE(567),
    [sym_statement_block] = STATE(567),
    [sym_if_statement] = STATE(567),
    [sym_switch_statement] = STATE(567),
    [sym_for_statement] = STATE(567),
    [sym_for_in_statement] = STATE(567),
    [sym_while_statement] = STATE(567),
    [sym_do_statement] = STATE(567),
    [sym_try_statement] = STATE(567),
    [sym_with_statement] = STATE(567),
    [sym_break_statement] = STATE(567),
    [sym_continue_statement] = STATE(567),
    [sym_debugger_statement] = STATE(567),
    [sym_return_statement] = STATE(567),
    [sym_throw_statement] = STATE(567),
    [sym_empty_statement] = STATE(567),
    [sym_labeled_statement] = STATE(567),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(567),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(567),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(567),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(567),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(567),
    [sym_abstract_class_declaration] = STATE(567),
    [sym_module] = STATE(567),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(567),
    [sym_interface_declaration] = STATE(567),
    [sym_enum_declaration] = STATE(567),
    [sym_type_alias_declaration] = STATE(567),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [44] = {
    [sym_export_statement] = STATE(583),
    [sym__declaration] = STATE(583),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(583),
    [sym_expression_statement] = STATE(583),
    [sym_variable_declaration] = STATE(583),
    [sym_lexical_declaration] = STATE(583),
    [sym_statement_block] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_switch_statement] = STATE(583),
    [sym_for_statement] = STATE(583),
    [sym_for_in_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_do_statement] = STATE(583),
    [sym_try_statement] = STATE(583),
    [sym_with_statement] = STATE(583),
    [sym_break_statement] = STATE(583),
    [sym_continue_statement] = STATE(583),
    [sym_debugger_statement] = STATE(583),
    [sym_return_statement] = STATE(583),
    [sym_throw_statement] = STATE(583),
    [sym_empty_statement] = STATE(583),
    [sym_labeled_statement] = STATE(583),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(583),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(583),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(583),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(583),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(583),
    [sym_abstract_class_declaration] = STATE(583),
    [sym_module] = STATE(583),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(583),
    [sym_interface_declaration] = STATE(583),
    [sym_enum_declaration] = STATE(583),
    [sym_type_alias_declaration] = STATE(583),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [45] = {
    [sym_export_statement] = STATE(2801),
    [sym__declaration] = STATE(2801),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(2801),
    [sym_expression_statement] = STATE(2801),
    [sym_variable_declaration] = STATE(2801),
    [sym_lexical_declaration] = STATE(2801),
    [sym_statement_block] = STATE(2801),
    [sym_if_statement] = STATE(2801),
    [sym_switch_statement] = STATE(2801),
    [sym_for_statement] = STATE(2801),
    [sym_for_in_statement] = STATE(2801),
    [sym_while_statement] = STATE(2801),
    [sym_do_statement] = STATE(2801),
    [sym_try_statement] = STATE(2801),
    [sym_with_statement] = STATE(2801),
    [sym_break_statement] = STATE(2801),
    [sym_continue_statement] = STATE(2801),
    [sym_debugger_statement] = STATE(2801),
    [sym_return_statement] = STATE(2801),
    [sym_throw_statement] = STATE(2801),
    [sym_empty_statement] = STATE(2801),
    [sym_labeled_statement] = STATE(2801),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(2801),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(2801),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(2801),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(2801),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(2801),
    [sym_abstract_class_declaration] = STATE(2801),
    [sym_module] = STATE(2801),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(2801),
    [sym_interface_declaration] = STATE(2801),
    [sym_enum_declaration] = STATE(2801),
    [sym_type_alias_declaration] = STATE(2801),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [46] = {
    [sym_export_statement] = STATE(594),
    [sym__declaration] = STATE(594),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(594),
    [sym_expression_statement] = STATE(594),
    [sym_variable_declaration] = STATE(594),
    [sym_lexical_declaration] = STATE(594),
    [sym_statement_block] = STATE(594),
    [sym_if_statement] = STATE(594),
    [sym_switch_statement] = STATE(594),
    [sym_for_statement] = STATE(594),
    [sym_for_in_statement] = STATE(594),
    [sym_while_statement] = STATE(594),
    [sym_do_statement] = STATE(594),
    [sym_try_statement] = STATE(594),
    [sym_with_statement] = STATE(594),
    [sym_break_statement] = STATE(594),
    [sym_continue_statement] = STATE(594),
    [sym_debugger_statement] = STATE(594),
    [sym_return_statement] = STATE(594),
    [sym_throw_statement] = STATE(594),
    [sym_empty_statement] = STATE(594),
    [sym_labeled_statement] = STATE(594),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(594),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(594),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(594),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(594),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(594),
    [sym_abstract_class_declaration] = STATE(594),
    [sym_module] = STATE(594),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(594),
    [sym_interface_declaration] = STATE(594),
    [sym_enum_declaration] = STATE(594),
    [sym_type_alias_declaration] = STATE(594),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [47] = {
    [sym_export_statement] = STATE(2837),
    [sym__declaration] = STATE(2837),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(2837),
    [sym_expression_statement] = STATE(2837),
    [sym_variable_declaration] = STATE(2837),
    [sym_lexical_declaration] = STATE(2837),
    [sym_statement_block] = STATE(2837),
    [sym_if_statement] = STATE(2837),
    [sym_switch_statement] = STATE(2837),
    [sym_for_statement] = STATE(2837),
    [sym_for_in_statement] = STATE(2837),
    [sym_while_statement] = STATE(2837),
    [sym_do_statement] = STATE(2837),
    [sym_try_statement] = STATE(2837),
    [sym_with_statement] = STATE(2837),
    [sym_break_statement] = STATE(2837),
    [sym_continue_statement] = STATE(2837),
    [sym_debugger_statement] = STATE(2837),
    [sym_return_statement] = STATE(2837),
    [sym_throw_statement] = STATE(2837),
    [sym_empty_statement] = STATE(2837),
    [sym_labeled_statement] = STATE(2837),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(2837),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(2837),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(2837),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(2837),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(2837),
    [sym_abstract_class_declaration] = STATE(2837),
    [sym_module] = STATE(2837),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(2837),
    [sym_interface_declaration] = STATE(2837),
    [sym_enum_declaration] = STATE(2837),
    [sym_type_alias_declaration] = STATE(2837),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [48] = {
    [sym_export_statement] = STATE(612),
    [sym__declaration] = STATE(612),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_variable_declaration] = STATE(612),
    [sym_lexical_declaration] = STATE(612),
    [sym_statement_block] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_for_in_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_with_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_debugger_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_empty_statement] = STATE(612),
    [sym_labeled_statement] = STATE(612),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(612),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(612),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(612),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(612),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(612),
    [sym_abstract_class_declaration] = STATE(612),
    [sym_module] = STATE(612),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(612),
    [sym_interface_declaration] = STATE(612),
    [sym_enum_declaration] = STATE(612),
    [sym_type_alias_declaration] = STATE(612),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [49] = {
    [sym_export_statement] = STATE(575),
    [sym__declaration] = STATE(575),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(575),
    [sym_expression_statement] = STATE(575),
    [sym_variable_declaration] = STATE(575),
    [sym_lexical_declaration] = STATE(575),
    [sym_statement_block] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_switch_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_for_in_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_do_statement] = STATE(575),
    [sym_try_statement] = STATE(575),
    [sym_with_statement] = STATE(575),
    [sym_break_statement] = STATE(575),
    [sym_continue_statement] = STATE(575),
    [sym_debugger_statement] = STATE(575),
    [sym_return_statement] = STATE(575),
    [sym_throw_statement] = STATE(575),
    [sym_empty_statement] = STATE(575),
    [sym_labeled_statement] = STATE(575),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(575),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(575),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(575),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(575),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(575),
    [sym_abstract_class_declaration] = STATE(575),
    [sym_module] = STATE(575),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(575),
    [sym_interface_declaration] = STATE(575),
    [sym_enum_declaration] = STATE(575),
    [sym_type_alias_declaration] = STATE(575),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [50] = {
    [sym_export_statement] = STATE(575),
    [sym__declaration] = STATE(575),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(575),
    [sym_expression_statement] = STATE(575),
    [sym_variable_declaration] = STATE(575),
    [sym_lexical_declaration] = STATE(575),
    [sym_statement_block] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_switch_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_for_in_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_do_statement] = STATE(575),
    [sym_try_statement] = STATE(575),
    [sym_with_statement] = STATE(575),
    [sym_break_statement] = STATE(575),
    [sym_continue_statement] = STATE(575),
    [sym_debugger_statement] = STATE(575),
    [sym_return_statement] = STATE(575),
    [sym_throw_statement] = STATE(575),
    [sym_empty_statement] = STATE(575),
    [sym_labeled_statement] = STATE(575),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(575),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(575),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(575),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(575),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(575),
    [sym_abstract_class_declaration] = STATE(575),
    [sym_module] = STATE(575),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(575),
    [sym_interface_declaration] = STATE(575),
    [sym_enum_declaration] = STATE(575),
    [sym_type_alias_declaration] = STATE(575),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [51] = {
    [sym_export_statement] = STATE(610),
    [sym__declaration] = STATE(610),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(610),
    [sym_expression_statement] = STATE(610),
    [sym_variable_declaration] = STATE(610),
    [sym_lexical_declaration] = STATE(610),
    [sym_statement_block] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_switch_statement] = STATE(610),
    [sym_for_statement] = STATE(610),
    [sym_for_in_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_do_statement] = STATE(610),
    [sym_try_statement] = STATE(610),
    [sym_with_statement] = STATE(610),
    [sym_break_statement] = STATE(610),
    [sym_continue_statement] = STATE(610),
    [sym_debugger_statement] = STATE(610),
    [sym_return_statement] = STATE(610),
    [sym_throw_statement] = STATE(610),
    [sym_empty_statement] = STATE(610),
    [sym_labeled_statement] = STATE(610),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(610),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(610),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(610),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(610),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(610),
    [sym_abstract_class_declaration] = STATE(610),
    [sym_module] = STATE(610),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(610),
    [sym_interface_declaration] = STATE(610),
    [sym_enum_declaration] = STATE(610),
    [sym_type_alias_declaration] = STATE(610),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [52] = {
    [sym_export_statement] = STATE(575),
    [sym__declaration] = STATE(575),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(575),
    [sym_expression_statement] = STATE(575),
    [sym_variable_declaration] = STATE(575),
    [sym_lexical_declaration] = STATE(575),
    [sym_statement_block] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_switch_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_for_in_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_do_statement] = STATE(575),
    [sym_try_statement] = STATE(575),
    [sym_with_statement] = STATE(575),
    [sym_break_statement] = STATE(575),
    [sym_continue_statement] = STATE(575),
    [sym_debugger_statement] = STATE(575),
    [sym_return_statement] = STATE(575),
    [sym_throw_statement] = STATE(575),
    [sym_empty_statement] = STATE(575),
    [sym_labeled_statement] = STATE(575),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(575),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(575),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(575),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(575),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(575),
    [sym_abstract_class_declaration] = STATE(575),
    [sym_module] = STATE(575),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(575),
    [sym_interface_declaration] = STATE(575),
    [sym_enum_declaration] = STATE(575),
    [sym_type_alias_declaration] = STATE(575),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [53] = {
    [sym_export_statement] = STATE(595),
    [sym__declaration] = STATE(595),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(595),
    [sym_expression_statement] = STATE(595),
    [sym_variable_declaration] = STATE(595),
    [sym_lexical_declaration] = STATE(595),
    [sym_statement_block] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_switch_statement] = STATE(595),
    [sym_for_statement] = STATE(595),
    [sym_for_in_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_do_statement] = STATE(595),
    [sym_try_statement] = STATE(595),
    [sym_with_statement] = STATE(595),
    [sym_break_statement] = STATE(595),
    [sym_continue_statement] = STATE(595),
    [sym_debugger_statement] = STATE(595),
    [sym_return_statement] = STATE(595),
    [sym_throw_statement] = STATE(595),
    [sym_empty_statement] = STATE(595),
    [sym_labeled_statement] = STATE(595),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(595),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(595),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(595),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(595),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(595),
    [sym_abstract_class_declaration] = STATE(595),
    [sym_module] = STATE(595),
    [sym_internal_module] = STATE(117),
    [sym_import_alias] = STATE(595),
    [sym_interface_declaration] = STATE(595),
    [sym_enum_declaration] = STATE(595),
    [sym_type_alias_declaration] = STATE(595),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [54] = {
    [sym_export_statement] = STATE(583),
    [sym__declaration] = STATE(583),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(583),
    [sym_expression_statement] = STATE(583),
    [sym_variable_declaration] = STATE(583),
    [sym_lexical_declaration] = STATE(583),
    [sym_statement_block] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_switch_statement] = STATE(583),
    [sym_for_statement] = STATE(583),
    [sym_for_in_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_do_statement] = STATE(583),
    [sym_try_statement] = STATE(583),
    [sym_with_statement] = STATE(583),
    [sym_break_statement] = STATE(583),
    [sym_continue_statement] = STATE(583),
    [sym_debugger_statement] = STATE(583),
    [sym_return_statement] = STATE(583),
    [sym_throw_statement] = STATE(583),
    [sym_empty_statement] = STATE(583),
    [sym_labeled_statement] = STATE(583),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(583),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(583),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(583),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(583),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(583),
    [sym_abstract_class_declaration] = STATE(583),
    [sym_module] = STATE(583),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(583),
    [sym_interface_declaration] = STATE(583),
    [sym_enum_declaration] = STATE(583),
    [sym_type_alias_declaration] = STATE(583),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2238),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [55] = {
    [sym_export_statement] = STATE(610),
    [sym__declaration] = STATE(610),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(610),
    [sym_expression_statement] = STATE(610),
    [sym_variable_declaration] = STATE(610),
    [sym_lexical_declaration] = STATE(610),
    [sym_statement_block] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_switch_statement] = STATE(610),
    [sym_for_statement] = STATE(610),
    [sym_for_in_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_do_statement] = STATE(610),
    [sym_try_statement] = STATE(610),
    [sym_with_statement] = STATE(610),
    [sym_break_statement] = STATE(610),
    [sym_continue_statement] = STATE(610),
    [sym_debugger_statement] = STATE(610),
    [sym_return_statement] = STATE(610),
    [sym_throw_statement] = STATE(610),
    [sym_empty_statement] = STATE(610),
    [sym_labeled_statement] = STATE(610),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(610),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(610),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(610),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(610),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(610),
    [sym_abstract_class_declaration] = STATE(610),
    [sym_module] = STATE(610),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(610),
    [sym_interface_declaration] = STATE(610),
    [sym_enum_declaration] = STATE(610),
    [sym_type_alias_declaration] = STATE(610),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [56] = {
    [sym_export_statement] = STATE(598),
    [sym__declaration] = STATE(598),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(598),
    [sym_expression_statement] = STATE(598),
    [sym_variable_declaration] = STATE(598),
    [sym_lexical_declaration] = STATE(598),
    [sym_statement_block] = STATE(598),
    [sym_if_statement] = STATE(598),
    [sym_switch_statement] = STATE(598),
    [sym_for_statement] = STATE(598),
    [sym_for_in_statement] = STATE(598),
    [sym_while_statement] = STATE(598),
    [sym_do_statement] = STATE(598),
    [sym_try_statement] = STATE(598),
    [sym_with_statement] = STATE(598),
    [sym_break_statement] = STATE(598),
    [sym_continue_statement] = STATE(598),
    [sym_debugger_statement] = STATE(598),
    [sym_return_statement] = STATE(598),
    [sym_throw_statement] = STATE(598),
    [sym_empty_statement] = STATE(598),
    [sym_labeled_statement] = STATE(598),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(598),
    [sym_function] = STATE(1049),
    [sym_function_declaration] = STATE(598),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(598),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(598),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(598),
    [sym_abstract_class_declaration] = STATE(598),
    [sym_module] = STATE(598),
    [sym_internal_module] = STATE(1315),
    [sym_import_alias] = STATE(598),
    [sym_interface_declaration] = STATE(598),
    [sym_enum_declaration] = STATE(598),
    [sym_type_alias_declaration] = STATE(598),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [57] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [aux_sym_object_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [58] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1173),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(525),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [59] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [aux_sym_object_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [60] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [aux_sym_object_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [61] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [62] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1425),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
    [sym__automatic_semicolon] = ACTIONS(525),
  },
  [63] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [64] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_PIPE_RBRACE] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(617),
  },
  [65] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [66] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(621),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [67] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(623),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [68] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [69] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(627),
    [anon_sym_of] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [70] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1173),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(525),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [71] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [72] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [73] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [74] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [75] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1425),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
    [sym__automatic_semicolon] = ACTIONS(525),
  },
  [76] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [77] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [78] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1173),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(657),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_implements] = ACTIONS(517),
    [sym_readonly] = ACTIONS(515),
  },
  [79] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [80] = {
    [sym_import] = STATE(1326),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1326),
    [sym_jsx_fragment] = STATE(1326),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1326),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(665),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(679),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(691),
    [sym_this] = ACTIONS(693),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_null] = ACTIONS(693),
    [sym_undefined] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [81] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1642),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(695),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [82] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [83] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1248),
    [sym_jsx_fragment] = STATE(1248),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1248),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(703),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(695),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(751),
    [sym_this] = ACTIONS(753),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(753),
    [sym_false] = ACTIONS(753),
    [sym_null] = ACTIONS(753),
    [sym_undefined] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [84] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1248),
    [sym_jsx_fragment] = STATE(1248),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1248),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(703),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(695),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(751),
    [sym_this] = ACTIONS(753),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(753),
    [sym_false] = ACTIONS(753),
    [sym_null] = ACTIONS(753),
    [sym_undefined] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [85] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1289),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1289),
    [sym_jsx_fragment] = STATE(1289),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1289),
    [sym_class] = STATE(1289),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1289),
    [sym_arrow_function] = STATE(1289),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1289),
    [sym_new_expression] = STATE(1289),
    [sym_await_expression] = STATE(1289),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1289),
    [sym_augmented_assignment_expression] = STATE(1289),
    [sym_ternary_expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_update_expression] = STATE(1289),
    [sym_string] = STATE(1289),
    [sym_template_string] = STATE(1289),
    [sym_regex] = STATE(1289),
    [sym_meta_property] = STATE(1289),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1289),
    [sym_as_expression] = STATE(1289),
    [sym_internal_module] = STATE(1289),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(761),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(657),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(789),
    [sym_this] = ACTIONS(791),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(791),
    [sym_false] = ACTIONS(791),
    [sym_null] = ACTIONS(791),
    [sym_undefined] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(759),
  },
  [86] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [87] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1289),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1289),
    [sym_jsx_fragment] = STATE(1289),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1289),
    [sym_class] = STATE(1289),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1289),
    [sym_arrow_function] = STATE(1289),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1289),
    [sym_new_expression] = STATE(1289),
    [sym_await_expression] = STATE(1289),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1289),
    [sym_augmented_assignment_expression] = STATE(1289),
    [sym_ternary_expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_update_expression] = STATE(1289),
    [sym_string] = STATE(1289),
    [sym_template_string] = STATE(1289),
    [sym_regex] = STATE(1289),
    [sym_meta_property] = STATE(1289),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1289),
    [sym_as_expression] = STATE(1289),
    [sym_internal_module] = STATE(1289),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(761),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(657),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(789),
    [sym_this] = ACTIONS(791),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(791),
    [sym_false] = ACTIONS(791),
    [sym_null] = ACTIONS(791),
    [sym_undefined] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(759),
  },
  [88] = {
    [sym_import] = STATE(1326),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1326),
    [sym_jsx_fragment] = STATE(1326),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1326),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(665),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(679),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(691),
    [sym_this] = ACTIONS(693),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_null] = ACTIONS(693),
    [sym_undefined] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [89] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(793),
    [anon_sym_of] = ACTIONS(796),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [90] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(627),
    [anon_sym_of] = ACTIONS(630),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [91] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1555),
    [sym_array] = STATE(1556),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_sequence_expression] = STATE(3012),
    [sym_string] = STATE(1564),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2576),
    [sym_constructor_type] = STATE(2576),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym_function_type] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(1756),
    [sym_identifier] = ACTIONS(798),
    [anon_sym_export] = ACTIONS(800),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_typeof] = ACTIONS(808),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(818),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(834),
    [sym_this] = ACTIONS(836),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_set] = ACTIONS(800),
    [anon_sym_declare] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(800),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(846),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [92] = {
    [sym_import] = STATE(1169),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1169),
    [sym_object] = STATE(1555),
    [sym_array] = STATE(1556),
    [sym_jsx_element] = STATE(1169),
    [sym_jsx_fragment] = STATE(1169),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1169),
    [sym_class] = STATE(1169),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1169),
    [sym_arrow_function] = STATE(1169),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1169),
    [sym_new_expression] = STATE(1169),
    [sym_await_expression] = STATE(1169),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1169),
    [sym_augmented_assignment_expression] = STATE(1169),
    [sym_ternary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(1169),
    [sym_unary_expression] = STATE(1169),
    [sym_update_expression] = STATE(1169),
    [sym_sequence_expression] = STATE(3026),
    [sym_string] = STATE(1564),
    [sym_template_string] = STATE(1169),
    [sym_regex] = STATE(1169),
    [sym_meta_property] = STATE(1169),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1169),
    [sym_as_expression] = STATE(1169),
    [sym_internal_module] = STATE(1169),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2616),
    [sym_constructor_type] = STATE(2616),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2616),
    [sym_intersection_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [aux_sym_export_statement_repeat1] = STATE(1756),
    [sym_identifier] = ACTIONS(798),
    [anon_sym_export] = ACTIONS(800),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_typeof] = ACTIONS(808),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(818),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(834),
    [sym_this] = ACTIONS(836),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_null] = ACTIONS(852),
    [sym_undefined] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_set] = ACTIONS(800),
    [anon_sym_declare] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(800),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(846),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [93] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1555),
    [sym_array] = STATE(1556),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_sequence_expression] = STATE(3012),
    [sym_string] = STATE(1564),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2616),
    [sym_constructor_type] = STATE(2616),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2616),
    [sym_intersection_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [aux_sym_export_statement_repeat1] = STATE(1756),
    [sym_identifier] = ACTIONS(798),
    [anon_sym_export] = ACTIONS(800),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_typeof] = ACTIONS(808),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(818),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(834),
    [sym_this] = ACTIONS(836),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_set] = ACTIONS(800),
    [anon_sym_declare] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(800),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(846),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [94] = {
    [sym_import] = STATE(1025),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1025),
    [sym_object] = STATE(1555),
    [sym_array] = STATE(1556),
    [sym_jsx_element] = STATE(1025),
    [sym_jsx_fragment] = STATE(1025),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1025),
    [sym_class] = STATE(1025),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1025),
    [sym_arrow_function] = STATE(1025),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1025),
    [sym_new_expression] = STATE(1025),
    [sym_await_expression] = STATE(1025),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1025),
    [sym_augmented_assignment_expression] = STATE(1025),
    [sym_ternary_expression] = STATE(1025),
    [sym_binary_expression] = STATE(1025),
    [sym_unary_expression] = STATE(1025),
    [sym_update_expression] = STATE(1025),
    [sym_sequence_expression] = STATE(3118),
    [sym_string] = STATE(1564),
    [sym_template_string] = STATE(1025),
    [sym_regex] = STATE(1025),
    [sym_meta_property] = STATE(1025),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1025),
    [sym_as_expression] = STATE(1025),
    [sym_internal_module] = STATE(1025),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2616),
    [sym_constructor_type] = STATE(2616),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2616),
    [sym_intersection_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [aux_sym_export_statement_repeat1] = STATE(1756),
    [sym_identifier] = ACTIONS(798),
    [anon_sym_export] = ACTIONS(800),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_typeof] = ACTIONS(808),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(818),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(834),
    [sym_this] = ACTIONS(836),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_null] = ACTIONS(854),
    [sym_undefined] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_set] = ACTIONS(800),
    [anon_sym_declare] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(800),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(846),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [95] = {
    [sym_import] = STATE(1264),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1264),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1264),
    [sym_jsx_fragment] = STATE(1264),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1264),
    [sym_class] = STATE(1264),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1264),
    [sym_arrow_function] = STATE(1264),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1264),
    [sym_new_expression] = STATE(1264),
    [sym_await_expression] = STATE(1264),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1264),
    [sym_augmented_assignment_expression] = STATE(1264),
    [sym_spread_element] = STATE(2625),
    [sym_ternary_expression] = STATE(1264),
    [sym_binary_expression] = STATE(1264),
    [sym_unary_expression] = STATE(1264),
    [sym_update_expression] = STATE(1264),
    [sym_string] = STATE(1729),
    [sym_template_string] = STATE(1264),
    [sym_regex] = STATE(1264),
    [sym_meta_property] = STATE(1264),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1264),
    [sym_as_expression] = STATE(1264),
    [sym_internal_module] = STATE(1264),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2442),
    [sym_constructor_type] = STATE(2442),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2442),
    [sym_intersection_type] = STATE(2442),
    [sym_function_type] = STATE(2442),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2621),
    [sym_identifier] = ACTIONS(856),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(858),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(862),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_RBRACK] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(868),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(870),
    [sym_this] = ACTIONS(872),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_null] = ACTIONS(876),
    [sym_undefined] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [96] = {
    [sym_import] = STATE(1231),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1231),
    [sym_yield_expression] = STATE(1231),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1231),
    [sym_jsx_fragment] = STATE(1231),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1231),
    [sym_class] = STATE(1231),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1231),
    [sym_arrow_function] = STATE(1231),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1231),
    [sym_new_expression] = STATE(1231),
    [sym_await_expression] = STATE(1231),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1231),
    [sym_augmented_assignment_expression] = STATE(1231),
    [sym_spread_element] = STATE(2610),
    [sym_ternary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(1231),
    [sym_unary_expression] = STATE(1231),
    [sym_update_expression] = STATE(1231),
    [sym_string] = STATE(1729),
    [sym_template_string] = STATE(1231),
    [sym_regex] = STATE(1231),
    [sym_meta_property] = STATE(1231),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1231),
    [sym_as_expression] = STATE(1231),
    [sym_internal_module] = STATE(1231),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2296),
    [sym_constructor_type] = STATE(2296),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2296),
    [sym_intersection_type] = STATE(2296),
    [sym_function_type] = STATE(2296),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2609),
    [sym_identifier] = ACTIONS(856),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(858),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(862),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_RBRACK] = ACTIONS(880),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(868),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(870),
    [sym_this] = ACTIONS(872),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_null] = ACTIONS(882),
    [sym_undefined] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [97] = {
    [sym_import] = STATE(1293),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1293),
    [sym_jsx_fragment] = STATE(1293),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1293),
    [sym_class] = STATE(1293),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1293),
    [sym_arrow_function] = STATE(1293),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1293),
    [sym_new_expression] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_spread_element] = STATE(2602),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_string] = STATE(1729),
    [sym_template_string] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2442),
    [sym_constructor_type] = STATE(2442),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2442),
    [sym_intersection_type] = STATE(2442),
    [sym_function_type] = STATE(2442),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2603),
    [sym_identifier] = ACTIONS(856),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(858),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(862),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_RBRACK] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(868),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(870),
    [sym_this] = ACTIONS(872),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_null] = ACTIONS(886),
    [sym_undefined] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [98] = {
    [sym_import] = STATE(1231),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1231),
    [sym_yield_expression] = STATE(1231),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1231),
    [sym_jsx_fragment] = STATE(1231),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1231),
    [sym_class] = STATE(1231),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1231),
    [sym_arrow_function] = STATE(1231),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1231),
    [sym_new_expression] = STATE(1231),
    [sym_await_expression] = STATE(1231),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1231),
    [sym_augmented_assignment_expression] = STATE(1231),
    [sym_spread_element] = STATE(2610),
    [sym_ternary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(1231),
    [sym_unary_expression] = STATE(1231),
    [sym_update_expression] = STATE(1231),
    [sym_string] = STATE(1729),
    [sym_template_string] = STATE(1231),
    [sym_regex] = STATE(1231),
    [sym_meta_property] = STATE(1231),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1231),
    [sym_as_expression] = STATE(1231),
    [sym_internal_module] = STATE(1231),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2442),
    [sym_constructor_type] = STATE(2442),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2442),
    [sym_intersection_type] = STATE(2442),
    [sym_function_type] = STATE(2442),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2609),
    [sym_identifier] = ACTIONS(856),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(858),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(862),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_RBRACK] = ACTIONS(880),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(868),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(870),
    [sym_this] = ACTIONS(872),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_null] = ACTIONS(882),
    [sym_undefined] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [99] = {
    [sym_import] = STATE(1302),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1302),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1302),
    [sym_jsx_fragment] = STATE(1302),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1302),
    [sym_class] = STATE(1302),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1302),
    [sym_arrow_function] = STATE(1302),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1302),
    [sym_new_expression] = STATE(1302),
    [sym_await_expression] = STATE(1302),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1302),
    [sym_augmented_assignment_expression] = STATE(1302),
    [sym_spread_element] = STATE(2673),
    [sym_ternary_expression] = STATE(1302),
    [sym_binary_expression] = STATE(1302),
    [sym_unary_expression] = STATE(1302),
    [sym_update_expression] = STATE(1302),
    [sym_string] = STATE(1729),
    [sym_template_string] = STATE(1302),
    [sym_regex] = STATE(1302),
    [sym_meta_property] = STATE(1302),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1302),
    [sym_as_expression] = STATE(1302),
    [sym_internal_module] = STATE(1302),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2442),
    [sym_constructor_type] = STATE(2442),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2442),
    [sym_intersection_type] = STATE(2442),
    [sym_function_type] = STATE(2442),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2674),
    [sym_identifier] = ACTIONS(856),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(858),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(862),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_RBRACK] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(868),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(870),
    [sym_this] = ACTIONS(872),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_null] = ACTIONS(890),
    [sym_undefined] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [100] = {
    [sym_import] = STATE(1006),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1006),
    [sym_yield_expression] = STATE(1006),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1006),
    [sym_jsx_fragment] = STATE(1006),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1006),
    [sym_class] = STATE(1006),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1006),
    [sym_arrow_function] = STATE(1006),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1006),
    [sym_new_expression] = STATE(1006),
    [sym_await_expression] = STATE(1006),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1006),
    [sym_augmented_assignment_expression] = STATE(1006),
    [sym_ternary_expression] = STATE(1006),
    [sym_binary_expression] = STATE(1006),
    [sym_unary_expression] = STATE(1006),
    [sym_update_expression] = STATE(1006),
    [sym_string] = STATE(1006),
    [sym_template_string] = STATE(1006),
    [sym_regex] = STATE(1006),
    [sym_meta_property] = STATE(1006),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1006),
    [sym_as_expression] = STATE(1006),
    [sym_internal_module] = STATE(1006),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(896),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_COLON] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(896),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(896),
    [anon_sym_PIPE_PIPE] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_STAR_STAR] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(896),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(896),
    [anon_sym_QMARK_QMARK] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(900),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_null] = ACTIONS(900),
    [sym_undefined] = ACTIONS(900),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [101] = {
    [sym_import] = STATE(1100),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1100),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1100),
    [sym_jsx_fragment] = STATE(1100),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1100),
    [sym_arrow_function] = STATE(1100),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1100),
    [sym_new_expression] = STATE(1100),
    [sym_await_expression] = STATE(1100),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1100),
    [sym_augmented_assignment_expression] = STATE(1100),
    [sym_ternary_expression] = STATE(1100),
    [sym_binary_expression] = STATE(1100),
    [sym_unary_expression] = STATE(1100),
    [sym_update_expression] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym_template_string] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_meta_property] = STATE(1100),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1100),
    [sym_as_expression] = STATE(1100),
    [sym_internal_module] = STATE(1100),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(902),
    [anon_sym_as] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(896),
    [anon_sym_PIPE_PIPE] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_STAR_STAR] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(896),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(896),
    [anon_sym_QMARK_QMARK] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(904),
    [sym_this] = ACTIONS(906),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_null] = ACTIONS(906),
    [sym_undefined] = ACTIONS(906),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(896),
  },
  [102] = {
    [sym_import] = STATE(1190),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1190),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1190),
    [sym_jsx_fragment] = STATE(1190),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1190),
    [sym_class] = STATE(1190),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1190),
    [sym_arrow_function] = STATE(1190),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1190),
    [sym_new_expression] = STATE(1190),
    [sym_await_expression] = STATE(1190),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1190),
    [sym_augmented_assignment_expression] = STATE(1190),
    [sym_ternary_expression] = STATE(1190),
    [sym_binary_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1190),
    [sym_update_expression] = STATE(1190),
    [sym_string] = STATE(1470),
    [sym_template_string] = STATE(1190),
    [sym_regex] = STATE(1190),
    [sym_meta_property] = STATE(1190),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1190),
    [sym_as_expression] = STATE(1190),
    [sym_internal_module] = STATE(1190),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2426),
    [sym_constructor_type] = STATE(2426),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2426),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(912),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(914),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(918),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(920),
    [sym_this] = ACTIONS(922),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_null] = ACTIONS(926),
    [sym_undefined] = ACTIONS(926),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [sym_readonly] = ACTIONS(515),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [103] = {
    [sym_import] = STATE(1362),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1362),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1362),
    [sym_jsx_fragment] = STATE(1362),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1362),
    [sym_class] = STATE(1362),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1362),
    [sym_arrow_function] = STATE(1362),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1362),
    [sym_new_expression] = STATE(1362),
    [sym_await_expression] = STATE(1362),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1362),
    [sym_augmented_assignment_expression] = STATE(1362),
    [sym_ternary_expression] = STATE(1362),
    [sym_binary_expression] = STATE(1362),
    [sym_unary_expression] = STATE(1362),
    [sym_update_expression] = STATE(1362),
    [sym_string] = STATE(1575),
    [sym_template_string] = STATE(1362),
    [sym_regex] = STATE(1362),
    [sym_meta_property] = STATE(1362),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1362),
    [sym_as_expression] = STATE(1362),
    [sym_internal_module] = STATE(1362),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2426),
    [sym_constructor_type] = STATE(2426),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2426),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(930),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(934),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(938),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(946),
    [sym_this] = ACTIONS(948),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(952),
    [sym_undefined] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(954),
    [anon_sym_number] = ACTIONS(954),
    [anon_sym_boolean] = ACTIONS(954),
    [anon_sym_string] = ACTIONS(954),
    [anon_sym_symbol] = ACTIONS(954),
    [sym_readonly] = ACTIONS(663),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [104] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(1147),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2426),
    [sym_constructor_type] = STATE(2426),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2426),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(820),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(962),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(964),
    [sym_this] = ACTIONS(966),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(968),
    [sym_false] = ACTIONS(968),
    [sym_null] = ACTIONS(970),
    [sym_undefined] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(972),
    [anon_sym_number] = ACTIONS(972),
    [anon_sym_boolean] = ACTIONS(972),
    [anon_sym_string] = ACTIONS(972),
    [anon_sym_symbol] = ACTIONS(972),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [105] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1349),
    [sym_jsx_fragment] = STATE(1349),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(2993),
    [sym_jsx_self_closing_element] = STATE(1349),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_ternary_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_update_expression] = STATE(1349),
    [sym_string] = STATE(1374),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2734),
    [sym_non_null_expression] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_internal_module] = STATE(1349),
    [sym_nested_type_identifier] = STATE(1918),
    [sym__type] = STATE(2022),
    [sym_constructor_type] = STATE(2022),
    [sym__primary_type] = STATE(1978),
    [sym_generic_type] = STATE(1978),
    [sym_type_predicate] = STATE(1978),
    [sym_type_query] = STATE(1978),
    [sym_index_type_query] = STATE(1978),
    [sym_lookup_type] = STATE(1978),
    [sym_literal_type] = STATE(1978),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1978),
    [sym_flow_maybe_type] = STATE(1978),
    [sym_parenthesized_type] = STATE(1978),
    [sym_predefined_type] = STATE(1978),
    [sym_object_type] = STATE(1978),
    [sym_type_parameters] = STATE(2856),
    [sym_array_type] = STATE(1978),
    [sym_tuple_type] = STATE(1978),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2022),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(976),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(980),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(982),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_PIPE] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(996),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(998),
    [sym_this] = ACTIONS(1000),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1002),
    [sym_false] = ACTIONS(1002),
    [sym_null] = ACTIONS(1004),
    [sym_undefined] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(1008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1010),
  },
  [106] = {
    [sym_import] = STATE(1135),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1135),
    [sym_yield_expression] = STATE(1135),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1135),
    [sym_jsx_fragment] = STATE(1135),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1135),
    [sym_class] = STATE(1135),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1135),
    [sym_arrow_function] = STATE(1135),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1135),
    [sym_new_expression] = STATE(1135),
    [sym_await_expression] = STATE(1135),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1135),
    [sym_augmented_assignment_expression] = STATE(1135),
    [sym_ternary_expression] = STATE(1135),
    [sym_binary_expression] = STATE(1135),
    [sym_unary_expression] = STATE(1135),
    [sym_update_expression] = STATE(1135),
    [sym_string] = STATE(1495),
    [sym_template_string] = STATE(1135),
    [sym_regex] = STATE(1135),
    [sym_meta_property] = STATE(1135),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1135),
    [sym_as_expression] = STATE(1135),
    [sym_internal_module] = STATE(1135),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2426),
    [sym_constructor_type] = STATE(2426),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2426),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(1014),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(938),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(1016),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1020),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1022),
    [sym_this] = ACTIONS(1024),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1026),
    [sym_false] = ACTIONS(1026),
    [sym_null] = ACTIONS(1028),
    [sym_undefined] = ACTIONS(1028),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(1030),
    [anon_sym_number] = ACTIONS(1030),
    [anon_sym_boolean] = ACTIONS(1030),
    [anon_sym_string] = ACTIONS(1030),
    [anon_sym_symbol] = ACTIONS(1030),
    [sym_readonly] = ACTIONS(469),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [107] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1179),
    [sym_jsx_fragment] = STATE(1179),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1179),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1670),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2426),
    [sym_constructor_type] = STATE(2426),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2426),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(1036),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(1048),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1050),
    [sym_this] = ACTIONS(1052),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1054),
    [sym_false] = ACTIONS(1054),
    [sym_null] = ACTIONS(1056),
    [sym_undefined] = ACTIONS(1056),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(1058),
    [anon_sym_number] = ACTIONS(1058),
    [anon_sym_boolean] = ACTIONS(1058),
    [anon_sym_string] = ACTIONS(1058),
    [anon_sym_symbol] = ACTIONS(1058),
    [sym_readonly] = ACTIONS(701),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [108] = {
    [sym_import] = STATE(1267),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1267),
    [sym_jsx_fragment] = STATE(1267),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1267),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_string] = STATE(1147),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2631),
    [sym_non_null_expression] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1894),
    [sym__type] = STATE(2426),
    [sym_constructor_type] = STATE(2426),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2957),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2426),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1060),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(1062),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(1064),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(1068),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(964),
    [sym_this] = ACTIONS(966),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(968),
    [sym_false] = ACTIONS(968),
    [sym_null] = ACTIONS(1070),
    [sym_undefined] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [sym_readonly] = ACTIONS(759),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [109] = {
    [sym_import] = STATE(1247),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1247),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1247),
    [sym_jsx_fragment] = STATE(1247),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1247),
    [sym_class] = STATE(1247),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1247),
    [sym_arrow_function] = STATE(1247),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1247),
    [sym_new_expression] = STATE(1247),
    [sym_await_expression] = STATE(1247),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1247),
    [sym_augmented_assignment_expression] = STATE(1247),
    [sym_ternary_expression] = STATE(1247),
    [sym_binary_expression] = STATE(1247),
    [sym_unary_expression] = STATE(1247),
    [sym_update_expression] = STATE(1247),
    [sym_string] = STATE(1247),
    [sym_template_string] = STATE(1247),
    [sym_regex] = STATE(1247),
    [sym_meta_property] = STATE(1247),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1247),
    [sym_as_expression] = STATE(1247),
    [sym_internal_module] = STATE(1247),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_as] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_COLON] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(896),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(896),
    [anon_sym_PIPE_PIPE] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_STAR_STAR] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(896),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(896),
    [anon_sym_QMARK_QMARK] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1076),
    [sym_this] = ACTIONS(1078),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1078),
    [sym_false] = ACTIONS(1078),
    [sym_null] = ACTIONS(1078),
    [sym_undefined] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [110] = {
    [sym_import] = STATE(1230),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1230),
    [sym_yield_expression] = STATE(1230),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1230),
    [sym_jsx_fragment] = STATE(1230),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1230),
    [sym_class] = STATE(1230),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1230),
    [sym_arrow_function] = STATE(1230),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1230),
    [sym_new_expression] = STATE(1230),
    [sym_await_expression] = STATE(1230),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1230),
    [sym_augmented_assignment_expression] = STATE(1230),
    [sym_ternary_expression] = STATE(1230),
    [sym_binary_expression] = STATE(1230),
    [sym_unary_expression] = STATE(1230),
    [sym_update_expression] = STATE(1230),
    [sym_string] = STATE(1230),
    [sym_template_string] = STATE(1230),
    [sym_regex] = STATE(1230),
    [sym_meta_property] = STATE(1230),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1230),
    [sym_as_expression] = STATE(1230),
    [sym_internal_module] = STATE(1230),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_as] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(896),
    [anon_sym_PIPE_PIPE] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_STAR_STAR] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(896),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(896),
    [anon_sym_QMARK_QMARK] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1082),
    [sym_this] = ACTIONS(1084),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_undefined] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(896),
  },
  [111] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1324),
    [sym_jsx_fragment] = STATE(1324),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1324),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_as] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(896),
    [anon_sym_PIPE_PIPE] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_STAR_STAR] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(896),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(896),
    [anon_sym_QMARK_QMARK] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1088),
    [sym_this] = ACTIONS(1090),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1090),
    [sym_false] = ACTIONS(1090),
    [sym_null] = ACTIONS(1090),
    [sym_undefined] = ACTIONS(1090),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
    [sym__automatic_semicolon] = ACTIONS(896),
  },
  [112] = {
    [sym_import] = STATE(1268),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1268),
    [sym_yield_expression] = STATE(1268),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1268),
    [sym_jsx_fragment] = STATE(1268),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1268),
    [sym_class] = STATE(1268),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1268),
    [sym_arrow_function] = STATE(1268),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1268),
    [sym_new_expression] = STATE(1268),
    [sym_await_expression] = STATE(1268),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1268),
    [sym_augmented_assignment_expression] = STATE(1268),
    [sym_ternary_expression] = STATE(1268),
    [sym_binary_expression] = STATE(1268),
    [sym_unary_expression] = STATE(1268),
    [sym_update_expression] = STATE(1268),
    [sym_string] = STATE(1268),
    [sym_template_string] = STATE(1268),
    [sym_regex] = STATE(1268),
    [sym_meta_property] = STATE(1268),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1268),
    [sym_as_expression] = STATE(1268),
    [sym_internal_module] = STATE(1268),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_as] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(896),
    [anon_sym_PIPE_PIPE] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_STAR_STAR] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(896),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(896),
    [anon_sym_QMARK_QMARK] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1094),
    [sym_this] = ACTIONS(1096),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [anon_sym_implements] = ACTIONS(894),
    [sym_readonly] = ACTIONS(759),
  },
  [113] = {
    [sym_statement_block] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_export] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_as] = ACTIONS(1100),
    [anon_sym_namespace] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1098),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_var] = ACTIONS(1100),
    [anon_sym_let] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1098),
    [anon_sym_await] = ACTIONS(1100),
    [anon_sym_in] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_debugger] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_throw] = ACTIONS(1100),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_GT] = ACTIONS(1100),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_function] = ACTIONS(1100),
    [anon_sym_new] = ACTIONS(1100),
    [anon_sym_QMARK] = ACTIONS(1100),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE_PIPE] = ACTIONS(1098),
    [anon_sym_GT_GT] = ACTIONS(1100),
    [anon_sym_GT_GT_GT] = ACTIONS(1098),
    [anon_sym_LT_LT] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PERCENT] = ACTIONS(1098),
    [anon_sym_STAR_STAR] = ACTIONS(1098),
    [anon_sym_LT_EQ] = ACTIONS(1098),
    [anon_sym_EQ_EQ] = ACTIONS(1100),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1098),
    [anon_sym_BANG_EQ] = ACTIONS(1100),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1098),
    [anon_sym_GT_EQ] = ACTIONS(1098),
    [anon_sym_QMARK_QMARK] = ACTIONS(1098),
    [anon_sym_instanceof] = ACTIONS(1100),
    [anon_sym_BANG] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_void] = ACTIONS(1100),
    [anon_sym_delete] = ACTIONS(1100),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1098),
    [sym_number] = ACTIONS(1098),
    [sym_this] = ACTIONS(1100),
    [sym_super] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_undefined] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_abstract] = ACTIONS(1100),
    [anon_sym_get] = ACTIONS(1100),
    [anon_sym_set] = ACTIONS(1100),
    [anon_sym_declare] = ACTIONS(1100),
    [anon_sym_public] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym_protected] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [anon_sym_any] = ACTIONS(1100),
    [anon_sym_number] = ACTIONS(1100),
    [anon_sym_boolean] = ACTIONS(1100),
    [anon_sym_string] = ACTIONS(1100),
    [anon_sym_symbol] = ACTIONS(1100),
    [anon_sym_interface] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [sym_readonly] = ACTIONS(1100),
    [sym__automatic_semicolon] = ACTIONS(1098),
  },
  [114] = {
    [sym_statement_block] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_export] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_as] = ACTIONS(1100),
    [anon_sym_namespace] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1098),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_var] = ACTIONS(1100),
    [anon_sym_let] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1098),
    [anon_sym_await] = ACTIONS(1100),
    [anon_sym_in] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_debugger] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_throw] = ACTIONS(1100),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_GT] = ACTIONS(1100),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_DOT] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_function] = ACTIONS(1100),
    [anon_sym_new] = ACTIONS(1100),
    [anon_sym_QMARK] = ACTIONS(1100),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE_PIPE] = ACTIONS(1098),
    [anon_sym_GT_GT] = ACTIONS(1100),
    [anon_sym_GT_GT_GT] = ACTIONS(1098),
    [anon_sym_LT_LT] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PERCENT] = ACTIONS(1098),
    [anon_sym_STAR_STAR] = ACTIONS(1098),
    [anon_sym_LT_EQ] = ACTIONS(1098),
    [anon_sym_EQ_EQ] = ACTIONS(1100),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1098),
    [anon_sym_BANG_EQ] = ACTIONS(1100),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1098),
    [anon_sym_GT_EQ] = ACTIONS(1098),
    [anon_sym_QMARK_QMARK] = ACTIONS(1098),
    [anon_sym_instanceof] = ACTIONS(1100),
    [anon_sym_BANG] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_void] = ACTIONS(1100),
    [anon_sym_delete] = ACTIONS(1100),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1098),
    [sym_number] = ACTIONS(1098),
    [sym_this] = ACTIONS(1100),
    [sym_super] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_undefined] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_abstract] = ACTIONS(1100),
    [anon_sym_get] = ACTIONS(1100),
    [anon_sym_set] = ACTIONS(1100),
    [anon_sym_declare] = ACTIONS(1100),
    [anon_sym_public] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym_protected] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [anon_sym_any] = ACTIONS(1100),
    [anon_sym_number] = ACTIONS(1100),
    [anon_sym_boolean] = ACTIONS(1100),
    [anon_sym_string] = ACTIONS(1100),
    [anon_sym_symbol] = ACTIONS(1100),
    [anon_sym_interface] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [sym_readonly] = ACTIONS(1100),
    [sym__automatic_semicolon] = ACTIONS(1098),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_export] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_EQ] = ACTIONS(1110),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_type] = ACTIONS(1108),
    [anon_sym_typeof] = ACTIONS(1108),
    [anon_sym_import] = ACTIONS(1108),
    [anon_sym_var] = ACTIONS(1108),
    [anon_sym_let] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_else] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_await] = ACTIONS(1108),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_try] = ACTIONS(1108),
    [anon_sym_with] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_debugger] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_throw] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_yield] = ACTIONS(1108),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1108),
    [anon_sym_async] = ACTIONS(1108),
    [anon_sym_function] = ACTIONS(1108),
    [anon_sym_new] = ACTIONS(1108),
    [anon_sym_QMARK] = ACTIONS(1110),
    [anon_sym_AMP_AMP] = ACTIONS(1112),
    [anon_sym_PIPE_PIPE] = ACTIONS(1112),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1112),
    [anon_sym_LT_LT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_STAR_STAR] = ACTIONS(1112),
    [anon_sym_LT_EQ] = ACTIONS(1112),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1112),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1112),
    [anon_sym_GT_EQ] = ACTIONS(1112),
    [anon_sym_QMARK_QMARK] = ACTIONS(1112),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_void] = ACTIONS(1108),
    [anon_sym_delete] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1106),
    [sym_number] = ACTIONS(1106),
    [sym_this] = ACTIONS(1108),
    [sym_super] = ACTIONS(1108),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_undefined] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_abstract] = ACTIONS(1108),
    [anon_sym_get] = ACTIONS(1108),
    [anon_sym_set] = ACTIONS(1108),
    [anon_sym_declare] = ACTIONS(1108),
    [anon_sym_public] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym_protected] = ACTIONS(1108),
    [anon_sym_module] = ACTIONS(1108),
    [anon_sym_any] = ACTIONS(1108),
    [anon_sym_number] = ACTIONS(1108),
    [anon_sym_boolean] = ACTIONS(1108),
    [anon_sym_string] = ACTIONS(1108),
    [anon_sym_symbol] = ACTIONS(1108),
    [anon_sym_interface] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [sym_readonly] = ACTIONS(1108),
    [sym__automatic_semicolon] = ACTIONS(1114),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(1116),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_export] = ACTIONS(1118),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_default] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1118),
    [anon_sym_namespace] = ACTIONS(1118),
    [anon_sym_LBRACE] = ACTIONS(1116),
    [anon_sym_COMMA] = ACTIONS(1116),
    [anon_sym_RBRACE] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1118),
    [anon_sym_typeof] = ACTIONS(1118),
    [anon_sym_import] = ACTIONS(1118),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1118),
    [anon_sym_const] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1118),
    [anon_sym_else] = ACTIONS(1118),
    [anon_sym_switch] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1118),
    [anon_sym_in] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1118),
    [anon_sym_try] = ACTIONS(1118),
    [anon_sym_with] = ACTIONS(1118),
    [anon_sym_break] = ACTIONS(1118),
    [anon_sym_continue] = ACTIONS(1118),
    [anon_sym_debugger] = ACTIONS(1118),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_throw] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1118),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_LBRACK] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1118),
    [anon_sym_GT] = ACTIONS(1118),
    [anon_sym_SLASH] = ACTIONS(1118),
    [anon_sym_DOT] = ACTIONS(1118),
    [anon_sym_class] = ACTIONS(1118),
    [anon_sym_async] = ACTIONS(1118),
    [anon_sym_function] = ACTIONS(1118),
    [anon_sym_new] = ACTIONS(1118),
    [anon_sym_QMARK] = ACTIONS(1118),
    [anon_sym_AMP_AMP] = ACTIONS(1116),
    [anon_sym_PIPE_PIPE] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1118),
    [anon_sym_GT_GT_GT] = ACTIONS(1116),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_AMP] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1116),
    [anon_sym_PIPE] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1118),
    [anon_sym_PERCENT] = ACTIONS(1116),
    [anon_sym_STAR_STAR] = ACTIONS(1116),
    [anon_sym_LT_EQ] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1116),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1116),
    [anon_sym_GT_EQ] = ACTIONS(1116),
    [anon_sym_QMARK_QMARK] = ACTIONS(1116),
    [anon_sym_instanceof] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1116),
    [anon_sym_void] = ACTIONS(1118),
    [anon_sym_delete] = ACTIONS(1118),
    [anon_sym_PLUS_PLUS] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1116),
    [anon_sym_DQUOTE] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1116),
    [sym_number] = ACTIONS(1116),
    [sym_this] = ACTIONS(1118),
    [sym_super] = ACTIONS(1118),
    [sym_true] = ACTIONS(1118),
    [sym_false] = ACTIONS(1118),
    [sym_null] = ACTIONS(1118),
    [sym_undefined] = ACTIONS(1118),
    [anon_sym_AT] = ACTIONS(1116),
    [anon_sym_static] = ACTIONS(1118),
    [anon_sym_abstract] = ACTIONS(1118),
    [anon_sym_get] = ACTIONS(1118),
    [anon_sym_set] = ACTIONS(1118),
    [anon_sym_declare] = ACTIONS(1118),
    [anon_sym_public] = ACTIONS(1118),
    [anon_sym_private] = ACTIONS(1118),
    [anon_sym_protected] = ACTIONS(1118),
    [anon_sym_module] = ACTIONS(1118),
    [anon_sym_any] = ACTIONS(1118),
    [anon_sym_number] = ACTIONS(1118),
    [anon_sym_boolean] = ACTIONS(1118),
    [anon_sym_string] = ACTIONS(1118),
    [anon_sym_symbol] = ACTIONS(1118),
    [anon_sym_interface] = ACTIONS(1118),
    [anon_sym_enum] = ACTIONS(1118),
    [sym_readonly] = ACTIONS(1118),
    [sym__automatic_semicolon] = ACTIONS(1116),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1120),
    [sym_identifier] = ACTIONS(1122),
    [anon_sym_export] = ACTIONS(1122),
    [anon_sym_STAR] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1122),
    [anon_sym_as] = ACTIONS(1124),
    [anon_sym_namespace] = ACTIONS(1122),
    [anon_sym_LBRACE] = ACTIONS(1120),
    [anon_sym_COMMA] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [anon_sym_type] = ACTIONS(1122),
    [anon_sym_typeof] = ACTIONS(1122),
    [anon_sym_import] = ACTIONS(1122),
    [anon_sym_var] = ACTIONS(1122),
    [anon_sym_let] = ACTIONS(1122),
    [anon_sym_const] = ACTIONS(1122),
    [anon_sym_if] = ACTIONS(1122),
    [anon_sym_else] = ACTIONS(1122),
    [anon_sym_switch] = ACTIONS(1122),
    [anon_sym_for] = ACTIONS(1122),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [anon_sym_await] = ACTIONS(1122),
    [anon_sym_in] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(1122),
    [anon_sym_try] = ACTIONS(1122),
    [anon_sym_with] = ACTIONS(1122),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_continue] = ACTIONS(1122),
    [anon_sym_debugger] = ACTIONS(1122),
    [anon_sym_return] = ACTIONS(1122),
    [anon_sym_throw] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1120),
    [anon_sym_case] = ACTIONS(1122),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [anon_sym_LT] = ACTIONS(1122),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_SLASH] = ACTIONS(1122),
    [anon_sym_DOT] = ACTIONS(1124),
    [anon_sym_class] = ACTIONS(1122),
    [anon_sym_async] = ACTIONS(1122),
    [anon_sym_function] = ACTIONS(1122),
    [anon_sym_new] = ACTIONS(1122),
    [anon_sym_QMARK] = ACTIONS(1124),
    [anon_sym_AMP_AMP] = ACTIONS(1126),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_GT_GT_GT] = ACTIONS(1126),
    [anon_sym_LT_LT] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1124),
    [anon_sym_CARET] = ACTIONS(1126),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1122),
    [anon_sym_PERCENT] = ACTIONS(1126),
    [anon_sym_STAR_STAR] = ACTIONS(1126),
    [anon_sym_LT_EQ] = ACTIONS(1126),
    [anon_sym_EQ_EQ] = ACTIONS(1124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1126),
    [anon_sym_BANG_EQ] = ACTIONS(1124),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1126),
    [anon_sym_GT_EQ] = ACTIONS(1126),
    [anon_sym_QMARK_QMARK] = ACTIONS(1126),
    [anon_sym_instanceof] = ACTIONS(1124),
    [anon_sym_BANG] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1122),
    [anon_sym_delete] = ACTIONS(1122),
    [anon_sym_PLUS_PLUS] = ACTIONS(1120),
    [anon_sym_DASH_DASH] = ACTIONS(1120),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [anon_sym_SQUOTE] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1120),
    [sym_number] = ACTIONS(1120),
    [sym_this] = ACTIONS(1122),
    [sym_super] = ACTIONS(1122),
    [sym_true] = ACTIONS(1122),
    [sym_false] = ACTIONS(1122),
    [sym_null] = ACTIONS(1122),
    [sym_undefined] = ACTIONS(1122),
    [anon_sym_AT] = ACTIONS(1120),
    [anon_sym_static] = ACTIONS(1122),
    [anon_sym_abstract] = ACTIONS(1122),
    [anon_sym_get] = ACTIONS(1122),
    [anon_sym_set] = ACTIONS(1122),
    [anon_sym_declare] = ACTIONS(1122),
    [anon_sym_public] = ACTIONS(1122),
    [anon_sym_private] = ACTIONS(1122),
    [anon_sym_protected] = ACTIONS(1122),
    [anon_sym_module] = ACTIONS(1122),
    [anon_sym_any] = ACTIONS(1122),
    [anon_sym_number] = ACTIONS(1122),
    [anon_sym_boolean] = ACTIONS(1122),
    [anon_sym_string] = ACTIONS(1122),
    [anon_sym_symbol] = ACTIONS(1122),
    [anon_sym_interface] = ACTIONS(1122),
    [anon_sym_enum] = ACTIONS(1122),
    [sym_readonly] = ACTIONS(1122),
    [sym__automatic_semicolon] = ACTIONS(1126),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1128),
    [sym_identifier] = ACTIONS(1130),
    [anon_sym_export] = ACTIONS(1130),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_default] = ACTIONS(1130),
    [anon_sym_as] = ACTIONS(1132),
    [anon_sym_namespace] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1128),
    [anon_sym_COMMA] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1130),
    [anon_sym_import] = ACTIONS(1130),
    [anon_sym_var] = ACTIONS(1130),
    [anon_sym_let] = ACTIONS(1130),
    [anon_sym_const] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1130),
    [anon_sym_else] = ACTIONS(1130),
    [anon_sym_switch] = ACTIONS(1130),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_LPAREN] = ACTIONS(1128),
    [anon_sym_await] = ACTIONS(1130),
    [anon_sym_in] = ACTIONS(1132),
    [anon_sym_while] = ACTIONS(1130),
    [anon_sym_do] = ACTIONS(1130),
    [anon_sym_try] = ACTIONS(1130),
    [anon_sym_with] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_debugger] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_throw] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1128),
    [anon_sym_case] = ACTIONS(1130),
    [anon_sym_yield] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(1130),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_SLASH] = ACTIONS(1130),
    [anon_sym_DOT] = ACTIONS(1132),
    [anon_sym_class] = ACTIONS(1130),
    [anon_sym_async] = ACTIONS(1130),
    [anon_sym_function] = ACTIONS(1130),
    [anon_sym_new] = ACTIONS(1130),
    [anon_sym_QMARK] = ACTIONS(1132),
    [anon_sym_AMP_AMP] = ACTIONS(1134),
    [anon_sym_PIPE_PIPE] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(1132),
    [anon_sym_GT_GT_GT] = ACTIONS(1134),
    [anon_sym_LT_LT] = ACTIONS(1134),
    [anon_sym_AMP] = ACTIONS(1132),
    [anon_sym_CARET] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1130),
    [anon_sym_PERCENT] = ACTIONS(1134),
    [anon_sym_STAR_STAR] = ACTIONS(1134),
    [anon_sym_LT_EQ] = ACTIONS(1134),
    [anon_sym_EQ_EQ] = ACTIONS(1132),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(1132),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1134),
    [anon_sym_GT_EQ] = ACTIONS(1134),
    [anon_sym_QMARK_QMARK] = ACTIONS(1134),
    [anon_sym_instanceof] = ACTIONS(1132),
    [anon_sym_BANG] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1128),
    [anon_sym_void] = ACTIONS(1130),
    [anon_sym_delete] = ACTIONS(1130),
    [anon_sym_PLUS_PLUS] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1128),
    [anon_sym_DQUOTE] = ACTIONS(1128),
    [anon_sym_SQUOTE] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1128),
    [sym_number] = ACTIONS(1128),
    [sym_this] = ACTIONS(1130),
    [sym_super] = ACTIONS(1130),
    [sym_true] = ACTIONS(1130),
    [sym_false] = ACTIONS(1130),
    [sym_null] = ACTIONS(1130),
    [sym_undefined] = ACTIONS(1130),
    [anon_sym_AT] = ACTIONS(1128),
    [anon_sym_static] = ACTIONS(1130),
    [anon_sym_abstract] = ACTIONS(1130),
    [anon_sym_get] = ACTIONS(1130),
    [anon_sym_set] = ACTIONS(1130),
    [anon_sym_declare] = ACTIONS(1130),
    [anon_sym_public] = ACTIONS(1130),
    [anon_sym_private] = ACTIONS(1130),
    [anon_sym_protected] = ACTIONS(1130),
    [anon_sym_module] = ACTIONS(1130),
    [anon_sym_any] = ACTIONS(1130),
    [anon_sym_number] = ACTIONS(1130),
    [anon_sym_boolean] = ACTIONS(1130),
    [anon_sym_string] = ACTIONS(1130),
    [anon_sym_symbol] = ACTIONS(1130),
    [anon_sym_interface] = ACTIONS(1130),
    [anon_sym_enum] = ACTIONS(1130),
    [sym_readonly] = ACTIONS(1130),
    [sym__automatic_semicolon] = ACTIONS(1136),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_as] = ACTIONS(1140),
    [anon_sym_namespace] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_import] = ACTIONS(1140),
    [anon_sym_var] = ACTIONS(1140),
    [anon_sym_let] = ACTIONS(1140),
    [anon_sym_const] = ACTIONS(1140),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_await] = ACTIONS(1140),
    [anon_sym_in] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(1140),
    [anon_sym_do] = ACTIONS(1140),
    [anon_sym_try] = ACTIONS(1140),
    [anon_sym_with] = ACTIONS(1140),
    [anon_sym_break] = ACTIONS(1140),
    [anon_sym_continue] = ACTIONS(1140),
    [anon_sym_debugger] = ACTIONS(1140),
    [anon_sym_return] = ACTIONS(1140),
    [anon_sym_throw] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_yield] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_DOT] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1140),
    [anon_sym_async] = ACTIONS(1140),
    [anon_sym_function] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1140),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_AMP_AMP] = ACTIONS(1138),
    [anon_sym_PIPE_PIPE] = ACTIONS(1138),
    [anon_sym_GT_GT] = ACTIONS(1140),
    [anon_sym_GT_GT_GT] = ACTIONS(1138),
    [anon_sym_LT_LT] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1140),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_PIPE] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_PERCENT] = ACTIONS(1138),
    [anon_sym_STAR_STAR] = ACTIONS(1138),
    [anon_sym_LT_EQ] = ACTIONS(1138),
    [anon_sym_EQ_EQ] = ACTIONS(1140),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1138),
    [anon_sym_BANG_EQ] = ACTIONS(1140),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1138),
    [anon_sym_GT_EQ] = ACTIONS(1138),
    [anon_sym_QMARK_QMARK] = ACTIONS(1138),
    [anon_sym_instanceof] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_void] = ACTIONS(1140),
    [anon_sym_delete] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [sym_number] = ACTIONS(1138),
    [sym_this] = ACTIONS(1140),
    [sym_super] = ACTIONS(1140),
    [sym_true] = ACTIONS(1140),
    [sym_false] = ACTIONS(1140),
    [sym_null] = ACTIONS(1140),
    [sym_undefined] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_static] = ACTIONS(1140),
    [anon_sym_abstract] = ACTIONS(1140),
    [anon_sym_get] = ACTIONS(1140),
    [anon_sym_set] = ACTIONS(1140),
    [anon_sym_declare] = ACTIONS(1140),
    [anon_sym_public] = ACTIONS(1140),
    [anon_sym_private] = ACTIONS(1140),
    [anon_sym_protected] = ACTIONS(1140),
    [anon_sym_module] = ACTIONS(1140),
    [anon_sym_any] = ACTIONS(1140),
    [anon_sym_number] = ACTIONS(1140),
    [anon_sym_boolean] = ACTIONS(1140),
    [anon_sym_string] = ACTIONS(1140),
    [anon_sym_symbol] = ACTIONS(1140),
    [anon_sym_interface] = ACTIONS(1140),
    [anon_sym_enum] = ACTIONS(1140),
    [sym_readonly] = ACTIONS(1140),
    [sym__automatic_semicolon] = ACTIONS(1138),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(1144),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_default] = ACTIONS(1144),
    [anon_sym_as] = ACTIONS(1144),
    [anon_sym_namespace] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_var] = ACTIONS(1144),
    [anon_sym_let] = ACTIONS(1144),
    [anon_sym_const] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_switch] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_await] = ACTIONS(1144),
    [anon_sym_in] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_do] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_debugger] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_GT] = ACTIONS(1144),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_DOT] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_function] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_QMARK] = ACTIONS(1144),
    [anon_sym_AMP_AMP] = ACTIONS(1142),
    [anon_sym_PIPE_PIPE] = ACTIONS(1142),
    [anon_sym_GT_GT] = ACTIONS(1144),
    [anon_sym_GT_GT_GT] = ACTIONS(1142),
    [anon_sym_LT_LT] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_CARET] = ACTIONS(1142),
    [anon_sym_PIPE] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_PERCENT] = ACTIONS(1142),
    [anon_sym_STAR_STAR] = ACTIONS(1142),
    [anon_sym_LT_EQ] = ACTIONS(1142),
    [anon_sym_EQ_EQ] = ACTIONS(1144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1142),
    [anon_sym_BANG_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1142),
    [anon_sym_GT_EQ] = ACTIONS(1142),
    [anon_sym_QMARK_QMARK] = ACTIONS(1142),
    [anon_sym_instanceof] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [sym_number] = ACTIONS(1142),
    [sym_this] = ACTIONS(1144),
    [sym_super] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_null] = ACTIONS(1144),
    [sym_undefined] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_get] = ACTIONS(1144),
    [anon_sym_set] = ACTIONS(1144),
    [anon_sym_declare] = ACTIONS(1144),
    [anon_sym_public] = ACTIONS(1144),
    [anon_sym_private] = ACTIONS(1144),
    [anon_sym_protected] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [anon_sym_any] = ACTIONS(1144),
    [anon_sym_number] = ACTIONS(1144),
    [anon_sym_boolean] = ACTIONS(1144),
    [anon_sym_string] = ACTIONS(1144),
    [anon_sym_symbol] = ACTIONS(1144),
    [anon_sym_interface] = ACTIONS(1144),
    [anon_sym_enum] = ACTIONS(1144),
    [sym_readonly] = ACTIONS(1144),
    [sym__automatic_semicolon] = ACTIONS(1146),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(1144),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_default] = ACTIONS(1144),
    [anon_sym_as] = ACTIONS(1144),
    [anon_sym_namespace] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_var] = ACTIONS(1144),
    [anon_sym_let] = ACTIONS(1144),
    [anon_sym_const] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_switch] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_await] = ACTIONS(1144),
    [anon_sym_in] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_do] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_debugger] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_GT] = ACTIONS(1144),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_DOT] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_function] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_QMARK] = ACTIONS(1144),
    [anon_sym_AMP_AMP] = ACTIONS(1142),
    [anon_sym_PIPE_PIPE] = ACTIONS(1142),
    [anon_sym_GT_GT] = ACTIONS(1144),
    [anon_sym_GT_GT_GT] = ACTIONS(1142),
    [anon_sym_LT_LT] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_CARET] = ACTIONS(1142),
    [anon_sym_PIPE] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_PERCENT] = ACTIONS(1142),
    [anon_sym_STAR_STAR] = ACTIONS(1142),
    [anon_sym_LT_EQ] = ACTIONS(1142),
    [anon_sym_EQ_EQ] = ACTIONS(1144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1142),
    [anon_sym_BANG_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1142),
    [anon_sym_GT_EQ] = ACTIONS(1142),
    [anon_sym_QMARK_QMARK] = ACTIONS(1142),
    [anon_sym_instanceof] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [sym_number] = ACTIONS(1142),
    [sym_this] = ACTIONS(1144),
    [sym_super] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_null] = ACTIONS(1144),
    [sym_undefined] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_get] = ACTIONS(1144),
    [anon_sym_set] = ACTIONS(1144),
    [anon_sym_declare] = ACTIONS(1144),
    [anon_sym_public] = ACTIONS(1144),
    [anon_sym_private] = ACTIONS(1144),
    [anon_sym_protected] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [anon_sym_any] = ACTIONS(1144),
    [anon_sym_number] = ACTIONS(1144),
    [anon_sym_boolean] = ACTIONS(1144),
    [anon_sym_string] = ACTIONS(1144),
    [anon_sym_symbol] = ACTIONS(1144),
    [anon_sym_interface] = ACTIONS(1144),
    [anon_sym_enum] = ACTIONS(1144),
    [sym_readonly] = ACTIONS(1144),
    [sym__automatic_semicolon] = ACTIONS(1142),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1148),
    [sym_identifier] = ACTIONS(1150),
    [anon_sym_export] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1152),
    [anon_sym_default] = ACTIONS(1150),
    [anon_sym_as] = ACTIONS(1152),
    [anon_sym_namespace] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1148),
    [anon_sym_COMMA] = ACTIONS(1154),
    [anon_sym_RBRACE] = ACTIONS(1148),
    [anon_sym_type] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(1150),
    [anon_sym_import] = ACTIONS(1150),
    [anon_sym_var] = ACTIONS(1150),
    [anon_sym_let] = ACTIONS(1150),
    [anon_sym_const] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(1150),
    [anon_sym_else] = ACTIONS(1150),
    [anon_sym_switch] = ACTIONS(1150),
    [anon_sym_for] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [anon_sym_await] = ACTIONS(1150),
    [anon_sym_in] = ACTIONS(1152),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_do] = ACTIONS(1150),
    [anon_sym_try] = ACTIONS(1150),
    [anon_sym_with] = ACTIONS(1150),
    [anon_sym_break] = ACTIONS(1150),
    [anon_sym_continue] = ACTIONS(1150),
    [anon_sym_debugger] = ACTIONS(1150),
    [anon_sym_return] = ACTIONS(1150),
    [anon_sym_throw] = ACTIONS(1150),
    [anon_sym_SEMI] = ACTIONS(1148),
    [anon_sym_case] = ACTIONS(1150),
    [anon_sym_yield] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1150),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_DOT] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(1150),
    [anon_sym_async] = ACTIONS(1150),
    [anon_sym_function] = ACTIONS(1150),
    [anon_sym_new] = ACTIONS(1150),
    [anon_sym_QMARK] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1154),
    [anon_sym_PIPE_PIPE] = ACTIONS(1154),
    [anon_sym_GT_GT] = ACTIONS(1152),
    [anon_sym_GT_GT_GT] = ACTIONS(1154),
    [anon_sym_LT_LT] = ACTIONS(1154),
    [anon_sym_AMP] = ACTIONS(1152),
    [anon_sym_CARET] = ACTIONS(1154),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_PERCENT] = ACTIONS(1154),
    [anon_sym_STAR_STAR] = ACTIONS(1154),
    [anon_sym_LT_EQ] = ACTIONS(1154),
    [anon_sym_EQ_EQ] = ACTIONS(1152),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1152),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1154),
    [anon_sym_GT_EQ] = ACTIONS(1154),
    [anon_sym_QMARK_QMARK] = ACTIONS(1154),
    [anon_sym_instanceof] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1150),
    [anon_sym_TILDE] = ACTIONS(1148),
    [anon_sym_void] = ACTIONS(1150),
    [anon_sym_delete] = ACTIONS(1150),
    [anon_sym_PLUS_PLUS] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1148),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_SQUOTE] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1148),
    [sym_number] = ACTIONS(1148),
    [sym_this] = ACTIONS(1150),
    [sym_super] = ACTIONS(1150),
    [sym_true] = ACTIONS(1150),
    [sym_false] = ACTIONS(1150),
    [sym_null] = ACTIONS(1150),
    [sym_undefined] = ACTIONS(1150),
    [anon_sym_AT] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1150),
    [anon_sym_abstract] = ACTIONS(1150),
    [anon_sym_get] = ACTIONS(1150),
    [anon_sym_set] = ACTIONS(1150),
    [anon_sym_declare] = ACTIONS(1150),
    [anon_sym_public] = ACTIONS(1150),
    [anon_sym_private] = ACTIONS(1150),
    [anon_sym_protected] = ACTIONS(1150),
    [anon_sym_module] = ACTIONS(1150),
    [anon_sym_any] = ACTIONS(1150),
    [anon_sym_number] = ACTIONS(1150),
    [anon_sym_boolean] = ACTIONS(1150),
    [anon_sym_string] = ACTIONS(1150),
    [anon_sym_symbol] = ACTIONS(1150),
    [anon_sym_interface] = ACTIONS(1150),
    [anon_sym_enum] = ACTIONS(1150),
    [sym_readonly] = ACTIONS(1150),
    [sym__automatic_semicolon] = ACTIONS(1156),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_export] = ACTIONS(1160),
    [anon_sym_STAR] = ACTIONS(1160),
    [anon_sym_default] = ACTIONS(1160),
    [anon_sym_as] = ACTIONS(1160),
    [anon_sym_namespace] = ACTIONS(1160),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1160),
    [anon_sym_typeof] = ACTIONS(1160),
    [anon_sym_import] = ACTIONS(1160),
    [anon_sym_var] = ACTIONS(1160),
    [anon_sym_let] = ACTIONS(1160),
    [anon_sym_const] = ACTIONS(1160),
    [anon_sym_if] = ACTIONS(1160),
    [anon_sym_else] = ACTIONS(1160),
    [anon_sym_switch] = ACTIONS(1160),
    [anon_sym_for] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [anon_sym_await] = ACTIONS(1160),
    [anon_sym_in] = ACTIONS(1160),
    [anon_sym_while] = ACTIONS(1160),
    [anon_sym_do] = ACTIONS(1160),
    [anon_sym_try] = ACTIONS(1160),
    [anon_sym_with] = ACTIONS(1160),
    [anon_sym_break] = ACTIONS(1160),
    [anon_sym_continue] = ACTIONS(1160),
    [anon_sym_debugger] = ACTIONS(1160),
    [anon_sym_return] = ACTIONS(1160),
    [anon_sym_throw] = ACTIONS(1160),
    [anon_sym_SEMI] = ACTIONS(1158),
    [anon_sym_case] = ACTIONS(1160),
    [anon_sym_yield] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_LT] = ACTIONS(1160),
    [anon_sym_GT] = ACTIONS(1160),
    [anon_sym_SLASH] = ACTIONS(1160),
    [anon_sym_DOT] = ACTIONS(1160),
    [anon_sym_class] = ACTIONS(1160),
    [anon_sym_async] = ACTIONS(1160),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_QMARK] = ACTIONS(1160),
    [anon_sym_AMP_AMP] = ACTIONS(1158),
    [anon_sym_PIPE_PIPE] = ACTIONS(1158),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_GT_GT_GT] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(1160),
    [anon_sym_CARET] = ACTIONS(1158),
    [anon_sym_PIPE] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_PERCENT] = ACTIONS(1158),
    [anon_sym_STAR_STAR] = ACTIONS(1158),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_EQ_EQ] = ACTIONS(1160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1158),
    [anon_sym_BANG_EQ] = ACTIONS(1160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_QMARK_QMARK] = ACTIONS(1158),
    [anon_sym_instanceof] = ACTIONS(1160),
    [anon_sym_BANG] = ACTIONS(1160),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_void] = ACTIONS(1160),
    [anon_sym_delete] = ACTIONS(1160),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_DQUOTE] = ACTIONS(1158),
    [anon_sym_SQUOTE] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1158),
    [sym_this] = ACTIONS(1160),
    [sym_super] = ACTIONS(1160),
    [sym_true] = ACTIONS(1160),
    [sym_false] = ACTIONS(1160),
    [sym_null] = ACTIONS(1160),
    [sym_undefined] = ACTIONS(1160),
    [anon_sym_AT] = ACTIONS(1158),
    [anon_sym_static] = ACTIONS(1160),
    [anon_sym_abstract] = ACTIONS(1160),
    [anon_sym_get] = ACTIONS(1160),
    [anon_sym_set] = ACTIONS(1160),
    [anon_sym_declare] = ACTIONS(1160),
    [anon_sym_public] = ACTIONS(1160),
    [anon_sym_private] = ACTIONS(1160),
    [anon_sym_protected] = ACTIONS(1160),
    [anon_sym_module] = ACTIONS(1160),
    [anon_sym_any] = ACTIONS(1160),
    [anon_sym_number] = ACTIONS(1160),
    [anon_sym_boolean] = ACTIONS(1160),
    [anon_sym_string] = ACTIONS(1160),
    [anon_sym_symbol] = ACTIONS(1160),
    [anon_sym_interface] = ACTIONS(1160),
    [anon_sym_enum] = ACTIONS(1160),
    [sym_readonly] = ACTIONS(1160),
    [sym__automatic_semicolon] = ACTIONS(1158),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1164),
    [anon_sym_default] = ACTIONS(1164),
    [anon_sym_as] = ACTIONS(1164),
    [anon_sym_namespace] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1164),
    [anon_sym_typeof] = ACTIONS(1164),
    [anon_sym_import] = ACTIONS(1164),
    [anon_sym_var] = ACTIONS(1164),
    [anon_sym_let] = ACTIONS(1164),
    [anon_sym_const] = ACTIONS(1164),
    [anon_sym_if] = ACTIONS(1164),
    [anon_sym_else] = ACTIONS(1164),
    [anon_sym_switch] = ACTIONS(1164),
    [anon_sym_for] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_await] = ACTIONS(1164),
    [anon_sym_in] = ACTIONS(1164),
    [anon_sym_while] = ACTIONS(1164),
    [anon_sym_do] = ACTIONS(1164),
    [anon_sym_try] = ACTIONS(1164),
    [anon_sym_with] = ACTIONS(1164),
    [anon_sym_break] = ACTIONS(1164),
    [anon_sym_continue] = ACTIONS(1164),
    [anon_sym_debugger] = ACTIONS(1164),
    [anon_sym_return] = ACTIONS(1164),
    [anon_sym_throw] = ACTIONS(1164),
    [anon_sym_SEMI] = ACTIONS(1162),
    [anon_sym_case] = ACTIONS(1164),
    [anon_sym_yield] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_LT] = ACTIONS(1164),
    [anon_sym_GT] = ACTIONS(1164),
    [anon_sym_SLASH] = ACTIONS(1164),
    [anon_sym_DOT] = ACTIONS(1164),
    [anon_sym_class] = ACTIONS(1164),
    [anon_sym_async] = ACTIONS(1164),
    [anon_sym_function] = ACTIONS(1164),
    [anon_sym_new] = ACTIONS(1164),
    [anon_sym_QMARK] = ACTIONS(1164),
    [anon_sym_AMP_AMP] = ACTIONS(1162),
    [anon_sym_PIPE_PIPE] = ACTIONS(1162),
    [anon_sym_GT_GT] = ACTIONS(1164),
    [anon_sym_GT_GT_GT] = ACTIONS(1162),
    [anon_sym_LT_LT] = ACTIONS(1162),
    [anon_sym_AMP] = ACTIONS(1164),
    [anon_sym_CARET] = ACTIONS(1162),
    [anon_sym_PIPE] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_PERCENT] = ACTIONS(1162),
    [anon_sym_STAR_STAR] = ACTIONS(1162),
    [anon_sym_LT_EQ] = ACTIONS(1162),
    [anon_sym_EQ_EQ] = ACTIONS(1164),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1162),
    [anon_sym_BANG_EQ] = ACTIONS(1164),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1162),
    [anon_sym_GT_EQ] = ACTIONS(1162),
    [anon_sym_QMARK_QMARK] = ACTIONS(1162),
    [anon_sym_instanceof] = ACTIONS(1164),
    [anon_sym_BANG] = ACTIONS(1164),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_void] = ACTIONS(1164),
    [anon_sym_delete] = ACTIONS(1164),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [sym_number] = ACTIONS(1162),
    [sym_this] = ACTIONS(1164),
    [sym_super] = ACTIONS(1164),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1162),
    [anon_sym_static] = ACTIONS(1164),
    [anon_sym_abstract] = ACTIONS(1164),
    [anon_sym_get] = ACTIONS(1164),
    [anon_sym_set] = ACTIONS(1164),
    [anon_sym_declare] = ACTIONS(1164),
    [anon_sym_public] = ACTIONS(1164),
    [anon_sym_private] = ACTIONS(1164),
    [anon_sym_protected] = ACTIONS(1164),
    [anon_sym_module] = ACTIONS(1164),
    [anon_sym_any] = ACTIONS(1164),
    [anon_sym_number] = ACTIONS(1164),
    [anon_sym_boolean] = ACTIONS(1164),
    [anon_sym_string] = ACTIONS(1164),
    [anon_sym_symbol] = ACTIONS(1164),
    [anon_sym_interface] = ACTIONS(1164),
    [anon_sym_enum] = ACTIONS(1164),
    [sym_readonly] = ACTIONS(1164),
    [sym__automatic_semicolon] = ACTIONS(1162),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_identifier] = ACTIONS(1168),
    [anon_sym_export] = ACTIONS(1168),
    [anon_sym_STAR] = ACTIONS(1170),
    [anon_sym_default] = ACTIONS(1168),
    [anon_sym_as] = ACTIONS(1170),
    [anon_sym_namespace] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_COMMA] = ACTIONS(1172),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(1168),
    [anon_sym_import] = ACTIONS(1168),
    [anon_sym_var] = ACTIONS(1168),
    [anon_sym_let] = ACTIONS(1168),
    [anon_sym_const] = ACTIONS(1168),
    [anon_sym_if] = ACTIONS(1168),
    [anon_sym_else] = ACTIONS(1168),
    [anon_sym_switch] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [anon_sym_await] = ACTIONS(1168),
    [anon_sym_in] = ACTIONS(1170),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_try] = ACTIONS(1168),
    [anon_sym_with] = ACTIONS(1168),
    [anon_sym_break] = ACTIONS(1168),
    [anon_sym_continue] = ACTIONS(1168),
    [anon_sym_debugger] = ACTIONS(1168),
    [anon_sym_return] = ACTIONS(1168),
    [anon_sym_throw] = ACTIONS(1168),
    [anon_sym_SEMI] = ACTIONS(1166),
    [anon_sym_case] = ACTIONS(1168),
    [anon_sym_yield] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(1168),
    [anon_sym_GT] = ACTIONS(1170),
    [anon_sym_SLASH] = ACTIONS(1168),
    [anon_sym_DOT] = ACTIONS(1170),
    [anon_sym_class] = ACTIONS(1168),
    [anon_sym_async] = ACTIONS(1168),
    [anon_sym_function] = ACTIONS(1168),
    [anon_sym_new] = ACTIONS(1168),
    [anon_sym_QMARK] = ACTIONS(1170),
    [anon_sym_AMP_AMP] = ACTIONS(1172),
    [anon_sym_PIPE_PIPE] = ACTIONS(1172),
    [anon_sym_GT_GT] = ACTIONS(1170),
    [anon_sym_GT_GT_GT] = ACTIONS(1172),
    [anon_sym_LT_LT] = ACTIONS(1172),
    [anon_sym_AMP] = ACTIONS(1170),
    [anon_sym_CARET] = ACTIONS(1172),
    [anon_sym_PIPE] = ACTIONS(1170),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_PERCENT] = ACTIONS(1172),
    [anon_sym_STAR_STAR] = ACTIONS(1172),
    [anon_sym_LT_EQ] = ACTIONS(1172),
    [anon_sym_EQ_EQ] = ACTIONS(1170),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1172),
    [anon_sym_BANG_EQ] = ACTIONS(1170),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1172),
    [anon_sym_GT_EQ] = ACTIONS(1172),
    [anon_sym_QMARK_QMARK] = ACTIONS(1172),
    [anon_sym_instanceof] = ACTIONS(1170),
    [anon_sym_BANG] = ACTIONS(1168),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_void] = ACTIONS(1168),
    [anon_sym_delete] = ACTIONS(1168),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [sym_number] = ACTIONS(1166),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(1168),
    [sym_true] = ACTIONS(1168),
    [sym_false] = ACTIONS(1168),
    [sym_null] = ACTIONS(1168),
    [sym_undefined] = ACTIONS(1168),
    [anon_sym_AT] = ACTIONS(1166),
    [anon_sym_static] = ACTIONS(1168),
    [anon_sym_abstract] = ACTIONS(1168),
    [anon_sym_get] = ACTIONS(1168),
    [anon_sym_set] = ACTIONS(1168),
    [anon_sym_declare] = ACTIONS(1168),
    [anon_sym_public] = ACTIONS(1168),
    [anon_sym_private] = ACTIONS(1168),
    [anon_sym_protected] = ACTIONS(1168),
    [anon_sym_module] = ACTIONS(1168),
    [anon_sym_any] = ACTIONS(1168),
    [anon_sym_number] = ACTIONS(1168),
    [anon_sym_boolean] = ACTIONS(1168),
    [anon_sym_string] = ACTIONS(1168),
    [anon_sym_symbol] = ACTIONS(1168),
    [anon_sym_interface] = ACTIONS(1168),
    [anon_sym_enum] = ACTIONS(1168),
    [sym_readonly] = ACTIONS(1168),
    [sym__automatic_semicolon] = ACTIONS(1174),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1176),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_export] = ACTIONS(1178),
    [anon_sym_STAR] = ACTIONS(1180),
    [anon_sym_default] = ACTIONS(1178),
    [anon_sym_as] = ACTIONS(1180),
    [anon_sym_namespace] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_COMMA] = ACTIONS(1182),
    [anon_sym_RBRACE] = ACTIONS(1176),
    [anon_sym_type] = ACTIONS(1178),
    [anon_sym_typeof] = ACTIONS(1178),
    [anon_sym_import] = ACTIONS(1178),
    [anon_sym_var] = ACTIONS(1178),
    [anon_sym_let] = ACTIONS(1178),
    [anon_sym_const] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_else] = ACTIONS(1178),
    [anon_sym_switch] = ACTIONS(1178),
    [anon_sym_for] = ACTIONS(1178),
    [anon_sym_LPAREN] = ACTIONS(1176),
    [anon_sym_await] = ACTIONS(1178),
    [anon_sym_in] = ACTIONS(1180),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_do] = ACTIONS(1178),
    [anon_sym_try] = ACTIONS(1178),
    [anon_sym_with] = ACTIONS(1178),
    [anon_sym_break] = ACTIONS(1178),
    [anon_sym_continue] = ACTIONS(1178),
    [anon_sym_debugger] = ACTIONS(1178),
    [anon_sym_return] = ACTIONS(1178),
    [anon_sym_throw] = ACTIONS(1178),
    [anon_sym_SEMI] = ACTIONS(1176),
    [anon_sym_case] = ACTIONS(1178),
    [anon_sym_yield] = ACTIONS(1178),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_LT] = ACTIONS(1178),
    [anon_sym_GT] = ACTIONS(1180),
    [anon_sym_SLASH] = ACTIONS(1178),
    [anon_sym_DOT] = ACTIONS(1180),
    [anon_sym_class] = ACTIONS(1178),
    [anon_sym_async] = ACTIONS(1178),
    [anon_sym_function] = ACTIONS(1178),
    [anon_sym_new] = ACTIONS(1178),
    [anon_sym_QMARK] = ACTIONS(1180),
    [anon_sym_AMP_AMP] = ACTIONS(1182),
    [anon_sym_PIPE_PIPE] = ACTIONS(1182),
    [anon_sym_GT_GT] = ACTIONS(1180),
    [anon_sym_GT_GT_GT] = ACTIONS(1182),
    [anon_sym_LT_LT] = ACTIONS(1182),
    [anon_sym_AMP] = ACTIONS(1180),
    [anon_sym_CARET] = ACTIONS(1182),
    [anon_sym_PIPE] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1178),
    [anon_sym_DASH] = ACTIONS(1178),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1182),
    [anon_sym_LT_EQ] = ACTIONS(1182),
    [anon_sym_EQ_EQ] = ACTIONS(1180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1182),
    [anon_sym_BANG_EQ] = ACTIONS(1180),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1182),
    [anon_sym_GT_EQ] = ACTIONS(1182),
    [anon_sym_QMARK_QMARK] = ACTIONS(1182),
    [anon_sym_instanceof] = ACTIONS(1180),
    [anon_sym_BANG] = ACTIONS(1178),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_void] = ACTIONS(1178),
    [anon_sym_delete] = ACTIONS(1178),
    [anon_sym_PLUS_PLUS] = ACTIONS(1176),
    [anon_sym_DASH_DASH] = ACTIONS(1176),
    [anon_sym_DQUOTE] = ACTIONS(1176),
    [anon_sym_SQUOTE] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1176),
    [sym_number] = ACTIONS(1176),
    [sym_this] = ACTIONS(1178),
    [sym_super] = ACTIONS(1178),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_null] = ACTIONS(1178),
    [sym_undefined] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_static] = ACTIONS(1178),
    [anon_sym_abstract] = ACTIONS(1178),
    [anon_sym_get] = ACTIONS(1178),
    [anon_sym_set] = ACTIONS(1178),
    [anon_sym_declare] = ACTIONS(1178),
    [anon_sym_public] = ACTIONS(1178),
    [anon_sym_private] = ACTIONS(1178),
    [anon_sym_protected] = ACTIONS(1178),
    [anon_sym_module] = ACTIONS(1178),
    [anon_sym_any] = ACTIONS(1178),
    [anon_sym_number] = ACTIONS(1178),
    [anon_sym_boolean] = ACTIONS(1178),
    [anon_sym_string] = ACTIONS(1178),
    [anon_sym_symbol] = ACTIONS(1178),
    [anon_sym_interface] = ACTIONS(1178),
    [anon_sym_enum] = ACTIONS(1178),
    [sym_readonly] = ACTIONS(1178),
    [sym__automatic_semicolon] = ACTIONS(1184),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1186),
    [sym_identifier] = ACTIONS(1188),
    [anon_sym_export] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_default] = ACTIONS(1188),
    [anon_sym_as] = ACTIONS(1190),
    [anon_sym_namespace] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [anon_sym_type] = ACTIONS(1188),
    [anon_sym_typeof] = ACTIONS(1188),
    [anon_sym_import] = ACTIONS(1188),
    [anon_sym_var] = ACTIONS(1188),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_if] = ACTIONS(1188),
    [anon_sym_else] = ACTIONS(1188),
    [anon_sym_switch] = ACTIONS(1188),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_await] = ACTIONS(1188),
    [anon_sym_in] = ACTIONS(1190),
    [anon_sym_while] = ACTIONS(1188),
    [anon_sym_do] = ACTIONS(1188),
    [anon_sym_try] = ACTIONS(1188),
    [anon_sym_with] = ACTIONS(1188),
    [anon_sym_break] = ACTIONS(1188),
    [anon_sym_continue] = ACTIONS(1188),
    [anon_sym_debugger] = ACTIONS(1188),
    [anon_sym_return] = ACTIONS(1188),
    [anon_sym_throw] = ACTIONS(1188),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_case] = ACTIONS(1188),
    [anon_sym_yield] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1188),
    [anon_sym_GT] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1188),
    [anon_sym_DOT] = ACTIONS(1190),
    [anon_sym_class] = ACTIONS(1188),
    [anon_sym_async] = ACTIONS(1188),
    [anon_sym_function] = ACTIONS(1188),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_QMARK] = ACTIONS(1190),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_GT_GT] = ACTIONS(1190),
    [anon_sym_GT_GT_GT] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(1190),
    [anon_sym_CARET] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1190),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_PERCENT] = ACTIONS(1192),
    [anon_sym_STAR_STAR] = ACTIONS(1192),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_EQ_EQ] = ACTIONS(1190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1192),
    [anon_sym_BANG_EQ] = ACTIONS(1190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_QMARK_QMARK] = ACTIONS(1192),
    [anon_sym_instanceof] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_void] = ACTIONS(1188),
    [anon_sym_delete] = ACTIONS(1188),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [anon_sym_SQUOTE] = ACTIONS(1186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1186),
    [sym_number] = ACTIONS(1186),
    [sym_this] = ACTIONS(1188),
    [sym_super] = ACTIONS(1188),
    [sym_true] = ACTIONS(1188),
    [sym_false] = ACTIONS(1188),
    [sym_null] = ACTIONS(1188),
    [sym_undefined] = ACTIONS(1188),
    [anon_sym_AT] = ACTIONS(1186),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_abstract] = ACTIONS(1188),
    [anon_sym_get] = ACTIONS(1188),
    [anon_sym_set] = ACTIONS(1188),
    [anon_sym_declare] = ACTIONS(1188),
    [anon_sym_public] = ACTIONS(1188),
    [anon_sym_private] = ACTIONS(1188),
    [anon_sym_protected] = ACTIONS(1188),
    [anon_sym_module] = ACTIONS(1188),
    [anon_sym_any] = ACTIONS(1188),
    [anon_sym_number] = ACTIONS(1188),
    [anon_sym_boolean] = ACTIONS(1188),
    [anon_sym_string] = ACTIONS(1188),
    [anon_sym_symbol] = ACTIONS(1188),
    [anon_sym_interface] = ACTIONS(1188),
    [anon_sym_enum] = ACTIONS(1188),
    [sym_readonly] = ACTIONS(1188),
    [sym__automatic_semicolon] = ACTIONS(1194),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1196),
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_export] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1200),
    [anon_sym_default] = ACTIONS(1198),
    [anon_sym_as] = ACTIONS(1200),
    [anon_sym_namespace] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1196),
    [anon_sym_type] = ACTIONS(1198),
    [anon_sym_typeof] = ACTIONS(1198),
    [anon_sym_import] = ACTIONS(1198),
    [anon_sym_var] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(1198),
    [anon_sym_const] = ACTIONS(1198),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_else] = ACTIONS(1198),
    [anon_sym_switch] = ACTIONS(1198),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_await] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(1200),
    [anon_sym_while] = ACTIONS(1198),
    [anon_sym_do] = ACTIONS(1198),
    [anon_sym_try] = ACTIONS(1198),
    [anon_sym_with] = ACTIONS(1198),
    [anon_sym_break] = ACTIONS(1198),
    [anon_sym_continue] = ACTIONS(1198),
    [anon_sym_debugger] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(1198),
    [anon_sym_throw] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1196),
    [anon_sym_case] = ACTIONS(1198),
    [anon_sym_yield] = ACTIONS(1198),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_GT] = ACTIONS(1200),
    [anon_sym_SLASH] = ACTIONS(1198),
    [anon_sym_DOT] = ACTIONS(1200),
    [anon_sym_class] = ACTIONS(1198),
    [anon_sym_async] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(1198),
    [anon_sym_new] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1200),
    [anon_sym_AMP_AMP] = ACTIONS(1202),
    [anon_sym_PIPE_PIPE] = ACTIONS(1202),
    [anon_sym_GT_GT] = ACTIONS(1200),
    [anon_sym_GT_GT_GT] = ACTIONS(1202),
    [anon_sym_LT_LT] = ACTIONS(1202),
    [anon_sym_AMP] = ACTIONS(1200),
    [anon_sym_CARET] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_PERCENT] = ACTIONS(1202),
    [anon_sym_STAR_STAR] = ACTIONS(1202),
    [anon_sym_LT_EQ] = ACTIONS(1202),
    [anon_sym_EQ_EQ] = ACTIONS(1200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1202),
    [anon_sym_BANG_EQ] = ACTIONS(1200),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1202),
    [anon_sym_GT_EQ] = ACTIONS(1202),
    [anon_sym_QMARK_QMARK] = ACTIONS(1202),
    [anon_sym_instanceof] = ACTIONS(1200),
    [anon_sym_BANG] = ACTIONS(1198),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_void] = ACTIONS(1198),
    [anon_sym_delete] = ACTIONS(1198),
    [anon_sym_PLUS_PLUS] = ACTIONS(1196),
    [anon_sym_DASH_DASH] = ACTIONS(1196),
    [anon_sym_DQUOTE] = ACTIONS(1196),
    [anon_sym_SQUOTE] = ACTIONS(1196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1196),
    [sym_number] = ACTIONS(1196),
    [sym_this] = ACTIONS(1198),
    [sym_super] = ACTIONS(1198),
    [sym_true] = ACTIONS(1198),
    [sym_false] = ACTIONS(1198),
    [sym_null] = ACTIONS(1198),
    [sym_undefined] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_static] = ACTIONS(1198),
    [anon_sym_abstract] = ACTIONS(1198),
    [anon_sym_get] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1198),
    [anon_sym_declare] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1198),
    [anon_sym_private] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1198),
    [anon_sym_number] = ACTIONS(1198),
    [anon_sym_boolean] = ACTIONS(1198),
    [anon_sym_string] = ACTIONS(1198),
    [anon_sym_symbol] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(1198),
    [anon_sym_enum] = ACTIONS(1198),
    [sym_readonly] = ACTIONS(1198),
    [sym__automatic_semicolon] = ACTIONS(1204),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_export] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(1210),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_as] = ACTIONS(1210),
    [anon_sym_namespace] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(1212),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_typeof] = ACTIONS(1208),
    [anon_sym_import] = ACTIONS(1208),
    [anon_sym_var] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [anon_sym_switch] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_await] = ACTIONS(1208),
    [anon_sym_in] = ACTIONS(1210),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [anon_sym_with] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_debugger] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_throw] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1206),
    [anon_sym_case] = ACTIONS(1208),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(1210),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_class] = ACTIONS(1208),
    [anon_sym_async] = ACTIONS(1208),
    [anon_sym_function] = ACTIONS(1208),
    [anon_sym_new] = ACTIONS(1208),
    [anon_sym_QMARK] = ACTIONS(1210),
    [anon_sym_AMP_AMP] = ACTIONS(1212),
    [anon_sym_PIPE_PIPE] = ACTIONS(1212),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_GT_GT_GT] = ACTIONS(1212),
    [anon_sym_LT_LT] = ACTIONS(1212),
    [anon_sym_AMP] = ACTIONS(1210),
    [anon_sym_CARET] = ACTIONS(1212),
    [anon_sym_PIPE] = ACTIONS(1210),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1212),
    [anon_sym_STAR_STAR] = ACTIONS(1212),
    [anon_sym_LT_EQ] = ACTIONS(1212),
    [anon_sym_EQ_EQ] = ACTIONS(1210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1212),
    [anon_sym_BANG_EQ] = ACTIONS(1210),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1212),
    [anon_sym_GT_EQ] = ACTIONS(1212),
    [anon_sym_QMARK_QMARK] = ACTIONS(1212),
    [anon_sym_instanceof] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1206),
    [anon_sym_void] = ACTIONS(1208),
    [anon_sym_delete] = ACTIONS(1208),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [sym_number] = ACTIONS(1206),
    [sym_this] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_true] = ACTIONS(1208),
    [sym_false] = ACTIONS(1208),
    [sym_null] = ACTIONS(1208),
    [sym_undefined] = ACTIONS(1208),
    [anon_sym_AT] = ACTIONS(1206),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_abstract] = ACTIONS(1208),
    [anon_sym_get] = ACTIONS(1208),
    [anon_sym_set] = ACTIONS(1208),
    [anon_sym_declare] = ACTIONS(1208),
    [anon_sym_public] = ACTIONS(1208),
    [anon_sym_private] = ACTIONS(1208),
    [anon_sym_protected] = ACTIONS(1208),
    [anon_sym_module] = ACTIONS(1208),
    [anon_sym_any] = ACTIONS(1208),
    [anon_sym_number] = ACTIONS(1208),
    [anon_sym_boolean] = ACTIONS(1208),
    [anon_sym_string] = ACTIONS(1208),
    [anon_sym_symbol] = ACTIONS(1208),
    [anon_sym_interface] = ACTIONS(1208),
    [anon_sym_enum] = ACTIONS(1208),
    [sym_readonly] = ACTIONS(1208),
    [sym__automatic_semicolon] = ACTIONS(1214),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(1216),
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_export] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_default] = ACTIONS(1218),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_type] = ACTIONS(1218),
    [anon_sym_typeof] = ACTIONS(1218),
    [anon_sym_import] = ACTIONS(1218),
    [anon_sym_var] = ACTIONS(1218),
    [anon_sym_let] = ACTIONS(1218),
    [anon_sym_const] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_else] = ACTIONS(1218),
    [anon_sym_switch] = ACTIONS(1218),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_await] = ACTIONS(1218),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_while] = ACTIONS(1218),
    [anon_sym_do] = ACTIONS(1218),
    [anon_sym_try] = ACTIONS(1218),
    [anon_sym_with] = ACTIONS(1218),
    [anon_sym_break] = ACTIONS(1218),
    [anon_sym_continue] = ACTIONS(1218),
    [anon_sym_debugger] = ACTIONS(1218),
    [anon_sym_return] = ACTIONS(1218),
    [anon_sym_throw] = ACTIONS(1218),
    [anon_sym_SEMI] = ACTIONS(1216),
    [anon_sym_case] = ACTIONS(1218),
    [anon_sym_yield] = ACTIONS(1218),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_LT] = ACTIONS(1218),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1218),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(1218),
    [anon_sym_async] = ACTIONS(1218),
    [anon_sym_function] = ACTIONS(1218),
    [anon_sym_new] = ACTIONS(1218),
    [anon_sym_QMARK] = ACTIONS(1218),
    [anon_sym_AMP_AMP] = ACTIONS(1216),
    [anon_sym_PIPE_PIPE] = ACTIONS(1216),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1216),
    [anon_sym_LT_LT] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_PERCENT] = ACTIONS(1216),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_LT_EQ] = ACTIONS(1216),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1216),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1216),
    [anon_sym_GT_EQ] = ACTIONS(1216),
    [anon_sym_QMARK_QMARK] = ACTIONS(1216),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1216),
    [anon_sym_void] = ACTIONS(1218),
    [anon_sym_delete] = ACTIONS(1218),
    [anon_sym_PLUS_PLUS] = ACTIONS(1216),
    [anon_sym_DASH_DASH] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(1216),
    [anon_sym_SQUOTE] = ACTIONS(1216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [sym_number] = ACTIONS(1216),
    [sym_this] = ACTIONS(1218),
    [sym_super] = ACTIONS(1218),
    [sym_true] = ACTIONS(1218),
    [sym_false] = ACTIONS(1218),
    [sym_null] = ACTIONS(1218),
    [sym_undefined] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_static] = ACTIONS(1218),
    [anon_sym_abstract] = ACTIONS(1218),
    [anon_sym_get] = ACTIONS(1218),
    [anon_sym_set] = ACTIONS(1218),
    [anon_sym_declare] = ACTIONS(1218),
    [anon_sym_public] = ACTIONS(1218),
    [anon_sym_private] = ACTIONS(1218),
    [anon_sym_protected] = ACTIONS(1218),
    [anon_sym_module] = ACTIONS(1218),
    [anon_sym_any] = ACTIONS(1218),
    [anon_sym_number] = ACTIONS(1218),
    [anon_sym_boolean] = ACTIONS(1218),
    [anon_sym_string] = ACTIONS(1218),
    [anon_sym_symbol] = ACTIONS(1218),
    [anon_sym_interface] = ACTIONS(1218),
    [anon_sym_enum] = ACTIONS(1218),
    [sym_readonly] = ACTIONS(1218),
    [sym__automatic_semicolon] = ACTIONS(1216),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(1220),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_export] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_default] = ACTIONS(1222),
    [anon_sym_as] = ACTIONS(1224),
    [anon_sym_namespace] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1226),
    [anon_sym_RBRACE] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1222),
    [anon_sym_typeof] = ACTIONS(1222),
    [anon_sym_import] = ACTIONS(1222),
    [anon_sym_var] = ACTIONS(1222),
    [anon_sym_let] = ACTIONS(1222),
    [anon_sym_const] = ACTIONS(1222),
    [anon_sym_if] = ACTIONS(1222),
    [anon_sym_else] = ACTIONS(1222),
    [anon_sym_switch] = ACTIONS(1222),
    [anon_sym_for] = ACTIONS(1222),
    [anon_sym_LPAREN] = ACTIONS(1220),
    [anon_sym_await] = ACTIONS(1222),
    [anon_sym_in] = ACTIONS(1224),
    [anon_sym_while] = ACTIONS(1222),
    [anon_sym_do] = ACTIONS(1222),
    [anon_sym_try] = ACTIONS(1222),
    [anon_sym_with] = ACTIONS(1222),
    [anon_sym_break] = ACTIONS(1222),
    [anon_sym_continue] = ACTIONS(1222),
    [anon_sym_debugger] = ACTIONS(1222),
    [anon_sym_return] = ACTIONS(1222),
    [anon_sym_throw] = ACTIONS(1222),
    [anon_sym_SEMI] = ACTIONS(1220),
    [anon_sym_case] = ACTIONS(1222),
    [anon_sym_yield] = ACTIONS(1222),
    [anon_sym_LBRACK] = ACTIONS(1220),
    [anon_sym_LT] = ACTIONS(1222),
    [anon_sym_GT] = ACTIONS(1224),
    [anon_sym_SLASH] = ACTIONS(1222),
    [anon_sym_DOT] = ACTIONS(1224),
    [anon_sym_class] = ACTIONS(1222),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1222),
    [anon_sym_QMARK] = ACTIONS(1224),
    [anon_sym_AMP_AMP] = ACTIONS(1226),
    [anon_sym_PIPE_PIPE] = ACTIONS(1226),
    [anon_sym_GT_GT] = ACTIONS(1224),
    [anon_sym_GT_GT_GT] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1226),
    [anon_sym_AMP] = ACTIONS(1224),
    [anon_sym_CARET] = ACTIONS(1226),
    [anon_sym_PIPE] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1222),
    [anon_sym_DASH] = ACTIONS(1222),
    [anon_sym_PERCENT] = ACTIONS(1226),
    [anon_sym_STAR_STAR] = ACTIONS(1226),
    [anon_sym_LT_EQ] = ACTIONS(1226),
    [anon_sym_EQ_EQ] = ACTIONS(1224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1226),
    [anon_sym_BANG_EQ] = ACTIONS(1224),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1226),
    [anon_sym_GT_EQ] = ACTIONS(1226),
    [anon_sym_QMARK_QMARK] = ACTIONS(1226),
    [anon_sym_instanceof] = ACTIONS(1224),
    [anon_sym_BANG] = ACTIONS(1222),
    [anon_sym_TILDE] = ACTIONS(1220),
    [anon_sym_void] = ACTIONS(1222),
    [anon_sym_delete] = ACTIONS(1222),
    [anon_sym_PLUS_PLUS] = ACTIONS(1220),
    [anon_sym_DASH_DASH] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1220),
    [anon_sym_SQUOTE] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1220),
    [sym_number] = ACTIONS(1220),
    [sym_this] = ACTIONS(1222),
    [sym_super] = ACTIONS(1222),
    [sym_true] = ACTIONS(1222),
    [sym_false] = ACTIONS(1222),
    [sym_null] = ACTIONS(1222),
    [sym_undefined] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1222),
    [anon_sym_abstract] = ACTIONS(1222),
    [anon_sym_get] = ACTIONS(1222),
    [anon_sym_set] = ACTIONS(1222),
    [anon_sym_declare] = ACTIONS(1222),
    [anon_sym_public] = ACTIONS(1222),
    [anon_sym_private] = ACTIONS(1222),
    [anon_sym_protected] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(1222),
    [anon_sym_any] = ACTIONS(1222),
    [anon_sym_number] = ACTIONS(1222),
    [anon_sym_boolean] = ACTIONS(1222),
    [anon_sym_string] = ACTIONS(1222),
    [anon_sym_symbol] = ACTIONS(1222),
    [anon_sym_interface] = ACTIONS(1222),
    [anon_sym_enum] = ACTIONS(1222),
    [sym_readonly] = ACTIONS(1222),
    [sym__automatic_semicolon] = ACTIONS(1228),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1232),
    [anon_sym_export] = ACTIONS(1232),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_namespace] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1232),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_import] = ACTIONS(1232),
    [anon_sym_var] = ACTIONS(1232),
    [anon_sym_let] = ACTIONS(1232),
    [anon_sym_const] = ACTIONS(1232),
    [anon_sym_if] = ACTIONS(1232),
    [anon_sym_else] = ACTIONS(1232),
    [anon_sym_switch] = ACTIONS(1232),
    [anon_sym_for] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_await] = ACTIONS(1232),
    [anon_sym_in] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1232),
    [anon_sym_do] = ACTIONS(1232),
    [anon_sym_try] = ACTIONS(1232),
    [anon_sym_with] = ACTIONS(1232),
    [anon_sym_break] = ACTIONS(1232),
    [anon_sym_continue] = ACTIONS(1232),
    [anon_sym_debugger] = ACTIONS(1232),
    [anon_sym_return] = ACTIONS(1232),
    [anon_sym_throw] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1230),
    [anon_sym_case] = ACTIONS(1232),
    [anon_sym_yield] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1232),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_class] = ACTIONS(1232),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1236),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_GT_GT_GT] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1236),
    [anon_sym_AMP] = ACTIONS(1234),
    [anon_sym_CARET] = ACTIONS(1236),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_PLUS] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_PERCENT] = ACTIONS(1236),
    [anon_sym_STAR_STAR] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1236),
    [anon_sym_EQ_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(1234),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1236),
    [anon_sym_GT_EQ] = ACTIONS(1236),
    [anon_sym_QMARK_QMARK] = ACTIONS(1236),
    [anon_sym_instanceof] = ACTIONS(1234),
    [anon_sym_BANG] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_void] = ACTIONS(1232),
    [anon_sym_delete] = ACTIONS(1232),
    [anon_sym_PLUS_PLUS] = ACTIONS(1230),
    [anon_sym_DASH_DASH] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1230),
    [sym_this] = ACTIONS(1232),
    [sym_super] = ACTIONS(1232),
    [sym_true] = ACTIONS(1232),
    [sym_false] = ACTIONS(1232),
    [sym_null] = ACTIONS(1232),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(1230),
    [anon_sym_static] = ACTIONS(1232),
    [anon_sym_abstract] = ACTIONS(1232),
    [anon_sym_get] = ACTIONS(1232),
    [anon_sym_set] = ACTIONS(1232),
    [anon_sym_declare] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1232),
    [anon_sym_private] = ACTIONS(1232),
    [anon_sym_protected] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1232),
    [anon_sym_any] = ACTIONS(1232),
    [anon_sym_number] = ACTIONS(1232),
    [anon_sym_boolean] = ACTIONS(1232),
    [anon_sym_string] = ACTIONS(1232),
    [anon_sym_symbol] = ACTIONS(1232),
    [anon_sym_interface] = ACTIONS(1232),
    [anon_sym_enum] = ACTIONS(1232),
    [sym_readonly] = ACTIONS(1232),
    [sym__automatic_semicolon] = ACTIONS(1238),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_export] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_as] = ACTIONS(1244),
    [anon_sym_namespace] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_COMMA] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1242),
    [anon_sym_import] = ACTIONS(1242),
    [anon_sym_var] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [anon_sym_switch] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_await] = ACTIONS(1242),
    [anon_sym_in] = ACTIONS(1244),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_do] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [anon_sym_with] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_debugger] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_throw] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_case] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1244),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1244),
    [anon_sym_class] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_function] = ACTIONS(1242),
    [anon_sym_new] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_AMP_AMP] = ACTIONS(1246),
    [anon_sym_PIPE_PIPE] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1244),
    [anon_sym_GT_GT_GT] = ACTIONS(1246),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_STAR_STAR] = ACTIONS(1246),
    [anon_sym_LT_EQ] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1246),
    [anon_sym_QMARK_QMARK] = ACTIONS(1246),
    [anon_sym_instanceof] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(1242),
    [anon_sym_TILDE] = ACTIONS(1240),
    [anon_sym_void] = ACTIONS(1242),
    [anon_sym_delete] = ACTIONS(1242),
    [anon_sym_PLUS_PLUS] = ACTIONS(1240),
    [anon_sym_DASH_DASH] = ACTIONS(1240),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1240),
    [sym_number] = ACTIONS(1240),
    [sym_this] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_true] = ACTIONS(1242),
    [sym_false] = ACTIONS(1242),
    [sym_null] = ACTIONS(1242),
    [sym_undefined] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1240),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_abstract] = ACTIONS(1242),
    [anon_sym_get] = ACTIONS(1242),
    [anon_sym_set] = ACTIONS(1242),
    [anon_sym_declare] = ACTIONS(1242),
    [anon_sym_public] = ACTIONS(1242),
    [anon_sym_private] = ACTIONS(1242),
    [anon_sym_protected] = ACTIONS(1242),
    [anon_sym_module] = ACTIONS(1242),
    [anon_sym_any] = ACTIONS(1242),
    [anon_sym_number] = ACTIONS(1242),
    [anon_sym_boolean] = ACTIONS(1242),
    [anon_sym_string] = ACTIONS(1242),
    [anon_sym_symbol] = ACTIONS(1242),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [sym_readonly] = ACTIONS(1242),
    [sym__automatic_semicolon] = ACTIONS(1248),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_export] = ACTIONS(1252),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1254),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_type] = ACTIONS(1252),
    [anon_sym_typeof] = ACTIONS(1252),
    [anon_sym_import] = ACTIONS(1252),
    [anon_sym_var] = ACTIONS(1252),
    [anon_sym_let] = ACTIONS(1252),
    [anon_sym_const] = ACTIONS(1252),
    [anon_sym_if] = ACTIONS(1252),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_await] = ACTIONS(1252),
    [anon_sym_in] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1252),
    [anon_sym_with] = ACTIONS(1252),
    [anon_sym_break] = ACTIONS(1252),
    [anon_sym_continue] = ACTIONS(1252),
    [anon_sym_debugger] = ACTIONS(1252),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_throw] = ACTIONS(1252),
    [anon_sym_SEMI] = ACTIONS(1250),
    [anon_sym_case] = ACTIONS(1252),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1252),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_class] = ACTIONS(1252),
    [anon_sym_async] = ACTIONS(1252),
    [anon_sym_function] = ACTIONS(1252),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(1254),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_GT_GT_GT] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1256),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_CARET] = ACTIONS(1256),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_PERCENT] = ACTIONS(1256),
    [anon_sym_STAR_STAR] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym_EQ_EQ] = ACTIONS(1254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1256),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_QMARK_QMARK] = ACTIONS(1256),
    [anon_sym_instanceof] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_void] = ACTIONS(1252),
    [anon_sym_delete] = ACTIONS(1252),
    [anon_sym_PLUS_PLUS] = ACTIONS(1250),
    [anon_sym_DASH_DASH] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_super] = ACTIONS(1252),
    [sym_true] = ACTIONS(1252),
    [sym_false] = ACTIONS(1252),
    [sym_null] = ACTIONS(1252),
    [sym_undefined] = ACTIONS(1252),
    [anon_sym_AT] = ACTIONS(1250),
    [anon_sym_static] = ACTIONS(1252),
    [anon_sym_abstract] = ACTIONS(1252),
    [anon_sym_get] = ACTIONS(1252),
    [anon_sym_set] = ACTIONS(1252),
    [anon_sym_declare] = ACTIONS(1252),
    [anon_sym_public] = ACTIONS(1252),
    [anon_sym_private] = ACTIONS(1252),
    [anon_sym_protected] = ACTIONS(1252),
    [anon_sym_module] = ACTIONS(1252),
    [anon_sym_any] = ACTIONS(1252),
    [anon_sym_number] = ACTIONS(1252),
    [anon_sym_boolean] = ACTIONS(1252),
    [anon_sym_string] = ACTIONS(1252),
    [anon_sym_symbol] = ACTIONS(1252),
    [anon_sym_interface] = ACTIONS(1252),
    [anon_sym_enum] = ACTIONS(1252),
    [sym_readonly] = ACTIONS(1252),
    [sym__automatic_semicolon] = ACTIONS(1258),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1260),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_export] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1264),
    [anon_sym_default] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(1264),
    [anon_sym_namespace] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1266),
    [anon_sym_RBRACE] = ACTIONS(1260),
    [anon_sym_type] = ACTIONS(1262),
    [anon_sym_typeof] = ACTIONS(1262),
    [anon_sym_import] = ACTIONS(1262),
    [anon_sym_var] = ACTIONS(1262),
    [anon_sym_let] = ACTIONS(1262),
    [anon_sym_const] = ACTIONS(1262),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_else] = ACTIONS(1262),
    [anon_sym_switch] = ACTIONS(1262),
    [anon_sym_for] = ACTIONS(1262),
    [anon_sym_LPAREN] = ACTIONS(1260),
    [anon_sym_await] = ACTIONS(1262),
    [anon_sym_in] = ACTIONS(1264),
    [anon_sym_while] = ACTIONS(1262),
    [anon_sym_do] = ACTIONS(1262),
    [anon_sym_try] = ACTIONS(1262),
    [anon_sym_with] = ACTIONS(1262),
    [anon_sym_break] = ACTIONS(1262),
    [anon_sym_continue] = ACTIONS(1262),
    [anon_sym_debugger] = ACTIONS(1262),
    [anon_sym_return] = ACTIONS(1262),
    [anon_sym_throw] = ACTIONS(1262),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_case] = ACTIONS(1262),
    [anon_sym_yield] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1264),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_DOT] = ACTIONS(1264),
    [anon_sym_class] = ACTIONS(1262),
    [anon_sym_async] = ACTIONS(1262),
    [anon_sym_function] = ACTIONS(1262),
    [anon_sym_new] = ACTIONS(1262),
    [anon_sym_QMARK] = ACTIONS(1264),
    [anon_sym_AMP_AMP] = ACTIONS(1266),
    [anon_sym_PIPE_PIPE] = ACTIONS(1266),
    [anon_sym_GT_GT] = ACTIONS(1264),
    [anon_sym_GT_GT_GT] = ACTIONS(1266),
    [anon_sym_LT_LT] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(1264),
    [anon_sym_CARET] = ACTIONS(1266),
    [anon_sym_PIPE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_STAR_STAR] = ACTIONS(1266),
    [anon_sym_LT_EQ] = ACTIONS(1266),
    [anon_sym_EQ_EQ] = ACTIONS(1264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1266),
    [anon_sym_BANG_EQ] = ACTIONS(1264),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1266),
    [anon_sym_GT_EQ] = ACTIONS(1266),
    [anon_sym_QMARK_QMARK] = ACTIONS(1266),
    [anon_sym_instanceof] = ACTIONS(1264),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1260),
    [anon_sym_void] = ACTIONS(1262),
    [anon_sym_delete] = ACTIONS(1262),
    [anon_sym_PLUS_PLUS] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1260),
    [anon_sym_DQUOTE] = ACTIONS(1260),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1260),
    [sym_number] = ACTIONS(1260),
    [sym_this] = ACTIONS(1262),
    [sym_super] = ACTIONS(1262),
    [sym_true] = ACTIONS(1262),
    [sym_false] = ACTIONS(1262),
    [sym_null] = ACTIONS(1262),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(1262),
    [anon_sym_abstract] = ACTIONS(1262),
    [anon_sym_get] = ACTIONS(1262),
    [anon_sym_set] = ACTIONS(1262),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_public] = ACTIONS(1262),
    [anon_sym_private] = ACTIONS(1262),
    [anon_sym_protected] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_any] = ACTIONS(1262),
    [anon_sym_number] = ACTIONS(1262),
    [anon_sym_boolean] = ACTIONS(1262),
    [anon_sym_string] = ACTIONS(1262),
    [anon_sym_symbol] = ACTIONS(1262),
    [anon_sym_interface] = ACTIONS(1262),
    [anon_sym_enum] = ACTIONS(1262),
    [sym_readonly] = ACTIONS(1262),
    [sym__automatic_semicolon] = ACTIONS(1268),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym_identifier] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(1272),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_default] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(1272),
    [anon_sym_namespace] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(1272),
    [anon_sym_typeof] = ACTIONS(1272),
    [anon_sym_import] = ACTIONS(1272),
    [anon_sym_var] = ACTIONS(1272),
    [anon_sym_let] = ACTIONS(1272),
    [anon_sym_const] = ACTIONS(1272),
    [anon_sym_if] = ACTIONS(1272),
    [anon_sym_else] = ACTIONS(1272),
    [anon_sym_switch] = ACTIONS(1272),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_await] = ACTIONS(1272),
    [anon_sym_in] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [anon_sym_do] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_with] = ACTIONS(1272),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_debugger] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_throw] = ACTIONS(1272),
    [anon_sym_SEMI] = ACTIONS(1270),
    [anon_sym_case] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_SLASH] = ACTIONS(1272),
    [anon_sym_DOT] = ACTIONS(1272),
    [anon_sym_class] = ACTIONS(1272),
    [anon_sym_async] = ACTIONS(1272),
    [anon_sym_function] = ACTIONS(1272),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1272),
    [anon_sym_AMP_AMP] = ACTIONS(1270),
    [anon_sym_PIPE_PIPE] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(1272),
    [anon_sym_GT_GT_GT] = ACTIONS(1270),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_PERCENT] = ACTIONS(1270),
    [anon_sym_STAR_STAR] = ACTIONS(1270),
    [anon_sym_LT_EQ] = ACTIONS(1270),
    [anon_sym_EQ_EQ] = ACTIONS(1272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1270),
    [anon_sym_BANG_EQ] = ACTIONS(1272),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1270),
    [anon_sym_GT_EQ] = ACTIONS(1270),
    [anon_sym_QMARK_QMARK] = ACTIONS(1270),
    [anon_sym_instanceof] = ACTIONS(1272),
    [anon_sym_BANG] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_void] = ACTIONS(1272),
    [anon_sym_delete] = ACTIONS(1272),
    [anon_sym_PLUS_PLUS] = ACTIONS(1270),
    [anon_sym_DASH_DASH] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1270),
    [sym_number] = ACTIONS(1270),
    [sym_this] = ACTIONS(1272),
    [sym_super] = ACTIONS(1272),
    [sym_true] = ACTIONS(1272),
    [sym_false] = ACTIONS(1272),
    [sym_null] = ACTIONS(1272),
    [sym_undefined] = ACTIONS(1272),
    [anon_sym_AT] = ACTIONS(1270),
    [anon_sym_static] = ACTIONS(1272),
    [anon_sym_abstract] = ACTIONS(1272),
    [anon_sym_get] = ACTIONS(1272),
    [anon_sym_set] = ACTIONS(1272),
    [anon_sym_declare] = ACTIONS(1272),
    [anon_sym_public] = ACTIONS(1272),
    [anon_sym_private] = ACTIONS(1272),
    [anon_sym_protected] = ACTIONS(1272),
    [anon_sym_module] = ACTIONS(1272),
    [anon_sym_any] = ACTIONS(1272),
    [anon_sym_number] = ACTIONS(1272),
    [anon_sym_boolean] = ACTIONS(1272),
    [anon_sym_string] = ACTIONS(1272),
    [anon_sym_symbol] = ACTIONS(1272),
    [anon_sym_interface] = ACTIONS(1272),
    [anon_sym_enum] = ACTIONS(1272),
    [sym_readonly] = ACTIONS(1272),
    [sym__automatic_semicolon] = ACTIONS(1270),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_export] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_as] = ACTIONS(1108),
    [anon_sym_namespace] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_COMMA] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_type] = ACTIONS(1108),
    [anon_sym_typeof] = ACTIONS(1108),
    [anon_sym_import] = ACTIONS(1108),
    [anon_sym_var] = ACTIONS(1108),
    [anon_sym_let] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_else] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_await] = ACTIONS(1108),
    [anon_sym_in] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_try] = ACTIONS(1108),
    [anon_sym_with] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_debugger] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_throw] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_yield] = ACTIONS(1108),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_GT] = ACTIONS(1108),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_DOT] = ACTIONS(1108),
    [anon_sym_class] = ACTIONS(1108),
    [anon_sym_async] = ACTIONS(1108),
    [anon_sym_function] = ACTIONS(1108),
    [anon_sym_new] = ACTIONS(1108),
    [anon_sym_QMARK] = ACTIONS(1108),
    [anon_sym_AMP_AMP] = ACTIONS(1106),
    [anon_sym_PIPE_PIPE] = ACTIONS(1106),
    [anon_sym_GT_GT] = ACTIONS(1108),
    [anon_sym_GT_GT_GT] = ACTIONS(1106),
    [anon_sym_LT_LT] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1108),
    [anon_sym_CARET] = ACTIONS(1106),
    [anon_sym_PIPE] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_STAR_STAR] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1106),
    [anon_sym_EQ_EQ] = ACTIONS(1108),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1106),
    [anon_sym_BANG_EQ] = ACTIONS(1108),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1106),
    [anon_sym_GT_EQ] = ACTIONS(1106),
    [anon_sym_QMARK_QMARK] = ACTIONS(1106),
    [anon_sym_instanceof] = ACTIONS(1108),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_void] = ACTIONS(1108),
    [anon_sym_delete] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1106),
    [sym_number] = ACTIONS(1106),
    [sym_this] = ACTIONS(1108),
    [sym_super] = ACTIONS(1108),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_undefined] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_abstract] = ACTIONS(1108),
    [anon_sym_get] = ACTIONS(1108),
    [anon_sym_set] = ACTIONS(1108),
    [anon_sym_declare] = ACTIONS(1108),
    [anon_sym_public] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym_protected] = ACTIONS(1108),
    [anon_sym_module] = ACTIONS(1108),
    [anon_sym_any] = ACTIONS(1108),
    [anon_sym_number] = ACTIONS(1108),
    [anon_sym_boolean] = ACTIONS(1108),
    [anon_sym_string] = ACTIONS(1108),
    [anon_sym_symbol] = ACTIONS(1108),
    [anon_sym_interface] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [sym_readonly] = ACTIONS(1108),
    [sym__automatic_semicolon] = ACTIONS(1274),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1276),
    [sym_identifier] = ACTIONS(1278),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_default] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1276),
    [anon_sym_RBRACE] = ACTIONS(1276),
    [anon_sym_type] = ACTIONS(1278),
    [anon_sym_typeof] = ACTIONS(1278),
    [anon_sym_import] = ACTIONS(1278),
    [anon_sym_var] = ACTIONS(1278),
    [anon_sym_let] = ACTIONS(1278),
    [anon_sym_const] = ACTIONS(1278),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_else] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(1278),
    [anon_sym_for] = ACTIONS(1278),
    [anon_sym_LPAREN] = ACTIONS(1276),
    [anon_sym_await] = ACTIONS(1278),
    [anon_sym_in] = ACTIONS(1278),
    [anon_sym_while] = ACTIONS(1278),
    [anon_sym_do] = ACTIONS(1278),
    [anon_sym_try] = ACTIONS(1278),
    [anon_sym_with] = ACTIONS(1278),
    [anon_sym_break] = ACTIONS(1278),
    [anon_sym_continue] = ACTIONS(1278),
    [anon_sym_debugger] = ACTIONS(1278),
    [anon_sym_return] = ACTIONS(1278),
    [anon_sym_throw] = ACTIONS(1278),
    [anon_sym_SEMI] = ACTIONS(1276),
    [anon_sym_case] = ACTIONS(1278),
    [anon_sym_yield] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_DOT] = ACTIONS(1278),
    [anon_sym_class] = ACTIONS(1278),
    [anon_sym_async] = ACTIONS(1278),
    [anon_sym_function] = ACTIONS(1278),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_QMARK] = ACTIONS(1278),
    [anon_sym_AMP_AMP] = ACTIONS(1276),
    [anon_sym_PIPE_PIPE] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1278),
    [anon_sym_GT_GT_GT] = ACTIONS(1276),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_CARET] = ACTIONS(1276),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_PERCENT] = ACTIONS(1276),
    [anon_sym_STAR_STAR] = ACTIONS(1276),
    [anon_sym_LT_EQ] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1276),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1276),
    [anon_sym_GT_EQ] = ACTIONS(1276),
    [anon_sym_QMARK_QMARK] = ACTIONS(1276),
    [anon_sym_instanceof] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1278),
    [anon_sym_TILDE] = ACTIONS(1276),
    [anon_sym_void] = ACTIONS(1278),
    [anon_sym_delete] = ACTIONS(1278),
    [anon_sym_PLUS_PLUS] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1276),
    [sym_number] = ACTIONS(1276),
    [sym_this] = ACTIONS(1278),
    [sym_super] = ACTIONS(1278),
    [sym_true] = ACTIONS(1278),
    [sym_false] = ACTIONS(1278),
    [sym_null] = ACTIONS(1278),
    [sym_undefined] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1276),
    [anon_sym_static] = ACTIONS(1278),
    [anon_sym_abstract] = ACTIONS(1278),
    [anon_sym_get] = ACTIONS(1278),
    [anon_sym_set] = ACTIONS(1278),
    [anon_sym_declare] = ACTIONS(1278),
    [anon_sym_public] = ACTIONS(1278),
    [anon_sym_private] = ACTIONS(1278),
    [anon_sym_protected] = ACTIONS(1278),
    [anon_sym_module] = ACTIONS(1278),
    [anon_sym_any] = ACTIONS(1278),
    [anon_sym_number] = ACTIONS(1278),
    [anon_sym_boolean] = ACTIONS(1278),
    [anon_sym_string] = ACTIONS(1278),
    [anon_sym_symbol] = ACTIONS(1278),
    [anon_sym_interface] = ACTIONS(1278),
    [anon_sym_enum] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1278),
    [sym__automatic_semicolon] = ACTIONS(1276),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1280),
    [sym_identifier] = ACTIONS(1282),
    [anon_sym_export] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(1282),
    [anon_sym_default] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(1282),
    [anon_sym_namespace] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_type] = ACTIONS(1282),
    [anon_sym_typeof] = ACTIONS(1282),
    [anon_sym_import] = ACTIONS(1282),
    [anon_sym_var] = ACTIONS(1282),
    [anon_sym_let] = ACTIONS(1282),
    [anon_sym_const] = ACTIONS(1282),
    [anon_sym_if] = ACTIONS(1282),
    [anon_sym_else] = ACTIONS(1282),
    [anon_sym_switch] = ACTIONS(1282),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_await] = ACTIONS(1282),
    [anon_sym_in] = ACTIONS(1282),
    [anon_sym_while] = ACTIONS(1282),
    [anon_sym_do] = ACTIONS(1282),
    [anon_sym_try] = ACTIONS(1282),
    [anon_sym_with] = ACTIONS(1282),
    [anon_sym_break] = ACTIONS(1282),
    [anon_sym_continue] = ACTIONS(1282),
    [anon_sym_debugger] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(1282),
    [anon_sym_throw] = ACTIONS(1282),
    [anon_sym_SEMI] = ACTIONS(1280),
    [anon_sym_case] = ACTIONS(1282),
    [anon_sym_yield] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_SLASH] = ACTIONS(1282),
    [anon_sym_DOT] = ACTIONS(1282),
    [anon_sym_class] = ACTIONS(1282),
    [anon_sym_async] = ACTIONS(1282),
    [anon_sym_function] = ACTIONS(1282),
    [anon_sym_new] = ACTIONS(1282),
    [anon_sym_QMARK] = ACTIONS(1282),
    [anon_sym_AMP_AMP] = ACTIONS(1280),
    [anon_sym_PIPE_PIPE] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [anon_sym_GT_GT_GT] = ACTIONS(1280),
    [anon_sym_LT_LT] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_CARET] = ACTIONS(1280),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_PERCENT] = ACTIONS(1280),
    [anon_sym_STAR_STAR] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1280),
    [anon_sym_BANG_EQ] = ACTIONS(1282),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1280),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK_QMARK] = ACTIONS(1280),
    [anon_sym_instanceof] = ACTIONS(1282),
    [anon_sym_BANG] = ACTIONS(1282),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_void] = ACTIONS(1282),
    [anon_sym_delete] = ACTIONS(1282),
    [anon_sym_PLUS_PLUS] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [sym_number] = ACTIONS(1280),
    [sym_this] = ACTIONS(1282),
    [sym_super] = ACTIONS(1282),
    [sym_true] = ACTIONS(1282),
    [sym_false] = ACTIONS(1282),
    [sym_null] = ACTIONS(1282),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_static] = ACTIONS(1282),
    [anon_sym_abstract] = ACTIONS(1282),
    [anon_sym_get] = ACTIONS(1282),
    [anon_sym_set] = ACTIONS(1282),
    [anon_sym_declare] = ACTIONS(1282),
    [anon_sym_public] = ACTIONS(1282),
    [anon_sym_private] = ACTIONS(1282),
    [anon_sym_protected] = ACTIONS(1282),
    [anon_sym_module] = ACTIONS(1282),
    [anon_sym_any] = ACTIONS(1282),
    [anon_sym_number] = ACTIONS(1282),
    [anon_sym_boolean] = ACTIONS(1282),
    [anon_sym_string] = ACTIONS(1282),
    [anon_sym_symbol] = ACTIONS(1282),
    [anon_sym_interface] = ACTIONS(1282),
    [anon_sym_enum] = ACTIONS(1282),
    [sym_readonly] = ACTIONS(1282),
    [sym__automatic_semicolon] = ACTIONS(1280),
  },
  [140] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(161),
    [sym_variable_declaration] = STATE(161),
    [sym_lexical_declaration] = STATE(161),
    [sym_empty_statement] = STATE(161),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1330),
    [sym_array] = STATE(1327),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1290),
    [anon_sym_let] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1296),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [sym_readonly] = ACTIONS(1286),
  },
  [141] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(160),
    [sym_variable_declaration] = STATE(160),
    [sym_lexical_declaration] = STATE(160),
    [sym_empty_statement] = STATE(160),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1330),
    [sym_array] = STATE(1327),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1290),
    [anon_sym_let] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1296),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [sym_readonly] = ACTIONS(1286),
  },
  [142] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_empty_statement] = STATE(164),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1330),
    [sym_array] = STATE(1327),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1290),
    [anon_sym_let] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1296),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [sym_readonly] = ACTIONS(1286),
  },
  [143] = {
    [sym_import] = STATE(1025),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1025),
    [sym_object] = STATE(1555),
    [sym_array] = STATE(1556),
    [sym_jsx_element] = STATE(1025),
    [sym_jsx_fragment] = STATE(1025),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1025),
    [sym_class] = STATE(1025),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1025),
    [sym_arrow_function] = STATE(1025),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1025),
    [sym_new_expression] = STATE(1025),
    [sym_await_expression] = STATE(1025),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1025),
    [sym_augmented_assignment_expression] = STATE(1025),
    [sym_ternary_expression] = STATE(1025),
    [sym_binary_expression] = STATE(1025),
    [sym_unary_expression] = STATE(1025),
    [sym_update_expression] = STATE(1025),
    [sym_sequence_expression] = STATE(3118),
    [sym_string] = STATE(1025),
    [sym_template_string] = STATE(1025),
    [sym_regex] = STATE(1025),
    [sym_meta_property] = STATE(1025),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1025),
    [sym_as_expression] = STATE(1025),
    [sym_internal_module] = STATE(1025),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(1756),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(800),
    [anon_sym_namespace] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(818),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(1300),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1302),
    [sym_this] = ACTIONS(1304),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(854),
    [sym_false] = ACTIONS(854),
    [sym_null] = ACTIONS(854),
    [sym_undefined] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_set] = ACTIONS(800),
    [anon_sym_declare] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(800),
    [anon_sym_any] = ACTIONS(800),
    [anon_sym_number] = ACTIONS(800),
    [anon_sym_boolean] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_symbol] = ACTIONS(800),
    [sym_readonly] = ACTIONS(846),
  },
  [144] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1555),
    [sym_array] = STATE(1556),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_sequence_expression] = STATE(3012),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(1756),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(800),
    [anon_sym_namespace] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(818),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(1300),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1306),
    [sym_this] = ACTIONS(1304),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_null] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_set] = ACTIONS(800),
    [anon_sym_declare] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(800),
    [anon_sym_any] = ACTIONS(800),
    [anon_sym_number] = ACTIONS(800),
    [anon_sym_boolean] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_symbol] = ACTIONS(800),
    [sym_readonly] = ACTIONS(846),
  },
  [145] = {
    [sym_import] = STATE(1169),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1169),
    [sym_object] = STATE(1555),
    [sym_array] = STATE(1556),
    [sym_jsx_element] = STATE(1169),
    [sym_jsx_fragment] = STATE(1169),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1169),
    [sym_class] = STATE(1169),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1169),
    [sym_arrow_function] = STATE(1169),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1169),
    [sym_new_expression] = STATE(1169),
    [sym_await_expression] = STATE(1169),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1169),
    [sym_augmented_assignment_expression] = STATE(1169),
    [sym_ternary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(1169),
    [sym_unary_expression] = STATE(1169),
    [sym_update_expression] = STATE(1169),
    [sym_sequence_expression] = STATE(3026),
    [sym_string] = STATE(1169),
    [sym_template_string] = STATE(1169),
    [sym_regex] = STATE(1169),
    [sym_meta_property] = STATE(1169),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1169),
    [sym_as_expression] = STATE(1169),
    [sym_internal_module] = STATE(1169),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(1756),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(800),
    [anon_sym_namespace] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(818),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(1300),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1308),
    [sym_this] = ACTIONS(1304),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_null] = ACTIONS(852),
    [sym_undefined] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_set] = ACTIONS(800),
    [anon_sym_declare] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(800),
    [anon_sym_any] = ACTIONS(800),
    [anon_sym_number] = ACTIONS(800),
    [anon_sym_boolean] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_symbol] = ACTIONS(800),
    [sym_readonly] = ACTIONS(846),
  },
  [146] = {
    [sym_import] = STATE(1237),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1237),
    [sym_yield_expression] = STATE(1237),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1237),
    [sym_jsx_fragment] = STATE(1237),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1237),
    [sym_class] = STATE(1237),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1237),
    [sym_arrow_function] = STATE(1237),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1237),
    [sym_new_expression] = STATE(1237),
    [sym_await_expression] = STATE(1237),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1237),
    [sym_augmented_assignment_expression] = STATE(1237),
    [sym_spread_element] = STATE(2602),
    [sym_ternary_expression] = STATE(1237),
    [sym_binary_expression] = STATE(1237),
    [sym_unary_expression] = STATE(1237),
    [sym_update_expression] = STATE(1237),
    [sym_string] = STATE(1237),
    [sym_template_string] = STATE(1237),
    [sym_regex] = STATE(1237),
    [sym_meta_property] = STATE(1237),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1237),
    [sym_as_expression] = STATE(1237),
    [sym_internal_module] = STATE(1237),
    [sym_mapped_type_clause] = STATE(3036),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2603),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_export] = ACTIONS(1312),
    [anon_sym_namespace] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(1312),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1316),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1320),
    [sym_this] = ACTIONS(1322),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [sym_null] = ACTIONS(1322),
    [sym_undefined] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1312),
    [anon_sym_get] = ACTIONS(1312),
    [anon_sym_set] = ACTIONS(1312),
    [anon_sym_declare] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1312),
    [anon_sym_private] = ACTIONS(1312),
    [anon_sym_protected] = ACTIONS(1312),
    [anon_sym_module] = ACTIONS(1312),
    [anon_sym_any] = ACTIONS(1312),
    [anon_sym_number] = ACTIONS(1312),
    [anon_sym_boolean] = ACTIONS(1312),
    [anon_sym_string] = ACTIONS(1312),
    [anon_sym_symbol] = ACTIONS(1312),
    [sym_readonly] = ACTIONS(1312),
  },
  [147] = {
    [sym_import] = STATE(1231),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1231),
    [sym_yield_expression] = STATE(1231),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1231),
    [sym_jsx_fragment] = STATE(1231),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1231),
    [sym_class] = STATE(1231),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1231),
    [sym_arrow_function] = STATE(1231),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1231),
    [sym_new_expression] = STATE(1231),
    [sym_await_expression] = STATE(1231),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1231),
    [sym_augmented_assignment_expression] = STATE(1231),
    [sym_spread_element] = STATE(2610),
    [sym_ternary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(1231),
    [sym_unary_expression] = STATE(1231),
    [sym_update_expression] = STATE(1231),
    [sym_string] = STATE(1231),
    [sym_template_string] = STATE(1231),
    [sym_regex] = STATE(1231),
    [sym_meta_property] = STATE(1231),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1231),
    [sym_as_expression] = STATE(1231),
    [sym_internal_module] = STATE(1231),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2609),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(880),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1324),
    [sym_this] = ACTIONS(882),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(882),
    [sym_false] = ACTIONS(882),
    [sym_null] = ACTIONS(882),
    [sym_undefined] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [148] = {
    [sym_import] = STATE(1274),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1274),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1274),
    [sym_jsx_fragment] = STATE(1274),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1274),
    [sym_class] = STATE(1274),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1274),
    [sym_arrow_function] = STATE(1274),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1274),
    [sym_new_expression] = STATE(1274),
    [sym_await_expression] = STATE(1274),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1274),
    [sym_augmented_assignment_expression] = STATE(1274),
    [sym_spread_element] = STATE(2625),
    [sym_ternary_expression] = STATE(1274),
    [sym_binary_expression] = STATE(1274),
    [sym_unary_expression] = STATE(1274),
    [sym_update_expression] = STATE(1274),
    [sym_string] = STATE(1274),
    [sym_template_string] = STATE(1274),
    [sym_regex] = STATE(1274),
    [sym_meta_property] = STATE(1274),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1274),
    [sym_as_expression] = STATE(1274),
    [sym_internal_module] = STATE(1274),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2621),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1326),
    [sym_this] = ACTIONS(1328),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1328),
    [sym_false] = ACTIONS(1328),
    [sym_null] = ACTIONS(1328),
    [sym_undefined] = ACTIONS(1328),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [149] = {
    [sym_import] = STATE(1304),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1304),
    [sym_yield_expression] = STATE(1304),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1304),
    [sym_jsx_fragment] = STATE(1304),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1304),
    [sym_class] = STATE(1304),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1304),
    [sym_arrow_function] = STATE(1304),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1304),
    [sym_new_expression] = STATE(1304),
    [sym_await_expression] = STATE(1304),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1304),
    [sym_augmented_assignment_expression] = STATE(1304),
    [sym_spread_element] = STATE(2703),
    [sym_ternary_expression] = STATE(1304),
    [sym_binary_expression] = STATE(1304),
    [sym_unary_expression] = STATE(1304),
    [sym_update_expression] = STATE(1304),
    [sym_string] = STATE(1304),
    [sym_template_string] = STATE(1304),
    [sym_regex] = STATE(1304),
    [sym_meta_property] = STATE(1304),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1304),
    [sym_as_expression] = STATE(1304),
    [sym_internal_module] = STATE(1304),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(1330),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1330),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(1330),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1332),
    [sym_this] = ACTIONS(1334),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_undefined] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [150] = {
    [sym_import] = STATE(1238),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1238),
    [sym_yield_expression] = STATE(1238),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1238),
    [sym_jsx_fragment] = STATE(1238),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1238),
    [sym_class] = STATE(1238),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1238),
    [sym_arrow_function] = STATE(1238),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1238),
    [sym_new_expression] = STATE(1238),
    [sym_await_expression] = STATE(1238),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1238),
    [sym_augmented_assignment_expression] = STATE(1238),
    [sym_spread_element] = STATE(2599),
    [sym_ternary_expression] = STATE(1238),
    [sym_binary_expression] = STATE(1238),
    [sym_unary_expression] = STATE(1238),
    [sym_update_expression] = STATE(1238),
    [sym_string] = STATE(1238),
    [sym_template_string] = STATE(1238),
    [sym_regex] = STATE(1238),
    [sym_meta_property] = STATE(1238),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1238),
    [sym_as_expression] = STATE(1238),
    [sym_internal_module] = STATE(1238),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2605),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1338),
    [sym_this] = ACTIONS(1340),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1340),
    [sym_false] = ACTIONS(1340),
    [sym_null] = ACTIONS(1340),
    [sym_undefined] = ACTIONS(1340),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [151] = {
    [sym_import] = STATE(1412),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1412),
    [sym_yield_expression] = STATE(1412),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1412),
    [sym_jsx_fragment] = STATE(1412),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1412),
    [sym_class] = STATE(1412),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1412),
    [sym_arrow_function] = STATE(1412),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1412),
    [sym_new_expression] = STATE(1412),
    [sym_await_expression] = STATE(1412),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1412),
    [sym_augmented_assignment_expression] = STATE(1412),
    [sym_spread_element] = STATE(2703),
    [sym_ternary_expression] = STATE(1412),
    [sym_binary_expression] = STATE(1412),
    [sym_unary_expression] = STATE(1412),
    [sym_update_expression] = STATE(1412),
    [sym_sequence_expression] = STATE(2530),
    [sym_string] = STATE(1412),
    [sym_template_string] = STATE(1412),
    [sym_regex] = STATE(1412),
    [sym_meta_property] = STATE(1412),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1412),
    [sym_as_expression] = STATE(1412),
    [sym_internal_module] = STATE(1412),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(1330),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1330),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1342),
    [sym_this] = ACTIONS(1344),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1344),
    [sym_false] = ACTIONS(1344),
    [sym_null] = ACTIONS(1344),
    [sym_undefined] = ACTIONS(1344),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [152] = {
    [sym_import] = STATE(1264),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1264),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1264),
    [sym_jsx_fragment] = STATE(1264),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1264),
    [sym_class] = STATE(1264),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1264),
    [sym_arrow_function] = STATE(1264),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1264),
    [sym_new_expression] = STATE(1264),
    [sym_await_expression] = STATE(1264),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1264),
    [sym_augmented_assignment_expression] = STATE(1264),
    [sym_spread_element] = STATE(2625),
    [sym_ternary_expression] = STATE(1264),
    [sym_binary_expression] = STATE(1264),
    [sym_unary_expression] = STATE(1264),
    [sym_update_expression] = STATE(1264),
    [sym_string] = STATE(1264),
    [sym_template_string] = STATE(1264),
    [sym_regex] = STATE(1264),
    [sym_meta_property] = STATE(1264),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1264),
    [sym_as_expression] = STATE(1264),
    [sym_internal_module] = STATE(1264),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2621),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1346),
    [sym_this] = ACTIONS(876),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_null] = ACTIONS(876),
    [sym_undefined] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [153] = {
    [sym_import] = STATE(1296),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1296),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1296),
    [sym_jsx_fragment] = STATE(1296),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1296),
    [sym_class] = STATE(1296),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1296),
    [sym_arrow_function] = STATE(1296),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1296),
    [sym_new_expression] = STATE(1296),
    [sym_await_expression] = STATE(1296),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1296),
    [sym_augmented_assignment_expression] = STATE(1296),
    [sym_spread_element] = STATE(2623),
    [sym_ternary_expression] = STATE(1296),
    [sym_binary_expression] = STATE(1296),
    [sym_unary_expression] = STATE(1296),
    [sym_update_expression] = STATE(1296),
    [sym_string] = STATE(1296),
    [sym_template_string] = STATE(1296),
    [sym_regex] = STATE(1296),
    [sym_meta_property] = STATE(1296),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1296),
    [sym_as_expression] = STATE(1296),
    [sym_internal_module] = STATE(1296),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2624),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1348),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1350),
    [sym_this] = ACTIONS(1352),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [sym_null] = ACTIONS(1352),
    [sym_undefined] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [154] = {
    [sym_import] = STATE(1293),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1293),
    [sym_jsx_fragment] = STATE(1293),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1293),
    [sym_class] = STATE(1293),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1293),
    [sym_arrow_function] = STATE(1293),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1293),
    [sym_new_expression] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_spread_element] = STATE(2602),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_string] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2603),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(886),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_null] = ACTIONS(886),
    [sym_undefined] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [155] = {
    [sym_import] = STATE(1210),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1210),
    [sym_yield_expression] = STATE(1210),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1210),
    [sym_jsx_fragment] = STATE(1210),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1210),
    [sym_class] = STATE(1210),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1210),
    [sym_arrow_function] = STATE(1210),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1210),
    [sym_new_expression] = STATE(1210),
    [sym_await_expression] = STATE(1210),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1210),
    [sym_augmented_assignment_expression] = STATE(1210),
    [sym_spread_element] = STATE(2737),
    [sym_ternary_expression] = STATE(1210),
    [sym_binary_expression] = STATE(1210),
    [sym_unary_expression] = STATE(1210),
    [sym_update_expression] = STATE(1210),
    [sym_string] = STATE(1210),
    [sym_template_string] = STATE(1210),
    [sym_regex] = STATE(1210),
    [sym_meta_property] = STATE(1210),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1210),
    [sym_as_expression] = STATE(1210),
    [sym_internal_module] = STATE(1210),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2733),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1358),
    [sym_this] = ACTIONS(1360),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1360),
    [sym_false] = ACTIONS(1360),
    [sym_null] = ACTIONS(1360),
    [sym_undefined] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [156] = {
    [sym_import] = STATE(1200),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1200),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1200),
    [sym_jsx_fragment] = STATE(1200),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1200),
    [sym_class] = STATE(1200),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1200),
    [sym_arrow_function] = STATE(1200),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_await_expression] = STATE(1200),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1200),
    [sym_augmented_assignment_expression] = STATE(1200),
    [sym_spread_element] = STATE(2739),
    [sym_ternary_expression] = STATE(1200),
    [sym_binary_expression] = STATE(1200),
    [sym_unary_expression] = STATE(1200),
    [sym_update_expression] = STATE(1200),
    [sym_string] = STATE(1200),
    [sym_template_string] = STATE(1200),
    [sym_regex] = STATE(1200),
    [sym_meta_property] = STATE(1200),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1200),
    [sym_as_expression] = STATE(1200),
    [sym_internal_module] = STATE(1200),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2738),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1362),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1364),
    [sym_this] = ACTIONS(1366),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [157] = {
    [sym_import] = STATE(1177),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1177),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1177),
    [sym_jsx_fragment] = STATE(1177),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1177),
    [sym_class] = STATE(1177),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1177),
    [sym_arrow_function] = STATE(1177),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(1177),
    [sym_spread_element] = STATE(2595),
    [sym_ternary_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_update_expression] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_template_string] = STATE(1177),
    [sym_regex] = STATE(1177),
    [sym_meta_property] = STATE(1177),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1177),
    [sym_as_expression] = STATE(1177),
    [sym_internal_module] = STATE(1177),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2593),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1368),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1372),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_undefined] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [158] = {
    [sym_import] = STATE(1201),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1201),
    [sym_yield_expression] = STATE(1201),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1201),
    [sym_jsx_fragment] = STATE(1201),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1201),
    [sym_class] = STATE(1201),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1201),
    [sym_arrow_function] = STATE(1201),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1201),
    [sym_new_expression] = STATE(1201),
    [sym_await_expression] = STATE(1201),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1201),
    [sym_augmented_assignment_expression] = STATE(1201),
    [sym_spread_element] = STATE(2602),
    [sym_ternary_expression] = STATE(1201),
    [sym_binary_expression] = STATE(1201),
    [sym_unary_expression] = STATE(1201),
    [sym_update_expression] = STATE(1201),
    [sym_string] = STATE(1201),
    [sym_template_string] = STATE(1201),
    [sym_regex] = STATE(1201),
    [sym_meta_property] = STATE(1201),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1201),
    [sym_as_expression] = STATE(1201),
    [sym_internal_module] = STATE(1201),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2603),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1374),
    [sym_this] = ACTIONS(1376),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1376),
    [sym_false] = ACTIONS(1376),
    [sym_null] = ACTIONS(1376),
    [sym_undefined] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [159] = {
    [sym_import] = STATE(1302),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1302),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1302),
    [sym_jsx_fragment] = STATE(1302),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1302),
    [sym_class] = STATE(1302),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1302),
    [sym_arrow_function] = STATE(1302),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1302),
    [sym_new_expression] = STATE(1302),
    [sym_await_expression] = STATE(1302),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1302),
    [sym_augmented_assignment_expression] = STATE(1302),
    [sym_spread_element] = STATE(2673),
    [sym_ternary_expression] = STATE(1302),
    [sym_binary_expression] = STATE(1302),
    [sym_unary_expression] = STATE(1302),
    [sym_update_expression] = STATE(1302),
    [sym_string] = STATE(1302),
    [sym_template_string] = STATE(1302),
    [sym_regex] = STATE(1302),
    [sym_meta_property] = STATE(1302),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1302),
    [sym_as_expression] = STATE(1302),
    [sym_internal_module] = STATE(1302),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [aux_sym_array_repeat1] = STATE(2674),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1378),
    [sym_this] = ACTIONS(890),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_null] = ACTIONS(890),
    [sym_undefined] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [160] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(172),
    [sym_empty_statement] = STATE(172),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [161] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(171),
    [sym_empty_statement] = STATE(171),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [162] = {
    [sym_import] = STATE(1342),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1342),
    [sym_yield_expression] = STATE(1342),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1342),
    [sym_jsx_fragment] = STATE(1342),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1342),
    [sym_class] = STATE(1342),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1342),
    [sym_arrow_function] = STATE(1342),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1342),
    [sym_new_expression] = STATE(1342),
    [sym_await_expression] = STATE(1342),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1342),
    [sym_augmented_assignment_expression] = STATE(1342),
    [sym_spread_element] = STATE(3029),
    [sym_ternary_expression] = STATE(1342),
    [sym_binary_expression] = STATE(1342),
    [sym_unary_expression] = STATE(1342),
    [sym_update_expression] = STATE(1342),
    [sym_sequence_expression] = STATE(3029),
    [sym_string] = STATE(1342),
    [sym_template_string] = STATE(1342),
    [sym_regex] = STATE(1342),
    [sym_meta_property] = STATE(1342),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1342),
    [sym_as_expression] = STATE(1342),
    [sym_internal_module] = STATE(1342),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1384),
    [sym_this] = ACTIONS(1386),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [sym_null] = ACTIONS(1386),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [163] = {
    [sym_import] = STATE(1354),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1354),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1354),
    [sym_jsx_fragment] = STATE(1354),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1354),
    [sym_class] = STATE(1354),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1354),
    [sym_arrow_function] = STATE(1354),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_await_expression] = STATE(1354),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1354),
    [sym_augmented_assignment_expression] = STATE(1354),
    [sym_spread_element] = STATE(3153),
    [sym_ternary_expression] = STATE(1354),
    [sym_binary_expression] = STATE(1354),
    [sym_unary_expression] = STATE(1354),
    [sym_update_expression] = STATE(1354),
    [sym_sequence_expression] = STATE(3153),
    [sym_string] = STATE(1354),
    [sym_template_string] = STATE(1354),
    [sym_regex] = STATE(1354),
    [sym_meta_property] = STATE(1354),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1354),
    [sym_as_expression] = STATE(1354),
    [sym_internal_module] = STATE(1354),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1390),
    [sym_this] = ACTIONS(1392),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_null] = ACTIONS(1392),
    [sym_undefined] = ACTIONS(1392),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [164] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(175),
    [sym_empty_statement] = STATE(175),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2824),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [165] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1255),
    [sym_yield_expression] = STATE(1255),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1255),
    [sym_jsx_fragment] = STATE(1255),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_nested_identifier] = STATE(3081),
    [sym_jsx_self_closing_element] = STATE(1255),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1255),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1255),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1255),
    [sym_augmented_assignment_expression] = STATE(1255),
    [sym_ternary_expression] = STATE(1255),
    [sym_binary_expression] = STATE(1255),
    [sym_unary_expression] = STATE(1255),
    [sym_update_expression] = STATE(1255),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1255),
    [sym_as_expression] = STATE(1255),
    [sym_internal_module] = STATE(1255),
    [sym_nested_type_identifier] = STATE(2410),
    [sym_generic_type] = STATE(2607),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(1394),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1398),
    [sym_this] = ACTIONS(1400),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1400),
    [sym_false] = ACTIONS(1400),
    [sym_null] = ACTIONS(1400),
    [sym_undefined] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [166] = {
    [sym_import] = STATE(1072),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1072),
    [sym_yield_expression] = STATE(1072),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1072),
    [sym_jsx_fragment] = STATE(1072),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1072),
    [sym_class] = STATE(1072),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1072),
    [sym_arrow_function] = STATE(1072),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1072),
    [sym_new_expression] = STATE(1072),
    [sym_await_expression] = STATE(1072),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1072),
    [sym_augmented_assignment_expression] = STATE(1072),
    [sym_ternary_expression] = STATE(1072),
    [sym_binary_expression] = STATE(1072),
    [sym_unary_expression] = STATE(1072),
    [sym_update_expression] = STATE(1072),
    [sym_string] = STATE(1072),
    [sym_template_string] = STATE(1072),
    [sym_regex] = STATE(1072),
    [sym_meta_property] = STATE(1072),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1072),
    [sym_as_expression] = STATE(1072),
    [sym_internal_module] = STATE(1072),
    [sym_nested_type_identifier] = STATE(2204),
    [sym_generic_type] = STATE(2554),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1404),
    [sym_this] = ACTIONS(1406),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [sym_null] = ACTIONS(1406),
    [sym_undefined] = ACTIONS(1406),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [167] = {
    [sym_import] = STATE(1153),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1153),
    [sym_yield_expression] = STATE(1153),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1153),
    [sym_jsx_fragment] = STATE(1153),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_nested_identifier] = STATE(3081),
    [sym_jsx_self_closing_element] = STATE(1153),
    [sym_class] = STATE(1153),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1153),
    [sym_arrow_function] = STATE(1153),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1153),
    [sym_new_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(1153),
    [sym_ternary_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_update_expression] = STATE(1153),
    [sym_string] = STATE(1153),
    [sym_template_string] = STATE(1153),
    [sym_regex] = STATE(1153),
    [sym_meta_property] = STATE(1153),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1153),
    [sym_as_expression] = STATE(1153),
    [sym_internal_module] = STATE(1153),
    [sym_nested_type_identifier] = STATE(2187),
    [sym_generic_type] = STATE(2551),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(1408),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1410),
    [sym_this] = ACTIONS(1412),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1412),
    [sym_false] = ACTIONS(1412),
    [sym_null] = ACTIONS(1412),
    [sym_undefined] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [168] = {
    [sym_import] = STATE(1209),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1209),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1209),
    [sym_jsx_fragment] = STATE(1209),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1209),
    [sym_class] = STATE(1209),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1209),
    [sym_arrow_function] = STATE(1209),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1209),
    [sym_new_expression] = STATE(1209),
    [sym_await_expression] = STATE(1209),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1209),
    [sym_augmented_assignment_expression] = STATE(1209),
    [sym_ternary_expression] = STATE(1209),
    [sym_binary_expression] = STATE(1209),
    [sym_unary_expression] = STATE(1209),
    [sym_update_expression] = STATE(1209),
    [sym_sequence_expression] = STATE(2963),
    [sym_string] = STATE(1209),
    [sym_template_string] = STATE(1209),
    [sym_regex] = STATE(1209),
    [sym_meta_property] = STATE(1209),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1209),
    [sym_as_expression] = STATE(1209),
    [sym_internal_module] = STATE(1209),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1414),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1416),
    [sym_this] = ACTIONS(1418),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [sym_null] = ACTIONS(1418),
    [sym_undefined] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(1414),
  },
  [169] = {
    [sym_import] = STATE(1292),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1292),
    [sym_jsx_fragment] = STATE(1292),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(3072),
    [sym_jsx_self_closing_element] = STATE(1292),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_nested_type_identifier] = STATE(2243),
    [sym_generic_type] = STATE(2581),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1422),
    [sym_this] = ACTIONS(1424),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [sym_undefined] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [170] = {
    [sym_import] = STATE(1619),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(1708),
    [sym_array] = STATE(1700),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1619),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1619),
    [sym_arrow_function] = STATE(1619),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1619),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1619),
    [sym_template_string] = STATE(1619),
    [sym_regex] = STATE(1619),
    [sym_meta_property] = STATE(1619),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1428),
    [anon_sym_namespace] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1428),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_var] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1438),
    [sym_this] = ACTIONS(1440),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [sym_null] = ACTIONS(1440),
    [sym_undefined] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_get] = ACTIONS(1428),
    [anon_sym_set] = ACTIONS(1428),
    [anon_sym_declare] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1428),
    [anon_sym_private] = ACTIONS(1428),
    [anon_sym_protected] = ACTIONS(1428),
    [anon_sym_module] = ACTIONS(1428),
    [anon_sym_any] = ACTIONS(1428),
    [anon_sym_number] = ACTIONS(1428),
    [anon_sym_boolean] = ACTIONS(1428),
    [anon_sym_string] = ACTIONS(1428),
    [anon_sym_symbol] = ACTIONS(1428),
    [sym_readonly] = ACTIONS(1428),
  },
  [171] = {
    [sym_import] = STATE(1307),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1307),
    [sym_jsx_fragment] = STATE(1307),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1307),
    [sym_class] = STATE(1307),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1307),
    [sym_arrow_function] = STATE(1307),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1307),
    [sym_new_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1307),
    [sym_augmented_assignment_expression] = STATE(1307),
    [sym_ternary_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_unary_expression] = STATE(1307),
    [sym_update_expression] = STATE(1307),
    [sym_sequence_expression] = STATE(3191),
    [sym_string] = STATE(1307),
    [sym_template_string] = STATE(1307),
    [sym_regex] = STATE(1307),
    [sym_meta_property] = STATE(1307),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1307),
    [sym_as_expression] = STATE(1307),
    [sym_internal_module] = STATE(1307),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1444),
    [sym_this] = ACTIONS(1446),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [sym_null] = ACTIONS(1446),
    [sym_undefined] = ACTIONS(1446),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [172] = {
    [sym_import] = STATE(1392),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1392),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1392),
    [sym_jsx_fragment] = STATE(1392),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1392),
    [sym_class] = STATE(1392),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1392),
    [sym_arrow_function] = STATE(1392),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1392),
    [sym_new_expression] = STATE(1392),
    [sym_await_expression] = STATE(1392),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1392),
    [sym_augmented_assignment_expression] = STATE(1392),
    [sym_ternary_expression] = STATE(1392),
    [sym_binary_expression] = STATE(1392),
    [sym_unary_expression] = STATE(1392),
    [sym_update_expression] = STATE(1392),
    [sym_sequence_expression] = STATE(3164),
    [sym_string] = STATE(1392),
    [sym_template_string] = STATE(1392),
    [sym_regex] = STATE(1392),
    [sym_meta_property] = STATE(1392),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1392),
    [sym_as_expression] = STATE(1392),
    [sym_internal_module] = STATE(1392),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1450),
    [sym_this] = ACTIONS(1452),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [173] = {
    [sym_export_clause] = STATE(2510),
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_object_repeat1] = STATE(2680),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(1458),
    [anon_sym_as] = ACTIONS(1460),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [174] = {
    [sym_export_clause] = STATE(2510),
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_object_repeat1] = STATE(2563),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(1458),
    [anon_sym_as] = ACTIONS(1460),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [175] = {
    [sym_import] = STATE(1321),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1321),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1321),
    [sym_jsx_fragment] = STATE(1321),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1321),
    [sym_class] = STATE(1321),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1321),
    [sym_arrow_function] = STATE(1321),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_ternary_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_update_expression] = STATE(1321),
    [sym_sequence_expression] = STATE(3096),
    [sym_string] = STATE(1321),
    [sym_template_string] = STATE(1321),
    [sym_regex] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1321),
    [sym_as_expression] = STATE(1321),
    [sym_internal_module] = STATE(1321),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(1497),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1499),
    [sym_this] = ACTIONS(1501),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [sym_null] = ACTIONS(1501),
    [sym_undefined] = ACTIONS(1501),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [176] = {
    [sym_export_clause] = STATE(2510),
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_object_repeat1] = STATE(2585),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(1458),
    [anon_sym_as] = ACTIONS(1460),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [177] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(789),
    [sym__expression] = STATE(1617),
    [sym_yield_expression] = STATE(1617),
    [sym_object] = STATE(1249),
    [sym_array] = STATE(1215),
    [sym_jsx_element] = STATE(1617),
    [sym_jsx_fragment] = STATE(1617),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1617),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(1139),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1617),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1617),
    [sym_member_expression] = STATE(789),
    [sym_subscript_expression] = STATE(789),
    [sym_assignment_expression] = STATE(1617),
    [sym_augmented_assignment_expression] = STATE(1617),
    [sym_ternary_expression] = STATE(1617),
    [sym_binary_expression] = STATE(1617),
    [sym_unary_expression] = STATE(1617),
    [sym_update_expression] = STATE(1617),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2570),
    [sym_non_null_expression] = STATE(1617),
    [sym_as_expression] = STATE(1617),
    [sym_internal_module] = STATE(1617),
    [sym_type_parameters] = STATE(2918),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1505),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1505),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1511),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1515),
    [sym_this] = ACTIONS(1517),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_null] = ACTIONS(1517),
    [sym_undefined] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_get] = ACTIONS(1505),
    [anon_sym_set] = ACTIONS(1505),
    [anon_sym_declare] = ACTIONS(1505),
    [anon_sym_public] = ACTIONS(1505),
    [anon_sym_private] = ACTIONS(1505),
    [anon_sym_protected] = ACTIONS(1505),
    [anon_sym_module] = ACTIONS(1505),
    [anon_sym_any] = ACTIONS(1505),
    [anon_sym_number] = ACTIONS(1505),
    [anon_sym_boolean] = ACTIONS(1505),
    [anon_sym_string] = ACTIONS(1505),
    [anon_sym_symbol] = ACTIONS(1505),
    [sym_readonly] = ACTIONS(1505),
  },
  [178] = {
    [sym_import] = STATE(1284),
    [sym_statement_block] = STATE(1111),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1284),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1284),
    [sym_jsx_fragment] = STATE(1284),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1284),
    [sym_class] = STATE(1284),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1284),
    [sym_arrow_function] = STATE(1284),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1284),
    [sym_new_expression] = STATE(1284),
    [sym_await_expression] = STATE(1284),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1284),
    [sym_augmented_assignment_expression] = STATE(1284),
    [sym_ternary_expression] = STATE(1284),
    [sym_binary_expression] = STATE(1284),
    [sym_unary_expression] = STATE(1284),
    [sym_update_expression] = STATE(1284),
    [sym_string] = STATE(1284),
    [sym_template_string] = STATE(1284),
    [sym_regex] = STATE(1284),
    [sym_meta_property] = STATE(1284),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1284),
    [sym_as_expression] = STATE(1284),
    [sym_internal_module] = STATE(1284),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1523),
    [sym_this] = ACTIONS(1525),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_undefined] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [179] = {
    [sym_import] = STATE(1259),
    [sym_statement_block] = STATE(1165),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1259),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1259),
    [sym_jsx_fragment] = STATE(1259),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1259),
    [sym_class] = STATE(1259),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1259),
    [sym_arrow_function] = STATE(1259),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1259),
    [sym_new_expression] = STATE(1259),
    [sym_await_expression] = STATE(1259),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1259),
    [sym_augmented_assignment_expression] = STATE(1259),
    [sym_ternary_expression] = STATE(1259),
    [sym_binary_expression] = STATE(1259),
    [sym_unary_expression] = STATE(1259),
    [sym_update_expression] = STATE(1259),
    [sym_string] = STATE(1259),
    [sym_template_string] = STATE(1259),
    [sym_regex] = STATE(1259),
    [sym_meta_property] = STATE(1259),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1259),
    [sym_as_expression] = STATE(1259),
    [sym_internal_module] = STATE(1259),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [180] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(666),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(972),
    [sym_array] = STATE(973),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(963),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(666),
    [sym_subscript_expression] = STATE(666),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [sym_readonly] = ACTIONS(1533),
  },
  [181] = {
    [sym_import] = STATE(1009),
    [sym_statement_block] = STATE(1108),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1009),
    [sym_yield_expression] = STATE(1009),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1009),
    [sym_jsx_fragment] = STATE(1009),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1009),
    [sym_class] = STATE(1009),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1009),
    [sym_arrow_function] = STATE(1009),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1009),
    [sym_new_expression] = STATE(1009),
    [sym_await_expression] = STATE(1009),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1009),
    [sym_augmented_assignment_expression] = STATE(1009),
    [sym_ternary_expression] = STATE(1009),
    [sym_binary_expression] = STATE(1009),
    [sym_unary_expression] = STATE(1009),
    [sym_update_expression] = STATE(1009),
    [sym_string] = STATE(1009),
    [sym_template_string] = STATE(1009),
    [sym_regex] = STATE(1009),
    [sym_meta_property] = STATE(1009),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1009),
    [sym_as_expression] = STATE(1009),
    [sym_internal_module] = STATE(1009),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1547),
    [sym_this] = ACTIONS(1549),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [sym_null] = ACTIONS(1549),
    [sym_undefined] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [182] = {
    [sym_import] = STATE(1008),
    [sym_statement_block] = STATE(1111),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1008),
    [sym_yield_expression] = STATE(1008),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1008),
    [sym_jsx_fragment] = STATE(1008),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1008),
    [sym_class] = STATE(1008),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1008),
    [sym_arrow_function] = STATE(1008),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1008),
    [sym_new_expression] = STATE(1008),
    [sym_await_expression] = STATE(1008),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1008),
    [sym_augmented_assignment_expression] = STATE(1008),
    [sym_ternary_expression] = STATE(1008),
    [sym_binary_expression] = STATE(1008),
    [sym_unary_expression] = STATE(1008),
    [sym_update_expression] = STATE(1008),
    [sym_string] = STATE(1008),
    [sym_template_string] = STATE(1008),
    [sym_regex] = STATE(1008),
    [sym_meta_property] = STATE(1008),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1008),
    [sym_as_expression] = STATE(1008),
    [sym_internal_module] = STATE(1008),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1551),
    [sym_this] = ACTIONS(1553),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [sym_null] = ACTIONS(1553),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [183] = {
    [sym_import] = STATE(1283),
    [sym_statement_block] = STATE(1630),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1283),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1283),
    [sym_jsx_fragment] = STATE(1283),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1283),
    [sym_class] = STATE(1283),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1283),
    [sym_arrow_function] = STATE(1283),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1283),
    [sym_new_expression] = STATE(1283),
    [sym_await_expression] = STATE(1283),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1283),
    [sym_augmented_assignment_expression] = STATE(1283),
    [sym_ternary_expression] = STATE(1283),
    [sym_binary_expression] = STATE(1283),
    [sym_unary_expression] = STATE(1283),
    [sym_update_expression] = STATE(1283),
    [sym_string] = STATE(1283),
    [sym_template_string] = STATE(1283),
    [sym_regex] = STATE(1283),
    [sym_meta_property] = STATE(1283),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1283),
    [sym_as_expression] = STATE(1283),
    [sym_internal_module] = STATE(1283),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1557),
    [sym_this] = ACTIONS(1559),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1559),
    [sym_false] = ACTIONS(1559),
    [sym_null] = ACTIONS(1559),
    [sym_undefined] = ACTIONS(1559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [184] = {
    [sym_import] = STATE(1007),
    [sym_statement_block] = STATE(1115),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1007),
    [sym_yield_expression] = STATE(1007),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1007),
    [sym_jsx_fragment] = STATE(1007),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1007),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1007),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1007),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1007),
    [sym_augmented_assignment_expression] = STATE(1007),
    [sym_ternary_expression] = STATE(1007),
    [sym_binary_expression] = STATE(1007),
    [sym_unary_expression] = STATE(1007),
    [sym_update_expression] = STATE(1007),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1007),
    [sym_as_expression] = STATE(1007),
    [sym_internal_module] = STATE(1007),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1561),
    [sym_this] = ACTIONS(1563),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1563),
    [sym_false] = ACTIONS(1563),
    [sym_null] = ACTIONS(1563),
    [sym_undefined] = ACTIONS(1563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [185] = {
    [sym_import] = STATE(1393),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1393),
    [sym_yield_expression] = STATE(1393),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1393),
    [sym_jsx_fragment] = STATE(1393),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1393),
    [sym_class] = STATE(1393),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1393),
    [sym_arrow_function] = STATE(1393),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1393),
    [sym_new_expression] = STATE(1393),
    [sym_await_expression] = STATE(1393),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1393),
    [sym_augmented_assignment_expression] = STATE(1393),
    [sym_ternary_expression] = STATE(1393),
    [sym_binary_expression] = STATE(1393),
    [sym_unary_expression] = STATE(1393),
    [sym_update_expression] = STATE(1393),
    [sym_sequence_expression] = STATE(3163),
    [sym_string] = STATE(1393),
    [sym_template_string] = STATE(1393),
    [sym_regex] = STATE(1393),
    [sym_meta_property] = STATE(1393),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1393),
    [sym_as_expression] = STATE(1393),
    [sym_internal_module] = STATE(1393),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1565),
    [sym_this] = ACTIONS(1567),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1567),
    [sym_false] = ACTIONS(1567),
    [sym_null] = ACTIONS(1567),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [186] = {
    [sym_import] = STATE(1394),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1394),
    [sym_jsx_fragment] = STATE(1394),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1394),
    [sym_class] = STATE(1394),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1394),
    [sym_arrow_function] = STATE(1394),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1394),
    [sym_new_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1394),
    [sym_augmented_assignment_expression] = STATE(1394),
    [sym_ternary_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_unary_expression] = STATE(1394),
    [sym_update_expression] = STATE(1394),
    [sym_sequence_expression] = STATE(3157),
    [sym_string] = STATE(1394),
    [sym_template_string] = STATE(1394),
    [sym_regex] = STATE(1394),
    [sym_meta_property] = STATE(1394),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1394),
    [sym_as_expression] = STATE(1394),
    [sym_internal_module] = STATE(1394),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1569),
    [sym_this] = ACTIONS(1571),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1571),
    [sym_false] = ACTIONS(1571),
    [sym_null] = ACTIONS(1571),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [187] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [188] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(666),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(972),
    [sym_array] = STATE(973),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(963),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(666),
    [sym_subscript_expression] = STATE(666),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1583),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [sym_readonly] = ACTIONS(1577),
  },
  [189] = {
    [sym_import] = STATE(1079),
    [sym_statement_block] = STATE(1449),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1079),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1079),
    [sym_jsx_fragment] = STATE(1079),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1079),
    [sym_class] = STATE(1079),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1079),
    [sym_arrow_function] = STATE(1079),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1079),
    [sym_new_expression] = STATE(1079),
    [sym_await_expression] = STATE(1079),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1079),
    [sym_augmented_assignment_expression] = STATE(1079),
    [sym_ternary_expression] = STATE(1079),
    [sym_binary_expression] = STATE(1079),
    [sym_unary_expression] = STATE(1079),
    [sym_update_expression] = STATE(1079),
    [sym_string] = STATE(1079),
    [sym_template_string] = STATE(1079),
    [sym_regex] = STATE(1079),
    [sym_meta_property] = STATE(1079),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1079),
    [sym_as_expression] = STATE(1079),
    [sym_internal_module] = STATE(1079),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1587),
    [sym_this] = ACTIONS(1589),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1589),
    [sym_false] = ACTIONS(1589),
    [sym_null] = ACTIONS(1589),
    [sym_undefined] = ACTIONS(1589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [190] = {
    [sym_import] = STATE(1082),
    [sym_statement_block] = STATE(1450),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1082),
    [sym_yield_expression] = STATE(1082),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1082),
    [sym_jsx_fragment] = STATE(1082),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1082),
    [sym_class] = STATE(1082),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1082),
    [sym_arrow_function] = STATE(1082),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1082),
    [sym_new_expression] = STATE(1082),
    [sym_await_expression] = STATE(1082),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1082),
    [sym_augmented_assignment_expression] = STATE(1082),
    [sym_ternary_expression] = STATE(1082),
    [sym_binary_expression] = STATE(1082),
    [sym_unary_expression] = STATE(1082),
    [sym_update_expression] = STATE(1082),
    [sym_string] = STATE(1082),
    [sym_template_string] = STATE(1082),
    [sym_regex] = STATE(1082),
    [sym_meta_property] = STATE(1082),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1082),
    [sym_as_expression] = STATE(1082),
    [sym_internal_module] = STATE(1082),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1591),
    [sym_this] = ACTIONS(1593),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [sym_null] = ACTIONS(1593),
    [sym_undefined] = ACTIONS(1593),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [191] = {
    [sym_import] = STATE(1087),
    [sym_statement_block] = STATE(1454),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1087),
    [sym_yield_expression] = STATE(1087),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1087),
    [sym_jsx_fragment] = STATE(1087),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1087),
    [sym_class] = STATE(1087),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1087),
    [sym_arrow_function] = STATE(1087),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1087),
    [sym_new_expression] = STATE(1087),
    [sym_await_expression] = STATE(1087),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1087),
    [sym_augmented_assignment_expression] = STATE(1087),
    [sym_ternary_expression] = STATE(1087),
    [sym_binary_expression] = STATE(1087),
    [sym_unary_expression] = STATE(1087),
    [sym_update_expression] = STATE(1087),
    [sym_string] = STATE(1087),
    [sym_template_string] = STATE(1087),
    [sym_regex] = STATE(1087),
    [sym_meta_property] = STATE(1087),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1087),
    [sym_as_expression] = STATE(1087),
    [sym_internal_module] = STATE(1087),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1595),
    [sym_this] = ACTIONS(1597),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [sym_null] = ACTIONS(1597),
    [sym_undefined] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [192] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1599),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [193] = {
    [sym_import] = STATE(1234),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1234),
    [sym_jsx_fragment] = STATE(1234),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1234),
    [sym_class] = STATE(1234),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1234),
    [sym_arrow_function] = STATE(1234),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_sequence_expression] = STATE(2964),
    [sym_string] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_meta_property] = STATE(1234),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1601),
    [sym_this] = ACTIONS(1603),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1603),
    [sym_false] = ACTIONS(1603),
    [sym_null] = ACTIONS(1603),
    [sym_undefined] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [194] = {
    [sym_import] = STATE(1484),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1598),
    [sym_yield_expression] = STATE(1598),
    [sym_object] = STATE(1396),
    [sym_array] = STATE(1395),
    [sym_jsx_element] = STATE(1598),
    [sym_jsx_fragment] = STATE(1598),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1598),
    [sym_class] = STATE(1484),
    [sym_function] = STATE(1214),
    [sym_generator_function] = STATE(1484),
    [sym_arrow_function] = STATE(1484),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1598),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1598),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1598),
    [sym_augmented_assignment_expression] = STATE(1598),
    [sym_ternary_expression] = STATE(1598),
    [sym_binary_expression] = STATE(1598),
    [sym_unary_expression] = STATE(1598),
    [sym_update_expression] = STATE(1598),
    [sym_string] = STATE(1484),
    [sym_template_string] = STATE(1484),
    [sym_regex] = STATE(1484),
    [sym_meta_property] = STATE(1484),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1598),
    [sym_as_expression] = STATE(1598),
    [sym_internal_module] = STATE(1598),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(1605),
    [anon_sym_export] = ACTIONS(1607),
    [anon_sym_namespace] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1607),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(1611),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1619),
    [sym_super] = ACTIONS(1621),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [sym_null] = ACTIONS(1619),
    [sym_undefined] = ACTIONS(1619),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(1607),
    [anon_sym_set] = ACTIONS(1607),
    [anon_sym_declare] = ACTIONS(1607),
    [anon_sym_public] = ACTIONS(1607),
    [anon_sym_private] = ACTIONS(1607),
    [anon_sym_protected] = ACTIONS(1607),
    [anon_sym_module] = ACTIONS(1607),
    [anon_sym_any] = ACTIONS(1607),
    [anon_sym_number] = ACTIONS(1607),
    [anon_sym_boolean] = ACTIONS(1607),
    [anon_sym_string] = ACTIONS(1607),
    [anon_sym_symbol] = ACTIONS(1607),
    [sym_readonly] = ACTIONS(1607),
  },
  [195] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1220),
    [sym_jsx_fragment] = STATE(1220),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(2958),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1623),
    [sym_this] = ACTIONS(1625),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1625),
    [sym_false] = ACTIONS(1625),
    [sym_null] = ACTIONS(1625),
    [sym_undefined] = ACTIONS(1625),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [196] = {
    [sym_import] = STATE(1484),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1598),
    [sym_yield_expression] = STATE(1598),
    [sym_object] = STATE(1396),
    [sym_array] = STATE(1395),
    [sym_jsx_element] = STATE(1598),
    [sym_jsx_fragment] = STATE(1598),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1598),
    [sym_class] = STATE(1484),
    [sym_function] = STATE(1214),
    [sym_generator_function] = STATE(1484),
    [sym_arrow_function] = STATE(1484),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1598),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1598),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1598),
    [sym_augmented_assignment_expression] = STATE(1598),
    [sym_ternary_expression] = STATE(1598),
    [sym_binary_expression] = STATE(1598),
    [sym_unary_expression] = STATE(1598),
    [sym_update_expression] = STATE(1598),
    [sym_string] = STATE(1484),
    [sym_template_string] = STATE(1484),
    [sym_regex] = STATE(1484),
    [sym_meta_property] = STATE(1484),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2570),
    [sym_non_null_expression] = STATE(1598),
    [sym_as_expression] = STATE(1598),
    [sym_internal_module] = STATE(1598),
    [sym_type_parameters] = STATE(2918),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(1605),
    [anon_sym_export] = ACTIONS(1607),
    [anon_sym_namespace] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1607),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(1611),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1619),
    [sym_super] = ACTIONS(1621),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [sym_null] = ACTIONS(1619),
    [sym_undefined] = ACTIONS(1619),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(1607),
    [anon_sym_set] = ACTIONS(1607),
    [anon_sym_declare] = ACTIONS(1607),
    [anon_sym_public] = ACTIONS(1607),
    [anon_sym_private] = ACTIONS(1607),
    [anon_sym_protected] = ACTIONS(1607),
    [anon_sym_module] = ACTIONS(1607),
    [anon_sym_any] = ACTIONS(1607),
    [anon_sym_number] = ACTIONS(1607),
    [anon_sym_boolean] = ACTIONS(1607),
    [anon_sym_string] = ACTIONS(1607),
    [anon_sym_symbol] = ACTIONS(1607),
    [sym_readonly] = ACTIONS(1607),
  },
  [197] = {
    [sym_import] = STATE(1439),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1439),
    [sym_yield_expression] = STATE(1439),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1439),
    [sym_jsx_fragment] = STATE(1439),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1439),
    [sym_class] = STATE(1439),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1439),
    [sym_arrow_function] = STATE(1439),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1439),
    [sym_new_expression] = STATE(1439),
    [sym_await_expression] = STATE(1439),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1439),
    [sym_augmented_assignment_expression] = STATE(1439),
    [sym_ternary_expression] = STATE(1439),
    [sym_binary_expression] = STATE(1439),
    [sym_unary_expression] = STATE(1439),
    [sym_update_expression] = STATE(1439),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1439),
    [sym_regex] = STATE(1439),
    [sym_meta_property] = STATE(1439),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1439),
    [sym_as_expression] = STATE(1439),
    [sym_internal_module] = STATE(1439),
    [sym_mapped_type_clause] = STATE(3036),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1629),
    [anon_sym_namespace] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1629),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1635),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1637),
    [sym_this] = ACTIONS(1639),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1639),
    [sym_false] = ACTIONS(1639),
    [sym_null] = ACTIONS(1639),
    [sym_undefined] = ACTIONS(1639),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1629),
    [anon_sym_get] = ACTIONS(1629),
    [anon_sym_set] = ACTIONS(1629),
    [anon_sym_declare] = ACTIONS(1629),
    [anon_sym_public] = ACTIONS(1629),
    [anon_sym_private] = ACTIONS(1629),
    [anon_sym_protected] = ACTIONS(1629),
    [anon_sym_module] = ACTIONS(1629),
    [anon_sym_any] = ACTIONS(1629),
    [anon_sym_number] = ACTIONS(1629),
    [anon_sym_boolean] = ACTIONS(1629),
    [anon_sym_string] = ACTIONS(1629),
    [anon_sym_symbol] = ACTIONS(1629),
    [sym_readonly] = ACTIONS(1629),
  },
  [198] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(1924),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1641),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [199] = {
    [sym_import] = STATE(1251),
    [sym_statement_block] = STATE(1130),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1251),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1251),
    [sym_jsx_fragment] = STATE(1251),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1251),
    [sym_class] = STATE(1251),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1251),
    [sym_arrow_function] = STATE(1251),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1251),
    [sym_new_expression] = STATE(1251),
    [sym_await_expression] = STATE(1251),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1251),
    [sym_augmented_assignment_expression] = STATE(1251),
    [sym_ternary_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_unary_expression] = STATE(1251),
    [sym_update_expression] = STATE(1251),
    [sym_string] = STATE(1251),
    [sym_template_string] = STATE(1251),
    [sym_regex] = STATE(1251),
    [sym_meta_property] = STATE(1251),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1251),
    [sym_as_expression] = STATE(1251),
    [sym_internal_module] = STATE(1251),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1643),
    [sym_this] = ACTIONS(1645),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1645),
    [sym_false] = ACTIONS(1645),
    [sym_null] = ACTIONS(1645),
    [sym_undefined] = ACTIONS(1645),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [200] = {
    [sym_import] = STATE(1391),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1391),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1391),
    [sym_jsx_fragment] = STATE(1391),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1391),
    [sym_class] = STATE(1391),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1391),
    [sym_arrow_function] = STATE(1391),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_await_expression] = STATE(1391),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1391),
    [sym_augmented_assignment_expression] = STATE(1391),
    [sym_ternary_expression] = STATE(1391),
    [sym_binary_expression] = STATE(1391),
    [sym_unary_expression] = STATE(1391),
    [sym_update_expression] = STATE(1391),
    [sym_sequence_expression] = STATE(3169),
    [sym_string] = STATE(1391),
    [sym_template_string] = STATE(1391),
    [sym_regex] = STATE(1391),
    [sym_meta_property] = STATE(1391),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1391),
    [sym_as_expression] = STATE(1391),
    [sym_internal_module] = STATE(1391),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1647),
    [sym_this] = ACTIONS(1649),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1649),
    [sym_false] = ACTIONS(1649),
    [sym_null] = ACTIONS(1649),
    [sym_undefined] = ACTIONS(1649),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [201] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(789),
    [sym__expression] = STATE(1617),
    [sym_yield_expression] = STATE(1617),
    [sym_object] = STATE(1249),
    [sym_array] = STATE(1215),
    [sym_jsx_element] = STATE(1617),
    [sym_jsx_fragment] = STATE(1617),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1617),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(1139),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1617),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1617),
    [sym_member_expression] = STATE(789),
    [sym_subscript_expression] = STATE(789),
    [sym_assignment_expression] = STATE(1617),
    [sym_augmented_assignment_expression] = STATE(1617),
    [sym_ternary_expression] = STATE(1617),
    [sym_binary_expression] = STATE(1617),
    [sym_unary_expression] = STATE(1617),
    [sym_update_expression] = STATE(1617),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1617),
    [sym_as_expression] = STATE(1617),
    [sym_internal_module] = STATE(1617),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1651),
    [anon_sym_export] = ACTIONS(1653),
    [anon_sym_namespace] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1653),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1657),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1659),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1515),
    [sym_this] = ACTIONS(1517),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_null] = ACTIONS(1517),
    [sym_undefined] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1653),
    [anon_sym_get] = ACTIONS(1653),
    [anon_sym_set] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(1653),
    [anon_sym_public] = ACTIONS(1653),
    [anon_sym_private] = ACTIONS(1653),
    [anon_sym_protected] = ACTIONS(1653),
    [anon_sym_module] = ACTIONS(1653),
    [anon_sym_any] = ACTIONS(1653),
    [anon_sym_number] = ACTIONS(1653),
    [anon_sym_boolean] = ACTIONS(1653),
    [anon_sym_string] = ACTIONS(1653),
    [anon_sym_symbol] = ACTIONS(1653),
    [sym_readonly] = ACTIONS(1653),
  },
  [202] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(666),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(972),
    [sym_array] = STATE(973),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(963),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(666),
    [sym_subscript_expression] = STATE(666),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2686),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2879),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1583),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [sym_readonly] = ACTIONS(1577),
  },
  [203] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1661),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [204] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1663),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [205] = {
    [sym_import] = STATE(1000),
    [sym_statement_block] = STATE(1020),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1000),
    [sym_yield_expression] = STATE(1000),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1000),
    [sym_jsx_fragment] = STATE(1000),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1000),
    [sym_class] = STATE(1000),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1000),
    [sym_arrow_function] = STATE(1000),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1000),
    [sym_new_expression] = STATE(1000),
    [sym_await_expression] = STATE(1000),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1000),
    [sym_augmented_assignment_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym_update_expression] = STATE(1000),
    [sym_string] = STATE(1000),
    [sym_template_string] = STATE(1000),
    [sym_regex] = STATE(1000),
    [sym_meta_property] = STATE(1000),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1000),
    [sym_as_expression] = STATE(1000),
    [sym_internal_module] = STATE(1000),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1665),
    [sym_this] = ACTIONS(1667),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1667),
    [sym_false] = ACTIONS(1667),
    [sym_null] = ACTIONS(1667),
    [sym_undefined] = ACTIONS(1667),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [206] = {
    [sym_import] = STATE(1338),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1338),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1338),
    [sym_jsx_fragment] = STATE(1338),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1338),
    [sym_class] = STATE(1338),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1338),
    [sym_arrow_function] = STATE(1338),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1338),
    [sym_new_expression] = STATE(1338),
    [sym_await_expression] = STATE(1338),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1338),
    [sym_augmented_assignment_expression] = STATE(1338),
    [sym_ternary_expression] = STATE(1338),
    [sym_binary_expression] = STATE(1338),
    [sym_unary_expression] = STATE(1338),
    [sym_update_expression] = STATE(1338),
    [sym_sequence_expression] = STATE(3005),
    [sym_string] = STATE(1338),
    [sym_template_string] = STATE(1338),
    [sym_regex] = STATE(1338),
    [sym_meta_property] = STATE(1338),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1338),
    [sym_as_expression] = STATE(1338),
    [sym_internal_module] = STATE(1338),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1669),
    [sym_this] = ACTIONS(1671),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1671),
    [sym_false] = ACTIONS(1671),
    [sym_null] = ACTIONS(1671),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [207] = {
    [sym_import] = STATE(1406),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1406),
    [sym_yield_expression] = STATE(1406),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1406),
    [sym_jsx_fragment] = STATE(1406),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1406),
    [sym_class] = STATE(1406),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1406),
    [sym_arrow_function] = STATE(1406),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1406),
    [sym_new_expression] = STATE(1406),
    [sym_await_expression] = STATE(1406),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1406),
    [sym_augmented_assignment_expression] = STATE(1406),
    [sym_ternary_expression] = STATE(1406),
    [sym_binary_expression] = STATE(1406),
    [sym_unary_expression] = STATE(1406),
    [sym_update_expression] = STATE(1406),
    [sym_sequence_expression] = STATE(3061),
    [sym_string] = STATE(1406),
    [sym_template_string] = STATE(1406),
    [sym_regex] = STATE(1406),
    [sym_meta_property] = STATE(1406),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1406),
    [sym_as_expression] = STATE(1406),
    [sym_internal_module] = STATE(1406),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1673),
    [sym_this] = ACTIONS(1675),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1675),
    [sym_false] = ACTIONS(1675),
    [sym_null] = ACTIONS(1675),
    [sym_undefined] = ACTIONS(1675),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [208] = {
    [sym_import] = STATE(1263),
    [sym_statement_block] = STATE(1661),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1263),
    [sym_yield_expression] = STATE(1263),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1263),
    [sym_jsx_fragment] = STATE(1263),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1263),
    [sym_class] = STATE(1263),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1263),
    [sym_arrow_function] = STATE(1263),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1263),
    [sym_new_expression] = STATE(1263),
    [sym_await_expression] = STATE(1263),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1263),
    [sym_augmented_assignment_expression] = STATE(1263),
    [sym_ternary_expression] = STATE(1263),
    [sym_binary_expression] = STATE(1263),
    [sym_unary_expression] = STATE(1263),
    [sym_update_expression] = STATE(1263),
    [sym_string] = STATE(1263),
    [sym_template_string] = STATE(1263),
    [sym_regex] = STATE(1263),
    [sym_meta_property] = STATE(1263),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1263),
    [sym_as_expression] = STATE(1263),
    [sym_internal_module] = STATE(1263),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1677),
    [sym_this] = ACTIONS(1679),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_undefined] = ACTIONS(1679),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [209] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(666),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(972),
    [sym_array] = STATE(973),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(963),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(666),
    [sym_subscript_expression] = STATE(666),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2570),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2918),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1583),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [sym_readonly] = ACTIONS(1577),
  },
  [210] = {
    [sym_import] = STATE(1280),
    [sym_statement_block] = STATE(1020),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1280),
    [sym_yield_expression] = STATE(1280),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1280),
    [sym_jsx_fragment] = STATE(1280),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1280),
    [sym_class] = STATE(1280),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1280),
    [sym_arrow_function] = STATE(1280),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1280),
    [sym_new_expression] = STATE(1280),
    [sym_await_expression] = STATE(1280),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1280),
    [sym_augmented_assignment_expression] = STATE(1280),
    [sym_ternary_expression] = STATE(1280),
    [sym_binary_expression] = STATE(1280),
    [sym_unary_expression] = STATE(1280),
    [sym_update_expression] = STATE(1280),
    [sym_string] = STATE(1280),
    [sym_template_string] = STATE(1280),
    [sym_regex] = STATE(1280),
    [sym_meta_property] = STATE(1280),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1280),
    [sym_as_expression] = STATE(1280),
    [sym_internal_module] = STATE(1280),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1681),
    [sym_this] = ACTIONS(1683),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [211] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(666),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(972),
    [sym_array] = STATE(973),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(963),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(666),
    [sym_subscript_expression] = STATE(666),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1685),
    [anon_sym_export] = ACTIONS(1687),
    [anon_sym_namespace] = ACTIONS(1689),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1687),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1693),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_get] = ACTIONS(1687),
    [anon_sym_set] = ACTIONS(1687),
    [anon_sym_declare] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1687),
    [anon_sym_private] = ACTIONS(1687),
    [anon_sym_protected] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1687),
    [anon_sym_any] = ACTIONS(1687),
    [anon_sym_number] = ACTIONS(1687),
    [anon_sym_boolean] = ACTIONS(1687),
    [anon_sym_string] = ACTIONS(1687),
    [anon_sym_symbol] = ACTIONS(1687),
    [sym_readonly] = ACTIONS(1687),
  },
  [212] = {
    [sym_import] = STATE(1126),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1126),
    [sym_jsx_fragment] = STATE(1126),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1126),
    [sym_class] = STATE(1126),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1126),
    [sym_arrow_function] = STATE(1126),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1126),
    [sym_new_expression] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_sequence_expression] = STATE(3147),
    [sym_string] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_meta_property] = STATE(1126),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1695),
    [sym_this] = ACTIONS(1697),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1697),
    [sym_false] = ACTIONS(1697),
    [sym_null] = ACTIONS(1697),
    [sym_undefined] = ACTIONS(1697),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [213] = {
    [sym_import] = STATE(989),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(989),
    [sym_yield_expression] = STATE(989),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(989),
    [sym_jsx_fragment] = STATE(989),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(989),
    [sym_class] = STATE(989),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(989),
    [sym_arrow_function] = STATE(989),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(989),
    [sym_new_expression] = STATE(989),
    [sym_await_expression] = STATE(989),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(989),
    [sym_augmented_assignment_expression] = STATE(989),
    [sym_ternary_expression] = STATE(989),
    [sym_binary_expression] = STATE(989),
    [sym_unary_expression] = STATE(989),
    [sym_update_expression] = STATE(989),
    [sym_sequence_expression] = STATE(2530),
    [sym_string] = STATE(989),
    [sym_template_string] = STATE(989),
    [sym_regex] = STATE(989),
    [sym_meta_property] = STATE(989),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(989),
    [sym_as_expression] = STATE(989),
    [sym_internal_module] = STATE(989),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1699),
    [sym_this] = ACTIONS(1701),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1701),
    [sym_false] = ACTIONS(1701),
    [sym_null] = ACTIONS(1701),
    [sym_undefined] = ACTIONS(1701),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [214] = {
    [sym_import] = STATE(1407),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1407),
    [sym_yield_expression] = STATE(1407),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1407),
    [sym_jsx_fragment] = STATE(1407),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1407),
    [sym_class] = STATE(1407),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1407),
    [sym_arrow_function] = STATE(1407),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1407),
    [sym_new_expression] = STATE(1407),
    [sym_await_expression] = STATE(1407),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1407),
    [sym_augmented_assignment_expression] = STATE(1407),
    [sym_ternary_expression] = STATE(1407),
    [sym_binary_expression] = STATE(1407),
    [sym_unary_expression] = STATE(1407),
    [sym_update_expression] = STATE(1407),
    [sym_sequence_expression] = STATE(3062),
    [sym_string] = STATE(1407),
    [sym_template_string] = STATE(1407),
    [sym_regex] = STATE(1407),
    [sym_meta_property] = STATE(1407),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1407),
    [sym_as_expression] = STATE(1407),
    [sym_internal_module] = STATE(1407),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1703),
    [sym_this] = ACTIONS(1705),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1705),
    [sym_false] = ACTIONS(1705),
    [sym_null] = ACTIONS(1705),
    [sym_undefined] = ACTIONS(1705),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [215] = {
    [sym_import] = STATE(1281),
    [sym_statement_block] = STATE(1115),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1281),
    [sym_yield_expression] = STATE(1281),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1281),
    [sym_jsx_fragment] = STATE(1281),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1281),
    [sym_class] = STATE(1281),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1281),
    [sym_arrow_function] = STATE(1281),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1281),
    [sym_new_expression] = STATE(1281),
    [sym_await_expression] = STATE(1281),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1281),
    [sym_augmented_assignment_expression] = STATE(1281),
    [sym_ternary_expression] = STATE(1281),
    [sym_binary_expression] = STATE(1281),
    [sym_unary_expression] = STATE(1281),
    [sym_update_expression] = STATE(1281),
    [sym_string] = STATE(1281),
    [sym_template_string] = STATE(1281),
    [sym_regex] = STATE(1281),
    [sym_meta_property] = STATE(1281),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1281),
    [sym_as_expression] = STATE(1281),
    [sym_internal_module] = STATE(1281),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1707),
    [sym_this] = ACTIONS(1709),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1709),
    [sym_false] = ACTIONS(1709),
    [sym_null] = ACTIONS(1709),
    [sym_undefined] = ACTIONS(1709),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [216] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(789),
    [sym__expression] = STATE(1617),
    [sym_yield_expression] = STATE(1617),
    [sym_object] = STATE(1249),
    [sym_array] = STATE(1215),
    [sym_jsx_element] = STATE(1617),
    [sym_jsx_fragment] = STATE(1617),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1617),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(1139),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1617),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1617),
    [sym_member_expression] = STATE(789),
    [sym_subscript_expression] = STATE(789),
    [sym_assignment_expression] = STATE(1617),
    [sym_augmented_assignment_expression] = STATE(1617),
    [sym_ternary_expression] = STATE(1617),
    [sym_binary_expression] = STATE(1617),
    [sym_unary_expression] = STATE(1617),
    [sym_update_expression] = STATE(1617),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1617),
    [sym_as_expression] = STATE(1617),
    [sym_internal_module] = STATE(1617),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1505),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1505),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1511),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1515),
    [sym_this] = ACTIONS(1517),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_null] = ACTIONS(1517),
    [sym_undefined] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_get] = ACTIONS(1505),
    [anon_sym_set] = ACTIONS(1505),
    [anon_sym_declare] = ACTIONS(1505),
    [anon_sym_public] = ACTIONS(1505),
    [anon_sym_private] = ACTIONS(1505),
    [anon_sym_protected] = ACTIONS(1505),
    [anon_sym_module] = ACTIONS(1505),
    [anon_sym_any] = ACTIONS(1505),
    [anon_sym_number] = ACTIONS(1505),
    [anon_sym_boolean] = ACTIONS(1505),
    [anon_sym_string] = ACTIONS(1505),
    [anon_sym_symbol] = ACTIONS(1505),
    [sym_readonly] = ACTIONS(1505),
  },
  [217] = {
    [sym_import] = STATE(986),
    [sym_statement_block] = STATE(1165),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(986),
    [sym_yield_expression] = STATE(986),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(986),
    [sym_jsx_fragment] = STATE(986),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(986),
    [sym_class] = STATE(986),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(986),
    [sym_arrow_function] = STATE(986),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(986),
    [sym_new_expression] = STATE(986),
    [sym_await_expression] = STATE(986),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(986),
    [sym_augmented_assignment_expression] = STATE(986),
    [sym_ternary_expression] = STATE(986),
    [sym_binary_expression] = STATE(986),
    [sym_unary_expression] = STATE(986),
    [sym_update_expression] = STATE(986),
    [sym_string] = STATE(986),
    [sym_template_string] = STATE(986),
    [sym_regex] = STATE(986),
    [sym_meta_property] = STATE(986),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(986),
    [sym_as_expression] = STATE(986),
    [sym_internal_module] = STATE(986),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1711),
    [sym_this] = ACTIONS(1713),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1713),
    [sym_false] = ACTIONS(1713),
    [sym_null] = ACTIONS(1713),
    [sym_undefined] = ACTIONS(1713),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [218] = {
    [sym_import] = STATE(1408),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1408),
    [sym_yield_expression] = STATE(1408),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1408),
    [sym_jsx_fragment] = STATE(1408),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1408),
    [sym_class] = STATE(1408),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1408),
    [sym_arrow_function] = STATE(1408),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1408),
    [sym_new_expression] = STATE(1408),
    [sym_await_expression] = STATE(1408),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1408),
    [sym_augmented_assignment_expression] = STATE(1408),
    [sym_ternary_expression] = STATE(1408),
    [sym_binary_expression] = STATE(1408),
    [sym_unary_expression] = STATE(1408),
    [sym_update_expression] = STATE(1408),
    [sym_sequence_expression] = STATE(3073),
    [sym_string] = STATE(1408),
    [sym_template_string] = STATE(1408),
    [sym_regex] = STATE(1408),
    [sym_meta_property] = STATE(1408),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1408),
    [sym_as_expression] = STATE(1408),
    [sym_internal_module] = STATE(1408),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1715),
    [sym_this] = ACTIONS(1717),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1717),
    [sym_false] = ACTIONS(1717),
    [sym_null] = ACTIONS(1717),
    [sym_undefined] = ACTIONS(1717),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [219] = {
    [sym_import] = STATE(1619),
    [sym_variable_declarator] = STATE(2468),
    [sym_parenthesized_expression] = STATE(925),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(1001),
    [sym_array] = STATE(1004),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1619),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1619),
    [sym_arrow_function] = STATE(1619),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1619),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(925),
    [sym_subscript_expression] = STATE(925),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1619),
    [sym_template_string] = STATE(1619),
    [sym_regex] = STATE(1619),
    [sym_meta_property] = STATE(1619),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1721),
    [anon_sym_namespace] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1727),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1438),
    [sym_this] = ACTIONS(1440),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [sym_null] = ACTIONS(1440),
    [sym_undefined] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1721),
    [anon_sym_get] = ACTIONS(1721),
    [anon_sym_set] = ACTIONS(1721),
    [anon_sym_declare] = ACTIONS(1721),
    [anon_sym_public] = ACTIONS(1721),
    [anon_sym_private] = ACTIONS(1721),
    [anon_sym_protected] = ACTIONS(1721),
    [anon_sym_module] = ACTIONS(1721),
    [anon_sym_any] = ACTIONS(1721),
    [anon_sym_number] = ACTIONS(1721),
    [anon_sym_boolean] = ACTIONS(1721),
    [anon_sym_string] = ACTIONS(1721),
    [anon_sym_symbol] = ACTIONS(1721),
    [sym_readonly] = ACTIONS(1721),
  },
  [220] = {
    [sym_import] = STATE(1619),
    [sym_variable_declarator] = STATE(2461),
    [sym_parenthesized_expression] = STATE(925),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(1001),
    [sym_array] = STATE(1004),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1619),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1619),
    [sym_arrow_function] = STATE(1619),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1619),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(925),
    [sym_subscript_expression] = STATE(925),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1619),
    [sym_template_string] = STATE(1619),
    [sym_regex] = STATE(1619),
    [sym_meta_property] = STATE(1619),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1721),
    [anon_sym_namespace] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1727),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1438),
    [sym_this] = ACTIONS(1440),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [sym_null] = ACTIONS(1440),
    [sym_undefined] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1721),
    [anon_sym_get] = ACTIONS(1721),
    [anon_sym_set] = ACTIONS(1721),
    [anon_sym_declare] = ACTIONS(1721),
    [anon_sym_public] = ACTIONS(1721),
    [anon_sym_private] = ACTIONS(1721),
    [anon_sym_protected] = ACTIONS(1721),
    [anon_sym_module] = ACTIONS(1721),
    [anon_sym_any] = ACTIONS(1721),
    [anon_sym_number] = ACTIONS(1721),
    [anon_sym_boolean] = ACTIONS(1721),
    [anon_sym_string] = ACTIONS(1721),
    [anon_sym_symbol] = ACTIONS(1721),
    [sym_readonly] = ACTIONS(1721),
  },
  [221] = {
    [sym_import] = STATE(1370),
    [sym_statement_block] = STATE(1488),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1370),
    [sym_yield_expression] = STATE(1370),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1370),
    [sym_jsx_fragment] = STATE(1370),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1370),
    [sym_class] = STATE(1370),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1370),
    [sym_arrow_function] = STATE(1370),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1370),
    [sym_new_expression] = STATE(1370),
    [sym_await_expression] = STATE(1370),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1370),
    [sym_augmented_assignment_expression] = STATE(1370),
    [sym_ternary_expression] = STATE(1370),
    [sym_binary_expression] = STATE(1370),
    [sym_unary_expression] = STATE(1370),
    [sym_update_expression] = STATE(1370),
    [sym_string] = STATE(1370),
    [sym_template_string] = STATE(1370),
    [sym_regex] = STATE(1370),
    [sym_meta_property] = STATE(1370),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1370),
    [sym_as_expression] = STATE(1370),
    [sym_internal_module] = STATE(1370),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1729),
    [sym_this] = ACTIONS(1731),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1731),
    [sym_false] = ACTIONS(1731),
    [sym_null] = ACTIONS(1731),
    [sym_undefined] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [222] = {
    [sym_import] = STATE(1409),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1409),
    [sym_yield_expression] = STATE(1409),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1409),
    [sym_jsx_fragment] = STATE(1409),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1409),
    [sym_class] = STATE(1409),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1409),
    [sym_arrow_function] = STATE(1409),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1409),
    [sym_new_expression] = STATE(1409),
    [sym_await_expression] = STATE(1409),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1409),
    [sym_augmented_assignment_expression] = STATE(1409),
    [sym_ternary_expression] = STATE(1409),
    [sym_binary_expression] = STATE(1409),
    [sym_unary_expression] = STATE(1409),
    [sym_update_expression] = STATE(1409),
    [sym_sequence_expression] = STATE(3075),
    [sym_string] = STATE(1409),
    [sym_template_string] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_meta_property] = STATE(1409),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1409),
    [sym_as_expression] = STATE(1409),
    [sym_internal_module] = STATE(1409),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1733),
    [sym_this] = ACTIONS(1735),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1735),
    [sym_false] = ACTIONS(1735),
    [sym_null] = ACTIONS(1735),
    [sym_undefined] = ACTIONS(1735),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [223] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(666),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(972),
    [sym_array] = STATE(973),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(963),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(666),
    [sym_subscript_expression] = STATE(666),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2570),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2918),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [sym_readonly] = ACTIONS(1533),
  },
  [224] = {
    [sym_import] = STATE(1032),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1032),
    [sym_yield_expression] = STATE(1032),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1032),
    [sym_jsx_fragment] = STATE(1032),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1032),
    [sym_class] = STATE(1032),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1032),
    [sym_arrow_function] = STATE(1032),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1032),
    [sym_new_expression] = STATE(1032),
    [sym_await_expression] = STATE(1032),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1032),
    [sym_augmented_assignment_expression] = STATE(1032),
    [sym_ternary_expression] = STATE(1032),
    [sym_binary_expression] = STATE(1032),
    [sym_unary_expression] = STATE(1032),
    [sym_update_expression] = STATE(1032),
    [sym_sequence_expression] = STATE(3084),
    [sym_string] = STATE(1032),
    [sym_template_string] = STATE(1032),
    [sym_regex] = STATE(1032),
    [sym_meta_property] = STATE(1032),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1032),
    [sym_as_expression] = STATE(1032),
    [sym_internal_module] = STATE(1032),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1737),
    [sym_this] = ACTIONS(1739),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1739),
    [sym_false] = ACTIONS(1739),
    [sym_null] = ACTIONS(1739),
    [sym_undefined] = ACTIONS(1739),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [225] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1248),
    [sym_jsx_fragment] = STATE(1248),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(1248),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(1741),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(751),
    [sym_this] = ACTIONS(753),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(753),
    [sym_false] = ACTIONS(753),
    [sym_null] = ACTIONS(753),
    [sym_undefined] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [226] = {
    [sym_import] = STATE(1365),
    [sym_statement_block] = STATE(1453),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1365),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1365),
    [sym_jsx_fragment] = STATE(1365),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1365),
    [sym_class] = STATE(1365),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1365),
    [sym_arrow_function] = STATE(1365),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1365),
    [sym_new_expression] = STATE(1365),
    [sym_await_expression] = STATE(1365),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1365),
    [sym_augmented_assignment_expression] = STATE(1365),
    [sym_ternary_expression] = STATE(1365),
    [sym_binary_expression] = STATE(1365),
    [sym_unary_expression] = STATE(1365),
    [sym_update_expression] = STATE(1365),
    [sym_string] = STATE(1365),
    [sym_template_string] = STATE(1365),
    [sym_regex] = STATE(1365),
    [sym_meta_property] = STATE(1365),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1365),
    [sym_as_expression] = STATE(1365),
    [sym_internal_module] = STATE(1365),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1743),
    [sym_this] = ACTIONS(1745),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1745),
    [sym_false] = ACTIONS(1745),
    [sym_null] = ACTIONS(1745),
    [sym_undefined] = ACTIONS(1745),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [227] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1364),
    [sym_jsx_fragment] = STATE(1364),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1364),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_sequence_expression] = STATE(3166),
    [sym_string] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1747),
    [sym_this] = ACTIONS(1749),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1749),
    [sym_false] = ACTIONS(1749),
    [sym_null] = ACTIONS(1749),
    [sym_undefined] = ACTIONS(1749),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [228] = {
    [sym_import] = STATE(1353),
    [sym_statement_block] = STATE(1553),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1353),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1353),
    [sym_jsx_fragment] = STATE(1353),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1353),
    [sym_class] = STATE(1353),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_await_expression] = STATE(1353),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1353),
    [sym_augmented_assignment_expression] = STATE(1353),
    [sym_ternary_expression] = STATE(1353),
    [sym_binary_expression] = STATE(1353),
    [sym_unary_expression] = STATE(1353),
    [sym_update_expression] = STATE(1353),
    [sym_string] = STATE(1353),
    [sym_template_string] = STATE(1353),
    [sym_regex] = STATE(1353),
    [sym_meta_property] = STATE(1353),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1353),
    [sym_as_expression] = STATE(1353),
    [sym_internal_module] = STATE(1353),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1751),
    [sym_this] = ACTIONS(1753),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1753),
    [sym_false] = ACTIONS(1753),
    [sym_null] = ACTIONS(1753),
    [sym_undefined] = ACTIONS(1753),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [229] = {
    [sym_import] = STATE(1352),
    [sym_statement_block] = STATE(1454),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1352),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1352),
    [sym_jsx_fragment] = STATE(1352),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1352),
    [sym_class] = STATE(1352),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1352),
    [sym_arrow_function] = STATE(1352),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1352),
    [sym_new_expression] = STATE(1352),
    [sym_await_expression] = STATE(1352),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1352),
    [sym_augmented_assignment_expression] = STATE(1352),
    [sym_ternary_expression] = STATE(1352),
    [sym_binary_expression] = STATE(1352),
    [sym_unary_expression] = STATE(1352),
    [sym_update_expression] = STATE(1352),
    [sym_string] = STATE(1352),
    [sym_template_string] = STATE(1352),
    [sym_regex] = STATE(1352),
    [sym_meta_property] = STATE(1352),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1352),
    [sym_as_expression] = STATE(1352),
    [sym_internal_module] = STATE(1352),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1755),
    [sym_this] = ACTIONS(1757),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1757),
    [sym_false] = ACTIONS(1757),
    [sym_null] = ACTIONS(1757),
    [sym_undefined] = ACTIONS(1757),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [230] = {
    [sym_import] = STATE(1351),
    [sym_statement_block] = STATE(1450),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1351),
    [sym_jsx_fragment] = STATE(1351),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1351),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1351),
    [sym_as_expression] = STATE(1351),
    [sym_internal_module] = STATE(1351),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1759),
    [sym_this] = ACTIONS(1761),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1761),
    [sym_false] = ACTIONS(1761),
    [sym_null] = ACTIONS(1761),
    [sym_undefined] = ACTIONS(1761),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [231] = {
    [sym_import] = STATE(1350),
    [sym_statement_block] = STATE(1449),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1350),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1350),
    [sym_jsx_fragment] = STATE(1350),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1350),
    [sym_class] = STATE(1350),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1350),
    [sym_arrow_function] = STATE(1350),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1350),
    [sym_new_expression] = STATE(1350),
    [sym_await_expression] = STATE(1350),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1350),
    [sym_augmented_assignment_expression] = STATE(1350),
    [sym_ternary_expression] = STATE(1350),
    [sym_binary_expression] = STATE(1350),
    [sym_unary_expression] = STATE(1350),
    [sym_update_expression] = STATE(1350),
    [sym_string] = STATE(1350),
    [sym_template_string] = STATE(1350),
    [sym_regex] = STATE(1350),
    [sym_meta_property] = STATE(1350),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1350),
    [sym_as_expression] = STATE(1350),
    [sym_internal_module] = STATE(1350),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1763),
    [sym_this] = ACTIONS(1765),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1765),
    [sym_false] = ACTIONS(1765),
    [sym_null] = ACTIONS(1765),
    [sym_undefined] = ACTIONS(1765),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [232] = {
    [sym_import] = STATE(1121),
    [sym_statement_block] = STATE(1488),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1121),
    [sym_jsx_fragment] = STATE(1121),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1121),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1767),
    [sym_this] = ACTIONS(1769),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1769),
    [sym_false] = ACTIONS(1769),
    [sym_null] = ACTIONS(1769),
    [sym_undefined] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [233] = {
    [sym_import] = STATE(1337),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1337),
    [sym_jsx_fragment] = STATE(1337),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1337),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_sequence_expression] = STATE(3035),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1771),
    [sym_this] = ACTIONS(1773),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1773),
    [sym_false] = ACTIONS(1773),
    [sym_null] = ACTIONS(1773),
    [sym_undefined] = ACTIONS(1773),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [234] = {
    [sym_import] = STATE(1326),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1326),
    [sym_jsx_fragment] = STATE(1326),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(1326),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1775),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(691),
    [sym_this] = ACTIONS(693),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_null] = ACTIONS(693),
    [sym_undefined] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [235] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(789),
    [sym__expression] = STATE(1617),
    [sym_yield_expression] = STATE(1617),
    [sym_object] = STATE(1249),
    [sym_array] = STATE(1215),
    [sym_jsx_element] = STATE(1617),
    [sym_jsx_fragment] = STATE(1617),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1617),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(1139),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1617),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1617),
    [sym_member_expression] = STATE(789),
    [sym_subscript_expression] = STATE(789),
    [sym_assignment_expression] = STATE(1617),
    [sym_augmented_assignment_expression] = STATE(1617),
    [sym_ternary_expression] = STATE(1617),
    [sym_binary_expression] = STATE(1617),
    [sym_unary_expression] = STATE(1617),
    [sym_update_expression] = STATE(1617),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2570),
    [sym_non_null_expression] = STATE(1617),
    [sym_as_expression] = STATE(1617),
    [sym_internal_module] = STATE(1617),
    [sym_type_parameters] = STATE(2918),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(1651),
    [anon_sym_export] = ACTIONS(1653),
    [anon_sym_namespace] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1653),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1657),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1659),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1515),
    [sym_this] = ACTIONS(1517),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_null] = ACTIONS(1517),
    [sym_undefined] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1653),
    [anon_sym_get] = ACTIONS(1653),
    [anon_sym_set] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(1653),
    [anon_sym_public] = ACTIONS(1653),
    [anon_sym_private] = ACTIONS(1653),
    [anon_sym_protected] = ACTIONS(1653),
    [anon_sym_module] = ACTIONS(1653),
    [anon_sym_any] = ACTIONS(1653),
    [anon_sym_number] = ACTIONS(1653),
    [anon_sym_boolean] = ACTIONS(1653),
    [anon_sym_string] = ACTIONS(1653),
    [anon_sym_symbol] = ACTIONS(1653),
    [sym_readonly] = ACTIONS(1653),
  },
  [236] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(666),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(972),
    [sym_array] = STATE(973),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(963),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(666),
    [sym_subscript_expression] = STATE(666),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2570),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2918),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1685),
    [anon_sym_export] = ACTIONS(1687),
    [anon_sym_namespace] = ACTIONS(1689),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1687),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1693),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_get] = ACTIONS(1687),
    [anon_sym_set] = ACTIONS(1687),
    [anon_sym_declare] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1687),
    [anon_sym_private] = ACTIONS(1687),
    [anon_sym_protected] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1687),
    [anon_sym_any] = ACTIONS(1687),
    [anon_sym_number] = ACTIONS(1687),
    [anon_sym_boolean] = ACTIONS(1687),
    [anon_sym_string] = ACTIONS(1687),
    [anon_sym_symbol] = ACTIONS(1687),
    [sym_readonly] = ACTIONS(1687),
  },
  [237] = {
    [sym_import] = STATE(1116),
    [sym_statement_block] = STATE(1453),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1116),
    [sym_yield_expression] = STATE(1116),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1116),
    [sym_jsx_fragment] = STATE(1116),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1116),
    [sym_class] = STATE(1116),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1116),
    [sym_arrow_function] = STATE(1116),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1116),
    [sym_new_expression] = STATE(1116),
    [sym_await_expression] = STATE(1116),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1116),
    [sym_augmented_assignment_expression] = STATE(1116),
    [sym_ternary_expression] = STATE(1116),
    [sym_binary_expression] = STATE(1116),
    [sym_unary_expression] = STATE(1116),
    [sym_update_expression] = STATE(1116),
    [sym_string] = STATE(1116),
    [sym_template_string] = STATE(1116),
    [sym_regex] = STATE(1116),
    [sym_meta_property] = STATE(1116),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1116),
    [sym_as_expression] = STATE(1116),
    [sym_internal_module] = STATE(1116),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1777),
    [sym_this] = ACTIONS(1779),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [238] = {
    [sym_import] = STATE(1285),
    [sym_statement_block] = STATE(1108),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1285),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1285),
    [sym_jsx_fragment] = STATE(1285),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1285),
    [sym_class] = STATE(1285),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1285),
    [sym_arrow_function] = STATE(1285),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1285),
    [sym_new_expression] = STATE(1285),
    [sym_await_expression] = STATE(1285),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1285),
    [sym_augmented_assignment_expression] = STATE(1285),
    [sym_ternary_expression] = STATE(1285),
    [sym_binary_expression] = STATE(1285),
    [sym_unary_expression] = STATE(1285),
    [sym_update_expression] = STATE(1285),
    [sym_string] = STATE(1285),
    [sym_template_string] = STATE(1285),
    [sym_regex] = STATE(1285),
    [sym_meta_property] = STATE(1285),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1285),
    [sym_as_expression] = STATE(1285),
    [sym_internal_module] = STATE(1285),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1781),
    [sym_this] = ACTIONS(1783),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [sym_null] = ACTIONS(1783),
    [sym_undefined] = ACTIONS(1783),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [239] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1289),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1289),
    [sym_jsx_fragment] = STATE(1289),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(1289),
    [sym_class] = STATE(1289),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1289),
    [sym_arrow_function] = STATE(1289),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1289),
    [sym_new_expression] = STATE(1289),
    [sym_await_expression] = STATE(1289),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1289),
    [sym_augmented_assignment_expression] = STATE(1289),
    [sym_ternary_expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_update_expression] = STATE(1289),
    [sym_string] = STATE(1289),
    [sym_template_string] = STATE(1289),
    [sym_regex] = STATE(1289),
    [sym_meta_property] = STATE(1289),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1289),
    [sym_as_expression] = STATE(1289),
    [sym_internal_module] = STATE(1289),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1785),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(789),
    [sym_this] = ACTIONS(791),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(791),
    [sym_false] = ACTIONS(791),
    [sym_null] = ACTIONS(791),
    [sym_undefined] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [240] = {
    [sym_import] = STATE(1340),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1340),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1340),
    [sym_jsx_fragment] = STATE(1340),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1340),
    [sym_class] = STATE(1340),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1340),
    [sym_arrow_function] = STATE(1340),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_await_expression] = STATE(1340),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1340),
    [sym_augmented_assignment_expression] = STATE(1340),
    [sym_ternary_expression] = STATE(1340),
    [sym_binary_expression] = STATE(1340),
    [sym_unary_expression] = STATE(1340),
    [sym_update_expression] = STATE(1340),
    [sym_sequence_expression] = STATE(2987),
    [sym_string] = STATE(1340),
    [sym_template_string] = STATE(1340),
    [sym_regex] = STATE(1340),
    [sym_meta_property] = STATE(1340),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1340),
    [sym_as_expression] = STATE(1340),
    [sym_internal_module] = STATE(1340),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1787),
    [sym_this] = ACTIONS(1789),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1789),
    [sym_false] = ACTIONS(1789),
    [sym_null] = ACTIONS(1789),
    [sym_undefined] = ACTIONS(1789),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [241] = {
    [sym_import] = STATE(1235),
    [sym_statement_block] = STATE(1593),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1235),
    [sym_yield_expression] = STATE(1235),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1235),
    [sym_jsx_fragment] = STATE(1235),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1235),
    [sym_class] = STATE(1235),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1235),
    [sym_arrow_function] = STATE(1235),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1235),
    [sym_new_expression] = STATE(1235),
    [sym_await_expression] = STATE(1235),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1235),
    [sym_augmented_assignment_expression] = STATE(1235),
    [sym_ternary_expression] = STATE(1235),
    [sym_binary_expression] = STATE(1235),
    [sym_unary_expression] = STATE(1235),
    [sym_update_expression] = STATE(1235),
    [sym_string] = STATE(1235),
    [sym_template_string] = STATE(1235),
    [sym_regex] = STATE(1235),
    [sym_meta_property] = STATE(1235),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1235),
    [sym_as_expression] = STATE(1235),
    [sym_internal_module] = STATE(1235),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1791),
    [sym_this] = ACTIONS(1793),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1793),
    [sym_false] = ACTIONS(1793),
    [sym_null] = ACTIONS(1793),
    [sym_undefined] = ACTIONS(1793),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [242] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [243] = {
    [sym_import] = STATE(1207),
    [sym_statement_block] = STATE(1108),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1207),
    [sym_jsx_fragment] = STATE(1207),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1207),
    [sym_class] = STATE(1207),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1207),
    [sym_arrow_function] = STATE(1207),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1207),
    [sym_new_expression] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_string] = STATE(1207),
    [sym_template_string] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1797),
    [sym_this] = ACTIONS(1799),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1799),
    [sym_false] = ACTIONS(1799),
    [sym_null] = ACTIONS(1799),
    [sym_undefined] = ACTIONS(1799),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [244] = {
    [sym_import] = STATE(1206),
    [sym_statement_block] = STATE(1111),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1206),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1206),
    [sym_jsx_fragment] = STATE(1206),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1206),
    [sym_class] = STATE(1206),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1206),
    [sym_arrow_function] = STATE(1206),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1206),
    [sym_new_expression] = STATE(1206),
    [sym_await_expression] = STATE(1206),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1206),
    [sym_augmented_assignment_expression] = STATE(1206),
    [sym_ternary_expression] = STATE(1206),
    [sym_binary_expression] = STATE(1206),
    [sym_unary_expression] = STATE(1206),
    [sym_update_expression] = STATE(1206),
    [sym_string] = STATE(1206),
    [sym_template_string] = STATE(1206),
    [sym_regex] = STATE(1206),
    [sym_meta_property] = STATE(1206),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1206),
    [sym_as_expression] = STATE(1206),
    [sym_internal_module] = STATE(1206),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1801),
    [sym_this] = ACTIONS(1803),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_undefined] = ACTIONS(1803),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [245] = {
    [sym_import] = STATE(1205),
    [sym_statement_block] = STATE(1115),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1205),
    [sym_yield_expression] = STATE(1205),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1205),
    [sym_jsx_fragment] = STATE(1205),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1205),
    [sym_class] = STATE(1205),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1205),
    [sym_arrow_function] = STATE(1205),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1205),
    [sym_new_expression] = STATE(1205),
    [sym_await_expression] = STATE(1205),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1205),
    [sym_augmented_assignment_expression] = STATE(1205),
    [sym_ternary_expression] = STATE(1205),
    [sym_binary_expression] = STATE(1205),
    [sym_unary_expression] = STATE(1205),
    [sym_update_expression] = STATE(1205),
    [sym_string] = STATE(1205),
    [sym_template_string] = STATE(1205),
    [sym_regex] = STATE(1205),
    [sym_meta_property] = STATE(1205),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1205),
    [sym_as_expression] = STATE(1205),
    [sym_internal_module] = STATE(1205),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1805),
    [sym_this] = ACTIONS(1807),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_undefined] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [246] = {
    [sym_import] = STATE(1204),
    [sym_statement_block] = STATE(1020),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1204),
    [sym_jsx_fragment] = STATE(1204),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1204),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1204),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1809),
    [sym_this] = ACTIONS(1811),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1811),
    [sym_false] = ACTIONS(1811),
    [sym_null] = ACTIONS(1811),
    [sym_undefined] = ACTIONS(1811),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [247] = {
    [sym_import] = STATE(1253),
    [sym_statement_block] = STATE(1594),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1253),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1253),
    [sym_jsx_fragment] = STATE(1253),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1253),
    [sym_class] = STATE(1253),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1253),
    [sym_arrow_function] = STATE(1253),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1253),
    [sym_new_expression] = STATE(1253),
    [sym_await_expression] = STATE(1253),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1253),
    [sym_augmented_assignment_expression] = STATE(1253),
    [sym_ternary_expression] = STATE(1253),
    [sym_binary_expression] = STATE(1253),
    [sym_unary_expression] = STATE(1253),
    [sym_update_expression] = STATE(1253),
    [sym_string] = STATE(1253),
    [sym_template_string] = STATE(1253),
    [sym_regex] = STATE(1253),
    [sym_meta_property] = STATE(1253),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1253),
    [sym_as_expression] = STATE(1253),
    [sym_internal_module] = STATE(1253),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1813),
    [sym_this] = ACTIONS(1815),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1815),
    [sym_false] = ACTIONS(1815),
    [sym_null] = ACTIONS(1815),
    [sym_undefined] = ACTIONS(1815),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [248] = {
    [sym_import] = STATE(1240),
    [sym_statement_block] = STATE(1130),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1240),
    [sym_yield_expression] = STATE(1240),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1240),
    [sym_jsx_fragment] = STATE(1240),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1240),
    [sym_class] = STATE(1240),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1240),
    [sym_arrow_function] = STATE(1240),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1240),
    [sym_new_expression] = STATE(1240),
    [sym_await_expression] = STATE(1240),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1240),
    [sym_augmented_assignment_expression] = STATE(1240),
    [sym_ternary_expression] = STATE(1240),
    [sym_binary_expression] = STATE(1240),
    [sym_unary_expression] = STATE(1240),
    [sym_update_expression] = STATE(1240),
    [sym_string] = STATE(1240),
    [sym_template_string] = STATE(1240),
    [sym_regex] = STATE(1240),
    [sym_meta_property] = STATE(1240),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1240),
    [sym_as_expression] = STATE(1240),
    [sym_internal_module] = STATE(1240),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1817),
    [sym_this] = ACTIONS(1819),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1819),
    [sym_false] = ACTIONS(1819),
    [sym_null] = ACTIONS(1819),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [249] = {
    [sym_import] = STATE(1389),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1389),
    [sym_yield_expression] = STATE(1389),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1389),
    [sym_jsx_fragment] = STATE(1389),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1389),
    [sym_class] = STATE(1389),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1389),
    [sym_arrow_function] = STATE(1389),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1389),
    [sym_new_expression] = STATE(1389),
    [sym_await_expression] = STATE(1389),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1389),
    [sym_augmented_assignment_expression] = STATE(1389),
    [sym_ternary_expression] = STATE(1389),
    [sym_binary_expression] = STATE(1389),
    [sym_unary_expression] = STATE(1389),
    [sym_update_expression] = STATE(1389),
    [sym_sequence_expression] = STATE(3188),
    [sym_string] = STATE(1389),
    [sym_template_string] = STATE(1389),
    [sym_regex] = STATE(1389),
    [sym_meta_property] = STATE(1389),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1389),
    [sym_as_expression] = STATE(1389),
    [sym_internal_module] = STATE(1389),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1821),
    [sym_this] = ACTIONS(1823),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1823),
    [sym_false] = ACTIONS(1823),
    [sym_null] = ACTIONS(1823),
    [sym_undefined] = ACTIONS(1823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [250] = {
    [sym_import] = STATE(1239),
    [sym_statement_block] = STATE(1601),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1239),
    [sym_jsx_fragment] = STATE(1239),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1239),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1239),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1825),
    [sym_this] = ACTIONS(1827),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1827),
    [sym_false] = ACTIONS(1827),
    [sym_null] = ACTIONS(1827),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [251] = {
    [sym_import] = STATE(981),
    [sym_statement_block] = STATE(1130),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(981),
    [sym_yield_expression] = STATE(981),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(981),
    [sym_jsx_fragment] = STATE(981),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(981),
    [sym_class] = STATE(981),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(981),
    [sym_arrow_function] = STATE(981),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(981),
    [sym_new_expression] = STATE(981),
    [sym_await_expression] = STATE(981),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(981),
    [sym_augmented_assignment_expression] = STATE(981),
    [sym_ternary_expression] = STATE(981),
    [sym_binary_expression] = STATE(981),
    [sym_unary_expression] = STATE(981),
    [sym_update_expression] = STATE(981),
    [sym_string] = STATE(981),
    [sym_template_string] = STATE(981),
    [sym_regex] = STATE(981),
    [sym_meta_property] = STATE(981),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(981),
    [sym_as_expression] = STATE(981),
    [sym_internal_module] = STATE(981),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1829),
    [sym_this] = ACTIONS(1831),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1831),
    [sym_false] = ACTIONS(1831),
    [sym_null] = ACTIONS(1831),
    [sym_undefined] = ACTIONS(1831),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [252] = {
    [sym_import] = STATE(1185),
    [sym_statement_block] = STATE(1165),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1185),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1185),
    [sym_jsx_fragment] = STATE(1185),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1185),
    [sym_class] = STATE(1185),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1185),
    [sym_arrow_function] = STATE(1185),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1185),
    [sym_new_expression] = STATE(1185),
    [sym_await_expression] = STATE(1185),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1185),
    [sym_augmented_assignment_expression] = STATE(1185),
    [sym_ternary_expression] = STATE(1185),
    [sym_binary_expression] = STATE(1185),
    [sym_unary_expression] = STATE(1185),
    [sym_update_expression] = STATE(1185),
    [sym_string] = STATE(1185),
    [sym_template_string] = STATE(1185),
    [sym_regex] = STATE(1185),
    [sym_meta_property] = STATE(1185),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1185),
    [sym_internal_module] = STATE(1185),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1833),
    [sym_this] = ACTIONS(1835),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1835),
    [sym_false] = ACTIONS(1835),
    [sym_null] = ACTIONS(1835),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [253] = {
    [sym_import] = STATE(1151),
    [sym_statement_block] = STATE(1553),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1151),
    [sym_yield_expression] = STATE(1151),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1151),
    [sym_jsx_fragment] = STATE(1151),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1151),
    [sym_class] = STATE(1151),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1151),
    [sym_arrow_function] = STATE(1151),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1151),
    [sym_new_expression] = STATE(1151),
    [sym_await_expression] = STATE(1151),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1151),
    [sym_augmented_assignment_expression] = STATE(1151),
    [sym_ternary_expression] = STATE(1151),
    [sym_binary_expression] = STATE(1151),
    [sym_unary_expression] = STATE(1151),
    [sym_update_expression] = STATE(1151),
    [sym_string] = STATE(1151),
    [sym_template_string] = STATE(1151),
    [sym_regex] = STATE(1151),
    [sym_meta_property] = STATE(1151),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1151),
    [sym_as_expression] = STATE(1151),
    [sym_internal_module] = STATE(1151),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1837),
    [sym_this] = ACTIONS(1839),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1839),
    [sym_false] = ACTIONS(1839),
    [sym_null] = ACTIONS(1839),
    [sym_undefined] = ACTIONS(1839),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [254] = {
    [sym_import] = STATE(1390),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1390),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1390),
    [sym_jsx_fragment] = STATE(1390),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1390),
    [sym_class] = STATE(1390),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1390),
    [sym_arrow_function] = STATE(1390),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1390),
    [sym_new_expression] = STATE(1390),
    [sym_await_expression] = STATE(1390),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1390),
    [sym_augmented_assignment_expression] = STATE(1390),
    [sym_ternary_expression] = STATE(1390),
    [sym_binary_expression] = STATE(1390),
    [sym_unary_expression] = STATE(1390),
    [sym_update_expression] = STATE(1390),
    [sym_sequence_expression] = STATE(3170),
    [sym_string] = STATE(1390),
    [sym_template_string] = STATE(1390),
    [sym_regex] = STATE(1390),
    [sym_meta_property] = STATE(1390),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1390),
    [sym_as_expression] = STATE(1390),
    [sym_internal_module] = STATE(1390),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1841),
    [sym_this] = ACTIONS(1843),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1843),
    [sym_false] = ACTIONS(1843),
    [sym_null] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [255] = {
    [sym_import] = STATE(1221),
    [sym_statement_block] = STATE(1618),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1221),
    [sym_jsx_fragment] = STATE(1221),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1221),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1845),
    [sym_this] = ACTIONS(1847),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1847),
    [sym_false] = ACTIONS(1847),
    [sym_null] = ACTIONS(1847),
    [sym_undefined] = ACTIONS(1847),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [256] = {
    [sym_import] = STATE(1216),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1216),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1216),
    [sym_jsx_fragment] = STATE(1216),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1216),
    [sym_class] = STATE(1216),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1216),
    [sym_arrow_function] = STATE(1216),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1216),
    [sym_new_expression] = STATE(1216),
    [sym_await_expression] = STATE(1216),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1216),
    [sym_augmented_assignment_expression] = STATE(1216),
    [sym_ternary_expression] = STATE(1216),
    [sym_binary_expression] = STATE(1216),
    [sym_unary_expression] = STATE(1216),
    [sym_update_expression] = STATE(1216),
    [sym_string] = STATE(1216),
    [sym_template_string] = STATE(1216),
    [sym_regex] = STATE(1216),
    [sym_meta_property] = STATE(1216),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1216),
    [sym_as_expression] = STATE(1216),
    [sym_internal_module] = STATE(1216),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1849),
    [sym_this] = ACTIONS(1851),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1851),
    [sym_false] = ACTIONS(1851),
    [sym_null] = ACTIONS(1851),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [257] = {
    [sym_import] = STATE(1181),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1181),
    [sym_yield_expression] = STATE(1181),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1181),
    [sym_jsx_fragment] = STATE(1181),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1181),
    [sym_class] = STATE(1181),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1181),
    [sym_arrow_function] = STATE(1181),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1181),
    [sym_new_expression] = STATE(1181),
    [sym_await_expression] = STATE(1181),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1181),
    [sym_augmented_assignment_expression] = STATE(1181),
    [sym_ternary_expression] = STATE(1181),
    [sym_binary_expression] = STATE(1181),
    [sym_unary_expression] = STATE(1181),
    [sym_update_expression] = STATE(1181),
    [sym_string] = STATE(1181),
    [sym_template_string] = STATE(1181),
    [sym_regex] = STATE(1181),
    [sym_meta_property] = STATE(1181),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1181),
    [sym_as_expression] = STATE(1181),
    [sym_internal_module] = STATE(1181),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(1853),
    [sym_this] = ACTIONS(1855),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_undefined] = ACTIONS(1855),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [258] = {
    [sym_import] = STATE(1135),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1135),
    [sym_yield_expression] = STATE(1135),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1135),
    [sym_jsx_fragment] = STATE(1135),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1135),
    [sym_class] = STATE(1135),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1135),
    [sym_arrow_function] = STATE(1135),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1135),
    [sym_new_expression] = STATE(1135),
    [sym_await_expression] = STATE(1135),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1135),
    [sym_augmented_assignment_expression] = STATE(1135),
    [sym_ternary_expression] = STATE(1135),
    [sym_binary_expression] = STATE(1135),
    [sym_unary_expression] = STATE(1135),
    [sym_update_expression] = STATE(1135),
    [sym_string] = STATE(1135),
    [sym_template_string] = STATE(1135),
    [sym_regex] = STATE(1135),
    [sym_meta_property] = STATE(1135),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1135),
    [sym_as_expression] = STATE(1135),
    [sym_internal_module] = STATE(1135),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1857),
    [sym_this] = ACTIONS(1028),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_undefined] = ACTIONS(1028),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [259] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1859),
    [sym_this] = ACTIONS(1861),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [sym_null] = ACTIONS(1861),
    [sym_undefined] = ACTIONS(1861),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [260] = {
    [sym_import] = STATE(1534),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1534),
    [sym_yield_expression] = STATE(1534),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1534),
    [sym_jsx_fragment] = STATE(1534),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1534),
    [sym_class] = STATE(1534),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1534),
    [sym_arrow_function] = STATE(1534),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1534),
    [sym_new_expression] = STATE(1534),
    [sym_await_expression] = STATE(1534),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1534),
    [sym_augmented_assignment_expression] = STATE(1534),
    [sym_ternary_expression] = STATE(1534),
    [sym_binary_expression] = STATE(1534),
    [sym_unary_expression] = STATE(1534),
    [sym_update_expression] = STATE(1534),
    [sym_string] = STATE(1534),
    [sym_template_string] = STATE(1534),
    [sym_regex] = STATE(1534),
    [sym_meta_property] = STATE(1534),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1534),
    [sym_as_expression] = STATE(1534),
    [sym_internal_module] = STATE(1534),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1863),
    [sym_this] = ACTIONS(1865),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1865),
    [sym_false] = ACTIONS(1865),
    [sym_null] = ACTIONS(1865),
    [sym_undefined] = ACTIONS(1865),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [261] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1138),
    [sym_jsx_fragment] = STATE(1138),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1138),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1867),
    [sym_this] = ACTIONS(1869),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1869),
    [sym_false] = ACTIONS(1869),
    [sym_null] = ACTIONS(1869),
    [sym_undefined] = ACTIONS(1869),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [262] = {
    [sym_import] = STATE(1140),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1140),
    [sym_yield_expression] = STATE(1140),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1140),
    [sym_jsx_fragment] = STATE(1140),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1140),
    [sym_class] = STATE(1140),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1140),
    [sym_arrow_function] = STATE(1140),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1140),
    [sym_new_expression] = STATE(1140),
    [sym_await_expression] = STATE(1140),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1140),
    [sym_augmented_assignment_expression] = STATE(1140),
    [sym_ternary_expression] = STATE(1140),
    [sym_binary_expression] = STATE(1140),
    [sym_unary_expression] = STATE(1140),
    [sym_update_expression] = STATE(1140),
    [sym_string] = STATE(1140),
    [sym_template_string] = STATE(1140),
    [sym_regex] = STATE(1140),
    [sym_meta_property] = STATE(1140),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1140),
    [sym_as_expression] = STATE(1140),
    [sym_internal_module] = STATE(1140),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1871),
    [sym_this] = ACTIONS(1873),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [sym_null] = ACTIONS(1873),
    [sym_undefined] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [263] = {
    [sym_import] = STATE(1141),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1141),
    [sym_yield_expression] = STATE(1141),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1141),
    [sym_jsx_fragment] = STATE(1141),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1141),
    [sym_class] = STATE(1141),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1141),
    [sym_arrow_function] = STATE(1141),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1141),
    [sym_new_expression] = STATE(1141),
    [sym_await_expression] = STATE(1141),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1141),
    [sym_augmented_assignment_expression] = STATE(1141),
    [sym_ternary_expression] = STATE(1141),
    [sym_binary_expression] = STATE(1141),
    [sym_unary_expression] = STATE(1141),
    [sym_update_expression] = STATE(1141),
    [sym_string] = STATE(1141),
    [sym_template_string] = STATE(1141),
    [sym_regex] = STATE(1141),
    [sym_meta_property] = STATE(1141),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1141),
    [sym_as_expression] = STATE(1141),
    [sym_internal_module] = STATE(1141),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1875),
    [sym_this] = ACTIONS(1877),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1877),
    [sym_false] = ACTIONS(1877),
    [sym_null] = ACTIONS(1877),
    [sym_undefined] = ACTIONS(1877),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [264] = {
    [sym_import] = STATE(1142),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1142),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1142),
    [sym_jsx_fragment] = STATE(1142),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1142),
    [sym_class] = STATE(1142),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1142),
    [sym_arrow_function] = STATE(1142),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1142),
    [sym_new_expression] = STATE(1142),
    [sym_await_expression] = STATE(1142),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1142),
    [sym_augmented_assignment_expression] = STATE(1142),
    [sym_ternary_expression] = STATE(1142),
    [sym_binary_expression] = STATE(1142),
    [sym_unary_expression] = STATE(1142),
    [sym_update_expression] = STATE(1142),
    [sym_string] = STATE(1142),
    [sym_template_string] = STATE(1142),
    [sym_regex] = STATE(1142),
    [sym_meta_property] = STATE(1142),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1142),
    [sym_as_expression] = STATE(1142),
    [sym_internal_module] = STATE(1142),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1879),
    [sym_this] = ACTIONS(1881),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1881),
    [sym_false] = ACTIONS(1881),
    [sym_null] = ACTIONS(1881),
    [sym_undefined] = ACTIONS(1881),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [265] = {
    [sym_import] = STATE(1143),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1143),
    [sym_yield_expression] = STATE(1143),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1143),
    [sym_jsx_fragment] = STATE(1143),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1143),
    [sym_class] = STATE(1143),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1143),
    [sym_arrow_function] = STATE(1143),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1143),
    [sym_new_expression] = STATE(1143),
    [sym_await_expression] = STATE(1143),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1143),
    [sym_augmented_assignment_expression] = STATE(1143),
    [sym_ternary_expression] = STATE(1143),
    [sym_binary_expression] = STATE(1143),
    [sym_unary_expression] = STATE(1143),
    [sym_update_expression] = STATE(1143),
    [sym_string] = STATE(1143),
    [sym_template_string] = STATE(1143),
    [sym_regex] = STATE(1143),
    [sym_meta_property] = STATE(1143),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1143),
    [sym_internal_module] = STATE(1143),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1883),
    [sym_this] = ACTIONS(1885),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1885),
    [sym_false] = ACTIONS(1885),
    [sym_null] = ACTIONS(1885),
    [sym_undefined] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [266] = {
    [sym_import] = STATE(1193),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1193),
    [sym_yield_expression] = STATE(1193),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1193),
    [sym_jsx_fragment] = STATE(1193),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1193),
    [sym_class] = STATE(1193),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1193),
    [sym_arrow_function] = STATE(1193),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1193),
    [sym_new_expression] = STATE(1193),
    [sym_await_expression] = STATE(1193),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1193),
    [sym_augmented_assignment_expression] = STATE(1193),
    [sym_ternary_expression] = STATE(1193),
    [sym_binary_expression] = STATE(1193),
    [sym_unary_expression] = STATE(1193),
    [sym_update_expression] = STATE(1193),
    [sym_string] = STATE(1193),
    [sym_template_string] = STATE(1193),
    [sym_regex] = STATE(1193),
    [sym_meta_property] = STATE(1193),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1193),
    [sym_as_expression] = STATE(1193),
    [sym_internal_module] = STATE(1193),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1887),
    [sym_this] = ACTIONS(1889),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1889),
    [sym_false] = ACTIONS(1889),
    [sym_null] = ACTIONS(1889),
    [sym_undefined] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [267] = {
    [sym_import] = STATE(1192),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1192),
    [sym_yield_expression] = STATE(1192),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1192),
    [sym_jsx_fragment] = STATE(1192),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1192),
    [sym_class] = STATE(1192),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1192),
    [sym_arrow_function] = STATE(1192),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1192),
    [sym_new_expression] = STATE(1192),
    [sym_await_expression] = STATE(1192),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1192),
    [sym_augmented_assignment_expression] = STATE(1192),
    [sym_ternary_expression] = STATE(1192),
    [sym_binary_expression] = STATE(1192),
    [sym_unary_expression] = STATE(1192),
    [sym_update_expression] = STATE(1192),
    [sym_string] = STATE(1192),
    [sym_template_string] = STATE(1192),
    [sym_regex] = STATE(1192),
    [sym_meta_property] = STATE(1192),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1192),
    [sym_as_expression] = STATE(1192),
    [sym_internal_module] = STATE(1192),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [sym_undefined] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [268] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1144),
    [sym_yield_expression] = STATE(1144),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1144),
    [sym_jsx_fragment] = STATE(1144),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1144),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1144),
    [sym_await_expression] = STATE(1144),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1144),
    [sym_augmented_assignment_expression] = STATE(1144),
    [sym_ternary_expression] = STATE(1144),
    [sym_binary_expression] = STATE(1144),
    [sym_unary_expression] = STATE(1144),
    [sym_update_expression] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1144),
    [sym_as_expression] = STATE(1144),
    [sym_internal_module] = STATE(1144),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1895),
    [sym_this] = ACTIONS(1897),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [sym_null] = ACTIONS(1897),
    [sym_undefined] = ACTIONS(1897),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [269] = {
    [sym_import] = STATE(1146),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1146),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1146),
    [sym_jsx_fragment] = STATE(1146),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1146),
    [sym_class] = STATE(1146),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1146),
    [sym_arrow_function] = STATE(1146),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1146),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1146),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1146),
    [sym_template_string] = STATE(1146),
    [sym_regex] = STATE(1146),
    [sym_meta_property] = STATE(1146),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1146),
    [sym_as_expression] = STATE(1146),
    [sym_internal_module] = STATE(1146),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1899),
    [sym_this] = ACTIONS(1901),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [sym_null] = ACTIONS(1901),
    [sym_undefined] = ACTIONS(1901),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [270] = {
    [sym_import] = STATE(1133),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1133),
    [sym_yield_expression] = STATE(1133),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1133),
    [sym_jsx_fragment] = STATE(1133),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1133),
    [sym_class] = STATE(1133),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1133),
    [sym_arrow_function] = STATE(1133),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1133),
    [sym_new_expression] = STATE(1133),
    [sym_await_expression] = STATE(1133),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1133),
    [sym_augmented_assignment_expression] = STATE(1133),
    [sym_ternary_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym_update_expression] = STATE(1133),
    [sym_string] = STATE(1133),
    [sym_template_string] = STATE(1133),
    [sym_regex] = STATE(1133),
    [sym_meta_property] = STATE(1133),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1133),
    [sym_as_expression] = STATE(1133),
    [sym_internal_module] = STATE(1133),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1903),
    [sym_this] = ACTIONS(1905),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1905),
    [sym_false] = ACTIONS(1905),
    [sym_null] = ACTIONS(1905),
    [sym_undefined] = ACTIONS(1905),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [271] = {
    [sym_import] = STATE(1190),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1190),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1190),
    [sym_jsx_fragment] = STATE(1190),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1190),
    [sym_class] = STATE(1190),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1190),
    [sym_arrow_function] = STATE(1190),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1190),
    [sym_new_expression] = STATE(1190),
    [sym_await_expression] = STATE(1190),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1190),
    [sym_augmented_assignment_expression] = STATE(1190),
    [sym_ternary_expression] = STATE(1190),
    [sym_binary_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1190),
    [sym_update_expression] = STATE(1190),
    [sym_string] = STATE(1190),
    [sym_template_string] = STATE(1190),
    [sym_regex] = STATE(1190),
    [sym_meta_property] = STATE(1190),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1190),
    [sym_as_expression] = STATE(1190),
    [sym_internal_module] = STATE(1190),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1907),
    [sym_this] = ACTIONS(926),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_undefined] = ACTIONS(926),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [272] = {
    [sym_import] = STATE(1187),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1187),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1187),
    [sym_jsx_fragment] = STATE(1187),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1187),
    [sym_class] = STATE(1187),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1187),
    [sym_arrow_function] = STATE(1187),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_await_expression] = STATE(1187),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1187),
    [sym_augmented_assignment_expression] = STATE(1187),
    [sym_ternary_expression] = STATE(1187),
    [sym_binary_expression] = STATE(1187),
    [sym_unary_expression] = STATE(1187),
    [sym_update_expression] = STATE(1187),
    [sym_string] = STATE(1187),
    [sym_template_string] = STATE(1187),
    [sym_regex] = STATE(1187),
    [sym_meta_property] = STATE(1187),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1187),
    [sym_as_expression] = STATE(1187),
    [sym_internal_module] = STATE(1187),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1909),
    [sym_this] = ACTIONS(1911),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1911),
    [sym_false] = ACTIONS(1911),
    [sym_null] = ACTIONS(1911),
    [sym_undefined] = ACTIONS(1911),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [273] = {
    [sym_import] = STATE(1186),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1186),
    [sym_yield_expression] = STATE(1186),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1186),
    [sym_jsx_fragment] = STATE(1186),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1186),
    [sym_class] = STATE(1186),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1186),
    [sym_arrow_function] = STATE(1186),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1186),
    [sym_new_expression] = STATE(1186),
    [sym_await_expression] = STATE(1186),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1186),
    [sym_augmented_assignment_expression] = STATE(1186),
    [sym_ternary_expression] = STATE(1186),
    [sym_binary_expression] = STATE(1186),
    [sym_unary_expression] = STATE(1186),
    [sym_update_expression] = STATE(1186),
    [sym_string] = STATE(1186),
    [sym_template_string] = STATE(1186),
    [sym_regex] = STATE(1186),
    [sym_meta_property] = STATE(1186),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1186),
    [sym_as_expression] = STATE(1186),
    [sym_internal_module] = STATE(1186),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1913),
    [sym_this] = ACTIONS(1915),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1915),
    [sym_false] = ACTIONS(1915),
    [sym_null] = ACTIONS(1915),
    [sym_undefined] = ACTIONS(1915),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [274] = {
    [sym_import] = STATE(962),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(962),
    [sym_yield_expression] = STATE(962),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(962),
    [sym_jsx_fragment] = STATE(962),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(962),
    [sym_class] = STATE(962),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(962),
    [sym_arrow_function] = STATE(962),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(962),
    [sym_new_expression] = STATE(962),
    [sym_await_expression] = STATE(962),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(962),
    [sym_augmented_assignment_expression] = STATE(962),
    [sym_ternary_expression] = STATE(962),
    [sym_binary_expression] = STATE(962),
    [sym_unary_expression] = STATE(962),
    [sym_update_expression] = STATE(962),
    [sym_string] = STATE(962),
    [sym_template_string] = STATE(962),
    [sym_regex] = STATE(962),
    [sym_meta_property] = STATE(962),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(962),
    [sym_as_expression] = STATE(962),
    [sym_internal_module] = STATE(962),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1917),
    [sym_this] = ACTIONS(1919),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [sym_null] = ACTIONS(1919),
    [sym_undefined] = ACTIONS(1919),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [275] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(982),
    [sym_jsx_fragment] = STATE(982),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(982),
    [sym_class] = STATE(982),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1921),
    [sym_this] = ACTIONS(1923),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [sym_undefined] = ACTIONS(1923),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [276] = {
    [sym_import] = STATE(1195),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1195),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1195),
    [sym_jsx_fragment] = STATE(1195),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1195),
    [sym_class] = STATE(1195),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1195),
    [sym_arrow_function] = STATE(1195),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1195),
    [sym_augmented_assignment_expression] = STATE(1195),
    [sym_ternary_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_update_expression] = STATE(1195),
    [sym_string] = STATE(1195),
    [sym_template_string] = STATE(1195),
    [sym_regex] = STATE(1195),
    [sym_meta_property] = STATE(1195),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1195),
    [sym_as_expression] = STATE(1195),
    [sym_internal_module] = STATE(1195),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1925),
    [sym_this] = ACTIONS(1927),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1927),
    [sym_false] = ACTIONS(1927),
    [sym_null] = ACTIONS(1927),
    [sym_undefined] = ACTIONS(1927),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [277] = {
    [sym_import] = STATE(1183),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1183),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1183),
    [sym_jsx_fragment] = STATE(1183),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1183),
    [sym_class] = STATE(1183),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1183),
    [sym_arrow_function] = STATE(1183),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1183),
    [sym_new_expression] = STATE(1183),
    [sym_await_expression] = STATE(1183),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1183),
    [sym_augmented_assignment_expression] = STATE(1183),
    [sym_ternary_expression] = STATE(1183),
    [sym_binary_expression] = STATE(1183),
    [sym_unary_expression] = STATE(1183),
    [sym_update_expression] = STATE(1183),
    [sym_string] = STATE(1183),
    [sym_template_string] = STATE(1183),
    [sym_regex] = STATE(1183),
    [sym_meta_property] = STATE(1183),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1183),
    [sym_as_expression] = STATE(1183),
    [sym_internal_module] = STATE(1183),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1929),
    [sym_this] = ACTIONS(1931),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1931),
    [sym_false] = ACTIONS(1931),
    [sym_null] = ACTIONS(1931),
    [sym_undefined] = ACTIONS(1931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [278] = {
    [sym_import] = STATE(1196),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1196),
    [sym_yield_expression] = STATE(1196),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1196),
    [sym_jsx_fragment] = STATE(1196),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1196),
    [sym_class] = STATE(1196),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1196),
    [sym_arrow_function] = STATE(1196),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1196),
    [sym_new_expression] = STATE(1196),
    [sym_await_expression] = STATE(1196),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1196),
    [sym_augmented_assignment_expression] = STATE(1196),
    [sym_ternary_expression] = STATE(1196),
    [sym_binary_expression] = STATE(1196),
    [sym_unary_expression] = STATE(1196),
    [sym_update_expression] = STATE(1196),
    [sym_string] = STATE(1196),
    [sym_template_string] = STATE(1196),
    [sym_regex] = STATE(1196),
    [sym_meta_property] = STATE(1196),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1196),
    [sym_as_expression] = STATE(1196),
    [sym_internal_module] = STATE(1196),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1933),
    [sym_this] = ACTIONS(1935),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1935),
    [sym_false] = ACTIONS(1935),
    [sym_null] = ACTIONS(1935),
    [sym_undefined] = ACTIONS(1935),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [279] = {
    [sym_import] = STATE(980),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(980),
    [sym_yield_expression] = STATE(980),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(980),
    [sym_jsx_fragment] = STATE(980),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(980),
    [sym_class] = STATE(980),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(980),
    [sym_arrow_function] = STATE(980),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(980),
    [sym_new_expression] = STATE(980),
    [sym_await_expression] = STATE(980),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(980),
    [sym_augmented_assignment_expression] = STATE(980),
    [sym_ternary_expression] = STATE(980),
    [sym_binary_expression] = STATE(980),
    [sym_unary_expression] = STATE(980),
    [sym_update_expression] = STATE(980),
    [sym_string] = STATE(980),
    [sym_template_string] = STATE(980),
    [sym_regex] = STATE(980),
    [sym_meta_property] = STATE(980),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(980),
    [sym_as_expression] = STATE(980),
    [sym_internal_module] = STATE(980),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1937),
    [sym_this] = ACTIONS(1939),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1939),
    [sym_false] = ACTIONS(1939),
    [sym_null] = ACTIONS(1939),
    [sym_undefined] = ACTIONS(1939),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [280] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [281] = {
    [sym_import] = STATE(1246),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1246),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1246),
    [sym_jsx_fragment] = STATE(1246),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1246),
    [sym_class] = STATE(1246),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1246),
    [sym_arrow_function] = STATE(1246),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1246),
    [sym_new_expression] = STATE(1246),
    [sym_await_expression] = STATE(1246),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1246),
    [sym_augmented_assignment_expression] = STATE(1246),
    [sym_ternary_expression] = STATE(1246),
    [sym_binary_expression] = STATE(1246),
    [sym_unary_expression] = STATE(1246),
    [sym_update_expression] = STATE(1246),
    [sym_string] = STATE(1246),
    [sym_template_string] = STATE(1246),
    [sym_regex] = STATE(1246),
    [sym_meta_property] = STATE(1246),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1246),
    [sym_as_expression] = STATE(1246),
    [sym_internal_module] = STATE(1246),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1941),
    [sym_this] = ACTIONS(1943),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1943),
    [sym_false] = ACTIONS(1943),
    [sym_null] = ACTIONS(1943),
    [sym_undefined] = ACTIONS(1943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [282] = {
    [sym_import] = STATE(983),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(983),
    [sym_arrow_function] = STATE(983),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(983),
    [sym_new_expression] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_string] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [283] = {
    [sym_import] = STATE(1485),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1485),
    [sym_yield_expression] = STATE(1485),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1485),
    [sym_jsx_fragment] = STATE(1485),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1485),
    [sym_class] = STATE(1485),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1485),
    [sym_arrow_function] = STATE(1485),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1485),
    [sym_new_expression] = STATE(1485),
    [sym_await_expression] = STATE(1485),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1485),
    [sym_augmented_assignment_expression] = STATE(1485),
    [sym_ternary_expression] = STATE(1485),
    [sym_binary_expression] = STATE(1485),
    [sym_unary_expression] = STATE(1485),
    [sym_update_expression] = STATE(1485),
    [sym_string] = STATE(1485),
    [sym_template_string] = STATE(1485),
    [sym_regex] = STATE(1485),
    [sym_meta_property] = STATE(1485),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1485),
    [sym_as_expression] = STATE(1485),
    [sym_internal_module] = STATE(1485),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1949),
    [sym_this] = ACTIONS(1951),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [sym_null] = ACTIONS(1951),
    [sym_undefined] = ACTIONS(1951),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [284] = {
    [sym_import] = STATE(985),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(985),
    [sym_yield_expression] = STATE(985),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(985),
    [sym_jsx_fragment] = STATE(985),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(985),
    [sym_class] = STATE(985),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(985),
    [sym_arrow_function] = STATE(985),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(985),
    [sym_new_expression] = STATE(985),
    [sym_await_expression] = STATE(985),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(985),
    [sym_augmented_assignment_expression] = STATE(985),
    [sym_ternary_expression] = STATE(985),
    [sym_binary_expression] = STATE(985),
    [sym_unary_expression] = STATE(985),
    [sym_update_expression] = STATE(985),
    [sym_string] = STATE(985),
    [sym_template_string] = STATE(985),
    [sym_regex] = STATE(985),
    [sym_meta_property] = STATE(985),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(985),
    [sym_as_expression] = STATE(985),
    [sym_internal_module] = STATE(985),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1953),
    [sym_this] = ACTIONS(1955),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1955),
    [sym_false] = ACTIONS(1955),
    [sym_null] = ACTIONS(1955),
    [sym_undefined] = ACTIONS(1955),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [285] = {
    [sym_import] = STATE(987),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(987),
    [sym_yield_expression] = STATE(987),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(987),
    [sym_jsx_fragment] = STATE(987),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(987),
    [sym_class] = STATE(987),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(987),
    [sym_arrow_function] = STATE(987),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(987),
    [sym_new_expression] = STATE(987),
    [sym_await_expression] = STATE(987),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(987),
    [sym_augmented_assignment_expression] = STATE(987),
    [sym_ternary_expression] = STATE(987),
    [sym_binary_expression] = STATE(987),
    [sym_unary_expression] = STATE(987),
    [sym_update_expression] = STATE(987),
    [sym_string] = STATE(987),
    [sym_template_string] = STATE(987),
    [sym_regex] = STATE(987),
    [sym_meta_property] = STATE(987),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(987),
    [sym_as_expression] = STATE(987),
    [sym_internal_module] = STATE(987),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1957),
    [sym_this] = ACTIONS(1959),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1959),
    [sym_false] = ACTIONS(1959),
    [sym_null] = ACTIONS(1959),
    [sym_undefined] = ACTIONS(1959),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [286] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(988),
    [sym_jsx_fragment] = STATE(988),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(988),
    [sym_class] = STATE(988),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1961),
    [sym_this] = ACTIONS(1963),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1963),
    [sym_false] = ACTIONS(1963),
    [sym_null] = ACTIONS(1963),
    [sym_undefined] = ACTIONS(1963),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [287] = {
    [sym_import] = STATE(1167),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1167),
    [sym_yield_expression] = STATE(1167),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1167),
    [sym_jsx_fragment] = STATE(1167),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1167),
    [sym_class] = STATE(1167),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1167),
    [sym_arrow_function] = STATE(1167),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1167),
    [sym_new_expression] = STATE(1167),
    [sym_await_expression] = STATE(1167),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1167),
    [sym_augmented_assignment_expression] = STATE(1167),
    [sym_ternary_expression] = STATE(1167),
    [sym_binary_expression] = STATE(1167),
    [sym_unary_expression] = STATE(1167),
    [sym_update_expression] = STATE(1167),
    [sym_string] = STATE(1167),
    [sym_template_string] = STATE(1167),
    [sym_regex] = STATE(1167),
    [sym_meta_property] = STATE(1167),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1167),
    [sym_internal_module] = STATE(1167),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1965),
    [sym_this] = ACTIONS(1967),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [sym_null] = ACTIONS(1967),
    [sym_undefined] = ACTIONS(1967),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [288] = {
    [sym_import] = STATE(1182),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1182),
    [sym_yield_expression] = STATE(1182),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1182),
    [sym_jsx_fragment] = STATE(1182),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1182),
    [sym_class] = STATE(1182),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1182),
    [sym_arrow_function] = STATE(1182),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1182),
    [sym_new_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1182),
    [sym_augmented_assignment_expression] = STATE(1182),
    [sym_ternary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_update_expression] = STATE(1182),
    [sym_string] = STATE(1182),
    [sym_template_string] = STATE(1182),
    [sym_regex] = STATE(1182),
    [sym_meta_property] = STATE(1182),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1182),
    [sym_as_expression] = STATE(1182),
    [sym_internal_module] = STATE(1182),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1969),
    [sym_this] = ACTIONS(1971),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [sym_null] = ACTIONS(1971),
    [sym_undefined] = ACTIONS(1971),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [289] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1973),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [sym_undefined] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [290] = {
    [sym_import] = STATE(992),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(992),
    [sym_yield_expression] = STATE(992),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(992),
    [sym_jsx_fragment] = STATE(992),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(992),
    [sym_class] = STATE(992),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(992),
    [sym_arrow_function] = STATE(992),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(992),
    [sym_new_expression] = STATE(992),
    [sym_await_expression] = STATE(992),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(992),
    [sym_augmented_assignment_expression] = STATE(992),
    [sym_ternary_expression] = STATE(992),
    [sym_binary_expression] = STATE(992),
    [sym_unary_expression] = STATE(992),
    [sym_update_expression] = STATE(992),
    [sym_string] = STATE(992),
    [sym_template_string] = STATE(992),
    [sym_regex] = STATE(992),
    [sym_meta_property] = STATE(992),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(992),
    [sym_as_expression] = STATE(992),
    [sym_internal_module] = STATE(992),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1975),
    [sym_this] = ACTIONS(1977),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [291] = {
    [sym_import] = STATE(993),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(993),
    [sym_yield_expression] = STATE(993),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(993),
    [sym_jsx_fragment] = STATE(993),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(993),
    [sym_class] = STATE(993),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(993),
    [sym_arrow_function] = STATE(993),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(993),
    [sym_new_expression] = STATE(993),
    [sym_await_expression] = STATE(993),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(993),
    [sym_augmented_assignment_expression] = STATE(993),
    [sym_ternary_expression] = STATE(993),
    [sym_binary_expression] = STATE(993),
    [sym_unary_expression] = STATE(993),
    [sym_update_expression] = STATE(993),
    [sym_string] = STATE(993),
    [sym_template_string] = STATE(993),
    [sym_regex] = STATE(993),
    [sym_meta_property] = STATE(993),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(993),
    [sym_internal_module] = STATE(993),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1979),
    [sym_this] = ACTIONS(1981),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1981),
    [sym_false] = ACTIONS(1981),
    [sym_null] = ACTIONS(1981),
    [sym_undefined] = ACTIONS(1981),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [292] = {
    [sym_import] = STATE(994),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(994),
    [sym_yield_expression] = STATE(994),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(994),
    [sym_jsx_fragment] = STATE(994),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(994),
    [sym_class] = STATE(994),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(994),
    [sym_arrow_function] = STATE(994),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(994),
    [sym_new_expression] = STATE(994),
    [sym_await_expression] = STATE(994),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(994),
    [sym_augmented_assignment_expression] = STATE(994),
    [sym_ternary_expression] = STATE(994),
    [sym_binary_expression] = STATE(994),
    [sym_unary_expression] = STATE(994),
    [sym_update_expression] = STATE(994),
    [sym_string] = STATE(994),
    [sym_template_string] = STATE(994),
    [sym_regex] = STATE(994),
    [sym_meta_property] = STATE(994),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(994),
    [sym_as_expression] = STATE(994),
    [sym_internal_module] = STATE(994),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1983),
    [sym_this] = ACTIONS(1985),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1985),
    [sym_false] = ACTIONS(1985),
    [sym_null] = ACTIONS(1985),
    [sym_undefined] = ACTIONS(1985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [293] = {
    [sym_import] = STATE(995),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(995),
    [sym_yield_expression] = STATE(995),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(995),
    [sym_jsx_fragment] = STATE(995),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(995),
    [sym_class] = STATE(995),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(995),
    [sym_arrow_function] = STATE(995),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(995),
    [sym_new_expression] = STATE(995),
    [sym_await_expression] = STATE(995),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(995),
    [sym_augmented_assignment_expression] = STATE(995),
    [sym_ternary_expression] = STATE(995),
    [sym_binary_expression] = STATE(995),
    [sym_unary_expression] = STATE(995),
    [sym_update_expression] = STATE(995),
    [sym_string] = STATE(995),
    [sym_template_string] = STATE(995),
    [sym_regex] = STATE(995),
    [sym_meta_property] = STATE(995),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(995),
    [sym_as_expression] = STATE(995),
    [sym_internal_module] = STATE(995),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1987),
    [sym_this] = ACTIONS(1989),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1989),
    [sym_false] = ACTIONS(1989),
    [sym_null] = ACTIONS(1989),
    [sym_undefined] = ACTIONS(1989),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [294] = {
    [sym_import] = STATE(996),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(996),
    [sym_yield_expression] = STATE(996),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(996),
    [sym_jsx_fragment] = STATE(996),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(996),
    [sym_class] = STATE(996),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(996),
    [sym_arrow_function] = STATE(996),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(996),
    [sym_new_expression] = STATE(996),
    [sym_await_expression] = STATE(996),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(996),
    [sym_augmented_assignment_expression] = STATE(996),
    [sym_ternary_expression] = STATE(996),
    [sym_binary_expression] = STATE(996),
    [sym_unary_expression] = STATE(996),
    [sym_update_expression] = STATE(996),
    [sym_string] = STATE(996),
    [sym_template_string] = STATE(996),
    [sym_regex] = STATE(996),
    [sym_meta_property] = STATE(996),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(996),
    [sym_as_expression] = STATE(996),
    [sym_internal_module] = STATE(996),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1991),
    [sym_this] = ACTIONS(1993),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1993),
    [sym_false] = ACTIONS(1993),
    [sym_null] = ACTIONS(1993),
    [sym_undefined] = ACTIONS(1993),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [295] = {
    [sym_import] = STATE(997),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(997),
    [sym_yield_expression] = STATE(997),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(997),
    [sym_jsx_fragment] = STATE(997),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(997),
    [sym_class] = STATE(997),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(997),
    [sym_arrow_function] = STATE(997),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(997),
    [sym_new_expression] = STATE(997),
    [sym_await_expression] = STATE(997),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(997),
    [sym_augmented_assignment_expression] = STATE(997),
    [sym_ternary_expression] = STATE(997),
    [sym_binary_expression] = STATE(997),
    [sym_unary_expression] = STATE(997),
    [sym_update_expression] = STATE(997),
    [sym_string] = STATE(997),
    [sym_template_string] = STATE(997),
    [sym_regex] = STATE(997),
    [sym_meta_property] = STATE(997),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(997),
    [sym_as_expression] = STATE(997),
    [sym_internal_module] = STATE(997),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1995),
    [sym_this] = ACTIONS(1997),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [sym_null] = ACTIONS(1997),
    [sym_undefined] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [296] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(998),
    [sym_yield_expression] = STATE(998),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(998),
    [sym_jsx_fragment] = STATE(998),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(998),
    [sym_class] = STATE(998),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(998),
    [sym_await_expression] = STATE(998),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(998),
    [sym_augmented_assignment_expression] = STATE(998),
    [sym_ternary_expression] = STATE(998),
    [sym_binary_expression] = STATE(998),
    [sym_unary_expression] = STATE(998),
    [sym_update_expression] = STATE(998),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(998),
    [sym_internal_module] = STATE(998),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1999),
    [sym_this] = ACTIONS(2001),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [297] = {
    [sym_import] = STATE(1233),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1233),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1233),
    [sym_jsx_fragment] = STATE(1233),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1233),
    [sym_class] = STATE(1233),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1233),
    [sym_arrow_function] = STATE(1233),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1233),
    [sym_new_expression] = STATE(1233),
    [sym_await_expression] = STATE(1233),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1233),
    [sym_augmented_assignment_expression] = STATE(1233),
    [sym_ternary_expression] = STATE(1233),
    [sym_binary_expression] = STATE(1233),
    [sym_unary_expression] = STATE(1233),
    [sym_update_expression] = STATE(1233),
    [sym_string] = STATE(1233),
    [sym_template_string] = STATE(1233),
    [sym_regex] = STATE(1233),
    [sym_meta_property] = STATE(1233),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1233),
    [sym_as_expression] = STATE(1233),
    [sym_internal_module] = STATE(1233),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2003),
    [sym_this] = ACTIONS(2005),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [sym_null] = ACTIONS(2005),
    [sym_undefined] = ACTIONS(2005),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [298] = {
    [sym_import] = STATE(1180),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1180),
    [sym_yield_expression] = STATE(1180),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1180),
    [sym_jsx_fragment] = STATE(1180),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1180),
    [sym_class] = STATE(1180),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1180),
    [sym_arrow_function] = STATE(1180),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1180),
    [sym_new_expression] = STATE(1180),
    [sym_await_expression] = STATE(1180),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1180),
    [sym_augmented_assignment_expression] = STATE(1180),
    [sym_ternary_expression] = STATE(1180),
    [sym_binary_expression] = STATE(1180),
    [sym_unary_expression] = STATE(1180),
    [sym_update_expression] = STATE(1180),
    [sym_string] = STATE(1180),
    [sym_template_string] = STATE(1180),
    [sym_regex] = STATE(1180),
    [sym_meta_property] = STATE(1180),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1180),
    [sym_as_expression] = STATE(1180),
    [sym_internal_module] = STATE(1180),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2007),
    [sym_this] = ACTIONS(2009),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2009),
    [sym_false] = ACTIONS(2009),
    [sym_null] = ACTIONS(2009),
    [sym_undefined] = ACTIONS(2009),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [299] = {
    [sym_import] = STATE(1197),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1197),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1197),
    [sym_jsx_fragment] = STATE(1197),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1197),
    [sym_class] = STATE(1197),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1197),
    [sym_arrow_function] = STATE(1197),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1197),
    [sym_new_expression] = STATE(1197),
    [sym_await_expression] = STATE(1197),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1197),
    [sym_augmented_assignment_expression] = STATE(1197),
    [sym_ternary_expression] = STATE(1197),
    [sym_binary_expression] = STATE(1197),
    [sym_unary_expression] = STATE(1197),
    [sym_update_expression] = STATE(1197),
    [sym_string] = STATE(1197),
    [sym_template_string] = STATE(1197),
    [sym_regex] = STATE(1197),
    [sym_meta_property] = STATE(1197),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1197),
    [sym_as_expression] = STATE(1197),
    [sym_internal_module] = STATE(1197),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2011),
    [sym_this] = ACTIONS(2013),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2013),
    [sym_false] = ACTIONS(2013),
    [sym_null] = ACTIONS(2013),
    [sym_undefined] = ACTIONS(2013),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [300] = {
    [sym_import] = STATE(962),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(962),
    [sym_yield_expression] = STATE(962),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(962),
    [sym_jsx_fragment] = STATE(962),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(962),
    [sym_class] = STATE(962),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(962),
    [sym_arrow_function] = STATE(962),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(962),
    [sym_new_expression] = STATE(962),
    [sym_await_expression] = STATE(962),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(962),
    [sym_augmented_assignment_expression] = STATE(962),
    [sym_ternary_expression] = STATE(962),
    [sym_binary_expression] = STATE(962),
    [sym_unary_expression] = STATE(962),
    [sym_update_expression] = STATE(962),
    [sym_string] = STATE(962),
    [sym_template_string] = STATE(962),
    [sym_regex] = STATE(962),
    [sym_meta_property] = STATE(962),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(962),
    [sym_as_expression] = STATE(962),
    [sym_internal_module] = STATE(962),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1917),
    [sym_this] = ACTIONS(1919),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [sym_null] = ACTIONS(1919),
    [sym_undefined] = ACTIONS(1919),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [301] = {
    [sym_import] = STATE(1225),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1225),
    [sym_yield_expression] = STATE(1225),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1225),
    [sym_jsx_fragment] = STATE(1225),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1225),
    [sym_class] = STATE(1225),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1225),
    [sym_arrow_function] = STATE(1225),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1225),
    [sym_new_expression] = STATE(1225),
    [sym_await_expression] = STATE(1225),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1225),
    [sym_augmented_assignment_expression] = STATE(1225),
    [sym_ternary_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_update_expression] = STATE(1225),
    [sym_string] = STATE(1225),
    [sym_template_string] = STATE(1225),
    [sym_regex] = STATE(1225),
    [sym_meta_property] = STATE(1225),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1225),
    [sym_as_expression] = STATE(1225),
    [sym_internal_module] = STATE(1225),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2015),
    [sym_this] = ACTIONS(2017),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [sym_null] = ACTIONS(2017),
    [sym_undefined] = ACTIONS(2017),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [302] = {
    [sym_import] = STATE(1530),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1530),
    [sym_yield_expression] = STATE(1530),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1530),
    [sym_jsx_fragment] = STATE(1530),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1530),
    [sym_class] = STATE(1530),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1530),
    [sym_arrow_function] = STATE(1530),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1530),
    [sym_new_expression] = STATE(1530),
    [sym_await_expression] = STATE(1530),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1530),
    [sym_augmented_assignment_expression] = STATE(1530),
    [sym_ternary_expression] = STATE(1530),
    [sym_binary_expression] = STATE(1530),
    [sym_unary_expression] = STATE(1530),
    [sym_update_expression] = STATE(1530),
    [sym_string] = STATE(1530),
    [sym_template_string] = STATE(1530),
    [sym_regex] = STATE(1530),
    [sym_meta_property] = STATE(1530),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1530),
    [sym_as_expression] = STATE(1530),
    [sym_internal_module] = STATE(1530),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2019),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [sym_null] = ACTIONS(2021),
    [sym_undefined] = ACTIONS(2021),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [303] = {
    [sym_export_clause] = STATE(2510),
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(1460),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [304] = {
    [sym_import] = STATE(1217),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1217),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1217),
    [sym_jsx_fragment] = STATE(1217),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1217),
    [sym_class] = STATE(1217),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1217),
    [sym_arrow_function] = STATE(1217),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1217),
    [sym_new_expression] = STATE(1217),
    [sym_await_expression] = STATE(1217),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1217),
    [sym_augmented_assignment_expression] = STATE(1217),
    [sym_ternary_expression] = STATE(1217),
    [sym_binary_expression] = STATE(1217),
    [sym_unary_expression] = STATE(1217),
    [sym_update_expression] = STATE(1217),
    [sym_string] = STATE(1217),
    [sym_template_string] = STATE(1217),
    [sym_regex] = STATE(1217),
    [sym_meta_property] = STATE(1217),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1217),
    [sym_as_expression] = STATE(1217),
    [sym_internal_module] = STATE(1217),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2025),
    [sym_this] = ACTIONS(2027),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [sym_null] = ACTIONS(2027),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [305] = {
    [sym_import] = STATE(1218),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1218),
    [sym_jsx_fragment] = STATE(1218),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1218),
    [sym_class] = STATE(1218),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1218),
    [sym_arrow_function] = STATE(1218),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_string] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [306] = {
    [sym_import] = STATE(1198),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1198),
    [sym_yield_expression] = STATE(1198),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1198),
    [sym_jsx_fragment] = STATE(1198),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1198),
    [sym_class] = STATE(1198),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1198),
    [sym_arrow_function] = STATE(1198),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1198),
    [sym_new_expression] = STATE(1198),
    [sym_await_expression] = STATE(1198),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1198),
    [sym_augmented_assignment_expression] = STATE(1198),
    [sym_ternary_expression] = STATE(1198),
    [sym_binary_expression] = STATE(1198),
    [sym_unary_expression] = STATE(1198),
    [sym_update_expression] = STATE(1198),
    [sym_string] = STATE(1198),
    [sym_template_string] = STATE(1198),
    [sym_regex] = STATE(1198),
    [sym_meta_property] = STATE(1198),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1198),
    [sym_as_expression] = STATE(1198),
    [sym_internal_module] = STATE(1198),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2033),
    [sym_this] = ACTIONS(2035),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2035),
    [sym_false] = ACTIONS(2035),
    [sym_null] = ACTIONS(2035),
    [sym_undefined] = ACTIONS(2035),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [307] = {
    [sym_import] = STATE(1176),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1176),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1176),
    [sym_jsx_fragment] = STATE(1176),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1176),
    [sym_class] = STATE(1176),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1176),
    [sym_arrow_function] = STATE(1176),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1176),
    [sym_new_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(1176),
    [sym_ternary_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_update_expression] = STATE(1176),
    [sym_string] = STATE(1176),
    [sym_template_string] = STATE(1176),
    [sym_regex] = STATE(1176),
    [sym_meta_property] = STATE(1176),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1176),
    [sym_internal_module] = STATE(1176),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2039),
    [sym_this] = ACTIONS(2041),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_null] = ACTIONS(2041),
    [sym_undefined] = ACTIONS(2041),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [308] = {
    [sym_import] = STATE(1110),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1110),
    [sym_yield_expression] = STATE(1110),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1110),
    [sym_jsx_fragment] = STATE(1110),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1110),
    [sym_class] = STATE(1110),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1110),
    [sym_arrow_function] = STATE(1110),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1110),
    [sym_new_expression] = STATE(1110),
    [sym_await_expression] = STATE(1110),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1110),
    [sym_augmented_assignment_expression] = STATE(1110),
    [sym_ternary_expression] = STATE(1110),
    [sym_binary_expression] = STATE(1110),
    [sym_unary_expression] = STATE(1110),
    [sym_update_expression] = STATE(1110),
    [sym_string] = STATE(1110),
    [sym_template_string] = STATE(1110),
    [sym_regex] = STATE(1110),
    [sym_meta_property] = STATE(1110),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1110),
    [sym_as_expression] = STATE(1110),
    [sym_internal_module] = STATE(1110),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2043),
    [sym_this] = ACTIONS(2045),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2045),
    [sym_false] = ACTIONS(2045),
    [sym_null] = ACTIONS(2045),
    [sym_undefined] = ACTIONS(2045),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [309] = {
    [sym_import] = STATE(1199),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1199),
    [sym_yield_expression] = STATE(1199),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1199),
    [sym_jsx_fragment] = STATE(1199),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1199),
    [sym_class] = STATE(1199),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1199),
    [sym_arrow_function] = STATE(1199),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1199),
    [sym_new_expression] = STATE(1199),
    [sym_await_expression] = STATE(1199),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1199),
    [sym_augmented_assignment_expression] = STATE(1199),
    [sym_ternary_expression] = STATE(1199),
    [sym_binary_expression] = STATE(1199),
    [sym_unary_expression] = STATE(1199),
    [sym_update_expression] = STATE(1199),
    [sym_string] = STATE(1199),
    [sym_template_string] = STATE(1199),
    [sym_regex] = STATE(1199),
    [sym_meta_property] = STATE(1199),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1199),
    [sym_as_expression] = STATE(1199),
    [sym_internal_module] = STATE(1199),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2047),
    [sym_this] = ACTIONS(2049),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_null] = ACTIONS(2049),
    [sym_undefined] = ACTIONS(2049),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [310] = {
    [sym_import] = STATE(1113),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1113),
    [sym_yield_expression] = STATE(1113),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1113),
    [sym_jsx_fragment] = STATE(1113),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1113),
    [sym_class] = STATE(1113),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1113),
    [sym_arrow_function] = STATE(1113),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1113),
    [sym_new_expression] = STATE(1113),
    [sym_await_expression] = STATE(1113),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1113),
    [sym_augmented_assignment_expression] = STATE(1113),
    [sym_ternary_expression] = STATE(1113),
    [sym_binary_expression] = STATE(1113),
    [sym_unary_expression] = STATE(1113),
    [sym_update_expression] = STATE(1113),
    [sym_string] = STATE(1113),
    [sym_template_string] = STATE(1113),
    [sym_regex] = STATE(1113),
    [sym_meta_property] = STATE(1113),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1113),
    [sym_as_expression] = STATE(1113),
    [sym_internal_module] = STATE(1113),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2051),
    [sym_this] = ACTIONS(2053),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_null] = ACTIONS(2053),
    [sym_undefined] = ACTIONS(2053),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [311] = {
    [sym_import] = STATE(1502),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1502),
    [sym_yield_expression] = STATE(1502),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1502),
    [sym_jsx_fragment] = STATE(1502),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1502),
    [sym_class] = STATE(1502),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1502),
    [sym_arrow_function] = STATE(1502),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1502),
    [sym_new_expression] = STATE(1502),
    [sym_await_expression] = STATE(1502),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1502),
    [sym_augmented_assignment_expression] = STATE(1502),
    [sym_ternary_expression] = STATE(1502),
    [sym_binary_expression] = STATE(1502),
    [sym_unary_expression] = STATE(1502),
    [sym_update_expression] = STATE(1502),
    [sym_string] = STATE(1502),
    [sym_template_string] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_meta_property] = STATE(1502),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1502),
    [sym_as_expression] = STATE(1502),
    [sym_internal_module] = STATE(1502),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2055),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [312] = {
    [sym_import] = STATE(1125),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1125),
    [sym_yield_expression] = STATE(1125),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1125),
    [sym_jsx_fragment] = STATE(1125),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1125),
    [sym_class] = STATE(1125),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1125),
    [sym_arrow_function] = STATE(1125),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1125),
    [sym_new_expression] = STATE(1125),
    [sym_await_expression] = STATE(1125),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1125),
    [sym_augmented_assignment_expression] = STATE(1125),
    [sym_ternary_expression] = STATE(1125),
    [sym_binary_expression] = STATE(1125),
    [sym_unary_expression] = STATE(1125),
    [sym_update_expression] = STATE(1125),
    [sym_string] = STATE(1125),
    [sym_template_string] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_meta_property] = STATE(1125),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1125),
    [sym_internal_module] = STATE(1125),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2059),
    [sym_this] = ACTIONS(2061),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_null] = ACTIONS(2061),
    [sym_undefined] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [313] = {
    [sym_import] = STATE(1176),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1176),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1176),
    [sym_jsx_fragment] = STATE(1176),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1176),
    [sym_class] = STATE(1176),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1176),
    [sym_arrow_function] = STATE(1176),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1176),
    [sym_new_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(1176),
    [sym_ternary_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_update_expression] = STATE(1176),
    [sym_string] = STATE(1176),
    [sym_template_string] = STATE(1176),
    [sym_regex] = STATE(1176),
    [sym_meta_property] = STATE(1176),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1176),
    [sym_internal_module] = STATE(1176),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2039),
    [sym_this] = ACTIONS(2041),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_null] = ACTIONS(2041),
    [sym_undefined] = ACTIONS(2041),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [314] = {
    [sym_export_clause] = STATE(2510),
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(1460),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(2063),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [315] = {
    [sym_import] = STATE(1344),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1344),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1344),
    [sym_jsx_fragment] = STATE(1344),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1344),
    [sym_class] = STATE(1344),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1344),
    [sym_arrow_function] = STATE(1344),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1344),
    [sym_new_expression] = STATE(1344),
    [sym_await_expression] = STATE(1344),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1344),
    [sym_augmented_assignment_expression] = STATE(1344),
    [sym_ternary_expression] = STATE(1344),
    [sym_binary_expression] = STATE(1344),
    [sym_unary_expression] = STATE(1344),
    [sym_update_expression] = STATE(1344),
    [sym_string] = STATE(1344),
    [sym_template_string] = STATE(1344),
    [sym_regex] = STATE(1344),
    [sym_meta_property] = STATE(1344),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1344),
    [sym_as_expression] = STATE(1344),
    [sym_internal_module] = STATE(1344),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2065),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [316] = {
    [sym_import] = STATE(1003),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1003),
    [sym_yield_expression] = STATE(1003),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1003),
    [sym_jsx_fragment] = STATE(1003),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1003),
    [sym_class] = STATE(1003),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1003),
    [sym_arrow_function] = STATE(1003),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1003),
    [sym_new_expression] = STATE(1003),
    [sym_await_expression] = STATE(1003),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1003),
    [sym_augmented_assignment_expression] = STATE(1003),
    [sym_ternary_expression] = STATE(1003),
    [sym_binary_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1003),
    [sym_update_expression] = STATE(1003),
    [sym_string] = STATE(1003),
    [sym_template_string] = STATE(1003),
    [sym_regex] = STATE(1003),
    [sym_meta_property] = STATE(1003),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1003),
    [sym_as_expression] = STATE(1003),
    [sym_internal_module] = STATE(1003),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2069),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [317] = {
    [sym_import] = STATE(1252),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1252),
    [sym_jsx_fragment] = STATE(1252),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1252),
    [sym_class] = STATE(1252),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1252),
    [sym_arrow_function] = STATE(1252),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1252),
    [sym_new_expression] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_string] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_meta_property] = STATE(1252),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2073),
    [sym_this] = ACTIONS(2075),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [sym_undefined] = ACTIONS(2075),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [318] = {
    [sym_import] = STATE(1019),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1019),
    [sym_yield_expression] = STATE(1019),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1019),
    [sym_jsx_fragment] = STATE(1019),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1019),
    [sym_class] = STATE(1019),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1019),
    [sym_arrow_function] = STATE(1019),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1019),
    [sym_new_expression] = STATE(1019),
    [sym_await_expression] = STATE(1019),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1019),
    [sym_augmented_assignment_expression] = STATE(1019),
    [sym_ternary_expression] = STATE(1019),
    [sym_binary_expression] = STATE(1019),
    [sym_unary_expression] = STATE(1019),
    [sym_update_expression] = STATE(1019),
    [sym_string] = STATE(1019),
    [sym_template_string] = STATE(1019),
    [sym_regex] = STATE(1019),
    [sym_meta_property] = STATE(1019),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1019),
    [sym_as_expression] = STATE(1019),
    [sym_internal_module] = STATE(1019),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2077),
    [sym_this] = ACTIONS(2079),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_null] = ACTIONS(2079),
    [sym_undefined] = ACTIONS(2079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [319] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1386),
    [sym_yield_expression] = STATE(1386),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1386),
    [sym_jsx_fragment] = STATE(1386),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1386),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1386),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1386),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1386),
    [sym_augmented_assignment_expression] = STATE(1386),
    [sym_ternary_expression] = STATE(1386),
    [sym_binary_expression] = STATE(1386),
    [sym_unary_expression] = STATE(1386),
    [sym_update_expression] = STATE(1386),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1386),
    [sym_as_expression] = STATE(1386),
    [sym_internal_module] = STATE(1386),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2081),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2083),
    [sym_this] = ACTIONS(2085),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2085),
    [sym_false] = ACTIONS(2085),
    [sym_null] = ACTIONS(2085),
    [sym_undefined] = ACTIONS(2085),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [320] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1178),
    [sym_jsx_fragment] = STATE(1178),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1178),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1178),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2087),
    [sym_this] = ACTIONS(2089),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_null] = ACTIONS(2089),
    [sym_undefined] = ACTIONS(2089),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [321] = {
    [sym_import] = STATE(1189),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1189),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1189),
    [sym_jsx_fragment] = STATE(1189),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1189),
    [sym_class] = STATE(1189),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1189),
    [sym_arrow_function] = STATE(1189),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1189),
    [sym_augmented_assignment_expression] = STATE(1189),
    [sym_ternary_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_update_expression] = STATE(1189),
    [sym_string] = STATE(1189),
    [sym_template_string] = STATE(1189),
    [sym_regex] = STATE(1189),
    [sym_meta_property] = STATE(1189),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1189),
    [sym_as_expression] = STATE(1189),
    [sym_internal_module] = STATE(1189),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2091),
    [sym_this] = ACTIONS(2093),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_null] = ACTIONS(2093),
    [sym_undefined] = ACTIONS(2093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [322] = {
    [sym_import] = STATE(962),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(962),
    [sym_yield_expression] = STATE(962),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(962),
    [sym_jsx_fragment] = STATE(962),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(962),
    [sym_class] = STATE(962),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(962),
    [sym_arrow_function] = STATE(962),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(962),
    [sym_new_expression] = STATE(962),
    [sym_await_expression] = STATE(962),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(962),
    [sym_augmented_assignment_expression] = STATE(962),
    [sym_ternary_expression] = STATE(962),
    [sym_binary_expression] = STATE(962),
    [sym_unary_expression] = STATE(962),
    [sym_update_expression] = STATE(962),
    [sym_string] = STATE(962),
    [sym_template_string] = STATE(962),
    [sym_regex] = STATE(962),
    [sym_meta_property] = STATE(962),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(962),
    [sym_as_expression] = STATE(962),
    [sym_internal_module] = STATE(962),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1917),
    [sym_this] = ACTIONS(1919),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [sym_null] = ACTIONS(1919),
    [sym_undefined] = ACTIONS(1919),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [323] = {
    [sym_import] = STATE(1295),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1295),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1295),
    [sym_jsx_fragment] = STATE(1295),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1295),
    [sym_class] = STATE(1295),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1295),
    [sym_arrow_function] = STATE(1295),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1295),
    [sym_new_expression] = STATE(1295),
    [sym_await_expression] = STATE(1295),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1295),
    [sym_augmented_assignment_expression] = STATE(1295),
    [sym_ternary_expression] = STATE(1295),
    [sym_binary_expression] = STATE(1295),
    [sym_unary_expression] = STATE(1295),
    [sym_update_expression] = STATE(1295),
    [sym_string] = STATE(1295),
    [sym_template_string] = STATE(1295),
    [sym_regex] = STATE(1295),
    [sym_meta_property] = STATE(1295),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1295),
    [sym_as_expression] = STATE(1295),
    [sym_internal_module] = STATE(1295),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2095),
    [sym_this] = ACTIONS(2097),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2097),
    [sym_false] = ACTIONS(2097),
    [sym_null] = ACTIONS(2097),
    [sym_undefined] = ACTIONS(2097),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [324] = {
    [sym_import] = STATE(1188),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1188),
    [sym_yield_expression] = STATE(1188),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1188),
    [sym_jsx_fragment] = STATE(1188),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1188),
    [sym_class] = STATE(1188),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1188),
    [sym_arrow_function] = STATE(1188),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1188),
    [sym_new_expression] = STATE(1188),
    [sym_await_expression] = STATE(1188),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1188),
    [sym_augmented_assignment_expression] = STATE(1188),
    [sym_ternary_expression] = STATE(1188),
    [sym_binary_expression] = STATE(1188),
    [sym_unary_expression] = STATE(1188),
    [sym_update_expression] = STATE(1188),
    [sym_string] = STATE(1188),
    [sym_template_string] = STATE(1188),
    [sym_regex] = STATE(1188),
    [sym_meta_property] = STATE(1188),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1188),
    [sym_as_expression] = STATE(1188),
    [sym_internal_module] = STATE(1188),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2099),
    [sym_this] = ACTIONS(2101),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2101),
    [sym_false] = ACTIONS(2101),
    [sym_null] = ACTIONS(2101),
    [sym_undefined] = ACTIONS(2101),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [325] = {
    [sym_import] = STATE(1294),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1294),
    [sym_jsx_fragment] = STATE(1294),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1294),
    [sym_class] = STATE(1294),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1294),
    [sym_arrow_function] = STATE(1294),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1294),
    [sym_new_expression] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_string] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2103),
    [sym_this] = ACTIONS(2105),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_null] = ACTIONS(2105),
    [sym_undefined] = ACTIONS(2105),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [326] = {
    [sym_import] = STATE(1266),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1266),
    [sym_yield_expression] = STATE(1266),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1266),
    [sym_jsx_fragment] = STATE(1266),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1266),
    [sym_class] = STATE(1266),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1266),
    [sym_arrow_function] = STATE(1266),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1266),
    [sym_new_expression] = STATE(1266),
    [sym_await_expression] = STATE(1266),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1266),
    [sym_augmented_assignment_expression] = STATE(1266),
    [sym_ternary_expression] = STATE(1266),
    [sym_binary_expression] = STATE(1266),
    [sym_unary_expression] = STATE(1266),
    [sym_update_expression] = STATE(1266),
    [sym_string] = STATE(1266),
    [sym_template_string] = STATE(1266),
    [sym_regex] = STATE(1266),
    [sym_meta_property] = STATE(1266),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1266),
    [sym_as_expression] = STATE(1266),
    [sym_internal_module] = STATE(1266),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [327] = {
    [sym_import] = STATE(1260),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1260),
    [sym_yield_expression] = STATE(1260),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1260),
    [sym_jsx_fragment] = STATE(1260),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1260),
    [sym_class] = STATE(1260),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1260),
    [sym_arrow_function] = STATE(1260),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1260),
    [sym_new_expression] = STATE(1260),
    [sym_await_expression] = STATE(1260),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1260),
    [sym_augmented_assignment_expression] = STATE(1260),
    [sym_ternary_expression] = STATE(1260),
    [sym_binary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1260),
    [sym_update_expression] = STATE(1260),
    [sym_string] = STATE(1260),
    [sym_template_string] = STATE(1260),
    [sym_regex] = STATE(1260),
    [sym_meta_property] = STATE(1260),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1260),
    [sym_as_expression] = STATE(1260),
    [sym_internal_module] = STATE(1260),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2111),
    [sym_this] = ACTIONS(2113),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2113),
    [sym_false] = ACTIONS(2113),
    [sym_null] = ACTIONS(2113),
    [sym_undefined] = ACTIONS(2113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [328] = {
    [sym_import] = STATE(1345),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1345),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1345),
    [sym_jsx_fragment] = STATE(1345),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1345),
    [sym_class] = STATE(1345),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1345),
    [sym_arrow_function] = STATE(1345),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1345),
    [sym_new_expression] = STATE(1345),
    [sym_await_expression] = STATE(1345),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1345),
    [sym_augmented_assignment_expression] = STATE(1345),
    [sym_ternary_expression] = STATE(1345),
    [sym_binary_expression] = STATE(1345),
    [sym_unary_expression] = STATE(1345),
    [sym_update_expression] = STATE(1345),
    [sym_string] = STATE(1345),
    [sym_template_string] = STATE(1345),
    [sym_regex] = STATE(1345),
    [sym_meta_property] = STATE(1345),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1345),
    [sym_as_expression] = STATE(1345),
    [sym_internal_module] = STATE(1345),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2115),
    [sym_this] = ACTIONS(2117),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2117),
    [sym_false] = ACTIONS(2117),
    [sym_null] = ACTIONS(2117),
    [sym_undefined] = ACTIONS(2117),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [329] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1256),
    [sym_jsx_fragment] = STATE(1256),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1256),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [330] = {
    [sym_import] = STATE(1166),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1166),
    [sym_yield_expression] = STATE(1166),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1166),
    [sym_jsx_fragment] = STATE(1166),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1166),
    [sym_class] = STATE(1166),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1166),
    [sym_arrow_function] = STATE(1166),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1166),
    [sym_new_expression] = STATE(1166),
    [sym_await_expression] = STATE(1166),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1166),
    [sym_augmented_assignment_expression] = STATE(1166),
    [sym_ternary_expression] = STATE(1166),
    [sym_binary_expression] = STATE(1166),
    [sym_unary_expression] = STATE(1166),
    [sym_update_expression] = STATE(1166),
    [sym_string] = STATE(1166),
    [sym_template_string] = STATE(1166),
    [sym_regex] = STATE(1166),
    [sym_meta_property] = STATE(1166),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1166),
    [sym_as_expression] = STATE(1166),
    [sym_internal_module] = STATE(1166),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [331] = {
    [sym_import] = STATE(1323),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1323),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1323),
    [sym_jsx_fragment] = STATE(1323),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1323),
    [sym_class] = STATE(1323),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1323),
    [sym_arrow_function] = STATE(1323),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1323),
    [sym_new_expression] = STATE(1323),
    [sym_await_expression] = STATE(1323),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1323),
    [sym_augmented_assignment_expression] = STATE(1323),
    [sym_ternary_expression] = STATE(1323),
    [sym_binary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(1323),
    [sym_update_expression] = STATE(1323),
    [sym_string] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_regex] = STATE(1323),
    [sym_meta_property] = STATE(1323),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1323),
    [sym_as_expression] = STATE(1323),
    [sym_internal_module] = STATE(1323),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2127),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [332] = {
    [sym_import] = STATE(1118),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1118),
    [sym_yield_expression] = STATE(1118),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1118),
    [sym_jsx_fragment] = STATE(1118),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1118),
    [sym_arrow_function] = STATE(1118),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1118),
    [sym_new_expression] = STATE(1118),
    [sym_await_expression] = STATE(1118),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1118),
    [sym_augmented_assignment_expression] = STATE(1118),
    [sym_ternary_expression] = STATE(1118),
    [sym_binary_expression] = STATE(1118),
    [sym_unary_expression] = STATE(1118),
    [sym_update_expression] = STATE(1118),
    [sym_string] = STATE(1118),
    [sym_template_string] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_meta_property] = STATE(1118),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1118),
    [sym_as_expression] = STATE(1118),
    [sym_internal_module] = STATE(1118),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2131),
    [sym_this] = ACTIONS(2133),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [sym_null] = ACTIONS(2133),
    [sym_undefined] = ACTIONS(2133),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [333] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1114),
    [sym_jsx_fragment] = STATE(1114),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1114),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_string] = STATE(1114),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2135),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [334] = {
    [sym_import] = STATE(1159),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1159),
    [sym_yield_expression] = STATE(1159),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1159),
    [sym_jsx_fragment] = STATE(1159),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1159),
    [sym_class] = STATE(1159),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1159),
    [sym_arrow_function] = STATE(1159),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1159),
    [sym_new_expression] = STATE(1159),
    [sym_await_expression] = STATE(1159),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1159),
    [sym_augmented_assignment_expression] = STATE(1159),
    [sym_ternary_expression] = STATE(1159),
    [sym_binary_expression] = STATE(1159),
    [sym_unary_expression] = STATE(1159),
    [sym_update_expression] = STATE(1159),
    [sym_string] = STATE(1159),
    [sym_template_string] = STATE(1159),
    [sym_regex] = STATE(1159),
    [sym_meta_property] = STATE(1159),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1159),
    [sym_as_expression] = STATE(1159),
    [sym_internal_module] = STATE(1159),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2139),
    [sym_this] = ACTIONS(2141),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [sym_null] = ACTIONS(2141),
    [sym_undefined] = ACTIONS(2141),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [335] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1258),
    [sym_jsx_fragment] = STATE(1258),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1258),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1258),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2143),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [336] = {
    [sym_import] = STATE(1294),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1294),
    [sym_jsx_fragment] = STATE(1294),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1294),
    [sym_class] = STATE(1294),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1294),
    [sym_arrow_function] = STATE(1294),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1294),
    [sym_new_expression] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_string] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2069),
    [sym_this] = ACTIONS(2105),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_null] = ACTIONS(2105),
    [sym_undefined] = ACTIONS(2105),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [337] = {
    [sym_import] = STATE(1155),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1155),
    [sym_yield_expression] = STATE(1155),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1155),
    [sym_jsx_fragment] = STATE(1155),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1155),
    [sym_class] = STATE(1155),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1155),
    [sym_arrow_function] = STATE(1155),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1155),
    [sym_new_expression] = STATE(1155),
    [sym_await_expression] = STATE(1155),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1155),
    [sym_augmented_assignment_expression] = STATE(1155),
    [sym_ternary_expression] = STATE(1155),
    [sym_binary_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1155),
    [sym_update_expression] = STATE(1155),
    [sym_string] = STATE(1155),
    [sym_template_string] = STATE(1155),
    [sym_regex] = STATE(1155),
    [sym_meta_property] = STATE(1155),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1155),
    [sym_as_expression] = STATE(1155),
    [sym_internal_module] = STATE(1155),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2147),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [338] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1349),
    [sym_jsx_fragment] = STATE(1349),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1349),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_ternary_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_update_expression] = STATE(1349),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_internal_module] = STATE(1349),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2151),
    [sym_this] = ACTIONS(1004),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_undefined] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [339] = {
    [sym_import] = STATE(1320),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1320),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1320),
    [sym_jsx_fragment] = STATE(1320),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1320),
    [sym_class] = STATE(1320),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1320),
    [sym_arrow_function] = STATE(1320),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1320),
    [sym_new_expression] = STATE(1320),
    [sym_await_expression] = STATE(1320),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1320),
    [sym_augmented_assignment_expression] = STATE(1320),
    [sym_ternary_expression] = STATE(1320),
    [sym_binary_expression] = STATE(1320),
    [sym_unary_expression] = STATE(1320),
    [sym_update_expression] = STATE(1320),
    [sym_string] = STATE(1320),
    [sym_template_string] = STATE(1320),
    [sym_regex] = STATE(1320),
    [sym_meta_property] = STATE(1320),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1320),
    [sym_as_expression] = STATE(1320),
    [sym_internal_module] = STATE(1320),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2153),
    [sym_this] = ACTIONS(2155),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [sym_null] = ACTIONS(2155),
    [sym_undefined] = ACTIONS(2155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [340] = {
    [sym_import] = STATE(1105),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1105),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1105),
    [sym_jsx_fragment] = STATE(1105),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1105),
    [sym_class] = STATE(1105),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1105),
    [sym_arrow_function] = STATE(1105),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1105),
    [sym_new_expression] = STATE(1105),
    [sym_await_expression] = STATE(1105),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1105),
    [sym_augmented_assignment_expression] = STATE(1105),
    [sym_ternary_expression] = STATE(1105),
    [sym_binary_expression] = STATE(1105),
    [sym_unary_expression] = STATE(1105),
    [sym_update_expression] = STATE(1105),
    [sym_string] = STATE(1105),
    [sym_template_string] = STATE(1105),
    [sym_regex] = STATE(1105),
    [sym_meta_property] = STATE(1105),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1105),
    [sym_as_expression] = STATE(1105),
    [sym_internal_module] = STATE(1105),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2157),
    [sym_this] = ACTIONS(2159),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [sym_null] = ACTIONS(2159),
    [sym_undefined] = ACTIONS(2159),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [341] = {
    [sym_import] = STATE(1203),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1203),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1203),
    [sym_jsx_fragment] = STATE(1203),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1203),
    [sym_class] = STATE(1203),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1203),
    [sym_arrow_function] = STATE(1203),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1203),
    [sym_new_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1203),
    [sym_augmented_assignment_expression] = STATE(1203),
    [sym_ternary_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_update_expression] = STATE(1203),
    [sym_string] = STATE(1203),
    [sym_template_string] = STATE(1203),
    [sym_regex] = STATE(1203),
    [sym_meta_property] = STATE(1203),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1203),
    [sym_as_expression] = STATE(1203),
    [sym_internal_module] = STATE(1203),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2161),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [342] = {
    [sym_import] = STATE(1184),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1184),
    [sym_yield_expression] = STATE(1184),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1184),
    [sym_jsx_fragment] = STATE(1184),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1184),
    [sym_class] = STATE(1184),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1184),
    [sym_arrow_function] = STATE(1184),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1184),
    [sym_new_expression] = STATE(1184),
    [sym_await_expression] = STATE(1184),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1184),
    [sym_augmented_assignment_expression] = STATE(1184),
    [sym_ternary_expression] = STATE(1184),
    [sym_binary_expression] = STATE(1184),
    [sym_unary_expression] = STATE(1184),
    [sym_update_expression] = STATE(1184),
    [sym_string] = STATE(1184),
    [sym_template_string] = STATE(1184),
    [sym_regex] = STATE(1184),
    [sym_meta_property] = STATE(1184),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1184),
    [sym_as_expression] = STATE(1184),
    [sym_internal_module] = STATE(1184),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2165),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [343] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1243),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1243),
    [sym_jsx_fragment] = STATE(1243),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1243),
    [sym_class] = STATE(1243),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1243),
    [sym_arrow_function] = STATE(1243),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1243),
    [sym_new_expression] = STATE(1243),
    [sym_await_expression] = STATE(1243),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1243),
    [sym_augmented_assignment_expression] = STATE(1243),
    [sym_ternary_expression] = STATE(1243),
    [sym_binary_expression] = STATE(1243),
    [sym_unary_expression] = STATE(1243),
    [sym_update_expression] = STATE(1243),
    [sym_string] = STATE(1243),
    [sym_template_string] = STATE(1243),
    [sym_regex] = STATE(1243),
    [sym_meta_property] = STATE(1243),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1243),
    [sym_as_expression] = STATE(1243),
    [sym_internal_module] = STATE(1243),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2169),
    [sym_this] = ACTIONS(2171),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [sym_null] = ACTIONS(2171),
    [sym_undefined] = ACTIONS(2171),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [344] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1179),
    [sym_jsx_fragment] = STATE(1179),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1179),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1179),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2173),
    [sym_this] = ACTIONS(1056),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_undefined] = ACTIONS(1056),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [345] = {
    [sym_import] = STATE(1250),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1250),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1250),
    [sym_jsx_fragment] = STATE(1250),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1250),
    [sym_class] = STATE(1250),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1250),
    [sym_arrow_function] = STATE(1250),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1250),
    [sym_new_expression] = STATE(1250),
    [sym_await_expression] = STATE(1250),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1250),
    [sym_augmented_assignment_expression] = STATE(1250),
    [sym_ternary_expression] = STATE(1250),
    [sym_binary_expression] = STATE(1250),
    [sym_unary_expression] = STATE(1250),
    [sym_update_expression] = STATE(1250),
    [sym_string] = STATE(1250),
    [sym_template_string] = STATE(1250),
    [sym_regex] = STATE(1250),
    [sym_meta_property] = STATE(1250),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1250),
    [sym_as_expression] = STATE(1250),
    [sym_internal_module] = STATE(1250),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2175),
    [sym_this] = ACTIONS(2177),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2177),
    [sym_false] = ACTIONS(2177),
    [sym_null] = ACTIONS(2177),
    [sym_undefined] = ACTIONS(2177),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [346] = {
    [sym_import] = STATE(1439),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1439),
    [sym_yield_expression] = STATE(1439),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1439),
    [sym_jsx_fragment] = STATE(1439),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1439),
    [sym_class] = STATE(1439),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1439),
    [sym_arrow_function] = STATE(1439),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1439),
    [sym_new_expression] = STATE(1439),
    [sym_await_expression] = STATE(1439),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1439),
    [sym_augmented_assignment_expression] = STATE(1439),
    [sym_ternary_expression] = STATE(1439),
    [sym_binary_expression] = STATE(1439),
    [sym_unary_expression] = STATE(1439),
    [sym_update_expression] = STATE(1439),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1439),
    [sym_regex] = STATE(1439),
    [sym_meta_property] = STATE(1439),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1439),
    [sym_as_expression] = STATE(1439),
    [sym_internal_module] = STATE(1439),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1637),
    [sym_this] = ACTIONS(1639),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1639),
    [sym_false] = ACTIONS(1639),
    [sym_null] = ACTIONS(1639),
    [sym_undefined] = ACTIONS(1639),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [347] = {
    [sym_import] = STATE(1254),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1254),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1254),
    [sym_jsx_fragment] = STATE(1254),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1254),
    [sym_class] = STATE(1254),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1254),
    [sym_arrow_function] = STATE(1254),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1254),
    [sym_new_expression] = STATE(1254),
    [sym_await_expression] = STATE(1254),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1254),
    [sym_augmented_assignment_expression] = STATE(1254),
    [sym_ternary_expression] = STATE(1254),
    [sym_binary_expression] = STATE(1254),
    [sym_unary_expression] = STATE(1254),
    [sym_update_expression] = STATE(1254),
    [sym_string] = STATE(1254),
    [sym_template_string] = STATE(1254),
    [sym_regex] = STATE(1254),
    [sym_meta_property] = STATE(1254),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1254),
    [sym_as_expression] = STATE(1254),
    [sym_internal_module] = STATE(1254),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2179),
    [sym_this] = ACTIONS(2181),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2181),
    [sym_false] = ACTIONS(2181),
    [sym_null] = ACTIONS(2181),
    [sym_undefined] = ACTIONS(2181),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [348] = {
    [sym_import] = STATE(1211),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1211),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1211),
    [sym_jsx_fragment] = STATE(1211),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1211),
    [sym_class] = STATE(1211),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1211),
    [sym_arrow_function] = STATE(1211),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1211),
    [sym_new_expression] = STATE(1211),
    [sym_await_expression] = STATE(1211),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1211),
    [sym_augmented_assignment_expression] = STATE(1211),
    [sym_ternary_expression] = STATE(1211),
    [sym_binary_expression] = STATE(1211),
    [sym_unary_expression] = STATE(1211),
    [sym_update_expression] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_template_string] = STATE(1211),
    [sym_regex] = STATE(1211),
    [sym_meta_property] = STATE(1211),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1211),
    [sym_as_expression] = STATE(1211),
    [sym_internal_module] = STATE(1211),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2183),
    [sym_this] = ACTIONS(2185),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2185),
    [sym_false] = ACTIONS(2185),
    [sym_null] = ACTIONS(2185),
    [sym_undefined] = ACTIONS(2185),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [349] = {
    [sym_import] = STATE(1355),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1355),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1355),
    [sym_jsx_fragment] = STATE(1355),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1355),
    [sym_class] = STATE(1355),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1355),
    [sym_arrow_function] = STATE(1355),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1355),
    [sym_new_expression] = STATE(1355),
    [sym_await_expression] = STATE(1355),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1355),
    [sym_augmented_assignment_expression] = STATE(1355),
    [sym_ternary_expression] = STATE(1355),
    [sym_binary_expression] = STATE(1355),
    [sym_unary_expression] = STATE(1355),
    [sym_update_expression] = STATE(1355),
    [sym_string] = STATE(1355),
    [sym_template_string] = STATE(1355),
    [sym_regex] = STATE(1355),
    [sym_meta_property] = STATE(1355),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1355),
    [sym_as_expression] = STATE(1355),
    [sym_internal_module] = STATE(1355),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2187),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [350] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1356),
    [sym_jsx_fragment] = STATE(1356),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1356),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2191),
    [sym_this] = ACTIONS(2193),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2193),
    [sym_false] = ACTIONS(2193),
    [sym_null] = ACTIONS(2193),
    [sym_undefined] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [351] = {
    [sym_import] = STATE(1357),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1357),
    [sym_yield_expression] = STATE(1357),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1357),
    [sym_jsx_fragment] = STATE(1357),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1357),
    [sym_class] = STATE(1357),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1357),
    [sym_arrow_function] = STATE(1357),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1357),
    [sym_new_expression] = STATE(1357),
    [sym_await_expression] = STATE(1357),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1357),
    [sym_augmented_assignment_expression] = STATE(1357),
    [sym_ternary_expression] = STATE(1357),
    [sym_binary_expression] = STATE(1357),
    [sym_unary_expression] = STATE(1357),
    [sym_update_expression] = STATE(1357),
    [sym_string] = STATE(1357),
    [sym_template_string] = STATE(1357),
    [sym_regex] = STATE(1357),
    [sym_meta_property] = STATE(1357),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1357),
    [sym_as_expression] = STATE(1357),
    [sym_internal_module] = STATE(1357),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2195),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [352] = {
    [sym_import] = STATE(1358),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1358),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1358),
    [sym_jsx_fragment] = STATE(1358),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1358),
    [sym_class] = STATE(1358),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1358),
    [sym_arrow_function] = STATE(1358),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1358),
    [sym_new_expression] = STATE(1358),
    [sym_await_expression] = STATE(1358),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1358),
    [sym_augmented_assignment_expression] = STATE(1358),
    [sym_ternary_expression] = STATE(1358),
    [sym_binary_expression] = STATE(1358),
    [sym_unary_expression] = STATE(1358),
    [sym_update_expression] = STATE(1358),
    [sym_string] = STATE(1358),
    [sym_template_string] = STATE(1358),
    [sym_regex] = STATE(1358),
    [sym_meta_property] = STATE(1358),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1358),
    [sym_as_expression] = STATE(1358),
    [sym_internal_module] = STATE(1358),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2201),
    [sym_false] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [353] = {
    [sym_import] = STATE(1359),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1359),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1359),
    [sym_jsx_fragment] = STATE(1359),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1359),
    [sym_class] = STATE(1359),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1359),
    [sym_arrow_function] = STATE(1359),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1359),
    [sym_new_expression] = STATE(1359),
    [sym_await_expression] = STATE(1359),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1359),
    [sym_augmented_assignment_expression] = STATE(1359),
    [sym_ternary_expression] = STATE(1359),
    [sym_binary_expression] = STATE(1359),
    [sym_unary_expression] = STATE(1359),
    [sym_update_expression] = STATE(1359),
    [sym_string] = STATE(1359),
    [sym_template_string] = STATE(1359),
    [sym_regex] = STATE(1359),
    [sym_meta_property] = STATE(1359),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1359),
    [sym_as_expression] = STATE(1359),
    [sym_internal_module] = STATE(1359),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2203),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [354] = {
    [sym_import] = STATE(1360),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1360),
    [sym_jsx_fragment] = STATE(1360),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1360),
    [sym_class] = STATE(1360),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1360),
    [sym_arrow_function] = STATE(1360),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1360),
    [sym_new_expression] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_string] = STATE(1360),
    [sym_template_string] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1360),
    [sym_as_expression] = STATE(1360),
    [sym_internal_module] = STATE(1360),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2207),
    [sym_this] = ACTIONS(2209),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2209),
    [sym_false] = ACTIONS(2209),
    [sym_null] = ACTIONS(2209),
    [sym_undefined] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [355] = {
    [sym_import] = STATE(1361),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1361),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1361),
    [sym_jsx_fragment] = STATE(1361),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1361),
    [sym_class] = STATE(1361),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1361),
    [sym_arrow_function] = STATE(1361),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1361),
    [sym_new_expression] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_ternary_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_update_expression] = STATE(1361),
    [sym_string] = STATE(1361),
    [sym_template_string] = STATE(1361),
    [sym_regex] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1361),
    [sym_as_expression] = STATE(1361),
    [sym_internal_module] = STATE(1361),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2211),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [356] = {
    [sym_import] = STATE(1435),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1435),
    [sym_yield_expression] = STATE(1435),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1435),
    [sym_jsx_fragment] = STATE(1435),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1435),
    [sym_class] = STATE(1435),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1435),
    [sym_arrow_function] = STATE(1435),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1435),
    [sym_new_expression] = STATE(1435),
    [sym_await_expression] = STATE(1435),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1435),
    [sym_augmented_assignment_expression] = STATE(1435),
    [sym_ternary_expression] = STATE(1435),
    [sym_binary_expression] = STATE(1435),
    [sym_unary_expression] = STATE(1435),
    [sym_update_expression] = STATE(1435),
    [sym_string] = STATE(1435),
    [sym_template_string] = STATE(1435),
    [sym_regex] = STATE(1435),
    [sym_meta_property] = STATE(1435),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1435),
    [sym_as_expression] = STATE(1435),
    [sym_internal_module] = STATE(1435),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2215),
    [sym_this] = ACTIONS(2217),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2217),
    [sym_false] = ACTIONS(2217),
    [sym_null] = ACTIONS(2217),
    [sym_undefined] = ACTIONS(2217),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [357] = {
    [sym_import] = STATE(1362),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1362),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1362),
    [sym_jsx_fragment] = STATE(1362),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1362),
    [sym_class] = STATE(1362),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1362),
    [sym_arrow_function] = STATE(1362),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1362),
    [sym_new_expression] = STATE(1362),
    [sym_await_expression] = STATE(1362),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1362),
    [sym_augmented_assignment_expression] = STATE(1362),
    [sym_ternary_expression] = STATE(1362),
    [sym_binary_expression] = STATE(1362),
    [sym_unary_expression] = STATE(1362),
    [sym_update_expression] = STATE(1362),
    [sym_string] = STATE(1362),
    [sym_template_string] = STATE(1362),
    [sym_regex] = STATE(1362),
    [sym_meta_property] = STATE(1362),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1362),
    [sym_as_expression] = STATE(1362),
    [sym_internal_module] = STATE(1362),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2219),
    [sym_this] = ACTIONS(952),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_null] = ACTIONS(952),
    [sym_undefined] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [358] = {
    [sym_import] = STATE(1363),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1363),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1363),
    [sym_jsx_fragment] = STATE(1363),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1363),
    [sym_class] = STATE(1363),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1363),
    [sym_arrow_function] = STATE(1363),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1363),
    [sym_new_expression] = STATE(1363),
    [sym_await_expression] = STATE(1363),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1363),
    [sym_augmented_assignment_expression] = STATE(1363),
    [sym_ternary_expression] = STATE(1363),
    [sym_binary_expression] = STATE(1363),
    [sym_unary_expression] = STATE(1363),
    [sym_update_expression] = STATE(1363),
    [sym_string] = STATE(1363),
    [sym_template_string] = STATE(1363),
    [sym_regex] = STATE(1363),
    [sym_meta_property] = STATE(1363),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1363),
    [sym_as_expression] = STATE(1363),
    [sym_internal_module] = STATE(1363),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2221),
    [sym_this] = ACTIONS(2223),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [sym_null] = ACTIONS(2223),
    [sym_undefined] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [359] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1212),
    [sym_yield_expression] = STATE(1212),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1212),
    [sym_jsx_fragment] = STATE(1212),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1212),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1212),
    [sym_await_expression] = STATE(1212),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1212),
    [sym_augmented_assignment_expression] = STATE(1212),
    [sym_ternary_expression] = STATE(1212),
    [sym_binary_expression] = STATE(1212),
    [sym_unary_expression] = STATE(1212),
    [sym_update_expression] = STATE(1212),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1212),
    [sym_as_expression] = STATE(1212),
    [sym_internal_module] = STATE(1212),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2225),
    [sym_this] = ACTIONS(2227),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2227),
    [sym_false] = ACTIONS(2227),
    [sym_null] = ACTIONS(2227),
    [sym_undefined] = ACTIONS(2227),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [360] = {
    [sym_import] = STATE(1213),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1213),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1213),
    [sym_jsx_fragment] = STATE(1213),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1213),
    [sym_class] = STATE(1213),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1213),
    [sym_arrow_function] = STATE(1213),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1213),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1213),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1213),
    [sym_template_string] = STATE(1213),
    [sym_regex] = STATE(1213),
    [sym_meta_property] = STATE(1213),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1213),
    [sym_as_expression] = STATE(1213),
    [sym_internal_module] = STATE(1213),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2229),
    [sym_this] = ACTIONS(2231),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2231),
    [sym_false] = ACTIONS(2231),
    [sym_null] = ACTIONS(2231),
    [sym_undefined] = ACTIONS(2231),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [361] = {
    [sym_import] = STATE(1306),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1306),
    [sym_yield_expression] = STATE(1306),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1306),
    [sym_jsx_fragment] = STATE(1306),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1306),
    [sym_class] = STATE(1306),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1306),
    [sym_arrow_function] = STATE(1306),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1306),
    [sym_new_expression] = STATE(1306),
    [sym_await_expression] = STATE(1306),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1306),
    [sym_augmented_assignment_expression] = STATE(1306),
    [sym_ternary_expression] = STATE(1306),
    [sym_binary_expression] = STATE(1306),
    [sym_unary_expression] = STATE(1306),
    [sym_update_expression] = STATE(1306),
    [sym_string] = STATE(1306),
    [sym_template_string] = STATE(1306),
    [sym_regex] = STATE(1306),
    [sym_meta_property] = STATE(1306),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1306),
    [sym_as_expression] = STATE(1306),
    [sym_internal_module] = STATE(1306),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2233),
    [sym_this] = ACTIONS(2235),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2235),
    [sym_false] = ACTIONS(2235),
    [sym_null] = ACTIONS(2235),
    [sym_undefined] = ACTIONS(2235),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [362] = {
    [sym_import] = STATE(1003),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1003),
    [sym_yield_expression] = STATE(1003),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1003),
    [sym_jsx_fragment] = STATE(1003),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1003),
    [sym_class] = STATE(1003),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1003),
    [sym_arrow_function] = STATE(1003),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1003),
    [sym_new_expression] = STATE(1003),
    [sym_await_expression] = STATE(1003),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1003),
    [sym_augmented_assignment_expression] = STATE(1003),
    [sym_ternary_expression] = STATE(1003),
    [sym_binary_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1003),
    [sym_update_expression] = STATE(1003),
    [sym_string] = STATE(1003),
    [sym_template_string] = STATE(1003),
    [sym_regex] = STATE(1003),
    [sym_meta_property] = STATE(1003),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1003),
    [sym_as_expression] = STATE(1003),
    [sym_internal_module] = STATE(1003),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2237),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [363] = {
    [sym_import] = STATE(1366),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1366),
    [sym_yield_expression] = STATE(1366),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1366),
    [sym_jsx_fragment] = STATE(1366),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1366),
    [sym_class] = STATE(1366),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1366),
    [sym_arrow_function] = STATE(1366),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1366),
    [sym_new_expression] = STATE(1366),
    [sym_await_expression] = STATE(1366),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1366),
    [sym_augmented_assignment_expression] = STATE(1366),
    [sym_ternary_expression] = STATE(1366),
    [sym_binary_expression] = STATE(1366),
    [sym_unary_expression] = STATE(1366),
    [sym_update_expression] = STATE(1366),
    [sym_string] = STATE(1366),
    [sym_template_string] = STATE(1366),
    [sym_regex] = STATE(1366),
    [sym_meta_property] = STATE(1366),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1366),
    [sym_as_expression] = STATE(1366),
    [sym_internal_module] = STATE(1366),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2239),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [364] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1219),
    [sym_jsx_fragment] = STATE(1219),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1219),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1219),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2243),
    [sym_this] = ACTIONS(2245),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2245),
    [sym_false] = ACTIONS(2245),
    [sym_null] = ACTIONS(2245),
    [sym_undefined] = ACTIONS(2245),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [365] = {
    [sym_import] = STATE(1134),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1134),
    [sym_yield_expression] = STATE(1134),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1134),
    [sym_jsx_fragment] = STATE(1134),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1134),
    [sym_class] = STATE(1134),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1134),
    [sym_arrow_function] = STATE(1134),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1134),
    [sym_new_expression] = STATE(1134),
    [sym_await_expression] = STATE(1134),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1134),
    [sym_augmented_assignment_expression] = STATE(1134),
    [sym_ternary_expression] = STATE(1134),
    [sym_binary_expression] = STATE(1134),
    [sym_unary_expression] = STATE(1134),
    [sym_update_expression] = STATE(1134),
    [sym_string] = STATE(1134),
    [sym_template_string] = STATE(1134),
    [sym_regex] = STATE(1134),
    [sym_meta_property] = STATE(1134),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1134),
    [sym_as_expression] = STATE(1134),
    [sym_internal_module] = STATE(1134),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2247),
    [sym_this] = ACTIONS(2249),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2249),
    [sym_false] = ACTIONS(2249),
    [sym_null] = ACTIONS(2249),
    [sym_undefined] = ACTIONS(2249),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [366] = {
    [sym_import] = STATE(1471),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1471),
    [sym_yield_expression] = STATE(1471),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1471),
    [sym_jsx_fragment] = STATE(1471),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1471),
    [sym_class] = STATE(1471),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1471),
    [sym_arrow_function] = STATE(1471),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1471),
    [sym_new_expression] = STATE(1471),
    [sym_await_expression] = STATE(1471),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1471),
    [sym_augmented_assignment_expression] = STATE(1471),
    [sym_ternary_expression] = STATE(1471),
    [sym_binary_expression] = STATE(1471),
    [sym_unary_expression] = STATE(1471),
    [sym_update_expression] = STATE(1471),
    [sym_string] = STATE(1471),
    [sym_template_string] = STATE(1471),
    [sym_regex] = STATE(1471),
    [sym_meta_property] = STATE(1471),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1471),
    [sym_as_expression] = STATE(1471),
    [sym_internal_module] = STATE(1471),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2251),
    [sym_this] = ACTIONS(2253),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2253),
    [sym_false] = ACTIONS(2253),
    [sym_null] = ACTIONS(2253),
    [sym_undefined] = ACTIONS(2253),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [367] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1178),
    [sym_jsx_fragment] = STATE(1178),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1178),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1178),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2255),
    [sym_this] = ACTIONS(2089),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_null] = ACTIONS(2089),
    [sym_undefined] = ACTIONS(2089),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [368] = {
    [sym_import] = STATE(1227),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1227),
    [sym_yield_expression] = STATE(1227),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1227),
    [sym_jsx_fragment] = STATE(1227),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1227),
    [sym_class] = STATE(1227),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1227),
    [sym_arrow_function] = STATE(1227),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1227),
    [sym_new_expression] = STATE(1227),
    [sym_await_expression] = STATE(1227),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1227),
    [sym_augmented_assignment_expression] = STATE(1227),
    [sym_ternary_expression] = STATE(1227),
    [sym_binary_expression] = STATE(1227),
    [sym_unary_expression] = STATE(1227),
    [sym_update_expression] = STATE(1227),
    [sym_string] = STATE(1227),
    [sym_template_string] = STATE(1227),
    [sym_regex] = STATE(1227),
    [sym_meta_property] = STATE(1227),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1227),
    [sym_as_expression] = STATE(1227),
    [sym_internal_module] = STATE(1227),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2257),
    [sym_this] = ACTIONS(2259),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2259),
    [sym_false] = ACTIONS(2259),
    [sym_null] = ACTIONS(2259),
    [sym_undefined] = ACTIONS(2259),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [369] = {
    [sym_import] = STATE(1125),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1125),
    [sym_yield_expression] = STATE(1125),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1125),
    [sym_jsx_fragment] = STATE(1125),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1125),
    [sym_class] = STATE(1125),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1125),
    [sym_arrow_function] = STATE(1125),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1125),
    [sym_new_expression] = STATE(1125),
    [sym_await_expression] = STATE(1125),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1125),
    [sym_augmented_assignment_expression] = STATE(1125),
    [sym_ternary_expression] = STATE(1125),
    [sym_binary_expression] = STATE(1125),
    [sym_unary_expression] = STATE(1125),
    [sym_update_expression] = STATE(1125),
    [sym_string] = STATE(1125),
    [sym_template_string] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_meta_property] = STATE(1125),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1125),
    [sym_internal_module] = STATE(1125),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2059),
    [sym_this] = ACTIONS(2061),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_null] = ACTIONS(2061),
    [sym_undefined] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [370] = {
    [sym_import] = STATE(1368),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1368),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1368),
    [sym_jsx_fragment] = STATE(1368),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1368),
    [sym_class] = STATE(1368),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1368),
    [sym_arrow_function] = STATE(1368),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1368),
    [sym_new_expression] = STATE(1368),
    [sym_await_expression] = STATE(1368),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1368),
    [sym_augmented_assignment_expression] = STATE(1368),
    [sym_ternary_expression] = STATE(1368),
    [sym_binary_expression] = STATE(1368),
    [sym_unary_expression] = STATE(1368),
    [sym_update_expression] = STATE(1368),
    [sym_string] = STATE(1368),
    [sym_template_string] = STATE(1368),
    [sym_regex] = STATE(1368),
    [sym_meta_property] = STATE(1368),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1368),
    [sym_as_expression] = STATE(1368),
    [sym_internal_module] = STATE(1368),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2261),
    [sym_this] = ACTIONS(2263),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2263),
    [sym_false] = ACTIONS(2263),
    [sym_null] = ACTIONS(2263),
    [sym_undefined] = ACTIONS(2263),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [371] = {
    [sym_import] = STATE(1322),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1322),
    [sym_jsx_fragment] = STATE(1322),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1322),
    [sym_class] = STATE(1322),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_ternary_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_update_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_template_string] = STATE(1322),
    [sym_regex] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1322),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2265),
    [sym_this] = ACTIONS(2267),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [sym_null] = ACTIONS(2267),
    [sym_undefined] = ACTIONS(2267),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [372] = {
    [sym_import] = STATE(1194),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1194),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1194),
    [sym_jsx_fragment] = STATE(1194),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1194),
    [sym_class] = STATE(1194),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1194),
    [sym_arrow_function] = STATE(1194),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1194),
    [sym_new_expression] = STATE(1194),
    [sym_await_expression] = STATE(1194),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1194),
    [sym_augmented_assignment_expression] = STATE(1194),
    [sym_ternary_expression] = STATE(1194),
    [sym_binary_expression] = STATE(1194),
    [sym_unary_expression] = STATE(1194),
    [sym_update_expression] = STATE(1194),
    [sym_string] = STATE(1194),
    [sym_template_string] = STATE(1194),
    [sym_regex] = STATE(1194),
    [sym_meta_property] = STATE(1194),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1194),
    [sym_as_expression] = STATE(1194),
    [sym_internal_module] = STATE(1194),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2269),
    [sym_this] = ACTIONS(2271),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [sym_null] = ACTIONS(2271),
    [sym_undefined] = ACTIONS(2271),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [373] = {
    [sym_import] = STATE(1105),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1105),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1105),
    [sym_jsx_fragment] = STATE(1105),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1105),
    [sym_class] = STATE(1105),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1105),
    [sym_arrow_function] = STATE(1105),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1105),
    [sym_new_expression] = STATE(1105),
    [sym_await_expression] = STATE(1105),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1105),
    [sym_augmented_assignment_expression] = STATE(1105),
    [sym_ternary_expression] = STATE(1105),
    [sym_binary_expression] = STATE(1105),
    [sym_unary_expression] = STATE(1105),
    [sym_update_expression] = STATE(1105),
    [sym_string] = STATE(1105),
    [sym_template_string] = STATE(1105),
    [sym_regex] = STATE(1105),
    [sym_meta_property] = STATE(1105),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1105),
    [sym_as_expression] = STATE(1105),
    [sym_internal_module] = STATE(1105),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2157),
    [sym_this] = ACTIONS(2159),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [sym_null] = ACTIONS(2159),
    [sym_undefined] = ACTIONS(2159),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [374] = {
    [sym_import] = STATE(1241),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1241),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1241),
    [sym_jsx_fragment] = STATE(1241),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1241),
    [sym_class] = STATE(1241),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1241),
    [sym_arrow_function] = STATE(1241),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1241),
    [sym_new_expression] = STATE(1241),
    [sym_await_expression] = STATE(1241),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1241),
    [sym_augmented_assignment_expression] = STATE(1241),
    [sym_ternary_expression] = STATE(1241),
    [sym_binary_expression] = STATE(1241),
    [sym_unary_expression] = STATE(1241),
    [sym_update_expression] = STATE(1241),
    [sym_string] = STATE(1241),
    [sym_template_string] = STATE(1241),
    [sym_regex] = STATE(1241),
    [sym_meta_property] = STATE(1241),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1241),
    [sym_as_expression] = STATE(1241),
    [sym_internal_module] = STATE(1241),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2273),
    [sym_this] = ACTIONS(2275),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [sym_null] = ACTIONS(2275),
    [sym_undefined] = ACTIONS(2275),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [375] = {
    [sym_import] = STATE(1323),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1323),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1323),
    [sym_jsx_fragment] = STATE(1323),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1323),
    [sym_class] = STATE(1323),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1323),
    [sym_arrow_function] = STATE(1323),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1323),
    [sym_new_expression] = STATE(1323),
    [sym_await_expression] = STATE(1323),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1323),
    [sym_augmented_assignment_expression] = STATE(1323),
    [sym_ternary_expression] = STATE(1323),
    [sym_binary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(1323),
    [sym_update_expression] = STATE(1323),
    [sym_string] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_regex] = STATE(1323),
    [sym_meta_property] = STATE(1323),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1323),
    [sym_as_expression] = STATE(1323),
    [sym_internal_module] = STATE(1323),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2277),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [376] = {
    [sym_import] = STATE(1244),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1244),
    [sym_yield_expression] = STATE(1244),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1244),
    [sym_jsx_fragment] = STATE(1244),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1244),
    [sym_class] = STATE(1244),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1244),
    [sym_arrow_function] = STATE(1244),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1244),
    [sym_new_expression] = STATE(1244),
    [sym_await_expression] = STATE(1244),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1244),
    [sym_augmented_assignment_expression] = STATE(1244),
    [sym_ternary_expression] = STATE(1244),
    [sym_binary_expression] = STATE(1244),
    [sym_unary_expression] = STATE(1244),
    [sym_update_expression] = STATE(1244),
    [sym_string] = STATE(1244),
    [sym_template_string] = STATE(1244),
    [sym_regex] = STATE(1244),
    [sym_meta_property] = STATE(1244),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1244),
    [sym_as_expression] = STATE(1244),
    [sym_internal_module] = STATE(1244),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2279),
    [sym_this] = ACTIONS(2281),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2281),
    [sym_false] = ACTIONS(2281),
    [sym_null] = ACTIONS(2281),
    [sym_undefined] = ACTIONS(2281),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [377] = {
    [sym_import] = STATE(1137),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1137),
    [sym_yield_expression] = STATE(1137),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1137),
    [sym_jsx_fragment] = STATE(1137),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1137),
    [sym_class] = STATE(1137),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1137),
    [sym_arrow_function] = STATE(1137),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1137),
    [sym_new_expression] = STATE(1137),
    [sym_await_expression] = STATE(1137),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1137),
    [sym_augmented_assignment_expression] = STATE(1137),
    [sym_ternary_expression] = STATE(1137),
    [sym_binary_expression] = STATE(1137),
    [sym_unary_expression] = STATE(1137),
    [sym_update_expression] = STATE(1137),
    [sym_string] = STATE(1137),
    [sym_template_string] = STATE(1137),
    [sym_regex] = STATE(1137),
    [sym_meta_property] = STATE(1137),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1137),
    [sym_as_expression] = STATE(1137),
    [sym_internal_module] = STATE(1137),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2283),
    [sym_this] = ACTIONS(2285),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2285),
    [sym_false] = ACTIONS(2285),
    [sym_null] = ACTIONS(2285),
    [sym_undefined] = ACTIONS(2285),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [378] = {
    [sym_import] = STATE(1028),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1028),
    [sym_yield_expression] = STATE(1028),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1028),
    [sym_jsx_fragment] = STATE(1028),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1028),
    [sym_class] = STATE(1028),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1028),
    [sym_arrow_function] = STATE(1028),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1028),
    [sym_new_expression] = STATE(1028),
    [sym_await_expression] = STATE(1028),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1028),
    [sym_augmented_assignment_expression] = STATE(1028),
    [sym_ternary_expression] = STATE(1028),
    [sym_binary_expression] = STATE(1028),
    [sym_unary_expression] = STATE(1028),
    [sym_update_expression] = STATE(1028),
    [sym_string] = STATE(1028),
    [sym_template_string] = STATE(1028),
    [sym_regex] = STATE(1028),
    [sym_meta_property] = STATE(1028),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1028),
    [sym_as_expression] = STATE(1028),
    [sym_internal_module] = STATE(1028),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2287),
    [sym_this] = ACTIONS(2289),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2289),
    [sym_false] = ACTIONS(2289),
    [sym_null] = ACTIONS(2289),
    [sym_undefined] = ACTIONS(2289),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [379] = {
    [sym_import] = STATE(1371),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1371),
    [sym_yield_expression] = STATE(1371),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1371),
    [sym_jsx_fragment] = STATE(1371),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1371),
    [sym_class] = STATE(1371),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1371),
    [sym_arrow_function] = STATE(1371),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1371),
    [sym_new_expression] = STATE(1371),
    [sym_await_expression] = STATE(1371),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1371),
    [sym_augmented_assignment_expression] = STATE(1371),
    [sym_ternary_expression] = STATE(1371),
    [sym_binary_expression] = STATE(1371),
    [sym_unary_expression] = STATE(1371),
    [sym_update_expression] = STATE(1371),
    [sym_string] = STATE(1371),
    [sym_template_string] = STATE(1371),
    [sym_regex] = STATE(1371),
    [sym_meta_property] = STATE(1371),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1371),
    [sym_as_expression] = STATE(1371),
    [sym_internal_module] = STATE(1371),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2291),
    [sym_this] = ACTIONS(2293),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2293),
    [sym_false] = ACTIONS(2293),
    [sym_null] = ACTIONS(2293),
    [sym_undefined] = ACTIONS(2293),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [380] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2295),
    [sym_this] = ACTIONS(2297),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2297),
    [sym_false] = ACTIONS(2297),
    [sym_null] = ACTIONS(2297),
    [sym_undefined] = ACTIONS(2297),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [381] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2299),
    [sym_this] = ACTIONS(2301),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2301),
    [sym_false] = ACTIONS(2301),
    [sym_null] = ACTIONS(2301),
    [sym_undefined] = ACTIONS(2301),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [382] = {
    [sym__declaration] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_class_declaration] = STATE(591),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function_declaration] = STATE(591),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(591),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(591),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_object_repeat1] = STATE(2585),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(2303),
    [anon_sym_global] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [383] = {
    [sym_import] = STATE(1070),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1070),
    [sym_yield_expression] = STATE(1070),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1070),
    [sym_jsx_fragment] = STATE(1070),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1070),
    [sym_class] = STATE(1070),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1070),
    [sym_arrow_function] = STATE(1070),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1070),
    [sym_new_expression] = STATE(1070),
    [sym_await_expression] = STATE(1070),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1070),
    [sym_augmented_assignment_expression] = STATE(1070),
    [sym_ternary_expression] = STATE(1070),
    [sym_binary_expression] = STATE(1070),
    [sym_unary_expression] = STATE(1070),
    [sym_update_expression] = STATE(1070),
    [sym_string] = STATE(1070),
    [sym_template_string] = STATE(1070),
    [sym_regex] = STATE(1070),
    [sym_meta_property] = STATE(1070),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1070),
    [sym_as_expression] = STATE(1070),
    [sym_internal_module] = STATE(1070),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2307),
    [sym_this] = ACTIONS(2309),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2309),
    [sym_false] = ACTIONS(2309),
    [sym_null] = ACTIONS(2309),
    [sym_undefined] = ACTIONS(2309),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [384] = {
    [sym_import] = STATE(1028),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1028),
    [sym_yield_expression] = STATE(1028),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1028),
    [sym_jsx_fragment] = STATE(1028),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1028),
    [sym_class] = STATE(1028),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1028),
    [sym_arrow_function] = STATE(1028),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1028),
    [sym_new_expression] = STATE(1028),
    [sym_await_expression] = STATE(1028),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1028),
    [sym_augmented_assignment_expression] = STATE(1028),
    [sym_ternary_expression] = STATE(1028),
    [sym_binary_expression] = STATE(1028),
    [sym_unary_expression] = STATE(1028),
    [sym_update_expression] = STATE(1028),
    [sym_string] = STATE(1028),
    [sym_template_string] = STATE(1028),
    [sym_regex] = STATE(1028),
    [sym_meta_property] = STATE(1028),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1028),
    [sym_as_expression] = STATE(1028),
    [sym_internal_module] = STATE(1028),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2311),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2287),
    [sym_this] = ACTIONS(2289),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2289),
    [sym_false] = ACTIONS(2289),
    [sym_null] = ACTIONS(2289),
    [sym_undefined] = ACTIONS(2289),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [385] = {
    [sym_import] = STATE(1003),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1003),
    [sym_yield_expression] = STATE(1003),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1003),
    [sym_jsx_fragment] = STATE(1003),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1003),
    [sym_class] = STATE(1003),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1003),
    [sym_arrow_function] = STATE(1003),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1003),
    [sym_new_expression] = STATE(1003),
    [sym_await_expression] = STATE(1003),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1003),
    [sym_augmented_assignment_expression] = STATE(1003),
    [sym_ternary_expression] = STATE(1003),
    [sym_binary_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1003),
    [sym_update_expression] = STATE(1003),
    [sym_string] = STATE(1003),
    [sym_template_string] = STATE(1003),
    [sym_regex] = STATE(1003),
    [sym_meta_property] = STATE(1003),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1003),
    [sym_as_expression] = STATE(1003),
    [sym_internal_module] = STATE(1003),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2313),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [386] = {
    [sym_import] = STATE(1003),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1003),
    [sym_yield_expression] = STATE(1003),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1003),
    [sym_jsx_fragment] = STATE(1003),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1003),
    [sym_class] = STATE(1003),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1003),
    [sym_arrow_function] = STATE(1003),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1003),
    [sym_new_expression] = STATE(1003),
    [sym_await_expression] = STATE(1003),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1003),
    [sym_augmented_assignment_expression] = STATE(1003),
    [sym_ternary_expression] = STATE(1003),
    [sym_binary_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1003),
    [sym_update_expression] = STATE(1003),
    [sym_string] = STATE(1003),
    [sym_template_string] = STATE(1003),
    [sym_regex] = STATE(1003),
    [sym_meta_property] = STATE(1003),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1003),
    [sym_as_expression] = STATE(1003),
    [sym_internal_module] = STATE(1003),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2315),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [387] = {
    [sym__declaration] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_class_declaration] = STATE(591),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function_declaration] = STATE(591),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(591),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(591),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_object_repeat1] = STATE(2680),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(2303),
    [anon_sym_global] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [388] = {
    [sym_import] = STATE(1110),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1110),
    [sym_yield_expression] = STATE(1110),
    [sym_object] = STATE(1308),
    [sym_array] = STATE(1309),
    [sym_jsx_element] = STATE(1110),
    [sym_jsx_fragment] = STATE(1110),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1110),
    [sym_class] = STATE(1110),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1110),
    [sym_arrow_function] = STATE(1110),
    [sym__call_signature] = STATE(3167),
    [sym_call_expression] = STATE(1110),
    [sym_new_expression] = STATE(1110),
    [sym_await_expression] = STATE(1110),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1110),
    [sym_augmented_assignment_expression] = STATE(1110),
    [sym_ternary_expression] = STATE(1110),
    [sym_binary_expression] = STATE(1110),
    [sym_unary_expression] = STATE(1110),
    [sym_update_expression] = STATE(1110),
    [sym_string] = STATE(1110),
    [sym_template_string] = STATE(1110),
    [sym_regex] = STATE(1110),
    [sym_meta_property] = STATE(1110),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1110),
    [sym_as_expression] = STATE(1110),
    [sym_internal_module] = STATE(1110),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2127),
    [sym_this] = ACTIONS(2045),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2045),
    [sym_false] = ACTIONS(2045),
    [sym_null] = ACTIONS(2045),
    [sym_undefined] = ACTIONS(2045),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [389] = {
    [sym_import] = STATE(1208),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1208),
    [sym_yield_expression] = STATE(1208),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1208),
    [sym_jsx_fragment] = STATE(1208),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1208),
    [sym_class] = STATE(1208),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1208),
    [sym_new_expression] = STATE(1208),
    [sym_await_expression] = STATE(1208),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1208),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_ternary_expression] = STATE(1208),
    [sym_binary_expression] = STATE(1208),
    [sym_unary_expression] = STATE(1208),
    [sym_update_expression] = STATE(1208),
    [sym_string] = STATE(1208),
    [sym_template_string] = STATE(1208),
    [sym_regex] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2317),
    [sym_this] = ACTIONS(2319),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2319),
    [sym_false] = ACTIONS(2319),
    [sym_null] = ACTIONS(2319),
    [sym_undefined] = ACTIONS(2319),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [390] = {
    [sym_import] = STATE(1257),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1257),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1257),
    [sym_jsx_fragment] = STATE(1257),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1257),
    [sym_class] = STATE(1257),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1257),
    [sym_arrow_function] = STATE(1257),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1257),
    [sym_new_expression] = STATE(1257),
    [sym_await_expression] = STATE(1257),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1257),
    [sym_augmented_assignment_expression] = STATE(1257),
    [sym_ternary_expression] = STATE(1257),
    [sym_binary_expression] = STATE(1257),
    [sym_unary_expression] = STATE(1257),
    [sym_update_expression] = STATE(1257),
    [sym_string] = STATE(1257),
    [sym_template_string] = STATE(1257),
    [sym_regex] = STATE(1257),
    [sym_meta_property] = STATE(1257),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1257),
    [sym_as_expression] = STATE(1257),
    [sym_internal_module] = STATE(1257),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2321),
    [sym_this] = ACTIONS(2323),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2323),
    [sym_false] = ACTIONS(2323),
    [sym_null] = ACTIONS(2323),
    [sym_undefined] = ACTIONS(2323),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [391] = {
    [sym_import] = STATE(1325),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1325),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1325),
    [sym_jsx_fragment] = STATE(1325),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1325),
    [sym_class] = STATE(1325),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1325),
    [sym_arrow_function] = STATE(1325),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1325),
    [sym_new_expression] = STATE(1325),
    [sym_await_expression] = STATE(1325),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1325),
    [sym_augmented_assignment_expression] = STATE(1325),
    [sym_ternary_expression] = STATE(1325),
    [sym_binary_expression] = STATE(1325),
    [sym_unary_expression] = STATE(1325),
    [sym_update_expression] = STATE(1325),
    [sym_string] = STATE(1325),
    [sym_template_string] = STATE(1325),
    [sym_regex] = STATE(1325),
    [sym_meta_property] = STATE(1325),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1325),
    [sym_as_expression] = STATE(1325),
    [sym_internal_module] = STATE(1325),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2325),
    [sym_this] = ACTIONS(2327),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2327),
    [sym_false] = ACTIONS(2327),
    [sym_null] = ACTIONS(2327),
    [sym_undefined] = ACTIONS(2327),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [392] = {
    [sym_import] = STATE(1326),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1326),
    [sym_jsx_fragment] = STATE(1326),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1326),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(691),
    [sym_this] = ACTIONS(693),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_null] = ACTIONS(693),
    [sym_undefined] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [393] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1372),
    [sym_jsx_fragment] = STATE(1372),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1372),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2329),
    [sym_this] = ACTIONS(2331),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2331),
    [sym_false] = ACTIONS(2331),
    [sym_null] = ACTIONS(2331),
    [sym_undefined] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [394] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(979),
    [sym_jsx_fragment] = STATE(979),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(979),
    [sym_class] = STATE(979),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(607),
    [sym_this] = ACTIONS(609),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_undefined] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [395] = {
    [sym_import] = STATE(1017),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1017),
    [sym_yield_expression] = STATE(1017),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1017),
    [sym_jsx_fragment] = STATE(1017),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1017),
    [sym_class] = STATE(1017),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1017),
    [sym_arrow_function] = STATE(1017),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1017),
    [sym_new_expression] = STATE(1017),
    [sym_await_expression] = STATE(1017),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1017),
    [sym_augmented_assignment_expression] = STATE(1017),
    [sym_ternary_expression] = STATE(1017),
    [sym_binary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym_update_expression] = STATE(1017),
    [sym_string] = STATE(1017),
    [sym_template_string] = STATE(1017),
    [sym_regex] = STATE(1017),
    [sym_meta_property] = STATE(1017),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1017),
    [sym_as_expression] = STATE(1017),
    [sym_internal_module] = STATE(1017),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2333),
    [sym_this] = ACTIONS(2335),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_null] = ACTIONS(2335),
    [sym_undefined] = ACTIONS(2335),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [396] = {
    [sym_import] = STATE(1452),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1452),
    [sym_yield_expression] = STATE(1452),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1452),
    [sym_jsx_fragment] = STATE(1452),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1452),
    [sym_class] = STATE(1452),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1452),
    [sym_arrow_function] = STATE(1452),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1452),
    [sym_new_expression] = STATE(1452),
    [sym_await_expression] = STATE(1452),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1452),
    [sym_augmented_assignment_expression] = STATE(1452),
    [sym_ternary_expression] = STATE(1452),
    [sym_binary_expression] = STATE(1452),
    [sym_unary_expression] = STATE(1452),
    [sym_update_expression] = STATE(1452),
    [sym_string] = STATE(1452),
    [sym_template_string] = STATE(1452),
    [sym_regex] = STATE(1452),
    [sym_meta_property] = STATE(1452),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1452),
    [sym_as_expression] = STATE(1452),
    [sym_internal_module] = STATE(1452),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2337),
    [sym_this] = ACTIONS(2339),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2339),
    [sym_false] = ACTIONS(2339),
    [sym_null] = ACTIONS(2339),
    [sym_undefined] = ACTIONS(2339),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [397] = {
    [sym_import] = STATE(1242),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1242),
    [sym_jsx_fragment] = STATE(1242),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1242),
    [sym_class] = STATE(1242),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1242),
    [sym_arrow_function] = STATE(1242),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1242),
    [sym_new_expression] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_string] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_meta_property] = STATE(1242),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(2341),
    [sym_this] = ACTIONS(2343),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(2343),
    [sym_false] = ACTIONS(2343),
    [sym_null] = ACTIONS(2343),
    [sym_undefined] = ACTIONS(2343),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [398] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(917),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1490),
    [sym_array] = STATE(1489),
    [sym_jsx_element] = STATE(1248),
    [sym_jsx_fragment] = STATE(1248),
    [sym_jsx_opening_element] = STATE(2001),
    [sym_jsx_self_closing_element] = STATE(1248),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(3028),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(701),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_await] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_void] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_number] = ACTIONS(751),
    [sym_this] = ACTIONS(753),
    [sym_super] = ACTIONS(755),
    [sym_true] = ACTIONS(753),
    [sym_false] = ACTIONS(753),
    [sym_null] = ACTIONS(753),
    [sym_undefined] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(701),
    [anon_sym_get] = ACTIONS(701),
    [anon_sym_set] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_public] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_any] = ACTIONS(701),
    [anon_sym_number] = ACTIONS(701),
    [anon_sym_boolean] = ACTIONS(701),
    [anon_sym_string] = ACTIONS(701),
    [anon_sym_symbol] = ACTIONS(701),
    [sym_readonly] = ACTIONS(701),
  },
  [399] = {
    [sym__declaration] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_class_declaration] = STATE(591),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function_declaration] = STATE(591),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(591),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(591),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_object_repeat1] = STATE(2563),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(2303),
    [anon_sym_global] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [400] = {
    [sym_import] = STATE(1619),
    [sym_parenthesized_expression] = STATE(925),
    [sym__expression] = STATE(1619),
    [sym_yield_expression] = STATE(1619),
    [sym_object] = STATE(1715),
    [sym_array] = STATE(1702),
    [sym_jsx_element] = STATE(1619),
    [sym_jsx_fragment] = STATE(1619),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1619),
    [sym_class] = STATE(1619),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1619),
    [sym_arrow_function] = STATE(1619),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1619),
    [sym_new_expression] = STATE(1619),
    [sym_await_expression] = STATE(1619),
    [sym_member_expression] = STATE(925),
    [sym_subscript_expression] = STATE(925),
    [sym_assignment_expression] = STATE(1619),
    [sym_augmented_assignment_expression] = STATE(1619),
    [sym_ternary_expression] = STATE(1619),
    [sym_binary_expression] = STATE(1619),
    [sym_unary_expression] = STATE(1619),
    [sym_update_expression] = STATE(1619),
    [sym_string] = STATE(1619),
    [sym_template_string] = STATE(1619),
    [sym_regex] = STATE(1619),
    [sym_meta_property] = STATE(1619),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1619),
    [sym_as_expression] = STATE(1619),
    [sym_internal_module] = STATE(1619),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2345),
    [anon_sym_export] = ACTIONS(1721),
    [anon_sym_namespace] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(1727),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(1438),
    [sym_this] = ACTIONS(1440),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [sym_null] = ACTIONS(1440),
    [sym_undefined] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1721),
    [anon_sym_get] = ACTIONS(1721),
    [anon_sym_set] = ACTIONS(1721),
    [anon_sym_declare] = ACTIONS(1721),
    [anon_sym_public] = ACTIONS(1721),
    [anon_sym_private] = ACTIONS(1721),
    [anon_sym_protected] = ACTIONS(1721),
    [anon_sym_module] = ACTIONS(1721),
    [anon_sym_any] = ACTIONS(1721),
    [anon_sym_number] = ACTIONS(1721),
    [anon_sym_boolean] = ACTIONS(1721),
    [anon_sym_string] = ACTIONS(1721),
    [anon_sym_symbol] = ACTIONS(1721),
    [sym_readonly] = ACTIONS(1721),
  },
  [401] = {
    [sym_import] = STATE(1547),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1547),
    [sym_yield_expression] = STATE(1547),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1547),
    [sym_jsx_fragment] = STATE(1547),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1547),
    [sym_class] = STATE(1547),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1547),
    [sym_arrow_function] = STATE(1547),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1547),
    [sym_new_expression] = STATE(1547),
    [sym_await_expression] = STATE(1547),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1547),
    [sym_augmented_assignment_expression] = STATE(1547),
    [sym_ternary_expression] = STATE(1547),
    [sym_binary_expression] = STATE(1547),
    [sym_unary_expression] = STATE(1547),
    [sym_update_expression] = STATE(1547),
    [sym_string] = STATE(1547),
    [sym_template_string] = STATE(1547),
    [sym_regex] = STATE(1547),
    [sym_meta_property] = STATE(1547),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1547),
    [sym_as_expression] = STATE(1547),
    [sym_internal_module] = STATE(1547),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2347),
    [sym_this] = ACTIONS(2349),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [sym_null] = ACTIONS(2349),
    [sym_undefined] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [402] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2351),
    [sym_this] = ACTIONS(2353),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2353),
    [sym_false] = ACTIONS(2353),
    [sym_null] = ACTIONS(2353),
    [sym_undefined] = ACTIONS(2353),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [403] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1289),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1289),
    [sym_jsx_fragment] = STATE(1289),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1289),
    [sym_class] = STATE(1289),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1289),
    [sym_arrow_function] = STATE(1289),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1289),
    [sym_new_expression] = STATE(1289),
    [sym_await_expression] = STATE(1289),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1289),
    [sym_augmented_assignment_expression] = STATE(1289),
    [sym_ternary_expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_update_expression] = STATE(1289),
    [sym_string] = STATE(1289),
    [sym_template_string] = STATE(1289),
    [sym_regex] = STATE(1289),
    [sym_meta_property] = STATE(1289),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1289),
    [sym_as_expression] = STATE(1289),
    [sym_internal_module] = STATE(1289),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(789),
    [sym_this] = ACTIONS(791),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(791),
    [sym_false] = ACTIONS(791),
    [sym_null] = ACTIONS(791),
    [sym_undefined] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [404] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(902),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1429),
    [sym_array] = STATE(1427),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3042),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_export] = ACTIONS(515),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(551),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(557),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_null] = ACTIONS(559),
    [sym_undefined] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_declare] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_symbol] = ACTIONS(515),
    [sym_readonly] = ACTIONS(515),
  },
  [405] = {
    [sym_import] = STATE(1286),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1286),
    [sym_jsx_fragment] = STATE(1286),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1286),
    [sym_class] = STATE(1286),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1286),
    [sym_arrow_function] = STATE(1286),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1286),
    [sym_new_expression] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_string] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2355),
    [sym_this] = ACTIONS(2357),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2357),
    [sym_false] = ACTIONS(2357),
    [sym_null] = ACTIONS(2357),
    [sym_undefined] = ACTIONS(2357),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [406] = {
    [sym_export_clause] = STATE(2510),
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(1460),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_module] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [407] = {
    [sym_import] = STATE(1218),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1218),
    [sym_jsx_fragment] = STATE(1218),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1218),
    [sym_class] = STATE(1218),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1218),
    [sym_arrow_function] = STATE(1218),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_string] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2069),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [408] = {
    [sym_import] = STATE(1279),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1279),
    [sym_jsx_fragment] = STATE(1279),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1279),
    [sym_class] = STATE(1279),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1279),
    [sym_arrow_function] = STATE(1279),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1279),
    [sym_new_expression] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2365),
    [sym_this] = ACTIONS(2367),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_undefined] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [409] = {
    [sym_import] = STATE(1278),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1278),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1278),
    [sym_jsx_fragment] = STATE(1278),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1278),
    [sym_class] = STATE(1278),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1278),
    [sym_arrow_function] = STATE(1278),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1278),
    [sym_new_expression] = STATE(1278),
    [sym_await_expression] = STATE(1278),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1278),
    [sym_augmented_assignment_expression] = STATE(1278),
    [sym_ternary_expression] = STATE(1278),
    [sym_binary_expression] = STATE(1278),
    [sym_unary_expression] = STATE(1278),
    [sym_update_expression] = STATE(1278),
    [sym_string] = STATE(1278),
    [sym_template_string] = STATE(1278),
    [sym_regex] = STATE(1278),
    [sym_meta_property] = STATE(1278),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1278),
    [sym_as_expression] = STATE(1278),
    [sym_internal_module] = STATE(1278),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2369),
    [sym_this] = ACTIONS(2371),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2371),
    [sym_false] = ACTIONS(2371),
    [sym_null] = ACTIONS(2371),
    [sym_undefined] = ACTIONS(2371),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [410] = {
    [sym_import] = STATE(1277),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1277),
    [sym_jsx_fragment] = STATE(1277),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1277),
    [sym_class] = STATE(1277),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1277),
    [sym_arrow_function] = STATE(1277),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1277),
    [sym_new_expression] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_string] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_meta_property] = STATE(1277),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2373),
    [sym_this] = ACTIONS(2375),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2375),
    [sym_false] = ACTIONS(2375),
    [sym_null] = ACTIONS(2375),
    [sym_undefined] = ACTIONS(2375),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [411] = {
    [sym_import] = STATE(1276),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1276),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1276),
    [sym_jsx_fragment] = STATE(1276),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1276),
    [sym_class] = STATE(1276),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1276),
    [sym_arrow_function] = STATE(1276),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1276),
    [sym_new_expression] = STATE(1276),
    [sym_await_expression] = STATE(1276),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1276),
    [sym_augmented_assignment_expression] = STATE(1276),
    [sym_ternary_expression] = STATE(1276),
    [sym_binary_expression] = STATE(1276),
    [sym_unary_expression] = STATE(1276),
    [sym_update_expression] = STATE(1276),
    [sym_string] = STATE(1276),
    [sym_template_string] = STATE(1276),
    [sym_regex] = STATE(1276),
    [sym_meta_property] = STATE(1276),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1276),
    [sym_as_expression] = STATE(1276),
    [sym_internal_module] = STATE(1276),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2377),
    [sym_this] = ACTIONS(2379),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2379),
    [sym_false] = ACTIONS(2379),
    [sym_null] = ACTIONS(2379),
    [sym_undefined] = ACTIONS(2379),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [412] = {
    [sym_import] = STATE(1388),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1388),
    [sym_yield_expression] = STATE(1388),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1388),
    [sym_jsx_fragment] = STATE(1388),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1388),
    [sym_class] = STATE(1388),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1388),
    [sym_arrow_function] = STATE(1388),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1388),
    [sym_new_expression] = STATE(1388),
    [sym_await_expression] = STATE(1388),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1388),
    [sym_augmented_assignment_expression] = STATE(1388),
    [sym_ternary_expression] = STATE(1388),
    [sym_binary_expression] = STATE(1388),
    [sym_unary_expression] = STATE(1388),
    [sym_update_expression] = STATE(1388),
    [sym_string] = STATE(1388),
    [sym_template_string] = STATE(1388),
    [sym_regex] = STATE(1388),
    [sym_meta_property] = STATE(1388),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1388),
    [sym_as_expression] = STATE(1388),
    [sym_internal_module] = STATE(1388),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2381),
    [sym_this] = ACTIONS(2383),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_null] = ACTIONS(2383),
    [sym_undefined] = ACTIONS(2383),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [413] = {
    [sym_import] = STATE(1387),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1387),
    [sym_yield_expression] = STATE(1387),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1387),
    [sym_jsx_fragment] = STATE(1387),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1387),
    [sym_class] = STATE(1387),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1387),
    [sym_arrow_function] = STATE(1387),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1387),
    [sym_new_expression] = STATE(1387),
    [sym_await_expression] = STATE(1387),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1387),
    [sym_augmented_assignment_expression] = STATE(1387),
    [sym_ternary_expression] = STATE(1387),
    [sym_binary_expression] = STATE(1387),
    [sym_unary_expression] = STATE(1387),
    [sym_update_expression] = STATE(1387),
    [sym_string] = STATE(1387),
    [sym_template_string] = STATE(1387),
    [sym_regex] = STATE(1387),
    [sym_meta_property] = STATE(1387),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1387),
    [sym_as_expression] = STATE(1387),
    [sym_internal_module] = STATE(1387),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2385),
    [sym_this] = ACTIONS(2387),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2387),
    [sym_false] = ACTIONS(2387),
    [sym_null] = ACTIONS(2387),
    [sym_undefined] = ACTIONS(2387),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [414] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1386),
    [sym_yield_expression] = STATE(1386),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1386),
    [sym_jsx_fragment] = STATE(1386),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1386),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1386),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1386),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1386),
    [sym_augmented_assignment_expression] = STATE(1386),
    [sym_ternary_expression] = STATE(1386),
    [sym_binary_expression] = STATE(1386),
    [sym_unary_expression] = STATE(1386),
    [sym_update_expression] = STATE(1386),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1386),
    [sym_as_expression] = STATE(1386),
    [sym_internal_module] = STATE(1386),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2083),
    [sym_this] = ACTIONS(2085),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2085),
    [sym_false] = ACTIONS(2085),
    [sym_null] = ACTIONS(2085),
    [sym_undefined] = ACTIONS(2085),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [415] = {
    [sym_import] = STATE(1275),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1275),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1275),
    [sym_jsx_fragment] = STATE(1275),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1275),
    [sym_class] = STATE(1275),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1275),
    [sym_arrow_function] = STATE(1275),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1275),
    [sym_new_expression] = STATE(1275),
    [sym_await_expression] = STATE(1275),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1275),
    [sym_augmented_assignment_expression] = STATE(1275),
    [sym_ternary_expression] = STATE(1275),
    [sym_binary_expression] = STATE(1275),
    [sym_unary_expression] = STATE(1275),
    [sym_update_expression] = STATE(1275),
    [sym_string] = STATE(1275),
    [sym_template_string] = STATE(1275),
    [sym_regex] = STATE(1275),
    [sym_meta_property] = STATE(1275),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1275),
    [sym_as_expression] = STATE(1275),
    [sym_internal_module] = STATE(1275),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2389),
    [sym_this] = ACTIONS(2391),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2391),
    [sym_false] = ACTIONS(2391),
    [sym_null] = ACTIONS(2391),
    [sym_undefined] = ACTIONS(2391),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [416] = {
    [sym_import] = STATE(1273),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1273),
    [sym_yield_expression] = STATE(1273),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1273),
    [sym_jsx_fragment] = STATE(1273),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1273),
    [sym_class] = STATE(1273),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1273),
    [sym_arrow_function] = STATE(1273),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_ternary_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_update_expression] = STATE(1273),
    [sym_string] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_regex] = STATE(1273),
    [sym_meta_property] = STATE(1273),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_internal_module] = STATE(1273),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2393),
    [sym_this] = ACTIONS(2395),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2395),
    [sym_false] = ACTIONS(2395),
    [sym_null] = ACTIONS(2395),
    [sym_undefined] = ACTIONS(2395),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [417] = {
    [sym_import] = STATE(1269),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1269),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1269),
    [sym_jsx_fragment] = STATE(1269),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1269),
    [sym_class] = STATE(1269),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1269),
    [sym_arrow_function] = STATE(1269),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1269),
    [sym_new_expression] = STATE(1269),
    [sym_await_expression] = STATE(1269),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1269),
    [sym_augmented_assignment_expression] = STATE(1269),
    [sym_ternary_expression] = STATE(1269),
    [sym_binary_expression] = STATE(1269),
    [sym_unary_expression] = STATE(1269),
    [sym_update_expression] = STATE(1269),
    [sym_string] = STATE(1269),
    [sym_template_string] = STATE(1269),
    [sym_regex] = STATE(1269),
    [sym_meta_property] = STATE(1269),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1269),
    [sym_as_expression] = STATE(1269),
    [sym_internal_module] = STATE(1269),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2397),
    [sym_this] = ACTIONS(2399),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2399),
    [sym_false] = ACTIONS(2399),
    [sym_null] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [418] = {
    [sym_import] = STATE(1267),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1267),
    [sym_jsx_fragment] = STATE(1267),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1267),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_string] = STATE(1267),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2401),
    [sym_this] = ACTIONS(1070),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(1070),
    [sym_false] = ACTIONS(1070),
    [sym_null] = ACTIONS(1070),
    [sym_undefined] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [419] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1265),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1265),
    [sym_jsx_fragment] = STATE(1265),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1265),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1265),
    [sym_await_expression] = STATE(1265),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1265),
    [sym_augmented_assignment_expression] = STATE(1265),
    [sym_ternary_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_update_expression] = STATE(1265),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1265),
    [sym_as_expression] = STATE(1265),
    [sym_internal_module] = STATE(1265),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2403),
    [sym_this] = ACTIONS(2405),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [420] = {
    [sym_import] = STATE(1003),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1003),
    [sym_yield_expression] = STATE(1003),
    [sym_object] = STATE(1299),
    [sym_array] = STATE(1298),
    [sym_jsx_element] = STATE(1003),
    [sym_jsx_fragment] = STATE(1003),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1003),
    [sym_class] = STATE(1003),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1003),
    [sym_arrow_function] = STATE(1003),
    [sym__call_signature] = STATE(3064),
    [sym_call_expression] = STATE(1003),
    [sym_new_expression] = STATE(1003),
    [sym_await_expression] = STATE(1003),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1003),
    [sym_augmented_assignment_expression] = STATE(1003),
    [sym_ternary_expression] = STATE(1003),
    [sym_binary_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1003),
    [sym_update_expression] = STATE(1003),
    [sym_string] = STATE(1003),
    [sym_template_string] = STATE(1003),
    [sym_regex] = STATE(1003),
    [sym_meta_property] = STATE(1003),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1003),
    [sym_as_expression] = STATE(1003),
    [sym_internal_module] = STATE(1003),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(601),
    [anon_sym_delete] = ACTIONS(575),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2407),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [421] = {
    [sym_import] = STATE(1385),
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(1385),
    [sym_yield_expression] = STATE(1385),
    [sym_object] = STATE(1636),
    [sym_array] = STATE(1638),
    [sym_jsx_element] = STATE(1385),
    [sym_jsx_fragment] = STATE(1385),
    [sym_jsx_opening_element] = STATE(2023),
    [sym_jsx_self_closing_element] = STATE(1385),
    [sym_class] = STATE(1385),
    [sym_function] = STATE(1049),
    [sym_generator_function] = STATE(1385),
    [sym_arrow_function] = STATE(1385),
    [sym__call_signature] = STATE(3105),
    [sym_call_expression] = STATE(1385),
    [sym_new_expression] = STATE(1385),
    [sym_await_expression] = STATE(1385),
    [sym_member_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1385),
    [sym_augmented_assignment_expression] = STATE(1385),
    [sym_ternary_expression] = STATE(1385),
    [sym_binary_expression] = STATE(1385),
    [sym_unary_expression] = STATE(1385),
    [sym_update_expression] = STATE(1385),
    [sym_string] = STATE(1385),
    [sym_template_string] = STATE(1385),
    [sym_regex] = STATE(1385),
    [sym_meta_property] = STATE(1385),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1385),
    [sym_as_expression] = STATE(1385),
    [sym_internal_module] = STATE(1385),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2491),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(663),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2409),
    [sym_this] = ACTIONS(2411),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2411),
    [sym_false] = ACTIONS(2411),
    [sym_null] = ACTIONS(2411),
    [sym_undefined] = ACTIONS(2411),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_get] = ACTIONS(663),
    [anon_sym_set] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_any] = ACTIONS(663),
    [anon_sym_number] = ACTIONS(663),
    [anon_sym_boolean] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_symbol] = ACTIONS(663),
    [sym_readonly] = ACTIONS(663),
  },
  [422] = {
    [sym_import] = STATE(1261),
    [sym_parenthesized_expression] = STATE(912),
    [sym__expression] = STATE(1261),
    [sym_yield_expression] = STATE(1261),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1459),
    [sym_jsx_element] = STATE(1261),
    [sym_jsx_fragment] = STATE(1261),
    [sym_jsx_opening_element] = STATE(2010),
    [sym_jsx_self_closing_element] = STATE(1261),
    [sym_class] = STATE(1261),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1261),
    [sym_arrow_function] = STATE(1261),
    [sym__call_signature] = STATE(3024),
    [sym_call_expression] = STATE(1261),
    [sym_new_expression] = STATE(1261),
    [sym_await_expression] = STATE(1261),
    [sym_member_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_assignment_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1261),
    [sym_ternary_expression] = STATE(1261),
    [sym_binary_expression] = STATE(1261),
    [sym_unary_expression] = STATE(1261),
    [sym_update_expression] = STATE(1261),
    [sym_string] = STATE(1261),
    [sym_template_string] = STATE(1261),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(2536),
    [sym_non_null_expression] = STATE(1261),
    [sym_as_expression] = STATE(1261),
    [sym_internal_module] = STATE(1261),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_export_statement_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_export] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_typeof] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(785),
    [anon_sym_delete] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_number] = ACTIONS(2413),
    [sym_this] = ACTIONS(2415),
    [sym_super] = ACTIONS(561),
    [sym_true] = ACTIONS(2415),
    [sym_false] = ACTIONS(2415),
    [sym_null] = ACTIONS(2415),
    [sym_undefined] = ACTIONS(2415),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_module] = ACTIONS(759),
    [anon_sym_any] = ACTIONS(759),
    [anon_sym_number] = ACTIONS(759),
    [anon_sym_boolean] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(759),
    [sym_readonly] = ACTIONS(759),
  },
  [423] = {
    [sym__declaration] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_class_declaration] = STATE(591),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function_declaration] = STATE(591),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(591),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(591),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_module] = ACTIONS(2417),
    [anon_sym_global] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [424] = {
    [sym__declaration] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_class_declaration] = STATE(591),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function_declaration] = STATE(591),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(591),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(591),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(2303),
    [anon_sym_global] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [425] = {
    [sym__declaration] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_class_declaration] = STATE(591),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function_declaration] = STATE(591),
    [sym_decorator] = STATE(1866),
    [sym_function_signature] = STATE(591),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(591),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1485),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(2063),
    [anon_sym_module] = ACTIONS(2419),
    [anon_sym_global] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1495),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [426] = {
    [sym__call_signature] = STATE(3014),
    [sym_string] = STATE(2164),
    [sym_formal_parameters] = STATE(2536),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_object_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(2421),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2423),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2423),
    [anon_sym_function] = ACTIONS(2439),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2423),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2447),
    [anon_sym_set] = ACTIONS(2447),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
    [sym_readonly] = ACTIONS(2423),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1280),
    [sym_identifier] = ACTIONS(1282),
    [anon_sym_export] = ACTIONS(1282),
    [anon_sym_default] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_namespace] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_type] = ACTIONS(1282),
    [anon_sym_typeof] = ACTIONS(1282),
    [anon_sym_import] = ACTIONS(1282),
    [anon_sym_var] = ACTIONS(1282),
    [anon_sym_let] = ACTIONS(1282),
    [anon_sym_const] = ACTIONS(1282),
    [anon_sym_if] = ACTIONS(1282),
    [anon_sym_else] = ACTIONS(1282),
    [anon_sym_switch] = ACTIONS(1282),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_await] = ACTIONS(1282),
    [anon_sym_while] = ACTIONS(1282),
    [anon_sym_do] = ACTIONS(1282),
    [anon_sym_try] = ACTIONS(1282),
    [anon_sym_with] = ACTIONS(1282),
    [anon_sym_break] = ACTIONS(1282),
    [anon_sym_continue] = ACTIONS(1282),
    [anon_sym_debugger] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(1282),
    [anon_sym_throw] = ACTIONS(1282),
    [anon_sym_SEMI] = ACTIONS(1280),
    [anon_sym_COLON] = ACTIONS(1280),
    [anon_sym_case] = ACTIONS(1282),
    [anon_sym_yield] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_SLASH] = ACTIONS(1282),
    [anon_sym_class] = ACTIONS(1282),
    [anon_sym_async] = ACTIONS(1282),
    [anon_sym_function] = ACTIONS(1282),
    [anon_sym_EQ_GT] = ACTIONS(1280),
    [anon_sym_new] = ACTIONS(1282),
    [anon_sym_QMARK] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1280),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_void] = ACTIONS(1282),
    [anon_sym_delete] = ACTIONS(1282),
    [anon_sym_PLUS_PLUS] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [sym_number] = ACTIONS(1280),
    [sym_this] = ACTIONS(1282),
    [sym_super] = ACTIONS(1282),
    [sym_true] = ACTIONS(1282),
    [sym_false] = ACTIONS(1282),
    [sym_null] = ACTIONS(1282),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_static] = ACTIONS(1282),
    [anon_sym_abstract] = ACTIONS(1282),
    [anon_sym_get] = ACTIONS(1282),
    [anon_sym_set] = ACTIONS(1282),
    [anon_sym_declare] = ACTIONS(1282),
    [anon_sym_public] = ACTIONS(1282),
    [anon_sym_private] = ACTIONS(1282),
    [anon_sym_protected] = ACTIONS(1282),
    [anon_sym_module] = ACTIONS(1282),
    [anon_sym_any] = ACTIONS(1282),
    [anon_sym_number] = ACTIONS(1282),
    [anon_sym_boolean] = ACTIONS(1282),
    [anon_sym_string] = ACTIONS(1282),
    [anon_sym_symbol] = ACTIONS(1282),
    [anon_sym_interface] = ACTIONS(1282),
    [anon_sym_enum] = ACTIONS(1282),
    [sym_readonly] = ACTIONS(1282),
  },
  [428] = {
    [sym__call_signature] = STATE(3014),
    [sym_string] = STATE(2164),
    [sym_formal_parameters] = STATE(2536),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_object_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(2421),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2423),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2423),
    [anon_sym_function] = ACTIONS(2439),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2423),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2447),
    [anon_sym_set] = ACTIONS(2447),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
    [sym_readonly] = ACTIONS(2423),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_export] = ACTIONS(1160),
    [anon_sym_default] = ACTIONS(1160),
    [anon_sym_EQ] = ACTIONS(1160),
    [anon_sym_namespace] = ACTIONS(1160),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1160),
    [anon_sym_typeof] = ACTIONS(1160),
    [anon_sym_import] = ACTIONS(1160),
    [anon_sym_var] = ACTIONS(1160),
    [anon_sym_let] = ACTIONS(1160),
    [anon_sym_const] = ACTIONS(1160),
    [anon_sym_if] = ACTIONS(1160),
    [anon_sym_else] = ACTIONS(1160),
    [anon_sym_switch] = ACTIONS(1160),
    [anon_sym_for] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [anon_sym_RPAREN] = ACTIONS(1158),
    [anon_sym_await] = ACTIONS(1160),
    [anon_sym_while] = ACTIONS(1160),
    [anon_sym_do] = ACTIONS(1160),
    [anon_sym_try] = ACTIONS(1160),
    [anon_sym_with] = ACTIONS(1160),
    [anon_sym_break] = ACTIONS(1160),
    [anon_sym_continue] = ACTIONS(1160),
    [anon_sym_debugger] = ACTIONS(1160),
    [anon_sym_return] = ACTIONS(1160),
    [anon_sym_throw] = ACTIONS(1160),
    [anon_sym_SEMI] = ACTIONS(1158),
    [anon_sym_COLON] = ACTIONS(1158),
    [anon_sym_case] = ACTIONS(1160),
    [anon_sym_yield] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_RBRACK] = ACTIONS(1158),
    [anon_sym_LT] = ACTIONS(1158),
    [anon_sym_GT] = ACTIONS(1158),
    [anon_sym_SLASH] = ACTIONS(1160),
    [anon_sym_class] = ACTIONS(1160),
    [anon_sym_async] = ACTIONS(1160),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_EQ_GT] = ACTIONS(1158),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_QMARK] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(1158),
    [anon_sym_PIPE] = ACTIONS(1158),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_BANG] = ACTIONS(1158),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_void] = ACTIONS(1160),
    [anon_sym_delete] = ACTIONS(1160),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_DQUOTE] = ACTIONS(1158),
    [anon_sym_SQUOTE] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1158),
    [sym_this] = ACTIONS(1160),
    [sym_super] = ACTIONS(1160),
    [sym_true] = ACTIONS(1160),
    [sym_false] = ACTIONS(1160),
    [sym_null] = ACTIONS(1160),
    [sym_undefined] = ACTIONS(1160),
    [anon_sym_AT] = ACTIONS(1158),
    [anon_sym_static] = ACTIONS(1160),
    [anon_sym_abstract] = ACTIONS(1160),
    [anon_sym_get] = ACTIONS(1160),
    [anon_sym_set] = ACTIONS(1160),
    [anon_sym_declare] = ACTIONS(1160),
    [anon_sym_public] = ACTIONS(1160),
    [anon_sym_private] = ACTIONS(1160),
    [anon_sym_protected] = ACTIONS(1160),
    [anon_sym_module] = ACTIONS(1160),
    [anon_sym_any] = ACTIONS(1160),
    [anon_sym_number] = ACTIONS(1160),
    [anon_sym_boolean] = ACTIONS(1160),
    [anon_sym_string] = ACTIONS(1160),
    [anon_sym_symbol] = ACTIONS(1160),
    [anon_sym_interface] = ACTIONS(1160),
    [anon_sym_enum] = ACTIONS(1160),
    [sym_readonly] = ACTIONS(1160),
  },
  [430] = {
    [sym__call_signature] = STATE(3014),
    [sym_string] = STATE(2164),
    [sym_formal_parameters] = STATE(2536),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [sym_type_parameters] = STATE(2828),
    [aux_sym_object_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(2421),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2423),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2423),
    [anon_sym_function] = ACTIONS(2439),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2423),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2447),
    [anon_sym_set] = ACTIONS(2447),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
    [sym_readonly] = ACTIONS(2423),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(2449),
    [sym_identifier] = ACTIONS(2451),
    [anon_sym_export] = ACTIONS(2451),
    [anon_sym_default] = ACTIONS(2451),
    [anon_sym_EQ] = ACTIONS(2451),
    [anon_sym_namespace] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2449),
    [anon_sym_COMMA] = ACTIONS(2449),
    [anon_sym_RBRACE] = ACTIONS(2449),
    [anon_sym_type] = ACTIONS(2451),
    [anon_sym_typeof] = ACTIONS(2451),
    [anon_sym_import] = ACTIONS(2451),
    [anon_sym_var] = ACTIONS(2451),
    [anon_sym_let] = ACTIONS(2451),
    [anon_sym_const] = ACTIONS(2451),
    [anon_sym_if] = ACTIONS(2451),
    [anon_sym_else] = ACTIONS(2451),
    [anon_sym_switch] = ACTIONS(2451),
    [anon_sym_for] = ACTIONS(2451),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_RPAREN] = ACTIONS(2449),
    [anon_sym_await] = ACTIONS(2451),
    [anon_sym_while] = ACTIONS(2451),
    [anon_sym_do] = ACTIONS(2451),
    [anon_sym_try] = ACTIONS(2451),
    [anon_sym_with] = ACTIONS(2451),
    [anon_sym_break] = ACTIONS(2451),
    [anon_sym_continue] = ACTIONS(2451),
    [anon_sym_debugger] = ACTIONS(2451),
    [anon_sym_return] = ACTIONS(2451),
    [anon_sym_throw] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(2449),
    [anon_sym_case] = ACTIONS(2451),
    [anon_sym_yield] = ACTIONS(2451),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_RBRACK] = ACTIONS(2449),
    [anon_sym_LT] = ACTIONS(2449),
    [anon_sym_GT] = ACTIONS(2449),
    [anon_sym_SLASH] = ACTIONS(2451),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(2451),
    [anon_sym_async] = ACTIONS(2451),
    [anon_sym_function] = ACTIONS(2451),
    [anon_sym_EQ_GT] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_PIPE] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2451),
    [anon_sym_BANG] = ACTIONS(2449),
    [anon_sym_TILDE] = ACTIONS(2449),
    [anon_sym_void] = ACTIONS(2451),
    [anon_sym_delete] = ACTIONS(2451),
    [anon_sym_PLUS_PLUS] = ACTIONS(2449),
    [anon_sym_DASH_DASH] = ACTIONS(2449),
    [anon_sym_DQUOTE] = ACTIONS(2449),
    [anon_sym_SQUOTE] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2449),
    [sym_number] = ACTIONS(2449),
    [sym_this] = ACTIONS(2451),
    [sym_super] = ACTIONS(2451),
    [sym_true] = ACTIONS(2451),
    [sym_false] = ACTIONS(2451),
    [sym_null] = ACTIONS(2451),
    [sym_undefined] = ACTIONS(2451),
    [anon_sym_AT] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2451),
    [anon_sym_abstract] = ACTIONS(2451),
    [anon_sym_get] = ACTIONS(2451),
    [anon_sym_set] = ACTIONS(2451),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_public] = ACTIONS(2451),
    [anon_sym_private] = ACTIONS(2451),
    [anon_sym_protected] = ACTIONS(2451),
    [anon_sym_module] = ACTIONS(2451),
    [anon_sym_any] = ACTIONS(2451),
    [anon_sym_number] = ACTIONS(2451),
    [anon_sym_boolean] = ACTIONS(2451),
    [anon_sym_string] = ACTIONS(2451),
    [anon_sym_symbol] = ACTIONS(2451),
    [anon_sym_implements] = ACTIONS(2451),
    [anon_sym_interface] = ACTIONS(2451),
    [anon_sym_enum] = ACTIONS(2451),
    [sym_readonly] = ACTIONS(2451),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2453),
    [sym_identifier] = ACTIONS(2455),
    [anon_sym_export] = ACTIONS(2455),
    [anon_sym_default] = ACTIONS(2455),
    [anon_sym_EQ] = ACTIONS(2455),
    [anon_sym_namespace] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2453),
    [anon_sym_type] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2455),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_var] = ACTIONS(2455),
    [anon_sym_let] = ACTIONS(2455),
    [anon_sym_const] = ACTIONS(2455),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_else] = ACTIONS(2455),
    [anon_sym_switch] = ACTIONS(2455),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_RPAREN] = ACTIONS(2453),
    [anon_sym_await] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_do] = ACTIONS(2455),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_with] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_debugger] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_throw] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_RBRACK] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(2455),
    [anon_sym_EQ_GT] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_void] = ACTIONS(2455),
    [anon_sym_delete] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2453),
    [sym_number] = ACTIONS(2453),
    [sym_this] = ACTIONS(2455),
    [sym_super] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [sym_false] = ACTIONS(2455),
    [sym_null] = ACTIONS(2455),
    [sym_undefined] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2455),
    [anon_sym_abstract] = ACTIONS(2455),
    [anon_sym_get] = ACTIONS(2455),
    [anon_sym_set] = ACTIONS(2455),
    [anon_sym_declare] = ACTIONS(2455),
    [anon_sym_public] = ACTIONS(2455),
    [anon_sym_private] = ACTIONS(2455),
    [anon_sym_protected] = ACTIONS(2455),
    [anon_sym_module] = ACTIONS(2455),
    [anon_sym_any] = ACTIONS(2455),
    [anon_sym_number] = ACTIONS(2455),
    [anon_sym_boolean] = ACTIONS(2455),
    [anon_sym_string] = ACTIONS(2455),
    [anon_sym_symbol] = ACTIONS(2455),
    [anon_sym_implements] = ACTIONS(2455),
    [anon_sym_interface] = ACTIONS(2455),
    [anon_sym_enum] = ACTIONS(2455),
    [sym_readonly] = ACTIONS(2455),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2457),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_export] = ACTIONS(2459),
    [anon_sym_default] = ACTIONS(2459),
    [anon_sym_EQ] = ACTIONS(2459),
    [anon_sym_namespace] = ACTIONS(2459),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_type] = ACTIONS(2459),
    [anon_sym_typeof] = ACTIONS(2459),
    [anon_sym_import] = ACTIONS(2459),
    [anon_sym_var] = ACTIONS(2459),
    [anon_sym_let] = ACTIONS(2459),
    [anon_sym_const] = ACTIONS(2459),
    [anon_sym_if] = ACTIONS(2459),
    [anon_sym_else] = ACTIONS(2459),
    [anon_sym_switch] = ACTIONS(2459),
    [anon_sym_for] = ACTIONS(2459),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2459),
    [anon_sym_while] = ACTIONS(2459),
    [anon_sym_do] = ACTIONS(2459),
    [anon_sym_try] = ACTIONS(2459),
    [anon_sym_with] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2459),
    [anon_sym_continue] = ACTIONS(2459),
    [anon_sym_debugger] = ACTIONS(2459),
    [anon_sym_return] = ACTIONS(2459),
    [anon_sym_throw] = ACTIONS(2459),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2459),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_RBRACK] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2459),
    [anon_sym_DOT] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2459),
    [anon_sym_async] = ACTIONS(2459),
    [anon_sym_function] = ACTIONS(2459),
    [anon_sym_EQ_GT] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_void] = ACTIONS(2459),
    [anon_sym_delete] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [sym_this] = ACTIONS(2459),
    [sym_super] = ACTIONS(2459),
    [sym_true] = ACTIONS(2459),
    [sym_false] = ACTIONS(2459),
    [sym_null] = ACTIONS(2459),
    [sym_undefined] = ACTIONS(2459),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2459),
    [anon_sym_abstract] = ACTIONS(2459),
    [anon_sym_get] = ACTIONS(2459),
    [anon_sym_set] = ACTIONS(2459),
    [anon_sym_declare] = ACTIONS(2459),
    [anon_sym_public] = ACTIONS(2459),
    [anon_sym_private] = ACTIONS(2459),
    [anon_sym_protected] = ACTIONS(2459),
    [anon_sym_module] = ACTIONS(2459),
    [anon_sym_any] = ACTIONS(2459),
    [anon_sym_number] = ACTIONS(2459),
    [anon_sym_boolean] = ACTIONS(2459),
    [anon_sym_string] = ACTIONS(2459),
    [anon_sym_symbol] = ACTIONS(2459),
    [anon_sym_interface] = ACTIONS(2459),
    [anon_sym_enum] = ACTIONS(2459),
    [sym_readonly] = ACTIONS(2459),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2463),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_export] = ACTIONS(2465),
    [anon_sym_default] = ACTIONS(2465),
    [anon_sym_EQ] = ACTIONS(2465),
    [anon_sym_namespace] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2463),
    [anon_sym_type] = ACTIONS(2465),
    [anon_sym_typeof] = ACTIONS(2465),
    [anon_sym_import] = ACTIONS(2465),
    [anon_sym_var] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_else] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_await] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_with] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_debugger] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_throw] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_case] = ACTIONS(2465),
    [anon_sym_yield] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_RBRACK] = ACTIONS(2463),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_async] = ACTIONS(2465),
    [anon_sym_function] = ACTIONS(2465),
    [anon_sym_EQ_GT] = ACTIONS(2463),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_void] = ACTIONS(2465),
    [anon_sym_delete] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2463),
    [sym_number] = ACTIONS(2463),
    [sym_this] = ACTIONS(2465),
    [sym_super] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_null] = ACTIONS(2465),
    [sym_undefined] = ACTIONS(2465),
    [anon_sym_AT] = ACTIONS(2463),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_abstract] = ACTIONS(2465),
    [anon_sym_get] = ACTIONS(2465),
    [anon_sym_set] = ACTIONS(2465),
    [anon_sym_declare] = ACTIONS(2465),
    [anon_sym_public] = ACTIONS(2465),
    [anon_sym_private] = ACTIONS(2465),
    [anon_sym_protected] = ACTIONS(2465),
    [anon_sym_module] = ACTIONS(2465),
    [anon_sym_any] = ACTIONS(2465),
    [anon_sym_number] = ACTIONS(2465),
    [anon_sym_boolean] = ACTIONS(2465),
    [anon_sym_string] = ACTIONS(2465),
    [anon_sym_symbol] = ACTIONS(2465),
    [anon_sym_implements] = ACTIONS(2465),
    [anon_sym_interface] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [sym_readonly] = ACTIONS(2465),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(2467),
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_EQ] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_COMMA] = ACTIONS(2467),
    [anon_sym_RBRACE] = ACTIONS(2467),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2467),
    [anon_sym_RPAREN] = ACTIONS(2467),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2467),
    [anon_sym_RBRACK] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_EQ_GT] = ACTIONS(2467),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2467),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [sym_number] = ACTIONS(2467),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2467),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [sym_readonly] = ACTIONS(2469),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(2471),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_export] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_EQ] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_COMMA] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2473),
    [anon_sym_typeof] = ACTIONS(2473),
    [anon_sym_import] = ACTIONS(2473),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_RPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_with] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_debugger] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_RBRACK] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2471),
    [anon_sym_GT] = ACTIONS(2471),
    [anon_sym_SLASH] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_async] = ACTIONS(2473),
    [anon_sym_function] = ACTIONS(2473),
    [anon_sym_EQ_GT] = ACTIONS(2471),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_PIPE] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2473),
    [sym_super] = ACTIONS(2473),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [sym_null] = ACTIONS(2473),
    [sym_undefined] = ACTIONS(2473),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_abstract] = ACTIONS(2473),
    [anon_sym_get] = ACTIONS(2473),
    [anon_sym_set] = ACTIONS(2473),
    [anon_sym_declare] = ACTIONS(2473),
    [anon_sym_public] = ACTIONS(2473),
    [anon_sym_private] = ACTIONS(2473),
    [anon_sym_protected] = ACTIONS(2473),
    [anon_sym_module] = ACTIONS(2473),
    [anon_sym_any] = ACTIONS(2473),
    [anon_sym_number] = ACTIONS(2473),
    [anon_sym_boolean] = ACTIONS(2473),
    [anon_sym_string] = ACTIONS(2473),
    [anon_sym_symbol] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [sym_readonly] = ACTIONS(2473),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2477),
    [anon_sym_export] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_EQ] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_COMMA] = ACTIONS(2475),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_type] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(2477),
    [anon_sym_import] = ACTIONS(2477),
    [anon_sym_var] = ACTIONS(2477),
    [anon_sym_let] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_RPAREN] = ACTIONS(2475),
    [anon_sym_await] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_with] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_debugger] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_throw] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_yield] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_RBRACK] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(2475),
    [anon_sym_SLASH] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_async] = ACTIONS(2477),
    [anon_sym_function] = ACTIONS(2477),
    [anon_sym_EQ_GT] = ACTIONS(2475),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_void] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2475),
    [sym_number] = ACTIONS(2475),
    [sym_this] = ACTIONS(2477),
    [sym_super] = ACTIONS(2477),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_undefined] = ACTIONS(2477),
    [anon_sym_AT] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_abstract] = ACTIONS(2477),
    [anon_sym_get] = ACTIONS(2477),
    [anon_sym_set] = ACTIONS(2477),
    [anon_sym_declare] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_module] = ACTIONS(2477),
    [anon_sym_any] = ACTIONS(2477),
    [anon_sym_number] = ACTIONS(2477),
    [anon_sym_boolean] = ACTIONS(2477),
    [anon_sym_string] = ACTIONS(2477),
    [anon_sym_symbol] = ACTIONS(2477),
    [anon_sym_interface] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [sym_readonly] = ACTIONS(2477),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2481),
    [anon_sym_export] = ACTIONS(2481),
    [anon_sym_default] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(2481),
    [anon_sym_namespace] = ACTIONS(2481),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_COMMA] = ACTIONS(2479),
    [anon_sym_RBRACE] = ACTIONS(2479),
    [anon_sym_type] = ACTIONS(2481),
    [anon_sym_typeof] = ACTIONS(2481),
    [anon_sym_import] = ACTIONS(2481),
    [anon_sym_var] = ACTIONS(2481),
    [anon_sym_let] = ACTIONS(2481),
    [anon_sym_const] = ACTIONS(2481),
    [anon_sym_if] = ACTIONS(2481),
    [anon_sym_else] = ACTIONS(2481),
    [anon_sym_switch] = ACTIONS(2481),
    [anon_sym_for] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2479),
    [anon_sym_RPAREN] = ACTIONS(2479),
    [anon_sym_await] = ACTIONS(2481),
    [anon_sym_while] = ACTIONS(2481),
    [anon_sym_do] = ACTIONS(2481),
    [anon_sym_try] = ACTIONS(2481),
    [anon_sym_with] = ACTIONS(2481),
    [anon_sym_break] = ACTIONS(2481),
    [anon_sym_continue] = ACTIONS(2481),
    [anon_sym_debugger] = ACTIONS(2481),
    [anon_sym_return] = ACTIONS(2481),
    [anon_sym_throw] = ACTIONS(2481),
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym_case] = ACTIONS(2481),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_LBRACK] = ACTIONS(2479),
    [anon_sym_RBRACK] = ACTIONS(2479),
    [anon_sym_LT] = ACTIONS(2479),
    [anon_sym_GT] = ACTIONS(2479),
    [anon_sym_SLASH] = ACTIONS(2481),
    [anon_sym_class] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2481),
    [anon_sym_function] = ACTIONS(2481),
    [anon_sym_EQ_GT] = ACTIONS(2479),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_AMP] = ACTIONS(2479),
    [anon_sym_PIPE] = ACTIONS(2479),
    [anon_sym_PLUS] = ACTIONS(2481),
    [anon_sym_DASH] = ACTIONS(2481),
    [anon_sym_BANG] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_void] = ACTIONS(2481),
    [anon_sym_delete] = ACTIONS(2481),
    [anon_sym_PLUS_PLUS] = ACTIONS(2479),
    [anon_sym_DASH_DASH] = ACTIONS(2479),
    [anon_sym_DQUOTE] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2479),
    [sym_number] = ACTIONS(2479),
    [sym_this] = ACTIONS(2481),
    [sym_super] = ACTIONS(2481),
    [sym_true] = ACTIONS(2481),
    [sym_false] = ACTIONS(2481),
    [sym_null] = ACTIONS(2481),
    [sym_undefined] = ACTIONS(2481),
    [anon_sym_AT] = ACTIONS(2479),
    [anon_sym_static] = ACTIONS(2481),
    [anon_sym_abstract] = ACTIONS(2481),
    [anon_sym_get] = ACTIONS(2481),
    [anon_sym_set] = ACTIONS(2481),
    [anon_sym_declare] = ACTIONS(2481),
    [anon_sym_public] = ACTIONS(2481),
    [anon_sym_private] = ACTIONS(2481),
    [anon_sym_protected] = ACTIONS(2481),
    [anon_sym_module] = ACTIONS(2481),
    [anon_sym_any] = ACTIONS(2481),
    [anon_sym_number] = ACTIONS(2481),
    [anon_sym_boolean] = ACTIONS(2481),
    [anon_sym_string] = ACTIONS(2481),
    [anon_sym_symbol] = ACTIONS(2481),
    [anon_sym_interface] = ACTIONS(2481),
    [anon_sym_enum] = ACTIONS(2481),
    [sym_readonly] = ACTIONS(2481),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(2483),
    [sym_identifier] = ACTIONS(2485),
    [anon_sym_export] = ACTIONS(2485),
    [anon_sym_default] = ACTIONS(2485),
    [anon_sym_EQ] = ACTIONS(2485),
    [anon_sym_namespace] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COMMA] = ACTIONS(2483),
    [anon_sym_RBRACE] = ACTIONS(2483),
    [anon_sym_type] = ACTIONS(2485),
    [anon_sym_typeof] = ACTIONS(2485),
    [anon_sym_import] = ACTIONS(2485),
    [anon_sym_var] = ACTIONS(2485),
    [anon_sym_let] = ACTIONS(2485),
    [anon_sym_const] = ACTIONS(2485),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_switch] = ACTIONS(2485),
    [anon_sym_for] = ACTIONS(2485),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_RPAREN] = ACTIONS(2483),
    [anon_sym_await] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_try] = ACTIONS(2485),
    [anon_sym_with] = ACTIONS(2485),
    [anon_sym_break] = ACTIONS(2485),
    [anon_sym_continue] = ACTIONS(2485),
    [anon_sym_debugger] = ACTIONS(2485),
    [anon_sym_return] = ACTIONS(2485),
    [anon_sym_throw] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2485),
    [anon_sym_yield] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2487),
    [anon_sym_RBRACK] = ACTIONS(2483),
    [anon_sym_LT] = ACTIONS(2483),
    [anon_sym_GT] = ACTIONS(2483),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_class] = ACTIONS(2485),
    [anon_sym_async] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2485),
    [anon_sym_EQ_GT] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_PIPE] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2483),
    [anon_sym_TILDE] = ACTIONS(2483),
    [anon_sym_void] = ACTIONS(2485),
    [anon_sym_delete] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2483),
    [anon_sym_DQUOTE] = ACTIONS(2483),
    [anon_sym_SQUOTE] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2483),
    [sym_number] = ACTIONS(2483),
    [sym_this] = ACTIONS(2485),
    [sym_super] = ACTIONS(2485),
    [sym_true] = ACTIONS(2485),
    [sym_false] = ACTIONS(2485),
    [sym_null] = ACTIONS(2485),
    [sym_undefined] = ACTIONS(2485),
    [anon_sym_AT] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2485),
    [anon_sym_abstract] = ACTIONS(2485),
    [anon_sym_get] = ACTIONS(2485),
    [anon_sym_set] = ACTIONS(2485),
    [anon_sym_declare] = ACTIONS(2485),
    [anon_sym_public] = ACTIONS(2485),
    [anon_sym_private] = ACTIONS(2485),
    [anon_sym_protected] = ACTIONS(2485),
    [anon_sym_module] = ACTIONS(2485),
    [anon_sym_any] = ACTIONS(2485),
    [anon_sym_number] = ACTIONS(2485),
    [anon_sym_boolean] = ACTIONS(2485),
    [anon_sym_string] = ACTIONS(2485),
    [anon_sym_symbol] = ACTIONS(2485),
    [anon_sym_interface] = ACTIONS(2485),
    [anon_sym_enum] = ACTIONS(2485),
    [sym_readonly] = ACTIONS(2485),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2489),
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_export] = ACTIONS(2491),
    [anon_sym_default] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(2491),
    [anon_sym_namespace] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_type] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(2491),
    [anon_sym_import] = ACTIONS(2491),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_await] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_with] = ACTIONS(2491),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_debugger] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym_case] = ACTIONS(2491),
    [anon_sym_yield] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_async] = ACTIONS(2491),
    [anon_sym_function] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2489),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2489),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_void] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2489),
    [sym_number] = ACTIONS(2489),
    [sym_this] = ACTIONS(2491),
    [sym_super] = ACTIONS(2491),
    [sym_true] = ACTIONS(2491),
    [sym_false] = ACTIONS(2491),
    [sym_null] = ACTIONS(2491),
    [sym_undefined] = ACTIONS(2491),
    [anon_sym_AT] = ACTIONS(2489),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_abstract] = ACTIONS(2491),
    [anon_sym_get] = ACTIONS(2491),
    [anon_sym_set] = ACTIONS(2491),
    [anon_sym_declare] = ACTIONS(2491),
    [anon_sym_public] = ACTIONS(2491),
    [anon_sym_private] = ACTIONS(2491),
    [anon_sym_protected] = ACTIONS(2491),
    [anon_sym_module] = ACTIONS(2491),
    [anon_sym_any] = ACTIONS(2491),
    [anon_sym_number] = ACTIONS(2491),
    [anon_sym_boolean] = ACTIONS(2491),
    [anon_sym_string] = ACTIONS(2491),
    [anon_sym_symbol] = ACTIONS(2491),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [sym_readonly] = ACTIONS(2491),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_default] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2493),
    [anon_sym_RBRACE] = ACTIONS(2493),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(2495),
    [anon_sym_import] = ACTIONS(2495),
    [anon_sym_var] = ACTIONS(2495),
    [anon_sym_let] = ACTIONS(2495),
    [anon_sym_const] = ACTIONS(2495),
    [anon_sym_if] = ACTIONS(2495),
    [anon_sym_else] = ACTIONS(2495),
    [anon_sym_switch] = ACTIONS(2495),
    [anon_sym_for] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_RPAREN] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [anon_sym_while] = ACTIONS(2495),
    [anon_sym_do] = ACTIONS(2495),
    [anon_sym_try] = ACTIONS(2495),
    [anon_sym_with] = ACTIONS(2495),
    [anon_sym_break] = ACTIONS(2495),
    [anon_sym_continue] = ACTIONS(2495),
    [anon_sym_debugger] = ACTIONS(2495),
    [anon_sym_return] = ACTIONS(2495),
    [anon_sym_throw] = ACTIONS(2495),
    [anon_sym_SEMI] = ACTIONS(2493),
    [anon_sym_case] = ACTIONS(2495),
    [anon_sym_yield] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(2493),
    [anon_sym_RBRACK] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_SLASH] = ACTIONS(2495),
    [anon_sym_class] = ACTIONS(2495),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_function] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(2493),
    [anon_sym_new] = ACTIONS(2495),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2495),
    [anon_sym_DASH] = ACTIONS(2495),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_delete] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(2493),
    [anon_sym_DASH_DASH] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2493),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2493),
    [sym_number] = ACTIONS(2493),
    [sym_this] = ACTIONS(2495),
    [sym_super] = ACTIONS(2495),
    [sym_true] = ACTIONS(2495),
    [sym_false] = ACTIONS(2495),
    [sym_null] = ACTIONS(2495),
    [sym_undefined] = ACTIONS(2495),
    [anon_sym_AT] = ACTIONS(2493),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_abstract] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [anon_sym_interface] = ACTIONS(2495),
    [anon_sym_enum] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(2497),
    [sym_identifier] = ACTIONS(2499),
    [anon_sym_export] = ACTIONS(2499),
    [anon_sym_default] = ACTIONS(2499),
    [anon_sym_EQ] = ACTIONS(2499),
    [anon_sym_namespace] = ACTIONS(2499),
    [anon_sym_LBRACE] = ACTIONS(2497),
    [anon_sym_COMMA] = ACTIONS(2497),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_type] = ACTIONS(2499),
    [anon_sym_typeof] = ACTIONS(2499),
    [anon_sym_import] = ACTIONS(2499),
    [anon_sym_var] = ACTIONS(2499),
    [anon_sym_let] = ACTIONS(2499),
    [anon_sym_const] = ACTIONS(2499),
    [anon_sym_if] = ACTIONS(2499),
    [anon_sym_else] = ACTIONS(2499),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_for] = ACTIONS(2499),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_RPAREN] = ACTIONS(2497),
    [anon_sym_await] = ACTIONS(2499),
    [anon_sym_while] = ACTIONS(2499),
    [anon_sym_do] = ACTIONS(2499),
    [anon_sym_try] = ACTIONS(2499),
    [anon_sym_with] = ACTIONS(2499),
    [anon_sym_break] = ACTIONS(2499),
    [anon_sym_continue] = ACTIONS(2499),
    [anon_sym_debugger] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_throw] = ACTIONS(2499),
    [anon_sym_SEMI] = ACTIONS(2497),
    [anon_sym_case] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2499),
    [anon_sym_LBRACK] = ACTIONS(2497),
    [anon_sym_RBRACK] = ACTIONS(2497),
    [anon_sym_LT] = ACTIONS(2497),
    [anon_sym_GT] = ACTIONS(2497),
    [anon_sym_SLASH] = ACTIONS(2499),
    [anon_sym_class] = ACTIONS(2499),
    [anon_sym_async] = ACTIONS(2499),
    [anon_sym_function] = ACTIONS(2499),
    [anon_sym_EQ_GT] = ACTIONS(2497),
    [anon_sym_new] = ACTIONS(2499),
    [anon_sym_AMP] = ACTIONS(2497),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_PLUS] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2497),
    [anon_sym_void] = ACTIONS(2499),
    [anon_sym_delete] = ACTIONS(2499),
    [anon_sym_PLUS_PLUS] = ACTIONS(2497),
    [anon_sym_DASH_DASH] = ACTIONS(2497),
    [anon_sym_DQUOTE] = ACTIONS(2497),
    [anon_sym_SQUOTE] = ACTIONS(2497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2497),
    [sym_number] = ACTIONS(2497),
    [sym_this] = ACTIONS(2499),
    [sym_super] = ACTIONS(2499),
    [sym_true] = ACTIONS(2499),
    [sym_false] = ACTIONS(2499),
    [sym_null] = ACTIONS(2499),
    [sym_undefined] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2497),
    [anon_sym_static] = ACTIONS(2499),
    [anon_sym_abstract] = ACTIONS(2499),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2499),
    [anon_sym_public] = ACTIONS(2499),
    [anon_sym_private] = ACTIONS(2499),
    [anon_sym_protected] = ACTIONS(2499),
    [anon_sym_module] = ACTIONS(2499),
    [anon_sym_any] = ACTIONS(2499),
    [anon_sym_number] = ACTIONS(2499),
    [anon_sym_boolean] = ACTIONS(2499),
    [anon_sym_string] = ACTIONS(2499),
    [anon_sym_symbol] = ACTIONS(2499),
    [anon_sym_interface] = ACTIONS(2499),
    [anon_sym_enum] = ACTIONS(2499),
    [sym_readonly] = ACTIONS(2499),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(2501),
    [sym_identifier] = ACTIONS(2503),
    [anon_sym_export] = ACTIONS(2503),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_EQ] = ACTIONS(2503),
    [anon_sym_namespace] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2501),
    [anon_sym_COMMA] = ACTIONS(2501),
    [anon_sym_RBRACE] = ACTIONS(2501),
    [anon_sym_type] = ACTIONS(2503),
    [anon_sym_typeof] = ACTIONS(2503),
    [anon_sym_import] = ACTIONS(2503),
    [anon_sym_var] = ACTIONS(2503),
    [anon_sym_let] = ACTIONS(2503),
    [anon_sym_const] = ACTIONS(2503),
    [anon_sym_if] = ACTIONS(2503),
    [anon_sym_else] = ACTIONS(2503),
    [anon_sym_switch] = ACTIONS(2503),
    [anon_sym_for] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2501),
    [anon_sym_RPAREN] = ACTIONS(2501),
    [anon_sym_await] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2503),
    [anon_sym_do] = ACTIONS(2503),
    [anon_sym_try] = ACTIONS(2503),
    [anon_sym_with] = ACTIONS(2503),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_continue] = ACTIONS(2503),
    [anon_sym_debugger] = ACTIONS(2503),
    [anon_sym_return] = ACTIONS(2503),
    [anon_sym_throw] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2501),
    [anon_sym_case] = ACTIONS(2503),
    [anon_sym_yield] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2501),
    [anon_sym_RBRACK] = ACTIONS(2501),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_class] = ACTIONS(2503),
    [anon_sym_async] = ACTIONS(2503),
    [anon_sym_function] = ACTIONS(2503),
    [anon_sym_EQ_GT] = ACTIONS(2501),
    [anon_sym_new] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2501),
    [anon_sym_PIPE] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_TILDE] = ACTIONS(2501),
    [anon_sym_void] = ACTIONS(2503),
    [anon_sym_delete] = ACTIONS(2503),
    [anon_sym_PLUS_PLUS] = ACTIONS(2501),
    [anon_sym_DASH_DASH] = ACTIONS(2501),
    [anon_sym_DQUOTE] = ACTIONS(2501),
    [anon_sym_SQUOTE] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2501),
    [sym_number] = ACTIONS(2501),
    [sym_this] = ACTIONS(2503),
    [sym_super] = ACTIONS(2503),
    [sym_true] = ACTIONS(2503),
    [sym_false] = ACTIONS(2503),
    [sym_null] = ACTIONS(2503),
    [sym_undefined] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2501),
    [anon_sym_static] = ACTIONS(2503),
    [anon_sym_abstract] = ACTIONS(2503),
    [anon_sym_get] = ACTIONS(2503),
    [anon_sym_set] = ACTIONS(2503),
    [anon_sym_declare] = ACTIONS(2503),
    [anon_sym_public] = ACTIONS(2503),
    [anon_sym_private] = ACTIONS(2503),
    [anon_sym_protected] = ACTIONS(2503),
    [anon_sym_module] = ACTIONS(2503),
    [anon_sym_any] = ACTIONS(2503),
    [anon_sym_number] = ACTIONS(2503),
    [anon_sym_boolean] = ACTIONS(2503),
    [anon_sym_string] = ACTIONS(2503),
    [anon_sym_symbol] = ACTIONS(2503),
    [anon_sym_interface] = ACTIONS(2503),
    [anon_sym_enum] = ACTIONS(2503),
    [sym_readonly] = ACTIONS(2503),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(2505),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_EQ] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2505),
    [anon_sym_COMMA] = ACTIONS(2505),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2507),
    [anon_sym_import] = ACTIONS(2507),
    [anon_sym_var] = ACTIONS(2507),
    [anon_sym_let] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_RPAREN] = ACTIONS(2505),
    [anon_sym_await] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_with] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_debugger] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2505),
    [anon_sym_case] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2505),
    [anon_sym_RBRACK] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_GT] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_function] = ACTIONS(2507),
    [anon_sym_EQ_GT] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2505),
    [anon_sym_PIPE] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_BANG] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2505),
    [anon_sym_void] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_PLUS_PLUS] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2505),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2505),
    [sym_number] = ACTIONS(2505),
    [sym_this] = ACTIONS(2507),
    [sym_super] = ACTIONS(2507),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [sym_null] = ACTIONS(2507),
    [sym_undefined] = ACTIONS(2507),
    [anon_sym_AT] = ACTIONS(2505),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_abstract] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2507),
    [anon_sym_private] = ACTIONS(2507),
    [anon_sym_protected] = ACTIONS(2507),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [anon_sym_interface] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(2507),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(2509),
    [sym_identifier] = ACTIONS(2511),
    [anon_sym_export] = ACTIONS(2511),
    [anon_sym_default] = ACTIONS(2511),
    [anon_sym_EQ] = ACTIONS(2511),
    [anon_sym_namespace] = ACTIONS(2511),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_RBRACE] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2511),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_import] = ACTIONS(2511),
    [anon_sym_var] = ACTIONS(2511),
    [anon_sym_let] = ACTIONS(2511),
    [anon_sym_const] = ACTIONS(2511),
    [anon_sym_if] = ACTIONS(2511),
    [anon_sym_else] = ACTIONS(2511),
    [anon_sym_switch] = ACTIONS(2511),
    [anon_sym_for] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2509),
    [anon_sym_RPAREN] = ACTIONS(2509),
    [anon_sym_await] = ACTIONS(2511),
    [anon_sym_while] = ACTIONS(2511),
    [anon_sym_do] = ACTIONS(2511),
    [anon_sym_try] = ACTIONS(2511),
    [anon_sym_with] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_continue] = ACTIONS(2511),
    [anon_sym_debugger] = ACTIONS(2511),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_throw] = ACTIONS(2511),
    [anon_sym_SEMI] = ACTIONS(2509),
    [anon_sym_case] = ACTIONS(2511),
    [anon_sym_yield] = ACTIONS(2511),
    [anon_sym_LBRACK] = ACTIONS(2509),
    [anon_sym_RBRACK] = ACTIONS(2509),
    [anon_sym_LT] = ACTIONS(2509),
    [anon_sym_GT] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2511),
    [anon_sym_class] = ACTIONS(2511),
    [anon_sym_async] = ACTIONS(2511),
    [anon_sym_function] = ACTIONS(2511),
    [anon_sym_EQ_GT] = ACTIONS(2509),
    [anon_sym_new] = ACTIONS(2511),
    [anon_sym_AMP] = ACTIONS(2509),
    [anon_sym_PIPE] = ACTIONS(2509),
    [anon_sym_PLUS] = ACTIONS(2511),
    [anon_sym_DASH] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_void] = ACTIONS(2511),
    [anon_sym_delete] = ACTIONS(2511),
    [anon_sym_PLUS_PLUS] = ACTIONS(2509),
    [anon_sym_DASH_DASH] = ACTIONS(2509),
    [anon_sym_DQUOTE] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2509),
    [sym_number] = ACTIONS(2509),
    [sym_this] = ACTIONS(2511),
    [sym_super] = ACTIONS(2511),
    [sym_true] = ACTIONS(2511),
    [sym_false] = ACTIONS(2511),
    [sym_null] = ACTIONS(2511),
    [sym_undefined] = ACTIONS(2511),
    [anon_sym_AT] = ACTIONS(2509),
    [anon_sym_static] = ACTIONS(2511),
    [anon_sym_abstract] = ACTIONS(2511),
    [anon_sym_get] = ACTIONS(2511),
    [anon_sym_set] = ACTIONS(2511),
    [anon_sym_declare] = ACTIONS(2511),
    [anon_sym_public] = ACTIONS(2511),
    [anon_sym_private] = ACTIONS(2511),
    [anon_sym_protected] = ACTIONS(2511),
    [anon_sym_module] = ACTIONS(2511),
    [anon_sym_any] = ACTIONS(2511),
    [anon_sym_number] = ACTIONS(2511),
    [anon_sym_boolean] = ACTIONS(2511),
    [anon_sym_string] = ACTIONS(2511),
    [anon_sym_symbol] = ACTIONS(2511),
    [anon_sym_interface] = ACTIONS(2511),
    [anon_sym_enum] = ACTIONS(2511),
    [sym_readonly] = ACTIONS(2511),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(2513),
    [sym_identifier] = ACTIONS(2515),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_default] = ACTIONS(2515),
    [anon_sym_EQ] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(2513),
    [anon_sym_RBRACE] = ACTIONS(2513),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2515),
    [anon_sym_import] = ACTIONS(2515),
    [anon_sym_var] = ACTIONS(2515),
    [anon_sym_let] = ACTIONS(2515),
    [anon_sym_const] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(2515),
    [anon_sym_else] = ACTIONS(2515),
    [anon_sym_switch] = ACTIONS(2515),
    [anon_sym_for] = ACTIONS(2515),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_RPAREN] = ACTIONS(2513),
    [anon_sym_await] = ACTIONS(2515),
    [anon_sym_while] = ACTIONS(2515),
    [anon_sym_do] = ACTIONS(2515),
    [anon_sym_try] = ACTIONS(2515),
    [anon_sym_with] = ACTIONS(2515),
    [anon_sym_break] = ACTIONS(2515),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_debugger] = ACTIONS(2515),
    [anon_sym_return] = ACTIONS(2515),
    [anon_sym_throw] = ACTIONS(2515),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_case] = ACTIONS(2515),
    [anon_sym_yield] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(2513),
    [anon_sym_RBRACK] = ACTIONS(2513),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_SLASH] = ACTIONS(2515),
    [anon_sym_class] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_function] = ACTIONS(2515),
    [anon_sym_EQ_GT] = ACTIONS(2513),
    [anon_sym_new] = ACTIONS(2515),
    [anon_sym_AMP] = ACTIONS(2513),
    [anon_sym_PIPE] = ACTIONS(2513),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_DASH] = ACTIONS(2515),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [anon_sym_void] = ACTIONS(2515),
    [anon_sym_delete] = ACTIONS(2515),
    [anon_sym_PLUS_PLUS] = ACTIONS(2513),
    [anon_sym_DASH_DASH] = ACTIONS(2513),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [anon_sym_SQUOTE] = ACTIONS(2513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2513),
    [sym_number] = ACTIONS(2513),
    [sym_this] = ACTIONS(2515),
    [sym_super] = ACTIONS(2515),
    [sym_true] = ACTIONS(2515),
    [sym_false] = ACTIONS(2515),
    [sym_null] = ACTIONS(2515),
    [sym_undefined] = ACTIONS(2515),
    [anon_sym_AT] = ACTIONS(2513),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_abstract] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2515),
    [anon_sym_private] = ACTIONS(2515),
    [anon_sym_protected] = ACTIONS(2515),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [anon_sym_interface] = ACTIONS(2515),
    [anon_sym_enum] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2515),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(2517),
    [sym_identifier] = ACTIONS(2519),
    [anon_sym_export] = ACTIONS(2519),
    [anon_sym_default] = ACTIONS(2519),
    [anon_sym_EQ] = ACTIONS(2519),
    [anon_sym_namespace] = ACTIONS(2519),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_RBRACE] = ACTIONS(2517),
    [anon_sym_type] = ACTIONS(2519),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_import] = ACTIONS(2519),
    [anon_sym_var] = ACTIONS(2519),
    [anon_sym_let] = ACTIONS(2519),
    [anon_sym_const] = ACTIONS(2519),
    [anon_sym_if] = ACTIONS(2519),
    [anon_sym_else] = ACTIONS(2519),
    [anon_sym_switch] = ACTIONS(2519),
    [anon_sym_for] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_RPAREN] = ACTIONS(2517),
    [anon_sym_await] = ACTIONS(2519),
    [anon_sym_while] = ACTIONS(2519),
    [anon_sym_do] = ACTIONS(2519),
    [anon_sym_try] = ACTIONS(2519),
    [anon_sym_with] = ACTIONS(2519),
    [anon_sym_break] = ACTIONS(2519),
    [anon_sym_continue] = ACTIONS(2519),
    [anon_sym_debugger] = ACTIONS(2519),
    [anon_sym_return] = ACTIONS(2519),
    [anon_sym_throw] = ACTIONS(2519),
    [anon_sym_SEMI] = ACTIONS(2517),
    [anon_sym_case] = ACTIONS(2519),
    [anon_sym_yield] = ACTIONS(2519),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [anon_sym_RBRACK] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_SLASH] = ACTIONS(2519),
    [anon_sym_class] = ACTIONS(2519),
    [anon_sym_async] = ACTIONS(2519),
    [anon_sym_function] = ACTIONS(2519),
    [anon_sym_EQ_GT] = ACTIONS(2517),
    [anon_sym_new] = ACTIONS(2519),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2517),
    [anon_sym_TILDE] = ACTIONS(2517),
    [anon_sym_void] = ACTIONS(2519),
    [anon_sym_delete] = ACTIONS(2519),
    [anon_sym_PLUS_PLUS] = ACTIONS(2517),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [anon_sym_SQUOTE] = ACTIONS(2517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2517),
    [sym_number] = ACTIONS(2517),
    [sym_this] = ACTIONS(2519),
    [sym_super] = ACTIONS(2519),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [sym_null] = ACTIONS(2519),
    [sym_undefined] = ACTIONS(2519),
    [anon_sym_AT] = ACTIONS(2517),
    [anon_sym_static] = ACTIONS(2519),
    [anon_sym_abstract] = ACTIONS(2519),
    [anon_sym_get] = ACTIONS(2519),
    [anon_sym_set] = ACTIONS(2519),
    [anon_sym_declare] = ACTIONS(2519),
    [anon_sym_public] = ACTIONS(2519),
    [anon_sym_private] = ACTIONS(2519),
    [anon_sym_protected] = ACTIONS(2519),
    [anon_sym_module] = ACTIONS(2519),
    [anon_sym_any] = ACTIONS(2519),
    [anon_sym_number] = ACTIONS(2519),
    [anon_sym_boolean] = ACTIONS(2519),
    [anon_sym_string] = ACTIONS(2519),
    [anon_sym_symbol] = ACTIONS(2519),
    [anon_sym_interface] = ACTIONS(2519),
    [anon_sym_enum] = ACTIONS(2519),
    [sym_readonly] = ACTIONS(2519),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(2523),
    [anon_sym_export] = ACTIONS(2523),
    [anon_sym_default] = ACTIONS(2523),
    [anon_sym_EQ] = ACTIONS(2523),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2521),
    [anon_sym_COMMA] = ACTIONS(2521),
    [anon_sym_RBRACE] = ACTIONS(2521),
    [anon_sym_type] = ACTIONS(2523),
    [anon_sym_typeof] = ACTIONS(2523),
    [anon_sym_import] = ACTIONS(2523),
    [anon_sym_var] = ACTIONS(2523),
    [anon_sym_let] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_else] = ACTIONS(2523),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_RPAREN] = ACTIONS(2521),
    [anon_sym_await] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_with] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_debugger] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2521),
    [anon_sym_case] = ACTIONS(2523),
    [anon_sym_yield] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2521),
    [anon_sym_RBRACK] = ACTIONS(2521),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_SLASH] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_async] = ACTIONS(2523),
    [anon_sym_function] = ACTIONS(2523),
    [anon_sym_EQ_GT] = ACTIONS(2521),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2521),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [anon_sym_void] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_PLUS_PLUS] = ACTIONS(2521),
    [anon_sym_DASH_DASH] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2521),
    [anon_sym_SQUOTE] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2521),
    [sym_number] = ACTIONS(2521),
    [sym_this] = ACTIONS(2523),
    [sym_super] = ACTIONS(2523),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [sym_null] = ACTIONS(2523),
    [sym_undefined] = ACTIONS(2523),
    [anon_sym_AT] = ACTIONS(2521),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_abstract] = ACTIONS(2523),
    [anon_sym_get] = ACTIONS(2523),
    [anon_sym_set] = ACTIONS(2523),
    [anon_sym_declare] = ACTIONS(2523),
    [anon_sym_public] = ACTIONS(2523),
    [anon_sym_private] = ACTIONS(2523),
    [anon_sym_protected] = ACTIONS(2523),
    [anon_sym_module] = ACTIONS(2523),
    [anon_sym_any] = ACTIONS(2523),
    [anon_sym_number] = ACTIONS(2523),
    [anon_sym_boolean] = ACTIONS(2523),
    [anon_sym_string] = ACTIONS(2523),
    [anon_sym_symbol] = ACTIONS(2523),
    [anon_sym_interface] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
    [sym_readonly] = ACTIONS(2523),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(617),
    [sym_identifier] = ACTIONS(2525),
    [anon_sym_export] = ACTIONS(2525),
    [anon_sym_default] = ACTIONS(2525),
    [anon_sym_EQ] = ACTIONS(2525),
    [anon_sym_namespace] = ACTIONS(2525),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_type] = ACTIONS(2525),
    [anon_sym_typeof] = ACTIONS(2525),
    [anon_sym_import] = ACTIONS(2525),
    [anon_sym_var] = ACTIONS(2525),
    [anon_sym_let] = ACTIONS(2525),
    [anon_sym_const] = ACTIONS(2525),
    [anon_sym_if] = ACTIONS(2525),
    [anon_sym_else] = ACTIONS(2525),
    [anon_sym_switch] = ACTIONS(2525),
    [anon_sym_for] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_await] = ACTIONS(2525),
    [anon_sym_while] = ACTIONS(2525),
    [anon_sym_do] = ACTIONS(2525),
    [anon_sym_try] = ACTIONS(2525),
    [anon_sym_with] = ACTIONS(2525),
    [anon_sym_break] = ACTIONS(2525),
    [anon_sym_continue] = ACTIONS(2525),
    [anon_sym_debugger] = ACTIONS(2525),
    [anon_sym_return] = ACTIONS(2525),
    [anon_sym_throw] = ACTIONS(2525),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_case] = ACTIONS(2525),
    [anon_sym_yield] = ACTIONS(2525),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(2525),
    [anon_sym_class] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(2525),
    [anon_sym_function] = ACTIONS(2525),
    [anon_sym_EQ_GT] = ACTIONS(617),
    [anon_sym_new] = ACTIONS(2525),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(2525),
    [anon_sym_delete] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [sym_number] = ACTIONS(617),
    [sym_this] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_undefined] = ACTIONS(2525),
    [anon_sym_AT] = ACTIONS(617),
    [anon_sym_static] = ACTIONS(2525),
    [anon_sym_abstract] = ACTIONS(2525),
    [anon_sym_get] = ACTIONS(2525),
    [anon_sym_set] = ACTIONS(2525),
    [anon_sym_declare] = ACTIONS(2525),
    [anon_sym_public] = ACTIONS(2525),
    [anon_sym_private] = ACTIONS(2525),
    [anon_sym_protected] = ACTIONS(2525),
    [anon_sym_module] = ACTIONS(2525),
    [anon_sym_any] = ACTIONS(2525),
    [anon_sym_number] = ACTIONS(2525),
    [anon_sym_boolean] = ACTIONS(2525),
    [anon_sym_string] = ACTIONS(2525),
    [anon_sym_symbol] = ACTIONS(2525),
    [anon_sym_interface] = ACTIONS(2525),
    [anon_sym_enum] = ACTIONS(2525),
    [sym_readonly] = ACTIONS(2525),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(2527),
    [sym_identifier] = ACTIONS(2529),
    [anon_sym_export] = ACTIONS(2529),
    [anon_sym_default] = ACTIONS(2529),
    [anon_sym_EQ] = ACTIONS(2529),
    [anon_sym_namespace] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2527),
    [anon_sym_COMMA] = ACTIONS(2527),
    [anon_sym_RBRACE] = ACTIONS(2527),
    [anon_sym_type] = ACTIONS(2529),
    [anon_sym_typeof] = ACTIONS(2529),
    [anon_sym_import] = ACTIONS(2529),
    [anon_sym_var] = ACTIONS(2529),
    [anon_sym_let] = ACTIONS(2529),
    [anon_sym_const] = ACTIONS(2529),
    [anon_sym_if] = ACTIONS(2529),
    [anon_sym_else] = ACTIONS(2529),
    [anon_sym_switch] = ACTIONS(2529),
    [anon_sym_for] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2527),
    [anon_sym_RPAREN] = ACTIONS(2527),
    [anon_sym_await] = ACTIONS(2529),
    [anon_sym_while] = ACTIONS(2529),
    [anon_sym_do] = ACTIONS(2529),
    [anon_sym_try] = ACTIONS(2529),
    [anon_sym_with] = ACTIONS(2529),
    [anon_sym_break] = ACTIONS(2529),
    [anon_sym_continue] = ACTIONS(2529),
    [anon_sym_debugger] = ACTIONS(2529),
    [anon_sym_return] = ACTIONS(2529),
    [anon_sym_throw] = ACTIONS(2529),
    [anon_sym_SEMI] = ACTIONS(2527),
    [anon_sym_case] = ACTIONS(2529),
    [anon_sym_yield] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_RBRACK] = ACTIONS(2527),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_SLASH] = ACTIONS(2529),
    [anon_sym_class] = ACTIONS(2529),
    [anon_sym_async] = ACTIONS(2529),
    [anon_sym_function] = ACTIONS(2529),
    [anon_sym_EQ_GT] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(2527),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2527),
    [anon_sym_TILDE] = ACTIONS(2527),
    [anon_sym_void] = ACTIONS(2529),
    [anon_sym_delete] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2527),
    [anon_sym_DASH_DASH] = ACTIONS(2527),
    [anon_sym_DQUOTE] = ACTIONS(2527),
    [anon_sym_SQUOTE] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2527),
    [sym_number] = ACTIONS(2527),
    [sym_this] = ACTIONS(2529),
    [sym_super] = ACTIONS(2529),
    [sym_true] = ACTIONS(2529),
    [sym_false] = ACTIONS(2529),
    [sym_null] = ACTIONS(2529),
    [sym_undefined] = ACTIONS(2529),
    [anon_sym_AT] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2529),
    [anon_sym_abstract] = ACTIONS(2529),
    [anon_sym_get] = ACTIONS(2529),
    [anon_sym_set] = ACTIONS(2529),
    [anon_sym_declare] = ACTIONS(2529),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2529),
    [anon_sym_any] = ACTIONS(2529),
    [anon_sym_number] = ACTIONS(2529),
    [anon_sym_boolean] = ACTIONS(2529),
    [anon_sym_string] = ACTIONS(2529),
    [anon_sym_symbol] = ACTIONS(2529),
    [anon_sym_interface] = ACTIONS(2529),
    [anon_sym_enum] = ACTIONS(2529),
    [sym_readonly] = ACTIONS(2529),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(2531),
    [sym_identifier] = ACTIONS(2533),
    [anon_sym_export] = ACTIONS(2533),
    [anon_sym_default] = ACTIONS(2533),
    [anon_sym_EQ] = ACTIONS(2533),
    [anon_sym_namespace] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2531),
    [anon_sym_COMMA] = ACTIONS(2531),
    [anon_sym_RBRACE] = ACTIONS(2531),
    [anon_sym_type] = ACTIONS(2533),
    [anon_sym_typeof] = ACTIONS(2533),
    [anon_sym_import] = ACTIONS(2533),
    [anon_sym_var] = ACTIONS(2533),
    [anon_sym_let] = ACTIONS(2533),
    [anon_sym_const] = ACTIONS(2533),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_else] = ACTIONS(2533),
    [anon_sym_switch] = ACTIONS(2533),
    [anon_sym_for] = ACTIONS(2533),
    [anon_sym_LPAREN] = ACTIONS(2531),
    [anon_sym_RPAREN] = ACTIONS(2531),
    [anon_sym_await] = ACTIONS(2533),
    [anon_sym_while] = ACTIONS(2533),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_try] = ACTIONS(2533),
    [anon_sym_with] = ACTIONS(2533),
    [anon_sym_break] = ACTIONS(2533),
    [anon_sym_continue] = ACTIONS(2533),
    [anon_sym_debugger] = ACTIONS(2533),
    [anon_sym_return] = ACTIONS(2533),
    [anon_sym_throw] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(2531),
    [anon_sym_case] = ACTIONS(2533),
    [anon_sym_yield] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2531),
    [anon_sym_RBRACK] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_class] = ACTIONS(2533),
    [anon_sym_async] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2533),
    [anon_sym_EQ_GT] = ACTIONS(2531),
    [anon_sym_new] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_BANG] = ACTIONS(2531),
    [anon_sym_TILDE] = ACTIONS(2531),
    [anon_sym_void] = ACTIONS(2533),
    [anon_sym_delete] = ACTIONS(2533),
    [anon_sym_PLUS_PLUS] = ACTIONS(2531),
    [anon_sym_DASH_DASH] = ACTIONS(2531),
    [anon_sym_DQUOTE] = ACTIONS(2531),
    [anon_sym_SQUOTE] = ACTIONS(2531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2531),
    [sym_number] = ACTIONS(2531),
    [sym_this] = ACTIONS(2533),
    [sym_super] = ACTIONS(2533),
    [sym_true] = ACTIONS(2533),
    [sym_false] = ACTIONS(2533),
    [sym_null] = ACTIONS(2533),
    [sym_undefined] = ACTIONS(2533),
    [anon_sym_AT] = ACTIONS(2531),
    [anon_sym_static] = ACTIONS(2533),
    [anon_sym_abstract] = ACTIONS(2533),
    [anon_sym_get] = ACTIONS(2533),
    [anon_sym_set] = ACTIONS(2533),
    [anon_sym_declare] = ACTIONS(2533),
    [anon_sym_public] = ACTIONS(2533),
    [anon_sym_private] = ACTIONS(2533),
    [anon_sym_protected] = ACTIONS(2533),
    [anon_sym_module] = ACTIONS(2533),
    [anon_sym_any] = ACTIONS(2533),
    [anon_sym_number] = ACTIONS(2533),
    [anon_sym_boolean] = ACTIONS(2533),
    [anon_sym_string] = ACTIONS(2533),
    [anon_sym_symbol] = ACTIONS(2533),
    [anon_sym_interface] = ACTIONS(2533),
    [anon_sym_enum] = ACTIONS(2533),
    [sym_readonly] = ACTIONS(2533),
  },
  [452] = {
    [ts_builtin_sym_end] = ACTIONS(2535),
    [sym_identifier] = ACTIONS(2537),
    [anon_sym_export] = ACTIONS(2537),
    [anon_sym_default] = ACTIONS(2537),
    [anon_sym_EQ] = ACTIONS(2537),
    [anon_sym_namespace] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2535),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_RBRACE] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2537),
    [anon_sym_import] = ACTIONS(2537),
    [anon_sym_var] = ACTIONS(2537),
    [anon_sym_let] = ACTIONS(2537),
    [anon_sym_const] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_else] = ACTIONS(2537),
    [anon_sym_switch] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2537),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2535),
    [anon_sym_await] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_try] = ACTIONS(2537),
    [anon_sym_with] = ACTIONS(2537),
    [anon_sym_break] = ACTIONS(2537),
    [anon_sym_continue] = ACTIONS(2537),
    [anon_sym_debugger] = ACTIONS(2537),
    [anon_sym_return] = ACTIONS(2537),
    [anon_sym_throw] = ACTIONS(2537),
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_case] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2535),
    [anon_sym_RBRACK] = ACTIONS(2535),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_GT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2537),
    [anon_sym_class] = ACTIONS(2537),
    [anon_sym_async] = ACTIONS(2537),
    [anon_sym_function] = ACTIONS(2537),
    [anon_sym_EQ_GT] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2537),
    [anon_sym_AMP] = ACTIONS(2535),
    [anon_sym_PIPE] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_DASH] = ACTIONS(2537),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_void] = ACTIONS(2537),
    [anon_sym_delete] = ACTIONS(2537),
    [anon_sym_PLUS_PLUS] = ACTIONS(2535),
    [anon_sym_DASH_DASH] = ACTIONS(2535),
    [anon_sym_DQUOTE] = ACTIONS(2535),
    [anon_sym_SQUOTE] = ACTIONS(2535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2535),
    [sym_number] = ACTIONS(2535),
    [sym_this] = ACTIONS(2537),
    [sym_super] = ACTIONS(2537),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [sym_null] = ACTIONS(2537),
    [sym_undefined] = ACTIONS(2537),
    [anon_sym_AT] = ACTIONS(2535),
    [anon_sym_static] = ACTIONS(2537),
    [anon_sym_abstract] = ACTIONS(2537),
    [anon_sym_get] = ACTIONS(2537),
    [anon_sym_set] = ACTIONS(2537),
    [anon_sym_declare] = ACTIONS(2537),
    [anon_sym_public] = ACTIONS(2537),
    [anon_sym_private] = ACTIONS(2537),
    [anon_sym_protected] = ACTIONS(2537),
    [anon_sym_module] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(2537),
    [anon_sym_number] = ACTIONS(2537),
    [anon_sym_boolean] = ACTIONS(2537),
    [anon_sym_string] = ACTIONS(2537),
    [anon_sym_symbol] = ACTIONS(2537),
    [anon_sym_interface] = ACTIONS(2537),
    [anon_sym_enum] = ACTIONS(2537),
    [sym_readonly] = ACTIONS(2537),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(2539),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_default] = ACTIONS(2541),
    [anon_sym_EQ] = ACTIONS(2541),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_LBRACE] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2539),
    [anon_sym_RBRACE] = ACTIONS(2539),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2541),
    [anon_sym_import] = ACTIONS(2541),
    [anon_sym_var] = ACTIONS(2541),
    [anon_sym_let] = ACTIONS(2541),
    [anon_sym_const] = ACTIONS(2541),
    [anon_sym_if] = ACTIONS(2541),
    [anon_sym_else] = ACTIONS(2541),
    [anon_sym_switch] = ACTIONS(2541),
    [anon_sym_for] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(2539),
    [anon_sym_RPAREN] = ACTIONS(2539),
    [anon_sym_await] = ACTIONS(2541),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(2541),
    [anon_sym_try] = ACTIONS(2541),
    [anon_sym_with] = ACTIONS(2541),
    [anon_sym_break] = ACTIONS(2541),
    [anon_sym_continue] = ACTIONS(2541),
    [anon_sym_debugger] = ACTIONS(2541),
    [anon_sym_return] = ACTIONS(2541),
    [anon_sym_throw] = ACTIONS(2541),
    [anon_sym_SEMI] = ACTIONS(2539),
    [anon_sym_case] = ACTIONS(2541),
    [anon_sym_yield] = ACTIONS(2541),
    [anon_sym_LBRACK] = ACTIONS(2539),
    [anon_sym_RBRACK] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2541),
    [anon_sym_class] = ACTIONS(2541),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_function] = ACTIONS(2541),
    [anon_sym_EQ_GT] = ACTIONS(2539),
    [anon_sym_new] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_PLUS] = ACTIONS(2541),
    [anon_sym_DASH] = ACTIONS(2541),
    [anon_sym_BANG] = ACTIONS(2539),
    [anon_sym_TILDE] = ACTIONS(2539),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_delete] = ACTIONS(2541),
    [anon_sym_PLUS_PLUS] = ACTIONS(2539),
    [anon_sym_DASH_DASH] = ACTIONS(2539),
    [anon_sym_DQUOTE] = ACTIONS(2539),
    [anon_sym_SQUOTE] = ACTIONS(2539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2539),
    [sym_number] = ACTIONS(2539),
    [sym_this] = ACTIONS(2541),
    [sym_super] = ACTIONS(2541),
    [sym_true] = ACTIONS(2541),
    [sym_false] = ACTIONS(2541),
    [sym_null] = ACTIONS(2541),
    [sym_undefined] = ACTIONS(2541),
    [anon_sym_AT] = ACTIONS(2539),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_abstract] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [anon_sym_interface] = ACTIONS(2541),
    [anon_sym_enum] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(2543),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_export] = ACTIONS(2545),
    [anon_sym_default] = ACTIONS(2545),
    [anon_sym_EQ] = ACTIONS(2545),
    [anon_sym_namespace] = ACTIONS(2545),
    [anon_sym_LBRACE] = ACTIONS(2543),
    [anon_sym_COMMA] = ACTIONS(2543),
    [anon_sym_RBRACE] = ACTIONS(2543),
    [anon_sym_type] = ACTIONS(2545),
    [anon_sym_typeof] = ACTIONS(2545),
    [anon_sym_import] = ACTIONS(2545),
    [anon_sym_var] = ACTIONS(2545),
    [anon_sym_let] = ACTIONS(2545),
    [anon_sym_const] = ACTIONS(2545),
    [anon_sym_if] = ACTIONS(2545),
    [anon_sym_else] = ACTIONS(2545),
    [anon_sym_switch] = ACTIONS(2545),
    [anon_sym_for] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2543),
    [anon_sym_RPAREN] = ACTIONS(2543),
    [anon_sym_await] = ACTIONS(2545),
    [anon_sym_while] = ACTIONS(2545),
    [anon_sym_do] = ACTIONS(2545),
    [anon_sym_try] = ACTIONS(2545),
    [anon_sym_with] = ACTIONS(2545),
    [anon_sym_break] = ACTIONS(2545),
    [anon_sym_continue] = ACTIONS(2545),
    [anon_sym_debugger] = ACTIONS(2545),
    [anon_sym_return] = ACTIONS(2545),
    [anon_sym_throw] = ACTIONS(2545),
    [anon_sym_SEMI] = ACTIONS(2543),
    [anon_sym_case] = ACTIONS(2545),
    [anon_sym_yield] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_RBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(2543),
    [anon_sym_GT] = ACTIONS(2543),
    [anon_sym_SLASH] = ACTIONS(2545),
    [anon_sym_class] = ACTIONS(2545),
    [anon_sym_async] = ACTIONS(2545),
    [anon_sym_function] = ACTIONS(2545),
    [anon_sym_EQ_GT] = ACTIONS(2543),
    [anon_sym_new] = ACTIONS(2545),
    [anon_sym_AMP] = ACTIONS(2543),
    [anon_sym_PIPE] = ACTIONS(2543),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(2545),
    [anon_sym_BANG] = ACTIONS(2543),
    [anon_sym_TILDE] = ACTIONS(2543),
    [anon_sym_void] = ACTIONS(2545),
    [anon_sym_delete] = ACTIONS(2545),
    [anon_sym_PLUS_PLUS] = ACTIONS(2543),
    [anon_sym_DASH_DASH] = ACTIONS(2543),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2543),
    [sym_number] = ACTIONS(2543),
    [sym_this] = ACTIONS(2545),
    [sym_super] = ACTIONS(2545),
    [sym_true] = ACTIONS(2545),
    [sym_false] = ACTIONS(2545),
    [sym_null] = ACTIONS(2545),
    [sym_undefined] = ACTIONS(2545),
    [anon_sym_AT] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2545),
    [anon_sym_abstract] = ACTIONS(2545),
    [anon_sym_get] = ACTIONS(2545),
    [anon_sym_set] = ACTIONS(2545),
    [anon_sym_declare] = ACTIONS(2545),
    [anon_sym_public] = ACTIONS(2545),
    [anon_sym_private] = ACTIONS(2545),
    [anon_sym_protected] = ACTIONS(2545),
    [anon_sym_module] = ACTIONS(2545),
    [anon_sym_any] = ACTIONS(2545),
    [anon_sym_number] = ACTIONS(2545),
    [anon_sym_boolean] = ACTIONS(2545),
    [anon_sym_string] = ACTIONS(2545),
    [anon_sym_symbol] = ACTIONS(2545),
    [anon_sym_interface] = ACTIONS(2545),
    [anon_sym_enum] = ACTIONS(2545),
    [sym_readonly] = ACTIONS(2545),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(2547),
    [sym_identifier] = ACTIONS(2549),
    [anon_sym_export] = ACTIONS(2549),
    [anon_sym_default] = ACTIONS(2549),
    [anon_sym_EQ] = ACTIONS(2549),
    [anon_sym_namespace] = ACTIONS(2549),
    [anon_sym_LBRACE] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(2547),
    [anon_sym_RBRACE] = ACTIONS(2547),
    [anon_sym_type] = ACTIONS(2549),
    [anon_sym_typeof] = ACTIONS(2549),
    [anon_sym_import] = ACTIONS(2549),
    [anon_sym_var] = ACTIONS(2549),
    [anon_sym_let] = ACTIONS(2549),
    [anon_sym_const] = ACTIONS(2549),
    [anon_sym_if] = ACTIONS(2549),
    [anon_sym_else] = ACTIONS(2549),
    [anon_sym_switch] = ACTIONS(2549),
    [anon_sym_for] = ACTIONS(2549),
    [anon_sym_LPAREN] = ACTIONS(2547),
    [anon_sym_RPAREN] = ACTIONS(2547),
    [anon_sym_await] = ACTIONS(2549),
    [anon_sym_while] = ACTIONS(2549),
    [anon_sym_do] = ACTIONS(2549),
    [anon_sym_try] = ACTIONS(2549),
    [anon_sym_with] = ACTIONS(2549),
    [anon_sym_break] = ACTIONS(2549),
    [anon_sym_continue] = ACTIONS(2549),
    [anon_sym_debugger] = ACTIONS(2549),
    [anon_sym_return] = ACTIONS(2549),
    [anon_sym_throw] = ACTIONS(2549),
    [anon_sym_SEMI] = ACTIONS(2547),
    [anon_sym_case] = ACTIONS(2549),
    [anon_sym_yield] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2487),
    [anon_sym_RBRACK] = ACTIONS(2547),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_SLASH] = ACTIONS(2549),
    [anon_sym_class] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2549),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_PIPE] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2549),
    [anon_sym_DASH] = ACTIONS(2549),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_void] = ACTIONS(2549),
    [anon_sym_delete] = ACTIONS(2549),
    [anon_sym_PLUS_PLUS] = ACTIONS(2547),
    [anon_sym_DASH_DASH] = ACTIONS(2547),
    [anon_sym_DQUOTE] = ACTIONS(2547),
    [anon_sym_SQUOTE] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2547),
    [sym_number] = ACTIONS(2547),
    [sym_this] = ACTIONS(2549),
    [sym_super] = ACTIONS(2549),
    [sym_true] = ACTIONS(2549),
    [sym_false] = ACTIONS(2549),
    [sym_null] = ACTIONS(2549),
    [sym_undefined] = ACTIONS(2549),
    [anon_sym_AT] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2549),
    [anon_sym_abstract] = ACTIONS(2549),
    [anon_sym_get] = ACTIONS(2549),
    [anon_sym_set] = ACTIONS(2549),
    [anon_sym_declare] = ACTIONS(2549),
    [anon_sym_public] = ACTIONS(2549),
    [anon_sym_private] = ACTIONS(2549),
    [anon_sym_protected] = ACTIONS(2549),
    [anon_sym_module] = ACTIONS(2549),
    [anon_sym_any] = ACTIONS(2549),
    [anon_sym_number] = ACTIONS(2549),
    [anon_sym_boolean] = ACTIONS(2549),
    [anon_sym_string] = ACTIONS(2549),
    [anon_sym_symbol] = ACTIONS(2549),
    [anon_sym_interface] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2549),
    [sym_readonly] = ACTIONS(2549),
  },
  [456] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2551),
    [anon_sym_set] = ACTIONS(2551),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [457] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2557),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [458] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2551),
    [anon_sym_set] = ACTIONS(2551),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [459] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [460] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2557),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [461] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2557),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [462] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [463] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [464] = {
    [sym_string] = STATE(2164),
    [sym__property_name] = STATE(2164),
    [sym_computed_property_name] = STATE(2164),
    [aux_sym_object_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2551),
    [anon_sym_set] = ACTIONS(2551),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [sym_readonly] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [465] = {
    [sym_type_arguments] = STATE(432),
    [ts_builtin_sym_end] = ACTIONS(2559),
    [sym_identifier] = ACTIONS(2561),
    [anon_sym_export] = ACTIONS(2561),
    [anon_sym_default] = ACTIONS(2561),
    [anon_sym_namespace] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(2559),
    [anon_sym_RBRACE] = ACTIONS(2559),
    [anon_sym_type] = ACTIONS(2561),
    [anon_sym_typeof] = ACTIONS(2561),
    [anon_sym_import] = ACTIONS(2561),
    [anon_sym_var] = ACTIONS(2561),
    [anon_sym_let] = ACTIONS(2561),
    [anon_sym_const] = ACTIONS(2561),
    [anon_sym_if] = ACTIONS(2561),
    [anon_sym_else] = ACTIONS(2561),
    [anon_sym_switch] = ACTIONS(2561),
    [anon_sym_for] = ACTIONS(2561),
    [anon_sym_LPAREN] = ACTIONS(2559),
    [anon_sym_await] = ACTIONS(2561),
    [anon_sym_while] = ACTIONS(2561),
    [anon_sym_do] = ACTIONS(2561),
    [anon_sym_try] = ACTIONS(2561),
    [anon_sym_with] = ACTIONS(2561),
    [anon_sym_break] = ACTIONS(2561),
    [anon_sym_continue] = ACTIONS(2561),
    [anon_sym_debugger] = ACTIONS(2561),
    [anon_sym_return] = ACTIONS(2561),
    [anon_sym_throw] = ACTIONS(2561),
    [anon_sym_SEMI] = ACTIONS(2559),
    [anon_sym_case] = ACTIONS(2561),
    [anon_sym_yield] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2561),
    [anon_sym_DOT] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2561),
    [anon_sym_async] = ACTIONS(2561),
    [anon_sym_function] = ACTIONS(2561),
    [anon_sym_new] = ACTIONS(2561),
    [anon_sym_AMP] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2559),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_BANG] = ACTIONS(2559),
    [anon_sym_TILDE] = ACTIONS(2559),
    [anon_sym_void] = ACTIONS(2561),
    [anon_sym_delete] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(2559),
    [anon_sym_DASH_DASH] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2559),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2559),
    [sym_number] = ACTIONS(2559),
    [sym_this] = ACTIONS(2561),
    [sym_super] = ACTIONS(2561),
    [sym_true] = ACTIONS(2561),
    [sym_false] = ACTIONS(2561),
    [sym_null] = ACTIONS(2561),
    [sym_undefined] = ACTIONS(2561),
    [anon_sym_AT] = ACTIONS(2559),
    [anon_sym_static] = ACTIONS(2561),
    [anon_sym_abstract] = ACTIONS(2561),
    [anon_sym_get] = ACTIONS(2561),
    [anon_sym_set] = ACTIONS(2561),
    [anon_sym_declare] = ACTIONS(2561),
    [anon_sym_public] = ACTIONS(2561),
    [anon_sym_private] = ACTIONS(2561),
    [anon_sym_protected] = ACTIONS(2561),
    [anon_sym_module] = ACTIONS(2561),
    [anon_sym_any] = ACTIONS(2561),
    [anon_sym_number] = ACTIONS(2561),
    [anon_sym_boolean] = ACTIONS(2561),
    [anon_sym_string] = ACTIONS(2561),
    [anon_sym_symbol] = ACTIONS(2561),
    [anon_sym_interface] = ACTIONS(2561),
    [anon_sym_enum] = ACTIONS(2561),
    [sym_readonly] = ACTIONS(2561),
    [anon_sym_is] = ACTIONS(2566),
  },
  [466] = {
    [sym__call_signature] = STATE(3205),
    [sym_arguments] = STATE(1173),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2570),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(2576),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_default] = ACTIONS(2578),
    [anon_sym_namespace] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_type] = ACTIONS(2578),
    [anon_sym_typeof] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_var] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_switch] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2576),
    [anon_sym_await] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_with] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_continue] = ACTIONS(2578),
    [anon_sym_debugger] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_throw] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2576),
    [anon_sym_SLASH] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_async] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2576),
    [anon_sym_TILDE] = ACTIONS(2576),
    [anon_sym_void] = ACTIONS(2578),
    [anon_sym_delete] = ACTIONS(2578),
    [anon_sym_PLUS_PLUS] = ACTIONS(2576),
    [anon_sym_DASH_DASH] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2576),
    [anon_sym_SQUOTE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2576),
    [sym_number] = ACTIONS(2576),
    [sym_this] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_null] = ACTIONS(2578),
    [sym_undefined] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_get] = ACTIONS(2578),
    [anon_sym_set] = ACTIONS(2578),
    [anon_sym_declare] = ACTIONS(2578),
    [anon_sym_public] = ACTIONS(2578),
    [anon_sym_private] = ACTIONS(2578),
    [anon_sym_protected] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_implements] = ACTIONS(2578),
    [anon_sym_interface] = ACTIONS(2578),
    [anon_sym_enum] = ACTIONS(2578),
    [sym_readonly] = ACTIONS(2578),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_default] = ACTIONS(2582),
    [anon_sym_namespace] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_type] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_var] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_switch] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_await] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_with] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_continue] = ACTIONS(2582),
    [anon_sym_debugger] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_throw] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_async] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_new] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2580),
    [anon_sym_TILDE] = ACTIONS(2580),
    [anon_sym_void] = ACTIONS(2582),
    [anon_sym_delete] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2580),
    [anon_sym_DQUOTE] = ACTIONS(2580),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2580),
    [sym_number] = ACTIONS(2580),
    [sym_this] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_null] = ACTIONS(2582),
    [sym_undefined] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_get] = ACTIONS(2582),
    [anon_sym_set] = ACTIONS(2582),
    [anon_sym_declare] = ACTIONS(2582),
    [anon_sym_public] = ACTIONS(2582),
    [anon_sym_private] = ACTIONS(2582),
    [anon_sym_protected] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_any] = ACTIONS(2582),
    [anon_sym_number] = ACTIONS(2582),
    [anon_sym_boolean] = ACTIONS(2582),
    [anon_sym_string] = ACTIONS(2582),
    [anon_sym_symbol] = ACTIONS(2582),
    [anon_sym_implements] = ACTIONS(2582),
    [anon_sym_interface] = ACTIONS(2582),
    [anon_sym_enum] = ACTIONS(2582),
    [sym_readonly] = ACTIONS(2582),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_default] = ACTIONS(2586),
    [anon_sym_namespace] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_type] = ACTIONS(2586),
    [anon_sym_typeof] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_var] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_switch] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_await] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_with] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_continue] = ACTIONS(2586),
    [anon_sym_debugger] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_throw] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_async] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2584),
    [anon_sym_TILDE] = ACTIONS(2584),
    [anon_sym_void] = ACTIONS(2586),
    [anon_sym_delete] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2584),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_number] = ACTIONS(2584),
    [sym_this] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_null] = ACTIONS(2586),
    [sym_undefined] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_get] = ACTIONS(2586),
    [anon_sym_set] = ACTIONS(2586),
    [anon_sym_declare] = ACTIONS(2586),
    [anon_sym_public] = ACTIONS(2586),
    [anon_sym_private] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_any] = ACTIONS(2586),
    [anon_sym_number] = ACTIONS(2586),
    [anon_sym_boolean] = ACTIONS(2586),
    [anon_sym_string] = ACTIONS(2586),
    [anon_sym_symbol] = ACTIONS(2586),
    [anon_sym_implements] = ACTIONS(2586),
    [anon_sym_interface] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2586),
    [sym_readonly] = ACTIONS(2586),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_export] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_namespace] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_COMMA] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_type] = ACTIONS(1108),
    [anon_sym_typeof] = ACTIONS(1108),
    [anon_sym_import] = ACTIONS(1108),
    [anon_sym_var] = ACTIONS(1108),
    [anon_sym_let] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_else] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_await] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_try] = ACTIONS(1108),
    [anon_sym_with] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_debugger] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_throw] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_catch] = ACTIONS(1108),
    [anon_sym_finally] = ACTIONS(1108),
    [anon_sym_yield] = ACTIONS(1108),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_class] = ACTIONS(1108),
    [anon_sym_async] = ACTIONS(1108),
    [anon_sym_function] = ACTIONS(1108),
    [anon_sym_new] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_void] = ACTIONS(1108),
    [anon_sym_delete] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1106),
    [sym_number] = ACTIONS(1106),
    [sym_this] = ACTIONS(1108),
    [sym_super] = ACTIONS(1108),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_undefined] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_abstract] = ACTIONS(1108),
    [anon_sym_get] = ACTIONS(1108),
    [anon_sym_set] = ACTIONS(1108),
    [anon_sym_declare] = ACTIONS(1108),
    [anon_sym_public] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym_protected] = ACTIONS(1108),
    [anon_sym_module] = ACTIONS(1108),
    [anon_sym_any] = ACTIONS(1108),
    [anon_sym_number] = ACTIONS(1108),
    [anon_sym_boolean] = ACTIONS(1108),
    [anon_sym_string] = ACTIONS(1108),
    [anon_sym_symbol] = ACTIONS(1108),
    [anon_sym_interface] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [sym_readonly] = ACTIONS(1108),
    [sym__automatic_semicolon] = ACTIONS(1114),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(1144),
    [anon_sym_default] = ACTIONS(1144),
    [anon_sym_namespace] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_var] = ACTIONS(1144),
    [anon_sym_let] = ACTIONS(1144),
    [anon_sym_const] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_switch] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_await] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_do] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_debugger] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1144),
    [anon_sym_catch] = ACTIONS(1144),
    [anon_sym_finally] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_function] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [sym_number] = ACTIONS(1142),
    [sym_this] = ACTIONS(1144),
    [sym_super] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_null] = ACTIONS(1144),
    [sym_undefined] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_get] = ACTIONS(1144),
    [anon_sym_set] = ACTIONS(1144),
    [anon_sym_declare] = ACTIONS(1144),
    [anon_sym_public] = ACTIONS(1144),
    [anon_sym_private] = ACTIONS(1144),
    [anon_sym_protected] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [anon_sym_any] = ACTIONS(1144),
    [anon_sym_number] = ACTIONS(1144),
    [anon_sym_boolean] = ACTIONS(1144),
    [anon_sym_string] = ACTIONS(1144),
    [anon_sym_symbol] = ACTIONS(1144),
    [anon_sym_interface] = ACTIONS(1144),
    [anon_sym_enum] = ACTIONS(1144),
    [sym_readonly] = ACTIONS(1144),
    [sym__automatic_semicolon] = ACTIONS(2588),
  },
  [472] = {
    [sym_catch_clause] = STATE(506),
    [sym_finally_clause] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(2590),
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_namespace] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_type] = ACTIONS(2592),
    [anon_sym_typeof] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_var] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2592),
    [anon_sym_switch] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_await] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_with] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_debugger] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_throw] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2592),
    [anon_sym_catch] = ACTIONS(2594),
    [anon_sym_finally] = ACTIONS(2596),
    [anon_sym_yield] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_class] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_void] = ACTIONS(2592),
    [anon_sym_delete] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym_number] = ACTIONS(2590),
    [sym_this] = ACTIONS(2592),
    [sym_super] = ACTIONS(2592),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [sym_null] = ACTIONS(2592),
    [sym_undefined] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_get] = ACTIONS(2592),
    [anon_sym_set] = ACTIONS(2592),
    [anon_sym_declare] = ACTIONS(2592),
    [anon_sym_public] = ACTIONS(2592),
    [anon_sym_private] = ACTIONS(2592),
    [anon_sym_protected] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_any] = ACTIONS(2592),
    [anon_sym_number] = ACTIONS(2592),
    [anon_sym_boolean] = ACTIONS(2592),
    [anon_sym_string] = ACTIONS(2592),
    [anon_sym_symbol] = ACTIONS(2592),
    [anon_sym_interface] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [sym_readonly] = ACTIONS(2592),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_typeof] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_var] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_await] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_with] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_debugger] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_yield] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_async] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_void] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [sym_number] = ACTIONS(2598),
    [sym_this] = ACTIONS(2600),
    [sym_super] = ACTIONS(2600),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [sym_null] = ACTIONS(2600),
    [sym_undefined] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2598),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_get] = ACTIONS(2600),
    [anon_sym_set] = ACTIONS(2600),
    [anon_sym_declare] = ACTIONS(2600),
    [anon_sym_public] = ACTIONS(2600),
    [anon_sym_private] = ACTIONS(2600),
    [anon_sym_protected] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_any] = ACTIONS(2600),
    [anon_sym_number] = ACTIONS(2600),
    [anon_sym_boolean] = ACTIONS(2600),
    [anon_sym_string] = ACTIONS(2600),
    [anon_sym_symbol] = ACTIONS(2600),
    [anon_sym_interface] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [sym_readonly] = ACTIONS(2600),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1116),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_export] = ACTIONS(1118),
    [anon_sym_default] = ACTIONS(1118),
    [anon_sym_namespace] = ACTIONS(1118),
    [anon_sym_LBRACE] = ACTIONS(1116),
    [anon_sym_COMMA] = ACTIONS(1116),
    [anon_sym_RBRACE] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1118),
    [anon_sym_typeof] = ACTIONS(1118),
    [anon_sym_import] = ACTIONS(1118),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1118),
    [anon_sym_const] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1118),
    [anon_sym_else] = ACTIONS(1118),
    [anon_sym_switch] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1118),
    [anon_sym_try] = ACTIONS(1118),
    [anon_sym_with] = ACTIONS(1118),
    [anon_sym_break] = ACTIONS(1118),
    [anon_sym_continue] = ACTIONS(1118),
    [anon_sym_debugger] = ACTIONS(1118),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_throw] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1118),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_LBRACK] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1118),
    [anon_sym_class] = ACTIONS(1118),
    [anon_sym_async] = ACTIONS(1118),
    [anon_sym_function] = ACTIONS(1118),
    [anon_sym_new] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1116),
    [anon_sym_void] = ACTIONS(1118),
    [anon_sym_delete] = ACTIONS(1118),
    [anon_sym_PLUS_PLUS] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1116),
    [anon_sym_DQUOTE] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1116),
    [sym_number] = ACTIONS(1116),
    [sym_this] = ACTIONS(1118),
    [sym_super] = ACTIONS(1118),
    [sym_true] = ACTIONS(1118),
    [sym_false] = ACTIONS(1118),
    [sym_null] = ACTIONS(1118),
    [sym_undefined] = ACTIONS(1118),
    [anon_sym_AT] = ACTIONS(1116),
    [anon_sym_static] = ACTIONS(1118),
    [anon_sym_abstract] = ACTIONS(1118),
    [anon_sym_get] = ACTIONS(1118),
    [anon_sym_set] = ACTIONS(1118),
    [anon_sym_declare] = ACTIONS(1118),
    [anon_sym_public] = ACTIONS(1118),
    [anon_sym_private] = ACTIONS(1118),
    [anon_sym_protected] = ACTIONS(1118),
    [anon_sym_module] = ACTIONS(1118),
    [anon_sym_any] = ACTIONS(1118),
    [anon_sym_number] = ACTIONS(1118),
    [anon_sym_boolean] = ACTIONS(1118),
    [anon_sym_string] = ACTIONS(1118),
    [anon_sym_symbol] = ACTIONS(1118),
    [anon_sym_interface] = ACTIONS(1118),
    [anon_sym_enum] = ACTIONS(1118),
    [sym_readonly] = ACTIONS(1118),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1116),
    [sym__automatic_semicolon] = ACTIONS(1116),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(1144),
    [anon_sym_default] = ACTIONS(1144),
    [anon_sym_namespace] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_var] = ACTIONS(1144),
    [anon_sym_let] = ACTIONS(1144),
    [anon_sym_const] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_switch] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_await] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_do] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_debugger] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_function] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [sym_number] = ACTIONS(1142),
    [sym_this] = ACTIONS(1144),
    [sym_super] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_null] = ACTIONS(1144),
    [sym_undefined] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_get] = ACTIONS(1144),
    [anon_sym_set] = ACTIONS(1144),
    [anon_sym_declare] = ACTIONS(1144),
    [anon_sym_public] = ACTIONS(1144),
    [anon_sym_private] = ACTIONS(1144),
    [anon_sym_protected] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [anon_sym_any] = ACTIONS(1144),
    [anon_sym_number] = ACTIONS(1144),
    [anon_sym_boolean] = ACTIONS(1144),
    [anon_sym_string] = ACTIONS(1144),
    [anon_sym_symbol] = ACTIONS(1144),
    [anon_sym_interface] = ACTIONS(1144),
    [anon_sym_enum] = ACTIONS(1144),
    [sym_readonly] = ACTIONS(1144),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1142),
    [sym__automatic_semicolon] = ACTIONS(2604),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(1144),
    [anon_sym_default] = ACTIONS(1144),
    [anon_sym_namespace] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_var] = ACTIONS(1144),
    [anon_sym_let] = ACTIONS(1144),
    [anon_sym_const] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_switch] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_await] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_do] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_debugger] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_function] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [sym_number] = ACTIONS(1142),
    [sym_this] = ACTIONS(1144),
    [sym_super] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_null] = ACTIONS(1144),
    [sym_undefined] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_get] = ACTIONS(1144),
    [anon_sym_set] = ACTIONS(1144),
    [anon_sym_declare] = ACTIONS(1144),
    [anon_sym_public] = ACTIONS(1144),
    [anon_sym_private] = ACTIONS(1144),
    [anon_sym_protected] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [anon_sym_any] = ACTIONS(1144),
    [anon_sym_number] = ACTIONS(1144),
    [anon_sym_boolean] = ACTIONS(1144),
    [anon_sym_string] = ACTIONS(1144),
    [anon_sym_symbol] = ACTIONS(1144),
    [anon_sym_interface] = ACTIONS(1144),
    [anon_sym_enum] = ACTIONS(1144),
    [sym_readonly] = ACTIONS(1144),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1142),
    [sym__automatic_semicolon] = ACTIONS(1142),
  },
  [477] = {
    [aux_sym_object_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(2606),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2606),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2606),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2608),
    [anon_sym_SQUOTE] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2606),
    [anon_sym_get] = ACTIONS(2606),
    [anon_sym_set] = ACTIONS(2606),
    [anon_sym_declare] = ACTIONS(2606),
    [anon_sym_public] = ACTIONS(2606),
    [anon_sym_private] = ACTIONS(2606),
    [anon_sym_protected] = ACTIONS(2606),
    [anon_sym_module] = ACTIONS(2606),
    [anon_sym_any] = ACTIONS(2606),
    [anon_sym_number] = ACTIONS(2606),
    [anon_sym_boolean] = ACTIONS(2606),
    [anon_sym_string] = ACTIONS(2606),
    [anon_sym_symbol] = ACTIONS(2606),
    [sym_readonly] = ACTIONS(2606),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [478] = {
    [sym__call_signature] = STATE(3205),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2570),
  },
  [479] = {
    [sym_object] = STATE(2291),
    [sym_array] = STATE(2292),
    [sym_nested_identifier] = STATE(3072),
    [sym_string] = STATE(451),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(3071),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2630),
    [sym_constructor_type] = STATE(2630),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2911),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2630),
    [sym_intersection_type] = STATE(2630),
    [sym_function_type] = STATE(2630),
    [aux_sym_export_statement_repeat1] = STATE(1759),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2638),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [sym_readonly] = ACTIONS(2644),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_namespace] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_import] = ACTIONS(1140),
    [anon_sym_var] = ACTIONS(1140),
    [anon_sym_let] = ACTIONS(1140),
    [anon_sym_const] = ACTIONS(1140),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_await] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(1140),
    [anon_sym_do] = ACTIONS(1140),
    [anon_sym_try] = ACTIONS(1140),
    [anon_sym_with] = ACTIONS(1140),
    [anon_sym_break] = ACTIONS(1140),
    [anon_sym_continue] = ACTIONS(1140),
    [anon_sym_debugger] = ACTIONS(1140),
    [anon_sym_return] = ACTIONS(1140),
    [anon_sym_throw] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_yield] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1138),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1140),
    [anon_sym_async] = ACTIONS(1140),
    [anon_sym_function] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_void] = ACTIONS(1140),
    [anon_sym_delete] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [sym_number] = ACTIONS(1138),
    [sym_this] = ACTIONS(1140),
    [sym_super] = ACTIONS(1140),
    [sym_true] = ACTIONS(1140),
    [sym_false] = ACTIONS(1140),
    [sym_null] = ACTIONS(1140),
    [sym_undefined] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_static] = ACTIONS(1140),
    [anon_sym_abstract] = ACTIONS(1140),
    [anon_sym_get] = ACTIONS(1140),
    [anon_sym_set] = ACTIONS(1140),
    [anon_sym_declare] = ACTIONS(1140),
    [anon_sym_public] = ACTIONS(1140),
    [anon_sym_private] = ACTIONS(1140),
    [anon_sym_protected] = ACTIONS(1140),
    [anon_sym_module] = ACTIONS(1140),
    [anon_sym_any] = ACTIONS(1140),
    [anon_sym_number] = ACTIONS(1140),
    [anon_sym_boolean] = ACTIONS(1140),
    [anon_sym_string] = ACTIONS(1140),
    [anon_sym_symbol] = ACTIONS(1140),
    [anon_sym_interface] = ACTIONS(1140),
    [anon_sym_enum] = ACTIONS(1140),
    [sym_readonly] = ACTIONS(1140),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1138),
    [sym__automatic_semicolon] = ACTIONS(1138),
  },
  [481] = {
    [sym_object] = STATE(2291),
    [sym_array] = STATE(2292),
    [sym_nested_identifier] = STATE(3072),
    [sym_string] = STATE(451),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(3071),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2616),
    [sym_constructor_type] = STATE(2616),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2911),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2616),
    [sym_intersection_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [aux_sym_export_statement_repeat1] = STATE(1759),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2638),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [sym_readonly] = ACTIONS(2644),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_export] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_namespace] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_COMMA] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_type] = ACTIONS(1108),
    [anon_sym_typeof] = ACTIONS(1108),
    [anon_sym_import] = ACTIONS(1108),
    [anon_sym_var] = ACTIONS(1108),
    [anon_sym_let] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_else] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_await] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_try] = ACTIONS(1108),
    [anon_sym_with] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_debugger] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_throw] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_yield] = ACTIONS(1108),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_class] = ACTIONS(1108),
    [anon_sym_async] = ACTIONS(1108),
    [anon_sym_function] = ACTIONS(1108),
    [anon_sym_new] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_void] = ACTIONS(1108),
    [anon_sym_delete] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1106),
    [sym_number] = ACTIONS(1106),
    [sym_this] = ACTIONS(1108),
    [sym_super] = ACTIONS(1108),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_undefined] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_abstract] = ACTIONS(1108),
    [anon_sym_get] = ACTIONS(1108),
    [anon_sym_set] = ACTIONS(1108),
    [anon_sym_declare] = ACTIONS(1108),
    [anon_sym_public] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym_protected] = ACTIONS(1108),
    [anon_sym_module] = ACTIONS(1108),
    [anon_sym_any] = ACTIONS(1108),
    [anon_sym_number] = ACTIONS(1108),
    [anon_sym_boolean] = ACTIONS(1108),
    [anon_sym_string] = ACTIONS(1108),
    [anon_sym_symbol] = ACTIONS(1108),
    [anon_sym_interface] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [sym_readonly] = ACTIONS(1108),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1106),
    [sym__automatic_semicolon] = ACTIONS(2646),
  },
  [483] = {
    [sym_type_arguments] = STATE(434),
    [ts_builtin_sym_end] = ACTIONS(2648),
    [sym_identifier] = ACTIONS(2650),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_default] = ACTIONS(2650),
    [anon_sym_namespace] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_type] = ACTIONS(2650),
    [anon_sym_typeof] = ACTIONS(2650),
    [anon_sym_import] = ACTIONS(2650),
    [anon_sym_var] = ACTIONS(2650),
    [anon_sym_let] = ACTIONS(2650),
    [anon_sym_const] = ACTIONS(2650),
    [anon_sym_if] = ACTIONS(2650),
    [anon_sym_else] = ACTIONS(2650),
    [anon_sym_switch] = ACTIONS(2650),
    [anon_sym_for] = ACTIONS(2650),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_await] = ACTIONS(2650),
    [anon_sym_while] = ACTIONS(2650),
    [anon_sym_do] = ACTIONS(2650),
    [anon_sym_try] = ACTIONS(2650),
    [anon_sym_with] = ACTIONS(2650),
    [anon_sym_break] = ACTIONS(2650),
    [anon_sym_continue] = ACTIONS(2650),
    [anon_sym_debugger] = ACTIONS(2650),
    [anon_sym_return] = ACTIONS(2650),
    [anon_sym_throw] = ACTIONS(2650),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2650),
    [anon_sym_yield] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2652),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_class] = ACTIONS(2650),
    [anon_sym_async] = ACTIONS(2650),
    [anon_sym_function] = ACTIONS(2650),
    [anon_sym_new] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_void] = ACTIONS(2650),
    [anon_sym_delete] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [anon_sym_DQUOTE] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2650),
    [sym_super] = ACTIONS(2650),
    [sym_true] = ACTIONS(2650),
    [sym_false] = ACTIONS(2650),
    [sym_null] = ACTIONS(2650),
    [sym_undefined] = ACTIONS(2650),
    [anon_sym_AT] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2650),
    [anon_sym_abstract] = ACTIONS(2650),
    [anon_sym_get] = ACTIONS(2650),
    [anon_sym_set] = ACTIONS(2650),
    [anon_sym_declare] = ACTIONS(2650),
    [anon_sym_public] = ACTIONS(2650),
    [anon_sym_private] = ACTIONS(2650),
    [anon_sym_protected] = ACTIONS(2650),
    [anon_sym_module] = ACTIONS(2650),
    [anon_sym_any] = ACTIONS(2650),
    [anon_sym_number] = ACTIONS(2650),
    [anon_sym_boolean] = ACTIONS(2650),
    [anon_sym_string] = ACTIONS(2650),
    [anon_sym_symbol] = ACTIONS(2650),
    [anon_sym_interface] = ACTIONS(2650),
    [anon_sym_enum] = ACTIONS(2650),
    [sym_readonly] = ACTIONS(2650),
  },
  [484] = {
    [sym_object] = STATE(2291),
    [sym_array] = STATE(2292),
    [sym_nested_identifier] = STATE(3072),
    [sym_string] = STATE(451),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(3071),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2701),
    [sym_constructor_type] = STATE(2701),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2911),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2701),
    [sym_intersection_type] = STATE(2701),
    [sym_function_type] = STATE(2701),
    [aux_sym_export_statement_repeat1] = STATE(1759),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2638),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [sym_readonly] = ACTIONS(2644),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [485] = {
    [aux_sym_object_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(2606),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2606),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2606),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2608),
    [anon_sym_SQUOTE] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2606),
    [anon_sym_get] = ACTIONS(2606),
    [anon_sym_set] = ACTIONS(2606),
    [anon_sym_declare] = ACTIONS(2606),
    [anon_sym_public] = ACTIONS(2606),
    [anon_sym_private] = ACTIONS(2606),
    [anon_sym_protected] = ACTIONS(2606),
    [anon_sym_module] = ACTIONS(2606),
    [anon_sym_any] = ACTIONS(2606),
    [anon_sym_number] = ACTIONS(2606),
    [anon_sym_boolean] = ACTIONS(2606),
    [anon_sym_string] = ACTIONS(2606),
    [anon_sym_symbol] = ACTIONS(2606),
    [sym_readonly] = ACTIONS(2606),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [486] = {
    [sym_object] = STATE(2291),
    [sym_array] = STATE(2292),
    [sym_nested_identifier] = STATE(3072),
    [sym_string] = STATE(451),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(3071),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2576),
    [sym_constructor_type] = STATE(2576),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2911),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym_function_type] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(1759),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2638),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [sym_readonly] = ACTIONS(2644),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [487] = {
    [sym__call_signature] = STATE(3014),
    [sym_arguments] = STATE(1425),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_function] = ACTIONS(2659),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_get] = ACTIONS(2657),
    [anon_sym_set] = ACTIONS(2657),
    [anon_sym_declare] = ACTIONS(2657),
    [anon_sym_public] = ACTIONS(2657),
    [anon_sym_private] = ACTIONS(2657),
    [anon_sym_protected] = ACTIONS(2657),
    [anon_sym_module] = ACTIONS(2657),
    [anon_sym_any] = ACTIONS(2657),
    [anon_sym_number] = ACTIONS(2657),
    [anon_sym_boolean] = ACTIONS(2657),
    [anon_sym_string] = ACTIONS(2657),
    [anon_sym_symbol] = ACTIONS(2657),
    [sym_readonly] = ACTIONS(2657),
    [sym__automatic_semicolon] = ACTIONS(525),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1276),
    [sym_identifier] = ACTIONS(1278),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_default] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1276),
    [anon_sym_RBRACE] = ACTIONS(1276),
    [anon_sym_type] = ACTIONS(1278),
    [anon_sym_typeof] = ACTIONS(1278),
    [anon_sym_import] = ACTIONS(1278),
    [anon_sym_var] = ACTIONS(1278),
    [anon_sym_let] = ACTIONS(1278),
    [anon_sym_const] = ACTIONS(1278),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_else] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(1278),
    [anon_sym_for] = ACTIONS(1278),
    [anon_sym_LPAREN] = ACTIONS(1276),
    [anon_sym_await] = ACTIONS(1278),
    [anon_sym_while] = ACTIONS(1278),
    [anon_sym_do] = ACTIONS(1278),
    [anon_sym_try] = ACTIONS(1278),
    [anon_sym_with] = ACTIONS(1278),
    [anon_sym_break] = ACTIONS(1278),
    [anon_sym_continue] = ACTIONS(1278),
    [anon_sym_debugger] = ACTIONS(1278),
    [anon_sym_return] = ACTIONS(1278),
    [anon_sym_throw] = ACTIONS(1278),
    [anon_sym_SEMI] = ACTIONS(1276),
    [anon_sym_case] = ACTIONS(1278),
    [anon_sym_yield] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_class] = ACTIONS(1278),
    [anon_sym_async] = ACTIONS(1278),
    [anon_sym_function] = ACTIONS(1278),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1276),
    [anon_sym_void] = ACTIONS(1278),
    [anon_sym_delete] = ACTIONS(1278),
    [anon_sym_PLUS_PLUS] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1276),
    [sym_number] = ACTIONS(1276),
    [sym_this] = ACTIONS(1278),
    [sym_super] = ACTIONS(1278),
    [sym_true] = ACTIONS(1278),
    [sym_false] = ACTIONS(1278),
    [sym_null] = ACTIONS(1278),
    [sym_undefined] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1276),
    [anon_sym_static] = ACTIONS(1278),
    [anon_sym_abstract] = ACTIONS(1278),
    [anon_sym_get] = ACTIONS(1278),
    [anon_sym_set] = ACTIONS(1278),
    [anon_sym_declare] = ACTIONS(1278),
    [anon_sym_public] = ACTIONS(1278),
    [anon_sym_private] = ACTIONS(1278),
    [anon_sym_protected] = ACTIONS(1278),
    [anon_sym_module] = ACTIONS(1278),
    [anon_sym_any] = ACTIONS(1278),
    [anon_sym_number] = ACTIONS(1278),
    [anon_sym_boolean] = ACTIONS(1278),
    [anon_sym_string] = ACTIONS(1278),
    [anon_sym_symbol] = ACTIONS(1278),
    [anon_sym_interface] = ACTIONS(1278),
    [anon_sym_enum] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1278),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1276),
    [sym__automatic_semicolon] = ACTIONS(1276),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(1216),
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_export] = ACTIONS(1218),
    [anon_sym_default] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_type] = ACTIONS(1218),
    [anon_sym_typeof] = ACTIONS(1218),
    [anon_sym_import] = ACTIONS(1218),
    [anon_sym_var] = ACTIONS(1218),
    [anon_sym_let] = ACTIONS(1218),
    [anon_sym_const] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_else] = ACTIONS(1218),
    [anon_sym_switch] = ACTIONS(1218),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_await] = ACTIONS(1218),
    [anon_sym_while] = ACTIONS(1218),
    [anon_sym_do] = ACTIONS(1218),
    [anon_sym_try] = ACTIONS(1218),
    [anon_sym_with] = ACTIONS(1218),
    [anon_sym_break] = ACTIONS(1218),
    [anon_sym_continue] = ACTIONS(1218),
    [anon_sym_debugger] = ACTIONS(1218),
    [anon_sym_return] = ACTIONS(1218),
    [anon_sym_throw] = ACTIONS(1218),
    [anon_sym_SEMI] = ACTIONS(1216),
    [anon_sym_case] = ACTIONS(1218),
    [anon_sym_yield] = ACTIONS(1218),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_LT] = ACTIONS(1216),
    [anon_sym_SLASH] = ACTIONS(1218),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(1218),
    [anon_sym_async] = ACTIONS(1218),
    [anon_sym_function] = ACTIONS(1218),
    [anon_sym_new] = ACTIONS(1218),
    [anon_sym_AMP] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1216),
    [anon_sym_void] = ACTIONS(1218),
    [anon_sym_delete] = ACTIONS(1218),
    [anon_sym_PLUS_PLUS] = ACTIONS(1216),
    [anon_sym_DASH_DASH] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(1216),
    [anon_sym_SQUOTE] = ACTIONS(1216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [sym_number] = ACTIONS(1216),
    [sym_this] = ACTIONS(1218),
    [sym_super] = ACTIONS(1218),
    [sym_true] = ACTIONS(1218),
    [sym_false] = ACTIONS(1218),
    [sym_null] = ACTIONS(1218),
    [sym_undefined] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_static] = ACTIONS(1218),
    [anon_sym_abstract] = ACTIONS(1218),
    [anon_sym_get] = ACTIONS(1218),
    [anon_sym_set] = ACTIONS(1218),
    [anon_sym_declare] = ACTIONS(1218),
    [anon_sym_public] = ACTIONS(1218),
    [anon_sym_private] = ACTIONS(1218),
    [anon_sym_protected] = ACTIONS(1218),
    [anon_sym_module] = ACTIONS(1218),
    [anon_sym_any] = ACTIONS(1218),
    [anon_sym_number] = ACTIONS(1218),
    [anon_sym_boolean] = ACTIONS(1218),
    [anon_sym_string] = ACTIONS(1218),
    [anon_sym_symbol] = ACTIONS(1218),
    [anon_sym_interface] = ACTIONS(1218),
    [anon_sym_enum] = ACTIONS(1218),
    [sym_readonly] = ACTIONS(1218),
  },
  [490] = {
    [sym_object] = STATE(2291),
    [sym_array] = STATE(2292),
    [sym_nested_identifier] = STATE(3072),
    [sym_string] = STATE(451),
    [sym_decorator] = STATE(1866),
    [sym_formal_parameters] = STATE(3071),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1894),
    [sym_accessibility_modifier] = STATE(1867),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2086),
    [sym__type] = STATE(2695),
    [sym_constructor_type] = STATE(2695),
    [sym__primary_type] = STATE(455),
    [sym_generic_type] = STATE(455),
    [sym_type_predicate] = STATE(455),
    [sym_type_query] = STATE(455),
    [sym_index_type_query] = STATE(455),
    [sym_lookup_type] = STATE(455),
    [sym_literal_type] = STATE(455),
    [sym__number] = STATE(451),
    [sym_existential_type] = STATE(455),
    [sym_flow_maybe_type] = STATE(455),
    [sym_parenthesized_type] = STATE(455),
    [sym_predefined_type] = STATE(455),
    [sym_object_type] = STATE(455),
    [sym_type_parameters] = STATE(2911),
    [sym_array_type] = STATE(455),
    [sym_tuple_type] = STATE(455),
    [sym_union_type] = STATE(2695),
    [sym_intersection_type] = STATE(2695),
    [sym_function_type] = STATE(2695),
    [aux_sym_export_statement_repeat1] = STATE(1759),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(822),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2638),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [sym_readonly] = ACTIONS(2644),
    [anon_sym_keyof] = ACTIONS(848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(1144),
    [anon_sym_default] = ACTIONS(1144),
    [anon_sym_namespace] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_var] = ACTIONS(1144),
    [anon_sym_let] = ACTIONS(1144),
    [anon_sym_const] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_switch] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_await] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_do] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_debugger] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1144),
    [anon_sym_catch] = ACTIONS(1144),
    [anon_sym_finally] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_function] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [sym_number] = ACTIONS(1142),
    [sym_this] = ACTIONS(1144),
    [sym_super] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_null] = ACTIONS(1144),
    [sym_undefined] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_get] = ACTIONS(1144),
    [anon_sym_set] = ACTIONS(1144),
    [anon_sym_declare] = ACTIONS(1144),
    [anon_sym_public] = ACTIONS(1144),
    [anon_sym_private] = ACTIONS(1144),
    [anon_sym_protected] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [anon_sym_any] = ACTIONS(1144),
    [anon_sym_number] = ACTIONS(1144),
    [anon_sym_boolean] = ACTIONS(1144),
    [anon_sym_string] = ACTIONS(1144),
    [anon_sym_symbol] = ACTIONS(1144),
    [anon_sym_interface] = ACTIONS(1144),
    [anon_sym_enum] = ACTIONS(1144),
    [sym_readonly] = ACTIONS(1144),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(1276),
    [sym_identifier] = ACTIONS(1278),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_default] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1276),
    [anon_sym_RBRACE] = ACTIONS(1276),
    [anon_sym_type] = ACTIONS(1278),
    [anon_sym_typeof] = ACTIONS(1278),
    [anon_sym_import] = ACTIONS(1278),
    [anon_sym_var] = ACTIONS(1278),
    [anon_sym_let] = ACTIONS(1278),
    [anon_sym_const] = ACTIONS(1278),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_else] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(1278),
    [anon_sym_for] = ACTIONS(1278),
    [anon_sym_LPAREN] = ACTIONS(1276),
    [anon_sym_await] = ACTIONS(1278),
    [anon_sym_while] = ACTIONS(1278),
    [anon_sym_do] = ACTIONS(1278),
    [anon_sym_try] = ACTIONS(1278),
    [anon_sym_with] = ACTIONS(1278),
    [anon_sym_break] = ACTIONS(1278),
    [anon_sym_continue] = ACTIONS(1278),
    [anon_sym_debugger] = ACTIONS(1278),
    [anon_sym_return] = ACTIONS(1278),
    [anon_sym_throw] = ACTIONS(1278),
    [anon_sym_SEMI] = ACTIONS(1276),
    [anon_sym_case] = ACTIONS(1278),
    [anon_sym_catch] = ACTIONS(1278),
    [anon_sym_finally] = ACTIONS(1278),
    [anon_sym_yield] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_class] = ACTIONS(1278),
    [anon_sym_async] = ACTIONS(1278),
    [anon_sym_function] = ACTIONS(1278),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1276),
    [anon_sym_void] = ACTIONS(1278),
    [anon_sym_delete] = ACTIONS(1278),
    [anon_sym_PLUS_PLUS] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1276),
    [sym_number] = ACTIONS(1276),
    [sym_this] = ACTIONS(1278),
    [sym_super] = ACTIONS(1278),
    [sym_true] = ACTIONS(1278),
    [sym_false] = ACTIONS(1278),
    [sym_null] = ACTIONS(1278),
    [sym_undefined] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1276),
    [anon_sym_static] = ACTIONS(1278),
    [anon_sym_abstract] = ACTIONS(1278),
    [anon_sym_get] = ACTIONS(1278),
    [anon_sym_set] = ACTIONS(1278),
    [anon_sym_declare] = ACTIONS(1278),
    [anon_sym_public] = ACTIONS(1278),
    [anon_sym_private] = ACTIONS(1278),
    [anon_sym_protected] = ACTIONS(1278),
    [anon_sym_module] = ACTIONS(1278),
    [anon_sym_any] = ACTIONS(1278),
    [anon_sym_number] = ACTIONS(1278),
    [anon_sym_boolean] = ACTIONS(1278),
    [anon_sym_string] = ACTIONS(1278),
    [anon_sym_symbol] = ACTIONS(1278),
    [anon_sym_interface] = ACTIONS(1278),
    [anon_sym_enum] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1278),
  },
  [493] = {
    [aux_sym_object_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(2606),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2606),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_type] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2606),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2608),
    [anon_sym_SQUOTE] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2606),
    [anon_sym_get] = ACTIONS(2606),
    [anon_sym_set] = ACTIONS(2606),
    [anon_sym_declare] = ACTIONS(2606),
    [anon_sym_public] = ACTIONS(2606),
    [anon_sym_private] = ACTIONS(2606),
    [anon_sym_protected] = ACTIONS(2606),
    [anon_sym_module] = ACTIONS(2606),
    [anon_sym_any] = ACTIONS(2606),
    [anon_sym_number] = ACTIONS(2606),
    [anon_sym_boolean] = ACTIONS(2606),
    [anon_sym_string] = ACTIONS(2606),
    [anon_sym_symbol] = ACTIONS(2606),
    [sym_readonly] = ACTIONS(2606),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [494] = {
    [sym_statement_block] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_export] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_namespace] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_var] = ACTIONS(1100),
    [anon_sym_let] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1098),
    [anon_sym_await] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_debugger] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_throw] = ACTIONS(1100),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_LT] = ACTIONS(1098),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_function] = ACTIONS(1100),
    [anon_sym_new] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_void] = ACTIONS(1100),
    [anon_sym_delete] = ACTIONS(1100),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1098),
    [sym_number] = ACTIONS(1098),
    [sym_this] = ACTIONS(1100),
    [sym_super] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_undefined] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_abstract] = ACTIONS(1100),
    [anon_sym_get] = ACTIONS(1100),
    [anon_sym_set] = ACTIONS(1100),
    [anon_sym_declare] = ACTIONS(1100),
    [anon_sym_public] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym_protected] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [anon_sym_any] = ACTIONS(1100),
    [anon_sym_number] = ACTIONS(1100),
    [anon_sym_boolean] = ACTIONS(1100),
    [anon_sym_string] = ACTIONS(1100),
    [anon_sym_symbol] = ACTIONS(1100),
    [anon_sym_interface] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [sym_readonly] = ACTIONS(1100),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_export] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_type] = ACTIONS(2665),
    [anon_sym_typeof] = ACTIONS(2665),
    [anon_sym_import] = ACTIONS(2665),
    [anon_sym_var] = ACTIONS(2665),
    [anon_sym_let] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_LPAREN] = ACTIONS(2663),
    [anon_sym_await] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_with] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_debugger] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_yield] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2663),
    [anon_sym_LT] = ACTIONS(2663),
    [anon_sym_SLASH] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_async] = ACTIONS(2665),
    [anon_sym_function] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_void] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2663),
    [sym_number] = ACTIONS(2663),
    [sym_this] = ACTIONS(2665),
    [sym_super] = ACTIONS(2665),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [sym_null] = ACTIONS(2665),
    [sym_undefined] = ACTIONS(2665),
    [anon_sym_AT] = ACTIONS(2663),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_abstract] = ACTIONS(2665),
    [anon_sym_get] = ACTIONS(2665),
    [anon_sym_set] = ACTIONS(2665),
    [anon_sym_declare] = ACTIONS(2665),
    [anon_sym_public] = ACTIONS(2665),
    [anon_sym_private] = ACTIONS(2665),
    [anon_sym_protected] = ACTIONS(2665),
    [anon_sym_module] = ACTIONS(2665),
    [anon_sym_any] = ACTIONS(2665),
    [anon_sym_number] = ACTIONS(2665),
    [anon_sym_boolean] = ACTIONS(2665),
    [anon_sym_string] = ACTIONS(2665),
    [anon_sym_symbol] = ACTIONS(2665),
    [anon_sym_interface] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [sym_readonly] = ACTIONS(2665),
  },
  [496] = {
    [sym__call_signature] = STATE(3014),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_function] = ACTIONS(2439),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_get] = ACTIONS(2657),
    [anon_sym_set] = ACTIONS(2657),
    [anon_sym_declare] = ACTIONS(2657),
    [anon_sym_public] = ACTIONS(2657),
    [anon_sym_private] = ACTIONS(2657),
    [anon_sym_protected] = ACTIONS(2657),
    [anon_sym_module] = ACTIONS(2657),
    [anon_sym_any] = ACTIONS(2657),
    [anon_sym_number] = ACTIONS(2657),
    [anon_sym_boolean] = ACTIONS(2657),
    [anon_sym_string] = ACTIONS(2657),
    [anon_sym_symbol] = ACTIONS(2657),
    [sym_readonly] = ACTIONS(2657),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_export] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_type] = ACTIONS(2673),
    [anon_sym_typeof] = ACTIONS(2673),
    [anon_sym_import] = ACTIONS(2673),
    [anon_sym_var] = ACTIONS(2673),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2671),
    [anon_sym_await] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_with] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_debugger] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_yield] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2671),
    [anon_sym_SLASH] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_function] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [sym_number] = ACTIONS(2671),
    [sym_this] = ACTIONS(2673),
    [sym_super] = ACTIONS(2673),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_AT] = ACTIONS(2671),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_abstract] = ACTIONS(2673),
    [anon_sym_get] = ACTIONS(2673),
    [anon_sym_set] = ACTIONS(2673),
    [anon_sym_declare] = ACTIONS(2673),
    [anon_sym_public] = ACTIONS(2673),
    [anon_sym_private] = ACTIONS(2673),
    [anon_sym_protected] = ACTIONS(2673),
    [anon_sym_module] = ACTIONS(2673),
    [anon_sym_any] = ACTIONS(2673),
    [anon_sym_number] = ACTIONS(2673),
    [anon_sym_boolean] = ACTIONS(2673),
    [anon_sym_string] = ACTIONS(2673),
    [anon_sym_symbol] = ACTIONS(2673),
    [anon_sym_interface] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [sym_readonly] = ACTIONS(2673),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(2675),
    [sym_identifier] = ACTIONS(2677),
    [anon_sym_export] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_type] = ACTIONS(2677),
    [anon_sym_typeof] = ACTIONS(2677),
    [anon_sym_import] = ACTIONS(2677),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_await] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_with] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_debugger] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_LT] = ACTIONS(2675),
    [anon_sym_SLASH] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_async] = ACTIONS(2677),
    [anon_sym_function] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_void] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2675),
    [sym_number] = ACTIONS(2675),
    [sym_this] = ACTIONS(2677),
    [sym_super] = ACTIONS(2677),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [sym_null] = ACTIONS(2677),
    [sym_undefined] = ACTIONS(2677),
    [anon_sym_AT] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(2677),
    [anon_sym_get] = ACTIONS(2677),
    [anon_sym_set] = ACTIONS(2677),
    [anon_sym_declare] = ACTIONS(2677),
    [anon_sym_public] = ACTIONS(2677),
    [anon_sym_private] = ACTIONS(2677),
    [anon_sym_protected] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2677),
    [anon_sym_number] = ACTIONS(2677),
    [anon_sym_boolean] = ACTIONS(2677),
    [anon_sym_string] = ACTIONS(2677),
    [anon_sym_symbol] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [sym_readonly] = ACTIONS(2677),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_type] = ACTIONS(2681),
    [anon_sym_typeof] = ACTIONS(2681),
    [anon_sym_import] = ACTIONS(2681),
    [anon_sym_var] = ACTIONS(2681),
    [anon_sym_let] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_LPAREN] = ACTIONS(2679),
    [anon_sym_await] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_with] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_debugger] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_LT] = ACTIONS(2679),
    [anon_sym_SLASH] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_function] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_void] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2679),
    [sym_number] = ACTIONS(2679),
    [sym_this] = ACTIONS(2681),
    [sym_super] = ACTIONS(2681),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [sym_null] = ACTIONS(2681),
    [sym_undefined] = ACTIONS(2681),
    [anon_sym_AT] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_abstract] = ACTIONS(2681),
    [anon_sym_get] = ACTIONS(2681),
    [anon_sym_set] = ACTIONS(2681),
    [anon_sym_declare] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_module] = ACTIONS(2681),
    [anon_sym_any] = ACTIONS(2681),
    [anon_sym_number] = ACTIONS(2681),
    [anon_sym_boolean] = ACTIONS(2681),
    [anon_sym_string] = ACTIONS(2681),
    [anon_sym_symbol] = ACTIONS(2681),
    [anon_sym_interface] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [sym_readonly] = ACTIONS(2681),
  },
  [500] = {
    [sym__call_signature] = STATE(3045),
    [sym_arguments] = STATE(1173),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_export] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2685),
    [anon_sym_public] = ACTIONS(2685),
    [anon_sym_private] = ACTIONS(2685),
    [anon_sym_protected] = ACTIONS(2685),
    [anon_sym_module] = ACTIONS(2685),
    [anon_sym_any] = ACTIONS(2685),
    [anon_sym_number] = ACTIONS(2685),
    [anon_sym_boolean] = ACTIONS(2685),
    [anon_sym_string] = ACTIONS(2685),
    [anon_sym_symbol] = ACTIONS(2685),
    [sym_readonly] = ACTIONS(2685),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_export] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_type] = ACTIONS(2689),
    [anon_sym_typeof] = ACTIONS(2689),
    [anon_sym_import] = ACTIONS(2689),
    [anon_sym_var] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_else] = ACTIONS(2689),
    [anon_sym_switch] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_LPAREN] = ACTIONS(2687),
    [anon_sym_await] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_with] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_debugger] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_throw] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2689),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_SLASH] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_async] = ACTIONS(2689),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_void] = ACTIONS(2689),
    [anon_sym_delete] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2687),
    [anon_sym_DQUOTE] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2687),
    [sym_number] = ACTIONS(2687),
    [sym_this] = ACTIONS(2689),
    [sym_super] = ACTIONS(2689),
    [sym_true] = ACTIONS(2689),
    [sym_false] = ACTIONS(2689),
    [sym_null] = ACTIONS(2689),
    [sym_undefined] = ACTIONS(2689),
    [anon_sym_AT] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_abstract] = ACTIONS(2689),
    [anon_sym_get] = ACTIONS(2689),
    [anon_sym_set] = ACTIONS(2689),
    [anon_sym_declare] = ACTIONS(2689),
    [anon_sym_public] = ACTIONS(2689),
    [anon_sym_private] = ACTIONS(2689),
    [anon_sym_protected] = ACTIONS(2689),
    [anon_sym_module] = ACTIONS(2689),
    [anon_sym_any] = ACTIONS(2689),
    [anon_sym_number] = ACTIONS(2689),
    [anon_sym_boolean] = ACTIONS(2689),
    [anon_sym_string] = ACTIONS(2689),
    [anon_sym_symbol] = ACTIONS(2689),
    [anon_sym_interface] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [sym_readonly] = ACTIONS(2689),
  },
  [502] = {
    [sym__call_signature] = STATE(3014),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_function] = ACTIONS(2691),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_get] = ACTIONS(2657),
    [anon_sym_set] = ACTIONS(2657),
    [anon_sym_declare] = ACTIONS(2657),
    [anon_sym_public] = ACTIONS(2657),
    [anon_sym_private] = ACTIONS(2657),
    [anon_sym_protected] = ACTIONS(2657),
    [anon_sym_module] = ACTIONS(2657),
    [anon_sym_any] = ACTIONS(2657),
    [anon_sym_number] = ACTIONS(2657),
    [anon_sym_boolean] = ACTIONS(2657),
    [anon_sym_string] = ACTIONS(2657),
    [anon_sym_symbol] = ACTIONS(2657),
    [sym_readonly] = ACTIONS(2657),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(2693),
    [sym_identifier] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2693),
    [anon_sym_type] = ACTIONS(2695),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_import] = ACTIONS(2695),
    [anon_sym_var] = ACTIONS(2695),
    [anon_sym_let] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_await] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_with] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_debugger] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_yield] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_SLASH] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_async] = ACTIONS(2695),
    [anon_sym_function] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_void] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2693),
    [sym_number] = ACTIONS(2693),
    [sym_this] = ACTIONS(2695),
    [sym_super] = ACTIONS(2695),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [sym_null] = ACTIONS(2695),
    [sym_undefined] = ACTIONS(2695),
    [anon_sym_AT] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_abstract] = ACTIONS(2695),
    [anon_sym_get] = ACTIONS(2695),
    [anon_sym_set] = ACTIONS(2695),
    [anon_sym_declare] = ACTIONS(2695),
    [anon_sym_public] = ACTIONS(2695),
    [anon_sym_private] = ACTIONS(2695),
    [anon_sym_protected] = ACTIONS(2695),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_any] = ACTIONS(2695),
    [anon_sym_number] = ACTIONS(2695),
    [anon_sym_boolean] = ACTIONS(2695),
    [anon_sym_string] = ACTIONS(2695),
    [anon_sym_symbol] = ACTIONS(2695),
    [anon_sym_interface] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [sym_readonly] = ACTIONS(2695),
  },
  [504] = {
    [sym__call_signature] = STATE(3014),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_function] = ACTIONS(2659),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_get] = ACTIONS(2657),
    [anon_sym_set] = ACTIONS(2657),
    [anon_sym_declare] = ACTIONS(2657),
    [anon_sym_public] = ACTIONS(2657),
    [anon_sym_private] = ACTIONS(2657),
    [anon_sym_protected] = ACTIONS(2657),
    [anon_sym_module] = ACTIONS(2657),
    [anon_sym_any] = ACTIONS(2657),
    [anon_sym_number] = ACTIONS(2657),
    [anon_sym_boolean] = ACTIONS(2657),
    [anon_sym_string] = ACTIONS(2657),
    [anon_sym_symbol] = ACTIONS(2657),
    [sym_readonly] = ACTIONS(2657),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [505] = {
    [sym__call_signature] = STATE(2997),
    [sym_arguments] = STATE(1642),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_export] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(2701),
    [anon_sym_async] = ACTIONS(2699),
    [anon_sym_function] = ACTIONS(2703),
    [anon_sym_EQ_GT] = ACTIONS(697),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_get] = ACTIONS(2699),
    [anon_sym_set] = ACTIONS(2699),
    [anon_sym_declare] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_module] = ACTIONS(2699),
    [anon_sym_any] = ACTIONS(2699),
    [anon_sym_number] = ACTIONS(2699),
    [anon_sym_boolean] = ACTIONS(2699),
    [anon_sym_string] = ACTIONS(2699),
    [anon_sym_symbol] = ACTIONS(2699),
    [sym_readonly] = ACTIONS(2699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [506] = {
    [sym_finally_clause] = STATE(597),
    [ts_builtin_sym_end] = ACTIONS(2705),
    [sym_identifier] = ACTIONS(2707),
    [anon_sym_export] = ACTIONS(2707),
    [anon_sym_default] = ACTIONS(2707),
    [anon_sym_namespace] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_type] = ACTIONS(2707),
    [anon_sym_typeof] = ACTIONS(2707),
    [anon_sym_import] = ACTIONS(2707),
    [anon_sym_var] = ACTIONS(2707),
    [anon_sym_let] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [anon_sym_switch] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(2705),
    [anon_sym_await] = ACTIONS(2707),
    [anon_sym_while] = ACTIONS(2707),
    [anon_sym_do] = ACTIONS(2707),
    [anon_sym_try] = ACTIONS(2707),
    [anon_sym_with] = ACTIONS(2707),
    [anon_sym_break] = ACTIONS(2707),
    [anon_sym_continue] = ACTIONS(2707),
    [anon_sym_debugger] = ACTIONS(2707),
    [anon_sym_return] = ACTIONS(2707),
    [anon_sym_throw] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2707),
    [anon_sym_finally] = ACTIONS(2596),
    [anon_sym_yield] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_SLASH] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2707),
    [anon_sym_async] = ACTIONS(2707),
    [anon_sym_function] = ACTIONS(2707),
    [anon_sym_new] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_void] = ACTIONS(2707),
    [anon_sym_delete] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2705),
    [sym_number] = ACTIONS(2705),
    [sym_this] = ACTIONS(2707),
    [sym_super] = ACTIONS(2707),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [sym_null] = ACTIONS(2707),
    [sym_undefined] = ACTIONS(2707),
    [anon_sym_AT] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2707),
    [anon_sym_abstract] = ACTIONS(2707),
    [anon_sym_get] = ACTIONS(2707),
    [anon_sym_set] = ACTIONS(2707),
    [anon_sym_declare] = ACTIONS(2707),
    [anon_sym_public] = ACTIONS(2707),
    [anon_sym_private] = ACTIONS(2707),
    [anon_sym_protected] = ACTIONS(2707),
    [anon_sym_module] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(2707),
    [anon_sym_number] = ACTIONS(2707),
    [anon_sym_boolean] = ACTIONS(2707),
    [anon_sym_string] = ACTIONS(2707),
    [anon_sym_symbol] = ACTIONS(2707),
    [anon_sym_interface] = ACTIONS(2707),
    [anon_sym_enum] = ACTIONS(2707),
    [sym_readonly] = ACTIONS(2707),
  },
  [507] = {
    [sym__call_signature] = STATE(3014),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(627),
    [anon_sym_of] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_function] = ACTIONS(2659),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_get] = ACTIONS(2657),
    [anon_sym_set] = ACTIONS(2657),
    [anon_sym_declare] = ACTIONS(2657),
    [anon_sym_public] = ACTIONS(2657),
    [anon_sym_private] = ACTIONS(2657),
    [anon_sym_protected] = ACTIONS(2657),
    [anon_sym_module] = ACTIONS(2657),
    [anon_sym_any] = ACTIONS(2657),
    [anon_sym_number] = ACTIONS(2657),
    [anon_sym_boolean] = ACTIONS(2657),
    [anon_sym_string] = ACTIONS(2657),
    [anon_sym_symbol] = ACTIONS(2657),
    [sym_readonly] = ACTIONS(2657),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [508] = {
    [sym__call_signature] = STATE(3014),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_function] = ACTIONS(2691),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_get] = ACTIONS(2657),
    [anon_sym_set] = ACTIONS(2657),
    [anon_sym_declare] = ACTIONS(2657),
    [anon_sym_public] = ACTIONS(2657),
    [anon_sym_private] = ACTIONS(2657),
    [anon_sym_protected] = ACTIONS(2657),
    [anon_sym_module] = ACTIONS(2657),
    [anon_sym_any] = ACTIONS(2657),
    [anon_sym_number] = ACTIONS(2657),
    [anon_sym_boolean] = ACTIONS(2657),
    [anon_sym_string] = ACTIONS(2657),
    [anon_sym_symbol] = ACTIONS(2657),
    [sym_readonly] = ACTIONS(2657),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [509] = {
    [sym__call_signature] = STATE(3020),
    [sym_arguments] = STATE(1173),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_export] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(2711),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2711),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(657),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_get] = ACTIONS(2711),
    [anon_sym_set] = ACTIONS(2711),
    [anon_sym_declare] = ACTIONS(2711),
    [anon_sym_public] = ACTIONS(2711),
    [anon_sym_private] = ACTIONS(2711),
    [anon_sym_protected] = ACTIONS(2711),
    [anon_sym_module] = ACTIONS(2711),
    [anon_sym_any] = ACTIONS(2711),
    [anon_sym_number] = ACTIONS(2711),
    [anon_sym_boolean] = ACTIONS(2711),
    [anon_sym_string] = ACTIONS(2711),
    [anon_sym_symbol] = ACTIONS(2711),
    [anon_sym_implements] = ACTIONS(517),
    [sym_readonly] = ACTIONS(2711),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_export] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1242),
    [anon_sym_import] = ACTIONS(1242),
    [anon_sym_var] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [anon_sym_switch] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_await] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_do] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [anon_sym_with] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_debugger] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_throw] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_case] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LT] = ACTIONS(1240),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_class] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_function] = ACTIONS(1242),
    [anon_sym_new] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1240),
    [anon_sym_void] = ACTIONS(1242),
    [anon_sym_delete] = ACTIONS(1242),
    [anon_sym_PLUS_PLUS] = ACTIONS(1240),
    [anon_sym_DASH_DASH] = ACTIONS(1240),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1240),
    [sym_number] = ACTIONS(1240),
    [sym_this] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_true] = ACTIONS(1242),
    [sym_false] = ACTIONS(1242),
    [sym_null] = ACTIONS(1242),
    [sym_undefined] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1240),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_abstract] = ACTIONS(1242),
    [anon_sym_get] = ACTIONS(1242),
    [anon_sym_set] = ACTIONS(1242),
    [anon_sym_declare] = ACTIONS(1242),
    [anon_sym_public] = ACTIONS(1242),
    [anon_sym_private] = ACTIONS(1242),
    [anon_sym_protected] = ACTIONS(1242),
    [anon_sym_module] = ACTIONS(1242),
    [anon_sym_any] = ACTIONS(1242),
    [anon_sym_number] = ACTIONS(1242),
    [anon_sym_boolean] = ACTIONS(1242),
    [anon_sym_string] = ACTIONS(1242),
    [anon_sym_symbol] = ACTIONS(1242),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [sym_readonly] = ACTIONS(1242),
    [sym__automatic_semicolon] = ACTIONS(1248),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1186),
    [sym_identifier] = ACTIONS(1188),
    [anon_sym_export] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1188),
    [anon_sym_namespace] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [anon_sym_type] = ACTIONS(1188),
    [anon_sym_typeof] = ACTIONS(1188),
    [anon_sym_import] = ACTIONS(1188),
    [anon_sym_var] = ACTIONS(1188),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_if] = ACTIONS(1188),
    [anon_sym_else] = ACTIONS(1188),
    [anon_sym_switch] = ACTIONS(1188),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_await] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1188),
    [anon_sym_do] = ACTIONS(1188),
    [anon_sym_try] = ACTIONS(1188),
    [anon_sym_with] = ACTIONS(1188),
    [anon_sym_break] = ACTIONS(1188),
    [anon_sym_continue] = ACTIONS(1188),
    [anon_sym_debugger] = ACTIONS(1188),
    [anon_sym_return] = ACTIONS(1188),
    [anon_sym_throw] = ACTIONS(1188),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_case] = ACTIONS(1188),
    [anon_sym_yield] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1188),
    [anon_sym_class] = ACTIONS(1188),
    [anon_sym_async] = ACTIONS(1188),
    [anon_sym_function] = ACTIONS(1188),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_void] = ACTIONS(1188),
    [anon_sym_delete] = ACTIONS(1188),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [anon_sym_SQUOTE] = ACTIONS(1186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1186),
    [sym_number] = ACTIONS(1186),
    [sym_this] = ACTIONS(1188),
    [sym_super] = ACTIONS(1188),
    [sym_true] = ACTIONS(1188),
    [sym_false] = ACTIONS(1188),
    [sym_null] = ACTIONS(1188),
    [sym_undefined] = ACTIONS(1188),
    [anon_sym_AT] = ACTIONS(1186),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_abstract] = ACTIONS(1188),
    [anon_sym_get] = ACTIONS(1188),
    [anon_sym_set] = ACTIONS(1188),
    [anon_sym_declare] = ACTIONS(1188),
    [anon_sym_public] = ACTIONS(1188),
    [anon_sym_private] = ACTIONS(1188),
    [anon_sym_protected] = ACTIONS(1188),
    [anon_sym_module] = ACTIONS(1188),
    [anon_sym_any] = ACTIONS(1188),
    [anon_sym_number] = ACTIONS(1188),
    [anon_sym_boolean] = ACTIONS(1188),
    [anon_sym_string] = ACTIONS(1188),
    [anon_sym_symbol] = ACTIONS(1188),
    [anon_sym_interface] = ACTIONS(1188),
    [anon_sym_enum] = ACTIONS(1188),
    [sym_readonly] = ACTIONS(1188),
    [sym__automatic_semicolon] = ACTIONS(1194),
  },
  [512] = {
    [sym__call_signature] = STATE(3205),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2570),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1128),
    [sym_identifier] = ACTIONS(1130),
    [anon_sym_export] = ACTIONS(1130),
    [anon_sym_default] = ACTIONS(1130),
    [anon_sym_namespace] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1128),
    [anon_sym_RBRACE] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1130),
    [anon_sym_import] = ACTIONS(1130),
    [anon_sym_var] = ACTIONS(1130),
    [anon_sym_let] = ACTIONS(1130),
    [anon_sym_const] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1130),
    [anon_sym_else] = ACTIONS(1130),
    [anon_sym_switch] = ACTIONS(1130),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_LPAREN] = ACTIONS(1128),
    [anon_sym_await] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1130),
    [anon_sym_do] = ACTIONS(1130),
    [anon_sym_try] = ACTIONS(1130),
    [anon_sym_with] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_debugger] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_throw] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1128),
    [anon_sym_case] = ACTIONS(1130),
    [anon_sym_yield] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(1128),
    [anon_sym_SLASH] = ACTIONS(1130),
    [anon_sym_class] = ACTIONS(1130),
    [anon_sym_async] = ACTIONS(1130),
    [anon_sym_function] = ACTIONS(1130),
    [anon_sym_new] = ACTIONS(1130),
    [anon_sym_PLUS] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1130),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1128),
    [anon_sym_void] = ACTIONS(1130),
    [anon_sym_delete] = ACTIONS(1130),
    [anon_sym_PLUS_PLUS] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1128),
    [anon_sym_DQUOTE] = ACTIONS(1128),
    [anon_sym_SQUOTE] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1128),
    [sym_number] = ACTIONS(1128),
    [sym_this] = ACTIONS(1130),
    [sym_super] = ACTIONS(1130),
    [sym_true] = ACTIONS(1130),
    [sym_false] = ACTIONS(1130),
    [sym_null] = ACTIONS(1130),
    [sym_undefined] = ACTIONS(1130),
    [anon_sym_AT] = ACTIONS(1128),
    [anon_sym_static] = ACTIONS(1130),
    [anon_sym_abstract] = ACTIONS(1130),
    [anon_sym_get] = ACTIONS(1130),
    [anon_sym_set] = ACTIONS(1130),
    [anon_sym_declare] = ACTIONS(1130),
    [anon_sym_public] = ACTIONS(1130),
    [anon_sym_private] = ACTIONS(1130),
    [anon_sym_protected] = ACTIONS(1130),
    [anon_sym_module] = ACTIONS(1130),
    [anon_sym_any] = ACTIONS(1130),
    [anon_sym_number] = ACTIONS(1130),
    [anon_sym_boolean] = ACTIONS(1130),
    [anon_sym_string] = ACTIONS(1130),
    [anon_sym_symbol] = ACTIONS(1130),
    [anon_sym_interface] = ACTIONS(1130),
    [anon_sym_enum] = ACTIONS(1130),
    [sym_readonly] = ACTIONS(1130),
    [sym__automatic_semicolon] = ACTIONS(1136),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_export] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_namespace] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_typeof] = ACTIONS(1208),
    [anon_sym_import] = ACTIONS(1208),
    [anon_sym_var] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [anon_sym_switch] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_await] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [anon_sym_with] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_debugger] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_throw] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1206),
    [anon_sym_case] = ACTIONS(1208),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_class] = ACTIONS(1208),
    [anon_sym_async] = ACTIONS(1208),
    [anon_sym_function] = ACTIONS(1208),
    [anon_sym_new] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_BANG] = ACTIONS(1206),
    [anon_sym_TILDE] = ACTIONS(1206),
    [anon_sym_void] = ACTIONS(1208),
    [anon_sym_delete] = ACTIONS(1208),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [sym_number] = ACTIONS(1206),
    [sym_this] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_true] = ACTIONS(1208),
    [sym_false] = ACTIONS(1208),
    [sym_null] = ACTIONS(1208),
    [sym_undefined] = ACTIONS(1208),
    [anon_sym_AT] = ACTIONS(1206),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_abstract] = ACTIONS(1208),
    [anon_sym_get] = ACTIONS(1208),
    [anon_sym_set] = ACTIONS(1208),
    [anon_sym_declare] = ACTIONS(1208),
    [anon_sym_public] = ACTIONS(1208),
    [anon_sym_private] = ACTIONS(1208),
    [anon_sym_protected] = ACTIONS(1208),
    [anon_sym_module] = ACTIONS(1208),
    [anon_sym_any] = ACTIONS(1208),
    [anon_sym_number] = ACTIONS(1208),
    [anon_sym_boolean] = ACTIONS(1208),
    [anon_sym_string] = ACTIONS(1208),
    [anon_sym_symbol] = ACTIONS(1208),
    [anon_sym_interface] = ACTIONS(1208),
    [anon_sym_enum] = ACTIONS(1208),
    [sym_readonly] = ACTIONS(1208),
    [sym__automatic_semicolon] = ACTIONS(1214),
  },
  [515] = {
    [sym_object] = STATE(2215),
    [sym_array] = STATE(2250),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_export] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2715),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_get] = ACTIONS(2715),
    [anon_sym_set] = ACTIONS(2715),
    [anon_sym_declare] = ACTIONS(2715),
    [anon_sym_public] = ACTIONS(2715),
    [anon_sym_private] = ACTIONS(2715),
    [anon_sym_protected] = ACTIONS(2715),
    [anon_sym_module] = ACTIONS(2715),
    [anon_sym_any] = ACTIONS(2715),
    [anon_sym_number] = ACTIONS(2715),
    [anon_sym_boolean] = ACTIONS(2715),
    [anon_sym_string] = ACTIONS(2715),
    [anon_sym_symbol] = ACTIONS(2715),
    [sym_readonly] = ACTIONS(2715),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1232),
    [anon_sym_export] = ACTIONS(1232),
    [anon_sym_default] = ACTIONS(1232),
    [anon_sym_namespace] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1232),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_import] = ACTIONS(1232),
    [anon_sym_var] = ACTIONS(1232),
    [anon_sym_let] = ACTIONS(1232),
    [anon_sym_const] = ACTIONS(1232),
    [anon_sym_if] = ACTIONS(1232),
    [anon_sym_else] = ACTIONS(1232),
    [anon_sym_switch] = ACTIONS(1232),
    [anon_sym_for] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_await] = ACTIONS(1232),
    [anon_sym_while] = ACTIONS(1232),
    [anon_sym_do] = ACTIONS(1232),
    [anon_sym_try] = ACTIONS(1232),
    [anon_sym_with] = ACTIONS(1232),
    [anon_sym_break] = ACTIONS(1232),
    [anon_sym_continue] = ACTIONS(1232),
    [anon_sym_debugger] = ACTIONS(1232),
    [anon_sym_return] = ACTIONS(1232),
    [anon_sym_throw] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1230),
    [anon_sym_case] = ACTIONS(1232),
    [anon_sym_yield] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1232),
    [anon_sym_class] = ACTIONS(1232),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_void] = ACTIONS(1232),
    [anon_sym_delete] = ACTIONS(1232),
    [anon_sym_PLUS_PLUS] = ACTIONS(1230),
    [anon_sym_DASH_DASH] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1230),
    [sym_this] = ACTIONS(1232),
    [sym_super] = ACTIONS(1232),
    [sym_true] = ACTIONS(1232),
    [sym_false] = ACTIONS(1232),
    [sym_null] = ACTIONS(1232),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(1230),
    [anon_sym_static] = ACTIONS(1232),
    [anon_sym_abstract] = ACTIONS(1232),
    [anon_sym_get] = ACTIONS(1232),
    [anon_sym_set] = ACTIONS(1232),
    [anon_sym_declare] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1232),
    [anon_sym_private] = ACTIONS(1232),
    [anon_sym_protected] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1232),
    [anon_sym_any] = ACTIONS(1232),
    [anon_sym_number] = ACTIONS(1232),
    [anon_sym_boolean] = ACTIONS(1232),
    [anon_sym_string] = ACTIONS(1232),
    [anon_sym_symbol] = ACTIONS(1232),
    [anon_sym_interface] = ACTIONS(1232),
    [anon_sym_enum] = ACTIONS(1232),
    [sym_readonly] = ACTIONS(1232),
    [sym__automatic_semicolon] = ACTIONS(1238),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1220),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_export] = ACTIONS(1222),
    [anon_sym_default] = ACTIONS(1222),
    [anon_sym_namespace] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1222),
    [anon_sym_typeof] = ACTIONS(1222),
    [anon_sym_import] = ACTIONS(1222),
    [anon_sym_var] = ACTIONS(1222),
    [anon_sym_let] = ACTIONS(1222),
    [anon_sym_const] = ACTIONS(1222),
    [anon_sym_if] = ACTIONS(1222),
    [anon_sym_else] = ACTIONS(1222),
    [anon_sym_switch] = ACTIONS(1222),
    [anon_sym_for] = ACTIONS(1222),
    [anon_sym_LPAREN] = ACTIONS(1220),
    [anon_sym_await] = ACTIONS(1222),
    [anon_sym_while] = ACTIONS(1222),
    [anon_sym_do] = ACTIONS(1222),
    [anon_sym_try] = ACTIONS(1222),
    [anon_sym_with] = ACTIONS(1222),
    [anon_sym_break] = ACTIONS(1222),
    [anon_sym_continue] = ACTIONS(1222),
    [anon_sym_debugger] = ACTIONS(1222),
    [anon_sym_return] = ACTIONS(1222),
    [anon_sym_throw] = ACTIONS(1222),
    [anon_sym_SEMI] = ACTIONS(1220),
    [anon_sym_case] = ACTIONS(1222),
    [anon_sym_yield] = ACTIONS(1222),
    [anon_sym_LBRACK] = ACTIONS(1220),
    [anon_sym_LT] = ACTIONS(1220),
    [anon_sym_SLASH] = ACTIONS(1222),
    [anon_sym_class] = ACTIONS(1222),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1222),
    [anon_sym_PLUS] = ACTIONS(1222),
    [anon_sym_DASH] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1220),
    [anon_sym_void] = ACTIONS(1222),
    [anon_sym_delete] = ACTIONS(1222),
    [anon_sym_PLUS_PLUS] = ACTIONS(1220),
    [anon_sym_DASH_DASH] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1220),
    [anon_sym_SQUOTE] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1220),
    [sym_number] = ACTIONS(1220),
    [sym_this] = ACTIONS(1222),
    [sym_super] = ACTIONS(1222),
    [sym_true] = ACTIONS(1222),
    [sym_false] = ACTIONS(1222),
    [sym_null] = ACTIONS(1222),
    [sym_undefined] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1222),
    [anon_sym_abstract] = ACTIONS(1222),
    [anon_sym_get] = ACTIONS(1222),
    [anon_sym_set] = ACTIONS(1222),
    [anon_sym_declare] = ACTIONS(1222),
    [anon_sym_public] = ACTIONS(1222),
    [anon_sym_private] = ACTIONS(1222),
    [anon_sym_protected] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(1222),
    [anon_sym_any] = ACTIONS(1222),
    [anon_sym_number] = ACTIONS(1222),
    [anon_sym_boolean] = ACTIONS(1222),
    [anon_sym_string] = ACTIONS(1222),
    [anon_sym_symbol] = ACTIONS(1222),
    [anon_sym_interface] = ACTIONS(1222),
    [anon_sym_enum] = ACTIONS(1222),
    [sym_readonly] = ACTIONS(1222),
    [sym__automatic_semicolon] = ACTIONS(1228),
  },
  [518] = {
    [sym__call_signature] = STATE(3020),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_export] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(761),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2711),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2711),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(657),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_get] = ACTIONS(2711),
    [anon_sym_set] = ACTIONS(2711),
    [anon_sym_declare] = ACTIONS(2711),
    [anon_sym_public] = ACTIONS(2711),
    [anon_sym_private] = ACTIONS(2711),
    [anon_sym_protected] = ACTIONS(2711),
    [anon_sym_module] = ACTIONS(2711),
    [anon_sym_any] = ACTIONS(2711),
    [anon_sym_number] = ACTIONS(2711),
    [anon_sym_boolean] = ACTIONS(2711),
    [anon_sym_string] = ACTIONS(2711),
    [anon_sym_symbol] = ACTIONS(2711),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(2711),
  },
  [519] = {
    [sym__call_signature] = STATE(2997),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_export] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(703),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2701),
    [anon_sym_async] = ACTIONS(2699),
    [anon_sym_function] = ACTIONS(2703),
    [anon_sym_EQ_GT] = ACTIONS(697),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_get] = ACTIONS(2699),
    [anon_sym_set] = ACTIONS(2699),
    [anon_sym_declare] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_module] = ACTIONS(2699),
    [anon_sym_any] = ACTIONS(2699),
    [anon_sym_number] = ACTIONS(2699),
    [anon_sym_boolean] = ACTIONS(2699),
    [anon_sym_string] = ACTIONS(2699),
    [anon_sym_symbol] = ACTIONS(2699),
    [sym_readonly] = ACTIONS(2699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(2722),
    [sym_identifier] = ACTIONS(2724),
    [anon_sym_export] = ACTIONS(2724),
    [anon_sym_default] = ACTIONS(2724),
    [anon_sym_namespace] = ACTIONS(2724),
    [anon_sym_LBRACE] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_type] = ACTIONS(2724),
    [anon_sym_typeof] = ACTIONS(2724),
    [anon_sym_import] = ACTIONS(2724),
    [anon_sym_var] = ACTIONS(2724),
    [anon_sym_let] = ACTIONS(2724),
    [anon_sym_const] = ACTIONS(2724),
    [anon_sym_if] = ACTIONS(2724),
    [anon_sym_else] = ACTIONS(2724),
    [anon_sym_switch] = ACTIONS(2724),
    [anon_sym_for] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_await] = ACTIONS(2724),
    [anon_sym_while] = ACTIONS(2724),
    [anon_sym_do] = ACTIONS(2724),
    [anon_sym_try] = ACTIONS(2724),
    [anon_sym_with] = ACTIONS(2724),
    [anon_sym_break] = ACTIONS(2724),
    [anon_sym_continue] = ACTIONS(2724),
    [anon_sym_debugger] = ACTIONS(2724),
    [anon_sym_return] = ACTIONS(2724),
    [anon_sym_throw] = ACTIONS(2724),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_case] = ACTIONS(2724),
    [anon_sym_finally] = ACTIONS(2724),
    [anon_sym_yield] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(2724),
    [anon_sym_class] = ACTIONS(2724),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(2724),
    [anon_sym_new] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2724),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_BANG] = ACTIONS(2722),
    [anon_sym_TILDE] = ACTIONS(2722),
    [anon_sym_void] = ACTIONS(2724),
    [anon_sym_delete] = ACTIONS(2724),
    [anon_sym_PLUS_PLUS] = ACTIONS(2722),
    [anon_sym_DASH_DASH] = ACTIONS(2722),
    [anon_sym_DQUOTE] = ACTIONS(2722),
    [anon_sym_SQUOTE] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2722),
    [sym_number] = ACTIONS(2722),
    [sym_this] = ACTIONS(2724),
    [sym_super] = ACTIONS(2724),
    [sym_true] = ACTIONS(2724),
    [sym_false] = ACTIONS(2724),
    [sym_null] = ACTIONS(2724),
    [sym_undefined] = ACTIONS(2724),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2724),
    [anon_sym_abstract] = ACTIONS(2724),
    [anon_sym_get] = ACTIONS(2724),
    [anon_sym_set] = ACTIONS(2724),
    [anon_sym_declare] = ACTIONS(2724),
    [anon_sym_public] = ACTIONS(2724),
    [anon_sym_private] = ACTIONS(2724),
    [anon_sym_protected] = ACTIONS(2724),
    [anon_sym_module] = ACTIONS(2724),
    [anon_sym_any] = ACTIONS(2724),
    [anon_sym_number] = ACTIONS(2724),
    [anon_sym_boolean] = ACTIONS(2724),
    [anon_sym_string] = ACTIONS(2724),
    [anon_sym_symbol] = ACTIONS(2724),
    [anon_sym_interface] = ACTIONS(2724),
    [anon_sym_enum] = ACTIONS(2724),
    [sym_readonly] = ACTIONS(2724),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1260),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_export] = ACTIONS(1262),
    [anon_sym_default] = ACTIONS(1262),
    [anon_sym_namespace] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1260),
    [anon_sym_type] = ACTIONS(1262),
    [anon_sym_typeof] = ACTIONS(1262),
    [anon_sym_import] = ACTIONS(1262),
    [anon_sym_var] = ACTIONS(1262),
    [anon_sym_let] = ACTIONS(1262),
    [anon_sym_const] = ACTIONS(1262),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_else] = ACTIONS(1262),
    [anon_sym_switch] = ACTIONS(1262),
    [anon_sym_for] = ACTIONS(1262),
    [anon_sym_LPAREN] = ACTIONS(1260),
    [anon_sym_await] = ACTIONS(1262),
    [anon_sym_while] = ACTIONS(1262),
    [anon_sym_do] = ACTIONS(1262),
    [anon_sym_try] = ACTIONS(1262),
    [anon_sym_with] = ACTIONS(1262),
    [anon_sym_break] = ACTIONS(1262),
    [anon_sym_continue] = ACTIONS(1262),
    [anon_sym_debugger] = ACTIONS(1262),
    [anon_sym_return] = ACTIONS(1262),
    [anon_sym_throw] = ACTIONS(1262),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_case] = ACTIONS(1262),
    [anon_sym_yield] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_class] = ACTIONS(1262),
    [anon_sym_async] = ACTIONS(1262),
    [anon_sym_function] = ACTIONS(1262),
    [anon_sym_new] = ACTIONS(1262),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_BANG] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1260),
    [anon_sym_void] = ACTIONS(1262),
    [anon_sym_delete] = ACTIONS(1262),
    [anon_sym_PLUS_PLUS] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1260),
    [anon_sym_DQUOTE] = ACTIONS(1260),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1260),
    [sym_number] = ACTIONS(1260),
    [sym_this] = ACTIONS(1262),
    [sym_super] = ACTIONS(1262),
    [sym_true] = ACTIONS(1262),
    [sym_false] = ACTIONS(1262),
    [sym_null] = ACTIONS(1262),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(1262),
    [anon_sym_abstract] = ACTIONS(1262),
    [anon_sym_get] = ACTIONS(1262),
    [anon_sym_set] = ACTIONS(1262),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_public] = ACTIONS(1262),
    [anon_sym_private] = ACTIONS(1262),
    [anon_sym_protected] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_any] = ACTIONS(1262),
    [anon_sym_number] = ACTIONS(1262),
    [anon_sym_boolean] = ACTIONS(1262),
    [anon_sym_string] = ACTIONS(1262),
    [anon_sym_symbol] = ACTIONS(1262),
    [anon_sym_interface] = ACTIONS(1262),
    [anon_sym_enum] = ACTIONS(1262),
    [sym_readonly] = ACTIONS(1262),
    [sym__automatic_semicolon] = ACTIONS(1268),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1196),
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_export] = ACTIONS(1198),
    [anon_sym_default] = ACTIONS(1198),
    [anon_sym_namespace] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_RBRACE] = ACTIONS(1196),
    [anon_sym_type] = ACTIONS(1198),
    [anon_sym_typeof] = ACTIONS(1198),
    [anon_sym_import] = ACTIONS(1198),
    [anon_sym_var] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(1198),
    [anon_sym_const] = ACTIONS(1198),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_else] = ACTIONS(1198),
    [anon_sym_switch] = ACTIONS(1198),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_await] = ACTIONS(1198),
    [anon_sym_while] = ACTIONS(1198),
    [anon_sym_do] = ACTIONS(1198),
    [anon_sym_try] = ACTIONS(1198),
    [anon_sym_with] = ACTIONS(1198),
    [anon_sym_break] = ACTIONS(1198),
    [anon_sym_continue] = ACTIONS(1198),
    [anon_sym_debugger] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(1198),
    [anon_sym_throw] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1196),
    [anon_sym_case] = ACTIONS(1198),
    [anon_sym_yield] = ACTIONS(1198),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_SLASH] = ACTIONS(1198),
    [anon_sym_class] = ACTIONS(1198),
    [anon_sym_async] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(1198),
    [anon_sym_new] = ACTIONS(1198),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_BANG] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_void] = ACTIONS(1198),
    [anon_sym_delete] = ACTIONS(1198),
    [anon_sym_PLUS_PLUS] = ACTIONS(1196),
    [anon_sym_DASH_DASH] = ACTIONS(1196),
    [anon_sym_DQUOTE] = ACTIONS(1196),
    [anon_sym_SQUOTE] = ACTIONS(1196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1196),
    [sym_number] = ACTIONS(1196),
    [sym_this] = ACTIONS(1198),
    [sym_super] = ACTIONS(1198),
    [sym_true] = ACTIONS(1198),
    [sym_false] = ACTIONS(1198),
    [sym_null] = ACTIONS(1198),
    [sym_undefined] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_static] = ACTIONS(1198),
    [anon_sym_abstract] = ACTIONS(1198),
    [anon_sym_get] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1198),
    [anon_sym_declare] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1198),
    [anon_sym_private] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1198),
    [anon_sym_number] = ACTIONS(1198),
    [anon_sym_boolean] = ACTIONS(1198),
    [anon_sym_string] = ACTIONS(1198),
    [anon_sym_symbol] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(1198),
    [anon_sym_enum] = ACTIONS(1198),
    [sym_readonly] = ACTIONS(1198),
    [sym__automatic_semicolon] = ACTIONS(1204),
  },
  [523] = {
    [sym_object] = STATE(2215),
    [sym_array] = STATE(2250),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_export] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2715),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_get] = ACTIONS(2715),
    [anon_sym_set] = ACTIONS(2715),
    [anon_sym_declare] = ACTIONS(2715),
    [anon_sym_public] = ACTIONS(2715),
    [anon_sym_private] = ACTIONS(2715),
    [anon_sym_protected] = ACTIONS(2715),
    [anon_sym_module] = ACTIONS(2715),
    [anon_sym_any] = ACTIONS(2715),
    [anon_sym_number] = ACTIONS(2715),
    [anon_sym_boolean] = ACTIONS(2715),
    [anon_sym_string] = ACTIONS(2715),
    [anon_sym_symbol] = ACTIONS(2715),
    [sym_readonly] = ACTIONS(2715),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_identifier] = ACTIONS(1168),
    [anon_sym_export] = ACTIONS(1168),
    [anon_sym_default] = ACTIONS(1168),
    [anon_sym_namespace] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(1168),
    [anon_sym_import] = ACTIONS(1168),
    [anon_sym_var] = ACTIONS(1168),
    [anon_sym_let] = ACTIONS(1168),
    [anon_sym_const] = ACTIONS(1168),
    [anon_sym_if] = ACTIONS(1168),
    [anon_sym_else] = ACTIONS(1168),
    [anon_sym_switch] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [anon_sym_await] = ACTIONS(1168),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_try] = ACTIONS(1168),
    [anon_sym_with] = ACTIONS(1168),
    [anon_sym_break] = ACTIONS(1168),
    [anon_sym_continue] = ACTIONS(1168),
    [anon_sym_debugger] = ACTIONS(1168),
    [anon_sym_return] = ACTIONS(1168),
    [anon_sym_throw] = ACTIONS(1168),
    [anon_sym_SEMI] = ACTIONS(1166),
    [anon_sym_case] = ACTIONS(1168),
    [anon_sym_yield] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_SLASH] = ACTIONS(1168),
    [anon_sym_class] = ACTIONS(1168),
    [anon_sym_async] = ACTIONS(1168),
    [anon_sym_function] = ACTIONS(1168),
    [anon_sym_new] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_BANG] = ACTIONS(1166),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_void] = ACTIONS(1168),
    [anon_sym_delete] = ACTIONS(1168),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [sym_number] = ACTIONS(1166),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(1168),
    [sym_true] = ACTIONS(1168),
    [sym_false] = ACTIONS(1168),
    [sym_null] = ACTIONS(1168),
    [sym_undefined] = ACTIONS(1168),
    [anon_sym_AT] = ACTIONS(1166),
    [anon_sym_static] = ACTIONS(1168),
    [anon_sym_abstract] = ACTIONS(1168),
    [anon_sym_get] = ACTIONS(1168),
    [anon_sym_set] = ACTIONS(1168),
    [anon_sym_declare] = ACTIONS(1168),
    [anon_sym_public] = ACTIONS(1168),
    [anon_sym_private] = ACTIONS(1168),
    [anon_sym_protected] = ACTIONS(1168),
    [anon_sym_module] = ACTIONS(1168),
    [anon_sym_any] = ACTIONS(1168),
    [anon_sym_number] = ACTIONS(1168),
    [anon_sym_boolean] = ACTIONS(1168),
    [anon_sym_string] = ACTIONS(1168),
    [anon_sym_symbol] = ACTIONS(1168),
    [anon_sym_interface] = ACTIONS(1168),
    [anon_sym_enum] = ACTIONS(1168),
    [sym_readonly] = ACTIONS(1168),
    [sym__automatic_semicolon] = ACTIONS(1174),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1176),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_export] = ACTIONS(1178),
    [anon_sym_default] = ACTIONS(1178),
    [anon_sym_namespace] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_RBRACE] = ACTIONS(1176),
    [anon_sym_type] = ACTIONS(1178),
    [anon_sym_typeof] = ACTIONS(1178),
    [anon_sym_import] = ACTIONS(1178),
    [anon_sym_var] = ACTIONS(1178),
    [anon_sym_let] = ACTIONS(1178),
    [anon_sym_const] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_else] = ACTIONS(1178),
    [anon_sym_switch] = ACTIONS(1178),
    [anon_sym_for] = ACTIONS(1178),
    [anon_sym_LPAREN] = ACTIONS(1176),
    [anon_sym_await] = ACTIONS(1178),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_do] = ACTIONS(1178),
    [anon_sym_try] = ACTIONS(1178),
    [anon_sym_with] = ACTIONS(1178),
    [anon_sym_break] = ACTIONS(1178),
    [anon_sym_continue] = ACTIONS(1178),
    [anon_sym_debugger] = ACTIONS(1178),
    [anon_sym_return] = ACTIONS(1178),
    [anon_sym_throw] = ACTIONS(1178),
    [anon_sym_SEMI] = ACTIONS(1176),
    [anon_sym_case] = ACTIONS(1178),
    [anon_sym_yield] = ACTIONS(1178),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_LT] = ACTIONS(1176),
    [anon_sym_SLASH] = ACTIONS(1178),
    [anon_sym_class] = ACTIONS(1178),
    [anon_sym_async] = ACTIONS(1178),
    [anon_sym_function] = ACTIONS(1178),
    [anon_sym_new] = ACTIONS(1178),
    [anon_sym_PLUS] = ACTIONS(1178),
    [anon_sym_DASH] = ACTIONS(1178),
    [anon_sym_BANG] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_void] = ACTIONS(1178),
    [anon_sym_delete] = ACTIONS(1178),
    [anon_sym_PLUS_PLUS] = ACTIONS(1176),
    [anon_sym_DASH_DASH] = ACTIONS(1176),
    [anon_sym_DQUOTE] = ACTIONS(1176),
    [anon_sym_SQUOTE] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1176),
    [sym_number] = ACTIONS(1176),
    [sym_this] = ACTIONS(1178),
    [sym_super] = ACTIONS(1178),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_null] = ACTIONS(1178),
    [sym_undefined] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_static] = ACTIONS(1178),
    [anon_sym_abstract] = ACTIONS(1178),
    [anon_sym_get] = ACTIONS(1178),
    [anon_sym_set] = ACTIONS(1178),
    [anon_sym_declare] = ACTIONS(1178),
    [anon_sym_public] = ACTIONS(1178),
    [anon_sym_private] = ACTIONS(1178),
    [anon_sym_protected] = ACTIONS(1178),
    [anon_sym_module] = ACTIONS(1178),
    [anon_sym_any] = ACTIONS(1178),
    [anon_sym_number] = ACTIONS(1178),
    [anon_sym_boolean] = ACTIONS(1178),
    [anon_sym_string] = ACTIONS(1178),
    [anon_sym_symbol] = ACTIONS(1178),
    [anon_sym_interface] = ACTIONS(1178),
    [anon_sym_enum] = ACTIONS(1178),
    [sym_readonly] = ACTIONS(1178),
    [sym__automatic_semicolon] = ACTIONS(1184),
  },
  [526] = {
    [sym_statement_block] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_export] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_namespace] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_var] = ACTIONS(1100),
    [anon_sym_let] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1098),
    [anon_sym_await] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_debugger] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_throw] = ACTIONS(1100),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_LT] = ACTIONS(1098),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_function] = ACTIONS(1100),
    [anon_sym_new] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_void] = ACTIONS(1100),
    [anon_sym_delete] = ACTIONS(1100),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1098),
    [sym_number] = ACTIONS(1098),
    [sym_this] = ACTIONS(1100),
    [sym_super] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_undefined] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_abstract] = ACTIONS(1100),
    [anon_sym_get] = ACTIONS(1100),
    [anon_sym_set] = ACTIONS(1100),
    [anon_sym_declare] = ACTIONS(1100),
    [anon_sym_public] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym_protected] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [anon_sym_any] = ACTIONS(1100),
    [anon_sym_number] = ACTIONS(1100),
    [anon_sym_boolean] = ACTIONS(1100),
    [anon_sym_string] = ACTIONS(1100),
    [anon_sym_symbol] = ACTIONS(1100),
    [anon_sym_interface] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [sym_readonly] = ACTIONS(1100),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1148),
    [sym_identifier] = ACTIONS(1150),
    [anon_sym_export] = ACTIONS(1150),
    [anon_sym_default] = ACTIONS(1150),
    [anon_sym_namespace] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1148),
    [anon_sym_RBRACE] = ACTIONS(1148),
    [anon_sym_type] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(1150),
    [anon_sym_import] = ACTIONS(1150),
    [anon_sym_var] = ACTIONS(1150),
    [anon_sym_let] = ACTIONS(1150),
    [anon_sym_const] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(1150),
    [anon_sym_else] = ACTIONS(1150),
    [anon_sym_switch] = ACTIONS(1150),
    [anon_sym_for] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [anon_sym_await] = ACTIONS(1150),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_do] = ACTIONS(1150),
    [anon_sym_try] = ACTIONS(1150),
    [anon_sym_with] = ACTIONS(1150),
    [anon_sym_break] = ACTIONS(1150),
    [anon_sym_continue] = ACTIONS(1150),
    [anon_sym_debugger] = ACTIONS(1150),
    [anon_sym_return] = ACTIONS(1150),
    [anon_sym_throw] = ACTIONS(1150),
    [anon_sym_SEMI] = ACTIONS(1148),
    [anon_sym_case] = ACTIONS(1150),
    [anon_sym_yield] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_class] = ACTIONS(1150),
    [anon_sym_async] = ACTIONS(1150),
    [anon_sym_function] = ACTIONS(1150),
    [anon_sym_new] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_BANG] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1148),
    [anon_sym_void] = ACTIONS(1150),
    [anon_sym_delete] = ACTIONS(1150),
    [anon_sym_PLUS_PLUS] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1148),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_SQUOTE] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1148),
    [sym_number] = ACTIONS(1148),
    [sym_this] = ACTIONS(1150),
    [sym_super] = ACTIONS(1150),
    [sym_true] = ACTIONS(1150),
    [sym_false] = ACTIONS(1150),
    [sym_null] = ACTIONS(1150),
    [sym_undefined] = ACTIONS(1150),
    [anon_sym_AT] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1150),
    [anon_sym_abstract] = ACTIONS(1150),
    [anon_sym_get] = ACTIONS(1150),
    [anon_sym_set] = ACTIONS(1150),
    [anon_sym_declare] = ACTIONS(1150),
    [anon_sym_public] = ACTIONS(1150),
    [anon_sym_private] = ACTIONS(1150),
    [anon_sym_protected] = ACTIONS(1150),
    [anon_sym_module] = ACTIONS(1150),
    [anon_sym_any] = ACTIONS(1150),
    [anon_sym_number] = ACTIONS(1150),
    [anon_sym_boolean] = ACTIONS(1150),
    [anon_sym_string] = ACTIONS(1150),
    [anon_sym_symbol] = ACTIONS(1150),
    [anon_sym_interface] = ACTIONS(1150),
    [anon_sym_enum] = ACTIONS(1150),
    [sym_readonly] = ACTIONS(1150),
    [sym__automatic_semicolon] = ACTIONS(1156),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(2726),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_default] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_typeof] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_var] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2728),
    [anon_sym_switch] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_await] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [anon_sym_do] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_with] = ACTIONS(2728),
    [anon_sym_break] = ACTIONS(2728),
    [anon_sym_continue] = ACTIONS(2728),
    [anon_sym_debugger] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_throw] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_case] = ACTIONS(2728),
    [anon_sym_yield] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_SLASH] = ACTIONS(2728),
    [anon_sym_class] = ACTIONS(2728),
    [anon_sym_async] = ACTIONS(2728),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2726),
    [anon_sym_void] = ACTIONS(2728),
    [anon_sym_delete] = ACTIONS(2728),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [anon_sym_SQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_number] = ACTIONS(2726),
    [sym_this] = ACTIONS(2728),
    [sym_super] = ACTIONS(2728),
    [sym_true] = ACTIONS(2728),
    [sym_false] = ACTIONS(2728),
    [sym_null] = ACTIONS(2728),
    [sym_undefined] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_static] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_get] = ACTIONS(2728),
    [anon_sym_set] = ACTIONS(2728),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2728),
    [anon_sym_private] = ACTIONS(2728),
    [anon_sym_protected] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_interface] = ACTIONS(2728),
    [anon_sym_enum] = ACTIONS(2728),
    [sym_readonly] = ACTIONS(2728),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_export] = ACTIONS(1252),
    [anon_sym_default] = ACTIONS(1252),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_type] = ACTIONS(1252),
    [anon_sym_typeof] = ACTIONS(1252),
    [anon_sym_import] = ACTIONS(1252),
    [anon_sym_var] = ACTIONS(1252),
    [anon_sym_let] = ACTIONS(1252),
    [anon_sym_const] = ACTIONS(1252),
    [anon_sym_if] = ACTIONS(1252),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_await] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1252),
    [anon_sym_with] = ACTIONS(1252),
    [anon_sym_break] = ACTIONS(1252),
    [anon_sym_continue] = ACTIONS(1252),
    [anon_sym_debugger] = ACTIONS(1252),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_throw] = ACTIONS(1252),
    [anon_sym_SEMI] = ACTIONS(1250),
    [anon_sym_case] = ACTIONS(1252),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1252),
    [anon_sym_class] = ACTIONS(1252),
    [anon_sym_async] = ACTIONS(1252),
    [anon_sym_function] = ACTIONS(1252),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_void] = ACTIONS(1252),
    [anon_sym_delete] = ACTIONS(1252),
    [anon_sym_PLUS_PLUS] = ACTIONS(1250),
    [anon_sym_DASH_DASH] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_super] = ACTIONS(1252),
    [sym_true] = ACTIONS(1252),
    [sym_false] = ACTIONS(1252),
    [sym_null] = ACTIONS(1252),
    [sym_undefined] = ACTIONS(1252),
    [anon_sym_AT] = ACTIONS(1250),
    [anon_sym_static] = ACTIONS(1252),
    [anon_sym_abstract] = ACTIONS(1252),
    [anon_sym_get] = ACTIONS(1252),
    [anon_sym_set] = ACTIONS(1252),
    [anon_sym_declare] = ACTIONS(1252),
    [anon_sym_public] = ACTIONS(1252),
    [anon_sym_private] = ACTIONS(1252),
    [anon_sym_protected] = ACTIONS(1252),
    [anon_sym_module] = ACTIONS(1252),
    [anon_sym_any] = ACTIONS(1252),
    [anon_sym_number] = ACTIONS(1252),
    [anon_sym_boolean] = ACTIONS(1252),
    [anon_sym_string] = ACTIONS(1252),
    [anon_sym_symbol] = ACTIONS(1252),
    [anon_sym_interface] = ACTIONS(1252),
    [anon_sym_enum] = ACTIONS(1252),
    [sym_readonly] = ACTIONS(1252),
    [sym__automatic_semicolon] = ACTIONS(1258),
  },
  [530] = {
    [sym__call_signature] = STATE(3205),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2570),
  },
  [531] = {
    [sym__call_signature] = STATE(3120),
    [sym_arguments] = STATE(1425),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_namespace] = ACTIONS(2732),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_function] = ACTIONS(2659),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [sym_readonly] = ACTIONS(2732),
    [sym__automatic_semicolon] = ACTIONS(525),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(2734),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_default] = ACTIONS(2736),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_import] = ACTIONS(2736),
    [anon_sym_var] = ACTIONS(2736),
    [anon_sym_let] = ACTIONS(2736),
    [anon_sym_const] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2736),
    [anon_sym_else] = ACTIONS(2736),
    [anon_sym_switch] = ACTIONS(2736),
    [anon_sym_for] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_await] = ACTIONS(2736),
    [anon_sym_while] = ACTIONS(2736),
    [anon_sym_do] = ACTIONS(2736),
    [anon_sym_try] = ACTIONS(2736),
    [anon_sym_with] = ACTIONS(2736),
    [anon_sym_break] = ACTIONS(2736),
    [anon_sym_continue] = ACTIONS(2736),
    [anon_sym_debugger] = ACTIONS(2736),
    [anon_sym_return] = ACTIONS(2736),
    [anon_sym_throw] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_case] = ACTIONS(2736),
    [anon_sym_yield] = ACTIONS(2736),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2736),
    [anon_sym_DASH] = ACTIONS(2736),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_TILDE] = ACTIONS(2734),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_delete] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_number] = ACTIONS(2734),
    [sym_this] = ACTIONS(2736),
    [sym_super] = ACTIONS(2736),
    [sym_true] = ACTIONS(2736),
    [sym_false] = ACTIONS(2736),
    [sym_null] = ACTIONS(2736),
    [sym_undefined] = ACTIONS(2736),
    [anon_sym_AT] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_abstract] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
    [anon_sym_interface] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2736),
    [sym_readonly] = ACTIONS(2736),
  },
  [533] = {
    [sym__call_signature] = STATE(3205),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2570),
  },
  [534] = {
    [sym__call_signature] = STATE(3045),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_export] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2685),
    [anon_sym_public] = ACTIONS(2685),
    [anon_sym_private] = ACTIONS(2685),
    [anon_sym_protected] = ACTIONS(2685),
    [anon_sym_module] = ACTIONS(2685),
    [anon_sym_any] = ACTIONS(2685),
    [anon_sym_number] = ACTIONS(2685),
    [anon_sym_boolean] = ACTIONS(2685),
    [anon_sym_string] = ACTIONS(2685),
    [anon_sym_symbol] = ACTIONS(2685),
    [sym_readonly] = ACTIONS(2685),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_namespace] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2740),
    [anon_sym_import] = ACTIONS(2740),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_else] = ACTIONS(2740),
    [anon_sym_switch] = ACTIONS(2740),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_await] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(2740),
    [anon_sym_try] = ACTIONS(2740),
    [anon_sym_with] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_debugger] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_throw] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_case] = ACTIONS(2740),
    [anon_sym_finally] = ACTIONS(2740),
    [anon_sym_yield] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_function] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_TILDE] = ACTIONS(2738),
    [anon_sym_void] = ACTIONS(2740),
    [anon_sym_delete] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2738),
    [anon_sym_DASH_DASH] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_number] = ACTIONS(2738),
    [sym_this] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [sym_true] = ACTIONS(2740),
    [sym_false] = ACTIONS(2740),
    [sym_null] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2738),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2740),
    [anon_sym_public] = ACTIONS(2740),
    [anon_sym_private] = ACTIONS(2740),
    [anon_sym_protected] = ACTIONS(2740),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_any] = ACTIONS(2740),
    [anon_sym_number] = ACTIONS(2740),
    [anon_sym_boolean] = ACTIONS(2740),
    [anon_sym_string] = ACTIONS(2740),
    [anon_sym_symbol] = ACTIONS(2740),
    [anon_sym_interface] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
    [sym_readonly] = ACTIONS(2740),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_type] = ACTIONS(2744),
    [anon_sym_typeof] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [anon_sym_await] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_with] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_debugger] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_finally] = ACTIONS(2744),
    [anon_sym_yield] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_TILDE] = ACTIONS(2742),
    [anon_sym_void] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_PLUS_PLUS] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2742),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2742),
    [sym_number] = ACTIONS(2742),
    [sym_this] = ACTIONS(2744),
    [sym_super] = ACTIONS(2744),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_undefined] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_get] = ACTIONS(2744),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_declare] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_any] = ACTIONS(2744),
    [anon_sym_number] = ACTIONS(2744),
    [anon_sym_boolean] = ACTIONS(2744),
    [anon_sym_string] = ACTIONS(2744),
    [anon_sym_symbol] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [sym_readonly] = ACTIONS(2744),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_export] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_namespace] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2748),
    [anon_sym_import] = ACTIONS(2748),
    [anon_sym_var] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_switch] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_await] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_debugger] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_throw] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_case] = ACTIONS(2748),
    [anon_sym_finally] = ACTIONS(2748),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_SLASH] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_void] = ACTIONS(2748),
    [anon_sym_delete] = ACTIONS(2748),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [sym_number] = ACTIONS(2746),
    [sym_this] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_null] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_get] = ACTIONS(2748),
    [anon_sym_set] = ACTIONS(2748),
    [anon_sym_declare] = ACTIONS(2748),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_module] = ACTIONS(2748),
    [anon_sym_any] = ACTIONS(2748),
    [anon_sym_number] = ACTIONS(2748),
    [anon_sym_boolean] = ACTIONS(2748),
    [anon_sym_string] = ACTIONS(2748),
    [anon_sym_symbol] = ACTIONS(2748),
    [anon_sym_interface] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
    [sym_readonly] = ACTIONS(2748),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2752),
    [anon_sym_export] = ACTIONS(2752),
    [anon_sym_default] = ACTIONS(2752),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_typeof] = ACTIONS(2752),
    [anon_sym_import] = ACTIONS(2752),
    [anon_sym_var] = ACTIONS(2752),
    [anon_sym_let] = ACTIONS(2752),
    [anon_sym_const] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2752),
    [anon_sym_else] = ACTIONS(2752),
    [anon_sym_switch] = ACTIONS(2752),
    [anon_sym_for] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_await] = ACTIONS(2752),
    [anon_sym_while] = ACTIONS(2752),
    [anon_sym_do] = ACTIONS(2752),
    [anon_sym_try] = ACTIONS(2752),
    [anon_sym_with] = ACTIONS(2752),
    [anon_sym_break] = ACTIONS(2752),
    [anon_sym_continue] = ACTIONS(2752),
    [anon_sym_debugger] = ACTIONS(2752),
    [anon_sym_return] = ACTIONS(2752),
    [anon_sym_throw] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_case] = ACTIONS(2752),
    [anon_sym_yield] = ACTIONS(2752),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2752),
    [anon_sym_async] = ACTIONS(2752),
    [anon_sym_function] = ACTIONS(2752),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_TILDE] = ACTIONS(2750),
    [anon_sym_void] = ACTIONS(2752),
    [anon_sym_delete] = ACTIONS(2752),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2750),
    [sym_number] = ACTIONS(2750),
    [sym_this] = ACTIONS(2752),
    [sym_super] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_null] = ACTIONS(2752),
    [sym_undefined] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2750),
    [anon_sym_static] = ACTIONS(2752),
    [anon_sym_abstract] = ACTIONS(2752),
    [anon_sym_get] = ACTIONS(2752),
    [anon_sym_set] = ACTIONS(2752),
    [anon_sym_declare] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2752),
    [anon_sym_private] = ACTIONS(2752),
    [anon_sym_protected] = ACTIONS(2752),
    [anon_sym_module] = ACTIONS(2752),
    [anon_sym_any] = ACTIONS(2752),
    [anon_sym_number] = ACTIONS(2752),
    [anon_sym_boolean] = ACTIONS(2752),
    [anon_sym_string] = ACTIONS(2752),
    [anon_sym_symbol] = ACTIONS(2752),
    [anon_sym_interface] = ACTIONS(2752),
    [anon_sym_enum] = ACTIONS(2752),
    [sym_readonly] = ACTIONS(2752),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_export] = ACTIONS(2756),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_namespace] = ACTIONS(2756),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_type] = ACTIONS(2756),
    [anon_sym_typeof] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2756),
    [anon_sym_var] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_else] = ACTIONS(2756),
    [anon_sym_switch] = ACTIONS(2756),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_await] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_break] = ACTIONS(2756),
    [anon_sym_continue] = ACTIONS(2756),
    [anon_sym_debugger] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_throw] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_case] = ACTIONS(2756),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2756),
    [anon_sym_async] = ACTIONS(2756),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_BANG] = ACTIONS(2754),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_void] = ACTIONS(2756),
    [anon_sym_delete] = ACTIONS(2756),
    [anon_sym_PLUS_PLUS] = ACTIONS(2754),
    [anon_sym_DASH_DASH] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_super] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_null] = ACTIONS(2756),
    [sym_undefined] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2754),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_abstract] = ACTIONS(2756),
    [anon_sym_get] = ACTIONS(2756),
    [anon_sym_set] = ACTIONS(2756),
    [anon_sym_declare] = ACTIONS(2756),
    [anon_sym_public] = ACTIONS(2756),
    [anon_sym_private] = ACTIONS(2756),
    [anon_sym_protected] = ACTIONS(2756),
    [anon_sym_module] = ACTIONS(2756),
    [anon_sym_any] = ACTIONS(2756),
    [anon_sym_number] = ACTIONS(2756),
    [anon_sym_boolean] = ACTIONS(2756),
    [anon_sym_string] = ACTIONS(2756),
    [anon_sym_symbol] = ACTIONS(2756),
    [anon_sym_interface] = ACTIONS(2756),
    [anon_sym_enum] = ACTIONS(2756),
    [sym_readonly] = ACTIONS(2756),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_export] = ACTIONS(2760),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_namespace] = ACTIONS(2760),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_type] = ACTIONS(2760),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_const] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_else] = ACTIONS(2760),
    [anon_sym_switch] = ACTIONS(2760),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_await] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_break] = ACTIONS(2760),
    [anon_sym_continue] = ACTIONS(2760),
    [anon_sym_debugger] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_throw] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_case] = ACTIONS(2760),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_SLASH] = ACTIONS(2760),
    [anon_sym_class] = ACTIONS(2760),
    [anon_sym_async] = ACTIONS(2760),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_BANG] = ACTIONS(2758),
    [anon_sym_TILDE] = ACTIONS(2758),
    [anon_sym_void] = ACTIONS(2760),
    [anon_sym_delete] = ACTIONS(2760),
    [anon_sym_PLUS_PLUS] = ACTIONS(2758),
    [anon_sym_DASH_DASH] = ACTIONS(2758),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2758),
    [sym_number] = ACTIONS(2758),
    [sym_this] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_undefined] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(2758),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_abstract] = ACTIONS(2760),
    [anon_sym_get] = ACTIONS(2760),
    [anon_sym_set] = ACTIONS(2760),
    [anon_sym_declare] = ACTIONS(2760),
    [anon_sym_public] = ACTIONS(2760),
    [anon_sym_private] = ACTIONS(2760),
    [anon_sym_protected] = ACTIONS(2760),
    [anon_sym_module] = ACTIONS(2760),
    [anon_sym_any] = ACTIONS(2760),
    [anon_sym_number] = ACTIONS(2760),
    [anon_sym_boolean] = ACTIONS(2760),
    [anon_sym_string] = ACTIONS(2760),
    [anon_sym_symbol] = ACTIONS(2760),
    [anon_sym_interface] = ACTIONS(2760),
    [anon_sym_enum] = ACTIONS(2760),
    [sym_readonly] = ACTIONS(2760),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_namespace] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_import] = ACTIONS(1140),
    [anon_sym_var] = ACTIONS(1140),
    [anon_sym_let] = ACTIONS(1140),
    [anon_sym_const] = ACTIONS(1140),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_await] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(1140),
    [anon_sym_do] = ACTIONS(1140),
    [anon_sym_try] = ACTIONS(1140),
    [anon_sym_with] = ACTIONS(1140),
    [anon_sym_break] = ACTIONS(1140),
    [anon_sym_continue] = ACTIONS(1140),
    [anon_sym_debugger] = ACTIONS(1140),
    [anon_sym_return] = ACTIONS(1140),
    [anon_sym_throw] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_yield] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1138),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1140),
    [anon_sym_async] = ACTIONS(1140),
    [anon_sym_function] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_void] = ACTIONS(1140),
    [anon_sym_delete] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [sym_number] = ACTIONS(1138),
    [sym_this] = ACTIONS(1140),
    [sym_super] = ACTIONS(1140),
    [sym_true] = ACTIONS(1140),
    [sym_false] = ACTIONS(1140),
    [sym_null] = ACTIONS(1140),
    [sym_undefined] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_static] = ACTIONS(1140),
    [anon_sym_abstract] = ACTIONS(1140),
    [anon_sym_get] = ACTIONS(1140),
    [anon_sym_set] = ACTIONS(1140),
    [anon_sym_declare] = ACTIONS(1140),
    [anon_sym_public] = ACTIONS(1140),
    [anon_sym_private] = ACTIONS(1140),
    [anon_sym_protected] = ACTIONS(1140),
    [anon_sym_module] = ACTIONS(1140),
    [anon_sym_any] = ACTIONS(1140),
    [anon_sym_number] = ACTIONS(1140),
    [anon_sym_boolean] = ACTIONS(1140),
    [anon_sym_string] = ACTIONS(1140),
    [anon_sym_symbol] = ACTIONS(1140),
    [anon_sym_interface] = ACTIONS(1140),
    [anon_sym_enum] = ACTIONS(1140),
    [sym_readonly] = ACTIONS(1140),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_export] = ACTIONS(2764),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_namespace] = ACTIONS(2764),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_type] = ACTIONS(2764),
    [anon_sym_typeof] = ACTIONS(2764),
    [anon_sym_import] = ACTIONS(2764),
    [anon_sym_var] = ACTIONS(2764),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_else] = ACTIONS(2764),
    [anon_sym_switch] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_await] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2764),
    [anon_sym_do] = ACTIONS(2764),
    [anon_sym_try] = ACTIONS(2764),
    [anon_sym_with] = ACTIONS(2764),
    [anon_sym_break] = ACTIONS(2764),
    [anon_sym_continue] = ACTIONS(2764),
    [anon_sym_debugger] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(2764),
    [anon_sym_throw] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_case] = ACTIONS(2764),
    [anon_sym_yield] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2764),
    [anon_sym_class] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_function] = ACTIONS(2764),
    [anon_sym_new] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_TILDE] = ACTIONS(2762),
    [anon_sym_void] = ACTIONS(2764),
    [anon_sym_delete] = ACTIONS(2764),
    [anon_sym_PLUS_PLUS] = ACTIONS(2762),
    [anon_sym_DASH_DASH] = ACTIONS(2762),
    [anon_sym_DQUOTE] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2762),
    [sym_number] = ACTIONS(2762),
    [sym_this] = ACTIONS(2764),
    [sym_super] = ACTIONS(2764),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_null] = ACTIONS(2764),
    [sym_undefined] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_static] = ACTIONS(2764),
    [anon_sym_abstract] = ACTIONS(2764),
    [anon_sym_get] = ACTIONS(2764),
    [anon_sym_set] = ACTIONS(2764),
    [anon_sym_declare] = ACTIONS(2764),
    [anon_sym_public] = ACTIONS(2764),
    [anon_sym_private] = ACTIONS(2764),
    [anon_sym_protected] = ACTIONS(2764),
    [anon_sym_module] = ACTIONS(2764),
    [anon_sym_any] = ACTIONS(2764),
    [anon_sym_number] = ACTIONS(2764),
    [anon_sym_boolean] = ACTIONS(2764),
    [anon_sym_string] = ACTIONS(2764),
    [anon_sym_symbol] = ACTIONS(2764),
    [anon_sym_interface] = ACTIONS(2764),
    [anon_sym_enum] = ACTIONS(2764),
    [sym_readonly] = ACTIONS(2764),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(1164),
    [anon_sym_default] = ACTIONS(1164),
    [anon_sym_namespace] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1164),
    [anon_sym_typeof] = ACTIONS(1164),
    [anon_sym_import] = ACTIONS(1164),
    [anon_sym_var] = ACTIONS(1164),
    [anon_sym_let] = ACTIONS(1164),
    [anon_sym_const] = ACTIONS(1164),
    [anon_sym_if] = ACTIONS(1164),
    [anon_sym_else] = ACTIONS(1164),
    [anon_sym_switch] = ACTIONS(1164),
    [anon_sym_for] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_await] = ACTIONS(1164),
    [anon_sym_while] = ACTIONS(1164),
    [anon_sym_do] = ACTIONS(1164),
    [anon_sym_try] = ACTIONS(1164),
    [anon_sym_with] = ACTIONS(1164),
    [anon_sym_break] = ACTIONS(1164),
    [anon_sym_continue] = ACTIONS(1164),
    [anon_sym_debugger] = ACTIONS(1164),
    [anon_sym_return] = ACTIONS(1164),
    [anon_sym_throw] = ACTIONS(1164),
    [anon_sym_SEMI] = ACTIONS(1162),
    [anon_sym_case] = ACTIONS(1164),
    [anon_sym_yield] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_LT] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1164),
    [anon_sym_class] = ACTIONS(1164),
    [anon_sym_async] = ACTIONS(1164),
    [anon_sym_function] = ACTIONS(1164),
    [anon_sym_new] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_BANG] = ACTIONS(1162),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_void] = ACTIONS(1164),
    [anon_sym_delete] = ACTIONS(1164),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [sym_number] = ACTIONS(1162),
    [sym_this] = ACTIONS(1164),
    [sym_super] = ACTIONS(1164),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1162),
    [anon_sym_static] = ACTIONS(1164),
    [anon_sym_abstract] = ACTIONS(1164),
    [anon_sym_get] = ACTIONS(1164),
    [anon_sym_set] = ACTIONS(1164),
    [anon_sym_declare] = ACTIONS(1164),
    [anon_sym_public] = ACTIONS(1164),
    [anon_sym_private] = ACTIONS(1164),
    [anon_sym_protected] = ACTIONS(1164),
    [anon_sym_module] = ACTIONS(1164),
    [anon_sym_any] = ACTIONS(1164),
    [anon_sym_number] = ACTIONS(1164),
    [anon_sym_boolean] = ACTIONS(1164),
    [anon_sym_string] = ACTIONS(1164),
    [anon_sym_symbol] = ACTIONS(1164),
    [anon_sym_interface] = ACTIONS(1164),
    [anon_sym_enum] = ACTIONS(1164),
    [sym_readonly] = ACTIONS(1164),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_typeof] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_var] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_else] = ACTIONS(2768),
    [anon_sym_switch] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_await] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_debugger] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_throw] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_case] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2768),
    [anon_sym_class] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_BANG] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2766),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_delete] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2766),
    [anon_sym_DASH_DASH] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2766),
    [sym_number] = ACTIONS(2766),
    [sym_this] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [sym_true] = ACTIONS(2768),
    [sym_false] = ACTIONS(2768),
    [sym_null] = ACTIONS(2768),
    [sym_undefined] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_interface] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
    [sym_readonly] = ACTIONS(2768),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1116),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_export] = ACTIONS(1118),
    [anon_sym_default] = ACTIONS(1118),
    [anon_sym_namespace] = ACTIONS(1118),
    [anon_sym_LBRACE] = ACTIONS(1116),
    [anon_sym_RBRACE] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1118),
    [anon_sym_typeof] = ACTIONS(1118),
    [anon_sym_import] = ACTIONS(1118),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1118),
    [anon_sym_const] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1118),
    [anon_sym_else] = ACTIONS(1118),
    [anon_sym_switch] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1118),
    [anon_sym_try] = ACTIONS(1118),
    [anon_sym_with] = ACTIONS(1118),
    [anon_sym_break] = ACTIONS(1118),
    [anon_sym_continue] = ACTIONS(1118),
    [anon_sym_debugger] = ACTIONS(1118),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_throw] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1118),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_LBRACK] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1118),
    [anon_sym_class] = ACTIONS(1118),
    [anon_sym_async] = ACTIONS(1118),
    [anon_sym_function] = ACTIONS(1118),
    [anon_sym_new] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1116),
    [anon_sym_void] = ACTIONS(1118),
    [anon_sym_delete] = ACTIONS(1118),
    [anon_sym_PLUS_PLUS] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1116),
    [anon_sym_DQUOTE] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1116),
    [sym_number] = ACTIONS(1116),
    [sym_this] = ACTIONS(1118),
    [sym_super] = ACTIONS(1118),
    [sym_true] = ACTIONS(1118),
    [sym_false] = ACTIONS(1118),
    [sym_null] = ACTIONS(1118),
    [sym_undefined] = ACTIONS(1118),
    [anon_sym_AT] = ACTIONS(1116),
    [anon_sym_static] = ACTIONS(1118),
    [anon_sym_abstract] = ACTIONS(1118),
    [anon_sym_get] = ACTIONS(1118),
    [anon_sym_set] = ACTIONS(1118),
    [anon_sym_declare] = ACTIONS(1118),
    [anon_sym_public] = ACTIONS(1118),
    [anon_sym_private] = ACTIONS(1118),
    [anon_sym_protected] = ACTIONS(1118),
    [anon_sym_module] = ACTIONS(1118),
    [anon_sym_any] = ACTIONS(1118),
    [anon_sym_number] = ACTIONS(1118),
    [anon_sym_boolean] = ACTIONS(1118),
    [anon_sym_string] = ACTIONS(1118),
    [anon_sym_symbol] = ACTIONS(1118),
    [anon_sym_interface] = ACTIONS(1118),
    [anon_sym_enum] = ACTIONS(1118),
    [sym_readonly] = ACTIONS(1118),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2772),
    [anon_sym_namespace] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_type] = ACTIONS(2772),
    [anon_sym_typeof] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_var] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_switch] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_await] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [anon_sym_do] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_with] = ACTIONS(2772),
    [anon_sym_break] = ACTIONS(2772),
    [anon_sym_continue] = ACTIONS(2772),
    [anon_sym_debugger] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_throw] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2772),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [anon_sym_void] = ACTIONS(2772),
    [anon_sym_delete] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2770),
    [sym_number] = ACTIONS(2770),
    [sym_this] = ACTIONS(2772),
    [sym_super] = ACTIONS(2772),
    [sym_true] = ACTIONS(2772),
    [sym_false] = ACTIONS(2772),
    [sym_null] = ACTIONS(2772),
    [sym_undefined] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_static] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_get] = ACTIONS(2772),
    [anon_sym_set] = ACTIONS(2772),
    [anon_sym_declare] = ACTIONS(2772),
    [anon_sym_public] = ACTIONS(2772),
    [anon_sym_private] = ACTIONS(2772),
    [anon_sym_protected] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_any] = ACTIONS(2772),
    [anon_sym_number] = ACTIONS(2772),
    [anon_sym_boolean] = ACTIONS(2772),
    [anon_sym_string] = ACTIONS(2772),
    [anon_sym_symbol] = ACTIONS(2772),
    [anon_sym_interface] = ACTIONS(2772),
    [anon_sym_enum] = ACTIONS(2772),
    [sym_readonly] = ACTIONS(2772),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_export] = ACTIONS(2776),
    [anon_sym_default] = ACTIONS(2776),
    [anon_sym_namespace] = ACTIONS(2776),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_type] = ACTIONS(2776),
    [anon_sym_typeof] = ACTIONS(2776),
    [anon_sym_import] = ACTIONS(2776),
    [anon_sym_var] = ACTIONS(2776),
    [anon_sym_let] = ACTIONS(2776),
    [anon_sym_const] = ACTIONS(2776),
    [anon_sym_if] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2776),
    [anon_sym_switch] = ACTIONS(2776),
    [anon_sym_for] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(2774),
    [anon_sym_await] = ACTIONS(2776),
    [anon_sym_while] = ACTIONS(2776),
    [anon_sym_do] = ACTIONS(2776),
    [anon_sym_try] = ACTIONS(2776),
    [anon_sym_with] = ACTIONS(2776),
    [anon_sym_break] = ACTIONS(2776),
    [anon_sym_continue] = ACTIONS(2776),
    [anon_sym_debugger] = ACTIONS(2776),
    [anon_sym_return] = ACTIONS(2776),
    [anon_sym_throw] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_case] = ACTIONS(2776),
    [anon_sym_yield] = ACTIONS(2776),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2776),
    [anon_sym_class] = ACTIONS(2776),
    [anon_sym_async] = ACTIONS(2776),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_new] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2776),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2774),
    [anon_sym_void] = ACTIONS(2776),
    [anon_sym_delete] = ACTIONS(2776),
    [anon_sym_PLUS_PLUS] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(2774),
    [anon_sym_SQUOTE] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2774),
    [sym_number] = ACTIONS(2774),
    [sym_this] = ACTIONS(2776),
    [sym_super] = ACTIONS(2776),
    [sym_true] = ACTIONS(2776),
    [sym_false] = ACTIONS(2776),
    [sym_null] = ACTIONS(2776),
    [sym_undefined] = ACTIONS(2776),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_static] = ACTIONS(2776),
    [anon_sym_abstract] = ACTIONS(2776),
    [anon_sym_get] = ACTIONS(2776),
    [anon_sym_set] = ACTIONS(2776),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_public] = ACTIONS(2776),
    [anon_sym_private] = ACTIONS(2776),
    [anon_sym_protected] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(2776),
    [anon_sym_number] = ACTIONS(2776),
    [anon_sym_boolean] = ACTIONS(2776),
    [anon_sym_string] = ACTIONS(2776),
    [anon_sym_symbol] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2776),
    [anon_sym_enum] = ACTIONS(2776),
    [sym_readonly] = ACTIONS(2776),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_default] = ACTIONS(2780),
    [anon_sym_namespace] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_import] = ACTIONS(2780),
    [anon_sym_var] = ACTIONS(2780),
    [anon_sym_let] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_switch] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2778),
    [anon_sym_await] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_try] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_break] = ACTIONS(2780),
    [anon_sym_continue] = ACTIONS(2780),
    [anon_sym_debugger] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_throw] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_case] = ACTIONS(2780),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_function] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2778),
    [anon_sym_TILDE] = ACTIONS(2778),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_delete] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(2778),
    [anon_sym_DQUOTE] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2778),
    [sym_number] = ACTIONS(2778),
    [sym_this] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_AT] = ACTIONS(2778),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_declare] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_module] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_interface] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
    [sym_readonly] = ACTIONS(2780),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_var] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_throw] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_case] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_var] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_else] = ACTIONS(2788),
    [anon_sym_switch] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_do] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [anon_sym_with] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_debugger] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_throw] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_interface] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_default] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_import] = ACTIONS(2792),
    [anon_sym_var] = ACTIONS(2792),
    [anon_sym_let] = ACTIONS(2792),
    [anon_sym_const] = ACTIONS(2792),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_await] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_do] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2792),
    [anon_sym_with] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2792),
    [anon_sym_continue] = ACTIONS(2792),
    [anon_sym_debugger] = ACTIONS(2792),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_throw] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_case] = ACTIONS(2792),
    [anon_sym_yield] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_class] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2792),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_TILDE] = ACTIONS(2790),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_delete] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2790),
    [anon_sym_DASH_DASH] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2792),
    [sym_super] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_AT] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2792),
    [anon_sym_enum] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2796),
    [anon_sym_var] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_else] = ACTIONS(2796),
    [anon_sym_switch] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_await] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_do] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [anon_sym_with] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_debugger] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_throw] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_declare] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_module] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [sym_readonly] = ACTIONS(2796),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2800),
    [anon_sym_import] = ACTIONS(2800),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_else] = ACTIONS(2800),
    [anon_sym_switch] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_await] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_do] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [anon_sym_with] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_debugger] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_throw] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_case] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_SLASH] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_function] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_PLUS] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_void] = ACTIONS(2800),
    [anon_sym_delete] = ACTIONS(2800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [sym_readonly] = ACTIONS(2800),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(2802),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_export] = ACTIONS(2804),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_namespace] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_type] = ACTIONS(2804),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_import] = ACTIONS(2804),
    [anon_sym_var] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2804),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_await] = ACTIONS(2804),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_break] = ACTIONS(2804),
    [anon_sym_continue] = ACTIONS(2804),
    [anon_sym_debugger] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_throw] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_case] = ACTIONS(2804),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2802),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_class] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_void] = ACTIONS(2804),
    [anon_sym_delete] = ACTIONS(2804),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_DQUOTE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2802),
    [sym_number] = ACTIONS(2802),
    [sym_this] = ACTIONS(2804),
    [sym_super] = ACTIONS(2804),
    [sym_true] = ACTIONS(2804),
    [sym_false] = ACTIONS(2804),
    [sym_null] = ACTIONS(2804),
    [sym_undefined] = ACTIONS(2804),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_get] = ACTIONS(2804),
    [anon_sym_set] = ACTIONS(2804),
    [anon_sym_declare] = ACTIONS(2804),
    [anon_sym_public] = ACTIONS(2804),
    [anon_sym_private] = ACTIONS(2804),
    [anon_sym_protected] = ACTIONS(2804),
    [anon_sym_module] = ACTIONS(2804),
    [anon_sym_any] = ACTIONS(2804),
    [anon_sym_number] = ACTIONS(2804),
    [anon_sym_boolean] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_symbol] = ACTIONS(2804),
    [anon_sym_interface] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
    [sym_readonly] = ACTIONS(2804),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(2806),
    [sym_identifier] = ACTIONS(2808),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_default] = ACTIONS(2808),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_LBRACE] = ACTIONS(2806),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_typeof] = ACTIONS(2808),
    [anon_sym_import] = ACTIONS(2808),
    [anon_sym_var] = ACTIONS(2808),
    [anon_sym_let] = ACTIONS(2808),
    [anon_sym_const] = ACTIONS(2808),
    [anon_sym_if] = ACTIONS(2808),
    [anon_sym_else] = ACTIONS(2808),
    [anon_sym_switch] = ACTIONS(2808),
    [anon_sym_for] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2806),
    [anon_sym_await] = ACTIONS(2808),
    [anon_sym_while] = ACTIONS(2808),
    [anon_sym_do] = ACTIONS(2808),
    [anon_sym_try] = ACTIONS(2808),
    [anon_sym_with] = ACTIONS(2808),
    [anon_sym_break] = ACTIONS(2808),
    [anon_sym_continue] = ACTIONS(2808),
    [anon_sym_debugger] = ACTIONS(2808),
    [anon_sym_return] = ACTIONS(2808),
    [anon_sym_throw] = ACTIONS(2808),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_yield] = ACTIONS(2808),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_SLASH] = ACTIONS(2808),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2808),
    [anon_sym_new] = ACTIONS(2808),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_BANG] = ACTIONS(2806),
    [anon_sym_TILDE] = ACTIONS(2806),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(2806),
    [anon_sym_DASH_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(2806),
    [anon_sym_SQUOTE] = ACTIONS(2806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2806),
    [sym_number] = ACTIONS(2806),
    [sym_this] = ACTIONS(2808),
    [sym_super] = ACTIONS(2808),
    [sym_true] = ACTIONS(2808),
    [sym_false] = ACTIONS(2808),
    [sym_null] = ACTIONS(2808),
    [sym_undefined] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(2806),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_abstract] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [anon_sym_interface] = ACTIONS(2808),
    [anon_sym_enum] = ACTIONS(2808),
    [sym_readonly] = ACTIONS(2808),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(2810),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_typeof] = ACTIONS(2812),
    [anon_sym_import] = ACTIONS(2812),
    [anon_sym_var] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_switch] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_await] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_break] = ACTIONS(2812),
    [anon_sym_continue] = ACTIONS(2812),
    [anon_sym_debugger] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_throw] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_case] = ACTIONS(2812),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2810),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_SLASH] = ACTIONS(2812),
    [anon_sym_class] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_BANG] = ACTIONS(2810),
    [anon_sym_TILDE] = ACTIONS(2810),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_delete] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2810),
    [anon_sym_DASH_DASH] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2810),
    [sym_number] = ACTIONS(2810),
    [sym_this] = ACTIONS(2812),
    [sym_super] = ACTIONS(2812),
    [sym_true] = ACTIONS(2812),
    [sym_false] = ACTIONS(2812),
    [sym_null] = ACTIONS(2812),
    [sym_undefined] = ACTIONS(2812),
    [anon_sym_AT] = ACTIONS(2810),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [anon_sym_interface] = ACTIONS(2812),
    [anon_sym_enum] = ACTIONS(2812),
    [sym_readonly] = ACTIONS(2812),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(2814),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_function] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [sym_false] = ACTIONS(2816),
    [sym_null] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [sym_readonly] = ACTIONS(2816),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_export] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_namespace] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_import] = ACTIONS(2820),
    [anon_sym_var] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2820),
    [anon_sym_switch] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_do] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [anon_sym_with] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_debugger] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_throw] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2820),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_SLASH] = ACTIONS(2820),
    [anon_sym_class] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2820),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_delete] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_declare] = ACTIONS(2820),
    [anon_sym_public] = ACTIONS(2820),
    [anon_sym_private] = ACTIONS(2820),
    [anon_sym_protected] = ACTIONS(2820),
    [anon_sym_module] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
    [sym_readonly] = ACTIONS(2820),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_typeof] = ACTIONS(2824),
    [anon_sym_import] = ACTIONS(2824),
    [anon_sym_var] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_await] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_do] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [anon_sym_with] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_debugger] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2824),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2824),
    [anon_sym_class] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2824),
    [anon_sym_new] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_TILDE] = ACTIONS(2822),
    [anon_sym_void] = ACTIONS(2824),
    [anon_sym_delete] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_true] = ACTIONS(2824),
    [sym_false] = ACTIONS(2824),
    [sym_null] = ACTIONS(2824),
    [sym_undefined] = ACTIONS(2824),
    [anon_sym_AT] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2824),
    [anon_sym_get] = ACTIONS(2824),
    [anon_sym_set] = ACTIONS(2824),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2824),
    [anon_sym_private] = ACTIONS(2824),
    [anon_sym_protected] = ACTIONS(2824),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
    [sym_readonly] = ACTIONS(2824),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_export] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_namespace] = ACTIONS(2828),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_typeof] = ACTIONS(2828),
    [anon_sym_import] = ACTIONS(2828),
    [anon_sym_var] = ACTIONS(2828),
    [anon_sym_let] = ACTIONS(2828),
    [anon_sym_const] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2828),
    [anon_sym_else] = ACTIONS(2828),
    [anon_sym_switch] = ACTIONS(2828),
    [anon_sym_for] = ACTIONS(2828),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_await] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2828),
    [anon_sym_do] = ACTIONS(2828),
    [anon_sym_try] = ACTIONS(2828),
    [anon_sym_with] = ACTIONS(2828),
    [anon_sym_break] = ACTIONS(2828),
    [anon_sym_continue] = ACTIONS(2828),
    [anon_sym_debugger] = ACTIONS(2828),
    [anon_sym_return] = ACTIONS(2828),
    [anon_sym_throw] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2828),
    [anon_sym_yield] = ACTIONS(2828),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2828),
    [anon_sym_class] = ACTIONS(2828),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2828),
    [anon_sym_new] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_TILDE] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2828),
    [anon_sym_delete] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_super] = ACTIONS(2828),
    [sym_true] = ACTIONS(2828),
    [sym_false] = ACTIONS(2828),
    [sym_null] = ACTIONS(2828),
    [sym_undefined] = ACTIONS(2828),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_abstract] = ACTIONS(2828),
    [anon_sym_get] = ACTIONS(2828),
    [anon_sym_set] = ACTIONS(2828),
    [anon_sym_declare] = ACTIONS(2828),
    [anon_sym_public] = ACTIONS(2828),
    [anon_sym_private] = ACTIONS(2828),
    [anon_sym_protected] = ACTIONS(2828),
    [anon_sym_module] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(2828),
    [anon_sym_number] = ACTIONS(2828),
    [anon_sym_boolean] = ACTIONS(2828),
    [anon_sym_string] = ACTIONS(2828),
    [anon_sym_symbol] = ACTIONS(2828),
    [anon_sym_interface] = ACTIONS(2828),
    [anon_sym_enum] = ACTIONS(2828),
    [sym_readonly] = ACTIONS(2828),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(2830),
    [sym_identifier] = ACTIONS(2832),
    [anon_sym_export] = ACTIONS(2832),
    [anon_sym_default] = ACTIONS(2832),
    [anon_sym_namespace] = ACTIONS(2832),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_type] = ACTIONS(2832),
    [anon_sym_typeof] = ACTIONS(2832),
    [anon_sym_import] = ACTIONS(2832),
    [anon_sym_var] = ACTIONS(2832),
    [anon_sym_let] = ACTIONS(2832),
    [anon_sym_const] = ACTIONS(2832),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_else] = ACTIONS(2832),
    [anon_sym_switch] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2832),
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_await] = ACTIONS(2832),
    [anon_sym_while] = ACTIONS(2832),
    [anon_sym_do] = ACTIONS(2832),
    [anon_sym_try] = ACTIONS(2832),
    [anon_sym_with] = ACTIONS(2832),
    [anon_sym_break] = ACTIONS(2832),
    [anon_sym_continue] = ACTIONS(2832),
    [anon_sym_debugger] = ACTIONS(2832),
    [anon_sym_return] = ACTIONS(2832),
    [anon_sym_throw] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2832),
    [anon_sym_yield] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_SLASH] = ACTIONS(2832),
    [anon_sym_class] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2832),
    [anon_sym_function] = ACTIONS(2832),
    [anon_sym_new] = ACTIONS(2832),
    [anon_sym_PLUS] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_void] = ACTIONS(2832),
    [anon_sym_delete] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_number] = ACTIONS(2830),
    [sym_this] = ACTIONS(2832),
    [sym_super] = ACTIONS(2832),
    [sym_true] = ACTIONS(2832),
    [sym_false] = ACTIONS(2832),
    [sym_null] = ACTIONS(2832),
    [sym_undefined] = ACTIONS(2832),
    [anon_sym_AT] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_abstract] = ACTIONS(2832),
    [anon_sym_get] = ACTIONS(2832),
    [anon_sym_set] = ACTIONS(2832),
    [anon_sym_declare] = ACTIONS(2832),
    [anon_sym_public] = ACTIONS(2832),
    [anon_sym_private] = ACTIONS(2832),
    [anon_sym_protected] = ACTIONS(2832),
    [anon_sym_module] = ACTIONS(2832),
    [anon_sym_any] = ACTIONS(2832),
    [anon_sym_number] = ACTIONS(2832),
    [anon_sym_boolean] = ACTIONS(2832),
    [anon_sym_string] = ACTIONS(2832),
    [anon_sym_symbol] = ACTIONS(2832),
    [anon_sym_interface] = ACTIONS(2832),
    [anon_sym_enum] = ACTIONS(2832),
    [sym_readonly] = ACTIONS(2832),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(2836),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_await] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_with] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_debugger] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_function] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_TILDE] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [sym_number] = ACTIONS(2834),
    [sym_this] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_undefined] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_abstract] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [sym_readonly] = ACTIONS(2836),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(2838),
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_export] = ACTIONS(2840),
    [anon_sym_default] = ACTIONS(2840),
    [anon_sym_namespace] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_typeof] = ACTIONS(2840),
    [anon_sym_import] = ACTIONS(2840),
    [anon_sym_var] = ACTIONS(2840),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2840),
    [anon_sym_if] = ACTIONS(2840),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2840),
    [anon_sym_LPAREN] = ACTIONS(2838),
    [anon_sym_await] = ACTIONS(2840),
    [anon_sym_while] = ACTIONS(2840),
    [anon_sym_do] = ACTIONS(2840),
    [anon_sym_try] = ACTIONS(2840),
    [anon_sym_with] = ACTIONS(2840),
    [anon_sym_break] = ACTIONS(2840),
    [anon_sym_continue] = ACTIONS(2840),
    [anon_sym_debugger] = ACTIONS(2840),
    [anon_sym_return] = ACTIONS(2840),
    [anon_sym_throw] = ACTIONS(2840),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2840),
    [anon_sym_yield] = ACTIONS(2840),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_SLASH] = ACTIONS(2840),
    [anon_sym_class] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_function] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_void] = ACTIONS(2840),
    [anon_sym_delete] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2838),
    [sym_number] = ACTIONS(2838),
    [sym_this] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [sym_true] = ACTIONS(2840),
    [sym_false] = ACTIONS(2840),
    [sym_null] = ACTIONS(2840),
    [sym_undefined] = ACTIONS(2840),
    [anon_sym_AT] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_abstract] = ACTIONS(2840),
    [anon_sym_get] = ACTIONS(2840),
    [anon_sym_set] = ACTIONS(2840),
    [anon_sym_declare] = ACTIONS(2840),
    [anon_sym_public] = ACTIONS(2840),
    [anon_sym_private] = ACTIONS(2840),
    [anon_sym_protected] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2840),
    [anon_sym_any] = ACTIONS(2840),
    [anon_sym_number] = ACTIONS(2840),
    [anon_sym_boolean] = ACTIONS(2840),
    [anon_sym_string] = ACTIONS(2840),
    [anon_sym_symbol] = ACTIONS(2840),
    [anon_sym_interface] = ACTIONS(2840),
    [anon_sym_enum] = ACTIONS(2840),
    [sym_readonly] = ACTIONS(2840),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(2842),
    [sym_identifier] = ACTIONS(2844),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_default] = ACTIONS(2844),
    [anon_sym_namespace] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_type] = ACTIONS(2844),
    [anon_sym_typeof] = ACTIONS(2844),
    [anon_sym_import] = ACTIONS(2844),
    [anon_sym_var] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_const] = ACTIONS(2844),
    [anon_sym_if] = ACTIONS(2844),
    [anon_sym_else] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_for] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [anon_sym_await] = ACTIONS(2844),
    [anon_sym_while] = ACTIONS(2844),
    [anon_sym_do] = ACTIONS(2844),
    [anon_sym_try] = ACTIONS(2844),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_break] = ACTIONS(2844),
    [anon_sym_continue] = ACTIONS(2844),
    [anon_sym_debugger] = ACTIONS(2844),
    [anon_sym_return] = ACTIONS(2844),
    [anon_sym_throw] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_class] = ACTIONS(2844),
    [anon_sym_async] = ACTIONS(2844),
    [anon_sym_function] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_void] = ACTIONS(2844),
    [anon_sym_delete] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2842),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_SQUOTE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2842),
    [sym_number] = ACTIONS(2842),
    [sym_this] = ACTIONS(2844),
    [sym_super] = ACTIONS(2844),
    [sym_true] = ACTIONS(2844),
    [sym_false] = ACTIONS(2844),
    [sym_null] = ACTIONS(2844),
    [sym_undefined] = ACTIONS(2844),
    [anon_sym_AT] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2844),
    [anon_sym_abstract] = ACTIONS(2844),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_declare] = ACTIONS(2844),
    [anon_sym_public] = ACTIONS(2844),
    [anon_sym_private] = ACTIONS(2844),
    [anon_sym_protected] = ACTIONS(2844),
    [anon_sym_module] = ACTIONS(2844),
    [anon_sym_any] = ACTIONS(2844),
    [anon_sym_number] = ACTIONS(2844),
    [anon_sym_boolean] = ACTIONS(2844),
    [anon_sym_string] = ACTIONS(2844),
    [anon_sym_symbol] = ACTIONS(2844),
    [anon_sym_interface] = ACTIONS(2844),
    [anon_sym_enum] = ACTIONS(2844),
    [sym_readonly] = ACTIONS(2844),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(2846),
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_export] = ACTIONS(2848),
    [anon_sym_default] = ACTIONS(2848),
    [anon_sym_namespace] = ACTIONS(2848),
    [anon_sym_LBRACE] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_type] = ACTIONS(2848),
    [anon_sym_typeof] = ACTIONS(2848),
    [anon_sym_import] = ACTIONS(2848),
    [anon_sym_var] = ACTIONS(2848),
    [anon_sym_let] = ACTIONS(2848),
    [anon_sym_const] = ACTIONS(2848),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_else] = ACTIONS(2848),
    [anon_sym_switch] = ACTIONS(2848),
    [anon_sym_for] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2846),
    [anon_sym_await] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_try] = ACTIONS(2848),
    [anon_sym_with] = ACTIONS(2848),
    [anon_sym_break] = ACTIONS(2848),
    [anon_sym_continue] = ACTIONS(2848),
    [anon_sym_debugger] = ACTIONS(2848),
    [anon_sym_return] = ACTIONS(2848),
    [anon_sym_throw] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2848),
    [anon_sym_yield] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_LT] = ACTIONS(2846),
    [anon_sym_SLASH] = ACTIONS(2848),
    [anon_sym_class] = ACTIONS(2848),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2848),
    [anon_sym_new] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_TILDE] = ACTIONS(2846),
    [anon_sym_void] = ACTIONS(2848),
    [anon_sym_delete] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2846),
    [anon_sym_DQUOTE] = ACTIONS(2846),
    [anon_sym_SQUOTE] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2846),
    [sym_number] = ACTIONS(2846),
    [sym_this] = ACTIONS(2848),
    [sym_super] = ACTIONS(2848),
    [sym_true] = ACTIONS(2848),
    [sym_false] = ACTIONS(2848),
    [sym_null] = ACTIONS(2848),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_AT] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_abstract] = ACTIONS(2848),
    [anon_sym_get] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(2848),
    [anon_sym_declare] = ACTIONS(2848),
    [anon_sym_public] = ACTIONS(2848),
    [anon_sym_private] = ACTIONS(2848),
    [anon_sym_protected] = ACTIONS(2848),
    [anon_sym_module] = ACTIONS(2848),
    [anon_sym_any] = ACTIONS(2848),
    [anon_sym_number] = ACTIONS(2848),
    [anon_sym_boolean] = ACTIONS(2848),
    [anon_sym_string] = ACTIONS(2848),
    [anon_sym_symbol] = ACTIONS(2848),
    [anon_sym_interface] = ACTIONS(2848),
    [anon_sym_enum] = ACTIONS(2848),
    [sym_readonly] = ACTIONS(2848),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_default] = ACTIONS(2852),
    [anon_sym_namespace] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_type] = ACTIONS(2852),
    [anon_sym_typeof] = ACTIONS(2852),
    [anon_sym_import] = ACTIONS(2852),
    [anon_sym_var] = ACTIONS(2852),
    [anon_sym_let] = ACTIONS(2852),
    [anon_sym_const] = ACTIONS(2852),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_switch] = ACTIONS(2852),
    [anon_sym_for] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2850),
    [anon_sym_await] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2852),
    [anon_sym_break] = ACTIONS(2852),
    [anon_sym_continue] = ACTIONS(2852),
    [anon_sym_debugger] = ACTIONS(2852),
    [anon_sym_return] = ACTIONS(2852),
    [anon_sym_throw] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2852),
    [anon_sym_yield] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_class] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_function] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_TILDE] = ACTIONS(2850),
    [anon_sym_void] = ACTIONS(2852),
    [anon_sym_delete] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2850),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_SQUOTE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2850),
    [sym_number] = ACTIONS(2850),
    [sym_this] = ACTIONS(2852),
    [sym_super] = ACTIONS(2852),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_AT] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_abstract] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(2852),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_public] = ACTIONS(2852),
    [anon_sym_private] = ACTIONS(2852),
    [anon_sym_protected] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2852),
    [anon_sym_any] = ACTIONS(2852),
    [anon_sym_number] = ACTIONS(2852),
    [anon_sym_boolean] = ACTIONS(2852),
    [anon_sym_string] = ACTIONS(2852),
    [anon_sym_symbol] = ACTIONS(2852),
    [anon_sym_interface] = ACTIONS(2852),
    [anon_sym_enum] = ACTIONS(2852),
    [sym_readonly] = ACTIONS(2852),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(2854),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_export] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_typeof] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_await] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_with] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_debugger] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_yield] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2854),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_function] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_void] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_number] = ACTIONS(2854),
    [sym_this] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [sym_null] = ACTIONS(2856),
    [sym_undefined] = ACTIONS(2856),
    [anon_sym_AT] = ACTIONS(2854),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2856),
    [anon_sym_set] = ACTIONS(2856),
    [anon_sym_declare] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_module] = ACTIONS(2856),
    [anon_sym_any] = ACTIONS(2856),
    [anon_sym_number] = ACTIONS(2856),
    [anon_sym_boolean] = ACTIONS(2856),
    [anon_sym_string] = ACTIONS(2856),
    [anon_sym_symbol] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [sym_readonly] = ACTIONS(2856),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(2858),
    [sym_identifier] = ACTIONS(2860),
    [anon_sym_export] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_type] = ACTIONS(2860),
    [anon_sym_typeof] = ACTIONS(2860),
    [anon_sym_import] = ACTIONS(2860),
    [anon_sym_var] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_else] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_await] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_with] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_debugger] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_yield] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_async] = ACTIONS(2860),
    [anon_sym_function] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_void] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2858),
    [sym_number] = ACTIONS(2858),
    [sym_this] = ACTIONS(2860),
    [sym_super] = ACTIONS(2860),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_undefined] = ACTIONS(2860),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_abstract] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_declare] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2860),
    [anon_sym_any] = ACTIONS(2860),
    [anon_sym_number] = ACTIONS(2860),
    [anon_sym_boolean] = ACTIONS(2860),
    [anon_sym_string] = ACTIONS(2860),
    [anon_sym_symbol] = ACTIONS(2860),
    [anon_sym_interface] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [sym_readonly] = ACTIONS(2860),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2864),
    [anon_sym_export] = ACTIONS(2864),
    [anon_sym_default] = ACTIONS(2864),
    [anon_sym_namespace] = ACTIONS(2864),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_type] = ACTIONS(2864),
    [anon_sym_typeof] = ACTIONS(2864),
    [anon_sym_import] = ACTIONS(2864),
    [anon_sym_var] = ACTIONS(2864),
    [anon_sym_let] = ACTIONS(2864),
    [anon_sym_const] = ACTIONS(2864),
    [anon_sym_if] = ACTIONS(2864),
    [anon_sym_else] = ACTIONS(2864),
    [anon_sym_switch] = ACTIONS(2864),
    [anon_sym_for] = ACTIONS(2864),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_await] = ACTIONS(2864),
    [anon_sym_while] = ACTIONS(2864),
    [anon_sym_do] = ACTIONS(2864),
    [anon_sym_try] = ACTIONS(2864),
    [anon_sym_with] = ACTIONS(2864),
    [anon_sym_break] = ACTIONS(2864),
    [anon_sym_continue] = ACTIONS(2864),
    [anon_sym_debugger] = ACTIONS(2864),
    [anon_sym_return] = ACTIONS(2864),
    [anon_sym_throw] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_case] = ACTIONS(2864),
    [anon_sym_yield] = ACTIONS(2864),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2862),
    [anon_sym_SLASH] = ACTIONS(2864),
    [anon_sym_class] = ACTIONS(2864),
    [anon_sym_async] = ACTIONS(2864),
    [anon_sym_function] = ACTIONS(2864),
    [anon_sym_new] = ACTIONS(2864),
    [anon_sym_PLUS] = ACTIONS(2864),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_void] = ACTIONS(2864),
    [anon_sym_delete] = ACTIONS(2864),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_number] = ACTIONS(2862),
    [sym_this] = ACTIONS(2864),
    [sym_super] = ACTIONS(2864),
    [sym_true] = ACTIONS(2864),
    [sym_false] = ACTIONS(2864),
    [sym_null] = ACTIONS(2864),
    [sym_undefined] = ACTIONS(2864),
    [anon_sym_AT] = ACTIONS(2862),
    [anon_sym_static] = ACTIONS(2864),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_get] = ACTIONS(2864),
    [anon_sym_set] = ACTIONS(2864),
    [anon_sym_declare] = ACTIONS(2864),
    [anon_sym_public] = ACTIONS(2864),
    [anon_sym_private] = ACTIONS(2864),
    [anon_sym_protected] = ACTIONS(2864),
    [anon_sym_module] = ACTIONS(2864),
    [anon_sym_any] = ACTIONS(2864),
    [anon_sym_number] = ACTIONS(2864),
    [anon_sym_boolean] = ACTIONS(2864),
    [anon_sym_string] = ACTIONS(2864),
    [anon_sym_symbol] = ACTIONS(2864),
    [anon_sym_interface] = ACTIONS(2864),
    [anon_sym_enum] = ACTIONS(2864),
    [sym_readonly] = ACTIONS(2864),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(2866),
    [sym_identifier] = ACTIONS(2868),
    [anon_sym_export] = ACTIONS(2868),
    [anon_sym_default] = ACTIONS(2868),
    [anon_sym_namespace] = ACTIONS(2868),
    [anon_sym_LBRACE] = ACTIONS(2866),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_type] = ACTIONS(2868),
    [anon_sym_typeof] = ACTIONS(2868),
    [anon_sym_import] = ACTIONS(2868),
    [anon_sym_var] = ACTIONS(2868),
    [anon_sym_let] = ACTIONS(2868),
    [anon_sym_const] = ACTIONS(2868),
    [anon_sym_if] = ACTIONS(2868),
    [anon_sym_else] = ACTIONS(2868),
    [anon_sym_switch] = ACTIONS(2868),
    [anon_sym_for] = ACTIONS(2868),
    [anon_sym_LPAREN] = ACTIONS(2866),
    [anon_sym_await] = ACTIONS(2868),
    [anon_sym_while] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2868),
    [anon_sym_try] = ACTIONS(2868),
    [anon_sym_with] = ACTIONS(2868),
    [anon_sym_break] = ACTIONS(2868),
    [anon_sym_continue] = ACTIONS(2868),
    [anon_sym_debugger] = ACTIONS(2868),
    [anon_sym_return] = ACTIONS(2868),
    [anon_sym_throw] = ACTIONS(2868),
    [anon_sym_SEMI] = ACTIONS(2866),
    [anon_sym_case] = ACTIONS(2868),
    [anon_sym_yield] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2868),
    [anon_sym_class] = ACTIONS(2868),
    [anon_sym_async] = ACTIONS(2868),
    [anon_sym_function] = ACTIONS(2868),
    [anon_sym_new] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2868),
    [anon_sym_DASH] = ACTIONS(2868),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_TILDE] = ACTIONS(2866),
    [anon_sym_void] = ACTIONS(2868),
    [anon_sym_delete] = ACTIONS(2868),
    [anon_sym_PLUS_PLUS] = ACTIONS(2866),
    [anon_sym_DASH_DASH] = ACTIONS(2866),
    [anon_sym_DQUOTE] = ACTIONS(2866),
    [anon_sym_SQUOTE] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [sym_number] = ACTIONS(2866),
    [sym_this] = ACTIONS(2868),
    [sym_super] = ACTIONS(2868),
    [sym_true] = ACTIONS(2868),
    [sym_false] = ACTIONS(2868),
    [sym_null] = ACTIONS(2868),
    [sym_undefined] = ACTIONS(2868),
    [anon_sym_AT] = ACTIONS(2866),
    [anon_sym_static] = ACTIONS(2868),
    [anon_sym_abstract] = ACTIONS(2868),
    [anon_sym_get] = ACTIONS(2868),
    [anon_sym_set] = ACTIONS(2868),
    [anon_sym_declare] = ACTIONS(2868),
    [anon_sym_public] = ACTIONS(2868),
    [anon_sym_private] = ACTIONS(2868),
    [anon_sym_protected] = ACTIONS(2868),
    [anon_sym_module] = ACTIONS(2868),
    [anon_sym_any] = ACTIONS(2868),
    [anon_sym_number] = ACTIONS(2868),
    [anon_sym_boolean] = ACTIONS(2868),
    [anon_sym_string] = ACTIONS(2868),
    [anon_sym_symbol] = ACTIONS(2868),
    [anon_sym_interface] = ACTIONS(2868),
    [anon_sym_enum] = ACTIONS(2868),
    [sym_readonly] = ACTIONS(2868),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(2870),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_export] = ACTIONS(2872),
    [anon_sym_default] = ACTIONS(2872),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_type] = ACTIONS(2872),
    [anon_sym_typeof] = ACTIONS(2872),
    [anon_sym_import] = ACTIONS(2872),
    [anon_sym_var] = ACTIONS(2872),
    [anon_sym_let] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2872),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2872),
    [anon_sym_switch] = ACTIONS(2872),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_await] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_do] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2872),
    [anon_sym_with] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2872),
    [anon_sym_debugger] = ACTIONS(2872),
    [anon_sym_return] = ACTIONS(2872),
    [anon_sym_throw] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2870),
    [anon_sym_case] = ACTIONS(2872),
    [anon_sym_yield] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2870),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2872),
    [anon_sym_async] = ACTIONS(2872),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_new] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_void] = ACTIONS(2872),
    [anon_sym_delete] = ACTIONS(2872),
    [anon_sym_PLUS_PLUS] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2870),
    [anon_sym_DQUOTE] = ACTIONS(2870),
    [anon_sym_SQUOTE] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym_this] = ACTIONS(2872),
    [sym_super] = ACTIONS(2872),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_null] = ACTIONS(2872),
    [sym_undefined] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_static] = ACTIONS(2872),
    [anon_sym_abstract] = ACTIONS(2872),
    [anon_sym_get] = ACTIONS(2872),
    [anon_sym_set] = ACTIONS(2872),
    [anon_sym_declare] = ACTIONS(2872),
    [anon_sym_public] = ACTIONS(2872),
    [anon_sym_private] = ACTIONS(2872),
    [anon_sym_protected] = ACTIONS(2872),
    [anon_sym_module] = ACTIONS(2872),
    [anon_sym_any] = ACTIONS(2872),
    [anon_sym_number] = ACTIONS(2872),
    [anon_sym_boolean] = ACTIONS(2872),
    [anon_sym_string] = ACTIONS(2872),
    [anon_sym_symbol] = ACTIONS(2872),
    [anon_sym_interface] = ACTIONS(2872),
    [anon_sym_enum] = ACTIONS(2872),
    [sym_readonly] = ACTIONS(2872),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(2874),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2876),
    [anon_sym_default] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_typeof] = ACTIONS(2876),
    [anon_sym_import] = ACTIONS(2876),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2876),
    [anon_sym_switch] = ACTIONS(2876),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_await] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_do] = ACTIONS(2876),
    [anon_sym_try] = ACTIONS(2876),
    [anon_sym_with] = ACTIONS(2876),
    [anon_sym_break] = ACTIONS(2876),
    [anon_sym_continue] = ACTIONS(2876),
    [anon_sym_debugger] = ACTIONS(2876),
    [anon_sym_return] = ACTIONS(2876),
    [anon_sym_throw] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_case] = ACTIONS(2876),
    [anon_sym_yield] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2874),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_class] = ACTIONS(2876),
    [anon_sym_async] = ACTIONS(2876),
    [anon_sym_function] = ACTIONS(2876),
    [anon_sym_new] = ACTIONS(2876),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_void] = ACTIONS(2876),
    [anon_sym_delete] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2874),
    [sym_number] = ACTIONS(2874),
    [sym_this] = ACTIONS(2876),
    [sym_super] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_null] = ACTIONS(2876),
    [sym_undefined] = ACTIONS(2876),
    [anon_sym_AT] = ACTIONS(2874),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2876),
    [anon_sym_get] = ACTIONS(2876),
    [anon_sym_set] = ACTIONS(2876),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2876),
    [anon_sym_private] = ACTIONS(2876),
    [anon_sym_protected] = ACTIONS(2876),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_interface] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
    [sym_readonly] = ACTIONS(2876),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(2878),
    [sym_identifier] = ACTIONS(2880),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_default] = ACTIONS(2880),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_typeof] = ACTIONS(2880),
    [anon_sym_import] = ACTIONS(2880),
    [anon_sym_var] = ACTIONS(2880),
    [anon_sym_let] = ACTIONS(2880),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_else] = ACTIONS(2880),
    [anon_sym_switch] = ACTIONS(2880),
    [anon_sym_for] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [anon_sym_await] = ACTIONS(2880),
    [anon_sym_while] = ACTIONS(2880),
    [anon_sym_do] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2880),
    [anon_sym_with] = ACTIONS(2880),
    [anon_sym_break] = ACTIONS(2880),
    [anon_sym_continue] = ACTIONS(2880),
    [anon_sym_debugger] = ACTIONS(2880),
    [anon_sym_return] = ACTIONS(2880),
    [anon_sym_throw] = ACTIONS(2880),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_case] = ACTIONS(2880),
    [anon_sym_yield] = ACTIONS(2880),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_SLASH] = ACTIONS(2880),
    [anon_sym_class] = ACTIONS(2880),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_function] = ACTIONS(2880),
    [anon_sym_new] = ACTIONS(2880),
    [anon_sym_PLUS] = ACTIONS(2880),
    [anon_sym_DASH] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(2878),
    [anon_sym_TILDE] = ACTIONS(2878),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_delete] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2878),
    [anon_sym_DASH_DASH] = ACTIONS(2878),
    [anon_sym_DQUOTE] = ACTIONS(2878),
    [anon_sym_SQUOTE] = ACTIONS(2878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2878),
    [sym_number] = ACTIONS(2878),
    [sym_this] = ACTIONS(2880),
    [sym_super] = ACTIONS(2880),
    [sym_true] = ACTIONS(2880),
    [sym_false] = ACTIONS(2880),
    [sym_null] = ACTIONS(2880),
    [sym_undefined] = ACTIONS(2880),
    [anon_sym_AT] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_abstract] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [anon_sym_interface] = ACTIONS(2880),
    [anon_sym_enum] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(2880),
  },
  [574] = {
    [sym__call_signature] = STATE(3045),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_export] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2685),
    [anon_sym_public] = ACTIONS(2685),
    [anon_sym_private] = ACTIONS(2685),
    [anon_sym_protected] = ACTIONS(2685),
    [anon_sym_module] = ACTIONS(2685),
    [anon_sym_any] = ACTIONS(2685),
    [anon_sym_number] = ACTIONS(2685),
    [anon_sym_boolean] = ACTIONS(2685),
    [anon_sym_string] = ACTIONS(2685),
    [anon_sym_symbol] = ACTIONS(2685),
    [sym_readonly] = ACTIONS(2685),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2882),
    [sym_identifier] = ACTIONS(2884),
    [anon_sym_export] = ACTIONS(2884),
    [anon_sym_default] = ACTIONS(2884),
    [anon_sym_namespace] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2884),
    [anon_sym_typeof] = ACTIONS(2884),
    [anon_sym_import] = ACTIONS(2884),
    [anon_sym_var] = ACTIONS(2884),
    [anon_sym_let] = ACTIONS(2884),
    [anon_sym_const] = ACTIONS(2884),
    [anon_sym_if] = ACTIONS(2884),
    [anon_sym_else] = ACTIONS(2884),
    [anon_sym_switch] = ACTIONS(2884),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_LPAREN] = ACTIONS(2882),
    [anon_sym_await] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2884),
    [anon_sym_do] = ACTIONS(2884),
    [anon_sym_try] = ACTIONS(2884),
    [anon_sym_with] = ACTIONS(2884),
    [anon_sym_break] = ACTIONS(2884),
    [anon_sym_continue] = ACTIONS(2884),
    [anon_sym_debugger] = ACTIONS(2884),
    [anon_sym_return] = ACTIONS(2884),
    [anon_sym_throw] = ACTIONS(2884),
    [anon_sym_SEMI] = ACTIONS(2882),
    [anon_sym_case] = ACTIONS(2884),
    [anon_sym_yield] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2882),
    [anon_sym_LT] = ACTIONS(2882),
    [anon_sym_SLASH] = ACTIONS(2884),
    [anon_sym_class] = ACTIONS(2884),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_function] = ACTIONS(2884),
    [anon_sym_new] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2884),
    [anon_sym_BANG] = ACTIONS(2882),
    [anon_sym_TILDE] = ACTIONS(2882),
    [anon_sym_void] = ACTIONS(2884),
    [anon_sym_delete] = ACTIONS(2884),
    [anon_sym_PLUS_PLUS] = ACTIONS(2882),
    [anon_sym_DASH_DASH] = ACTIONS(2882),
    [anon_sym_DQUOTE] = ACTIONS(2882),
    [anon_sym_SQUOTE] = ACTIONS(2882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2882),
    [sym_number] = ACTIONS(2882),
    [sym_this] = ACTIONS(2884),
    [sym_super] = ACTIONS(2884),
    [sym_true] = ACTIONS(2884),
    [sym_false] = ACTIONS(2884),
    [sym_null] = ACTIONS(2884),
    [sym_undefined] = ACTIONS(2884),
    [anon_sym_AT] = ACTIONS(2882),
    [anon_sym_static] = ACTIONS(2884),
    [anon_sym_abstract] = ACTIONS(2884),
    [anon_sym_get] = ACTIONS(2884),
    [anon_sym_set] = ACTIONS(2884),
    [anon_sym_declare] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2884),
    [anon_sym_private] = ACTIONS(2884),
    [anon_sym_protected] = ACTIONS(2884),
    [anon_sym_module] = ACTIONS(2884),
    [anon_sym_any] = ACTIONS(2884),
    [anon_sym_number] = ACTIONS(2884),
    [anon_sym_boolean] = ACTIONS(2884),
    [anon_sym_string] = ACTIONS(2884),
    [anon_sym_symbol] = ACTIONS(2884),
    [anon_sym_interface] = ACTIONS(2884),
    [anon_sym_enum] = ACTIONS(2884),
    [sym_readonly] = ACTIONS(2884),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(2886),
    [sym_identifier] = ACTIONS(2888),
    [anon_sym_export] = ACTIONS(2888),
    [anon_sym_default] = ACTIONS(2888),
    [anon_sym_namespace] = ACTIONS(2888),
    [anon_sym_LBRACE] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_type] = ACTIONS(2888),
    [anon_sym_typeof] = ACTIONS(2888),
    [anon_sym_import] = ACTIONS(2888),
    [anon_sym_var] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_const] = ACTIONS(2888),
    [anon_sym_if] = ACTIONS(2888),
    [anon_sym_else] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2888),
    [anon_sym_for] = ACTIONS(2888),
    [anon_sym_LPAREN] = ACTIONS(2886),
    [anon_sym_await] = ACTIONS(2888),
    [anon_sym_while] = ACTIONS(2888),
    [anon_sym_do] = ACTIONS(2888),
    [anon_sym_try] = ACTIONS(2888),
    [anon_sym_with] = ACTIONS(2888),
    [anon_sym_break] = ACTIONS(2888),
    [anon_sym_continue] = ACTIONS(2888),
    [anon_sym_debugger] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2888),
    [anon_sym_throw] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(2886),
    [anon_sym_case] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_LBRACK] = ACTIONS(2886),
    [anon_sym_LT] = ACTIONS(2886),
    [anon_sym_SLASH] = ACTIONS(2888),
    [anon_sym_class] = ACTIONS(2888),
    [anon_sym_async] = ACTIONS(2888),
    [anon_sym_function] = ACTIONS(2888),
    [anon_sym_new] = ACTIONS(2888),
    [anon_sym_PLUS] = ACTIONS(2888),
    [anon_sym_DASH] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2886),
    [anon_sym_TILDE] = ACTIONS(2886),
    [anon_sym_void] = ACTIONS(2888),
    [anon_sym_delete] = ACTIONS(2888),
    [anon_sym_PLUS_PLUS] = ACTIONS(2886),
    [anon_sym_DASH_DASH] = ACTIONS(2886),
    [anon_sym_DQUOTE] = ACTIONS(2886),
    [anon_sym_SQUOTE] = ACTIONS(2886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2886),
    [sym_number] = ACTIONS(2886),
    [sym_this] = ACTIONS(2888),
    [sym_super] = ACTIONS(2888),
    [sym_true] = ACTIONS(2888),
    [sym_false] = ACTIONS(2888),
    [sym_null] = ACTIONS(2888),
    [sym_undefined] = ACTIONS(2888),
    [anon_sym_AT] = ACTIONS(2886),
    [anon_sym_static] = ACTIONS(2888),
    [anon_sym_abstract] = ACTIONS(2888),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_declare] = ACTIONS(2888),
    [anon_sym_public] = ACTIONS(2888),
    [anon_sym_private] = ACTIONS(2888),
    [anon_sym_protected] = ACTIONS(2888),
    [anon_sym_module] = ACTIONS(2888),
    [anon_sym_any] = ACTIONS(2888),
    [anon_sym_number] = ACTIONS(2888),
    [anon_sym_boolean] = ACTIONS(2888),
    [anon_sym_string] = ACTIONS(2888),
    [anon_sym_symbol] = ACTIONS(2888),
    [anon_sym_interface] = ACTIONS(2888),
    [anon_sym_enum] = ACTIONS(2888),
    [sym_readonly] = ACTIONS(2888),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(2890),
    [sym_identifier] = ACTIONS(2892),
    [anon_sym_export] = ACTIONS(2892),
    [anon_sym_default] = ACTIONS(2892),
    [anon_sym_namespace] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_type] = ACTIONS(2892),
    [anon_sym_typeof] = ACTIONS(2892),
    [anon_sym_import] = ACTIONS(2892),
    [anon_sym_var] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_if] = ACTIONS(2892),
    [anon_sym_else] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_for] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(2890),
    [anon_sym_await] = ACTIONS(2892),
    [anon_sym_while] = ACTIONS(2892),
    [anon_sym_do] = ACTIONS(2892),
    [anon_sym_try] = ACTIONS(2892),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_break] = ACTIONS(2892),
    [anon_sym_continue] = ACTIONS(2892),
    [anon_sym_debugger] = ACTIONS(2892),
    [anon_sym_return] = ACTIONS(2892),
    [anon_sym_throw] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2890),
    [anon_sym_case] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_class] = ACTIONS(2892),
    [anon_sym_async] = ACTIONS(2892),
    [anon_sym_function] = ACTIONS(2892),
    [anon_sym_new] = ACTIONS(2892),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2890),
    [anon_sym_TILDE] = ACTIONS(2890),
    [anon_sym_void] = ACTIONS(2892),
    [anon_sym_delete] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_SQUOTE] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [sym_number] = ACTIONS(2890),
    [sym_this] = ACTIONS(2892),
    [sym_super] = ACTIONS(2892),
    [sym_true] = ACTIONS(2892),
    [sym_false] = ACTIONS(2892),
    [sym_null] = ACTIONS(2892),
    [sym_undefined] = ACTIONS(2892),
    [anon_sym_AT] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2892),
    [anon_sym_abstract] = ACTIONS(2892),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_declare] = ACTIONS(2892),
    [anon_sym_public] = ACTIONS(2892),
    [anon_sym_private] = ACTIONS(2892),
    [anon_sym_protected] = ACTIONS(2892),
    [anon_sym_module] = ACTIONS(2892),
    [anon_sym_any] = ACTIONS(2892),
    [anon_sym_number] = ACTIONS(2892),
    [anon_sym_boolean] = ACTIONS(2892),
    [anon_sym_string] = ACTIONS(2892),
    [anon_sym_symbol] = ACTIONS(2892),
    [anon_sym_interface] = ACTIONS(2892),
    [anon_sym_enum] = ACTIONS(2892),
    [sym_readonly] = ACTIONS(2892),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(2894),
    [sym_identifier] = ACTIONS(2896),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_namespace] = ACTIONS(2896),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_type] = ACTIONS(2896),
    [anon_sym_typeof] = ACTIONS(2896),
    [anon_sym_import] = ACTIONS(2896),
    [anon_sym_var] = ACTIONS(2896),
    [anon_sym_let] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_if] = ACTIONS(2896),
    [anon_sym_else] = ACTIONS(2896),
    [anon_sym_switch] = ACTIONS(2896),
    [anon_sym_for] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_await] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2896),
    [anon_sym_do] = ACTIONS(2896),
    [anon_sym_try] = ACTIONS(2896),
    [anon_sym_with] = ACTIONS(2896),
    [anon_sym_break] = ACTIONS(2896),
    [anon_sym_continue] = ACTIONS(2896),
    [anon_sym_debugger] = ACTIONS(2896),
    [anon_sym_return] = ACTIONS(2896),
    [anon_sym_throw] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_case] = ACTIONS(2896),
    [anon_sym_yield] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LT] = ACTIONS(2894),
    [anon_sym_SLASH] = ACTIONS(2896),
    [anon_sym_class] = ACTIONS(2896),
    [anon_sym_async] = ACTIONS(2896),
    [anon_sym_function] = ACTIONS(2896),
    [anon_sym_new] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_DASH] = ACTIONS(2896),
    [anon_sym_BANG] = ACTIONS(2894),
    [anon_sym_TILDE] = ACTIONS(2894),
    [anon_sym_void] = ACTIONS(2896),
    [anon_sym_delete] = ACTIONS(2896),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_DQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2894),
    [sym_number] = ACTIONS(2894),
    [sym_this] = ACTIONS(2896),
    [sym_super] = ACTIONS(2896),
    [sym_true] = ACTIONS(2896),
    [sym_false] = ACTIONS(2896),
    [sym_null] = ACTIONS(2896),
    [sym_undefined] = ACTIONS(2896),
    [anon_sym_AT] = ACTIONS(2894),
    [anon_sym_static] = ACTIONS(2896),
    [anon_sym_abstract] = ACTIONS(2896),
    [anon_sym_get] = ACTIONS(2896),
    [anon_sym_set] = ACTIONS(2896),
    [anon_sym_declare] = ACTIONS(2896),
    [anon_sym_public] = ACTIONS(2896),
    [anon_sym_private] = ACTIONS(2896),
    [anon_sym_protected] = ACTIONS(2896),
    [anon_sym_module] = ACTIONS(2896),
    [anon_sym_any] = ACTIONS(2896),
    [anon_sym_number] = ACTIONS(2896),
    [anon_sym_boolean] = ACTIONS(2896),
    [anon_sym_string] = ACTIONS(2896),
    [anon_sym_symbol] = ACTIONS(2896),
    [anon_sym_interface] = ACTIONS(2896),
    [anon_sym_enum] = ACTIONS(2896),
    [sym_readonly] = ACTIONS(2896),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(2898),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_typeof] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_var] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_switch] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_await] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [anon_sym_do] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_with] = ACTIONS(2900),
    [anon_sym_break] = ACTIONS(2900),
    [anon_sym_continue] = ACTIONS(2900),
    [anon_sym_debugger] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_throw] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_case] = ACTIONS(2900),
    [anon_sym_yield] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_LT] = ACTIONS(2898),
    [anon_sym_SLASH] = ACTIONS(2900),
    [anon_sym_class] = ACTIONS(2900),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2898),
    [anon_sym_TILDE] = ACTIONS(2898),
    [anon_sym_void] = ACTIONS(2900),
    [anon_sym_delete] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2898),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [anon_sym_SQUOTE] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [sym_number] = ACTIONS(2898),
    [sym_this] = ACTIONS(2900),
    [sym_super] = ACTIONS(2900),
    [sym_true] = ACTIONS(2900),
    [sym_false] = ACTIONS(2900),
    [sym_null] = ACTIONS(2900),
    [sym_undefined] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_interface] = ACTIONS(2900),
    [anon_sym_enum] = ACTIONS(2900),
    [sym_readonly] = ACTIONS(2900),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(2902),
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_default] = ACTIONS(2904),
    [anon_sym_namespace] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_type] = ACTIONS(2904),
    [anon_sym_typeof] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_var] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_else] = ACTIONS(2904),
    [anon_sym_switch] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_await] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [anon_sym_do] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_with] = ACTIONS(2904),
    [anon_sym_break] = ACTIONS(2904),
    [anon_sym_continue] = ACTIONS(2904),
    [anon_sym_debugger] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_throw] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2904),
    [anon_sym_class] = ACTIONS(2904),
    [anon_sym_async] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2904),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2902),
    [anon_sym_void] = ACTIONS(2904),
    [anon_sym_delete] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_SQUOTE] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2902),
    [sym_number] = ACTIONS(2902),
    [sym_this] = ACTIONS(2904),
    [sym_super] = ACTIONS(2904),
    [sym_true] = ACTIONS(2904),
    [sym_false] = ACTIONS(2904),
    [sym_null] = ACTIONS(2904),
    [sym_undefined] = ACTIONS(2904),
    [anon_sym_AT] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_get] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(2904),
    [anon_sym_declare] = ACTIONS(2904),
    [anon_sym_public] = ACTIONS(2904),
    [anon_sym_private] = ACTIONS(2904),
    [anon_sym_protected] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_any] = ACTIONS(2904),
    [anon_sym_number] = ACTIONS(2904),
    [anon_sym_boolean] = ACTIONS(2904),
    [anon_sym_string] = ACTIONS(2904),
    [anon_sym_symbol] = ACTIONS(2904),
    [anon_sym_interface] = ACTIONS(2904),
    [anon_sym_enum] = ACTIONS(2904),
    [sym_readonly] = ACTIONS(2904),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(2906),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_default] = ACTIONS(2908),
    [anon_sym_namespace] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_type] = ACTIONS(2908),
    [anon_sym_typeof] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_var] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_else] = ACTIONS(2908),
    [anon_sym_switch] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_await] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [anon_sym_do] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_with] = ACTIONS(2908),
    [anon_sym_break] = ACTIONS(2908),
    [anon_sym_continue] = ACTIONS(2908),
    [anon_sym_debugger] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_throw] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_case] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(2906),
    [anon_sym_SLASH] = ACTIONS(2908),
    [anon_sym_class] = ACTIONS(2908),
    [anon_sym_async] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2906),
    [anon_sym_void] = ACTIONS(2908),
    [anon_sym_delete] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2906),
    [anon_sym_DASH_DASH] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_SQUOTE] = ACTIONS(2906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2906),
    [sym_number] = ACTIONS(2906),
    [sym_this] = ACTIONS(2908),
    [sym_super] = ACTIONS(2908),
    [sym_true] = ACTIONS(2908),
    [sym_false] = ACTIONS(2908),
    [sym_null] = ACTIONS(2908),
    [sym_undefined] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2906),
    [anon_sym_static] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_get] = ACTIONS(2908),
    [anon_sym_set] = ACTIONS(2908),
    [anon_sym_declare] = ACTIONS(2908),
    [anon_sym_public] = ACTIONS(2908),
    [anon_sym_private] = ACTIONS(2908),
    [anon_sym_protected] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_any] = ACTIONS(2908),
    [anon_sym_number] = ACTIONS(2908),
    [anon_sym_boolean] = ACTIONS(2908),
    [anon_sym_string] = ACTIONS(2908),
    [anon_sym_symbol] = ACTIONS(2908),
    [anon_sym_interface] = ACTIONS(2908),
    [anon_sym_enum] = ACTIONS(2908),
    [sym_readonly] = ACTIONS(2908),
  },
  [582] = {
    [sym__call_signature] = STATE(3120),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(665),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2732),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_function] = ACTIONS(2659),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(679),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [sym_readonly] = ACTIONS(2732),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(2910),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_default] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_var] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_else] = ACTIONS(2912),
    [anon_sym_switch] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_await] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [anon_sym_do] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_with] = ACTIONS(2912),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_continue] = ACTIONS(2912),
    [anon_sym_debugger] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_throw] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_case] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2912),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(2910),
    [anon_sym_SLASH] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_DASH] = ACTIONS(2912),
    [anon_sym_BANG] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2910),
    [anon_sym_void] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2912),
    [anon_sym_PLUS_PLUS] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_SQUOTE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2910),
    [sym_number] = ACTIONS(2910),
    [sym_this] = ACTIONS(2912),
    [sym_super] = ACTIONS(2912),
    [sym_true] = ACTIONS(2912),
    [sym_false] = ACTIONS(2912),
    [sym_null] = ACTIONS(2912),
    [sym_undefined] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2910),
    [anon_sym_static] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_interface] = ACTIONS(2912),
    [anon_sym_enum] = ACTIONS(2912),
    [sym_readonly] = ACTIONS(2912),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(2914),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_default] = ACTIONS(2916),
    [anon_sym_namespace] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_type] = ACTIONS(2916),
    [anon_sym_typeof] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_var] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_else] = ACTIONS(2916),
    [anon_sym_switch] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_await] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [anon_sym_do] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_with] = ACTIONS(2916),
    [anon_sym_break] = ACTIONS(2916),
    [anon_sym_continue] = ACTIONS(2916),
    [anon_sym_debugger] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_throw] = ACTIONS(2916),
    [anon_sym_SEMI] = ACTIONS(2914),
    [anon_sym_case] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2916),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LT] = ACTIONS(2914),
    [anon_sym_SLASH] = ACTIONS(2916),
    [anon_sym_class] = ACTIONS(2916),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_DASH] = ACTIONS(2916),
    [anon_sym_BANG] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2914),
    [anon_sym_void] = ACTIONS(2916),
    [anon_sym_delete] = ACTIONS(2916),
    [anon_sym_PLUS_PLUS] = ACTIONS(2914),
    [anon_sym_DASH_DASH] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_SQUOTE] = ACTIONS(2914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2914),
    [sym_number] = ACTIONS(2914),
    [sym_this] = ACTIONS(2916),
    [sym_super] = ACTIONS(2916),
    [sym_true] = ACTIONS(2916),
    [sym_false] = ACTIONS(2916),
    [sym_null] = ACTIONS(2916),
    [sym_undefined] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_get] = ACTIONS(2916),
    [anon_sym_set] = ACTIONS(2916),
    [anon_sym_declare] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2916),
    [anon_sym_private] = ACTIONS(2916),
    [anon_sym_protected] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_any] = ACTIONS(2916),
    [anon_sym_number] = ACTIONS(2916),
    [anon_sym_boolean] = ACTIONS(2916),
    [anon_sym_string] = ACTIONS(2916),
    [anon_sym_symbol] = ACTIONS(2916),
    [anon_sym_interface] = ACTIONS(2916),
    [anon_sym_enum] = ACTIONS(2916),
    [sym_readonly] = ACTIONS(2916),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(2918),
    [sym_identifier] = ACTIONS(2920),
    [anon_sym_export] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_RBRACE] = ACTIONS(2918),
    [anon_sym_type] = ACTIONS(2920),
    [anon_sym_typeof] = ACTIONS(2920),
    [anon_sym_import] = ACTIONS(2920),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_else] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_await] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_with] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_debugger] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LT] = ACTIONS(2918),
    [anon_sym_SLASH] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_async] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2918),
    [anon_sym_void] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_SQUOTE] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2918),
    [sym_number] = ACTIONS(2918),
    [sym_this] = ACTIONS(2920),
    [sym_super] = ACTIONS(2920),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [sym_null] = ACTIONS(2920),
    [sym_undefined] = ACTIONS(2920),
    [anon_sym_AT] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_abstract] = ACTIONS(2920),
    [anon_sym_get] = ACTIONS(2920),
    [anon_sym_set] = ACTIONS(2920),
    [anon_sym_declare] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_module] = ACTIONS(2920),
    [anon_sym_any] = ACTIONS(2920),
    [anon_sym_number] = ACTIONS(2920),
    [anon_sym_boolean] = ACTIONS(2920),
    [anon_sym_string] = ACTIONS(2920),
    [anon_sym_symbol] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [sym_readonly] = ACTIONS(2920),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(2922),
    [sym_identifier] = ACTIONS(2924),
    [anon_sym_export] = ACTIONS(2924),
    [anon_sym_default] = ACTIONS(2924),
    [anon_sym_namespace] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_type] = ACTIONS(2924),
    [anon_sym_typeof] = ACTIONS(2924),
    [anon_sym_import] = ACTIONS(2924),
    [anon_sym_var] = ACTIONS(2924),
    [anon_sym_let] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_if] = ACTIONS(2924),
    [anon_sym_else] = ACTIONS(2924),
    [anon_sym_switch] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_await] = ACTIONS(2924),
    [anon_sym_while] = ACTIONS(2924),
    [anon_sym_do] = ACTIONS(2924),
    [anon_sym_try] = ACTIONS(2924),
    [anon_sym_with] = ACTIONS(2924),
    [anon_sym_break] = ACTIONS(2924),
    [anon_sym_continue] = ACTIONS(2924),
    [anon_sym_debugger] = ACTIONS(2924),
    [anon_sym_return] = ACTIONS(2924),
    [anon_sym_throw] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym_case] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_void] = ACTIONS(2924),
    [anon_sym_delete] = ACTIONS(2924),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2922),
    [sym_number] = ACTIONS(2922),
    [sym_this] = ACTIONS(2924),
    [sym_super] = ACTIONS(2924),
    [sym_true] = ACTIONS(2924),
    [sym_false] = ACTIONS(2924),
    [sym_null] = ACTIONS(2924),
    [sym_undefined] = ACTIONS(2924),
    [anon_sym_AT] = ACTIONS(2922),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_abstract] = ACTIONS(2924),
    [anon_sym_get] = ACTIONS(2924),
    [anon_sym_set] = ACTIONS(2924),
    [anon_sym_declare] = ACTIONS(2924),
    [anon_sym_public] = ACTIONS(2924),
    [anon_sym_private] = ACTIONS(2924),
    [anon_sym_protected] = ACTIONS(2924),
    [anon_sym_module] = ACTIONS(2924),
    [anon_sym_any] = ACTIONS(2924),
    [anon_sym_number] = ACTIONS(2924),
    [anon_sym_boolean] = ACTIONS(2924),
    [anon_sym_string] = ACTIONS(2924),
    [anon_sym_symbol] = ACTIONS(2924),
    [anon_sym_interface] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [sym_readonly] = ACTIONS(2924),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(2926),
    [sym_identifier] = ACTIONS(2928),
    [anon_sym_export] = ACTIONS(2928),
    [anon_sym_default] = ACTIONS(2928),
    [anon_sym_namespace] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [anon_sym_type] = ACTIONS(2928),
    [anon_sym_typeof] = ACTIONS(2928),
    [anon_sym_import] = ACTIONS(2928),
    [anon_sym_var] = ACTIONS(2928),
    [anon_sym_let] = ACTIONS(2928),
    [anon_sym_const] = ACTIONS(2928),
    [anon_sym_if] = ACTIONS(2928),
    [anon_sym_else] = ACTIONS(2928),
    [anon_sym_switch] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_await] = ACTIONS(2928),
    [anon_sym_while] = ACTIONS(2928),
    [anon_sym_do] = ACTIONS(2928),
    [anon_sym_try] = ACTIONS(2928),
    [anon_sym_with] = ACTIONS(2928),
    [anon_sym_break] = ACTIONS(2928),
    [anon_sym_continue] = ACTIONS(2928),
    [anon_sym_debugger] = ACTIONS(2928),
    [anon_sym_return] = ACTIONS(2928),
    [anon_sym_throw] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym_case] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_SLASH] = ACTIONS(2928),
    [anon_sym_class] = ACTIONS(2928),
    [anon_sym_async] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2928),
    [anon_sym_DASH] = ACTIONS(2928),
    [anon_sym_BANG] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_void] = ACTIONS(2928),
    [anon_sym_delete] = ACTIONS(2928),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_SQUOTE] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [sym_number] = ACTIONS(2926),
    [sym_this] = ACTIONS(2928),
    [sym_super] = ACTIONS(2928),
    [sym_true] = ACTIONS(2928),
    [sym_false] = ACTIONS(2928),
    [sym_null] = ACTIONS(2928),
    [sym_undefined] = ACTIONS(2928),
    [anon_sym_AT] = ACTIONS(2926),
    [anon_sym_static] = ACTIONS(2928),
    [anon_sym_abstract] = ACTIONS(2928),
    [anon_sym_get] = ACTIONS(2928),
    [anon_sym_set] = ACTIONS(2928),
    [anon_sym_declare] = ACTIONS(2928),
    [anon_sym_public] = ACTIONS(2928),
    [anon_sym_private] = ACTIONS(2928),
    [anon_sym_protected] = ACTIONS(2928),
    [anon_sym_module] = ACTIONS(2928),
    [anon_sym_any] = ACTIONS(2928),
    [anon_sym_number] = ACTIONS(2928),
    [anon_sym_boolean] = ACTIONS(2928),
    [anon_sym_string] = ACTIONS(2928),
    [anon_sym_symbol] = ACTIONS(2928),
    [anon_sym_interface] = ACTIONS(2928),
    [anon_sym_enum] = ACTIONS(2928),
    [sym_readonly] = ACTIONS(2928),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(2930),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_export] = ACTIONS(2932),
    [anon_sym_default] = ACTIONS(2932),
    [anon_sym_namespace] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_RBRACE] = ACTIONS(2930),
    [anon_sym_type] = ACTIONS(2932),
    [anon_sym_typeof] = ACTIONS(2932),
    [anon_sym_import] = ACTIONS(2932),
    [anon_sym_var] = ACTIONS(2932),
    [anon_sym_let] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2932),
    [anon_sym_if] = ACTIONS(2932),
    [anon_sym_else] = ACTIONS(2932),
    [anon_sym_switch] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_await] = ACTIONS(2932),
    [anon_sym_while] = ACTIONS(2932),
    [anon_sym_do] = ACTIONS(2932),
    [anon_sym_try] = ACTIONS(2932),
    [anon_sym_with] = ACTIONS(2932),
    [anon_sym_break] = ACTIONS(2932),
    [anon_sym_continue] = ACTIONS(2932),
    [anon_sym_debugger] = ACTIONS(2932),
    [anon_sym_return] = ACTIONS(2932),
    [anon_sym_throw] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2930),
    [anon_sym_case] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2930),
    [anon_sym_SLASH] = ACTIONS(2932),
    [anon_sym_class] = ACTIONS(2932),
    [anon_sym_async] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2930),
    [anon_sym_void] = ACTIONS(2932),
    [anon_sym_delete] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_SQUOTE] = ACTIONS(2930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [sym_number] = ACTIONS(2930),
    [sym_this] = ACTIONS(2932),
    [sym_super] = ACTIONS(2932),
    [sym_true] = ACTIONS(2932),
    [sym_false] = ACTIONS(2932),
    [sym_null] = ACTIONS(2932),
    [sym_undefined] = ACTIONS(2932),
    [anon_sym_AT] = ACTIONS(2930),
    [anon_sym_static] = ACTIONS(2932),
    [anon_sym_abstract] = ACTIONS(2932),
    [anon_sym_get] = ACTIONS(2932),
    [anon_sym_set] = ACTIONS(2932),
    [anon_sym_declare] = ACTIONS(2932),
    [anon_sym_public] = ACTIONS(2932),
    [anon_sym_private] = ACTIONS(2932),
    [anon_sym_protected] = ACTIONS(2932),
    [anon_sym_module] = ACTIONS(2932),
    [anon_sym_any] = ACTIONS(2932),
    [anon_sym_number] = ACTIONS(2932),
    [anon_sym_boolean] = ACTIONS(2932),
    [anon_sym_string] = ACTIONS(2932),
    [anon_sym_symbol] = ACTIONS(2932),
    [anon_sym_interface] = ACTIONS(2932),
    [anon_sym_enum] = ACTIONS(2932),
    [sym_readonly] = ACTIONS(2932),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2934),
    [sym_identifier] = ACTIONS(2936),
    [anon_sym_export] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2936),
    [anon_sym_namespace] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_RBRACE] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2936),
    [anon_sym_typeof] = ACTIONS(2936),
    [anon_sym_import] = ACTIONS(2936),
    [anon_sym_var] = ACTIONS(2936),
    [anon_sym_let] = ACTIONS(2936),
    [anon_sym_const] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_else] = ACTIONS(2936),
    [anon_sym_switch] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_await] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_do] = ACTIONS(2936),
    [anon_sym_try] = ACTIONS(2936),
    [anon_sym_with] = ACTIONS(2936),
    [anon_sym_break] = ACTIONS(2936),
    [anon_sym_continue] = ACTIONS(2936),
    [anon_sym_debugger] = ACTIONS(2936),
    [anon_sym_return] = ACTIONS(2936),
    [anon_sym_throw] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2934),
    [anon_sym_case] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2936),
    [anon_sym_class] = ACTIONS(2936),
    [anon_sym_async] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_BANG] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2934),
    [anon_sym_void] = ACTIONS(2936),
    [anon_sym_delete] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_SQUOTE] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2934),
    [sym_number] = ACTIONS(2934),
    [sym_this] = ACTIONS(2936),
    [sym_super] = ACTIONS(2936),
    [sym_true] = ACTIONS(2936),
    [sym_false] = ACTIONS(2936),
    [sym_null] = ACTIONS(2936),
    [sym_undefined] = ACTIONS(2936),
    [anon_sym_AT] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2936),
    [anon_sym_abstract] = ACTIONS(2936),
    [anon_sym_get] = ACTIONS(2936),
    [anon_sym_set] = ACTIONS(2936),
    [anon_sym_declare] = ACTIONS(2936),
    [anon_sym_public] = ACTIONS(2936),
    [anon_sym_private] = ACTIONS(2936),
    [anon_sym_protected] = ACTIONS(2936),
    [anon_sym_module] = ACTIONS(2936),
    [anon_sym_any] = ACTIONS(2936),
    [anon_sym_number] = ACTIONS(2936),
    [anon_sym_boolean] = ACTIONS(2936),
    [anon_sym_string] = ACTIONS(2936),
    [anon_sym_symbol] = ACTIONS(2936),
    [anon_sym_interface] = ACTIONS(2936),
    [anon_sym_enum] = ACTIONS(2936),
    [sym_readonly] = ACTIONS(2936),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2938),
    [sym_identifier] = ACTIONS(2940),
    [anon_sym_export] = ACTIONS(2940),
    [anon_sym_default] = ACTIONS(2940),
    [anon_sym_namespace] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_type] = ACTIONS(2940),
    [anon_sym_typeof] = ACTIONS(2940),
    [anon_sym_import] = ACTIONS(2940),
    [anon_sym_var] = ACTIONS(2940),
    [anon_sym_let] = ACTIONS(2940),
    [anon_sym_const] = ACTIONS(2940),
    [anon_sym_if] = ACTIONS(2940),
    [anon_sym_else] = ACTIONS(2940),
    [anon_sym_switch] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_await] = ACTIONS(2940),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_do] = ACTIONS(2940),
    [anon_sym_try] = ACTIONS(2940),
    [anon_sym_with] = ACTIONS(2940),
    [anon_sym_break] = ACTIONS(2940),
    [anon_sym_continue] = ACTIONS(2940),
    [anon_sym_debugger] = ACTIONS(2940),
    [anon_sym_return] = ACTIONS(2940),
    [anon_sym_throw] = ACTIONS(2940),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_case] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2940),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2940),
    [anon_sym_class] = ACTIONS(2940),
    [anon_sym_async] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_void] = ACTIONS(2940),
    [anon_sym_delete] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2938),
    [sym_number] = ACTIONS(2938),
    [sym_this] = ACTIONS(2940),
    [sym_super] = ACTIONS(2940),
    [sym_true] = ACTIONS(2940),
    [sym_false] = ACTIONS(2940),
    [sym_null] = ACTIONS(2940),
    [sym_undefined] = ACTIONS(2940),
    [anon_sym_AT] = ACTIONS(2938),
    [anon_sym_static] = ACTIONS(2940),
    [anon_sym_abstract] = ACTIONS(2940),
    [anon_sym_get] = ACTIONS(2940),
    [anon_sym_set] = ACTIONS(2940),
    [anon_sym_declare] = ACTIONS(2940),
    [anon_sym_public] = ACTIONS(2940),
    [anon_sym_private] = ACTIONS(2940),
    [anon_sym_protected] = ACTIONS(2940),
    [anon_sym_module] = ACTIONS(2940),
    [anon_sym_any] = ACTIONS(2940),
    [anon_sym_number] = ACTIONS(2940),
    [anon_sym_boolean] = ACTIONS(2940),
    [anon_sym_string] = ACTIONS(2940),
    [anon_sym_symbol] = ACTIONS(2940),
    [anon_sym_interface] = ACTIONS(2940),
    [anon_sym_enum] = ACTIONS(2940),
    [sym_readonly] = ACTIONS(2940),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2942),
    [sym_identifier] = ACTIONS(2944),
    [anon_sym_export] = ACTIONS(2944),
    [anon_sym_default] = ACTIONS(2944),
    [anon_sym_namespace] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [anon_sym_type] = ACTIONS(2944),
    [anon_sym_typeof] = ACTIONS(2944),
    [anon_sym_import] = ACTIONS(2944),
    [anon_sym_var] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_const] = ACTIONS(2944),
    [anon_sym_if] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2944),
    [anon_sym_switch] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_await] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2944),
    [anon_sym_do] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2944),
    [anon_sym_with] = ACTIONS(2944),
    [anon_sym_break] = ACTIONS(2944),
    [anon_sym_continue] = ACTIONS(2944),
    [anon_sym_debugger] = ACTIONS(2944),
    [anon_sym_return] = ACTIONS(2944),
    [anon_sym_throw] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym_case] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2944),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2944),
    [anon_sym_class] = ACTIONS(2944),
    [anon_sym_async] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2942),
    [anon_sym_void] = ACTIONS(2944),
    [anon_sym_delete] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_SQUOTE] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2942),
    [sym_number] = ACTIONS(2942),
    [sym_this] = ACTIONS(2944),
    [sym_super] = ACTIONS(2944),
    [sym_true] = ACTIONS(2944),
    [sym_false] = ACTIONS(2944),
    [sym_null] = ACTIONS(2944),
    [sym_undefined] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2944),
    [anon_sym_abstract] = ACTIONS(2944),
    [anon_sym_get] = ACTIONS(2944),
    [anon_sym_set] = ACTIONS(2944),
    [anon_sym_declare] = ACTIONS(2944),
    [anon_sym_public] = ACTIONS(2944),
    [anon_sym_private] = ACTIONS(2944),
    [anon_sym_protected] = ACTIONS(2944),
    [anon_sym_module] = ACTIONS(2944),
    [anon_sym_any] = ACTIONS(2944),
    [anon_sym_number] = ACTIONS(2944),
    [anon_sym_boolean] = ACTIONS(2944),
    [anon_sym_string] = ACTIONS(2944),
    [anon_sym_symbol] = ACTIONS(2944),
    [anon_sym_interface] = ACTIONS(2944),
    [anon_sym_enum] = ACTIONS(2944),
    [sym_readonly] = ACTIONS(2944),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2946),
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_export] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2948),
    [anon_sym_namespace] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_type] = ACTIONS(2948),
    [anon_sym_typeof] = ACTIONS(2948),
    [anon_sym_import] = ACTIONS(2948),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_else] = ACTIONS(2948),
    [anon_sym_switch] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_await] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_try] = ACTIONS(2948),
    [anon_sym_with] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_continue] = ACTIONS(2948),
    [anon_sym_debugger] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_throw] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_async] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_void] = ACTIONS(2948),
    [anon_sym_delete] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2946),
    [sym_number] = ACTIONS(2946),
    [sym_this] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_null] = ACTIONS(2948),
    [sym_undefined] = ACTIONS(2948),
    [anon_sym_AT] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2948),
    [anon_sym_abstract] = ACTIONS(2948),
    [anon_sym_get] = ACTIONS(2948),
    [anon_sym_set] = ACTIONS(2948),
    [anon_sym_declare] = ACTIONS(2948),
    [anon_sym_public] = ACTIONS(2948),
    [anon_sym_private] = ACTIONS(2948),
    [anon_sym_protected] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_any] = ACTIONS(2948),
    [anon_sym_number] = ACTIONS(2948),
    [anon_sym_boolean] = ACTIONS(2948),
    [anon_sym_string] = ACTIONS(2948),
    [anon_sym_symbol] = ACTIONS(2948),
    [anon_sym_interface] = ACTIONS(2948),
    [anon_sym_enum] = ACTIONS(2948),
    [sym_readonly] = ACTIONS(2948),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2950),
    [sym_identifier] = ACTIONS(2952),
    [anon_sym_export] = ACTIONS(2952),
    [anon_sym_default] = ACTIONS(2952),
    [anon_sym_namespace] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_type] = ACTIONS(2952),
    [anon_sym_typeof] = ACTIONS(2952),
    [anon_sym_import] = ACTIONS(2952),
    [anon_sym_var] = ACTIONS(2952),
    [anon_sym_let] = ACTIONS(2952),
    [anon_sym_const] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2952),
    [anon_sym_else] = ACTIONS(2952),
    [anon_sym_switch] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_await] = ACTIONS(2952),
    [anon_sym_while] = ACTIONS(2952),
    [anon_sym_do] = ACTIONS(2952),
    [anon_sym_try] = ACTIONS(2952),
    [anon_sym_with] = ACTIONS(2952),
    [anon_sym_break] = ACTIONS(2952),
    [anon_sym_continue] = ACTIONS(2952),
    [anon_sym_debugger] = ACTIONS(2952),
    [anon_sym_return] = ACTIONS(2952),
    [anon_sym_throw] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_class] = ACTIONS(2952),
    [anon_sym_async] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [anon_sym_void] = ACTIONS(2952),
    [anon_sym_delete] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_SQUOTE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2950),
    [sym_number] = ACTIONS(2950),
    [sym_this] = ACTIONS(2952),
    [sym_super] = ACTIONS(2952),
    [sym_true] = ACTIONS(2952),
    [sym_false] = ACTIONS(2952),
    [sym_null] = ACTIONS(2952),
    [sym_undefined] = ACTIONS(2952),
    [anon_sym_AT] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2952),
    [anon_sym_abstract] = ACTIONS(2952),
    [anon_sym_get] = ACTIONS(2952),
    [anon_sym_set] = ACTIONS(2952),
    [anon_sym_declare] = ACTIONS(2952),
    [anon_sym_public] = ACTIONS(2952),
    [anon_sym_private] = ACTIONS(2952),
    [anon_sym_protected] = ACTIONS(2952),
    [anon_sym_module] = ACTIONS(2952),
    [anon_sym_any] = ACTIONS(2952),
    [anon_sym_number] = ACTIONS(2952),
    [anon_sym_boolean] = ACTIONS(2952),
    [anon_sym_string] = ACTIONS(2952),
    [anon_sym_symbol] = ACTIONS(2952),
    [anon_sym_interface] = ACTIONS(2952),
    [anon_sym_enum] = ACTIONS(2952),
    [sym_readonly] = ACTIONS(2952),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2954),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_export] = ACTIONS(2956),
    [anon_sym_default] = ACTIONS(2956),
    [anon_sym_namespace] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2954),
    [anon_sym_type] = ACTIONS(2956),
    [anon_sym_typeof] = ACTIONS(2956),
    [anon_sym_import] = ACTIONS(2956),
    [anon_sym_var] = ACTIONS(2956),
    [anon_sym_let] = ACTIONS(2956),
    [anon_sym_const] = ACTIONS(2956),
    [anon_sym_if] = ACTIONS(2956),
    [anon_sym_else] = ACTIONS(2956),
    [anon_sym_switch] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_await] = ACTIONS(2956),
    [anon_sym_while] = ACTIONS(2956),
    [anon_sym_do] = ACTIONS(2956),
    [anon_sym_try] = ACTIONS(2956),
    [anon_sym_with] = ACTIONS(2956),
    [anon_sym_break] = ACTIONS(2956),
    [anon_sym_continue] = ACTIONS(2956),
    [anon_sym_debugger] = ACTIONS(2956),
    [anon_sym_return] = ACTIONS(2956),
    [anon_sym_throw] = ACTIONS(2956),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LT] = ACTIONS(2954),
    [anon_sym_SLASH] = ACTIONS(2956),
    [anon_sym_class] = ACTIONS(2956),
    [anon_sym_async] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_void] = ACTIONS(2956),
    [anon_sym_delete] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2954),
    [sym_number] = ACTIONS(2954),
    [sym_this] = ACTIONS(2956),
    [sym_super] = ACTIONS(2956),
    [sym_true] = ACTIONS(2956),
    [sym_false] = ACTIONS(2956),
    [sym_null] = ACTIONS(2956),
    [sym_undefined] = ACTIONS(2956),
    [anon_sym_AT] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2956),
    [anon_sym_abstract] = ACTIONS(2956),
    [anon_sym_get] = ACTIONS(2956),
    [anon_sym_set] = ACTIONS(2956),
    [anon_sym_declare] = ACTIONS(2956),
    [anon_sym_public] = ACTIONS(2956),
    [anon_sym_private] = ACTIONS(2956),
    [anon_sym_protected] = ACTIONS(2956),
    [anon_sym_module] = ACTIONS(2956),
    [anon_sym_any] = ACTIONS(2956),
    [anon_sym_number] = ACTIONS(2956),
    [anon_sym_boolean] = ACTIONS(2956),
    [anon_sym_string] = ACTIONS(2956),
    [anon_sym_symbol] = ACTIONS(2956),
    [anon_sym_interface] = ACTIONS(2956),
    [anon_sym_enum] = ACTIONS(2956),
    [sym_readonly] = ACTIONS(2956),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2958),
    [sym_identifier] = ACTIONS(2960),
    [anon_sym_export] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [anon_sym_type] = ACTIONS(2960),
    [anon_sym_typeof] = ACTIONS(2960),
    [anon_sym_import] = ACTIONS(2960),
    [anon_sym_var] = ACTIONS(2960),
    [anon_sym_let] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_else] = ACTIONS(2960),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_await] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_with] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_debugger] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LT] = ACTIONS(2958),
    [anon_sym_SLASH] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_async] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2958),
    [anon_sym_void] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2958),
    [anon_sym_DASH_DASH] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_SQUOTE] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2958),
    [sym_number] = ACTIONS(2958),
    [sym_this] = ACTIONS(2960),
    [sym_super] = ACTIONS(2960),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [sym_null] = ACTIONS(2960),
    [sym_undefined] = ACTIONS(2960),
    [anon_sym_AT] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_abstract] = ACTIONS(2960),
    [anon_sym_get] = ACTIONS(2960),
    [anon_sym_set] = ACTIONS(2960),
    [anon_sym_declare] = ACTIONS(2960),
    [anon_sym_public] = ACTIONS(2960),
    [anon_sym_private] = ACTIONS(2960),
    [anon_sym_protected] = ACTIONS(2960),
    [anon_sym_module] = ACTIONS(2960),
    [anon_sym_any] = ACTIONS(2960),
    [anon_sym_number] = ACTIONS(2960),
    [anon_sym_boolean] = ACTIONS(2960),
    [anon_sym_string] = ACTIONS(2960),
    [anon_sym_symbol] = ACTIONS(2960),
    [anon_sym_interface] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [sym_readonly] = ACTIONS(2960),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(2962),
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_export] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_type] = ACTIONS(2964),
    [anon_sym_typeof] = ACTIONS(2964),
    [anon_sym_import] = ACTIONS(2964),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_else] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_await] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_with] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_debugger] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_async] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_void] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2962),
    [sym_number] = ACTIONS(2962),
    [sym_this] = ACTIONS(2964),
    [sym_super] = ACTIONS(2964),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [sym_null] = ACTIONS(2964),
    [sym_undefined] = ACTIONS(2964),
    [anon_sym_AT] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_abstract] = ACTIONS(2964),
    [anon_sym_get] = ACTIONS(2964),
    [anon_sym_set] = ACTIONS(2964),
    [anon_sym_declare] = ACTIONS(2964),
    [anon_sym_public] = ACTIONS(2964),
    [anon_sym_private] = ACTIONS(2964),
    [anon_sym_protected] = ACTIONS(2964),
    [anon_sym_module] = ACTIONS(2964),
    [anon_sym_any] = ACTIONS(2964),
    [anon_sym_number] = ACTIONS(2964),
    [anon_sym_boolean] = ACTIONS(2964),
    [anon_sym_string] = ACTIONS(2964),
    [anon_sym_symbol] = ACTIONS(2964),
    [anon_sym_interface] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [sym_readonly] = ACTIONS(2964),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2966),
    [sym_identifier] = ACTIONS(2968),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_typeof] = ACTIONS(2968),
    [anon_sym_import] = ACTIONS(2968),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_else] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_await] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_with] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_debugger] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_SLASH] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2966),
    [anon_sym_void] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_PLUS_PLUS] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_SQUOTE] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2966),
    [sym_number] = ACTIONS(2966),
    [sym_this] = ACTIONS(2968),
    [sym_super] = ACTIONS(2968),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [sym_null] = ACTIONS(2968),
    [sym_undefined] = ACTIONS(2968),
    [anon_sym_AT] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_abstract] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [sym_readonly] = ACTIONS(2968),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2970),
    [sym_identifier] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2972),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_await] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_with] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_debugger] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_SLASH] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_void] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2970),
    [sym_number] = ACTIONS(2970),
    [sym_this] = ACTIONS(2972),
    [sym_super] = ACTIONS(2972),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [sym_null] = ACTIONS(2972),
    [sym_undefined] = ACTIONS(2972),
    [anon_sym_AT] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_abstract] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [sym_readonly] = ACTIONS(2972),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2974),
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_export] = ACTIONS(2976),
    [anon_sym_default] = ACTIONS(2976),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_type] = ACTIONS(2976),
    [anon_sym_typeof] = ACTIONS(2976),
    [anon_sym_import] = ACTIONS(2976),
    [anon_sym_var] = ACTIONS(2976),
    [anon_sym_let] = ACTIONS(2976),
    [anon_sym_const] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_else] = ACTIONS(2976),
    [anon_sym_switch] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_await] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2976),
    [anon_sym_try] = ACTIONS(2976),
    [anon_sym_with] = ACTIONS(2976),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_continue] = ACTIONS(2976),
    [anon_sym_debugger] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_throw] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_void] = ACTIONS(2976),
    [anon_sym_delete] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2974),
    [sym_number] = ACTIONS(2974),
    [sym_this] = ACTIONS(2976),
    [sym_super] = ACTIONS(2976),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [sym_null] = ACTIONS(2976),
    [sym_undefined] = ACTIONS(2976),
    [anon_sym_AT] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_abstract] = ACTIONS(2976),
    [anon_sym_get] = ACTIONS(2976),
    [anon_sym_set] = ACTIONS(2976),
    [anon_sym_declare] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2976),
    [anon_sym_private] = ACTIONS(2976),
    [anon_sym_protected] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_any] = ACTIONS(2976),
    [anon_sym_number] = ACTIONS(2976),
    [anon_sym_boolean] = ACTIONS(2976),
    [anon_sym_string] = ACTIONS(2976),
    [anon_sym_symbol] = ACTIONS(2976),
    [anon_sym_interface] = ACTIONS(2976),
    [anon_sym_enum] = ACTIONS(2976),
    [sym_readonly] = ACTIONS(2976),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2978),
    [sym_identifier] = ACTIONS(2980),
    [anon_sym_export] = ACTIONS(2980),
    [anon_sym_default] = ACTIONS(2980),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_type] = ACTIONS(2980),
    [anon_sym_typeof] = ACTIONS(2980),
    [anon_sym_import] = ACTIONS(2980),
    [anon_sym_var] = ACTIONS(2980),
    [anon_sym_let] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_else] = ACTIONS(2980),
    [anon_sym_switch] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_await] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_do] = ACTIONS(2980),
    [anon_sym_try] = ACTIONS(2980),
    [anon_sym_with] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_continue] = ACTIONS(2980),
    [anon_sym_debugger] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_throw] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_SLASH] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_async] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_void] = ACTIONS(2980),
    [anon_sym_delete] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2978),
    [sym_number] = ACTIONS(2978),
    [sym_this] = ACTIONS(2980),
    [sym_super] = ACTIONS(2980),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [sym_null] = ACTIONS(2980),
    [sym_undefined] = ACTIONS(2980),
    [anon_sym_AT] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_abstract] = ACTIONS(2980),
    [anon_sym_get] = ACTIONS(2980),
    [anon_sym_set] = ACTIONS(2980),
    [anon_sym_declare] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_any] = ACTIONS(2980),
    [anon_sym_number] = ACTIONS(2980),
    [anon_sym_boolean] = ACTIONS(2980),
    [anon_sym_string] = ACTIONS(2980),
    [anon_sym_symbol] = ACTIONS(2980),
    [anon_sym_interface] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [sym_readonly] = ACTIONS(2980),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2982),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_default] = ACTIONS(2984),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_typeof] = ACTIONS(2984),
    [anon_sym_import] = ACTIONS(2984),
    [anon_sym_var] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_const] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_else] = ACTIONS(2984),
    [anon_sym_switch] = ACTIONS(2984),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2982),
    [anon_sym_await] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_with] = ACTIONS(2984),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_continue] = ACTIONS(2984),
    [anon_sym_debugger] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_throw] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2984),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_SLASH] = ACTIONS(2984),
    [anon_sym_class] = ACTIONS(2984),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_void] = ACTIONS(2984),
    [anon_sym_delete] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(2982),
    [anon_sym_SQUOTE] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2982),
    [sym_number] = ACTIONS(2982),
    [sym_this] = ACTIONS(2984),
    [sym_super] = ACTIONS(2984),
    [sym_true] = ACTIONS(2984),
    [sym_false] = ACTIONS(2984),
    [sym_null] = ACTIONS(2984),
    [sym_undefined] = ACTIONS(2984),
    [anon_sym_AT] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_abstract] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_interface] = ACTIONS(2984),
    [anon_sym_enum] = ACTIONS(2984),
    [sym_readonly] = ACTIONS(2984),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_export] = ACTIONS(2988),
    [anon_sym_default] = ACTIONS(2988),
    [anon_sym_namespace] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_type] = ACTIONS(2988),
    [anon_sym_typeof] = ACTIONS(2988),
    [anon_sym_import] = ACTIONS(2988),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_const] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_else] = ACTIONS(2988),
    [anon_sym_switch] = ACTIONS(2988),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2986),
    [anon_sym_await] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_with] = ACTIONS(2988),
    [anon_sym_break] = ACTIONS(2988),
    [anon_sym_continue] = ACTIONS(2988),
    [anon_sym_debugger] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_throw] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym_case] = ACTIONS(2988),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_SLASH] = ACTIONS(2988),
    [anon_sym_class] = ACTIONS(2988),
    [anon_sym_async] = ACTIONS(2988),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_BANG] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [anon_sym_void] = ACTIONS(2988),
    [anon_sym_delete] = ACTIONS(2988),
    [anon_sym_PLUS_PLUS] = ACTIONS(2986),
    [anon_sym_DASH_DASH] = ACTIONS(2986),
    [anon_sym_DQUOTE] = ACTIONS(2986),
    [anon_sym_SQUOTE] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2986),
    [sym_number] = ACTIONS(2986),
    [sym_this] = ACTIONS(2988),
    [sym_super] = ACTIONS(2988),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [sym_null] = ACTIONS(2988),
    [sym_undefined] = ACTIONS(2988),
    [anon_sym_AT] = ACTIONS(2986),
    [anon_sym_static] = ACTIONS(2988),
    [anon_sym_abstract] = ACTIONS(2988),
    [anon_sym_get] = ACTIONS(2988),
    [anon_sym_set] = ACTIONS(2988),
    [anon_sym_declare] = ACTIONS(2988),
    [anon_sym_public] = ACTIONS(2988),
    [anon_sym_private] = ACTIONS(2988),
    [anon_sym_protected] = ACTIONS(2988),
    [anon_sym_module] = ACTIONS(2988),
    [anon_sym_any] = ACTIONS(2988),
    [anon_sym_number] = ACTIONS(2988),
    [anon_sym_boolean] = ACTIONS(2988),
    [anon_sym_string] = ACTIONS(2988),
    [anon_sym_symbol] = ACTIONS(2988),
    [anon_sym_interface] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2988),
    [sym_readonly] = ACTIONS(2988),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(2990),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_export] = ACTIONS(2992),
    [anon_sym_default] = ACTIONS(2992),
    [anon_sym_namespace] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_type] = ACTIONS(2992),
    [anon_sym_typeof] = ACTIONS(2992),
    [anon_sym_import] = ACTIONS(2992),
    [anon_sym_var] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_const] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_else] = ACTIONS(2992),
    [anon_sym_switch] = ACTIONS(2992),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_await] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_with] = ACTIONS(2992),
    [anon_sym_break] = ACTIONS(2992),
    [anon_sym_continue] = ACTIONS(2992),
    [anon_sym_debugger] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_throw] = ACTIONS(2992),
    [anon_sym_SEMI] = ACTIONS(2990),
    [anon_sym_case] = ACTIONS(2992),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_SLASH] = ACTIONS(2992),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_async] = ACTIONS(2992),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_BANG] = ACTIONS(2990),
    [anon_sym_TILDE] = ACTIONS(2990),
    [anon_sym_void] = ACTIONS(2992),
    [anon_sym_delete] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2990),
    [anon_sym_DASH_DASH] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [sym_number] = ACTIONS(2990),
    [sym_this] = ACTIONS(2992),
    [sym_super] = ACTIONS(2992),
    [sym_true] = ACTIONS(2992),
    [sym_false] = ACTIONS(2992),
    [sym_null] = ACTIONS(2992),
    [sym_undefined] = ACTIONS(2992),
    [anon_sym_AT] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2992),
    [anon_sym_abstract] = ACTIONS(2992),
    [anon_sym_get] = ACTIONS(2992),
    [anon_sym_set] = ACTIONS(2992),
    [anon_sym_declare] = ACTIONS(2992),
    [anon_sym_public] = ACTIONS(2992),
    [anon_sym_private] = ACTIONS(2992),
    [anon_sym_protected] = ACTIONS(2992),
    [anon_sym_module] = ACTIONS(2992),
    [anon_sym_any] = ACTIONS(2992),
    [anon_sym_number] = ACTIONS(2992),
    [anon_sym_boolean] = ACTIONS(2992),
    [anon_sym_string] = ACTIONS(2992),
    [anon_sym_symbol] = ACTIONS(2992),
    [anon_sym_interface] = ACTIONS(2992),
    [anon_sym_enum] = ACTIONS(2992),
    [sym_readonly] = ACTIONS(2992),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(2994),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_export] = ACTIONS(2996),
    [anon_sym_default] = ACTIONS(2996),
    [anon_sym_namespace] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_RBRACE] = ACTIONS(2994),
    [anon_sym_type] = ACTIONS(2996),
    [anon_sym_typeof] = ACTIONS(2996),
    [anon_sym_import] = ACTIONS(2996),
    [anon_sym_var] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_const] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_else] = ACTIONS(2996),
    [anon_sym_switch] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2994),
    [anon_sym_await] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_with] = ACTIONS(2996),
    [anon_sym_break] = ACTIONS(2996),
    [anon_sym_continue] = ACTIONS(2996),
    [anon_sym_debugger] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_throw] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2994),
    [anon_sym_case] = ACTIONS(2996),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_SLASH] = ACTIONS(2996),
    [anon_sym_class] = ACTIONS(2996),
    [anon_sym_async] = ACTIONS(2996),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [anon_sym_void] = ACTIONS(2996),
    [anon_sym_delete] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2994),
    [anon_sym_DASH_DASH] = ACTIONS(2994),
    [anon_sym_DQUOTE] = ACTIONS(2994),
    [anon_sym_SQUOTE] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2994),
    [sym_number] = ACTIONS(2994),
    [sym_this] = ACTIONS(2996),
    [sym_super] = ACTIONS(2996),
    [sym_true] = ACTIONS(2996),
    [sym_false] = ACTIONS(2996),
    [sym_null] = ACTIONS(2996),
    [sym_undefined] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2994),
    [anon_sym_static] = ACTIONS(2996),
    [anon_sym_abstract] = ACTIONS(2996),
    [anon_sym_get] = ACTIONS(2996),
    [anon_sym_set] = ACTIONS(2996),
    [anon_sym_declare] = ACTIONS(2996),
    [anon_sym_public] = ACTIONS(2996),
    [anon_sym_private] = ACTIONS(2996),
    [anon_sym_protected] = ACTIONS(2996),
    [anon_sym_module] = ACTIONS(2996),
    [anon_sym_any] = ACTIONS(2996),
    [anon_sym_number] = ACTIONS(2996),
    [anon_sym_boolean] = ACTIONS(2996),
    [anon_sym_string] = ACTIONS(2996),
    [anon_sym_symbol] = ACTIONS(2996),
    [anon_sym_interface] = ACTIONS(2996),
    [anon_sym_enum] = ACTIONS(2996),
    [sym_readonly] = ACTIONS(2996),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(2998),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3000),
    [anon_sym_default] = ACTIONS(3000),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2998),
    [anon_sym_type] = ACTIONS(3000),
    [anon_sym_typeof] = ACTIONS(3000),
    [anon_sym_import] = ACTIONS(3000),
    [anon_sym_var] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(3000),
    [anon_sym_const] = ACTIONS(3000),
    [anon_sym_if] = ACTIONS(3000),
    [anon_sym_else] = ACTIONS(3000),
    [anon_sym_switch] = ACTIONS(3000),
    [anon_sym_for] = ACTIONS(3000),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_await] = ACTIONS(3000),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_do] = ACTIONS(3000),
    [anon_sym_try] = ACTIONS(3000),
    [anon_sym_with] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3000),
    [anon_sym_continue] = ACTIONS(3000),
    [anon_sym_debugger] = ACTIONS(3000),
    [anon_sym_return] = ACTIONS(3000),
    [anon_sym_throw] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym_case] = ACTIONS(3000),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_SLASH] = ACTIONS(3000),
    [anon_sym_class] = ACTIONS(3000),
    [anon_sym_async] = ACTIONS(3000),
    [anon_sym_function] = ACTIONS(3000),
    [anon_sym_new] = ACTIONS(3000),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_BANG] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(2998),
    [anon_sym_void] = ACTIONS(3000),
    [anon_sym_delete] = ACTIONS(3000),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_DQUOTE] = ACTIONS(2998),
    [anon_sym_SQUOTE] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2998),
    [sym_number] = ACTIONS(2998),
    [sym_this] = ACTIONS(3000),
    [sym_super] = ACTIONS(3000),
    [sym_true] = ACTIONS(3000),
    [sym_false] = ACTIONS(3000),
    [sym_null] = ACTIONS(3000),
    [sym_undefined] = ACTIONS(3000),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_static] = ACTIONS(3000),
    [anon_sym_abstract] = ACTIONS(3000),
    [anon_sym_get] = ACTIONS(3000),
    [anon_sym_set] = ACTIONS(3000),
    [anon_sym_declare] = ACTIONS(3000),
    [anon_sym_public] = ACTIONS(3000),
    [anon_sym_private] = ACTIONS(3000),
    [anon_sym_protected] = ACTIONS(3000),
    [anon_sym_module] = ACTIONS(3000),
    [anon_sym_any] = ACTIONS(3000),
    [anon_sym_number] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(3000),
    [anon_sym_string] = ACTIONS(3000),
    [anon_sym_symbol] = ACTIONS(3000),
    [anon_sym_interface] = ACTIONS(3000),
    [anon_sym_enum] = ACTIONS(3000),
    [sym_readonly] = ACTIONS(3000),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym_identifier] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(1272),
    [anon_sym_default] = ACTIONS(1272),
    [anon_sym_namespace] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(1272),
    [anon_sym_typeof] = ACTIONS(1272),
    [anon_sym_import] = ACTIONS(1272),
    [anon_sym_var] = ACTIONS(1272),
    [anon_sym_let] = ACTIONS(1272),
    [anon_sym_const] = ACTIONS(1272),
    [anon_sym_if] = ACTIONS(1272),
    [anon_sym_else] = ACTIONS(1272),
    [anon_sym_switch] = ACTIONS(1272),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_await] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [anon_sym_do] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_with] = ACTIONS(1272),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_debugger] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_throw] = ACTIONS(1272),
    [anon_sym_SEMI] = ACTIONS(1270),
    [anon_sym_case] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_SLASH] = ACTIONS(1272),
    [anon_sym_class] = ACTIONS(1272),
    [anon_sym_async] = ACTIONS(1272),
    [anon_sym_function] = ACTIONS(1272),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_BANG] = ACTIONS(1270),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_void] = ACTIONS(1272),
    [anon_sym_delete] = ACTIONS(1272),
    [anon_sym_PLUS_PLUS] = ACTIONS(1270),
    [anon_sym_DASH_DASH] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1270),
    [sym_number] = ACTIONS(1270),
    [sym_this] = ACTIONS(1272),
    [sym_super] = ACTIONS(1272),
    [sym_true] = ACTIONS(1272),
    [sym_false] = ACTIONS(1272),
    [sym_null] = ACTIONS(1272),
    [sym_undefined] = ACTIONS(1272),
    [anon_sym_AT] = ACTIONS(1270),
    [anon_sym_static] = ACTIONS(1272),
    [anon_sym_abstract] = ACTIONS(1272),
    [anon_sym_get] = ACTIONS(1272),
    [anon_sym_set] = ACTIONS(1272),
    [anon_sym_declare] = ACTIONS(1272),
    [anon_sym_public] = ACTIONS(1272),
    [anon_sym_private] = ACTIONS(1272),
    [anon_sym_protected] = ACTIONS(1272),
    [anon_sym_module] = ACTIONS(1272),
    [anon_sym_any] = ACTIONS(1272),
    [anon_sym_number] = ACTIONS(1272),
    [anon_sym_boolean] = ACTIONS(1272),
    [anon_sym_string] = ACTIONS(1272),
    [anon_sym_symbol] = ACTIONS(1272),
    [anon_sym_interface] = ACTIONS(1272),
    [anon_sym_enum] = ACTIONS(1272),
    [sym_readonly] = ACTIONS(1272),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(3002),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3004),
    [anon_sym_default] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3004),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_type] = ACTIONS(3004),
    [anon_sym_typeof] = ACTIONS(3004),
    [anon_sym_import] = ACTIONS(3004),
    [anon_sym_var] = ACTIONS(3004),
    [anon_sym_let] = ACTIONS(3004),
    [anon_sym_const] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3004),
    [anon_sym_else] = ACTIONS(3004),
    [anon_sym_switch] = ACTIONS(3004),
    [anon_sym_for] = ACTIONS(3004),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_await] = ACTIONS(3004),
    [anon_sym_while] = ACTIONS(3004),
    [anon_sym_do] = ACTIONS(3004),
    [anon_sym_try] = ACTIONS(3004),
    [anon_sym_with] = ACTIONS(3004),
    [anon_sym_break] = ACTIONS(3004),
    [anon_sym_continue] = ACTIONS(3004),
    [anon_sym_debugger] = ACTIONS(3004),
    [anon_sym_return] = ACTIONS(3004),
    [anon_sym_throw] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_yield] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_class] = ACTIONS(3004),
    [anon_sym_async] = ACTIONS(3004),
    [anon_sym_function] = ACTIONS(3004),
    [anon_sym_new] = ACTIONS(3004),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3002),
    [anon_sym_TILDE] = ACTIONS(3002),
    [anon_sym_void] = ACTIONS(3004),
    [anon_sym_delete] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_DQUOTE] = ACTIONS(3002),
    [anon_sym_SQUOTE] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3002),
    [sym_number] = ACTIONS(3002),
    [sym_this] = ACTIONS(3004),
    [sym_super] = ACTIONS(3004),
    [sym_true] = ACTIONS(3004),
    [sym_false] = ACTIONS(3004),
    [sym_null] = ACTIONS(3004),
    [sym_undefined] = ACTIONS(3004),
    [anon_sym_AT] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3004),
    [anon_sym_abstract] = ACTIONS(3004),
    [anon_sym_get] = ACTIONS(3004),
    [anon_sym_set] = ACTIONS(3004),
    [anon_sym_declare] = ACTIONS(3004),
    [anon_sym_public] = ACTIONS(3004),
    [anon_sym_private] = ACTIONS(3004),
    [anon_sym_protected] = ACTIONS(3004),
    [anon_sym_module] = ACTIONS(3004),
    [anon_sym_any] = ACTIONS(3004),
    [anon_sym_number] = ACTIONS(3004),
    [anon_sym_boolean] = ACTIONS(3004),
    [anon_sym_string] = ACTIONS(3004),
    [anon_sym_symbol] = ACTIONS(3004),
    [anon_sym_interface] = ACTIONS(3004),
    [anon_sym_enum] = ACTIONS(3004),
    [sym_readonly] = ACTIONS(3004),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(3006),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3006),
    [anon_sym_await] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_yield] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(3006),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3006),
    [anon_sym_TILDE] = ACTIONS(3006),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3006),
    [anon_sym_DASH_DASH] = ACTIONS(3006),
    [anon_sym_DQUOTE] = ACTIONS(3006),
    [anon_sym_SQUOTE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3006),
    [sym_number] = ACTIONS(3006),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3006),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [sym_readonly] = ACTIONS(3008),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3012),
    [anon_sym_export] = ACTIONS(3012),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_type] = ACTIONS(3012),
    [anon_sym_typeof] = ACTIONS(3012),
    [anon_sym_import] = ACTIONS(3012),
    [anon_sym_var] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_await] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_debugger] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_async] = ACTIONS(3012),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_void] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3010),
    [sym_number] = ACTIONS(3010),
    [sym_this] = ACTIONS(3012),
    [sym_super] = ACTIONS(3012),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [sym_null] = ACTIONS(3012),
    [sym_undefined] = ACTIONS(3012),
    [anon_sym_AT] = ACTIONS(3010),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_abstract] = ACTIONS(3012),
    [anon_sym_get] = ACTIONS(3012),
    [anon_sym_set] = ACTIONS(3012),
    [anon_sym_declare] = ACTIONS(3012),
    [anon_sym_public] = ACTIONS(3012),
    [anon_sym_private] = ACTIONS(3012),
    [anon_sym_protected] = ACTIONS(3012),
    [anon_sym_module] = ACTIONS(3012),
    [anon_sym_any] = ACTIONS(3012),
    [anon_sym_number] = ACTIONS(3012),
    [anon_sym_boolean] = ACTIONS(3012),
    [anon_sym_string] = ACTIONS(3012),
    [anon_sym_symbol] = ACTIONS(3012),
    [anon_sym_interface] = ACTIONS(3012),
    [anon_sym_enum] = ACTIONS(3012),
    [sym_readonly] = ACTIONS(3012),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(3014),
    [sym_identifier] = ACTIONS(3016),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_typeof] = ACTIONS(3016),
    [anon_sym_import] = ACTIONS(3016),
    [anon_sym_var] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_else] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_await] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_debugger] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_yield] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_void] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_number] = ACTIONS(3014),
    [sym_this] = ACTIONS(3016),
    [sym_super] = ACTIONS(3016),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_undefined] = ACTIONS(3016),
    [anon_sym_AT] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_abstract] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_interface] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [sym_readonly] = ACTIONS(3016),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3020),
    [anon_sym_export] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_type] = ACTIONS(3020),
    [anon_sym_typeof] = ACTIONS(3020),
    [anon_sym_import] = ACTIONS(3020),
    [anon_sym_var] = ACTIONS(3020),
    [anon_sym_let] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_else] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_await] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_with] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_debugger] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_yield] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_async] = ACTIONS(3020),
    [anon_sym_function] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [sym_number] = ACTIONS(3018),
    [sym_this] = ACTIONS(3020),
    [sym_super] = ACTIONS(3020),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [sym_null] = ACTIONS(3020),
    [sym_undefined] = ACTIONS(3020),
    [anon_sym_AT] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_abstract] = ACTIONS(3020),
    [anon_sym_get] = ACTIONS(3020),
    [anon_sym_set] = ACTIONS(3020),
    [anon_sym_declare] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_module] = ACTIONS(3020),
    [anon_sym_any] = ACTIONS(3020),
    [anon_sym_number] = ACTIONS(3020),
    [anon_sym_boolean] = ACTIONS(3020),
    [anon_sym_string] = ACTIONS(3020),
    [anon_sym_symbol] = ACTIONS(3020),
    [anon_sym_interface] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [sym_readonly] = ACTIONS(3020),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3024),
    [anon_sym_export] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_type] = ACTIONS(3024),
    [anon_sym_typeof] = ACTIONS(3024),
    [anon_sym_import] = ACTIONS(3024),
    [anon_sym_var] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3022),
    [anon_sym_await] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_debugger] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_SLASH] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_async] = ACTIONS(3024),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_void] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3022),
    [sym_number] = ACTIONS(3022),
    [sym_this] = ACTIONS(3024),
    [sym_super] = ACTIONS(3024),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [sym_null] = ACTIONS(3024),
    [sym_undefined] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_abstract] = ACTIONS(3024),
    [anon_sym_get] = ACTIONS(3024),
    [anon_sym_set] = ACTIONS(3024),
    [anon_sym_declare] = ACTIONS(3024),
    [anon_sym_public] = ACTIONS(3024),
    [anon_sym_private] = ACTIONS(3024),
    [anon_sym_protected] = ACTIONS(3024),
    [anon_sym_module] = ACTIONS(3024),
    [anon_sym_any] = ACTIONS(3024),
    [anon_sym_number] = ACTIONS(3024),
    [anon_sym_boolean] = ACTIONS(3024),
    [anon_sym_string] = ACTIONS(3024),
    [anon_sym_symbol] = ACTIONS(3024),
    [anon_sym_interface] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [sym_readonly] = ACTIONS(3024),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_export] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_type] = ACTIONS(3030),
    [anon_sym_typeof] = ACTIONS(3030),
    [anon_sym_import] = ACTIONS(3030),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3028),
    [anon_sym_await] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_debugger] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_LT] = ACTIONS(3028),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_async] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_void] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3028),
    [sym_number] = ACTIONS(3028),
    [sym_this] = ACTIONS(3030),
    [sym_super] = ACTIONS(3030),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [sym_null] = ACTIONS(3030),
    [sym_undefined] = ACTIONS(3030),
    [anon_sym_AT] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_abstract] = ACTIONS(3030),
    [anon_sym_get] = ACTIONS(3030),
    [anon_sym_set] = ACTIONS(3030),
    [anon_sym_declare] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3030),
    [anon_sym_any] = ACTIONS(3030),
    [anon_sym_number] = ACTIONS(3030),
    [anon_sym_boolean] = ACTIONS(3030),
    [anon_sym_string] = ACTIONS(3030),
    [anon_sym_symbol] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [sym_readonly] = ACTIONS(3030),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(3032),
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_export] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3034),
    [anon_sym_typeof] = ACTIONS(3034),
    [anon_sym_import] = ACTIONS(3034),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_await] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_with] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_debugger] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_async] = ACTIONS(3034),
    [anon_sym_function] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_void] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3032),
    [sym_number] = ACTIONS(3032),
    [sym_this] = ACTIONS(3034),
    [sym_super] = ACTIONS(3034),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [sym_null] = ACTIONS(3034),
    [sym_undefined] = ACTIONS(3034),
    [anon_sym_AT] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_abstract] = ACTIONS(3034),
    [anon_sym_get] = ACTIONS(3034),
    [anon_sym_set] = ACTIONS(3034),
    [anon_sym_declare] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_module] = ACTIONS(3034),
    [anon_sym_any] = ACTIONS(3034),
    [anon_sym_number] = ACTIONS(3034),
    [anon_sym_boolean] = ACTIONS(3034),
    [anon_sym_string] = ACTIONS(3034),
    [anon_sym_symbol] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [sym_readonly] = ACTIONS(3034),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(3036),
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_export] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_type] = ACTIONS(3038),
    [anon_sym_typeof] = ACTIONS(3038),
    [anon_sym_import] = ACTIONS(3038),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(3036),
    [anon_sym_await] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_with] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_debugger] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_yield] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3036),
    [anon_sym_SLASH] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_async] = ACTIONS(3038),
    [anon_sym_function] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_void] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [sym_number] = ACTIONS(3036),
    [sym_this] = ACTIONS(3038),
    [sym_super] = ACTIONS(3038),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [sym_null] = ACTIONS(3038),
    [sym_undefined] = ACTIONS(3038),
    [anon_sym_AT] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_abstract] = ACTIONS(3038),
    [anon_sym_get] = ACTIONS(3038),
    [anon_sym_set] = ACTIONS(3038),
    [anon_sym_declare] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_module] = ACTIONS(3038),
    [anon_sym_any] = ACTIONS(3038),
    [anon_sym_number] = ACTIONS(3038),
    [anon_sym_boolean] = ACTIONS(3038),
    [anon_sym_string] = ACTIONS(3038),
    [anon_sym_symbol] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [sym_readonly] = ACTIONS(3038),
  },
  [616] = {
    [sym_identifier] = ACTIONS(2606),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2606),
    [anon_sym_LBRACE] = ACTIONS(2608),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2606),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2606),
    [anon_sym_get] = ACTIONS(2606),
    [anon_sym_set] = ACTIONS(2606),
    [anon_sym_declare] = ACTIONS(2606),
    [anon_sym_public] = ACTIONS(2606),
    [anon_sym_private] = ACTIONS(2606),
    [anon_sym_protected] = ACTIONS(2606),
    [anon_sym_module] = ACTIONS(2606),
    [anon_sym_any] = ACTIONS(2606),
    [anon_sym_number] = ACTIONS(2606),
    [anon_sym_boolean] = ACTIONS(2606),
    [anon_sym_string] = ACTIONS(2606),
    [anon_sym_symbol] = ACTIONS(2606),
    [sym_readonly] = ACTIONS(2606),
  },
  [617] = {
    [sym_identifier] = ACTIONS(2606),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2606),
    [anon_sym_LBRACE] = ACTIONS(2608),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2606),
    [anon_sym_EQ_GT] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(593),
    [anon_sym_DASH_EQ] = ACTIONS(593),
    [anon_sym_STAR_EQ] = ACTIONS(593),
    [anon_sym_SLASH_EQ] = ACTIONS(593),
    [anon_sym_PERCENT_EQ] = ACTIONS(593),
    [anon_sym_CARET_EQ] = ACTIONS(593),
    [anon_sym_AMP_EQ] = ACTIONS(593),
    [anon_sym_PIPE_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(593),
    [anon_sym_LT_LT_EQ] = ACTIONS(593),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2606),
    [anon_sym_get] = ACTIONS(2606),
    [anon_sym_set] = ACTIONS(2606),
    [anon_sym_declare] = ACTIONS(2606),
    [anon_sym_public] = ACTIONS(2606),
    [anon_sym_private] = ACTIONS(2606),
    [anon_sym_protected] = ACTIONS(2606),
    [anon_sym_module] = ACTIONS(2606),
    [anon_sym_any] = ACTIONS(2606),
    [anon_sym_number] = ACTIONS(2606),
    [anon_sym_boolean] = ACTIONS(2606),
    [anon_sym_string] = ACTIONS(2606),
    [anon_sym_symbol] = ACTIONS(2606),
    [sym_readonly] = ACTIONS(2606),
  },
  [618] = {
    [sym__call_signature] = STATE(3045),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_export] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(793),
    [anon_sym_of] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2685),
    [anon_sym_public] = ACTIONS(2685),
    [anon_sym_private] = ACTIONS(2685),
    [anon_sym_protected] = ACTIONS(2685),
    [anon_sym_module] = ACTIONS(2685),
    [anon_sym_any] = ACTIONS(2685),
    [anon_sym_number] = ACTIONS(2685),
    [anon_sym_boolean] = ACTIONS(2685),
    [anon_sym_string] = ACTIONS(2685),
    [anon_sym_symbol] = ACTIONS(2685),
    [sym_readonly] = ACTIONS(2685),
  },
  [619] = {
    [sym__call_signature] = STATE(3045),
    [sym_formal_parameters] = STATE(2536),
    [sym_type_parameters] = STATE(2828),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_export] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(627),
    [anon_sym_of] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(632),
    [anon_sym_PLUS_EQ] = ACTIONS(547),
    [anon_sym_DASH_EQ] = ACTIONS(547),
    [anon_sym_STAR_EQ] = ACTIONS(547),
    [anon_sym_SLASH_EQ] = ACTIONS(547),
    [anon_sym_PERCENT_EQ] = ACTIONS(547),
    [anon_sym_CARET_EQ] = ACTIONS(547),
    [anon_sym_AMP_EQ] = ACTIONS(547),
    [anon_sym_PIPE_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(547),
    [anon_sym_LT_LT_EQ] = ACTIONS(547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(547),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2685),
    [anon_sym_public] = ACTIONS(2685),
    [anon_sym_private] = ACTIONS(2685),
    [anon_sym_protected] = ACTIONS(2685),
    [anon_sym_module] = ACTIONS(2685),
    [anon_sym_any] = ACTIONS(2685),
    [anon_sym_number] = ACTIONS(2685),
    [anon_sym_boolean] = ACTIONS(2685),
    [anon_sym_string] = ACTIONS(2685),
    [anon_sym_symbol] = ACTIONS(2685),
    [sym_readonly] = ACTIONS(2685),
  },
  [620] = {
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_export] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_type] = ACTIONS(3040),
    [anon_sym_typeof] = ACTIONS(3040),
    [anon_sym_import] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(3040),
    [anon_sym_let] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_await] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_with] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_debugger] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_yield] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_function] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_void] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3042),
    [sym_number] = ACTIONS(3042),
    [sym_this] = ACTIONS(3040),
    [sym_super] = ACTIONS(3040),
    [sym_true] = ACTIONS(3040),
    [sym_false] = ACTIONS(3040),
    [sym_null] = ACTIONS(3040),
    [sym_undefined] = ACTIONS(3040),
    [anon_sym_AT] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_abstract] = ACTIONS(3040),
    [anon_sym_get] = ACTIONS(3040),
    [anon_sym_set] = ACTIONS(3040),
    [anon_sym_declare] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_module] = ACTIONS(3040),
    [anon_sym_any] = ACTIONS(3040),
    [anon_sym_number] = ACTIONS(3040),
    [anon_sym_boolean] = ACTIONS(3040),
    [anon_sym_string] = ACTIONS(3040),
    [anon_sym_symbol] = ACTIONS(3040),
    [anon_sym_interface] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [sym_readonly] = ACTIONS(3040),
  },
  [621] = {
    [sym_identifier] = ACTIONS(3044),
    [anon_sym_export] = ACTIONS(3044),
    [anon_sym_namespace] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_type] = ACTIONS(3044),
    [anon_sym_typeof] = ACTIONS(3044),
    [anon_sym_import] = ACTIONS(3044),
    [anon_sym_var] = ACTIONS(3044),
    [anon_sym_let] = ACTIONS(3044),
    [anon_sym_const] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_switch] = ACTIONS(3044),
    [anon_sym_for] = ACTIONS(3044),
    [anon_sym_LPAREN] = ACTIONS(3046),
    [anon_sym_await] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_try] = ACTIONS(3044),
    [anon_sym_with] = ACTIONS(3044),
    [anon_sym_break] = ACTIONS(3044),
    [anon_sym_continue] = ACTIONS(3044),
    [anon_sym_debugger] = ACTIONS(3044),
    [anon_sym_return] = ACTIONS(3044),
    [anon_sym_throw] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_yield] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_async] = ACTIONS(3044),
    [anon_sym_function] = ACTIONS(3044),
    [anon_sym_new] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_void] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3046),
    [sym_number] = ACTIONS(3046),
    [sym_this] = ACTIONS(3044),
    [sym_super] = ACTIONS(3044),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [sym_null] = ACTIONS(3044),
    [sym_undefined] = ACTIONS(3044),
    [anon_sym_AT] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_abstract] = ACTIONS(3044),
    [anon_sym_get] = ACTIONS(3044),
    [anon_sym_set] = ACTIONS(3044),
    [anon_sym_declare] = ACTIONS(3044),
    [anon_sym_public] = ACTIONS(3044),
    [anon_sym_private] = ACTIONS(3044),
    [anon_sym_protected] = ACTIONS(3044),
    [anon_sym_module] = ACTIONS(3044),
    [anon_sym_any] = ACTIONS(3044),
    [anon_sym_number] = ACTIONS(3044),
    [anon_sym_boolean] = ACTIONS(3044),
    [anon_sym_string] = ACTIONS(3044),
    [anon_sym_symbol] = ACTIONS(3044),
    [anon_sym_interface] = ACTIONS(3044),
    [anon_sym_enum] = ACTIONS(3044),
    [sym_readonly] = ACTIONS(3044),
  },
  [622] = {
    [sym_identifier] = ACTIONS(3048),
    [anon_sym_export] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_type] = ACTIONS(3048),
    [anon_sym_typeof] = ACTIONS(3048),
    [anon_sym_import] = ACTIONS(3048),
    [anon_sym_var] = ACTIONS(3048),
    [anon_sym_let] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_LPAREN] = ACTIONS(3050),
    [anon_sym_await] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_with] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_debugger] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_async] = ACTIONS(3048),
    [anon_sym_function] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_void] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3050),
    [sym_number] = ACTIONS(3050),
    [sym_this] = ACTIONS(3048),
    [sym_super] = ACTIONS(3048),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [sym_null] = ACTIONS(3048),
    [sym_undefined] = ACTIONS(3048),
    [anon_sym_AT] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_abstract] = ACTIONS(3048),
    [anon_sym_get] = ACTIONS(3048),
    [anon_sym_set] = ACTIONS(3048),
    [anon_sym_declare] = ACTIONS(3048),
    [anon_sym_public] = ACTIONS(3048),
    [anon_sym_private] = ACTIONS(3048),
    [anon_sym_protected] = ACTIONS(3048),
    [anon_sym_module] = ACTIONS(3048),
    [anon_sym_any] = ACTIONS(3048),
    [anon_sym_number] = ACTIONS(3048),
    [anon_sym_boolean] = ACTIONS(3048),
    [anon_sym_string] = ACTIONS(3048),
    [anon_sym_symbol] = ACTIONS(3048),
    [anon_sym_interface] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [sym_readonly] = ACTIONS(3048),
  },
  [623] = {
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_export] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_type] = ACTIONS(3052),
    [anon_sym_typeof] = ACTIONS(3052),
    [anon_sym_import] = ACTIONS(3052),
    [anon_sym_var] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3054),
    [anon_sym_await] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_async] = ACTIONS(3052),
    [anon_sym_function] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_void] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_DQUOTE] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3054),
    [sym_number] = ACTIONS(3054),
    [sym_this] = ACTIONS(3052),
    [sym_super] = ACTIONS(3052),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_undefined] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_abstract] = ACTIONS(3052),
    [anon_sym_get] = ACTIONS(3052),
    [anon_sym_set] = ACTIONS(3052),
    [anon_sym_declare] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_module] = ACTIONS(3052),
    [anon_sym_any] = ACTIONS(3052),
    [anon_sym_number] = ACTIONS(3052),
    [anon_sym_boolean] = ACTIONS(3052),
    [anon_sym_string] = ACTIONS(3052),
    [anon_sym_symbol] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [sym_readonly] = ACTIONS(3052),
  },
  [624] = {
    [sym_identifier] = ACTIONS(3056),
    [anon_sym_export] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_type] = ACTIONS(3056),
    [anon_sym_typeof] = ACTIONS(3056),
    [anon_sym_import] = ACTIONS(3056),
    [anon_sym_var] = ACTIONS(3056),
    [anon_sym_let] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_LPAREN] = ACTIONS(3058),
    [anon_sym_await] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_debugger] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_yield] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_async] = ACTIONS(3056),
    [anon_sym_function] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_void] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3058),
    [sym_number] = ACTIONS(3058),
    [sym_this] = ACTIONS(3056),
    [sym_super] = ACTIONS(3056),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [sym_null] = ACTIONS(3056),
    [sym_undefined] = ACTIONS(3056),
    [anon_sym_AT] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_abstract] = ACTIONS(3056),
    [anon_sym_get] = ACTIONS(3056),
    [anon_sym_set] = ACTIONS(3056),
    [anon_sym_declare] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_module] = ACTIONS(3056),
    [anon_sym_any] = ACTIONS(3056),
    [anon_sym_number] = ACTIONS(3056),
    [anon_sym_boolean] = ACTIONS(3056),
    [anon_sym_string] = ACTIONS(3056),
    [anon_sym_symbol] = ACTIONS(3056),
    [anon_sym_interface] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [sym_readonly] = ACTIONS(3056),
  },
  [625] = {
    [sym_identifier] = ACTIONS(3060),
    [anon_sym_export] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_type] = ACTIONS(3060),
    [anon_sym_typeof] = ACTIONS(3060),
    [anon_sym_import] = ACTIONS(3060),
    [anon_sym_var] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(3062),
    [anon_sym_await] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_with] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_debugger] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym_yield] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3062),
    [anon_sym_LT] = ACTIONS(3062),
    [anon_sym_SLASH] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_async] = ACTIONS(3060),
    [anon_sym_function] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_void] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3062),
    [sym_number] = ACTIONS(3062),
    [sym_this] = ACTIONS(3060),
    [sym_super] = ACTIONS(3060),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [sym_null] = ACTIONS(3060),
    [sym_undefined] = ACTIONS(3060),
    [anon_sym_AT] = ACTIONS(3062),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_abstract] = ACTIONS(3060),
    [anon_sym_get] = ACTIONS(3060),
    [anon_sym_set] = ACTIONS(3060),
    [anon_sym_declare] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_module] = ACTIONS(3060),
    [anon_sym_any] = ACTIONS(3060),
    [anon_sym_number] = ACTIONS(3060),
    [anon_sym_boolean] = ACTIONS(3060),
    [anon_sym_string] = ACTIONS(3060),
    [anon_sym_symbol] = ACTIONS(3060),
    [anon_sym_interface] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [sym_readonly] = ACTIONS(3060),
  },
  [626] = {
    [sym_identifier] = ACTIONS(3064),
    [anon_sym_export] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_type] = ACTIONS(3064),
    [anon_sym_typeof] = ACTIONS(3064),
    [anon_sym_import] = ACTIONS(3064),
    [anon_sym_var] = ACTIONS(3064),
    [anon_sym_let] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_LPAREN] = ACTIONS(3066),
    [anon_sym_await] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_with] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_debugger] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_yield] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_LT] = ACTIONS(3066),
    [anon_sym_SLASH] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_async] = ACTIONS(3064),
    [anon_sym_function] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_void] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3066),
    [sym_number] = ACTIONS(3066),
    [sym_this] = ACTIONS(3064),
    [sym_super] = ACTIONS(3064),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [sym_null] = ACTIONS(3064),
    [sym_undefined] = ACTIONS(3064),
    [anon_sym_AT] = ACTIONS(3066),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_abstract] = ACTIONS(3064),
    [anon_sym_get] = ACTIONS(3064),
    [anon_sym_set] = ACTIONS(3064),
    [anon_sym_declare] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3064),
    [anon_sym_private] = ACTIONS(3064),
    [anon_sym_protected] = ACTIONS(3064),
    [anon_sym_module] = ACTIONS(3064),
    [anon_sym_any] = ACTIONS(3064),
    [anon_sym_number] = ACTIONS(3064),
    [anon_sym_boolean] = ACTIONS(3064),
    [anon_sym_string] = ACTIONS(3064),
    [anon_sym_symbol] = ACTIONS(3064),
    [anon_sym_interface] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [sym_readonly] = ACTIONS(3064),
  },
  [627] = {
    [sym_identifier] = ACTIONS(3068),
    [anon_sym_export] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_type] = ACTIONS(3068),
    [anon_sym_typeof] = ACTIONS(3068),
    [anon_sym_import] = ACTIONS(3068),
    [anon_sym_var] = ACTIONS(3068),
    [anon_sym_let] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_LPAREN] = ACTIONS(3070),
    [anon_sym_await] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_with] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_debugger] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_yield] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3070),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_async] = ACTIONS(3068),
    [anon_sym_function] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_void] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [sym_number] = ACTIONS(3070),
    [sym_this] = ACTIONS(3068),
    [sym_super] = ACTIONS(3068),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [sym_null] = ACTIONS(3068),
    [sym_undefined] = ACTIONS(3068),
    [anon_sym_AT] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_abstract] = ACTIONS(3068),
    [anon_sym_get] = ACTIONS(3068),
    [anon_sym_set] = ACTIONS(3068),
    [anon_sym_declare] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_module] = ACTIONS(3068),
    [anon_sym_any] = ACTIONS(3068),
    [anon_sym_number] = ACTIONS(3068),
    [anon_sym_boolean] = ACTIONS(3068),
    [anon_sym_string] = ACTIONS(3068),
    [anon_sym_symbol] = ACTIONS(3068),
    [anon_sym_interface] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [sym_readonly] = ACTIONS(3068),
  },
  [628] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_export] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_type] = ACTIONS(3072),
    [anon_sym_typeof] = ACTIONS(3072),
    [anon_sym_import] = ACTIONS(3072),
    [anon_sym_var] = ACTIONS(3072),
    [anon_sym_let] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(3074),
    [anon_sym_await] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_with] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_debugger] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym_yield] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_async] = ACTIONS(3072),
    [anon_sym_function] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_void] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3074),
    [sym_number] = ACTIONS(3074),
    [sym_this] = ACTIONS(3072),
    [sym_super] = ACTIONS(3072),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [sym_null] = ACTIONS(3072),
    [sym_undefined] = ACTIONS(3072),
    [anon_sym_AT] = ACTIONS(3074),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_abstract] = ACTIONS(3072),
    [anon_sym_get] = ACTIONS(3072),
    [anon_sym_set] = ACTIONS(3072),
    [anon_sym_declare] = ACTIONS(3072),
    [anon_sym_public] = ACTIONS(3072),
    [anon_sym_private] = ACTIONS(3072),
    [anon_sym_protected] = ACTIONS(3072),
    [anon_sym_module] = ACTIONS(3072),
    [anon_sym_any] = ACTIONS(3072),
    [anon_sym_number] = ACTIONS(3072),
    [anon_sym_boolean] = ACTIONS(3072),
    [anon_sym_string] = ACTIONS(3072),
    [anon_sym_symbol] = ACTIONS(3072),
    [anon_sym_interface] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [sym_readonly] = ACTIONS(3072),
  },
  [629] = {
    [sym_identifier] = ACTIONS(3076),
    [anon_sym_export] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_type] = ACTIONS(3076),
    [anon_sym_typeof] = ACTIONS(3076),
    [anon_sym_import] = ACTIONS(3076),
    [anon_sym_var] = ACTIONS(3076),
    [anon_sym_let] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_await] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_with] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_debugger] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym_yield] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_SLASH] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_async] = ACTIONS(3076),
    [anon_sym_function] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_void] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [sym_number] = ACTIONS(3078),
    [sym_this] = ACTIONS(3076),
    [sym_super] = ACTIONS(3076),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [sym_null] = ACTIONS(3076),
    [sym_undefined] = ACTIONS(3076),
    [anon_sym_AT] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_abstract] = ACTIONS(3076),
    [anon_sym_get] = ACTIONS(3076),
    [anon_sym_set] = ACTIONS(3076),
    [anon_sym_declare] = ACTIONS(3076),
    [anon_sym_public] = ACTIONS(3076),
    [anon_sym_private] = ACTIONS(3076),
    [anon_sym_protected] = ACTIONS(3076),
    [anon_sym_module] = ACTIONS(3076),
    [anon_sym_any] = ACTIONS(3076),
    [anon_sym_number] = ACTIONS(3076),
    [anon_sym_boolean] = ACTIONS(3076),
    [anon_sym_string] = ACTIONS(3076),
    [anon_sym_symbol] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [sym_readonly] = ACTIONS(3076),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    STATE(1173), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 16,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [92] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3084), 1,
      sym_identifier,
    ACTIONS(3086), 1,
      anon_sym_DQUOTE,
    ACTIONS(3088), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(136), 1,
      sym__module,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [190] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3084), 1,
      sym_identifier,
    ACTIONS(3086), 1,
      anon_sym_DQUOTE,
    ACTIONS(3088), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(136), 1,
      sym__module,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [288] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3084), 1,
      sym_identifier,
    ACTIONS(3086), 1,
      anon_sym_DQUOTE,
    ACTIONS(3088), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(136), 1,
      sym__module,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [386] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(3090), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [484] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(3090), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [582] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(3090), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [680] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    STATE(1425), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [771] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [858] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(623), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3094), 1,
      sym_identifier,
    STATE(999), 1,
      sym_string,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1301), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [946] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(697), 1,
      anon_sym_EQ_GT,
    ACTIONS(2701), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    STATE(1642), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 13,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(517), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1036] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3094), 1,
      sym_identifier,
    STATE(999), 1,
      sym_string,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1301), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1122] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(627), 1,
      anon_sym_in,
    ACTIONS(630), 1,
      anon_sym_of,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3094), 1,
      sym_identifier,
    STATE(999), 1,
      sym_string,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1301), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1212] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(625), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3094), 1,
      sym_identifier,
    STATE(999), 1,
      sym_string,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1301), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1300] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(621), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3084), 1,
      sym_identifier,
    ACTIONS(3086), 1,
      anon_sym_DQUOTE,
    ACTIONS(3088), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(136), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1388] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(625), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(3090), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1476] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(623), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(3098), 1,
      sym_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    STATE(2555), 1,
      sym_nested_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1564] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(657), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    STATE(1173), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [1654] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    STATE(1173), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 14,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1744] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(621), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(3090), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1832] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3102), 1,
      anon_sym_export,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    ACTIONS(3108), 1,
      anon_sym_RBRACE,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3112), 1,
      anon_sym_SEMI,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3116), 1,
      anon_sym_async,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3126), 1,
      anon_sym_static,
    ACTIONS(3132), 1,
      sym_readonly,
    ACTIONS(3134), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2617), 1,
      aux_sym_object_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3128), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3130), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3100), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1961] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3112), 1,
      anon_sym_SEMI,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3134), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3138), 1,
      anon_sym_export,
    ACTIONS(3140), 1,
      anon_sym_RBRACE,
    ACTIONS(3142), 1,
      anon_sym_async,
    ACTIONS(3144), 1,
      anon_sym_static,
    ACTIONS(3150), 1,
      sym_readonly,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2667), 1,
      aux_sym_object_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3146), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3148), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2665), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3136), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2090] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(640), 1,
      anon_sym_EQ,
    ACTIONS(646), 1,
      anon_sym_COLON,
    ACTIONS(648), 1,
      anon_sym_QMARK,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(643), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(479), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2181] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    STATE(1425), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2270] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3112), 1,
      anon_sym_SEMI,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3134), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3154), 1,
      anon_sym_export,
    ACTIONS(3156), 1,
      anon_sym_RBRACE,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3160), 1,
      anon_sym_static,
    ACTIONS(3166), 1,
      sym_readonly,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2677), 1,
      aux_sym_object_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3162), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3164), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2678), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3152), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2399] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3102), 1,
      anon_sym_export,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3116), 1,
      anon_sym_async,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3126), 1,
      anon_sym_static,
    ACTIONS(3132), 1,
      sym_readonly,
    ACTIONS(3168), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(3172), 1,
      anon_sym_SEMI,
    ACTIONS(3174), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2617), 1,
      aux_sym_object_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3128), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3130), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2189), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3100), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2528] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3102), 1,
      anon_sym_export,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3112), 1,
      anon_sym_SEMI,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3116), 1,
      anon_sym_async,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3126), 1,
      anon_sym_static,
    ACTIONS(3132), 1,
      sym_readonly,
    ACTIONS(3134), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2617), 1,
      aux_sym_object_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3128), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3130), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3100), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2657] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(640), 1,
      anon_sym_EQ,
    ACTIONS(648), 1,
      anon_sym_QMARK,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(643), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(479), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2746] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3102), 1,
      anon_sym_export,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3112), 1,
      anon_sym_SEMI,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3116), 1,
      anon_sym_async,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3126), 1,
      anon_sym_static,
    ACTIONS(3132), 1,
      sym_readonly,
    ACTIONS(3134), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3178), 1,
      anon_sym_RBRACE,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2617), 1,
      aux_sym_object_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3128), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3130), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3100), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2875] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(657), 1,
      anon_sym_EQ_GT,
    ACTIONS(761), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(777), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [2960] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3112), 1,
      anon_sym_SEMI,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3134), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3182), 1,
      anon_sym_export,
    ACTIONS(3184), 1,
      anon_sym_RBRACE,
    ACTIONS(3186), 1,
      anon_sym_async,
    ACTIONS(3188), 1,
      anon_sym_static,
    ACTIONS(3194), 1,
      sym_readonly,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2596), 1,
      aux_sym_object_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3190), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3192), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2594), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3180), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3089] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_EQ_GT,
    ACTIONS(703), 1,
      anon_sym_EQ,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2701), 1,
      anon_sym_DOT,
    ACTIONS(3196), 1,
      sym_identifier,
    STATE(1457), 1,
      sym_nested_identifier,
    STATE(1458), 1,
      sym_string,
    STATE(1582), 1,
      sym__module,
    ACTIONS(733), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(471), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3174] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3259] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3346] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(665), 1,
      anon_sym_EQ,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3094), 1,
      sym_identifier,
    STATE(999), 1,
      sym_string,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1301), 1,
      sym__module,
    ACTIONS(679), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3430] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3516] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    STATE(1171), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3198), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3587] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3217), 1,
      anon_sym_DOT,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3223), 1,
      anon_sym_is,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3208), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3214), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [3668] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3225), 1,
      sym_identifier,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3074), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3227), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3229), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3877] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(793), 1,
      anon_sym_in,
    ACTIONS(796), 1,
      anon_sym_of,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(479), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3964] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3225), 1,
      sym_identifier,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3233), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4110] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3235), 1,
      anon_sym_EQ,
    ACTIONS(3239), 1,
      anon_sym_in,
    ACTIONS(3242), 1,
      anon_sym_of,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    STATE(2218), 1,
      sym_type_annotation,
    STATE(2766), 1,
      sym__initializer,
    ACTIONS(3237), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4193] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3250), 1,
      anon_sym_LT,
    ACTIONS(3253), 1,
      anon_sym_DOT,
    ACTIONS(3255), 1,
      anon_sym_is,
    STATE(1972), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2559), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3208), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3042), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4402] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(627), 1,
      anon_sym_in,
    ACTIONS(630), 1,
      anon_sym_of,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1023), 1,
      sym__module,
    ACTIONS(479), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4489] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3225), 1,
      sym_identifier,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4572] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1173), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4646] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(1628), 1,
      sym_template_string,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1560), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4762] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3297), 1,
      anon_sym_DOT,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3208), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3214), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [4842] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 1,
      anon_sym_COMMA,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    ACTIONS(3303), 1,
      anon_sym_DOT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3214), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [4924] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5004] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    STATE(1171), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3198), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5078] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_EQ,
    ACTIONS(3074), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3305), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3307), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [5144] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5224] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3309), 1,
      anon_sym_EQ,
    ACTIONS(3311), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(3314), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5304] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1476), 1,
      anon_sym_LPAREN,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5384] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3321), 1,
      anon_sym_export,
    ACTIONS(3325), 1,
      anon_sym_async,
    ACTIONS(3327), 1,
      anon_sym_static,
    ACTIONS(3333), 1,
      sym_readonly,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3323), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3329), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3331), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2873), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2168), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3319), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5502] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3309), 1,
      anon_sym_EQ,
    ACTIONS(3311), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(3314), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5582] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3309), 1,
      anon_sym_EQ,
    ACTIONS(3311), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(3314), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5662] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(1486), 1,
      sym_template_string,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1487), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3372), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [5844] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1157), 1,
      sym_template_string,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1156), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5960] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(3104), 1,
      anon_sym_STAR,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3114), 1,
      anon_sym_LBRACK,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3124), 1,
      sym_number,
    ACTIONS(3321), 1,
      anon_sym_export,
    ACTIONS(3325), 1,
      anon_sym_async,
    ACTIONS(3327), 1,
      anon_sym_static,
    ACTIONS(3333), 1,
      sym_readonly,
    STATE(1840), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3323), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3329), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3331), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1896), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2873), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2192), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3319), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6078] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3412), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [6146] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(623), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [6219] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3421), 1,
      anon_sym_GT,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6332] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3427), 1,
      anon_sym_RBRACK,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2577), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6445] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3217), 1,
      anon_sym_DOT,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(3429), 1,
      anon_sym_EQ,
    ACTIONS(3431), 1,
      anon_sym_EQ_GT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3208), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3214), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3433), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [6524] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(611), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(614), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6597] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3435), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6710] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_EQ,
    ACTIONS(3439), 1,
      anon_sym_LBRACE,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3443), 1,
      anon_sym_LT,
    ACTIONS(3446), 1,
      anon_sym_DOT,
    ACTIONS(3448), 1,
      anon_sym_EQ_GT,
    ACTIONS(3452), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2495), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2635), 1,
      sym_type_arguments,
    ACTIONS(3450), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6791] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3454), 1,
      anon_sym_RBRACK,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2714), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6904] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    STATE(1434), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3198), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6977] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3456), 1,
      anon_sym_RBRACK,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2574), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7090] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3458), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7203] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(614), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(611), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(617), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7278] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3460), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3462), 1,
      anon_sym_DOT,
    ACTIONS(2600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2598), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7464] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3464), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7577] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(3466), 1,
      anon_sym_EQ,
    ACTIONS(3472), 1,
      anon_sym_RPAREN,
    ACTIONS(3476), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3469), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7662] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(3437), 1,
      anon_sym_EQ,
    ACTIONS(3448), 1,
      anon_sym_EQ_GT,
    ACTIONS(3481), 1,
      anon_sym_DOT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3208), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3214), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3450), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7741] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7810] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3483), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7923] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3485), 1,
      anon_sym_DOT,
    ACTIONS(2598), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7996] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3487), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8109] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_EQ,
    ACTIONS(3431), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      anon_sym_COMMA,
    ACTIONS(3491), 1,
      anon_sym_LT,
    ACTIONS(3494), 1,
      anon_sym_DOT,
    STATE(432), 1,
      sym_type_arguments,
    STATE(2507), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3452), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3433), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8188] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3496), 1,
      sym_identifier,
    ACTIONS(3498), 1,
      sym_jsx_identifier,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2402), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8301] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    STATE(1425), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8374] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3500), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8487] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3502), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8600] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3504), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8713] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3506), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8826] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3508), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8939] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3510), 1,
      anon_sym_RBRACK,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2669), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9052] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 1,
      anon_sym_COMMA,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(3512), 1,
      anon_sym_EQ,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(3516), 1,
      anon_sym_EQ_GT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3214), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3518), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9133] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3520), 1,
      anon_sym_RBRACK,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2651), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9246] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(625), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [9319] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3522), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9432] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3524), 1,
      anon_sym_GT,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9545] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9614] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(621), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [9687] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2266), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9797] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1065), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9907] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2281), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10017] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2270), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10127] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3526), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [10197] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(435), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10307] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2526), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10417] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(501), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10527] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1173), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [10599] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2682), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10709] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(442), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10819] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(499), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10929] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2331), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11039] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1976), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11149] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(498), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11259] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1652), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11369] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1975), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3074), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11539] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1639), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11649] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1635), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11759] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(2449), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3409), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3412), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11827] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2521), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11937] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(452), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12047] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2462), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12157] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(611), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(614), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12229] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(450), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12339] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(495), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12449] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(497), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3233), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(625), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [12689] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(617), 1,
      anon_sym_COMMA,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(614), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12763] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(452), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12873] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2091), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12983] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2695), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13093] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2316), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_COLON,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [13273] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2458), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13383] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(435), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13493] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1689), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13603] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1690), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13713] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3448), 1,
      anon_sym_EQ_GT,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    STATE(1640), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3198), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [13785] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1538), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13895] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(442), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14005] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2616), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14115] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1609), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14225] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1519), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14335] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1611), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14445] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2442), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14555] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1520), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14665] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(1931), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3577), 1,
      anon_sym_of,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [14847] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1633), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14957] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(697), 1,
      anon_sym_EQ_GT,
    ACTIONS(2701), 1,
      anon_sym_DOT,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    STATE(1642), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(517), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15029] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(1923), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    STATE(1434), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3198), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15207] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2158), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15317] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(450), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15427] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(452), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15537] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3269), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_new,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3277), 1,
      anon_sym_AMP,
    ACTIONS(3279), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3287), 1,
      sym_this,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(2893), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym_nested_identifier,
    STATE(3187), 1,
      sym_formal_parameters,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    STATE(1631), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1659), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15707] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2576), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15885] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(1930), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15995] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(450), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16105] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2339), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16215] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2437), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16325] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1511), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16435] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1506), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16545] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(623), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16615] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_EQ,
    ACTIONS(3443), 1,
      anon_sym_LT,
    ACTIONS(3446), 1,
      anon_sym_DOT,
    ACTIONS(3448), 1,
      anon_sym_EQ_GT,
    ACTIONS(3579), 1,
      anon_sym_LBRACE,
    STATE(2635), 1,
      sym_type_arguments,
    ACTIONS(3581), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3450), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16691] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1099), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16801] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(657), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1173), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(517), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16873] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 1,
      anon_sym_COLON,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16943] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1956), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17053] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1954), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17163] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1952), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17273] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3583), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [17343] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1951), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17453] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    STATE(1171), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3198), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [17525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3042), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17585] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2340), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(2598), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17767] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2578), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17877] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1086), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(621), 1,
      anon_sym_COLON,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3227), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3229), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18185] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2447), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18295] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3431), 1,
      anon_sym_EQ_GT,
    STATE(1171), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3198), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18367] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1979), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18477] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1497), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18587] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1938), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18697] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1084), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18807] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2074), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18917] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2375), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19091] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1944), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19201] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1540), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19311] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1539), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19421] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2455), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19531] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2296), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19641] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(1928), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19751] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2476), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19861] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2402), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19971] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1073), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20081] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3343), 1,
      anon_sym_LPAREN,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_new,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3351), 1,
      anon_sym_AMP,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3361), 1,
      sym_this,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(2846), 1,
      sym_type_parameters,
    STATE(3137), 1,
      sym_nested_identifier,
    STATE(3176), 1,
      sym_formal_parameters,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    STATE(1541), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1436), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20191] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1051), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20301] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(503), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20411] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1068), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20521] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2231), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20631] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2505), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20741] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2022), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(2598), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20923] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(1927), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21033] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(442), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1216), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3369), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3257), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21209] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1045), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21319] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2457), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21429] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2630), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21539] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_new,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3391), 1,
      anon_sym_AMP,
    ACTIONS(3393), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3401), 1,
      sym_this,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(2917), 1,
      sym_type_parameters,
    STATE(3065), 1,
      sym_nested_identifier,
    STATE(3091), 1,
      sym_formal_parameters,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    STATE(1046), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1037), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21649] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_EQ,
    ACTIONS(3431), 1,
      anon_sym_EQ_GT,
    ACTIONS(3491), 1,
      anon_sym_LT,
    ACTIONS(3494), 1,
      anon_sym_DOT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3581), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3433), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21723] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(627), 1,
      anon_sym_in,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3589), 1,
      anon_sym_of,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21795] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    STATE(2843), 1,
      sym_type_annotation,
    ACTIONS(3591), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21869] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      anon_sym_new,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3546), 1,
      anon_sym_AMP,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3144), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(435), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21979] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(621), 1,
      anon_sym_COLON,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_EQ_GT,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22049] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2426), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22159] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(990), 1,
      anon_sym_AMP,
    ACTIONS(992), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3556), 1,
      anon_sym_LPAREN,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_new,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3568), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2985), 1,
      sym_type_parameters,
    STATE(2993), 1,
      sym_nested_identifier,
    STATE(3004), 1,
      sym_formal_parameters,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2542), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1978), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22269] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3532), 1,
      anon_sym_new,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(2775), 1,
      sym_type_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    STATE(3136), 1,
      sym_formal_parameters,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2443), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22379] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3211), 1,
      anon_sym_LT,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(3596), 1,
      anon_sym_DOT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3208), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22457] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(826), 1,
      anon_sym_AMP,
    ACTIONS(828), 1,
      anon_sym_PIPE,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2624), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_new,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    STATE(2701), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(455), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_EQ,
    ACTIONS(3448), 1,
      anon_sym_EQ_GT,
    ACTIONS(3598), 1,
      anon_sym_DOT,
    ACTIONS(2598), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3450), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1124), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22638] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_EQ_GT,
    ACTIONS(703), 1,
      anon_sym_EQ,
    ACTIONS(2701), 1,
      anon_sym_DOT,
    ACTIONS(611), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(614), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(733), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_EQ_GT,
    ACTIONS(761), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(777), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22776] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(640), 1,
      anon_sym_EQ,
    ACTIONS(648), 1,
      anon_sym_QMARK,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(643), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22847] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3516), 1,
      anon_sym_EQ_GT,
    STATE(1434), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3198), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22918] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_EQ,
    ACTIONS(3516), 1,
      anon_sym_EQ_GT,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(2598), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3518), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22989] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23056] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3466), 1,
      anon_sym_EQ,
    ACTIONS(3478), 1,
      anon_sym_QMARK,
    ACTIONS(3469), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_EQ,
    ACTIONS(3074), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3305), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3307), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23257] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(640), 1,
      anon_sym_EQ,
    ACTIONS(648), 1,
      anon_sym_QMARK,
    ACTIONS(653), 1,
      anon_sym_RPAREN,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(614), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(643), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3412), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23399] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_COMMA,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 1,
      anon_sym_LBRACK,
    ACTIONS(3412), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 28,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3372), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_EQ_GT,
    ACTIONS(761), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(611), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(614), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(777), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23600] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23669] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(640), 1,
      anon_sym_EQ,
    ACTIONS(646), 1,
      anon_sym_COLON,
    ACTIONS(648), 1,
      anon_sym_QMARK,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(643), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23805] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_EQ,
    ACTIONS(3431), 1,
      anon_sym_EQ_GT,
    ACTIONS(3485), 1,
      anon_sym_DOT,
    ACTIONS(2598), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3433), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1124), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_EQ,
    ACTIONS(3448), 1,
      anon_sym_EQ_GT,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3450), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1124), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23943] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_in,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24014] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_EQ_GT,
    ACTIONS(703), 1,
      anon_sym_EQ,
    ACTIONS(2701), 1,
      anon_sym_DOT,
    ACTIONS(733), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24081] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3606), 1,
      anon_sym_DOT,
    ACTIONS(2598), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24152] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3466), 1,
      anon_sym_EQ,
    ACTIONS(3478), 1,
      anon_sym_QMARK,
    ACTIONS(3608), 1,
      anon_sym_COLON,
    ACTIONS(3469), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    STATE(1425), 1,
      sym_arguments,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(525), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(517), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24296] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    STATE(1640), 1,
      sym_arguments,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3202), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3198), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24363] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3577), 1,
      anon_sym_of,
    ACTIONS(3301), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 1,
      anon_sym_COMMA,
    ACTIONS(3369), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3372), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 28,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24495] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3429), 1,
      anon_sym_EQ,
    ACTIONS(3431), 1,
      anon_sym_EQ_GT,
    ACTIONS(3433), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24562] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(617), 1,
      anon_sym_COMMA,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(665), 1,
      anon_sym_EQ,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(614), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(679), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3412), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(3257), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_EQ,
    ACTIONS(3074), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3307), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3305), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3042), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_COMMA,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 1,
      anon_sym_LBRACK,
    ACTIONS(3412), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3233), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3372), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25005] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_EQ,
    ACTIONS(3219), 1,
      anon_sym_EQ_GT,
    ACTIONS(3610), 1,
      anon_sym_DOT,
    ACTIONS(2600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2598), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3221), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 18,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3227), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3229), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3412), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25385] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3512), 1,
      anon_sym_EQ,
    ACTIONS(3516), 1,
      anon_sym_EQ_GT,
    ACTIONS(3518), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 1,
      anon_sym_COMMA,
    ACTIONS(3369), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3372), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25515] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    ACTIONS(3602), 1,
      anon_sym_in,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(665), 1,
      anon_sym_EQ,
    ACTIONS(1479), 1,
      anon_sym_DOT,
    ACTIONS(679), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25651] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3412), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_EQ,
    ACTIONS(3433), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3369), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3257), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25839] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(614), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(611), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(593), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3074), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3412), 1,
      anon_sym_LT,
    ACTIONS(3409), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3257), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_EQ,
    ACTIONS(3450), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1124), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3577), 1,
      anon_sym_of,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26162] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(793), 1,
      anon_sym_in,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3612), 1,
      anon_sym_of,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3369), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
    ACTIONS(3257), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3409), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3412), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3257), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3259), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26355] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(627), 1,
      anon_sym_in,
    ACTIONS(632), 1,
      anon_sym_EQ_GT,
    ACTIONS(2572), 1,
      anon_sym_DOT,
    ACTIONS(3589), 1,
      anon_sym_of,
    ACTIONS(547), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_EQ,
    ACTIONS(3518), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26485] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3239), 1,
      anon_sym_in,
    ACTIONS(3242), 1,
      anon_sym_of,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3248), 1,
      anon_sym_EQ_GT,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26554] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3239), 1,
      anon_sym_in,
    ACTIONS(3242), 1,
      anon_sym_of,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26618] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3112), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3134), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26722] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1464), 1,
      anon_sym_LBRACE,
    ACTIONS(3634), 1,
      anon_sym_STAR,
    ACTIONS(3636), 1,
      anon_sym_default,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_as,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3666), 1,
      anon_sym_module,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    STATE(1866), 1,
      sym_decorator,
    STATE(2498), 1,
      sym_export_clause,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2306), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26826] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3672), 1,
      sym_identifier,
    ACTIONS(3674), 1,
      anon_sym_STAR,
    ACTIONS(3678), 1,
      anon_sym_LBRACE,
    STATE(2938), 1,
      sym_import_clause,
    ACTIONS(3682), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(2946), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3041), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(3676), 15,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(3680), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26900] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1464), 1,
      anon_sym_LBRACE,
    ACTIONS(3634), 1,
      anon_sym_STAR,
    ACTIONS(3636), 1,
      anon_sym_default,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_as,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3666), 1,
      anon_sym_module,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    STATE(1866), 1,
      sym_decorator,
    STATE(2498), 1,
      sym_export_clause,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2306), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27004] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3684), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3686), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2206), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27108] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1464), 1,
      anon_sym_LBRACE,
    ACTIONS(3634), 1,
      anon_sym_STAR,
    ACTIONS(3636), 1,
      anon_sym_default,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_as,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3666), 1,
      anon_sym_module,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    STATE(1866), 1,
      sym_decorator,
    STATE(2498), 1,
      sym_export_clause,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2306), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27212] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3688), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3690), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2174), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27316] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3172), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3174), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2189), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27420] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1464), 1,
      anon_sym_LBRACE,
    ACTIONS(3634), 1,
      anon_sym_STAR,
    ACTIONS(3636), 1,
      anon_sym_default,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_as,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3666), 1,
      anon_sym_module,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    STATE(1866), 1,
      sym_decorator,
    STATE(2498), 1,
      sym_export_clause,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2306), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27524] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_EQ,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3577), 1,
      anon_sym_of,
    ACTIONS(3204), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1126), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1124), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [27588] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3692), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3694), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2213), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27692] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1464), 1,
      anon_sym_LBRACE,
    ACTIONS(3634), 1,
      anon_sym_STAR,
    ACTIONS(3636), 1,
      anon_sym_default,
    ACTIONS(3640), 1,
      anon_sym_as,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3666), 1,
      anon_sym_module,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    ACTIONS(3696), 1,
      anon_sym_EQ,
    STATE(1866), 1,
      sym_decorator,
    STATE(2498), 1,
      sym_export_clause,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2306), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27793] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1464), 1,
      anon_sym_LBRACE,
    ACTIONS(3634), 1,
      anon_sym_STAR,
    ACTIONS(3636), 1,
      anon_sym_default,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_as,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3666), 1,
      anon_sym_module,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    STATE(1866), 1,
      sym_decorator,
    STATE(2498), 1,
      sym_export_clause,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3644), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2306), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27896] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3701), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27996] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3703), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28096] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3705), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28196] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3707), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28296] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3709), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28396] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3711), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28496] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3713), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28596] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3715), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28696] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3717), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28796] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3719), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28896] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3721), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28996] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3723), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29096] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3725), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29196] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3727), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29296] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3729), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29396] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3731), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [29458] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2192), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29554] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2168), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29650] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2207), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29746] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2214), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29842] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3731), 1,
      anon_sym_LT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [29908] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30004] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3118), 1,
      anon_sym_new,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3616), 1,
      anon_sym_export,
    ACTIONS(3618), 1,
      anon_sym_STAR,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_async,
    ACTIONS(3624), 1,
      sym_number,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3632), 1,
      sym_readonly,
    STATE(1835), 1,
      sym_accessibility_modifier,
    STATE(1866), 1,
      sym_decorator,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym__call_signature,
    STATE(2472), 1,
      aux_sym_export_statement_repeat1,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(3628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2159), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3614), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30100] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3739), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30162] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1109), 1,
      sym_template_string,
    STATE(1170), 1,
      sym_arguments,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30220] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3741), 1,
      anon_sym_LT,
    ACTIONS(3744), 1,
      anon_sym_DOT,
    ACTIONS(3746), 1,
      anon_sym_is,
    STATE(1048), 1,
      sym_type_arguments,
    ACTIONS(2561), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2559), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1158), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [30330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 1,
      anon_sym_EQ,
    ACTIONS(3748), 1,
      sym__automatic_semicolon,
    ACTIONS(1108), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1106), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3752), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3756), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3760), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3764), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3768), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    STATE(1171), 1,
      sym_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3772), 1,
      anon_sym_EQ,
    STATE(1171), 1,
      sym_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3776), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3780), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1280), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [30958] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3784), 1,
      anon_sym_COMMA,
    ACTIONS(3786), 1,
      anon_sym_RPAREN,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2638), 1,
      aux_sym_array_repeat1,
    STATE(2996), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31058] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31128] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3823), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31220] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3825), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31312] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3827), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31404] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3829), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      sym__automatic_semicolon,
    ACTIONS(1144), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1142), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31548] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3833), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31640] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3835), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31732] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3837), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31824] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3843), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31896] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31990] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [32068] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3784), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3850), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2697), 1,
      aux_sym_array_repeat1,
    STATE(2996), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32168] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [32250] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3839), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [32336] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3843), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [32412] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3843), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [32482] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3839), 1,
      anon_sym_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [32572] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3852), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32664] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3854), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1272), 1,
      sym_statement_block,
    ACTIONS(1100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1098), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32810] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3858), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32902] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(3860), 1,
      anon_sym_EQ,
    ACTIONS(3864), 1,
      anon_sym_in,
    ACTIONS(3867), 1,
      anon_sym_of,
    STATE(2235), 1,
      sym_type_annotation,
    STATE(2755), 1,
      sym__initializer,
    ACTIONS(3862), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32966] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [33036] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [33104] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(3869), 1,
      anon_sym_EQ,
    ACTIONS(3873), 1,
      anon_sym_in,
    ACTIONS(3876), 1,
      anon_sym_of,
    STATE(2239), 1,
      sym_type_annotation,
    STATE(2753), 1,
      sym__initializer,
    ACTIONS(3871), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1171), 1,
      sym_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33222] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3878), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33314] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3880), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3882), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33498] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3884), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2545), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1110), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    ACTIONS(3886), 1,
      anon_sym_DOT,
    STATE(1272), 1,
      sym_statement_block,
    ACTIONS(1100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1098), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3888), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      sym__automatic_semicolon,
    ACTIONS(1108), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1106), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    STATE(1027), 1,
      sym_statement_block,
    ACTIONS(1100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1098), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1027), 1,
      sym_statement_block,
    ACTIONS(1100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1098), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3898), 1,
      anon_sym_LT,
    STATE(1052), 1,
      sym_type_arguments,
    ACTIONS(2650), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2648), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33968] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3901), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34060] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3784), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3903), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2565), 1,
      aux_sym_array_repeat1,
    STATE(2996), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34160] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3905), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3858), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3911), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3780), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1270), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3756), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34497] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(3913), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(3127), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1158), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1162), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34692] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3915), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1142), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2493), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34881] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(555), 1,
      anon_sym_SQUOTE,
    ACTIONS(3375), 1,
      sym_identifier,
    ACTIONS(3377), 1,
      anon_sym_STAR,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3381), 1,
      anon_sym_typeof,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3389), 1,
      anon_sym_QMARK,
    ACTIONS(3399), 1,
      sym_number,
    ACTIONS(3405), 1,
      anon_sym_keyof,
    ACTIONS(3407), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_LPAREN,
    ACTIONS(3919), 1,
      sym_this,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(3065), 1,
      sym_nested_identifier,
    ACTIONS(3395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3403), 2,
      sym_true,
      sym_false,
    STATE(1035), 2,
      sym_string,
      sym__number,
    ACTIONS(3397), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1044), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34966] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(3921), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(3086), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(617), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3680), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2531), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35210] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(824), 1,
      anon_sym_QMARK,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2622), 1,
      anon_sym_typeof,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3415), 1,
      sym_identifier,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3923), 1,
      anon_sym_LPAREN,
    ACTIONS(3925), 1,
      sym_this,
    STATE(1894), 1,
      sym_nested_type_identifier,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3927), 1,
      anon_sym_LBRACK,
    ACTIONS(2549), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2547), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1280), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35395] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(988), 1,
      anon_sym_QMARK,
    ACTIONS(1008), 1,
      anon_sym_keyof,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3550), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_typeof,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3566), 1,
      sym_number,
    ACTIONS(3929), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      sym_this,
    STATE(1918), 1,
      sym_nested_type_identifier,
    STATE(2993), 1,
      sym_nested_identifier,
    ACTIONS(3562), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3570), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    ACTIONS(3564), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1977), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1216), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1276), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2543), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(2600), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2598), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3927), 1,
      anon_sym_LBRACK,
    ACTIONS(2485), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2483), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2497), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2467), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2479), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2453), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35925] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3731), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [35984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_DOT,
    ACTIONS(2459), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2457), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2527), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2463), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2580), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1180), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1182), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2505), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2513), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2517), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_DOT,
    ACTIONS(2451), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2449), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3938), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1226), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1172), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1256), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1246), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_AMP,
    ACTIONS(3942), 1,
      anon_sym_PIPE,
    ACTIONS(2673), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2671), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1202), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3944), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3946), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_AMP,
    ACTIONS(3942), 1,
      anon_sym_PIPE,
    ACTIONS(2665), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2663), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3948), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3950), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36976] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3905), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3988), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37116] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3489), 1,
      anon_sym_COMMA,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2467), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3992), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2535), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2539), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4018), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4020), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37358] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3528), 1,
      sym_identifier,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3534), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_LPAREN,
    ACTIONS(3925), 1,
      sym_this,
    STATE(2049), 1,
      sym_nested_type_identifier,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4024), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2576), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37541] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3884), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3768), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2521), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37730] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3882), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2509), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_AMP,
    ACTIONS(3942), 1,
      anon_sym_PIPE,
    ACTIONS(2677), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2675), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2501), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_AMP,
    ACTIONS(3942), 1,
      anon_sym_PIPE,
    ACTIONS(2681), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2679), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38025] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3880), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4026), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4028), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4032), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1236), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1190), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1192), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1210), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1212), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1134), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2584), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4034), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4036), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4038), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4040), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2489), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2481), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_AMP,
    ACTIONS(3942), 1,
      anon_sym_PIPE,
    ACTIONS(2689), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2687), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38712] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3878), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2471), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3307), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4044), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4046), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4048), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38999] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3823), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39090] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      anon_sym_SQUOTE,
    ACTIONS(3261), 1,
      sym_identifier,
    ACTIONS(3263), 1,
      anon_sym_STAR,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_typeof,
    ACTIONS(3271), 1,
      anon_sym_LBRACK,
    ACTIONS(3275), 1,
      anon_sym_QMARK,
    ACTIONS(3285), 1,
      sym_number,
    ACTIONS(3291), 1,
      anon_sym_keyof,
    ACTIONS(3293), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_LPAREN,
    ACTIONS(4052), 1,
      sym_this,
    STATE(1557), 1,
      sym_nested_type_identifier,
    STATE(3088), 1,
      sym_nested_identifier,
    ACTIONS(3281), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3289), 2,
      sym_true,
      sym_false,
    STATE(1657), 2,
      sym_string,
      sym__number,
    ACTIONS(3283), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1691), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1216), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3884), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4056), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4058), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39322] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(4060), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3882), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4067), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39487] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4060), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39556] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3833), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3880), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39696] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3835), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4073), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39836] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3837), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4077), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3752), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40025] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3825), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40116] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4060), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4081), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40234] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4083), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2996), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    STATE(2538), 1,
      sym_type_arguments,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3739), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40390] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(3196), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1116), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4089), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4093), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3825), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1266), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40781] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4097), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40852] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3827), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40943] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4102), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41069] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3829), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41160] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [41241] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1109), 1,
      sym_template_string,
    STATE(1438), 1,
      sym_arguments,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41296] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3839), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [41381] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4097), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41456] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4097), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_QMARK,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41614] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3852), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4104), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4107), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41758] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3854), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4113), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41902] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3731), 1,
      anon_sym_LT,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    STATE(2538), 1,
      sym_type_arguments,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [41965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1138), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42014] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_STAR,
    ACTIONS(848), 1,
      anon_sym_keyof,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2636), 1,
      sym_number,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3530), 1,
      anon_sym_typeof,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(3544), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_LPAREN,
    ACTIONS(3925), 1,
      sym_this,
    STATE(483), 1,
      sym_nested_type_identifier,
    STATE(3072), 1,
      sym_nested_identifier,
    ACTIONS(2632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2640), 2,
      sym_true,
      sym_false,
    STATE(451), 2,
      sym_string,
      sym__number,
    ACTIONS(3423), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42099] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3858), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42190] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(3335), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_STAR,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3341), 1,
      anon_sym_typeof,
    ACTIONS(3345), 1,
      anon_sym_LBRACK,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(3359), 1,
      sym_number,
    ACTIONS(3365), 1,
      anon_sym_keyof,
    ACTIONS(3367), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4118), 1,
      sym_this,
    STATE(1413), 1,
      sym_nested_type_identifier,
    STATE(3137), 1,
      sym_nested_identifier,
    ACTIONS(3355), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3363), 2,
      sym_true,
      sym_false,
    STATE(1433), 2,
      sym_string,
      sym__number,
    ACTIONS(3357), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1518), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42275] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4124), 1,
      anon_sym_LBRACE,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    STATE(2494), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4156), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4158), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42421] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4160), 1,
      anon_sym_COMMA,
    ACTIONS(4163), 1,
      anon_sym_RBRACE,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3854), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3760), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42663] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4169), 1,
      anon_sym_COMMA,
    ACTIONS(4172), 1,
      anon_sym_RBRACE,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3852), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4174), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4176), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4180), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2477), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2475), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3764), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3835), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43052] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4184), 1,
      anon_sym_COMMA,
    ACTIONS(4187), 1,
      anon_sym_RBRACE,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43147] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3901), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4189), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4191), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43287] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4193), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(3223), 1,
      sym_type_annotation,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4201), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4203), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4205), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4209), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3776), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43678] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4187), 1,
      anon_sym_RBRACE,
    ACTIONS(4211), 1,
      anon_sym_COMMA,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3823), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43773] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4214), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2590), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43867] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4216), 1,
      anon_sym_LT,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [43933] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 8,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 11,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [44009] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3827), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44099] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 4,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 6,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [44179] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3829), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44269] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3833), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44359] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3837), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44451] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3835), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44541] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3837), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44631] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4247), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 15,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44701] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    STATE(2486), 1,
      sym_type_arguments,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3739), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [44759] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4216), 1,
      anon_sym_LT,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [44827] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 12,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44903] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_LT,
    ACTIONS(4253), 1,
      anon_sym_DOT,
    ACTIONS(4255), 1,
      anon_sym_is,
    STATE(1523), 1,
      sym_type_arguments,
    ACTIONS(2561), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2559), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44959] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 7,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [45039] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3839), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 6,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [45123] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4257), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45213] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4247), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 12,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45287] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4247), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45355] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3839), 1,
      anon_sym_QMARK,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3841), 4,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45443] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3852), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45533] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3854), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45623] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4259), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2697), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45717] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4261), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2614), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      sym_regex_flags,
    ACTIONS(4263), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4265), 23,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45861] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4269), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45953] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3858), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46043] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3880), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46133] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3882), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46223] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3884), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46313] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3905), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46403] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4271), 1,
      anon_sym_COMMA,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4273), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46495] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4275), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2751), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46589] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 10,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 11,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [46663] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [46731] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3839), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3841), 3,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1109), 1,
      sym_template_string,
    STATE(1634), 1,
      sym_arguments,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3198), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [46873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3772), 1,
      anon_sym_EQ,
    STATE(1434), 1,
      sym_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46927] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4280), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3852), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47019] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4282), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [47087] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(4282), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [47153] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4285), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3854), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47245] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4271), 1,
      anon_sym_COMMA,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3848), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47337] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3907), 1,
      anon_sym_LBRACE,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3858), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__automatic_semicolon,
    ACTIONS(1144), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1142), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1142), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1276), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47575] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4257), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 1,
      sym__automatic_semicolon,
    ACTIONS(1108), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1106), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47715] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4257), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47805] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4293), 1,
      anon_sym_RBRACE,
    ACTIONS(4295), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_async,
    ACTIONS(4299), 1,
      sym_number,
    ACTIONS(4301), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      sym_readonly,
    STATE(1837), 1,
      sym_accessibility_modifier,
    STATE(2617), 1,
      aux_sym_object_repeat1,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(4303), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4305), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4291), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47891] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      anon_sym_LBRACK,
    ACTIONS(4299), 1,
      sym_number,
    ACTIONS(4311), 1,
      anon_sym_RBRACE,
    ACTIONS(4313), 1,
      anon_sym_async,
    ACTIONS(4315), 1,
      anon_sym_static,
    ACTIONS(4321), 1,
      sym_readonly,
    STATE(1837), 1,
      sym_accessibility_modifier,
    STATE(2702), 1,
      aux_sym_object_repeat1,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(4317), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4319), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2732), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4309), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47977] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4323), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3878), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48069] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4325), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2600), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1116), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48211] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3823), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48301] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4271), 1,
      anon_sym_COMMA,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4327), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48393] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4054), 1,
      anon_sym_LBRACE,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3884), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48485] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2543), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1110), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48537] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4329), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2614), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48631] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4331), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2565), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48725] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4069), 1,
      anon_sym_LBRACE,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3880), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48817] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3825), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48907] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4257), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48997] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4333), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3901), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49089] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 14,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [49159] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4257), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49249] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4335), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49317] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49407] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3878), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49497] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4216), 1,
      anon_sym_LT,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [49565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    STATE(1434), 1,
      sym_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49619] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3823), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49709] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3825), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49799] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3827), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49889] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4063), 1,
      anon_sym_LBRACE,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3882), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49981] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 3,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 5,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50065] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4338), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4340), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50157] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3829), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50247] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3833), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50337] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4342), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3829), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50429] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3835), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50519] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4344), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3823), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50611] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3837), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3888), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50751] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4095), 1,
      anon_sym_LBRACE,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3825), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50843] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4346), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2700), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50937] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4348), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [51007] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3827), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51099] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [51175] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3878), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51265] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [51345] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_LT,
    ACTIONS(3962), 1,
      anon_sym_QMARK,
    ACTIONS(3964), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3970), 1,
      anon_sym_AMP,
    ACTIONS(3972), 1,
      anon_sym_PIPE,
    ACTIONS(3976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4271), 1,
      anon_sym_COMMA,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3966), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3974), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4353), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3952), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3968), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3956), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51437] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      anon_sym_LBRACK,
    ACTIONS(4299), 1,
      sym_number,
    ACTIONS(4357), 1,
      anon_sym_RBRACE,
    ACTIONS(4359), 1,
      anon_sym_async,
    ACTIONS(4361), 1,
      anon_sym_static,
    ACTIONS(4367), 1,
      sym_readonly,
    STATE(1837), 1,
      sym_accessibility_modifier,
    STATE(2677), 1,
      aux_sym_object_repeat1,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(4363), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4365), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2678), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4355), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [51523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1162), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51571] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3839), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [51655] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4369), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2700), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51749] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4348), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [51823] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4348), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [51891] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3839), 1,
      anon_sym_QMARK,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3841), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51979] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3852), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52069] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3854), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52159] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3858), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52249] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3880), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52339] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3731), 1,
      anon_sym_LT,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    STATE(2486), 1,
      sym_type_arguments,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [52401] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4182), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3835), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52493] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3882), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52583] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3884), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52673] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3905), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3731), 1,
      anon_sym_LT,
    STATE(2486), 1,
      sym_type_arguments,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [52821] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52911] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4282), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [52979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1114), 1,
      sym__automatic_semicolon,
    ACTIONS(1106), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1110), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53031] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      anon_sym_LBRACK,
    ACTIONS(4299), 1,
      sym_number,
    ACTIONS(4373), 1,
      anon_sym_RBRACE,
    ACTIONS(4375), 1,
      anon_sym_async,
    ACTIONS(4377), 1,
      anon_sym_static,
    ACTIONS(4383), 1,
      sym_readonly,
    STATE(1837), 1,
      sym_accessibility_modifier,
    STATE(2596), 1,
      aux_sym_object_repeat1,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4381), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2594), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4371), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53117] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3996), 1,
      anon_sym_LT,
    ACTIONS(3998), 1,
      anon_sym_QMARK,
    ACTIONS(4000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4006), 1,
      anon_sym_AMP,
    ACTIONS(4008), 1,
      anon_sym_PIPE,
    ACTIONS(4012), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4016), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4002), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3990), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4004), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4340), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3994), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4014), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53207] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4385), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2614), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53301] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(4335), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53367] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4335), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53435] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4387), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2638), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1138), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4391), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53677] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      anon_sym_LBRACK,
    ACTIONS(4299), 1,
      sym_number,
    ACTIONS(4395), 1,
      anon_sym_RBRACE,
    ACTIONS(4397), 1,
      anon_sym_async,
    ACTIONS(4399), 1,
      anon_sym_static,
    ACTIONS(4405), 1,
      sym_readonly,
    STATE(1837), 1,
      sym_accessibility_modifier,
    STATE(2667), 1,
      aux_sym_object_repeat1,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(4401), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4403), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2665), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4393), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1270), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53811] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4407), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(2683), 1,
      aux_sym_array_repeat1,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53905] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_as,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_QMARK,
    ACTIONS(4134), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4140), 1,
      anon_sym_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE,
    ACTIONS(4146), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4150), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4152), 1,
      anon_sym_BANG,
    ACTIONS(4409), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_type_arguments,
    ACTIONS(3905), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4136), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4144), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1684), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4120), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4138), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4126), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4148), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53997] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4411), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1228), 1,
      sym__automatic_semicolon,
    ACTIONS(1220), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1224), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1226), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54138] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3837), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54227] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4439), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54416] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      anon_sym_LBRACK,
    ACTIONS(4299), 1,
      sym_number,
    ACTIONS(4447), 1,
      anon_sym_async,
    ACTIONS(4449), 1,
      anon_sym_static,
    ACTIONS(4455), 1,
      sym_readonly,
    STATE(1837), 1,
      sym_accessibility_modifier,
    STATE(3103), 1,
      sym_object,
    STATE(3104), 1,
      sym_array,
    ACTIONS(3323), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4451), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4453), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2873), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4445), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54497] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54564] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    ACTIONS(4469), 1,
      sym_readonly,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54633] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(4475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54698] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4479), 1,
      anon_sym_RBRACE,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1336), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1120), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54828] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54895] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    ACTIONS(4469), 1,
      sym_readonly,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54964] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(4475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [55029] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    STATE(1434), 1,
      sym_arguments,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55080] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4493), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55169] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55260] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4497), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55327] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(4497), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55392] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55481] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3901), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55570] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4497), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_EQ,
    ACTIONS(4500), 1,
      anon_sym_in,
    ACTIONS(4503), 1,
      anon_sym_of,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55690] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4505), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1377), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55771] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1328), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_in,
    ACTIONS(4512), 1,
      anon_sym_of,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55905] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4514), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1377), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55986] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4516), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1331), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      sym_regex_flags,
    ACTIONS(4263), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4265), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56116] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1377), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56197] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1334), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56278] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4524), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1377), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56359] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4526), 1,
      anon_sym_RBRACE,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56450] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4528), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56541] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4530), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1377), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56622] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4532), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56713] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4534), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1339), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56794] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4536), 1,
      anon_sym_RBRACE,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LPAREN,
    ACTIONS(4541), 1,
      anon_sym_COLON,
    ACTIONS(4543), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3778), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3780), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56938] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3905), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57027] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4546), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57116] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [57183] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    ACTIONS(4469), 1,
      sym_readonly,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57252] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(4475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [57317] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4548), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3884), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57495] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3882), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57584] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3880), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57673] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3858), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57762] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57853] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3854), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57942] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3852), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58031] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_QMARK,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3841), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58118] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4552), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58185] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4552), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58258] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3839), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58341] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3841), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [58420] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58495] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4552), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3841), 14,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58564] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4555), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58655] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3835), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58744] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58833] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4557), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1377), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58914] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3829), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59003] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3827), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59092] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3825), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59181] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3823), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59270] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4559), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59359] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3620), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_STAR,
    ACTIONS(4481), 1,
      anon_sym_async,
    ACTIONS(4483), 1,
      sym_number,
    ACTIONS(4485), 1,
      anon_sym_static,
    ACTIONS(4487), 1,
      anon_sym_abstract,
    ACTIONS(4491), 1,
      sym_readonly,
    ACTIONS(4561), 1,
      anon_sym_RBRACE,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1367), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3614), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2531), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4110), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2648), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4104), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 1,
      anon_sym_LT,
    ACTIONS(4566), 1,
      anon_sym_DOT,
    ACTIONS(4568), 1,
      anon_sym_is,
    STATE(1603), 1,
      sym_type_arguments,
    ACTIONS(2561), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2559), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59601] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 1,
      anon_sym_STAR,
    ACTIONS(4576), 1,
      anon_sym_RBRACE,
    ACTIONS(4578), 1,
      anon_sym_LBRACK,
    ACTIONS(4581), 1,
      anon_sym_async,
    ACTIONS(4584), 1,
      anon_sym_DQUOTE,
    ACTIONS(4587), 1,
      anon_sym_SQUOTE,
    ACTIONS(4590), 1,
      sym_number,
    ACTIONS(4593), 1,
      anon_sym_AT,
    ACTIONS(4596), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_abstract,
    ACTIONS(4608), 1,
      sym_readonly,
    STATE(1818), 1,
      sym_method_definition,
    STATE(1829), 1,
      sym_accessibility_modifier,
    ACTIONS(4602), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1377), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2601), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4570), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59682] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2479), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 1,
      anon_sym_EQ,
    ACTIONS(4611), 1,
      sym__automatic_semicolon,
    ACTIONS(1108), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1106), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2545), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1110), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3888), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59884] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(4475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [59949] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    ACTIONS(4469), 1,
      sym_readonly,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60018] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [60085] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3954), 1,
      anon_sym_as,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_BANG,
    ACTIONS(4417), 1,
      anon_sym_LT,
    ACTIONS(4419), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4433), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    STATE(2538), 1,
      sym_type_arguments,
    ACTIONS(3984), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4423), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4431), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4613), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1504), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4413), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4425), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4415), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60174] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4187), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60263] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4172), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60352] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4163), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60441] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4615), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60532] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4617), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60623] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4619), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60714] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4621), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60805] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4623), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60896] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4625), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60987] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3772), 1,
      anon_sym_EQ,
    STATE(1640), 1,
      sym_arguments,
    ACTIONS(3198), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    STATE(1640), 1,
      sym_arguments,
    ACTIONS(3198), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 1,
      anon_sym_EQ,
    ACTIONS(4289), 1,
      sym__automatic_semicolon,
    ACTIONS(1108), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1106), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      sym__automatic_semicolon,
    ACTIONS(1148), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1152), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61195] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1184), 1,
      sym__automatic_semicolon,
    ACTIONS(1176), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1180), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1182), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      sym__automatic_semicolon,
    ACTIONS(1166), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1170), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1172), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      sym__automatic_semicolon,
    ACTIONS(1250), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1254), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1256), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1248), 1,
      sym__automatic_semicolon,
    ACTIONS(1240), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1244), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1246), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 1,
      sym__automatic_semicolon,
    ACTIONS(1196), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1200), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1202), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      sym__automatic_semicolon,
    ACTIONS(1230), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1234), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1236), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 1,
      sym__automatic_semicolon,
    ACTIONS(1186), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1190), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1192), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61552] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61643] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4629), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61734] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4631), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61825] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    ACTIONS(4633), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1214), 1,
      sym__automatic_semicolon,
    ACTIONS(1206), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1210), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1212), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 1,
      sym__automatic_semicolon,
    ACTIONS(1128), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1132), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1134), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62018] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3790), 1,
      anon_sym_LT,
    ACTIONS(3792), 1,
      anon_sym_QMARK,
    ACTIONS(3794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3800), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_PIPE,
    ACTIONS(3806), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3810), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3796), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4411), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3798), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3788), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LT,
    STATE(1527), 1,
      sym_type_arguments,
    ACTIONS(2650), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2648), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 1,
      sym__automatic_semicolon,
    ACTIONS(1260), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1264), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1266), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2513), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1180), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1182), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4034), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4036), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62347] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4638), 1,
      anon_sym_STAR,
    ACTIONS(4640), 1,
      anon_sym_async,
    ACTIONS(4642), 1,
      sym_number,
    ACTIONS(4644), 1,
      anon_sym_abstract,
    ACTIONS(4646), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1881), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4038), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4040), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4156), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4158), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4174), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4176), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2481), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4209), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_QMARK,
    ACTIONS(4104), 1,
      anon_sym_LBRACK,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(4650), 1,
      anon_sym_RPAREN,
    ACTIONS(3469), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4107), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4203), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4205), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62749] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2493), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4201), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2545), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1110), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(617), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2531), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63185] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4654), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACK,
    ACTIONS(2549), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2547), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1134), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63413] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4658), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1266), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_QMARK,
    ACTIONS(3608), 1,
      anon_sym_COLON,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(3469), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1210), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1212), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1190), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1192), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1236), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3307), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4044), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63877] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3884), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3882), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4067), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64075] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4660), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3835), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3880), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4073), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4662), 1,
      anon_sym_LBRACE,
    ACTIONS(4664), 1,
      anon_sym_DOT,
    STATE(1573), 1,
      sym_statement_block,
    ACTIONS(1100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1098), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4662), 1,
      anon_sym_LBRACE,
    STATE(1573), 1,
      sym_statement_block,
    ACTIONS(1100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1098), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4666), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [64497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4668), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [64545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3768), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 1,
      anon_sym_EQ,
    ACTIONS(4676), 1,
      anon_sym_COLON,
    ACTIONS(4678), 1,
      anon_sym_QMARK,
    ACTIONS(4673), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1202), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3764), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3756), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4681), 1,
      sym__automatic_semicolon,
    ACTIONS(1144), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1142), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4093), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64923] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_COMMA,
    ACTIONS(4104), 1,
      anon_sym_LBRACK,
    ACTIONS(4107), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_COMMA,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4113), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65027] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3915), 1,
      anon_sym_RBRACE,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4032), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4077), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65207] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4683), 1,
      anon_sym_EQ,
    ACTIONS(4689), 1,
      anon_sym_COLON,
    ACTIONS(4691), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4180), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3780), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4026), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4028), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      sym_regex_flags,
    ACTIONS(4263), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
    ACTIONS(4265), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3776), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3760), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4189), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4191), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3752), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2545), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1110), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    STATE(1640), 1,
      sym_arguments,
    ACTIONS(3198), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3202), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65731] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4694), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3825), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_EQ,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_EQ,
    ACTIONS(1124), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4024), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4018), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4020), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2471), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4611), 1,
      sym__automatic_semicolon,
    ACTIONS(1108), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1106), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4113), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4081), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_AMP,
    ACTIONS(4702), 1,
      anon_sym_PIPE,
    ACTIONS(2689), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2687), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2489), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3911), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4104), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4107), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66527] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    ACTIONS(3698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [66591] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4704), 1,
      anon_sym_RBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2584), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4056), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4058), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4046), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4048), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_AMP,
    ACTIONS(4702), 1,
      anon_sym_PIPE,
    ACTIONS(2681), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2679), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2501), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66913] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    ACTIONS(4469), 1,
      sym_readonly,
    ACTIONS(3698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4706), 1,
      sym_regex_flags,
    ACTIONS(4263), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4265), 20,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4089), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_AMP,
    ACTIONS(4702), 1,
      anon_sym_PIPE,
    ACTIONS(2677), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2675), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2509), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3938), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4708), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2543), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3886), 1,
      anon_sym_DOT,
    ACTIONS(2600), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2598), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACK,
    ACTIONS(2485), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2483), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2497), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2467), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2479), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2521), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2453), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_DOT,
    ACTIONS(2459), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2457), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2477), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2475), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67779] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    ACTIONS(3698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [67845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2463), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3680), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67937] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4714), 1,
      anon_sym_async,
    ACTIONS(4716), 1,
      sym_number,
    ACTIONS(4718), 1,
      anon_sym_abstract,
    ACTIONS(4720), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68001] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4722), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68089] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3948), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3950), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3944), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3946), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68241] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4724), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2576), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3988), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2539), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2535), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2527), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_AMP,
    ACTIONS(4702), 1,
      anon_sym_PIPE,
    ACTIONS(2665), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2663), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_AMP,
    ACTIONS(4702), 1,
      anon_sym_PIPE,
    ACTIONS(2673), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2671), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_DOT,
    ACTIONS(2451), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2449), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_EQ_GT,
    ACTIONS(3888), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2517), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2580), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68847] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68907] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4726), 1,
      anon_sym_COLON,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1226), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_LPAREN,
    ACTIONS(4731), 1,
      anon_sym_COLON,
    ACTIONS(4733), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1172), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1256), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1246), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3858), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69277] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_QMARK,
    ACTIONS(4648), 1,
      anon_sym_EQ,
    ACTIONS(3469), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69329] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 1,
      anon_sym_EQ,
    ACTIONS(4678), 1,
      anon_sym_QMARK,
    ACTIONS(4673), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4683), 1,
      anon_sym_EQ,
    ACTIONS(4691), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4736), 1,
      anon_sym_LT,
    STATE(1606), 1,
      sym_type_arguments,
    ACTIONS(2650), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2648), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4102), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2505), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4018), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4020), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69665] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4638), 1,
      anon_sym_STAR,
    ACTIONS(4640), 1,
      anon_sym_async,
    ACTIONS(4642), 1,
      sym_number,
    ACTIONS(4739), 1,
      sym_readonly,
    ACTIONS(4646), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1881), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69728] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4638), 1,
      anon_sym_STAR,
    ACTIONS(4741), 1,
      sym_number,
    ACTIONS(4743), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2135), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4113), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1138), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1180), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1182), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1226), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1172), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1256), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1246), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1162), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1202), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70286] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_COMMA,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4113), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3944), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3946), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4024), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70427] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4745), 1,
      anon_sym_STAR,
    ACTIONS(4747), 1,
      anon_sym_async,
    ACTIONS(4749), 1,
      sym_number,
    ACTIONS(4751), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1891), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3307), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1236), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1190), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1192), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1270), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1210), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1212), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1134), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4034), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4036), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1116), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4038), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4040), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2481), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2471), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4032), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4044), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2489), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3884), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3882), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2501), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2509), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4067), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71347] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2521), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3948), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3950), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3880), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4073), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2453), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71657] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4714), 1,
      anon_sym_async,
    ACTIONS(4716), 1,
      sym_number,
    ACTIONS(4720), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71718] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4714), 1,
      anon_sym_async,
    ACTIONS(4716), 1,
      sym_number,
    ACTIONS(4753), 1,
      sym_readonly,
    ACTIONS(4720), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2463), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2539), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71871] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4755), 1,
      anon_sym_STAR,
    ACTIONS(4757), 1,
      anon_sym_async,
    ACTIONS(4759), 1,
      sym_number,
    ACTIONS(4761), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2535), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71977] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4763), 1,
      sym_number,
    ACTIONS(4765), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2177), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2527), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3938), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72126] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4755), 1,
      anon_sym_STAR,
    ACTIONS(4767), 1,
      sym_number,
    ACTIONS(4769), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4089), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1266), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4081), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72320] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3858), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72450] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_DOT,
    ACTIONS(3733), 1,
      anon_sym_LBRACK,
    ACTIONS(3737), 1,
      anon_sym_as,
    ACTIONS(3812), 1,
      anon_sym_BANG,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4225), 1,
      anon_sym_QMARK,
    ACTIONS(4227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4233), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4243), 1,
      anon_sym_QMARK_QMARK,
    STATE(2557), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4229), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4237), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4219), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4231), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4221), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4241), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72535] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4771), 1,
      anon_sym_STAR,
    ACTIONS(4773), 1,
      sym_number,
    ACTIONS(4775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2162), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72594] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4779), 1,
      anon_sym_async,
    ACTIONS(4781), 1,
      sym_number,
    ACTIONS(4785), 1,
      sym_readonly,
    ACTIONS(4783), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1892), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2481), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3644), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2606), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72753] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4779), 1,
      anon_sym_async,
    ACTIONS(4781), 1,
      sym_number,
    ACTIONS(4783), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1892), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_DOT,
    ACTIONS(2451), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2449), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2517), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72906] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    ACTIONS(3698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4180), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3835), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_AMP,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(2673), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2671), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4189), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4191), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_AMP,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(2665), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2663), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_AMP,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(2677), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2675), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4791), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2513), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 1,
      anon_sym_EQ,
    ACTIONS(1124), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_AMP,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(2681), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2679), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4201), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4203), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4205), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73660] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4795), 1,
      anon_sym_STAR,
    ACTIONS(4797), 1,
      sym_number,
    ACTIONS(4799), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2505), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4026), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4028), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4209), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73854] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4745), 1,
      anon_sym_STAR,
    ACTIONS(4801), 1,
      sym_number,
    ACTIONS(4803), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2142), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73913] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3317), 1,
      anon_sym_DOT,
    ACTIONS(3731), 1,
      anon_sym_LT,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [73972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4174), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4176), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4156), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4158), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74062] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4805), 1,
      sym_number,
    ACTIONS(4807), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2171), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_AMP,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(2689), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2687), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1158), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1142), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2493), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(617), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2531), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74395] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4809), 1,
      anon_sym_STAR,
    ACTIONS(4811), 1,
      sym_number,
    ACTIONS(4813), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2205), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 1,
      anon_sym_LBRACK,
    ACTIONS(2549), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2547), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74501] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4817), 1,
      anon_sym_STAR,
    ACTIONS(4819), 1,
      sym_number,
    ACTIONS(4821), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2131), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3825), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_COMMA,
    ACTIONS(4104), 1,
      anon_sym_LBRACK,
    ACTIONS(4107), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4102), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3911), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1280), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2543), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1110), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1112), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4077), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4104), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4107), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74934] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4823), 1,
      anon_sym_STAR,
    ACTIONS(4825), 1,
      sym_number,
    ACTIONS(4827), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2196), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4113), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2584), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1216), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75132] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3731), 1,
      anon_sym_LT,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    STATE(2557), 1,
      sym_type_arguments,
    STATE(1109), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 16,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [75191] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4829), 1,
      anon_sym_STAR,
    ACTIONS(4831), 1,
      sym_number,
    ACTIONS(4833), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1276), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2576), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2580), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75385] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4829), 1,
      anon_sym_STAR,
    ACTIONS(4835), 1,
      anon_sym_async,
    ACTIONS(4837), 1,
      sym_number,
    ACTIONS(4841), 1,
      sym_readonly,
    ACTIONS(4839), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1895), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3680), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2477), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2475), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75538] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4823), 1,
      anon_sym_STAR,
    ACTIONS(4843), 1,
      anon_sym_async,
    ACTIONS(4845), 1,
      sym_number,
    ACTIONS(4849), 1,
      sym_readonly,
    ACTIONS(4847), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1893), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_DOT,
    ACTIONS(2459), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2457), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75648] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4817), 1,
      anon_sym_STAR,
    ACTIONS(4851), 1,
      anon_sym_async,
    ACTIONS(4853), 1,
      sym_number,
    ACTIONS(4855), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1882), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4056), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4058), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2479), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4046), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4048), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75844] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4823), 1,
      anon_sym_STAR,
    ACTIONS(4843), 1,
      anon_sym_async,
    ACTIONS(4845), 1,
      sym_number,
    ACTIONS(4847), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1893), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3988), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2467), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2497), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 1,
      anon_sym_LBRACK,
    ACTIONS(2485), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2483), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4093), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4829), 1,
      anon_sym_STAR,
    ACTIONS(4835), 1,
      anon_sym_async,
    ACTIONS(4837), 1,
      sym_number,
    ACTIONS(4839), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1895), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2543), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4664), 1,
      anon_sym_DOT,
    ACTIONS(2600), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2598), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76285] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(4859), 1,
      anon_sym_RBRACE,
    STATE(2760), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76353] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2479), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4861), 1,
      sym_number,
    STATE(2021), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76523] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_EQ,
    ACTIONS(4500), 1,
      anon_sym_in,
    ACTIONS(4503), 1,
      anon_sym_of,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4741), 1,
      sym_number,
    STATE(2135), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_EQ,
    ACTIONS(3873), 1,
      anon_sym_in,
    ACTIONS(3876), 1,
      anon_sym_of,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4763), 1,
      sym_number,
    STATE(2177), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76731] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4863), 1,
      sym_number,
    STATE(1993), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3614), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76785] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4865), 1,
      sym_number,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4867), 1,
      sym_number,
    STATE(2173), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76893] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4831), 1,
      sym_number,
    STATE(2170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_in,
    ACTIONS(4512), 1,
      anon_sym_of,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4797), 1,
      sym_number,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77051] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(2557), 1,
      sym_readonly,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4767), 1,
      sym_number,
    STATE(2193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77225] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4104), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77341] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    ACTIONS(3864), 1,
      anon_sym_in,
    ACTIONS(3867), 1,
      anon_sym_of,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77391] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77457] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77507] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4825), 1,
      sym_number,
    STATE(2196), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77561] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(4859), 1,
      anon_sym_RBRACE,
    STATE(2760), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77627] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4819), 1,
      sym_number,
    STATE(2131), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77681] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77747] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77815] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(2557), 1,
      sym_readonly,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77885] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4811), 1,
      sym_number,
    STATE(2205), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77939] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4805), 1,
      sym_number,
    STATE(2171), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78061] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      sym_number,
    STATE(2142), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78115] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(2557), 1,
      sym_readonly,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4110), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1126), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78233] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4773), 1,
      sym_number,
    STATE(2162), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78287] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78337] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78453] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78519] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(2557), 1,
      sym_readonly,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78589] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(2557), 1,
      sym_readonly,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(4859), 1,
      anon_sym_RBRACE,
    STATE(2760), 1,
      aux_sym_object_repeat1,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78659] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4873), 1,
      anon_sym_RPAREN,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(1762), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2865), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78730] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(4877), 1,
      anon_sym_RPAREN,
    STATE(1762), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2865), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78801] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(4879), 1,
      anon_sym_RPAREN,
    STATE(1762), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2865), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78872] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_RPAREN,
    STATE(1758), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2721), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78943] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4859), 1,
      anon_sym_RBRACE,
    STATE(2760), 1,
      aux_sym_object_repeat1,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79004] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79065] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(4883), 1,
      anon_sym_RPAREN,
    STATE(1762), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2865), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79136] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4885), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79197] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(4887), 1,
      anon_sym_RPAREN,
    STATE(1762), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2865), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79268] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(3698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3644), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79317] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(2557), 1,
      sym_readonly,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4885), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79382] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(4889), 1,
      anon_sym_RPAREN,
    STATE(1762), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2865), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79453] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(812), 1,
      anon_sym_RPAREN,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(1759), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2632), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79524] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_LPAREN,
    ACTIONS(4897), 1,
      anon_sym_DOT,
    STATE(1778), 1,
      sym_arguments,
    ACTIONS(4893), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4891), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79634] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79695] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_LPAREN,
    ACTIONS(4903), 1,
      anon_sym_DOT,
    STATE(1783), 1,
      sym_arguments,
    ACTIONS(4901), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4899), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79744] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79805] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4885), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79868] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(4905), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2719), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4907), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79981] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2752), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80049] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2719), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80117] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4885), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4911), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80215] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2832), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80283] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2644), 1,
      sym_readonly,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(1762), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    STATE(1867), 1,
      sym_accessibility_modifier,
    STATE(2086), 1,
      sym__parameter_name,
    STATE(2291), 1,
      sym_object,
    STATE(2292), 1,
      sym_array,
    ACTIONS(4871), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2642), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2865), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2618), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80351] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1462), 1,
      anon_sym_namespace,
    ACTIONS(1466), 1,
      anon_sym_type,
    ACTIONS(1468), 1,
      anon_sym_import,
    ACTIONS(1470), 1,
      anon_sym_var,
    ACTIONS(1472), 1,
      anon_sym_let,
    ACTIONS(1474), 1,
      anon_sym_const,
    ACTIONS(1481), 1,
      anon_sym_class,
    ACTIONS(1483), 1,
      anon_sym_async,
    ACTIONS(1485), 1,
      anon_sym_function,
    ACTIONS(1487), 1,
      anon_sym_abstract,
    ACTIONS(1489), 1,
      anon_sym_declare,
    ACTIONS(1491), 1,
      anon_sym_module,
    ACTIONS(1493), 1,
      anon_sym_interface,
    ACTIONS(1495), 1,
      anon_sym_enum,
    ACTIONS(4915), 1,
      anon_sym_default,
    STATE(1866), 1,
      sym_decorator,
    STATE(2506), 1,
      aux_sym_export_statement_repeat1,
    STATE(587), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [80426] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80477] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1462), 1,
      anon_sym_namespace,
    ACTIONS(1466), 1,
      anon_sym_type,
    ACTIONS(1468), 1,
      anon_sym_import,
    ACTIONS(1470), 1,
      anon_sym_var,
    ACTIONS(1472), 1,
      anon_sym_let,
    ACTIONS(1474), 1,
      anon_sym_const,
    ACTIONS(1481), 1,
      anon_sym_class,
    ACTIONS(1483), 1,
      anon_sym_async,
    ACTIONS(1485), 1,
      anon_sym_function,
    ACTIONS(1487), 1,
      anon_sym_abstract,
    ACTIONS(1489), 1,
      anon_sym_declare,
    ACTIONS(1493), 1,
      anon_sym_interface,
    ACTIONS(1495), 1,
      anon_sym_enum,
    ACTIONS(2303), 1,
      anon_sym_module,
    ACTIONS(2305), 1,
      anon_sym_global,
    STATE(1866), 1,
      sym_decorator,
    STATE(2506), 1,
      aux_sym_export_statement_repeat1,
    STATE(591), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [80552] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80603] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1462), 1,
      anon_sym_namespace,
    ACTIONS(1466), 1,
      anon_sym_type,
    ACTIONS(1468), 1,
      anon_sym_import,
    ACTIONS(1470), 1,
      anon_sym_var,
    ACTIONS(1472), 1,
      anon_sym_let,
    ACTIONS(1474), 1,
      anon_sym_const,
    ACTIONS(1481), 1,
      anon_sym_class,
    ACTIONS(1483), 1,
      anon_sym_async,
    ACTIONS(1485), 1,
      anon_sym_function,
    ACTIONS(1487), 1,
      anon_sym_abstract,
    ACTIONS(1491), 1,
      anon_sym_module,
    ACTIONS(1493), 1,
      anon_sym_interface,
    ACTIONS(1495), 1,
      anon_sym_enum,
    ACTIONS(2063), 1,
      anon_sym_declare,
    ACTIONS(4915), 1,
      anon_sym_default,
    STATE(1866), 1,
      sym_decorator,
    STATE(2506), 1,
      aux_sym_export_statement_repeat1,
    STATE(587), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [80678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80729] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1466), 1,
      anon_sym_type,
    ACTIONS(1468), 1,
      anon_sym_import,
    ACTIONS(1470), 1,
      anon_sym_var,
    ACTIONS(1472), 1,
      anon_sym_let,
    ACTIONS(1474), 1,
      anon_sym_const,
    ACTIONS(1481), 1,
      anon_sym_class,
    ACTIONS(1483), 1,
      anon_sym_async,
    ACTIONS(1485), 1,
      anon_sym_function,
    ACTIONS(1487), 1,
      anon_sym_abstract,
    ACTIONS(1493), 1,
      anon_sym_interface,
    ACTIONS(1495), 1,
      anon_sym_enum,
    ACTIONS(2359), 1,
      anon_sym_namespace,
    ACTIONS(2361), 1,
      anon_sym_declare,
    ACTIONS(2363), 1,
      anon_sym_module,
    ACTIONS(4915), 1,
      anon_sym_default,
    STATE(1866), 1,
      sym_decorator,
    STATE(2506), 1,
      aux_sym_export_statement_repeat1,
    STATE(587), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [80804] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4859), 1,
      anon_sym_RBRACE,
    STATE(2760), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80906] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1462), 1,
      anon_sym_namespace,
    ACTIONS(1466), 1,
      anon_sym_type,
    ACTIONS(1468), 1,
      anon_sym_import,
    ACTIONS(1470), 1,
      anon_sym_var,
    ACTIONS(1472), 1,
      anon_sym_let,
    ACTIONS(1474), 1,
      anon_sym_const,
    ACTIONS(1481), 1,
      anon_sym_class,
    ACTIONS(1483), 1,
      anon_sym_async,
    ACTIONS(1485), 1,
      anon_sym_function,
    ACTIONS(1487), 1,
      anon_sym_abstract,
    ACTIONS(1493), 1,
      anon_sym_interface,
    ACTIONS(1495), 1,
      anon_sym_enum,
    ACTIONS(2063), 1,
      anon_sym_declare,
    ACTIONS(2305), 1,
      anon_sym_global,
    ACTIONS(2419), 1,
      anon_sym_module,
    STATE(1866), 1,
      sym_decorator,
    STATE(2506), 1,
      aux_sym_export_statement_repeat1,
    STATE(591), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [80981] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3666), 1,
      anon_sym_module,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    ACTIONS(4917), 1,
      anon_sym_default,
    STATE(1866), 1,
      sym_decorator,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    STATE(2312), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [81056] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3642), 1,
      anon_sym_namespace,
    ACTIONS(3646), 1,
      anon_sym_type,
    ACTIONS(3648), 1,
      anon_sym_import,
    ACTIONS(3650), 1,
      anon_sym_var,
    ACTIONS(3652), 1,
      anon_sym_let,
    ACTIONS(3654), 1,
      anon_sym_const,
    ACTIONS(3656), 1,
      anon_sym_class,
    ACTIONS(3658), 1,
      anon_sym_async,
    ACTIONS(3660), 1,
      anon_sym_function,
    ACTIONS(3662), 1,
      anon_sym_abstract,
    ACTIONS(3664), 1,
      anon_sym_declare,
    ACTIONS(3668), 1,
      anon_sym_interface,
    ACTIONS(3670), 1,
      anon_sym_enum,
    ACTIONS(4919), 1,
      anon_sym_module,
    ACTIONS(4921), 1,
      anon_sym_global,
    STATE(1866), 1,
      sym_decorator,
    STATE(2514), 1,
      aux_sym_export_statement_repeat1,
    STATE(2246), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [81131] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1466), 1,
      anon_sym_type,
    ACTIONS(1468), 1,
      anon_sym_import,
    ACTIONS(1470), 1,
      anon_sym_var,
    ACTIONS(1472), 1,
      anon_sym_let,
    ACTIONS(1474), 1,
      anon_sym_const,
    ACTIONS(1481), 1,
      anon_sym_class,
    ACTIONS(1483), 1,
      anon_sym_async,
    ACTIONS(1485), 1,
      anon_sym_function,
    ACTIONS(1487), 1,
      anon_sym_abstract,
    ACTIONS(1493), 1,
      anon_sym_interface,
    ACTIONS(1495), 1,
      anon_sym_enum,
    ACTIONS(2305), 1,
      anon_sym_global,
    ACTIONS(2359), 1,
      anon_sym_namespace,
    ACTIONS(2361), 1,
      anon_sym_declare,
    ACTIONS(2417), 1,
      anon_sym_module,
    STATE(1866), 1,
      sym_decorator,
    STATE(2506), 1,
      aux_sym_export_statement_repeat1,
    STATE(591), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [81206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4899), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4923), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3890), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3888), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4020), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4018), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4885), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2608), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2606), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3305), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4927), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81492] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4931), 1,
      anon_sym_STAR,
    ACTIONS(4933), 1,
      anon_sym_async,
    ACTIONS(4935), 1,
      sym_number,
    ACTIONS(4937), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2202), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4939), 1,
      anon_sym_EQ_GT,
    ACTIONS(4941), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2151), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81598] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      sym_number,
    ACTIONS(4943), 1,
      anon_sym_STAR,
    ACTIONS(4945), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2151), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4931), 1,
      anon_sym_STAR,
    ACTIONS(4935), 1,
      sym_number,
    ACTIONS(4937), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2202), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81704] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      sym_number,
    ACTIONS(4943), 1,
      anon_sym_STAR,
    ACTIONS(4947), 1,
      anon_sym_async,
    ACTIONS(4945), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2151), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81759] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4949), 1,
      anon_sym_STAR,
    ACTIONS(4951), 1,
      sym_number,
    ACTIONS(4953), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2143), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81812] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      sym_number,
    ACTIONS(4943), 1,
      anon_sym_STAR,
    ACTIONS(4947), 1,
      anon_sym_async,
    ACTIONS(4955), 1,
      sym_readonly,
    ACTIONS(4945), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2151), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81869] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4763), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2177), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2142), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4957), 1,
      sym__automatic_semicolon,
    ACTIONS(1106), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1108), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4961), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4959), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4963), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4967), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82119] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4971), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2161), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82167] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4805), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2171), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82215] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4767), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4935), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2202), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 1,
      sym__automatic_semicolon,
    ACTIONS(1142), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1144), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82351] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4951), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2143), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1144), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4811), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2205), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82485] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2151), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82533] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4979), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4977), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4773), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2162), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4983), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4981), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4985), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4991), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4989), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82781] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4819), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2131), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4995), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4993), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4999), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4997), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5001), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82943] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(2215), 1,
      sym_object,
    STATE(2250), 1,
      sym_array,
    ACTIONS(2713), 2,
      sym_identifier,
      sym_this,
    ACTIONS(646), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2715), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5005), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5011), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5009), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1278), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5015), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5019), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2169), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83193] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5021), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83241] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    STATE(2359), 1,
      sym_object,
    STATE(2365), 1,
      sym_array,
    ACTIONS(5023), 2,
      sym_identifier,
      sym_this,
    ACTIONS(5027), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(5025), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83289] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4797), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83337] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4825), 1,
      sym_number,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2196), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83385] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5029), 1,
      anon_sym_RBRACE,
    ACTIONS(5031), 1,
      sym_number,
    STATE(2792), 1,
      sym_enum_assignment,
    STATE(2547), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83434] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5033), 1,
      anon_sym_RBRACE,
    ACTIONS(5035), 1,
      sym_number,
    STATE(2692), 1,
      sym_enum_assignment,
    STATE(2338), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83483] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5037), 1,
      anon_sym_RBRACE,
    ACTIONS(5039), 1,
      sym_number,
    STATE(2589), 1,
      sym_enum_assignment,
    STATE(2251), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83532] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4638), 1,
      anon_sym_STAR,
    ACTIONS(4640), 1,
      anon_sym_async,
    ACTIONS(4642), 1,
      sym_number,
    ACTIONS(5041), 1,
      anon_sym_static,
    ACTIONS(5043), 1,
      anon_sym_abstract,
    ACTIONS(5045), 1,
      sym_readonly,
    ACTIONS(4646), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1881), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3614), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83589] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5031), 1,
      sym_number,
    ACTIONS(5047), 1,
      anon_sym_RBRACE,
    STATE(2792), 1,
      sym_enum_assignment,
    STATE(2547), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83638] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5031), 1,
      sym_number,
    ACTIONS(5049), 1,
      anon_sym_RBRACE,
    STATE(2792), 1,
      sym_enum_assignment,
    STATE(2547), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83687] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5031), 1,
      sym_number,
    ACTIONS(5051), 1,
      anon_sym_RBRACE,
    STATE(2792), 1,
      sym_enum_assignment,
    STATE(2547), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83736] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(5053), 1,
      anon_sym_STAR,
    ACTIONS(5055), 1,
      sym_number,
    ACTIONS(5059), 1,
      sym_readonly,
    ACTIONS(5057), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_AT,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
    ACTIONS(5063), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5061), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83828] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4829), 1,
      anon_sym_STAR,
    ACTIONS(4835), 1,
      anon_sym_async,
    ACTIONS(4837), 1,
      sym_number,
    ACTIONS(4841), 1,
      sym_readonly,
    ACTIONS(5068), 1,
      anon_sym_static,
    ACTIONS(4839), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1895), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3614), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83882] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(5070), 1,
      anon_sym_STAR,
    ACTIONS(5072), 1,
      sym_number,
    ACTIONS(5076), 1,
      sym_readonly,
    ACTIONS(5074), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1885), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3614), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83932] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(2553), 1,
      anon_sym_async,
    ACTIONS(2557), 1,
      sym_readonly,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_STAR,
    ACTIONS(5078), 1,
      anon_sym_static,
    ACTIONS(2555), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4576), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5080), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5031), 1,
      sym_number,
    STATE(2792), 1,
      sym_enum_assignment,
    STATE(2547), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84068] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4457), 1,
      anon_sym_STAR,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      sym_number,
    ACTIONS(4469), 1,
      sym_readonly,
    ACTIONS(5082), 1,
      anon_sym_static,
    ACTIONS(4467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3614), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(646), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2606), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84160] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4951), 1,
      sym_number,
    STATE(2143), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84203] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      sym_number,
    STATE(2175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84246] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4935), 1,
      sym_number,
    STATE(2202), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4863), 1,
      sym_number,
    STATE(1993), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3614), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84332] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5021), 1,
      sym_number,
    STATE(2148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84375] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4867), 1,
      sym_number,
    STATE(2173), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84418] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4865), 1,
      sym_number,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84461] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4767), 1,
      sym_number,
    STATE(2193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84504] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4741), 1,
      sym_number,
    STATE(2135), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4831), 1,
      sym_number,
    STATE(2170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(5019), 1,
      sym_number,
    STATE(2169), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84633] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4861), 1,
      sym_number,
    STATE(2021), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3614), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84676] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      sym_number,
    STATE(2151), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4797), 1,
      sym_number,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84762] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4825), 1,
      sym_number,
    STATE(2196), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84805] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4971), 1,
      sym_number,
    STATE(2161), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4819), 1,
      sym_number,
    STATE(2131), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4805), 1,
      sym_number,
    STATE(2171), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84934] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      sym_number,
    STATE(2129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4763), 1,
      sym_number,
    STATE(2177), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      sym_number,
    STATE(2142), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4811), 1,
      sym_number,
    STATE(2205), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85106] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(2445), 1,
      sym_number,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    STATE(2164), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(4471), 1,
      anon_sym_LBRACK,
    ACTIONS(4773), 1,
      sym_number,
    STATE(2162), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2551), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5086), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(5084), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85226] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(5088), 1,
      sym_readonly,
    STATE(2215), 1,
      sym_object,
    STATE(2250), 1,
      sym_array,
    ACTIONS(2713), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2715), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5090), 1,
      sym_identifier,
    STATE(1753), 1,
      sym_decorator_member_expression,
    STATE(1777), 1,
      sym_decorator_call_expression,
    ACTIONS(5092), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85303] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5096), 1,
      anon_sym_EQ,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5100), 1,
      anon_sym_COMMA,
    ACTIONS(5102), 1,
      anon_sym_COLON,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5106), 1,
      anon_sym_GT,
    ACTIONS(5109), 1,
      anon_sym_SLASH,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5115), 1,
      anon_sym_extends,
    STATE(1996), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2473), 1,
      sym_constraint,
    STATE(2863), 1,
      sym_default_type,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85359] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5096), 1,
      anon_sym_EQ,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5100), 1,
      anon_sym_COMMA,
    ACTIONS(5102), 1,
      anon_sym_COLON,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5106), 1,
      anon_sym_GT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5115), 1,
      anon_sym_extends,
    ACTIONS(5117), 1,
      anon_sym_SLASH,
    STATE(2026), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2473), 1,
      sym_constraint,
    STATE(2863), 1,
      sym_default_type,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85415] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5096), 1,
      anon_sym_EQ,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5100), 1,
      anon_sym_COMMA,
    ACTIONS(5102), 1,
      anon_sym_COLON,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5106), 1,
      anon_sym_GT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5115), 1,
      anon_sym_extends,
    ACTIONS(5119), 1,
      anon_sym_SLASH,
    STATE(2003), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2473), 1,
      sym_constraint,
    STATE(2863), 1,
      sym_default_type,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 4,
      anon_sym_EQ,
      anon_sym_while,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1216), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [85495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 3,
      anon_sym_EQ,
      anon_sym_while,
      sym_identifier,
    ACTIONS(2580), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [85518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 1,
      anon_sym_PIPE,
    ACTIONS(1158), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [85541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 1,
      anon_sym_PIPE,
    ACTIONS(1280), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [85564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 3,
      anon_sym_EQ,
      anon_sym_while,
      sym_identifier,
    ACTIONS(2576), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [85587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 3,
      anon_sym_EQ,
      anon_sym_while,
      sym_identifier,
    ACTIONS(2584), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [85610] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5121), 1,
      anon_sym_DOT,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(2559), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [85641] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    ACTIONS(5127), 1,
      anon_sym_QMARK,
    ACTIONS(5129), 1,
      anon_sym_BANG,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2335), 1,
      sym_type_annotation,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2636), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5125), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85683] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    ACTIONS(5133), 1,
      anon_sym_QMARK,
    ACTIONS(5135), 1,
      anon_sym_BANG,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2301), 1,
      sym_type_annotation,
    STATE(2310), 1,
      sym__call_signature,
    STATE(2716), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5131), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85725] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    ACTIONS(5139), 1,
      anon_sym_QMARK,
    ACTIONS(5141), 1,
      anon_sym_BANG,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2418), 1,
      sym__call_signature,
    STATE(2441), 1,
      sym_type_annotation,
    STATE(2643), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5137), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85767] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    ACTIONS(5145), 1,
      anon_sym_QMARK,
    ACTIONS(5147), 1,
      anon_sym_BANG,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2240), 1,
      sym_type_annotation,
    STATE(2320), 1,
      sym__call_signature,
    STATE(2591), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5143), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85809] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    ACTIONS(5141), 1,
      anon_sym_BANG,
    ACTIONS(5149), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2441), 1,
      sym_type_annotation,
    STATE(2634), 1,
      sym__call_signature,
    STATE(2643), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5137), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5121), 1,
      anon_sym_DOT,
    ACTIONS(5155), 1,
      anon_sym_GT,
    ACTIONS(5158), 1,
      anon_sym_is,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(5151), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5153), 2,
      anon_sym_LBRACE,
      sym_jsx_identifier,
    ACTIONS(2559), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [85885] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    ACTIONS(5135), 1,
      anon_sym_BANG,
    ACTIONS(5160), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2301), 1,
      sym_type_annotation,
    STATE(2716), 1,
      sym__initializer,
    STATE(2725), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5131), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(3255), 1,
      anon_sym_is,
    ACTIONS(5162), 1,
      anon_sym_LT,
    ACTIONS(5164), 1,
      anon_sym_DOT,
    STATE(1972), 1,
      sym_type_arguments,
    ACTIONS(2559), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85957] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5170), 1,
      anon_sym_SLASH,
    STATE(1991), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85998] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5174), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2287), 1,
      sym_type_annotation,
    STATE(2367), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5172), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5178), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2369), 1,
      sym_type_annotation,
    STATE(2388), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5176), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86068] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5180), 1,
      anon_sym_SLASH,
    STATE(1994), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86109] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5182), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2124), 1,
      sym__call_signature,
    STATE(2287), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5172), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86144] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5186), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2058), 1,
      sym__call_signature,
    STATE(2225), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5184), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86179] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5188), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2225), 1,
      sym_type_annotation,
    STATE(2431), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5184), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_EQ,
    ACTIONS(5104), 1,
      anon_sym_LT,
    STATE(434), 1,
      sym_type_arguments,
    ACTIONS(2648), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [86239] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5192), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2256), 1,
      sym_type_annotation,
    STATE(2276), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5190), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5194), 1,
      anon_sym_COLON,
    ACTIONS(5196), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2056), 1,
      sym__call_signature,
    STATE(2369), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5176), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86309] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5198), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2059), 1,
      sym__call_signature,
    STATE(2256), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5190), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86344] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3223), 1,
      anon_sym_is,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5121), 1,
      anon_sym_DOT,
    ACTIONS(5200), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(2559), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3608), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [86374] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2054), 1,
      sym__call_signature,
    STATE(2262), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5203), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86406] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2444), 1,
      sym__call_signature,
    STATE(2456), 1,
      sym_type_annotation,
    STATE(2626), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5205), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86442] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2237), 1,
      sym__call_signature,
    STATE(2421), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86474] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2077), 1,
      sym__call_signature,
    STATE(2452), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5209), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86506] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5170), 1,
      anon_sym_SLASH,
    STATE(1991), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 1,
      anon_sym_DOT,
    ACTIONS(2451), 1,
      anon_sym_PIPE,
    ACTIONS(2449), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86566] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2062), 1,
      sym__call_signature,
    STATE(2248), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86598] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2305), 1,
      sym_type_annotation,
    STATE(2363), 1,
      sym__call_signature,
    STATE(2705), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5213), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86634] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2305), 1,
      sym_type_annotation,
    STATE(2705), 1,
      sym__initializer,
    STATE(2711), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5213), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86670] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5117), 1,
      anon_sym_SLASH,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(2026), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86708] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2373), 1,
      sym__call_signature,
    STATE(2452), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5209), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2262), 1,
      sym_type_annotation,
    STATE(2450), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5203), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86772] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2248), 1,
      sym_type_annotation,
    STATE(2249), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86804] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5180), 1,
      anon_sym_SLASH,
    STATE(1994), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86842] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2123), 1,
      sym__call_signature,
    STATE(2421), 1,
      sym_type_annotation,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86874] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2324), 1,
      sym__call_signature,
    STATE(2384), 1,
      sym_type_annotation,
    STATE(2687), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5215), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86910] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2295), 1,
      sym_type_annotation,
    STATE(2720), 1,
      sym__initializer,
    STATE(2726), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5217), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86946] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2295), 1,
      sym_type_annotation,
    STATE(2417), 1,
      sym__call_signature,
    STATE(2720), 1,
      sym__initializer,
    STATE(2915), 1,
      sym_type_parameters,
    ACTIONS(5217), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_EQ,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(2598), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [87004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_PIPE,
    ACTIONS(5162), 1,
      anon_sym_LT,
    STATE(1967), 1,
      sym_type_arguments,
    ACTIONS(2648), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87028] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5109), 1,
      anon_sym_SLASH,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(1996), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87066] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5104), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5119), 1,
      anon_sym_SLASH,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(2003), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2045), 1,
      sym_type_arguments,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4541), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [87121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [87142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_EQ,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(2663), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [87165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_DOT,
    ACTIONS(2598), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [87207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_DOT,
    ACTIONS(2457), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_EQ,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(2679), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [87251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2677), 1,
      anon_sym_EQ,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [87274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3644), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [87291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_EQ,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(2687), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [87314] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_EQ,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [87337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [87358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_PIPE,
    ACTIONS(1216), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [87398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 1,
      anon_sym_PIPE,
    ACTIONS(2493), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_EQ,
    ACTIONS(4541), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [87434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 1,
      anon_sym_PIPE,
    ACTIONS(2501), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(2679), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_PIPE,
    ACTIONS(2584), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87490] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5170), 1,
      anon_sym_SLASH,
    STATE(1991), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 1,
      anon_sym_PIPE,
    ACTIONS(2489), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87558] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      sym_identifier,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    STATE(1536), 1,
      sym_class_body,
    STATE(2068), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2978), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [87592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(2687), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87612] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5237), 1,
      sym_identifier,
    STATE(1420), 1,
      sym_class_body,
    STATE(2102), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2951), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [87646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_PIPE,
    ACTIONS(2471), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 1,
      anon_sym_PIPE,
    ACTIONS(2521), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(3698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3644), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [87702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 1,
      anon_sym_PIPE,
    ACTIONS(2539), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_PIPE,
    ACTIONS(2535), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_PIPE,
    ACTIONS(2527), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87774] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5180), 1,
      anon_sym_SLASH,
    STATE(1994), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(2663), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87826] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5239), 1,
      sym_identifier,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1154), 1,
      sym_class_body,
    STATE(2084), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2836), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [87860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87880] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5243), 1,
      sym_identifier,
    STATE(1536), 1,
      sym_class_body,
    STATE(2068), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2978), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [87914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 1,
      anon_sym_PIPE,
    ACTIONS(2517), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 1,
      anon_sym_PIPE,
    ACTIONS(2513), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2505), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [87968] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(5245), 1,
      sym_identifier,
    STATE(1071), 1,
      sym_class_body,
    STATE(2099), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2826), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88002] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5247), 1,
      anon_sym_LT,
    ACTIONS(5249), 1,
      anon_sym_DQUOTE,
    ACTIONS(5251), 1,
      anon_sym_SQUOTE,
    STATE(2019), 1,
      sym_jsx_opening_element,
    STATE(2344), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [88028] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3678), 1,
      anon_sym_LBRACE,
    ACTIONS(5253), 1,
      sym_identifier,
    ACTIONS(5255), 1,
      anon_sym_STAR,
    STATE(2811), 1,
      sym_import_clause,
    STATE(2810), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3041), 2,
      sym_namespace_import,
      sym_named_imports,
  [88058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_PIPE,
    ACTIONS(617), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88076] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5117), 1,
      anon_sym_SLASH,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(2026), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_PIPE,
    ACTIONS(2463), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5257), 1,
      sym_identifier,
    STATE(1536), 1,
      sym_class_body,
    STATE(2068), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2978), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88178] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5259), 1,
      sym_identifier,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1688), 1,
      sym_class_body,
    STATE(2081), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2983), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2477), 1,
      anon_sym_PIPE,
    ACTIONS(2475), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_PIPE,
    ACTIONS(2531), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 1,
      anon_sym_PIPE,
    ACTIONS(2453), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88266] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5247), 1,
      anon_sym_LT,
    ACTIONS(5249), 1,
      anon_sym_DQUOTE,
    ACTIONS(5251), 1,
      anon_sym_SQUOTE,
    STATE(2019), 1,
      sym_jsx_opening_element,
    STATE(2370), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [88292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_PIPE,
    ACTIONS(2479), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 1,
      anon_sym_PIPE,
    ACTIONS(2467), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_PIPE,
    ACTIONS(2497), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_PIPE,
    ACTIONS(5263), 1,
      anon_sym_LBRACK,
    ACTIONS(2483), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 1,
      anon_sym_PIPE,
    ACTIONS(5263), 1,
      anon_sym_LBRACK,
    ACTIONS(2547), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [88406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2543), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [88424] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5265), 1,
      sym_identifier,
    STATE(1420), 1,
      sym_class_body,
    STATE(2102), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2951), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88458] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5267), 1,
      sym_identifier,
    STATE(1420), 1,
      sym_class_body,
    STATE(2102), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2951), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88492] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5233), 1,
      anon_sym_implements,
    ACTIONS(5235), 1,
      anon_sym_extends,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    ACTIONS(5269), 1,
      sym_identifier,
    STATE(1650), 1,
      sym_class_body,
    STATE(2085), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2970), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88526] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5109), 1,
      anon_sym_SLASH,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(1996), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88558] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5119), 1,
      anon_sym_SLASH,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(2003), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88590] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5119), 1,
      anon_sym_SLASH,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(2003), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88619] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(521), 1,
      sym_class_body,
    STATE(2107), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2931), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88650] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5279), 1,
      anon_sym_LT,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2710), 1,
      sym_jsx_closing_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88675] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(2083), 1,
      sym_type_parameters,
    STATE(2318), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2839), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88706] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(2051), 1,
      sym_type_parameters,
    STATE(2446), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2876), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88737] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5285), 1,
      anon_sym_GT,
    ACTIONS(5287), 1,
      anon_sym_SLASH,
    STATE(2000), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88766] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(516), 1,
      sym_class_body,
    STATE(2119), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2854), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88797] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2240), 1,
      sym_type_annotation,
    STATE(2591), 1,
      sym__initializer,
    ACTIONS(5147), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(5143), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88822] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5285), 1,
      anon_sym_GT,
    ACTIONS(5289), 1,
      anon_sym_SLASH,
    STATE(2000), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88851] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5291), 1,
      anon_sym_LT,
    STATE(1663), 1,
      sym_jsx_closing_element,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5285), 1,
      anon_sym_GT,
    ACTIONS(5293), 1,
      anon_sym_SLASH,
    STATE(2000), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88905] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5109), 1,
      anon_sym_SLASH,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(1996), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88934] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1440), 1,
      sym_class_body,
    STATE(2097), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2850), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [88965] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5170), 1,
      anon_sym_SLASH,
    STATE(1991), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88994] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5295), 1,
      sym_identifier,
    ACTIONS(5298), 1,
      anon_sym_LBRACE,
    ACTIONS(5301), 1,
      anon_sym_GT,
    ACTIONS(5303), 1,
      anon_sym_SLASH,
    ACTIONS(5305), 1,
      sym_jsx_identifier,
    STATE(2000), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [89023] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5291), 1,
      anon_sym_LT,
    ACTIONS(5308), 1,
      sym_jsx_text,
    STATE(1616), 1,
      sym_jsx_closing_element,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(1995), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89048] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1090), 1,
      sym_class_body,
    STATE(2053), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2885), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89079] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5285), 1,
      anon_sym_GT,
    ACTIONS(5310), 1,
      anon_sym_SLASH,
    STATE(2000), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [89108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_DOT,
    ACTIONS(5312), 1,
      anon_sym_LT,
    ACTIONS(5314), 1,
      anon_sym_is,
    STATE(432), 1,
      sym_type_arguments,
    ACTIONS(2559), 5,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [89131] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5168), 1,
      anon_sym_GT,
    ACTIONS(5180), 1,
      anon_sym_SLASH,
    STATE(1994), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [89160] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1132), 1,
      sym_class_body,
    STATE(2080), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2840), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89191] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1404), 1,
      sym_class_body,
    STATE(2071), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2869), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89222] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5279), 1,
      anon_sym_LT,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5316), 1,
      sym_jsx_text,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2637), 1,
      sym_jsx_closing_element,
    STATE(1988), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89247] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1580), 1,
      sym_class_body,
    STATE(2096), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2940), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89278] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5318), 1,
      anon_sym_LT,
    ACTIONS(5320), 1,
      sym_jsx_text,
    STATE(1123), 1,
      sym_jsx_closing_element,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2014), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89303] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5117), 1,
      anon_sym_SLASH,
    ACTIONS(5168), 1,
      anon_sym_GT,
    STATE(2026), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [89332] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(135), 1,
      sym_class_body,
    STATE(2104), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2903), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89363] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5324), 1,
      anon_sym_LT,
    STATE(1558), 1,
      sym_jsx_closing_element,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89388] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5318), 1,
      anon_sym_LT,
    STATE(1136), 1,
      sym_jsx_closing_element,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89413] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1615), 1,
      sym_class_body,
    STATE(2087), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2969), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89444] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(132), 1,
      sym_class_body,
    STATE(2109), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2894), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89475] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1444), 1,
      sym_class_body,
    STATE(2052), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2769), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89506] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    ACTIONS(5326), 1,
      anon_sym_LBRACE,
    STATE(569), 1,
      sym_class_body,
    STATE(2095), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2939), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89537] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5328), 1,
      anon_sym_LT,
    ACTIONS(5330), 1,
      sym_jsx_text,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2345), 1,
      sym_jsx_closing_element,
    STATE(2024), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89562] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1414), 1,
      sym_class_body,
    STATE(2121), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2793), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89593] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2301), 1,
      sym_type_annotation,
    STATE(2716), 1,
      sym__initializer,
    ACTIONS(5135), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(5131), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5332), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89637] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5324), 1,
      anon_sym_LT,
    ACTIONS(5334), 1,
      sym_jsx_text,
    STATE(1496), 1,
      sym_jsx_closing_element,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2013), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89662] = 7,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5328), 1,
      anon_sym_LT,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2413), 1,
      sym_jsx_closing_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89687] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(2057), 1,
      sym_type_parameters,
    STATE(2408), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2864), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [89718] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5285), 1,
      anon_sym_GT,
    ACTIONS(5336), 1,
      anon_sym_SLASH,
    STATE(2000), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [89747] = 6,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5338), 1,
      anon_sym_LBRACE,
    ACTIONS(5341), 1,
      anon_sym_LT,
    ACTIONS(5344), 1,
      sym_jsx_text,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5347), 1,
      anon_sym_RPAREN,
    ACTIONS(617), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(646), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89787] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_LT,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89809] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5352), 1,
      anon_sym_LT,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    STATE(2611), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [89853] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5354), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      sym_jsx_text,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2029), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89875] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2563), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [89897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_RPAREN,
    ACTIONS(2648), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3608), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1112), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2543), 4,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [89931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 1,
      anon_sym_DOT,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(2390), 1,
      sym_statement_block,
    ACTIONS(1098), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89951] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_LT,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [89973] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5365), 1,
      anon_sym_GT,
    STATE(2000), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [89999] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5281), 1,
      sym_jsx_text,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5367), 1,
      anon_sym_LT,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2027), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [90021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(565), 1,
      anon_sym_RBRACE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2585), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [90043] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5369), 1,
      anon_sym_LT,
    ACTIONS(5371), 1,
      sym_jsx_text,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2039), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [90065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2128), 1,
      sym_type_annotation,
    ACTIONS(5373), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90083] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5375), 1,
      anon_sym_LT,
    ACTIONS(5377), 1,
      sym_jsx_text,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2037), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [90105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4859), 1,
      anon_sym_RBRACE,
    STATE(2760), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [90127] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      sym_identifier,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      sym_jsx_identifier,
    ACTIONS(5379), 1,
      anon_sym_GT,
    STATE(2038), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2210), 1,
      sym_jsx_namespace_name,
    STATE(2377), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [90153] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    STATE(2680), 1,
      aux_sym_object_repeat1,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [90175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2199), 1,
      sym_type_annotation,
    ACTIONS(5381), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90193] = 6,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_LT,
    ACTIONS(5385), 1,
      sym_jsx_text,
    STATE(2008), 1,
      sym_jsx_opening_element,
    STATE(2030), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [90215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 1,
      anon_sym_LT,
    STATE(434), 1,
      sym_type_arguments,
    ACTIONS(2648), 5,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [90232] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(5387), 1,
      sym_identifier,
    ACTIONS(5389), 1,
      anon_sym_DOT,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
  [90257] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(2284), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2908), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90282] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1548), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2949), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1061), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2914), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2971), 1,
      sym_statement_block,
    ACTIONS(5391), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5393), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [90362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2823), 1,
      sym_statement_block,
    ACTIONS(5395), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(2366), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2906), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2966), 1,
      sym_statement_block,
    ACTIONS(5397), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2821), 1,
      sym_statement_block,
    ACTIONS(5399), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90438] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5401), 1,
      sym_identifier,
    ACTIONS(5403), 1,
      anon_sym_STAR,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2921), 1,
      sym__call_signature,
  [90463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5407), 1,
      sym_identifier,
    ACTIONS(5409), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2984), 1,
      sym__call_signature,
  [90488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2797), 1,
      sym_statement_block,
    ACTIONS(5411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_EQ,
    ACTIONS(4885), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3644), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [90522] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5413), 1,
      sym_identifier,
    ACTIONS(5415), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2956), 1,
      sym__call_signature,
  [90547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3113), 1,
      sym_predefined_type,
    ACTIONS(5417), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2405), 1,
      sym_type_annotation,
    ACTIONS(5419), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2456), 1,
      sym_type_annotation,
    STATE(2626), 1,
      sym__initializer,
    ACTIONS(5205), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90600] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1421), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2916), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90625] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2295), 1,
      sym_type_annotation,
    STATE(2720), 1,
      sym__initializer,
    ACTIONS(5217), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90646] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5421), 1,
      sym_identifier,
    ACTIONS(5423), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2976), 1,
      sym__call_signature,
  [90671] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1305), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2907), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2260), 1,
      sym_type_annotation,
    ACTIONS(5425), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(5427), 1,
      anon_sym_LT,
    ACTIONS(5429), 1,
      anon_sym_extends,
    STATE(549), 1,
      sym_object_type,
    STATE(2330), 1,
      sym_type_parameters,
    STATE(2622), 1,
      sym_extends_clause,
  [90738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(2693), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3099), 1,
      sym_predefined_type,
    ACTIONS(5417), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(2390), 1,
      sym_statement_block,
    ACTIONS(1098), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2786), 1,
      sym_statement_block,
    ACTIONS(5431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90804] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5433), 1,
      sym_identifier,
    ACTIONS(5435), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2820), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [90829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5437), 1,
      sym_identifier,
    ACTIONS(5439), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2921), 1,
      sym__call_signature,
  [90854] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1092), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2877), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1649), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2977), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5441), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [90917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(2438), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2874), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90942] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1095), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2872), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1585), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2945), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [90992] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_QMARK,
    STATE(2537), 1,
      sym_type_annotation,
    STATE(2773), 1,
      sym__initializer,
    ACTIONS(5445), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [91015] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1583), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2943), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2239), 1,
      sym_type_annotation,
    STATE(2753), 1,
      sym__initializer,
    ACTIONS(3871), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2235), 1,
      sym_type_annotation,
    STATE(2755), 1,
      sym__initializer,
    ACTIONS(3862), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2218), 1,
      sym_type_annotation,
    STATE(2766), 1,
      sym__initializer,
    ACTIONS(3237), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5449), 1,
      anon_sym_EQ,
    ACTIONS(5332), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
  [91122] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym_identifier,
    ACTIONS(5453), 1,
      anon_sym_LBRACE,
    ACTIONS(5455), 1,
      anon_sym_LBRACK,
    ACTIONS(5457), 1,
      anon_sym_enum,
    STATE(2088), 1,
      sym_array,
    STATE(2089), 1,
      sym_object,
    STATE(2520), 1,
      sym_variable_declarator,
  [91147] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(5387), 1,
      sym_identifier,
    ACTIONS(5459), 1,
      anon_sym_DOT,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
  [91172] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5461), 1,
      sym_identifier,
    ACTIONS(5463), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2796), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [91197] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    ACTIONS(5326), 1,
      anon_sym_LBRACE,
    STATE(562), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2929), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91222] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1569), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2925), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91247] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1442), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2798), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91272] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2384), 1,
      sym_type_annotation,
    STATE(2687), 1,
      sym__initializer,
    ACTIONS(5215), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91293] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1160), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2818), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91318] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(5465), 1,
      sym_identifier,
    ACTIONS(5467), 1,
      anon_sym_DOT,
    STATE(2036), 1,
      sym_nested_identifier,
    STATE(2076), 1,
      sym_string,
    STATE(2241), 1,
      sym__module,
  [91343] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(5427), 1,
      anon_sym_LT,
    ACTIONS(5429), 1,
      anon_sym_extends,
    STATE(2269), 1,
      sym_object_type,
    STATE(2273), 1,
      sym_type_parameters,
    STATE(2736), 1,
      sym_extends_clause,
  [91368] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1417), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2888), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5469), 1,
      sym_identifier,
    ACTIONS(5471), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2956), 1,
      sym__call_signature,
  [91418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2959), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91443] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      anon_sym_EQ,
    STATE(2473), 1,
      sym_constraint,
    STATE(2863), 1,
      sym_default_type,
    ACTIONS(5100), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_COLON,
      anon_sym_extends,
  [91464] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5475), 1,
      anon_sym_COLON,
    ACTIONS(5477), 1,
      anon_sym_QMARK,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2849), 1,
      sym__call_signature,
  [91489] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(514), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2866), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5479), 1,
      sym_identifier,
    ACTIONS(5481), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2956), 1,
      sym__call_signature,
  [91539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(131), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2767), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [91577] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym_identifier,
    ACTIONS(5453), 1,
      anon_sym_LBRACE,
    ACTIONS(5455), 1,
      anon_sym_LBRACK,
    ACTIONS(5485), 1,
      anon_sym_enum,
    STATE(2088), 1,
      sym_array,
    STATE(2089), 1,
      sym_object,
    STATE(2468), 1,
      sym_variable_declarator,
  [91602] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5487), 1,
      sym_identifier,
    ACTIONS(5489), 1,
      anon_sym_STAR,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2921), 1,
      sym__call_signature,
  [91627] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      sym_identifier,
    ACTIONS(5493), 1,
      anon_sym_DOT,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    STATE(2555), 1,
      sym_nested_identifier,
  [91652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2933), 1,
      sym_statement_block,
    ACTIONS(5495), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2795), 1,
      sym_statement_block,
    ACTIONS(5497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2779), 1,
      sym_statement_block,
    ACTIONS(5499), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [91716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    ACTIONS(5501), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5505), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [91735] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(517), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2974), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2833), 1,
      sym_statement_block,
    ACTIONS(5507), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91777] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(5275), 1,
      anon_sym_extends,
    STATE(1410), 1,
      sym_class_body,
    STATE(2606), 1,
      sym_extends_clause,
    STATE(2844), 1,
      sym_class_heritage,
    STATE(2991), 1,
      sym_implements_clause,
  [91802] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2305), 1,
      sym_type_annotation,
    STATE(2705), 1,
      sym__initializer,
    ACTIONS(5213), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2830), 1,
      sym_statement_block,
    ACTIONS(5509), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2780), 1,
      sym_statement_block,
    ACTIONS(5511), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5513), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [91870] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2923), 1,
      sym__call_signature,
  [91892] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(5387), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
  [91914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2835), 1,
      sym__call_signature,
  [91948] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5521), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2972), 1,
      sym__call_signature,
  [91970] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5523), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2320), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [91992] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    ACTIONS(5527), 1,
      anon_sym_COMMA,
    ACTIONS(5529), 1,
      anon_sym_RBRACE,
    STATE(2713), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [92012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5533), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2923), 1,
      sym__call_signature,
  [92034] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_LBRACE,
    ACTIONS(5455), 1,
      anon_sym_LBRACK,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(2088), 1,
      sym_array,
    STATE(2089), 1,
      sym_object,
    STATE(2461), 1,
      sym_variable_declarator,
  [92056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5537), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2418), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92078] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    ACTIONS(5539), 1,
      anon_sym_COMMA,
    ACTIONS(5541), 1,
      anon_sym_RBRACE,
    STATE(2573), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [92098] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(5387), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(526), 1,
      sym_string,
    STATE(606), 1,
      sym__module,
  [92120] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5543), 1,
      sym_identifier,
    ACTIONS(5545), 1,
      anon_sym_GT,
    ACTIONS(5547), 1,
      sym_jsx_identifier,
    STATE(1920), 1,
      sym_nested_identifier,
    STATE(1986), 1,
      sym_jsx_namespace_name,
    STATE(2613), 1,
      sym_type_parameter,
  [92142] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      sym_identifier,
    STATE(526), 1,
      sym_string,
    STATE(606), 1,
      sym__module,
    STATE(2555), 1,
      sym_nested_identifier,
  [92164] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      sym_identifier,
    STATE(526), 1,
      sym_string,
    STATE(609), 1,
      sym__module,
    STATE(2555), 1,
      sym_nested_identifier,
  [92186] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5549), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2629), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5551), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2124), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5553), 1,
      anon_sym_QMARK,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2884), 1,
      sym__call_signature,
  [92252] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5555), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2950), 1,
      sym__call_signature,
  [92274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5151), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5153), 4,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [92288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3703), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5557), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92304] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5559), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2975), 1,
      sym__call_signature,
  [92326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2257), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5565), 1,
      anon_sym_BQUOTE,
    ACTIONS(5567), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5563), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2200), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [92366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5567), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5571), 1,
      anon_sym_BQUOTE,
    ACTIONS(5569), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2183), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [92384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5573), 1,
      anon_sym_QMARK,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2808), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [92406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5567), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5577), 1,
      anon_sym_BQUOTE,
    ACTIONS(5575), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2188), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [92424] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(5465), 1,
      sym_identifier,
    STATE(2036), 1,
      sym_nested_identifier,
    STATE(2076), 1,
      sym_string,
    STATE(2380), 1,
      sym__module,
  [92446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3713), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5579), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3721), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5581), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92478] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5583), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2328), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    ACTIONS(5465), 1,
      sym_identifier,
    STATE(2036), 1,
      sym_nested_identifier,
    STATE(2076), 1,
      sym_string,
    STATE(2241), 1,
      sym__module,
  [92522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5585), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_GT,
  [92538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2146), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3721), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5581), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3644), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [92566] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5587), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2115), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92588] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5589), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2120), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5594), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5591), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92626] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2919), 1,
      sym__call_signature,
  [92648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3723), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5598), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3707), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5600), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5567), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5604), 1,
      anon_sym_BQUOTE,
    ACTIONS(5602), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2152), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [92698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2154), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3723), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5598), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92714] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5606), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2302), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5608), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2276), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5610), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2058), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2165), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5614), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92796] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5616), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2725), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2155), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5620), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5618), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92834] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2059), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 1,
      sym_identifier,
    ACTIONS(5626), 1,
      anon_sym_GT,
    ACTIONS(5628), 1,
      sym_jsx_identifier,
    STATE(1919), 1,
      sym_nested_identifier,
    STATE(1997), 1,
      sym_jsx_namespace_name,
    STATE(2613), 1,
      sym_type_parameter,
  [92878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5630), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2310), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [92900] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 1,
      sym_identifier,
    ACTIONS(5634), 1,
      anon_sym_GT,
    ACTIONS(5636), 1,
      sym_jsx_identifier,
    STATE(1908), 1,
      sym_nested_identifier,
    STATE(2011), 1,
      sym_jsx_namespace_name,
    STATE(2613), 1,
      sym_type_parameter,
  [92922] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5638), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2853), 1,
      sym__call_signature,
  [92944] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_default,
    ACTIONS(5642), 1,
      anon_sym_RBRACE,
    ACTIONS(5644), 1,
      anon_sym_case,
    STATE(2184), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [92962] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5646), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2822), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [92984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5648), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2923), 1,
      sym__call_signature,
  [93006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5567), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5650), 1,
      anon_sym_BQUOTE,
    ACTIONS(5575), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2188), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [93024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_default,
    ACTIONS(5655), 1,
      anon_sym_RBRACE,
    ACTIONS(5657), 1,
      anon_sym_case,
    STATE(2184), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [93042] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_LBRACE,
    ACTIONS(5455), 1,
      anon_sym_LBRACK,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(2088), 1,
      sym_array,
    STATE(2089), 1,
      sym_object,
    STATE(2724), 1,
      sym_variable_declarator,
  [93064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_default,
    ACTIONS(5644), 1,
      anon_sym_case,
    ACTIONS(5660), 1,
      anon_sym_RBRACE,
    STATE(2180), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [93082] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3992), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4124), 1,
      anon_sym_LBRACE,
    ACTIONS(5662), 1,
      anon_sym_LT,
    STATE(2494), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2627), 1,
      sym_type_arguments,
  [93104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 1,
      anon_sym_BQUOTE,
    ACTIONS(5669), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5664), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2188), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [93122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2194), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5674), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5672), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93138] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_LBRACE,
    ACTIONS(5455), 1,
      anon_sym_LBRACK,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(2088), 1,
      sym_array,
    STATE(2089), 1,
      sym_object,
    STATE(2520), 1,
      sym_variable_declarator,
  [93160] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5676), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2972), 1,
      sym__call_signature,
  [93182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2198), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3715), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5678), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93198] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2367), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [93220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3715), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5678), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93236] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_LBRACE,
    ACTIONS(5455), 1,
      anon_sym_LBRACK,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(2088), 1,
      sym_array,
    STATE(2089), 1,
      sym_object,
    STATE(2519), 1,
      sym_variable_declarator,
  [93258] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5682), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2431), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [93280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    STATE(2502), 1,
      sym_type_annotation,
    STATE(2886), 1,
      sym__initializer,
    ACTIONS(5684), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [93300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3701), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5686), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5567), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      anon_sym_BQUOTE,
    ACTIONS(5575), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2188), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [93346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5692), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2972), 1,
      sym__call_signature,
  [93368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2965), 1,
      sym__call_signature,
  [93390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3709), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5696), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_COMMA,
    ACTIONS(5312), 1,
      anon_sym_LT,
    STATE(434), 1,
      sym_type_arguments,
    STATE(2467), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3992), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [93426] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(5698), 1,
      anon_sym_QMARK,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2307), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [93448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2208), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5702), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5700), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2209), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3711), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5704), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3711), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5704), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2163), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3729), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5706), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_EQ,
    ACTIONS(5708), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5712), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [93528] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_LBRACE,
    ACTIONS(5455), 1,
      anon_sym_LBRACK,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(2088), 1,
      sym_array,
    STATE(2089), 1,
      sym_object,
    STATE(2468), 1,
      sym_variable_declarator,
  [93550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4541), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [93562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2166), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5716), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5714), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2203), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3707), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5600), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5722), 1,
      anon_sym_SLASH,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [93624] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2831), 1,
      sym__call_signature,
  [93643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2729), 1,
      sym__initializer,
    ACTIONS(5726), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2968), 1,
      sym__call_signature,
  [93677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2114), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [93707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4093), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [93720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2541), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [93739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1810), 1,
      sym_statement_block,
    ACTIONS(5499), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5732), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [93784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    ACTIONS(5734), 1,
      anon_sym_RBRACE,
    STATE(2813), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [93801] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5736), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [93820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(5585), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
  [93835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    ACTIONS(5741), 1,
      anon_sym_RBRACE,
    STATE(2813), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [93852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5743), 1,
      anon_sym_LBRACE,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    STATE(2592), 1,
      aux_sym_implements_clause_repeat1,
  [93871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2511), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [93890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2517), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [93909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2899), 1,
      sym__call_signature,
  [93928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2722), 1,
      sym__initializer,
    ACTIONS(5747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5749), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [93962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93973] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5751), 1,
      anon_sym_export,
    ACTIONS(5753), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [93992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2717), 1,
      sym__initializer,
    ACTIONS(5755), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2662), 1,
      sym__initializer,
    ACTIONS(5757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4026), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4028), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 1,
      anon_sym_LT,
    STATE(434), 1,
      sym_type_arguments,
    ACTIONS(4340), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [94061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5027), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94094] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2952), 1,
      sym__call_signature,
  [94113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5761), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    ACTIONS(5765), 1,
      anon_sym_COMMA,
    ACTIONS(5767), 1,
      anon_sym_RBRACE,
    STATE(2588), 1,
      aux_sym_enum_body_repeat1,
    STATE(2935), 1,
      sym__initializer,
  [94165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2803), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [94195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4032), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5769), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94241] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5771), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [94260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2264), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [94279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2799), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [94353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5775), 1,
      anon_sym_COMMA,
    ACTIONS(5777), 1,
      anon_sym_GT,
    STATE(2740), 1,
      aux_sym_implements_clause_repeat1,
  [94372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5779), 1,
      anon_sym_COMMA,
    ACTIONS(5781), 1,
      anon_sym_GT,
    STATE(2696), 1,
      aux_sym_implements_clause_repeat1,
  [94424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94446] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    ACTIONS(5429), 1,
      anon_sym_extends,
    STATE(2315), 1,
      sym_object_type,
    STATE(2693), 1,
      sym_extends_clause,
  [94465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5783), 1,
      anon_sym_export,
    ACTIONS(5785), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [94495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94506] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2450), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [94525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [94547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94558] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5787), 1,
      anon_sym_COMMA,
    ACTIONS(5789), 1,
      anon_sym_GT,
    STATE(2731), 1,
      aux_sym_implements_clause_repeat1,
  [94577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3938), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1220), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2361), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [94631] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2790), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [94650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5791), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2711), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [94691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5795), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4676), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4689), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94735] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2891), 1,
      sym__call_signature,
  [94754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2763), 1,
      sym__initializer,
    ACTIONS(5797), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(5799), 1,
      anon_sym_RBRACK,
    STATE(2569), 1,
      aux_sym_implements_clause_repeat1,
  [94788] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2550), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [94807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1196), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2416), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [94837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3948), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3950), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2718), 1,
      sym__initializer,
    ACTIONS(5801), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_statement_block,
    ACTIONS(5497), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [94899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5805), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2691), 1,
      sym__initializer,
    ACTIONS(5807), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94960] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2881), 1,
      sym__call_signature,
  [94979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1795), 1,
      sym_statement_block,
    ACTIONS(5397), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3764), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2523), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [95046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(5809), 1,
      anon_sym_RBRACK,
    STATE(2672), 1,
      aux_sym_implements_clause_repeat1,
  [95076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95098] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5811), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [95117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1815), 1,
      sym_statement_block,
    ACTIONS(5511), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3776), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2841), 1,
      sym__call_signature,
  [95162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_EQ,
    ACTIONS(4541), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [95175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1794), 1,
      sym_statement_block,
    ACTIONS(5509), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2878), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95212] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2224), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [95231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1809), 1,
      sym_statement_block,
    ACTIONS(5507), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95246] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2363), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [95265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    ACTIONS(5429), 1,
      anon_sym_extends,
    STATE(593), 1,
      sym_object_type,
    STATE(2567), 1,
      sym_extends_clause,
  [95284] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(5813), 1,
      anon_sym_RBRACK,
    STATE(2712), 1,
      aux_sym_implements_clause_repeat1,
  [95303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5817), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [95344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2618), 1,
      sym__initializer,
    ACTIONS(5819), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2926), 1,
      sym__call_signature,
  [95378] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5821), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [95397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_COMMA,
    ACTIONS(5825), 1,
      anon_sym_RBRACE,
    STATE(2664), 1,
      aux_sym_enum_body_repeat1,
    STATE(2935), 1,
      sym__initializer,
  [95416] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5829), 1,
      anon_sym_GT,
    STATE(2704), 1,
      aux_sym_implements_clause_repeat1,
  [95435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_COMMA,
    ACTIONS(5833), 1,
      anon_sym_GT,
    STATE(2566), 1,
      aux_sym_implements_clause_repeat1,
  [95454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95465] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 1,
      sym_identifier,
    ACTIONS(5837), 1,
      anon_sym_GT,
    ACTIONS(5839), 1,
      sym_jsx_identifier,
    STATE(1912), 1,
      sym_nested_identifier,
    STATE(2005), 1,
      sym_jsx_namespace_name,
  [95484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5845), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4081), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2515), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [95540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95551] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2858), 1,
      sym__call_signature,
  [95570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5753), 1,
      anon_sym_class,
    ACTIONS(5847), 1,
      anon_sym_export,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [95600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2857), 1,
      sym__call_signature,
  [95630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5849), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2237), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [95671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      sym__automatic_semicolon,
    ACTIONS(1186), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3764), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1820), 1,
      sym_statement_block,
    ACTIONS(5431), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5861), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2116), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [95863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_LBRACK,
    ACTIONS(5863), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_object,
    STATE(3199), 1,
      sym_array,
  [95882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(2687), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [95919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5869), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5871), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1112), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1112), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1270), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95976] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2641), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [95995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2628), 1,
      sym__initializer,
    ACTIONS(5873), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96032] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2324), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [96051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5875), 1,
      sym__automatic_semicolon,
    ACTIONS(1240), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 1,
      sym__automatic_semicolon,
    ACTIONS(1250), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1162), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2967), 1,
      sym__call_signature,
  [96129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5879), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [96148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5881), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [96167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [96178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3776), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5885), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [96208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5887), 1,
      sym__automatic_semicolon,
    ACTIONS(1176), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96221] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2508), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [96240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2942), 1,
      sym__call_signature,
  [96281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5889), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [96296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2417), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [96315] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2941), 1,
      sym__call_signature,
  [96334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5893), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [96356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2848), 1,
      sym__call_signature,
  [96375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5895), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [96405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4338), 1,
      anon_sym_LBRACE,
    ACTIONS(5662), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    ACTIONS(4340), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [96422] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2862), 1,
      sym__call_signature,
  [96441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2470), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [96460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4102), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [96473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5897), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [96495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1813), 1,
      sym_statement_block,
    ACTIONS(5495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1796), 1,
      sym_statement_block,
    ACTIONS(5391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1817), 1,
      sym_statement_block,
    ACTIONS(5399), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96540] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2880), 1,
      sym__call_signature,
  [96559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    ACTIONS(5899), 1,
      anon_sym_RBRACE,
    STATE(2878), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [96576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5901), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2986), 1,
      sym__call_signature,
  [96606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym__call_signature,
  [96625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2770), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5903), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5905), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [96649] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5907), 1,
      anon_sym_COMMA,
    ACTIONS(5909), 1,
      anon_sym_GT,
    STATE(2579), 1,
      aux_sym_implements_clause_repeat1,
  [96668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96679] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2927), 1,
      sym__call_signature,
  [96698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    ACTIONS(5911), 1,
      anon_sym_SLASH,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [96717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2123), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [96736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5397), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1280), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [96760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2373), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [96779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1158), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [96792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1128), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1807), 1,
      sym_statement_block,
    ACTIONS(5395), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(2679), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [96833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1206), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    ACTIONS(5913), 1,
      anon_sym_RBRACE,
    STATE(2878), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [96861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2905), 1,
      sym__call_signature,
  [96880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2723), 1,
      sym__initializer,
    ACTIONS(5915), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(5917), 1,
      anon_sym_RBRACK,
    STATE(2587), 1,
      aux_sym_implements_clause_repeat1,
  [96914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [96929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1814), 1,
      sym_statement_block,
    ACTIONS(5411), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 1,
      anon_sym_DOT,
    ACTIONS(2451), 1,
      anon_sym_LBRACE,
    ACTIONS(2449), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [96959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96970] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(5919), 1,
      anon_sym_RBRACK,
    STATE(2649), 1,
      aux_sym_implements_clause_repeat1,
  [96989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97000] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(2910), 1,
      sym__call_signature,
  [97019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5391), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97030] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2054), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [97049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2962), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2536), 1,
      sym_formal_parameters,
    STATE(2781), 1,
      sym__call_signature,
    STATE(2828), 1,
      sym_type_parameters,
  [97090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5923), 1,
      anon_sym_COMMA,
    ACTIONS(5925), 1,
      anon_sym_GT,
    STATE(2640), 1,
      aux_sym_implements_clause_repeat1,
  [97109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    STATE(2728), 1,
      sym__initializer,
    ACTIONS(5927), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [97139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(2663), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [97154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5929), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97165] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_formal_parameters,
    STATE(2077), 1,
      sym__call_signature,
    STATE(2915), 1,
      sym_type_parameters,
  [97184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2558), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5933), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5937), 1,
      anon_sym_PIPE,
    ACTIONS(5935), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5939), 1,
      anon_sym_COMMA,
    STATE(2463), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4340), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [97226] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_SQUOTE,
    ACTIONS(5944), 1,
      aux_sym_string_token2,
    ACTIONS(5946), 1,
      sym_escape_sequence,
    STATE(2482), 1,
      aux_sym_string_repeat2,
  [97242] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_DQUOTE,
    ACTIONS(5948), 1,
      aux_sym_string_token1,
    ACTIONS(5950), 1,
      sym_escape_sequence,
    STATE(2481), 1,
      aux_sym_string_repeat1,
  [97258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5952), 1,
      sym_identifier,
    ACTIONS(5954), 1,
      sym_jsx_identifier,
    STATE(2960), 1,
      sym_nested_identifier,
    STATE(3082), 1,
      sym_jsx_namespace_name,
  [97274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_COMMA,
    STATE(2463), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5956), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [97288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2549), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5958), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_EQ_GT,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [97314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(510), 1,
      sym_statement_block,
    ACTIONS(5962), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      sym_jsx_identifier,
    STATE(1903), 1,
      sym_nested_identifier,
    STATE(1999), 1,
      sym_jsx_namespace_name,
  [97344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5964), 1,
      anon_sym_export,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [97360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      anon_sym_EQ,
    STATE(2920), 1,
      sym_default_type,
    ACTIONS(5966), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [97374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    STATE(2813), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [97388] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_SQUOTE,
    ACTIONS(5970), 1,
      aux_sym_string_token2,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [97404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(5974), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [97418] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_DQUOTE,
    ACTIONS(5976), 1,
      aux_sym_string_token1,
    ACTIONS(5978), 1,
      sym_escape_sequence,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [97434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_identifier,
    ACTIONS(5982), 1,
      sym_jsx_identifier,
    STATE(2947), 1,
      sym_nested_identifier,
    STATE(3040), 1,
      sym_jsx_namespace_name,
  [97450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym_type_parameters,
    STATE(3025), 1,
      sym_formal_parameters,
  [97466] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5984), 1,
      anon_sym_DQUOTE,
    ACTIONS(5986), 1,
      aux_sym_string_token1,
    ACTIONS(5988), 1,
      sym_escape_sequence,
    STATE(2562), 1,
      aux_sym_string_repeat1,
  [97482] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5976), 1,
      aux_sym_string_token1,
    ACTIONS(5978), 1,
      sym_escape_sequence,
    ACTIONS(5990), 1,
      anon_sym_DQUOTE,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [97498] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5970), 1,
      aux_sym_string_token2,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    ACTIONS(5990), 1,
      anon_sym_SQUOTE,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [97514] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5984), 1,
      anon_sym_SQUOTE,
    ACTIONS(5992), 1,
      aux_sym_string_token2,
    ACTIONS(5994), 1,
      sym_escape_sequence,
    STATE(2561), 1,
      aux_sym_string_repeat2,
  [97530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2909), 1,
      sym_type_parameters,
    STATE(3097), 1,
      sym_formal_parameters,
  [97546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4338), 1,
      anon_sym_LBRACE,
    ACTIONS(4340), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    STATE(2485), 1,
      aux_sym_extends_clause_repeat1,
  [97562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_BQUOTE,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    STATE(1629), 2,
      sym_template_string,
      sym_arguments,
  [97576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 1,
      sym_identifier,
    ACTIONS(6001), 1,
      sym_jsx_identifier,
    STATE(2870), 1,
      sym_nested_identifier,
    STATE(3106), 1,
      sym_jsx_namespace_name,
  [97592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      sym_identifier,
    STATE(2878), 1,
      sym__import_export_specifier,
    ACTIONS(5531), 2,
      anon_sym_type,
      anon_sym_typeof,
  [97606] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6003), 1,
      anon_sym_DQUOTE,
    ACTIONS(6005), 1,
      aux_sym_string_token1,
    ACTIONS(6007), 1,
      sym_escape_sequence,
    STATE(2477), 1,
      aux_sym_string_repeat1,
  [97622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_LBRACE,
    ACTIONS(5255), 1,
      anon_sym_STAR,
    STATE(3162), 2,
      sym_namespace_import,
      sym_named_imports,
  [97636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6009), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [97652] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6011), 1,
      anon_sym_DQUOTE,
    ACTIONS(6013), 1,
      aux_sym_string_token1,
    ACTIONS(6015), 1,
      sym_escape_sequence,
    STATE(2500), 1,
      aux_sym_string_repeat1,
  [97668] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6011), 1,
      anon_sym_SQUOTE,
    ACTIONS(6017), 1,
      aux_sym_string_token2,
    ACTIONS(6019), 1,
      sym_escape_sequence,
    STATE(2503), 1,
      aux_sym_string_repeat2,
  [97684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(5956), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6021), 1,
      anon_sym_LBRACE,
    STATE(2485), 1,
      aux_sym_extends_clause_repeat1,
  [97700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(6023), 1,
      anon_sym_LBRACE,
    ACTIONS(6025), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2485), 1,
      aux_sym_extends_clause_repeat1,
  [97716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2898), 1,
      sym_type_parameters,
    STATE(3151), 1,
      sym_formal_parameters,
  [97732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6027), 1,
      sym_identifier,
    ACTIONS(6029), 1,
      sym_jsx_identifier,
    STATE(2768), 1,
      sym_nested_identifier,
    STATE(3108), 1,
      sym_jsx_namespace_name,
  [97748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_from,
    STATE(2770), 1,
      sym__from_clause,
    ACTIONS(6033), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6035), 1,
      sym_identifier,
    ACTIONS(6037), 1,
      sym_jsx_identifier,
    STATE(2825), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_jsx_namespace_name,
  [97778] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5976), 1,
      aux_sym_string_token1,
    ACTIONS(5978), 1,
      sym_escape_sequence,
    ACTIONS(6039), 1,
      anon_sym_DQUOTE,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [97794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3217), 1,
      sym_formal_parameters,
  [97810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    STATE(2834), 1,
      sym__initializer,
    ACTIONS(6041), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [97824] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5970), 1,
      aux_sym_string_token2,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    ACTIONS(6039), 1,
      anon_sym_SQUOTE,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [97840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6043), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [97856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5937), 1,
      anon_sym_PIPE,
    ACTIONS(6045), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6047), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [97886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_COMMA,
    STATE(2463), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6025), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [97900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(2386), 1,
      sym_statement_block,
    ACTIONS(6049), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97914] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6003), 1,
      anon_sym_SQUOTE,
    ACTIONS(6051), 1,
      aux_sym_string_token2,
    ACTIONS(6053), 1,
      sym_escape_sequence,
    STATE(2475), 1,
      aux_sym_string_repeat2,
  [97930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_from,
    STATE(2922), 1,
      sym__from_clause,
    ACTIONS(6055), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(511), 1,
      sym_statement_block,
    ACTIONS(6057), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2072), 1,
      sym_formal_parameters,
    STATE(2895), 1,
      sym_type_parameters,
  [97974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_EQ_GT,
    ACTIONS(3644), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [97986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6059), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [98002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1402), 1,
      sym_statement_block,
    ACTIONS(5962), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2871), 1,
      sym_type_parameters,
    STATE(3131), 1,
      sym_formal_parameters,
  [98032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1102), 1,
      anon_sym_LBRACE,
    STATE(133), 1,
      sym_statement_block,
    ACTIONS(5962), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_COMMA,
    STATE(2518), 1,
      aux_sym_array_repeat1,
    ACTIONS(4411), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [98060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2553), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6064), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2552), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6066), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5937), 1,
      anon_sym_PIPE,
    ACTIONS(6068), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98102] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_DQUOTE,
    ACTIONS(6072), 1,
      aux_sym_string_token1,
    ACTIONS(6074), 1,
      sym_escape_sequence,
    STATE(2528), 1,
      aux_sym_string_repeat1,
  [98118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(2357), 1,
      sym_statement_block,
    ACTIONS(6076), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6078), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [98142] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_SQUOTE,
    ACTIONS(6080), 1,
      aux_sym_string_token2,
    ACTIONS(6082), 1,
      sym_escape_sequence,
    STATE(2529), 1,
      aux_sym_string_repeat2,
  [98158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(2693), 2,
      anon_sym_else,
      anon_sym_while,
  [98172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6084), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6087), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98186] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5976), 1,
      aux_sym_string_token1,
    ACTIONS(5978), 1,
      sym_escape_sequence,
    ACTIONS(6089), 1,
      anon_sym_DQUOTE,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [98202] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5970), 1,
      aux_sym_string_token2,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    ACTIONS(6089), 1,
      anon_sym_SQUOTE,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [98218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [98228] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5976), 1,
      aux_sym_string_token1,
    ACTIONS(5978), 1,
      sym_escape_sequence,
    ACTIONS(6091), 1,
      anon_sym_DQUOTE,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [98244] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6093), 1,
      anon_sym_SQUOTE,
    ACTIONS(6095), 1,
      aux_sym_string_token2,
    ACTIONS(6098), 1,
      sym_escape_sequence,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [98260] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6101), 1,
      anon_sym_DQUOTE,
    ACTIONS(6103), 1,
      aux_sym_string_token1,
    ACTIONS(6105), 1,
      sym_escape_sequence,
    STATE(2539), 1,
      aux_sym_string_repeat1,
  [98276] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5970), 1,
      aux_sym_string_token2,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    ACTIONS(6091), 1,
      anon_sym_SQUOTE,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [98292] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6101), 1,
      anon_sym_SQUOTE,
    ACTIONS(6107), 1,
      aux_sym_string_token2,
    ACTIONS(6109), 1,
      sym_escape_sequence,
    STATE(2540), 1,
      aux_sym_string_repeat2,
  [98308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    STATE(2928), 1,
      sym_type_annotation,
    ACTIONS(5381), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [98322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    STATE(2896), 1,
      sym__initializer,
    ACTIONS(6111), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [98336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
    STATE(1475), 2,
      sym_template_string,
      sym_arguments,
  [98350] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5976), 1,
      aux_sym_string_token1,
    ACTIONS(5978), 1,
      sym_escape_sequence,
    ACTIONS(6113), 1,
      anon_sym_DQUOTE,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [98366] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5970), 1,
      aux_sym_string_token2,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    ACTIONS(6113), 1,
      anon_sym_SQUOTE,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [98382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1405), 1,
      sym_statement_block,
    ACTIONS(6057), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_AMP,
    ACTIONS(5937), 1,
      anon_sym_PIPE,
    ACTIONS(6115), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98410] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6117), 1,
      anon_sym_DQUOTE,
    ACTIONS(6119), 1,
      aux_sym_string_token1,
    ACTIONS(6122), 1,
      sym_escape_sequence,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [98426] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_SQUOTE,
    ACTIONS(6127), 1,
      aux_sym_string_token2,
    ACTIONS(6129), 1,
      sym_escape_sequence,
    STATE(2534), 1,
      aux_sym_string_repeat2,
  [98442] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_DQUOTE,
    ACTIONS(6131), 1,
      aux_sym_string_token1,
    ACTIONS(6133), 1,
      sym_escape_sequence,
    STATE(2531), 1,
      aux_sym_string_repeat1,
  [98458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    STATE(2953), 1,
      sym_type_annotation,
    ACTIONS(5373), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [98472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    STATE(2935), 1,
      sym__initializer,
    ACTIONS(6135), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [98486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    STATE(2843), 1,
      sym_type_annotation,
    ACTIONS(6137), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [98500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6139), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1102), 1,
      anon_sym_LBRACE,
    STATE(127), 1,
      sym_statement_block,
    ACTIONS(6057), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3992), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4124), 1,
      anon_sym_LBRACE,
    STATE(2494), 1,
      aux_sym_extends_clause_repeat1,
  [98544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6141), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6143), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_COMMA,
    STATE(2467), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3992), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [98586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 1,
      anon_sym_while,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    STATE(543), 1,
      sym_statement_block,
  [98602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6145), 1,
      anon_sym_class,
    STATE(1834), 1,
      aux_sym_export_statement_repeat1,
    STATE(1866), 1,
      sym_decorator,
  [98618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_BQUOTE,
    ACTIONS(3082), 1,
      anon_sym_LPAREN,
    STATE(1161), 2,
      sym_template_string,
      sym_arguments,
  [98632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6147), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2924), 1,
      sym_type_parameters,
    STATE(3009), 1,
      sym_formal_parameters,
  [98662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2774), 1,
      sym_type_parameters,
    STATE(3148), 1,
      sym_formal_parameters,
  [98678] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5970), 1,
      aux_sym_string_token2,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    ACTIONS(6149), 1,
      anon_sym_SQUOTE,
    STATE(2532), 1,
      aux_sym_string_repeat2,
  [98694] = 5,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5976), 1,
      aux_sym_string_token1,
    ACTIONS(5978), 1,
      sym_escape_sequence,
    ACTIONS(6149), 1,
      anon_sym_DQUOTE,
    STATE(2543), 1,
      aux_sym_string_repeat1,
  [98710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6151), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [98723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      anon_sym_SQUOTE,
    STATE(2944), 1,
      sym_string,
  [98736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6153), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [98749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_GT,
    ACTIONS(6155), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [98762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_object_type,
  [98775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6157), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [98784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(6159), 1,
      anon_sym_RBRACK,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [98797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6161), 1,
      anon_sym_EQ_GT,
    STATE(2928), 1,
      sym_type_annotation,
  [98810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 1,
      anon_sym_as,
    ACTIONS(6166), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [98821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6168), 1,
      anon_sym_EQ_GT,
    STATE(2953), 1,
      sym_type_annotation,
  [98834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6171), 1,
      anon_sym_COMMA,
    ACTIONS(6173), 1,
      anon_sym_RBRACE,
    STATE(2654), 1,
      aux_sym_export_clause_repeat1,
  [98847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6175), 1,
      anon_sym_RBRACK,
  [98860] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5903), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6177), 1,
      anon_sym_RPAREN,
  [98882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6179), 1,
      anon_sym_RBRACK,
  [98895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_while,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
  [98908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_GT,
    ACTIONS(6181), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [98921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6183), 1,
      anon_sym_GT,
  [98934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4340), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [98943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6185), 1,
      anon_sym_EQ_GT,
    STATE(2953), 1,
      sym_type_annotation,
  [98956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6188), 1,
      sym_identifier,
    STATE(437), 1,
      sym_nested_type_identifier,
    STATE(3072), 1,
      sym_nested_identifier,
  [98969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    STATE(520), 1,
      sym_statement_block,
  [98982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6192), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [98995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6194), 1,
      anon_sym_GT,
  [99008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(6196), 1,
      anon_sym_RBRACK,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [99021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 1,
      anon_sym_RBRACE,
    ACTIONS(6198), 1,
      anon_sym_COMMA,
    STATE(2757), 1,
      aux_sym_enum_body_repeat1,
  [99034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5765), 1,
      anon_sym_COMMA,
    ACTIONS(5767), 1,
      anon_sym_RBRACE,
    STATE(2588), 1,
      aux_sym_enum_body_repeat1,
  [99047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6200), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(6204), 1,
      anon_sym_LBRACE,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [99082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4214), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6206), 1,
      anon_sym_RBRACE,
    STATE(2612), 1,
      aux_sym_object_repeat1,
  [99108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4214), 1,
      anon_sym_RPAREN,
    STATE(2590), 1,
      aux_sym_array_repeat1,
  [99121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6206), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [99134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 1,
      sym_identifier,
    STATE(1970), 1,
      sym_nested_type_identifier,
    STATE(2993), 1,
      sym_nested_identifier,
  [99147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [99156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4331), 1,
      anon_sym_RPAREN,
    STATE(2565), 1,
      aux_sym_array_repeat1,
  [99169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6212), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4385), 1,
      anon_sym_RBRACK,
    STATE(2614), 1,
      aux_sym_array_repeat1,
  [99204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4385), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6214), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [99230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4331), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_implements,
    ACTIONS(6216), 1,
      anon_sym_LBRACE,
    STATE(3068), 1,
      sym_implements_clause,
  [99256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4338), 1,
      anon_sym_LBRACE,
    ACTIONS(4340), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [99267] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(5803), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [99276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      anon_sym_RBRACK,
    STATE(2600), 1,
      aux_sym_array_repeat1,
  [99302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6218), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [99315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6220), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [99328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_COMMA,
    ACTIONS(6224), 1,
      anon_sym_GT,
    STATE(2652), 1,
      aux_sym_type_parameters_repeat1,
  [99341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6226), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6228), 1,
      anon_sym_LBRACE,
    ACTIONS(5883), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [99365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6230), 1,
      anon_sym_RPAREN,
  [99378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6232), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [99391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6232), 1,
      anon_sym_RBRACE,
    STATE(2604), 1,
      aux_sym_object_repeat1,
  [99413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6236), 1,
      sym_identifier,
    STATE(1163), 1,
      sym_nested_type_identifier,
    STATE(3065), 1,
      sym_nested_identifier,
  [99426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4346), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3417), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_object_type,
  [99452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4387), 1,
      anon_sym_RPAREN,
    STATE(2638), 1,
      aux_sym_array_repeat1,
  [99465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4387), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4346), 1,
      anon_sym_RBRACK,
    STATE(2700), 1,
      aux_sym_array_repeat1,
  [99491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6238), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_LBRACE,
    ACTIONS(2463), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [99511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6240), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6242), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6244), 1,
      anon_sym_RPAREN,
  [99542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6246), 1,
      anon_sym_EQ_GT,
    STATE(2928), 1,
      sym_type_annotation,
  [99555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym_COMMA,
    ACTIONS(6251), 1,
      anon_sym_RPAREN,
    STATE(2742), 1,
      aux_sym_formal_parameters_repeat1,
  [99568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [99577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6255), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 1,
      anon_sym_LBRACE,
    ACTIONS(2453), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [99597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6257), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99606] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(4079), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [99615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6259), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [99628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6261), 1,
      anon_sym_EQ_GT,
    STATE(2953), 1,
      sym_type_annotation,
  [99641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_GT,
    ACTIONS(6264), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [99654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6268), 1,
      anon_sym_GT,
  [99676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6270), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_LBRACE,
    ACTIONS(2580), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [99696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [99705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6272), 1,
      anon_sym_COMMA,
    ACTIONS(6275), 1,
      anon_sym_RBRACE,
    STATE(2646), 1,
      aux_sym_export_clause_repeat1,
  [99718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_COMMA,
    ACTIONS(6280), 1,
      anon_sym_GT,
    STATE(2647), 1,
      aux_sym_type_parameters_repeat1,
  [99731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [99740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(6284), 1,
      anon_sym_RBRACK,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [99753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 1,
      anon_sym_as,
    ACTIONS(6288), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [99764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_RBRACK,
  [99777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6292), 1,
      anon_sym_COMMA,
    ACTIONS(6294), 1,
      anon_sym_GT,
    STATE(2647), 1,
      aux_sym_type_parameters_repeat1,
  [99790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6296), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [99799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_RBRACE,
    ACTIONS(6298), 1,
      anon_sym_COMMA,
    STATE(2646), 1,
      aux_sym_export_clause_repeat1,
  [99812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym_LBRACE,
    ACTIONS(2576), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [99823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6294), 1,
      anon_sym_GT,
    ACTIONS(6300), 1,
      sym_identifier,
    STATE(2930), 1,
      sym_type_parameter,
  [99836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      sym_identifier,
    ACTIONS(6302), 1,
      anon_sym_GT,
    STATE(2930), 1,
      sym_type_parameter,
  [99849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_LBRACE,
    ACTIONS(2584), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [99860] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6304), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [99869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6306), 1,
      anon_sym_EQ,
    ACTIONS(6308), 1,
      anon_sym_COMMA,
    ACTIONS(6310), 1,
      anon_sym_from,
  [99882] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6312), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [99891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6316), 1,
      anon_sym_EQ_GT,
    STATE(2953), 1,
      sym_type_annotation,
  [99913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_RBRACE,
    ACTIONS(6319), 1,
      anon_sym_COMMA,
    STATE(2757), 1,
      aux_sym_enum_body_repeat1,
  [99926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6321), 1,
      anon_sym_RBRACE,
    STATE(2681), 1,
      aux_sym_object_repeat1,
  [99939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5393), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [99948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6321), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [99961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(6323), 1,
      anon_sym_EQ,
    STATE(3206), 1,
      sym_type_parameters,
  [99974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_RBRACK,
  [99987] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6327), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [99996] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6329), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [100005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(6331), 1,
      anon_sym_RBRACK,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [100018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4407), 1,
      anon_sym_RBRACK,
    STATE(2683), 1,
      aux_sym_array_repeat1,
  [100031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4407), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [100044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6333), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [100057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4879), 1,
      anon_sym_RPAREN,
    ACTIONS(6335), 1,
      anon_sym_COMMA,
    STATE(2688), 1,
      aux_sym_formal_parameters_repeat1,
  [100070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6337), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [100083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6337), 1,
      anon_sym_RBRACE,
    STATE(2675), 1,
      aux_sym_object_repeat1,
  [100096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6339), 1,
      anon_sym_LBRACE,
    ACTIONS(5893), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [100107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6341), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [100120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6343), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [100133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_RBRACK,
  [100146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6347), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [100159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [100172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 1,
      anon_sym_RBRACE,
    ACTIONS(6351), 1,
      anon_sym_COMMA,
    STATE(2761), 1,
      aux_sym_named_imports_repeat1,
  [100185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6353), 1,
      anon_sym_EQ_GT,
    STATE(2928), 1,
      sym_type_annotation,
  [100198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6356), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym_COMMA,
    ACTIONS(6361), 1,
      anon_sym_RPAREN,
    STATE(2688), 1,
      aux_sym_formal_parameters_repeat1,
  [100220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6363), 1,
      sym_identifier,
    STATE(1680), 1,
      sym_nested_type_identifier,
    STATE(3088), 1,
      sym_nested_identifier,
  [100233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6365), 1,
      anon_sym_COMMA,
    ACTIONS(6368), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [100246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5823), 1,
      anon_sym_COMMA,
    ACTIONS(5825), 1,
      anon_sym_RBRACE,
    STATE(2664), 1,
      aux_sym_enum_body_repeat1,
  [100268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    STATE(2360), 1,
      sym_object_type,
  [100281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LT,
    ACTIONS(6372), 1,
      anon_sym_EQ,
    STATE(3128), 1,
      sym_type_parameters,
  [100294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6374), 1,
      anon_sym_RPAREN,
  [100307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3502), 1,
      anon_sym_GT,
    ACTIONS(6376), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [100320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6378), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [100333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [100342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5441), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [100351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6380), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [100364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6382), 1,
      anon_sym_RPAREN,
  [100377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6384), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [100390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4411), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [100399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_GT,
    ACTIONS(6386), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [100412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6388), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6390), 1,
      anon_sym_GT,
  [100434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      sym_identifier,
    ACTIONS(6392), 1,
      anon_sym_GT,
    STATE(2930), 1,
      sym_type_parameter,
  [100447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 1,
      anon_sym_RPAREN,
    ACTIONS(6394), 1,
      anon_sym_COMMA,
    STATE(2688), 1,
      aux_sym_formal_parameters_repeat1,
  [100460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 1,
      anon_sym_DOT,
    ACTIONS(6396), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100471] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(4100), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [100480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(6400), 1,
      anon_sym_RBRACK,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [100502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 1,
      anon_sym_COMMA,
    ACTIONS(6404), 1,
      anon_sym_RBRACE,
    STATE(2685), 1,
      aux_sym_named_imports_repeat1,
  [100515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      anon_sym_AMP,
    ACTIONS(5221), 1,
      anon_sym_PIPE,
    ACTIONS(6406), 1,
      anon_sym_RBRACK,
  [100528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6308), 1,
      anon_sym_COMMA,
    ACTIONS(6310), 1,
      anon_sym_from,
    ACTIONS(6408), 1,
      anon_sym_EQ,
  [100541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4887), 1,
      anon_sym_RPAREN,
    ACTIONS(6416), 1,
      anon_sym_COMMA,
    STATE(2676), 1,
      aux_sym_formal_parameters_repeat1,
  [100581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6418), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6420), 1,
      anon_sym_COMMA,
    ACTIONS(6422), 1,
      anon_sym_RPAREN,
    STATE(2754), 1,
      aux_sym_formal_parameters_repeat1,
  [100603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6424), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6430), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6432), 1,
      sym_identifier,
    ACTIONS(6434), 1,
      anon_sym_require,
    STATE(2744), 1,
      sym_nested_identifier,
  [100661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6436), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6438), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100679] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(3948), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [100688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_GT,
    ACTIONS(6440), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [100701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6384), 1,
      anon_sym_RBRACE,
    STATE(2759), 1,
      aux_sym_object_repeat1,
  [100714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4275), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [100727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COLON,
    ACTIONS(6442), 1,
      anon_sym_EQ_GT,
    STATE(2928), 1,
      sym_type_annotation,
  [100740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6445), 1,
      anon_sym_COMMA,
    ACTIONS(6447), 1,
      anon_sym_GT,
    STATE(2749), 1,
      aux_sym_type_parameters_repeat1,
  [100753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    STATE(2414), 1,
      sym_object_type,
  [100766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4275), 1,
      anon_sym_RBRACK,
    STATE(2751), 1,
      aux_sym_array_repeat1,
  [100779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4259), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [100792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(4259), 1,
      anon_sym_RPAREN,
    STATE(2697), 1,
      aux_sym_array_repeat1,
  [100805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3504), 1,
      anon_sym_GT,
    ACTIONS(6449), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_implements_clause_repeat1,
  [100818] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(4026), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [100827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4887), 1,
      anon_sym_RPAREN,
    ACTIONS(6416), 1,
      anon_sym_COMMA,
    STATE(2688), 1,
      aux_sym_formal_parameters_repeat1,
  [100840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5513), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [100849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 1,
      anon_sym_DOT,
    ACTIONS(6451), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_LPAREN,
    ACTIONS(6455), 1,
      anon_sym_await,
    STATE(55), 1,
      sym__for_header,
  [100873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      sym_identifier,
    STATE(1525), 1,
      sym_nested_type_identifier,
    STATE(3137), 1,
      sym_nested_identifier,
  [100886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_LPAREN,
    ACTIONS(6461), 1,
      anon_sym_await,
    STATE(51), 1,
      sym__for_header,
  [100899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      sym_identifier,
    ACTIONS(6465), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6467), 1,
      anon_sym_COMMA,
    ACTIONS(6469), 1,
      anon_sym_GT,
    STATE(2647), 1,
      aux_sym_type_parameters_repeat1,
  [100923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      sym_identifier,
    ACTIONS(6469), 1,
      anon_sym_GT,
    STATE(2930), 1,
      sym_type_parameter,
  [100936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_COMMA,
    ACTIONS(6471), 1,
      anon_sym_RBRACK,
    STATE(2518), 1,
      aux_sym_array_repeat1,
  [100949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_RPAREN,
    ACTIONS(6473), 1,
      anon_sym_COMMA,
    STATE(2708), 1,
      aux_sym_formal_parameters_repeat1,
  [100962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_RPAREN,
    ACTIONS(6473), 1,
      anon_sym_COMMA,
    STATE(2688), 1,
      aux_sym_formal_parameters_repeat1,
  [100984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      sym_identifier,
    ACTIONS(6481), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6135), 1,
      anon_sym_RBRACE,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    STATE(2757), 1,
      aux_sym_enum_body_repeat1,
  [101017] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(4091), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [101026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6486), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [101039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6488), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      aux_sym_object_repeat1,
  [101052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6490), 1,
      anon_sym_COMMA,
    ACTIONS(6493), 1,
      anon_sym_RBRACE,
    STATE(2761), 1,
      aux_sym_named_imports_repeat1,
  [101065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      anon_sym_SQUOTE,
    STATE(3059), 1,
      sym_string,
  [101078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_LPAREN,
    ACTIONS(6499), 1,
      anon_sym_await,
    STATE(39), 1,
      sym__for_header,
  [101100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 1,
      anon_sym_LBRACE,
    ACTIONS(5897), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [101111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6503), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(122), 1,
      sym_class_body,
  [101130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [101140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1550), 1,
      sym_class_body,
  [101150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [101168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(48), 1,
      sym_parenthesized_expression,
  [101178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6507), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3154), 1,
      sym_formal_parameters,
  [101196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
  [101206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(2954), 1,
      sym_parenthesized_expression,
  [101224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_from,
    STATE(2770), 1,
      sym__from_clause,
  [101234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2830), 1,
      sym_statement_block,
  [101260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACE,
    STATE(542), 1,
      sym_enum_body,
  [101278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
  [101288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(472), 1,
      sym_statement_block,
  [101298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2288), 1,
      sym_type_annotation,
  [101316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(50), 1,
      sym_parenthesized_expression,
  [101326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6515), 1,
      anon_sym_LBRACE,
    STATE(2349), 1,
      sym_enum_body,
  [101336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2933), 1,
      sym_statement_block,
  [101346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(2263), 1,
      sym_statement_block,
  [101356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6135), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1411), 1,
      sym_class_body,
  [101374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym__for_header,
  [101384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4991), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1174), 1,
      sym_statement_block,
  [101402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4999), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1463), 1,
      sym_class_body,
  [101420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1552), 1,
      sym_statement_block,
  [101430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym_parenthesized_expression,
  [101440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_while,
    ACTIONS(6519), 1,
      anon_sym_else,
  [101450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LPAREN,
    STATE(46), 1,
      sym__for_header,
  [101460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1551), 1,
      sym_statement_block,
  [101470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(56), 1,
      sym_parenthesized_expression,
  [101480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(52), 1,
      sym_parenthesized_expression,
  [101490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2290), 1,
      sym_type_annotation,
  [101508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2966), 1,
      sym_statement_block,
  [101518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 1,
      anon_sym_LPAREN,
    STATE(2900), 1,
      sym_parenthesized_expression,
  [101528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_from,
    STATE(2776), 1,
      sym__from_clause,
  [101546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 1,
      sym_identifier,
    STATE(1517), 1,
      sym_nested_identifier,
  [101556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(49), 1,
      sym_parenthesized_expression,
  [101574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parenthesized_expression,
  [101584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6515), 1,
      anon_sym_LBRACE,
    STATE(2271), 1,
      sym_enum_body,
  [101594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1443), 1,
      sym_statement_block,
  [101604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1117), 1,
      sym_class_body,
  [101614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym_statement_block,
  [101624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1112), 1,
      sym_statement_block,
  [101634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1103), 1,
      sym_statement_block,
  [101652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4979), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(6390), 1,
      anon_sym_GT,
  [101678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1154), 1,
      sym_class_body,
  [101688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6390), 1,
      anon_sym_GT,
  [101698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2546), 1,
      sym_formal_parameters,
  [101708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      sym_identifier,
    STATE(2735), 1,
      sym_type_parameter,
  [101718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4961), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2779), 1,
      sym_statement_block,
  [101736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4983), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2795), 1,
      sym_statement_block,
  [101770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1096), 1,
      sym_class_body,
  [101780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_while,
    ACTIONS(6535), 1,
      anon_sym_else,
  [101790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym_class_body,
  [101808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1093), 1,
      sym_class_body,
  [101818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1091), 1,
      sym_statement_block,
  [101828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_from,
    STATE(2922), 1,
      sym__from_clause,
  [101838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1403), 1,
      sym_class_body,
  [101856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 1,
      sym_identifier,
    STATE(473), 1,
      sym_nested_identifier,
  [101866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3124), 1,
      sym_formal_parameters,
  [101876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 1,
      sym_identifier,
    STATE(1695), 1,
      sym_nested_identifier,
  [101886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2971), 1,
      sym_statement_block,
  [101896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2823), 1,
      sym_statement_block,
  [101906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1437), 1,
      sym_class_body,
  [101916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6545), 1,
      sym_identifier,
    ACTIONS(6547), 1,
      anon_sym_STAR,
  [101926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      sym_identifier,
    ACTIONS(6551), 1,
      anon_sym_STAR,
  [101936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1077), 1,
      sym_statement_block,
  [101946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_class_body,
  [101956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      sym_jsx_identifier,
    ACTIONS(6553), 1,
      sym_identifier,
  [101966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2639), 1,
      sym_formal_parameters,
  [101976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1401), 1,
      sym_statement_block,
  [101986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2797), 1,
      sym_statement_block,
  [101996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      sym_identifier,
    STATE(2930), 1,
      sym_type_parameter,
  [102006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 1,
      sym_identifier,
    STATE(2709), 1,
      sym_nested_identifier,
  [102016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_statement_block,
  [102034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [102042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(2368), 1,
      sym_class_body,
  [102052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6557), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [102060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(522), 1,
      sym_class_body,
  [102070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 1,
      sym_identifier,
    ACTIONS(6561), 1,
      anon_sym_STAR,
  [102080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_COLON,
    STATE(2332), 1,
      sym_type_annotation,
  [102090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1400), 1,
      sym_class_body,
  [102100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(6268), 1,
      anon_sym_GT,
  [102110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3083), 1,
      sym_formal_parameters,
  [102120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1067), 1,
      sym_class_body,
  [102130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [102138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(2298), 1,
      sym_class_body,
  [102148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6268), 1,
      anon_sym_GT,
  [102158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(2293), 1,
      sym_class_body,
  [102168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1066), 1,
      sym_class_body,
  [102178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [102186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2663), 1,
      sym_formal_parameters,
  [102196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1064), 1,
      sym_statement_block,
  [102206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(2387), 1,
      sym_statement_block,
  [102216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [102226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6565), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [102234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2833), 1,
      sym_statement_block,
  [102244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1062), 1,
      sym_class_body,
  [102254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [102262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(535), 1,
      sym_statement_block,
  [102272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1533), 1,
      sym_class_body,
  [102282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(536), 1,
      sym_statement_block,
  [102292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3220), 1,
      sym_formal_parameters,
  [102302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(2397), 1,
      sym_statement_block,
  [102312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6569), 1,
      sym_identifier,
    STATE(1043), 1,
      sym_nested_identifier,
  [102322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3190), 1,
      sym_formal_parameters,
  [102332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(125), 1,
      sym_class_body,
  [102342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
  [102352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [102360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(537), 1,
      sym_statement_block,
  [102370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3175), 1,
      sym_formal_parameters,
  [102380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1102), 1,
      anon_sym_LBRACE,
    STATE(134), 1,
      sym_statement_block,
  [102390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6573), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3156), 1,
      sym_formal_parameters,
  [102408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(118), 1,
      sym_class_body,
  [102426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 1,
      sym_identifier,
    STATE(1917), 1,
      sym_nested_identifier,
  [102436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1399), 1,
      sym_statement_block,
  [102446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(2272), 1,
      sym_class_body,
  [102456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1398), 1,
      sym_class_body,
  [102466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(2267), 1,
      sym_class_body,
  [102476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3112), 1,
      sym_formal_parameters,
  [102486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1055), 1,
      sym_statement_block,
  [102496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2990), 1,
      sym_formal_parameters,
  [102506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 1,
      sym_identifier,
    ACTIONS(6579), 1,
      anon_sym_STAR,
  [102516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6183), 1,
      anon_sym_GT,
  [102526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym_class_body,
  [102536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    STATE(2042), 1,
      sym_formal_parameters,
  [102546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1455), 1,
      sym_class_body,
  [102556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3100), 1,
      sym_formal_parameters,
  [102566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2582), 1,
      sym_formal_parameters,
  [102576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2821), 1,
      sym_statement_block,
  [102586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6581), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [102594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1451), 1,
      sym_statement_block,
  [102604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1446), 1,
      sym_statement_block,
  [102622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3146), 1,
      sym_formal_parameters,
  [102632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1565), 1,
      sym_class_body,
  [102642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1102), 1,
      anon_sym_LBRACE,
    STATE(126), 1,
      sym_statement_block,
  [102652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1567), 1,
      sym_statement_block,
  [102662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [102670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5326), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_class_body,
  [102680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6280), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [102688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      sym_class_body,
  [102698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6585), 1,
      sym_identifier,
    STATE(2744), 1,
      sym_nested_identifier,
  [102708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4995), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [102716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACE,
    STATE(550), 1,
      sym_enum_body,
  [102726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [102734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_statement_block,
  [102744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6589), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_from,
    STATE(2810), 1,
      sym__from_clause,
  [102762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5326), 1,
      anon_sym_LBRACE,
    STATE(563), 1,
      sym_class_body,
  [102772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1570), 1,
      sym_class_body,
  [102782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1571), 1,
      sym_statement_block,
  [102792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1572), 1,
      sym_statement_block,
  [102802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1574), 1,
      sym_class_body,
  [102812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1576), 1,
      sym_class_body,
  [102830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6593), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT,
  [102848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym_COLON,
    ACTIONS(6194), 1,
      anon_sym_GT,
  [102858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1447), 1,
      sym_class_body,
  [102868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1577), 1,
      sym_statement_block,
  [102878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1419), 1,
      sym_class_body,
  [102888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1416), 1,
      sym_statement_block,
  [102898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [102906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 1,
      anon_sym_LBRACE,
    STATE(571), 1,
      sym_switch_body,
  [102916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym__for_header,
  [102926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1423), 1,
      sym_statement_block,
  [102936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(2572), 1,
      sym_formal_parameters,
  [102946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(128), 1,
      sym_class_body,
  [102964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_DOT,
    ACTIONS(6183), 1,
      anon_sym_GT,
  [102974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4327), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2780), 1,
      sym_statement_block,
  [103016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1581), 1,
      sym_statement_block,
  [103034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    STATE(2786), 1,
      sym_statement_block,
  [103044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1584), 1,
      sym_class_body,
  [103054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1587), 1,
      sym_class_body,
  [103064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LBRACE,
    STATE(1491), 1,
      sym_statement_block,
  [103082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      sym_identifier,
    STATE(2613), 1,
      sym_type_parameter,
  [103092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LBRACE,
    STATE(527), 1,
      sym_class_body,
  [103102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1591), 1,
      sym_statement_block,
  [103112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1597), 1,
      sym_statement_block,
  [103122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1602), 1,
      sym_class_body,
  [103132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LBRACE,
    STATE(1420), 1,
      sym_class_body,
  [103142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3052), 1,
      sym_formal_parameters,
  [103160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      sym_identifier,
    STATE(1924), 1,
      sym_nested_identifier,
  [103170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_statement_block,
  [103180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(1650), 1,
      sym_class_body,
  [103190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    STATE(1646), 1,
      sym_statement_block,
  [103200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_LPAREN,
    STATE(3037), 1,
      sym_formal_parameters,
  [103210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_LBRACE,
    STATE(525), 1,
      sym_statement_block,
  [103220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4532), 1,
      anon_sym_RBRACK,
  [103227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6605), 1,
      sym_identifier,
  [103234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6607), 1,
      sym_identifier,
  [103241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 1,
      anon_sym_EQ_GT,
  [103248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6216), 1,
      anon_sym_LBRACE,
  [103255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 1,
      anon_sym_target,
  [103262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 1,
      anon_sym_DOT,
  [103269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 1,
      sym_identifier,
  [103276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      sym_identifier,
  [103283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6617), 1,
      anon_sym_RPAREN,
  [103290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6619), 1,
      anon_sym_EQ_GT,
  [103297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_EQ_GT,
  [103304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_EQ_GT,
  [103311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_EQ_GT,
  [103318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym_GT,
  [103325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 1,
      sym_number,
  [103332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym_SLASH2,
  [103339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 1,
      anon_sym_EQ_GT,
  [103346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 1,
      anon_sym_RBRACK,
  [103353] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6633), 1,
      sym_regex_pattern,
  [103360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 1,
      anon_sym_require,
  [103367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6637), 1,
      anon_sym_SLASH2,
  [103374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 1,
      anon_sym_EQ_GT,
  [103381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6641), 1,
      sym_identifier,
  [103388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym_GT,
  [103395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_RPAREN,
  [103402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6645), 1,
      sym_identifier,
  [103409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym_EQ_GT,
  [103416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      sym_identifier,
  [103423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 1,
      sym_identifier,
  [103430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6653), 1,
      anon_sym_COLON,
  [103437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 1,
      sym_identifier,
  [103444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 1,
      anon_sym_GT,
  [103451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 1,
      anon_sym_EQ_GT,
  [103458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6661), 1,
      anon_sym_while,
  [103465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 1,
      anon_sym_EQ_GT,
  [103472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6665), 1,
      anon_sym_EQ_GT,
  [103479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6667), 1,
      anon_sym_EQ_GT,
  [103486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 1,
      anon_sym_EQ_GT,
  [103493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_RPAREN,
  [103500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 1,
      sym_identifier,
  [103507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      anon_sym_EQ_GT,
  [103514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4536), 1,
      anon_sym_RBRACE,
  [103521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6675), 1,
      sym_identifier,
  [103528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6677), 1,
      anon_sym_LPAREN,
  [103535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6679), 1,
      anon_sym_target,
  [103542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 1,
      sym_identifier,
  [103549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6683), 1,
      sym_identifier,
  [103556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 1,
      anon_sym_RBRACE,
  [103563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym_RBRACK,
  [103570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 1,
      anon_sym_EQ_GT,
  [103577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 1,
      sym_identifier,
  [103584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 1,
      anon_sym_COLON,
  [103591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6194), 1,
      anon_sym_GT,
  [103598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6310), 1,
      anon_sym_from,
  [103605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6693), 1,
      anon_sym_EQ_GT,
  [103612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 1,
      anon_sym_EQ_GT,
  [103619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6697), 1,
      anon_sym_EQ_GT,
  [103626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 1,
      anon_sym_EQ_GT,
  [103633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6701), 1,
      sym_identifier,
  [103640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 1,
      sym_identifier,
  [103647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6705), 1,
      anon_sym_GT,
  [103654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_EQ_GT,
  [103661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 1,
      sym_identifier,
  [103668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6709), 1,
      anon_sym_COLON,
  [103675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 1,
      anon_sym_EQ_GT,
  [103682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6713), 1,
      sym_identifier,
  [103689] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6715), 1,
      sym_regex_pattern,
  [103696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6717), 1,
      anon_sym_from,
  [103703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      sym_identifier,
  [103710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6721), 1,
      sym_identifier,
  [103717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6723), 1,
      anon_sym_RBRACE,
  [103724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6725), 1,
      anon_sym_RPAREN,
  [103731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6727), 1,
      anon_sym_GT,
  [103738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4627), 1,
      anon_sym_RPAREN,
  [103745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_RPAREN,
  [103752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6729), 1,
      anon_sym_as,
  [103759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6731), 1,
      anon_sym_EQ_GT,
  [103766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_DOT,
  [103773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6733), 1,
      sym_identifier,
  [103780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6735), 1,
      sym_identifier,
  [103787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6737), 1,
      anon_sym_LBRACE,
  [103794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      anon_sym_EQ,
  [103801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6741), 1,
      sym_identifier,
  [103808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6743), 1,
      anon_sym_EQ_GT,
  [103815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_DOT,
  [103822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_RPAREN,
  [103829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6745), 1,
      sym_number,
  [103836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_RPAREN,
  [103843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6747), 1,
      sym_identifier,
  [103850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_GT,
  [103857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6751), 1,
      sym_identifier,
  [103864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      sym_identifier,
  [103871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6755), 1,
      sym_identifier,
  [103878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6757), 1,
      anon_sym_DOT,
  [103885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 1,
      anon_sym_GT,
  [103892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6759), 1,
      anon_sym_EQ_GT,
  [103899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3921), 1,
      anon_sym_RPAREN,
  [103906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      sym_identifier,
  [103913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_RPAREN,
  [103920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6765), 1,
      anon_sym_GT,
  [103927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_DOT,
  [103934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6767), 1,
      sym_identifier,
  [103941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6769), 1,
      sym_number,
  [103948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6771), 1,
      anon_sym_EQ_GT,
  [103955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6773), 1,
      sym_identifier,
  [103962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6775), 1,
      anon_sym_GT,
  [103969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6777), 1,
      anon_sym_GT,
  [103976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6779), 1,
      anon_sym_GT,
  [103983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4495), 1,
      anon_sym_RPAREN,
  [103990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym_EQ_GT,
  [103997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 1,
      sym_identifier,
  [104004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6785), 1,
      anon_sym_RBRACK,
  [104011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym_EQ_GT,
  [104018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_class,
  [104025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6791), 1,
      sym_identifier,
  [104032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_EQ,
  [104039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 1,
      anon_sym_EQ,
  [104046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6797), 1,
      anon_sym_EQ_GT,
  [104053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 1,
      anon_sym_GT,
  [104060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6799), 1,
      anon_sym_namespace,
  [104067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [104074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_GT,
  [104081] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6803), 1,
      sym_regex_pattern,
  [104088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6805), 1,
      anon_sym_target,
  [104095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_EQ_GT,
  [104102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_RBRACK,
  [104109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_COLON,
  [104116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      sym_identifier,
  [104123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6815), 1,
      anon_sym_GT,
  [104130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6817), 1,
      anon_sym_EQ_GT,
  [104137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3913), 1,
      anon_sym_RPAREN,
  [104144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6819), 1,
      anon_sym_EQ_GT,
  [104151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6821), 1,
      anon_sym_EQ_GT,
  [104158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6823), 1,
      sym_identifier,
  [104165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6825), 1,
      sym_identifier,
  [104172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6827), 1,
      sym_identifier,
  [104179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6829), 1,
      anon_sym_EQ_GT,
  [104186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6831), 1,
      sym_identifier,
  [104193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_EQ,
  [104200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6835), 1,
      anon_sym_RPAREN,
  [104207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6837), 1,
      anon_sym_EQ,
  [104214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 1,
      anon_sym_function,
  [104221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6841), 1,
      anon_sym_GT,
  [104228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6843), 1,
      anon_sym_EQ_GT,
  [104235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6845), 1,
      sym_number,
  [104242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 1,
      sym_identifier,
  [104249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6849), 1,
      sym_identifier,
  [104256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6851), 1,
      sym_identifier,
  [104263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      anon_sym_EQ_GT,
  [104270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_DOT,
  [104277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6855), 1,
      anon_sym_GT,
  [104284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6857), 1,
      anon_sym_GT,
  [104291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6859), 1,
      sym_identifier,
  [104298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6861), 1,
      anon_sym_GT,
  [104305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6863), 1,
      anon_sym_COLON,
  [104312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 1,
      anon_sym_namespace,
  [104319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 1,
      anon_sym_EQ_GT,
  [104326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6869), 1,
      anon_sym_SLASH2,
  [104333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6871), 1,
      anon_sym_EQ_GT,
  [104340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
  [104347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6873), 1,
      anon_sym_EQ_GT,
  [104354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6875), 1,
      anon_sym_EQ_GT,
  [104361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6877), 1,
      anon_sym_RPAREN,
  [104368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6879), 1,
      anon_sym_EQ_GT,
  [104375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6881), 1,
      sym_identifier,
  [104382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
  [104389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6883), 1,
      anon_sym_EQ_GT,
  [104396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_RPAREN,
  [104403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6887), 1,
      anon_sym_EQ_GT,
  [104410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_RPAREN,
  [104417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6889), 1,
      sym_identifier,
  [104424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_SLASH2,
  [104431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      sym_identifier,
  [104438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 1,
      sym_identifier,
  [104445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6897), 1,
      anon_sym_from,
  [104452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4623), 1,
      anon_sym_RPAREN,
  [104459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4621), 1,
      anon_sym_RPAREN,
  [104466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      anon_sym_EQ_GT,
  [104473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 1,
      anon_sym_RBRACK,
  [104480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 1,
      anon_sym_EQ_GT,
  [104487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 1,
      anon_sym_GT,
  [104494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4619), 1,
      anon_sym_RPAREN,
  [104501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4617), 1,
      anon_sym_RPAREN,
  [104508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      ts_builtin_sym_end,
  [104515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      sym_identifier,
  [104522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      sym_identifier,
  [104529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6909), 1,
      anon_sym_class,
  [104536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_EQ_GT,
  [104543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6913), 1,
      anon_sym_EQ_GT,
  [104550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6915), 1,
      sym_number,
  [104557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      sym_identifier,
  [104564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 1,
      anon_sym_RBRACE,
  [104571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 1,
      sym_identifier,
  [104578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_from,
  [104585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6925), 1,
      sym_identifier,
  [104592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6927), 1,
      anon_sym_from,
  [104599] = 2,
    ACTIONS(5283), 1,
      sym_comment,
    ACTIONS(6929), 1,
      sym_regex_pattern,
  [104606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 1,
      sym_identifier,
  [104613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6933), 1,
      anon_sym_GT,
  [104620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      anon_sym_EQ_GT,
  [104627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_COLON,
  [104634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      sym_identifier,
  [104641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6939), 1,
      anon_sym_EQ_GT,
  [104648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_RPAREN,
  [104655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      sym_identifier,
  [104662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6943), 1,
      anon_sym_GT,
  [104669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 1,
      sym_identifier,
  [104676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6947), 1,
      sym_identifier,
  [104683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      anon_sym_RPAREN,
  [104690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6951), 1,
      anon_sym_from,
  [104697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      sym_identifier,
  [104704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_RPAREN,
  [104711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6957), 1,
      sym_identifier,
  [104718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      sym_identifier,
  [104725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      sym_identifier,
  [104732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      sym_identifier,
  [104739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_from,
  [104746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym_EQ_GT,
  [104753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6969), 1,
      anon_sym_EQ,
  [104760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_from,
  [104767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6973), 1,
      sym_identifier,
  [104774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 1,
      sym_identifier,
  [104781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_function,
  [104788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      sym_identifier,
  [104795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 1,
      sym_identifier,
  [104802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6983), 1,
      sym_identifier,
  [104809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym_identifier,
  [104816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6987), 1,
      sym_identifier,
  [104823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6989), 1,
      sym_identifier,
  [104830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6991), 1,
      anon_sym_EQ_GT,
  [104837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6993), 1,
      sym_identifier,
  [104844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6995), 1,
      sym_identifier,
  [104851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6997), 1,
      anon_sym_EQ_GT,
  [104858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_EQ_GT,
  [104865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 1,
      sym_identifier,
  [104872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_RPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(630)] = 0,
  [SMALL_STATE(631)] = 92,
  [SMALL_STATE(632)] = 190,
  [SMALL_STATE(633)] = 288,
  [SMALL_STATE(634)] = 386,
  [SMALL_STATE(635)] = 484,
  [SMALL_STATE(636)] = 582,
  [SMALL_STATE(637)] = 680,
  [SMALL_STATE(638)] = 771,
  [SMALL_STATE(639)] = 858,
  [SMALL_STATE(640)] = 946,
  [SMALL_STATE(641)] = 1036,
  [SMALL_STATE(642)] = 1122,
  [SMALL_STATE(643)] = 1212,
  [SMALL_STATE(644)] = 1300,
  [SMALL_STATE(645)] = 1388,
  [SMALL_STATE(646)] = 1476,
  [SMALL_STATE(647)] = 1564,
  [SMALL_STATE(648)] = 1654,
  [SMALL_STATE(649)] = 1744,
  [SMALL_STATE(650)] = 1832,
  [SMALL_STATE(651)] = 1961,
  [SMALL_STATE(652)] = 2090,
  [SMALL_STATE(653)] = 2181,
  [SMALL_STATE(654)] = 2270,
  [SMALL_STATE(655)] = 2399,
  [SMALL_STATE(656)] = 2528,
  [SMALL_STATE(657)] = 2657,
  [SMALL_STATE(658)] = 2746,
  [SMALL_STATE(659)] = 2875,
  [SMALL_STATE(660)] = 2960,
  [SMALL_STATE(661)] = 3089,
  [SMALL_STATE(662)] = 3174,
  [SMALL_STATE(663)] = 3259,
  [SMALL_STATE(664)] = 3346,
  [SMALL_STATE(665)] = 3430,
  [SMALL_STATE(666)] = 3516,
  [SMALL_STATE(667)] = 3587,
  [SMALL_STATE(668)] = 3668,
  [SMALL_STATE(669)] = 3751,
  [SMALL_STATE(670)] = 3814,
  [SMALL_STATE(671)] = 3877,
  [SMALL_STATE(672)] = 3964,
  [SMALL_STATE(673)] = 4047,
  [SMALL_STATE(674)] = 4110,
  [SMALL_STATE(675)] = 4193,
  [SMALL_STATE(676)] = 4276,
  [SMALL_STATE(677)] = 4339,
  [SMALL_STATE(678)] = 4402,
  [SMALL_STATE(679)] = 4489,
  [SMALL_STATE(680)] = 4572,
  [SMALL_STATE(681)] = 4646,
  [SMALL_STATE(682)] = 4762,
  [SMALL_STATE(683)] = 4842,
  [SMALL_STATE(684)] = 4924,
  [SMALL_STATE(685)] = 5004,
  [SMALL_STATE(686)] = 5078,
  [SMALL_STATE(687)] = 5144,
  [SMALL_STATE(688)] = 5224,
  [SMALL_STATE(689)] = 5304,
  [SMALL_STATE(690)] = 5384,
  [SMALL_STATE(691)] = 5502,
  [SMALL_STATE(692)] = 5582,
  [SMALL_STATE(693)] = 5662,
  [SMALL_STATE(694)] = 5778,
  [SMALL_STATE(695)] = 5844,
  [SMALL_STATE(696)] = 5960,
  [SMALL_STATE(697)] = 6078,
  [SMALL_STATE(698)] = 6146,
  [SMALL_STATE(699)] = 6219,
  [SMALL_STATE(700)] = 6332,
  [SMALL_STATE(701)] = 6445,
  [SMALL_STATE(702)] = 6524,
  [SMALL_STATE(703)] = 6597,
  [SMALL_STATE(704)] = 6710,
  [SMALL_STATE(705)] = 6791,
  [SMALL_STATE(706)] = 6904,
  [SMALL_STATE(707)] = 6977,
  [SMALL_STATE(708)] = 7090,
  [SMALL_STATE(709)] = 7203,
  [SMALL_STATE(710)] = 7278,
  [SMALL_STATE(711)] = 7391,
  [SMALL_STATE(712)] = 7464,
  [SMALL_STATE(713)] = 7577,
  [SMALL_STATE(714)] = 7662,
  [SMALL_STATE(715)] = 7741,
  [SMALL_STATE(716)] = 7810,
  [SMALL_STATE(717)] = 7923,
  [SMALL_STATE(718)] = 7996,
  [SMALL_STATE(719)] = 8109,
  [SMALL_STATE(720)] = 8188,
  [SMALL_STATE(721)] = 8301,
  [SMALL_STATE(722)] = 8374,
  [SMALL_STATE(723)] = 8487,
  [SMALL_STATE(724)] = 8600,
  [SMALL_STATE(725)] = 8713,
  [SMALL_STATE(726)] = 8826,
  [SMALL_STATE(727)] = 8939,
  [SMALL_STATE(728)] = 9052,
  [SMALL_STATE(729)] = 9133,
  [SMALL_STATE(730)] = 9246,
  [SMALL_STATE(731)] = 9319,
  [SMALL_STATE(732)] = 9432,
  [SMALL_STATE(733)] = 9545,
  [SMALL_STATE(734)] = 9614,
  [SMALL_STATE(735)] = 9687,
  [SMALL_STATE(736)] = 9797,
  [SMALL_STATE(737)] = 9907,
  [SMALL_STATE(738)] = 10017,
  [SMALL_STATE(739)] = 10127,
  [SMALL_STATE(740)] = 10197,
  [SMALL_STATE(741)] = 10307,
  [SMALL_STATE(742)] = 10417,
  [SMALL_STATE(743)] = 10527,
  [SMALL_STATE(744)] = 10599,
  [SMALL_STATE(745)] = 10709,
  [SMALL_STATE(746)] = 10819,
  [SMALL_STATE(747)] = 10929,
  [SMALL_STATE(748)] = 11039,
  [SMALL_STATE(749)] = 11149,
  [SMALL_STATE(750)] = 11259,
  [SMALL_STATE(751)] = 11369,
  [SMALL_STATE(752)] = 11479,
  [SMALL_STATE(753)] = 11539,
  [SMALL_STATE(754)] = 11649,
  [SMALL_STATE(755)] = 11759,
  [SMALL_STATE(756)] = 11827,
  [SMALL_STATE(757)] = 11937,
  [SMALL_STATE(758)] = 12047,
  [SMALL_STATE(759)] = 12157,
  [SMALL_STATE(760)] = 12229,
  [SMALL_STATE(761)] = 12339,
  [SMALL_STATE(762)] = 12449,
  [SMALL_STATE(763)] = 12559,
  [SMALL_STATE(764)] = 12619,
  [SMALL_STATE(765)] = 12689,
  [SMALL_STATE(766)] = 12763,
  [SMALL_STATE(767)] = 12873,
  [SMALL_STATE(768)] = 12983,
  [SMALL_STATE(769)] = 13093,
  [SMALL_STATE(770)] = 13203,
  [SMALL_STATE(771)] = 13273,
  [SMALL_STATE(772)] = 13383,
  [SMALL_STATE(773)] = 13493,
  [SMALL_STATE(774)] = 13603,
  [SMALL_STATE(775)] = 13713,
  [SMALL_STATE(776)] = 13785,
  [SMALL_STATE(777)] = 13895,
  [SMALL_STATE(778)] = 14005,
  [SMALL_STATE(779)] = 14115,
  [SMALL_STATE(780)] = 14225,
  [SMALL_STATE(781)] = 14335,
  [SMALL_STATE(782)] = 14445,
  [SMALL_STATE(783)] = 14555,
  [SMALL_STATE(784)] = 14665,
  [SMALL_STATE(785)] = 14775,
  [SMALL_STATE(786)] = 14847,
  [SMALL_STATE(787)] = 14957,
  [SMALL_STATE(788)] = 15029,
  [SMALL_STATE(789)] = 15139,
  [SMALL_STATE(790)] = 15207,
  [SMALL_STATE(791)] = 15317,
  [SMALL_STATE(792)] = 15427,
  [SMALL_STATE(793)] = 15537,
  [SMALL_STATE(794)] = 15647,
  [SMALL_STATE(795)] = 15707,
  [SMALL_STATE(796)] = 15817,
  [SMALL_STATE(797)] = 15885,
  [SMALL_STATE(798)] = 15995,
  [SMALL_STATE(799)] = 16105,
  [SMALL_STATE(800)] = 16215,
  [SMALL_STATE(801)] = 16325,
  [SMALL_STATE(802)] = 16435,
  [SMALL_STATE(803)] = 16545,
  [SMALL_STATE(804)] = 16615,
  [SMALL_STATE(805)] = 16691,
  [SMALL_STATE(806)] = 16801,
  [SMALL_STATE(807)] = 16873,
  [SMALL_STATE(808)] = 16943,
  [SMALL_STATE(809)] = 17053,
  [SMALL_STATE(810)] = 17163,
  [SMALL_STATE(811)] = 17273,
  [SMALL_STATE(812)] = 17343,
  [SMALL_STATE(813)] = 17453,
  [SMALL_STATE(814)] = 17525,
  [SMALL_STATE(815)] = 17585,
  [SMALL_STATE(816)] = 17695,
  [SMALL_STATE(817)] = 17767,
  [SMALL_STATE(818)] = 17877,
  [SMALL_STATE(819)] = 17987,
  [SMALL_STATE(820)] = 18055,
  [SMALL_STATE(821)] = 18125,
  [SMALL_STATE(822)] = 18185,
  [SMALL_STATE(823)] = 18295,
  [SMALL_STATE(824)] = 18367,
  [SMALL_STATE(825)] = 18477,
  [SMALL_STATE(826)] = 18587,
  [SMALL_STATE(827)] = 18697,
  [SMALL_STATE(828)] = 18807,
  [SMALL_STATE(829)] = 18917,
  [SMALL_STATE(830)] = 19027,
  [SMALL_STATE(831)] = 19091,
  [SMALL_STATE(832)] = 19201,
  [SMALL_STATE(833)] = 19311,
  [SMALL_STATE(834)] = 19421,
  [SMALL_STATE(835)] = 19531,
  [SMALL_STATE(836)] = 19641,
  [SMALL_STATE(837)] = 19751,
  [SMALL_STATE(838)] = 19861,
  [SMALL_STATE(839)] = 19971,
  [SMALL_STATE(840)] = 20081,
  [SMALL_STATE(841)] = 20191,
  [SMALL_STATE(842)] = 20301,
  [SMALL_STATE(843)] = 20411,
  [SMALL_STATE(844)] = 20521,
  [SMALL_STATE(845)] = 20631,
  [SMALL_STATE(846)] = 20741,
  [SMALL_STATE(847)] = 20851,
  [SMALL_STATE(848)] = 20923,
  [SMALL_STATE(849)] = 21033,
  [SMALL_STATE(850)] = 21143,
  [SMALL_STATE(851)] = 21209,
  [SMALL_STATE(852)] = 21319,
  [SMALL_STATE(853)] = 21429,
  [SMALL_STATE(854)] = 21539,
  [SMALL_STATE(855)] = 21649,
  [SMALL_STATE(856)] = 21723,
  [SMALL_STATE(857)] = 21795,
  [SMALL_STATE(858)] = 21869,
  [SMALL_STATE(859)] = 21979,
  [SMALL_STATE(860)] = 22049,
  [SMALL_STATE(861)] = 22159,
  [SMALL_STATE(862)] = 22269,
  [SMALL_STATE(863)] = 22379,
  [SMALL_STATE(864)] = 22457,
  [SMALL_STATE(865)] = 22567,
  [SMALL_STATE(866)] = 22638,
  [SMALL_STATE(867)] = 22709,
  [SMALL_STATE(868)] = 22776,
  [SMALL_STATE(869)] = 22847,
  [SMALL_STATE(870)] = 22918,
  [SMALL_STATE(871)] = 22989,
  [SMALL_STATE(872)] = 23056,
  [SMALL_STATE(873)] = 23127,
  [SMALL_STATE(874)] = 23194,
  [SMALL_STATE(875)] = 23257,
  [SMALL_STATE(876)] = 23334,
  [SMALL_STATE(877)] = 23399,
  [SMALL_STATE(878)] = 23466,
  [SMALL_STATE(879)] = 23529,
  [SMALL_STATE(880)] = 23600,
  [SMALL_STATE(881)] = 23669,
  [SMALL_STATE(882)] = 23742,
  [SMALL_STATE(883)] = 23805,
  [SMALL_STATE(884)] = 23876,
  [SMALL_STATE(885)] = 23943,
  [SMALL_STATE(886)] = 24014,
  [SMALL_STATE(887)] = 24081,
  [SMALL_STATE(888)] = 24152,
  [SMALL_STATE(889)] = 24225,
  [SMALL_STATE(890)] = 24296,
  [SMALL_STATE(891)] = 24363,
  [SMALL_STATE(892)] = 24430,
  [SMALL_STATE(893)] = 24495,
  [SMALL_STATE(894)] = 24562,
  [SMALL_STATE(895)] = 24635,
  [SMALL_STATE(896)] = 24699,
  [SMALL_STATE(897)] = 24761,
  [SMALL_STATE(898)] = 24819,
  [SMALL_STATE(899)] = 24885,
  [SMALL_STATE(900)] = 24943,
  [SMALL_STATE(901)] = 25005,
  [SMALL_STATE(902)] = 25075,
  [SMALL_STATE(903)] = 25137,
  [SMALL_STATE(904)] = 25195,
  [SMALL_STATE(905)] = 25263,
  [SMALL_STATE(906)] = 25321,
  [SMALL_STATE(907)] = 25385,
  [SMALL_STATE(908)] = 25451,
  [SMALL_STATE(909)] = 25515,
  [SMALL_STATE(910)] = 25585,
  [SMALL_STATE(911)] = 25651,
  [SMALL_STATE(912)] = 25715,
  [SMALL_STATE(913)] = 25777,
  [SMALL_STATE(914)] = 25839,
  [SMALL_STATE(915)] = 25909,
  [SMALL_STATE(916)] = 25967,
  [SMALL_STATE(917)] = 26031,
  [SMALL_STATE(918)] = 26093,
  [SMALL_STATE(919)] = 26162,
  [SMALL_STATE(920)] = 26231,
  [SMALL_STATE(921)] = 26292,
  [SMALL_STATE(922)] = 26355,
  [SMALL_STATE(923)] = 26424,
  [SMALL_STATE(924)] = 26485,
  [SMALL_STATE(925)] = 26554,
  [SMALL_STATE(926)] = 26618,
  [SMALL_STATE(927)] = 26722,
  [SMALL_STATE(928)] = 26826,
  [SMALL_STATE(929)] = 26900,
  [SMALL_STATE(930)] = 27004,
  [SMALL_STATE(931)] = 27108,
  [SMALL_STATE(932)] = 27212,
  [SMALL_STATE(933)] = 27316,
  [SMALL_STATE(934)] = 27420,
  [SMALL_STATE(935)] = 27524,
  [SMALL_STATE(936)] = 27588,
  [SMALL_STATE(937)] = 27692,
  [SMALL_STATE(938)] = 27793,
  [SMALL_STATE(939)] = 27896,
  [SMALL_STATE(940)] = 27996,
  [SMALL_STATE(941)] = 28096,
  [SMALL_STATE(942)] = 28196,
  [SMALL_STATE(943)] = 28296,
  [SMALL_STATE(944)] = 28396,
  [SMALL_STATE(945)] = 28496,
  [SMALL_STATE(946)] = 28596,
  [SMALL_STATE(947)] = 28696,
  [SMALL_STATE(948)] = 28796,
  [SMALL_STATE(949)] = 28896,
  [SMALL_STATE(950)] = 28996,
  [SMALL_STATE(951)] = 29096,
  [SMALL_STATE(952)] = 29196,
  [SMALL_STATE(953)] = 29296,
  [SMALL_STATE(954)] = 29396,
  [SMALL_STATE(955)] = 29458,
  [SMALL_STATE(956)] = 29554,
  [SMALL_STATE(957)] = 29650,
  [SMALL_STATE(958)] = 29746,
  [SMALL_STATE(959)] = 29842,
  [SMALL_STATE(960)] = 29908,
  [SMALL_STATE(961)] = 30004,
  [SMALL_STATE(962)] = 30100,
  [SMALL_STATE(963)] = 30162,
  [SMALL_STATE(964)] = 30220,
  [SMALL_STATE(965)] = 30279,
  [SMALL_STATE(966)] = 30330,
  [SMALL_STATE(967)] = 30385,
  [SMALL_STATE(968)] = 30436,
  [SMALL_STATE(969)] = 30487,
  [SMALL_STATE(970)] = 30538,
  [SMALL_STATE(971)] = 30589,
  [SMALL_STATE(972)] = 30640,
  [SMALL_STATE(973)] = 30697,
  [SMALL_STATE(974)] = 30754,
  [SMALL_STATE(975)] = 30805,
  [SMALL_STATE(976)] = 30856,
  [SMALL_STATE(977)] = 30907,
  [SMALL_STATE(978)] = 30958,
  [SMALL_STATE(979)] = 31058,
  [SMALL_STATE(980)] = 31128,
  [SMALL_STATE(981)] = 31220,
  [SMALL_STATE(982)] = 31312,
  [SMALL_STATE(983)] = 31404,
  [SMALL_STATE(984)] = 31496,
  [SMALL_STATE(985)] = 31548,
  [SMALL_STATE(986)] = 31640,
  [SMALL_STATE(987)] = 31732,
  [SMALL_STATE(988)] = 31824,
  [SMALL_STATE(989)] = 31896,
  [SMALL_STATE(990)] = 31990,
  [SMALL_STATE(991)] = 32068,
  [SMALL_STATE(992)] = 32168,
  [SMALL_STATE(993)] = 32250,
  [SMALL_STATE(994)] = 32336,
  [SMALL_STATE(995)] = 32412,
  [SMALL_STATE(996)] = 32482,
  [SMALL_STATE(997)] = 32572,
  [SMALL_STATE(998)] = 32664,
  [SMALL_STATE(999)] = 32756,
  [SMALL_STATE(1000)] = 32810,
  [SMALL_STATE(1001)] = 32902,
  [SMALL_STATE(1002)] = 32966,
  [SMALL_STATE(1003)] = 33036,
  [SMALL_STATE(1004)] = 33104,
  [SMALL_STATE(1005)] = 33168,
  [SMALL_STATE(1006)] = 33222,
  [SMALL_STATE(1007)] = 33314,
  [SMALL_STATE(1008)] = 33406,
  [SMALL_STATE(1009)] = 33498,
  [SMALL_STATE(1010)] = 33590,
  [SMALL_STATE(1011)] = 33644,
  [SMALL_STATE(1012)] = 33700,
  [SMALL_STATE(1013)] = 33752,
  [SMALL_STATE(1014)] = 33804,
  [SMALL_STATE(1015)] = 33860,
  [SMALL_STATE(1016)] = 33914,
  [SMALL_STATE(1017)] = 33968,
  [SMALL_STATE(1018)] = 34060,
  [SMALL_STATE(1019)] = 34160,
  [SMALL_STATE(1020)] = 34252,
  [SMALL_STATE(1021)] = 34301,
  [SMALL_STATE(1022)] = 34350,
  [SMALL_STATE(1023)] = 34399,
  [SMALL_STATE(1024)] = 34448,
  [SMALL_STATE(1025)] = 34497,
  [SMALL_STATE(1026)] = 34594,
  [SMALL_STATE(1027)] = 34643,
  [SMALL_STATE(1028)] = 34692,
  [SMALL_STATE(1029)] = 34783,
  [SMALL_STATE(1030)] = 34832,
  [SMALL_STATE(1031)] = 34881,
  [SMALL_STATE(1032)] = 34966,
  [SMALL_STATE(1033)] = 35063,
  [SMALL_STATE(1034)] = 35112,
  [SMALL_STATE(1035)] = 35161,
  [SMALL_STATE(1036)] = 35210,
  [SMALL_STATE(1037)] = 35295,
  [SMALL_STATE(1038)] = 35346,
  [SMALL_STATE(1039)] = 35395,
  [SMALL_STATE(1040)] = 35480,
  [SMALL_STATE(1041)] = 35529,
  [SMALL_STATE(1042)] = 35578,
  [SMALL_STATE(1043)] = 35627,
  [SMALL_STATE(1044)] = 35678,
  [SMALL_STATE(1045)] = 35729,
  [SMALL_STATE(1046)] = 35778,
  [SMALL_STATE(1047)] = 35827,
  [SMALL_STATE(1048)] = 35876,
  [SMALL_STATE(1049)] = 35925,
  [SMALL_STATE(1050)] = 35984,
  [SMALL_STATE(1051)] = 36035,
  [SMALL_STATE(1052)] = 36084,
  [SMALL_STATE(1053)] = 36133,
  [SMALL_STATE(1054)] = 36182,
  [SMALL_STATE(1055)] = 36231,
  [SMALL_STATE(1056)] = 36280,
  [SMALL_STATE(1057)] = 36329,
  [SMALL_STATE(1058)] = 36378,
  [SMALL_STATE(1059)] = 36427,
  [SMALL_STATE(1060)] = 36478,
  [SMALL_STATE(1061)] = 36527,
  [SMALL_STATE(1062)] = 36576,
  [SMALL_STATE(1063)] = 36625,
  [SMALL_STATE(1064)] = 36674,
  [SMALL_STATE(1065)] = 36723,
  [SMALL_STATE(1066)] = 36776,
  [SMALL_STATE(1067)] = 36825,
  [SMALL_STATE(1068)] = 36874,
  [SMALL_STATE(1069)] = 36927,
  [SMALL_STATE(1070)] = 36976,
  [SMALL_STATE(1071)] = 37067,
  [SMALL_STATE(1072)] = 37116,
  [SMALL_STATE(1073)] = 37211,
  [SMALL_STATE(1074)] = 37260,
  [SMALL_STATE(1075)] = 37309,
  [SMALL_STATE(1076)] = 37358,
  [SMALL_STATE(1077)] = 37443,
  [SMALL_STATE(1078)] = 37492,
  [SMALL_STATE(1079)] = 37541,
  [SMALL_STATE(1080)] = 37632,
  [SMALL_STATE(1081)] = 37681,
  [SMALL_STATE(1082)] = 37730,
  [SMALL_STATE(1083)] = 37821,
  [SMALL_STATE(1084)] = 37870,
  [SMALL_STATE(1085)] = 37923,
  [SMALL_STATE(1086)] = 37972,
  [SMALL_STATE(1087)] = 38025,
  [SMALL_STATE(1088)] = 38116,
  [SMALL_STATE(1089)] = 38165,
  [SMALL_STATE(1090)] = 38214,
  [SMALL_STATE(1091)] = 38263,
  [SMALL_STATE(1092)] = 38312,
  [SMALL_STATE(1093)] = 38361,
  [SMALL_STATE(1094)] = 38410,
  [SMALL_STATE(1095)] = 38459,
  [SMALL_STATE(1096)] = 38508,
  [SMALL_STATE(1097)] = 38557,
  [SMALL_STATE(1098)] = 38606,
  [SMALL_STATE(1099)] = 38659,
  [SMALL_STATE(1100)] = 38712,
  [SMALL_STATE(1101)] = 38803,
  [SMALL_STATE(1102)] = 38852,
  [SMALL_STATE(1103)] = 38901,
  [SMALL_STATE(1104)] = 38950,
  [SMALL_STATE(1105)] = 38999,
  [SMALL_STATE(1106)] = 39090,
  [SMALL_STATE(1107)] = 39175,
  [SMALL_STATE(1108)] = 39224,
  [SMALL_STATE(1109)] = 39273,
  [SMALL_STATE(1110)] = 39322,
  [SMALL_STATE(1111)] = 39389,
  [SMALL_STATE(1112)] = 39438,
  [SMALL_STATE(1113)] = 39487,
  [SMALL_STATE(1114)] = 39556,
  [SMALL_STATE(1115)] = 39647,
  [SMALL_STATE(1116)] = 39696,
  [SMALL_STATE(1117)] = 39787,
  [SMALL_STATE(1118)] = 39836,
  [SMALL_STATE(1119)] = 39927,
  [SMALL_STATE(1120)] = 39976,
  [SMALL_STATE(1121)] = 40025,
  [SMALL_STATE(1122)] = 40116,
  [SMALL_STATE(1123)] = 40185,
  [SMALL_STATE(1124)] = 40234,
  [SMALL_STATE(1125)] = 40331,
  [SMALL_STATE(1126)] = 40390,
  [SMALL_STATE(1127)] = 40487,
  [SMALL_STATE(1128)] = 40536,
  [SMALL_STATE(1129)] = 40585,
  [SMALL_STATE(1130)] = 40634,
  [SMALL_STATE(1131)] = 40683,
  [SMALL_STATE(1132)] = 40732,
  [SMALL_STATE(1133)] = 40781,
  [SMALL_STATE(1134)] = 40852,
  [SMALL_STATE(1135)] = 40943,
  [SMALL_STATE(1136)] = 41020,
  [SMALL_STATE(1137)] = 41069,
  [SMALL_STATE(1138)] = 41160,
  [SMALL_STATE(1139)] = 41241,
  [SMALL_STATE(1140)] = 41296,
  [SMALL_STATE(1141)] = 41381,
  [SMALL_STATE(1142)] = 41456,
  [SMALL_STATE(1143)] = 41525,
  [SMALL_STATE(1144)] = 41614,
  [SMALL_STATE(1145)] = 41705,
  [SMALL_STATE(1146)] = 41758,
  [SMALL_STATE(1147)] = 41849,
  [SMALL_STATE(1148)] = 41902,
  [SMALL_STATE(1149)] = 41965,
  [SMALL_STATE(1150)] = 42014,
  [SMALL_STATE(1151)] = 42099,
  [SMALL_STATE(1152)] = 42190,
  [SMALL_STATE(1153)] = 42275,
  [SMALL_STATE(1154)] = 42372,
  [SMALL_STATE(1155)] = 42421,
  [SMALL_STATE(1156)] = 42516,
  [SMALL_STATE(1157)] = 42565,
  [SMALL_STATE(1158)] = 42614,
  [SMALL_STATE(1159)] = 42663,
  [SMALL_STATE(1160)] = 42758,
  [SMALL_STATE(1161)] = 42807,
  [SMALL_STATE(1162)] = 42856,
  [SMALL_STATE(1163)] = 42905,
  [SMALL_STATE(1164)] = 42954,
  [SMALL_STATE(1165)] = 43003,
  [SMALL_STATE(1166)] = 43052,
  [SMALL_STATE(1167)] = 43147,
  [SMALL_STATE(1168)] = 43238,
  [SMALL_STATE(1169)] = 43287,
  [SMALL_STATE(1170)] = 43384,
  [SMALL_STATE(1171)] = 43433,
  [SMALL_STATE(1172)] = 43482,
  [SMALL_STATE(1173)] = 43531,
  [SMALL_STATE(1174)] = 43580,
  [SMALL_STATE(1175)] = 43629,
  [SMALL_STATE(1176)] = 43678,
  [SMALL_STATE(1177)] = 43773,
  [SMALL_STATE(1178)] = 43867,
  [SMALL_STATE(1179)] = 43933,
  [SMALL_STATE(1180)] = 44009,
  [SMALL_STATE(1181)] = 44099,
  [SMALL_STATE(1182)] = 44179,
  [SMALL_STATE(1183)] = 44269,
  [SMALL_STATE(1184)] = 44359,
  [SMALL_STATE(1185)] = 44451,
  [SMALL_STATE(1186)] = 44541,
  [SMALL_STATE(1187)] = 44631,
  [SMALL_STATE(1188)] = 44701,
  [SMALL_STATE(1189)] = 44759,
  [SMALL_STATE(1190)] = 44827,
  [SMALL_STATE(1191)] = 44903,
  [SMALL_STATE(1192)] = 44959,
  [SMALL_STATE(1193)] = 45039,
  [SMALL_STATE(1194)] = 45123,
  [SMALL_STATE(1195)] = 45213,
  [SMALL_STATE(1196)] = 45287,
  [SMALL_STATE(1197)] = 45355,
  [SMALL_STATE(1198)] = 45443,
  [SMALL_STATE(1199)] = 45533,
  [SMALL_STATE(1200)] = 45623,
  [SMALL_STATE(1201)] = 45717,
  [SMALL_STATE(1202)] = 45811,
  [SMALL_STATE(1203)] = 45861,
  [SMALL_STATE(1204)] = 45953,
  [SMALL_STATE(1205)] = 46043,
  [SMALL_STATE(1206)] = 46133,
  [SMALL_STATE(1207)] = 46223,
  [SMALL_STATE(1208)] = 46313,
  [SMALL_STATE(1209)] = 46403,
  [SMALL_STATE(1210)] = 46495,
  [SMALL_STATE(1211)] = 46589,
  [SMALL_STATE(1212)] = 46663,
  [SMALL_STATE(1213)] = 46731,
  [SMALL_STATE(1214)] = 46819,
  [SMALL_STATE(1215)] = 46873,
  [SMALL_STATE(1216)] = 46927,
  [SMALL_STATE(1217)] = 47019,
  [SMALL_STATE(1218)] = 47087,
  [SMALL_STATE(1219)] = 47153,
  [SMALL_STATE(1220)] = 47245,
  [SMALL_STATE(1221)] = 47337,
  [SMALL_STATE(1222)] = 47429,
  [SMALL_STATE(1223)] = 47479,
  [SMALL_STATE(1224)] = 47527,
  [SMALL_STATE(1225)] = 47575,
  [SMALL_STATE(1226)] = 47665,
  [SMALL_STATE(1227)] = 47715,
  [SMALL_STATE(1228)] = 47805,
  [SMALL_STATE(1229)] = 47891,
  [SMALL_STATE(1230)] = 47977,
  [SMALL_STATE(1231)] = 48069,
  [SMALL_STATE(1232)] = 48163,
  [SMALL_STATE(1233)] = 48211,
  [SMALL_STATE(1234)] = 48301,
  [SMALL_STATE(1235)] = 48393,
  [SMALL_STATE(1236)] = 48485,
  [SMALL_STATE(1237)] = 48537,
  [SMALL_STATE(1238)] = 48631,
  [SMALL_STATE(1239)] = 48725,
  [SMALL_STATE(1240)] = 48817,
  [SMALL_STATE(1241)] = 48907,
  [SMALL_STATE(1242)] = 48997,
  [SMALL_STATE(1243)] = 49089,
  [SMALL_STATE(1244)] = 49159,
  [SMALL_STATE(1245)] = 49249,
  [SMALL_STATE(1246)] = 49317,
  [SMALL_STATE(1247)] = 49407,
  [SMALL_STATE(1248)] = 49497,
  [SMALL_STATE(1249)] = 49565,
  [SMALL_STATE(1250)] = 49619,
  [SMALL_STATE(1251)] = 49709,
  [SMALL_STATE(1252)] = 49799,
  [SMALL_STATE(1253)] = 49889,
  [SMALL_STATE(1254)] = 49981,
  [SMALL_STATE(1255)] = 50065,
  [SMALL_STATE(1256)] = 50157,
  [SMALL_STATE(1257)] = 50247,
  [SMALL_STATE(1258)] = 50337,
  [SMALL_STATE(1259)] = 50429,
  [SMALL_STATE(1260)] = 50519,
  [SMALL_STATE(1261)] = 50611,
  [SMALL_STATE(1262)] = 50701,
  [SMALL_STATE(1263)] = 50751,
  [SMALL_STATE(1264)] = 50843,
  [SMALL_STATE(1265)] = 50937,
  [SMALL_STATE(1266)] = 51007,
  [SMALL_STATE(1267)] = 51099,
  [SMALL_STATE(1268)] = 51175,
  [SMALL_STATE(1269)] = 51265,
  [SMALL_STATE(1270)] = 51345,
  [SMALL_STATE(1271)] = 51437,
  [SMALL_STATE(1272)] = 51523,
  [SMALL_STATE(1273)] = 51571,
  [SMALL_STATE(1274)] = 51655,
  [SMALL_STATE(1275)] = 51749,
  [SMALL_STATE(1276)] = 51823,
  [SMALL_STATE(1277)] = 51891,
  [SMALL_STATE(1278)] = 51979,
  [SMALL_STATE(1279)] = 52069,
  [SMALL_STATE(1280)] = 52159,
  [SMALL_STATE(1281)] = 52249,
  [SMALL_STATE(1282)] = 52339,
  [SMALL_STATE(1283)] = 52401,
  [SMALL_STATE(1284)] = 52493,
  [SMALL_STATE(1285)] = 52583,
  [SMALL_STATE(1286)] = 52673,
  [SMALL_STATE(1287)] = 52763,
  [SMALL_STATE(1288)] = 52821,
  [SMALL_STATE(1289)] = 52911,
  [SMALL_STATE(1290)] = 52979,
  [SMALL_STATE(1291)] = 53031,
  [SMALL_STATE(1292)] = 53117,
  [SMALL_STATE(1293)] = 53207,
  [SMALL_STATE(1294)] = 53301,
  [SMALL_STATE(1295)] = 53367,
  [SMALL_STATE(1296)] = 53435,
  [SMALL_STATE(1297)] = 53529,
  [SMALL_STATE(1298)] = 53577,
  [SMALL_STATE(1299)] = 53627,
  [SMALL_STATE(1300)] = 53677,
  [SMALL_STATE(1301)] = 53763,
  [SMALL_STATE(1302)] = 53811,
  [SMALL_STATE(1303)] = 53905,
  [SMALL_STATE(1304)] = 53997,
  [SMALL_STATE(1305)] = 54087,
  [SMALL_STATE(1306)] = 54138,
  [SMALL_STATE(1307)] = 54227,
  [SMALL_STATE(1308)] = 54318,
  [SMALL_STATE(1309)] = 54367,
  [SMALL_STATE(1310)] = 54416,
  [SMALL_STATE(1311)] = 54497,
  [SMALL_STATE(1312)] = 54564,
  [SMALL_STATE(1313)] = 54633,
  [SMALL_STATE(1314)] = 54698,
  [SMALL_STATE(1315)] = 54779,
  [SMALL_STATE(1316)] = 54828,
  [SMALL_STATE(1317)] = 54895,
  [SMALL_STATE(1318)] = 54964,
  [SMALL_STATE(1319)] = 55029,
  [SMALL_STATE(1320)] = 55080,
  [SMALL_STATE(1321)] = 55169,
  [SMALL_STATE(1322)] = 55260,
  [SMALL_STATE(1323)] = 55327,
  [SMALL_STATE(1324)] = 55392,
  [SMALL_STATE(1325)] = 55481,
  [SMALL_STATE(1326)] = 55570,
  [SMALL_STATE(1327)] = 55637,
  [SMALL_STATE(1328)] = 55690,
  [SMALL_STATE(1329)] = 55771,
  [SMALL_STATE(1330)] = 55852,
  [SMALL_STATE(1331)] = 55905,
  [SMALL_STATE(1332)] = 55986,
  [SMALL_STATE(1333)] = 56067,
  [SMALL_STATE(1334)] = 56116,
  [SMALL_STATE(1335)] = 56197,
  [SMALL_STATE(1336)] = 56278,
  [SMALL_STATE(1337)] = 56359,
  [SMALL_STATE(1338)] = 56450,
  [SMALL_STATE(1339)] = 56541,
  [SMALL_STATE(1340)] = 56622,
  [SMALL_STATE(1341)] = 56713,
  [SMALL_STATE(1342)] = 56794,
  [SMALL_STATE(1343)] = 56885,
  [SMALL_STATE(1344)] = 56938,
  [SMALL_STATE(1345)] = 57027,
  [SMALL_STATE(1346)] = 57116,
  [SMALL_STATE(1347)] = 57183,
  [SMALL_STATE(1348)] = 57252,
  [SMALL_STATE(1349)] = 57317,
  [SMALL_STATE(1350)] = 57406,
  [SMALL_STATE(1351)] = 57495,
  [SMALL_STATE(1352)] = 57584,
  [SMALL_STATE(1353)] = 57673,
  [SMALL_STATE(1354)] = 57762,
  [SMALL_STATE(1355)] = 57853,
  [SMALL_STATE(1356)] = 57942,
  [SMALL_STATE(1357)] = 58031,
  [SMALL_STATE(1358)] = 58118,
  [SMALL_STATE(1359)] = 58185,
  [SMALL_STATE(1360)] = 58258,
  [SMALL_STATE(1361)] = 58341,
  [SMALL_STATE(1362)] = 58420,
  [SMALL_STATE(1363)] = 58495,
  [SMALL_STATE(1364)] = 58564,
  [SMALL_STATE(1365)] = 58655,
  [SMALL_STATE(1366)] = 58744,
  [SMALL_STATE(1367)] = 58833,
  [SMALL_STATE(1368)] = 58914,
  [SMALL_STATE(1369)] = 59003,
  [SMALL_STATE(1370)] = 59092,
  [SMALL_STATE(1371)] = 59181,
  [SMALL_STATE(1372)] = 59270,
  [SMALL_STATE(1373)] = 59359,
  [SMALL_STATE(1374)] = 59440,
  [SMALL_STATE(1375)] = 59493,
  [SMALL_STATE(1376)] = 59546,
  [SMALL_STATE(1377)] = 59601,
  [SMALL_STATE(1378)] = 59682,
  [SMALL_STATE(1379)] = 59733,
  [SMALL_STATE(1380)] = 59784,
  [SMALL_STATE(1381)] = 59835,
  [SMALL_STATE(1382)] = 59884,
  [SMALL_STATE(1383)] = 59949,
  [SMALL_STATE(1384)] = 60018,
  [SMALL_STATE(1385)] = 60085,
  [SMALL_STATE(1386)] = 60174,
  [SMALL_STATE(1387)] = 60263,
  [SMALL_STATE(1388)] = 60352,
  [SMALL_STATE(1389)] = 60441,
  [SMALL_STATE(1390)] = 60532,
  [SMALL_STATE(1391)] = 60623,
  [SMALL_STATE(1392)] = 60714,
  [SMALL_STATE(1393)] = 60805,
  [SMALL_STATE(1394)] = 60896,
  [SMALL_STATE(1395)] = 60987,
  [SMALL_STATE(1396)] = 61040,
  [SMALL_STATE(1397)] = 61093,
  [SMALL_STATE(1398)] = 61144,
  [SMALL_STATE(1399)] = 61195,
  [SMALL_STATE(1400)] = 61246,
  [SMALL_STATE(1401)] = 61297,
  [SMALL_STATE(1402)] = 61348,
  [SMALL_STATE(1403)] = 61399,
  [SMALL_STATE(1404)] = 61450,
  [SMALL_STATE(1405)] = 61501,
  [SMALL_STATE(1406)] = 61552,
  [SMALL_STATE(1407)] = 61643,
  [SMALL_STATE(1408)] = 61734,
  [SMALL_STATE(1409)] = 61825,
  [SMALL_STATE(1410)] = 61916,
  [SMALL_STATE(1411)] = 61967,
  [SMALL_STATE(1412)] = 62018,
  [SMALL_STATE(1413)] = 62107,
  [SMALL_STATE(1414)] = 62158,
  [SMALL_STATE(1415)] = 62209,
  [SMALL_STATE(1416)] = 62255,
  [SMALL_STATE(1417)] = 62301,
  [SMALL_STATE(1418)] = 62347,
  [SMALL_STATE(1419)] = 62411,
  [SMALL_STATE(1420)] = 62457,
  [SMALL_STATE(1421)] = 62503,
  [SMALL_STATE(1422)] = 62549,
  [SMALL_STATE(1423)] = 62599,
  [SMALL_STATE(1424)] = 62645,
  [SMALL_STATE(1425)] = 62703,
  [SMALL_STATE(1426)] = 62749,
  [SMALL_STATE(1427)] = 62809,
  [SMALL_STATE(1428)] = 62857,
  [SMALL_STATE(1429)] = 62903,
  [SMALL_STATE(1430)] = 62951,
  [SMALL_STATE(1431)] = 62997,
  [SMALL_STATE(1432)] = 63047,
  [SMALL_STATE(1433)] = 63093,
  [SMALL_STATE(1434)] = 63139,
  [SMALL_STATE(1435)] = 63185,
  [SMALL_STATE(1436)] = 63273,
  [SMALL_STATE(1437)] = 63321,
  [SMALL_STATE(1438)] = 63367,
  [SMALL_STATE(1439)] = 63413,
  [SMALL_STATE(1440)] = 63501,
  [SMALL_STATE(1441)] = 63547,
  [SMALL_STATE(1442)] = 63601,
  [SMALL_STATE(1443)] = 63647,
  [SMALL_STATE(1444)] = 63693,
  [SMALL_STATE(1445)] = 63739,
  [SMALL_STATE(1446)] = 63785,
  [SMALL_STATE(1447)] = 63831,
  [SMALL_STATE(1448)] = 63877,
  [SMALL_STATE(1449)] = 63937,
  [SMALL_STATE(1450)] = 63983,
  [SMALL_STATE(1451)] = 64029,
  [SMALL_STATE(1452)] = 64075,
  [SMALL_STATE(1453)] = 64163,
  [SMALL_STATE(1454)] = 64209,
  [SMALL_STATE(1455)] = 64255,
  [SMALL_STATE(1456)] = 64301,
  [SMALL_STATE(1457)] = 64347,
  [SMALL_STATE(1458)] = 64399,
  [SMALL_STATE(1459)] = 64449,
  [SMALL_STATE(1460)] = 64497,
  [SMALL_STATE(1461)] = 64545,
  [SMALL_STATE(1462)] = 64591,
  [SMALL_STATE(1463)] = 64645,
  [SMALL_STATE(1464)] = 64691,
  [SMALL_STATE(1465)] = 64737,
  [SMALL_STATE(1466)] = 64783,
  [SMALL_STATE(1467)] = 64831,
  [SMALL_STATE(1468)] = 64877,
  [SMALL_STATE(1469)] = 64923,
  [SMALL_STATE(1470)] = 64975,
  [SMALL_STATE(1471)] = 65027,
  [SMALL_STATE(1472)] = 65115,
  [SMALL_STATE(1473)] = 65161,
  [SMALL_STATE(1474)] = 65207,
  [SMALL_STATE(1475)] = 65261,
  [SMALL_STATE(1476)] = 65307,
  [SMALL_STATE(1477)] = 65353,
  [SMALL_STATE(1478)] = 65399,
  [SMALL_STATE(1479)] = 65447,
  [SMALL_STATE(1480)] = 65493,
  [SMALL_STATE(1481)] = 65539,
  [SMALL_STATE(1482)] = 65585,
  [SMALL_STATE(1483)] = 65631,
  [SMALL_STATE(1484)] = 65681,
  [SMALL_STATE(1485)] = 65731,
  [SMALL_STATE(1486)] = 65819,
  [SMALL_STATE(1487)] = 65865,
  [SMALL_STATE(1488)] = 65911,
  [SMALL_STATE(1489)] = 65957,
  [SMALL_STATE(1490)] = 66005,
  [SMALL_STATE(1491)] = 66053,
  [SMALL_STATE(1492)] = 66099,
  [SMALL_STATE(1493)] = 66145,
  [SMALL_STATE(1494)] = 66191,
  [SMALL_STATE(1495)] = 66239,
  [SMALL_STATE(1496)] = 66289,
  [SMALL_STATE(1497)] = 66335,
  [SMALL_STATE(1498)] = 66385,
  [SMALL_STATE(1499)] = 66431,
  [SMALL_STATE(1500)] = 66477,
  [SMALL_STATE(1501)] = 66527,
  [SMALL_STATE(1502)] = 66591,
  [SMALL_STATE(1503)] = 66679,
  [SMALL_STATE(1504)] = 66725,
  [SMALL_STATE(1505)] = 66771,
  [SMALL_STATE(1506)] = 66817,
  [SMALL_STATE(1507)] = 66867,
  [SMALL_STATE(1508)] = 66913,
  [SMALL_STATE(1509)] = 66981,
  [SMALL_STATE(1510)] = 67029,
  [SMALL_STATE(1511)] = 67075,
  [SMALL_STATE(1512)] = 67125,
  [SMALL_STATE(1513)] = 67171,
  [SMALL_STATE(1514)] = 67217,
  [SMALL_STATE(1515)] = 67265,
  [SMALL_STATE(1516)] = 67313,
  [SMALL_STATE(1517)] = 67359,
  [SMALL_STATE(1518)] = 67407,
  [SMALL_STATE(1519)] = 67455,
  [SMALL_STATE(1520)] = 67501,
  [SMALL_STATE(1521)] = 67547,
  [SMALL_STATE(1522)] = 67593,
  [SMALL_STATE(1523)] = 67639,
  [SMALL_STATE(1524)] = 67685,
  [SMALL_STATE(1525)] = 67733,
  [SMALL_STATE(1526)] = 67779,
  [SMALL_STATE(1527)] = 67845,
  [SMALL_STATE(1528)] = 67891,
  [SMALL_STATE(1529)] = 67937,
  [SMALL_STATE(1530)] = 68001,
  [SMALL_STATE(1531)] = 68089,
  [SMALL_STATE(1532)] = 68149,
  [SMALL_STATE(1533)] = 68195,
  [SMALL_STATE(1534)] = 68241,
  [SMALL_STATE(1535)] = 68329,
  [SMALL_STATE(1536)] = 68375,
  [SMALL_STATE(1537)] = 68421,
  [SMALL_STATE(1538)] = 68467,
  [SMALL_STATE(1539)] = 68513,
  [SMALL_STATE(1540)] = 68559,
  [SMALL_STATE(1541)] = 68609,
  [SMALL_STATE(1542)] = 68659,
  [SMALL_STATE(1543)] = 68707,
  [SMALL_STATE(1544)] = 68755,
  [SMALL_STATE(1545)] = 68801,
  [SMALL_STATE(1546)] = 68847,
  [SMALL_STATE(1547)] = 68907,
  [SMALL_STATE(1548)] = 68995,
  [SMALL_STATE(1549)] = 69041,
  [SMALL_STATE(1550)] = 69093,
  [SMALL_STATE(1551)] = 69139,
  [SMALL_STATE(1552)] = 69185,
  [SMALL_STATE(1553)] = 69231,
  [SMALL_STATE(1554)] = 69277,
  [SMALL_STATE(1555)] = 69329,
  [SMALL_STATE(1556)] = 69381,
  [SMALL_STATE(1557)] = 69433,
  [SMALL_STATE(1558)] = 69483,
  [SMALL_STATE(1559)] = 69529,
  [SMALL_STATE(1560)] = 69575,
  [SMALL_STATE(1561)] = 69620,
  [SMALL_STATE(1562)] = 69665,
  [SMALL_STATE(1563)] = 69728,
  [SMALL_STATE(1564)] = 69787,
  [SMALL_STATE(1565)] = 69836,
  [SMALL_STATE(1566)] = 69881,
  [SMALL_STATE(1567)] = 69926,
  [SMALL_STATE(1568)] = 69971,
  [SMALL_STATE(1569)] = 70016,
  [SMALL_STATE(1570)] = 70061,
  [SMALL_STATE(1571)] = 70106,
  [SMALL_STATE(1572)] = 70151,
  [SMALL_STATE(1573)] = 70196,
  [SMALL_STATE(1574)] = 70241,
  [SMALL_STATE(1575)] = 70286,
  [SMALL_STATE(1576)] = 70337,
  [SMALL_STATE(1577)] = 70382,
  [SMALL_STATE(1578)] = 70427,
  [SMALL_STATE(1579)] = 70488,
  [SMALL_STATE(1580)] = 70533,
  [SMALL_STATE(1581)] = 70578,
  [SMALL_STATE(1582)] = 70623,
  [SMALL_STATE(1583)] = 70668,
  [SMALL_STATE(1584)] = 70713,
  [SMALL_STATE(1585)] = 70758,
  [SMALL_STATE(1586)] = 70803,
  [SMALL_STATE(1587)] = 70848,
  [SMALL_STATE(1588)] = 70893,
  [SMALL_STATE(1589)] = 70942,
  [SMALL_STATE(1590)] = 70987,
  [SMALL_STATE(1591)] = 71032,
  [SMALL_STATE(1592)] = 71077,
  [SMALL_STATE(1593)] = 71122,
  [SMALL_STATE(1594)] = 71167,
  [SMALL_STATE(1595)] = 71212,
  [SMALL_STATE(1596)] = 71257,
  [SMALL_STATE(1597)] = 71302,
  [SMALL_STATE(1598)] = 71347,
  [SMALL_STATE(1599)] = 71432,
  [SMALL_STATE(1600)] = 71477,
  [SMALL_STATE(1601)] = 71522,
  [SMALL_STATE(1602)] = 71567,
  [SMALL_STATE(1603)] = 71612,
  [SMALL_STATE(1604)] = 71657,
  [SMALL_STATE(1605)] = 71718,
  [SMALL_STATE(1606)] = 71781,
  [SMALL_STATE(1607)] = 71826,
  [SMALL_STATE(1608)] = 71871,
  [SMALL_STATE(1609)] = 71932,
  [SMALL_STATE(1610)] = 71977,
  [SMALL_STATE(1611)] = 72036,
  [SMALL_STATE(1612)] = 72081,
  [SMALL_STATE(1613)] = 72126,
  [SMALL_STATE(1614)] = 72185,
  [SMALL_STATE(1615)] = 72230,
  [SMALL_STATE(1616)] = 72275,
  [SMALL_STATE(1617)] = 72320,
  [SMALL_STATE(1618)] = 72405,
  [SMALL_STATE(1619)] = 72450,
  [SMALL_STATE(1620)] = 72535,
  [SMALL_STATE(1621)] = 72594,
  [SMALL_STATE(1622)] = 72657,
  [SMALL_STATE(1623)] = 72706,
  [SMALL_STATE(1624)] = 72753,
  [SMALL_STATE(1625)] = 72814,
  [SMALL_STATE(1626)] = 72861,
  [SMALL_STATE(1627)] = 72906,
  [SMALL_STATE(1628)] = 72965,
  [SMALL_STATE(1629)] = 73010,
  [SMALL_STATE(1630)] = 73055,
  [SMALL_STATE(1631)] = 73100,
  [SMALL_STATE(1632)] = 73149,
  [SMALL_STATE(1633)] = 73194,
  [SMALL_STATE(1634)] = 73243,
  [SMALL_STATE(1635)] = 73288,
  [SMALL_STATE(1636)] = 73337,
  [SMALL_STATE(1637)] = 73384,
  [SMALL_STATE(1638)] = 73429,
  [SMALL_STATE(1639)] = 73476,
  [SMALL_STATE(1640)] = 73525,
  [SMALL_STATE(1641)] = 73570,
  [SMALL_STATE(1642)] = 73615,
  [SMALL_STATE(1643)] = 73660,
  [SMALL_STATE(1644)] = 73719,
  [SMALL_STATE(1645)] = 73764,
  [SMALL_STATE(1646)] = 73809,
  [SMALL_STATE(1647)] = 73854,
  [SMALL_STATE(1648)] = 73913,
  [SMALL_STATE(1649)] = 73972,
  [SMALL_STATE(1650)] = 74017,
  [SMALL_STATE(1651)] = 74062,
  [SMALL_STATE(1652)] = 74121,
  [SMALL_STATE(1653)] = 74170,
  [SMALL_STATE(1654)] = 74215,
  [SMALL_STATE(1655)] = 74260,
  [SMALL_STATE(1656)] = 74305,
  [SMALL_STATE(1657)] = 74350,
  [SMALL_STATE(1658)] = 74395,
  [SMALL_STATE(1659)] = 74454,
  [SMALL_STATE(1660)] = 74501,
  [SMALL_STATE(1661)] = 74560,
  [SMALL_STATE(1662)] = 74605,
  [SMALL_STATE(1663)] = 74656,
  [SMALL_STATE(1664)] = 74701,
  [SMALL_STATE(1665)] = 74746,
  [SMALL_STATE(1666)] = 74791,
  [SMALL_STATE(1667)] = 74840,
  [SMALL_STATE(1668)] = 74885,
  [SMALL_STATE(1669)] = 74934,
  [SMALL_STATE(1670)] = 74993,
  [SMALL_STATE(1671)] = 75042,
  [SMALL_STATE(1672)] = 75087,
  [SMALL_STATE(1673)] = 75132,
  [SMALL_STATE(1674)] = 75191,
  [SMALL_STATE(1675)] = 75250,
  [SMALL_STATE(1676)] = 75295,
  [SMALL_STATE(1677)] = 75340,
  [SMALL_STATE(1678)] = 75385,
  [SMALL_STATE(1679)] = 75448,
  [SMALL_STATE(1680)] = 75493,
  [SMALL_STATE(1681)] = 75538,
  [SMALL_STATE(1682)] = 75601,
  [SMALL_STATE(1683)] = 75648,
  [SMALL_STATE(1684)] = 75709,
  [SMALL_STATE(1685)] = 75754,
  [SMALL_STATE(1686)] = 75799,
  [SMALL_STATE(1687)] = 75844,
  [SMALL_STATE(1688)] = 75905,
  [SMALL_STATE(1689)] = 75950,
  [SMALL_STATE(1690)] = 75995,
  [SMALL_STATE(1691)] = 76040,
  [SMALL_STATE(1692)] = 76087,
  [SMALL_STATE(1693)] = 76132,
  [SMALL_STATE(1694)] = 76193,
  [SMALL_STATE(1695)] = 76238,
  [SMALL_STATE(1696)] = 76285,
  [SMALL_STATE(1697)] = 76353,
  [SMALL_STATE(1698)] = 76421,
  [SMALL_STATE(1699)] = 76469,
  [SMALL_STATE(1700)] = 76523,
  [SMALL_STATE(1701)] = 76573,
  [SMALL_STATE(1702)] = 76627,
  [SMALL_STATE(1703)] = 76677,
  [SMALL_STATE(1704)] = 76731,
  [SMALL_STATE(1705)] = 76785,
  [SMALL_STATE(1706)] = 76839,
  [SMALL_STATE(1707)] = 76893,
  [SMALL_STATE(1708)] = 76947,
  [SMALL_STATE(1709)] = 76997,
  [SMALL_STATE(1710)] = 77051,
  [SMALL_STATE(1711)] = 77121,
  [SMALL_STATE(1712)] = 77175,
  [SMALL_STATE(1713)] = 77225,
  [SMALL_STATE(1714)] = 77293,
  [SMALL_STATE(1715)] = 77341,
  [SMALL_STATE(1716)] = 77391,
  [SMALL_STATE(1717)] = 77457,
  [SMALL_STATE(1718)] = 77507,
  [SMALL_STATE(1719)] = 77561,
  [SMALL_STATE(1720)] = 77627,
  [SMALL_STATE(1721)] = 77681,
  [SMALL_STATE(1722)] = 77747,
  [SMALL_STATE(1723)] = 77815,
  [SMALL_STATE(1724)] = 77885,
  [SMALL_STATE(1725)] = 77939,
  [SMALL_STATE(1726)] = 78007,
  [SMALL_STATE(1727)] = 78061,
  [SMALL_STATE(1728)] = 78115,
  [SMALL_STATE(1729)] = 78185,
  [SMALL_STATE(1730)] = 78233,
  [SMALL_STATE(1731)] = 78287,
  [SMALL_STATE(1732)] = 78337,
  [SMALL_STATE(1733)] = 78403,
  [SMALL_STATE(1734)] = 78453,
  [SMALL_STATE(1735)] = 78519,
  [SMALL_STATE(1736)] = 78589,
  [SMALL_STATE(1737)] = 78659,
  [SMALL_STATE(1738)] = 78730,
  [SMALL_STATE(1739)] = 78801,
  [SMALL_STATE(1740)] = 78872,
  [SMALL_STATE(1741)] = 78943,
  [SMALL_STATE(1742)] = 79004,
  [SMALL_STATE(1743)] = 79065,
  [SMALL_STATE(1744)] = 79136,
  [SMALL_STATE(1745)] = 79197,
  [SMALL_STATE(1746)] = 79268,
  [SMALL_STATE(1747)] = 79317,
  [SMALL_STATE(1748)] = 79382,
  [SMALL_STATE(1749)] = 79453,
  [SMALL_STATE(1750)] = 79524,
  [SMALL_STATE(1751)] = 79585,
  [SMALL_STATE(1752)] = 79634,
  [SMALL_STATE(1753)] = 79695,
  [SMALL_STATE(1754)] = 79744,
  [SMALL_STATE(1755)] = 79805,
  [SMALL_STATE(1756)] = 79868,
  [SMALL_STATE(1757)] = 79939,
  [SMALL_STATE(1758)] = 79981,
  [SMALL_STATE(1759)] = 80049,
  [SMALL_STATE(1760)] = 80117,
  [SMALL_STATE(1761)] = 80173,
  [SMALL_STATE(1762)] = 80215,
  [SMALL_STATE(1763)] = 80283,
  [SMALL_STATE(1764)] = 80351,
  [SMALL_STATE(1765)] = 80426,
  [SMALL_STATE(1766)] = 80477,
  [SMALL_STATE(1767)] = 80552,
  [SMALL_STATE(1768)] = 80603,
  [SMALL_STATE(1769)] = 80678,
  [SMALL_STATE(1770)] = 80729,
  [SMALL_STATE(1771)] = 80804,
  [SMALL_STATE(1772)] = 80855,
  [SMALL_STATE(1773)] = 80906,
  [SMALL_STATE(1774)] = 80981,
  [SMALL_STATE(1775)] = 81056,
  [SMALL_STATE(1776)] = 81131,
  [SMALL_STATE(1777)] = 81206,
  [SMALL_STATE(1778)] = 81246,
  [SMALL_STATE(1779)] = 81286,
  [SMALL_STATE(1780)] = 81326,
  [SMALL_STATE(1781)] = 81366,
  [SMALL_STATE(1782)] = 81412,
  [SMALL_STATE(1783)] = 81452,
  [SMALL_STATE(1784)] = 81492,
  [SMALL_STATE(1785)] = 81547,
  [SMALL_STATE(1786)] = 81598,
  [SMALL_STATE(1787)] = 81651,
  [SMALL_STATE(1788)] = 81704,
  [SMALL_STATE(1789)] = 81759,
  [SMALL_STATE(1790)] = 81812,
  [SMALL_STATE(1791)] = 81869,
  [SMALL_STATE(1792)] = 81917,
  [SMALL_STATE(1793)] = 81965,
  [SMALL_STATE(1794)] = 82005,
  [SMALL_STATE(1795)] = 82043,
  [SMALL_STATE(1796)] = 82081,
  [SMALL_STATE(1797)] = 82119,
  [SMALL_STATE(1798)] = 82167,
  [SMALL_STATE(1799)] = 82215,
  [SMALL_STATE(1800)] = 82263,
  [SMALL_STATE(1801)] = 82311,
  [SMALL_STATE(1802)] = 82351,
  [SMALL_STATE(1803)] = 82399,
  [SMALL_STATE(1804)] = 82437,
  [SMALL_STATE(1805)] = 82485,
  [SMALL_STATE(1806)] = 82533,
  [SMALL_STATE(1807)] = 82581,
  [SMALL_STATE(1808)] = 82619,
  [SMALL_STATE(1809)] = 82667,
  [SMALL_STATE(1810)] = 82705,
  [SMALL_STATE(1811)] = 82743,
  [SMALL_STATE(1812)] = 82781,
  [SMALL_STATE(1813)] = 82829,
  [SMALL_STATE(1814)] = 82867,
  [SMALL_STATE(1815)] = 82905,
  [SMALL_STATE(1816)] = 82943,
  [SMALL_STATE(1817)] = 82991,
  [SMALL_STATE(1818)] = 83029,
  [SMALL_STATE(1819)] = 83069,
  [SMALL_STATE(1820)] = 83107,
  [SMALL_STATE(1821)] = 83145,
  [SMALL_STATE(1822)] = 83193,
  [SMALL_STATE(1823)] = 83241,
  [SMALL_STATE(1824)] = 83289,
  [SMALL_STATE(1825)] = 83337,
  [SMALL_STATE(1826)] = 83385,
  [SMALL_STATE(1827)] = 83434,
  [SMALL_STATE(1828)] = 83483,
  [SMALL_STATE(1829)] = 83532,
  [SMALL_STATE(1830)] = 83589,
  [SMALL_STATE(1831)] = 83638,
  [SMALL_STATE(1832)] = 83687,
  [SMALL_STATE(1833)] = 83736,
  [SMALL_STATE(1834)] = 83786,
  [SMALL_STATE(1835)] = 83828,
  [SMALL_STATE(1836)] = 83882,
  [SMALL_STATE(1837)] = 83932,
  [SMALL_STATE(1838)] = 83986,
  [SMALL_STATE(1839)] = 84022,
  [SMALL_STATE(1840)] = 84068,
  [SMALL_STATE(1841)] = 84122,
  [SMALL_STATE(1842)] = 84160,
  [SMALL_STATE(1843)] = 84203,
  [SMALL_STATE(1844)] = 84246,
  [SMALL_STATE(1845)] = 84289,
  [SMALL_STATE(1846)] = 84332,
  [SMALL_STATE(1847)] = 84375,
  [SMALL_STATE(1848)] = 84418,
  [SMALL_STATE(1849)] = 84461,
  [SMALL_STATE(1850)] = 84504,
  [SMALL_STATE(1851)] = 84547,
  [SMALL_STATE(1852)] = 84590,
  [SMALL_STATE(1853)] = 84633,
  [SMALL_STATE(1854)] = 84676,
  [SMALL_STATE(1855)] = 84719,
  [SMALL_STATE(1856)] = 84762,
  [SMALL_STATE(1857)] = 84805,
  [SMALL_STATE(1858)] = 84848,
  [SMALL_STATE(1859)] = 84891,
  [SMALL_STATE(1860)] = 84934,
  [SMALL_STATE(1861)] = 84977,
  [SMALL_STATE(1862)] = 85020,
  [SMALL_STATE(1863)] = 85063,
  [SMALL_STATE(1864)] = 85106,
  [SMALL_STATE(1865)] = 85149,
  [SMALL_STATE(1866)] = 85192,
  [SMALL_STATE(1867)] = 85226,
  [SMALL_STATE(1868)] = 85269,
  [SMALL_STATE(1869)] = 85303,
  [SMALL_STATE(1870)] = 85359,
  [SMALL_STATE(1871)] = 85415,
  [SMALL_STATE(1872)] = 85471,
  [SMALL_STATE(1873)] = 85495,
  [SMALL_STATE(1874)] = 85518,
  [SMALL_STATE(1875)] = 85541,
  [SMALL_STATE(1876)] = 85564,
  [SMALL_STATE(1877)] = 85587,
  [SMALL_STATE(1878)] = 85610,
  [SMALL_STATE(1879)] = 85641,
  [SMALL_STATE(1880)] = 85683,
  [SMALL_STATE(1881)] = 85725,
  [SMALL_STATE(1882)] = 85767,
  [SMALL_STATE(1883)] = 85809,
  [SMALL_STATE(1884)] = 85851,
  [SMALL_STATE(1885)] = 85885,
  [SMALL_STATE(1886)] = 85927,
  [SMALL_STATE(1887)] = 85957,
  [SMALL_STATE(1888)] = 85998,
  [SMALL_STATE(1889)] = 86033,
  [SMALL_STATE(1890)] = 86068,
  [SMALL_STATE(1891)] = 86109,
  [SMALL_STATE(1892)] = 86144,
  [SMALL_STATE(1893)] = 86179,
  [SMALL_STATE(1894)] = 86214,
  [SMALL_STATE(1895)] = 86239,
  [SMALL_STATE(1896)] = 86274,
  [SMALL_STATE(1897)] = 86309,
  [SMALL_STATE(1898)] = 86344,
  [SMALL_STATE(1899)] = 86374,
  [SMALL_STATE(1900)] = 86406,
  [SMALL_STATE(1901)] = 86442,
  [SMALL_STATE(1902)] = 86474,
  [SMALL_STATE(1903)] = 86506,
  [SMALL_STATE(1904)] = 86544,
  [SMALL_STATE(1905)] = 86566,
  [SMALL_STATE(1906)] = 86598,
  [SMALL_STATE(1907)] = 86634,
  [SMALL_STATE(1908)] = 86670,
  [SMALL_STATE(1909)] = 86708,
  [SMALL_STATE(1910)] = 86740,
  [SMALL_STATE(1911)] = 86772,
  [SMALL_STATE(1912)] = 86804,
  [SMALL_STATE(1913)] = 86842,
  [SMALL_STATE(1914)] = 86874,
  [SMALL_STATE(1915)] = 86910,
  [SMALL_STATE(1916)] = 86946,
  [SMALL_STATE(1917)] = 86982,
  [SMALL_STATE(1918)] = 87004,
  [SMALL_STATE(1919)] = 87028,
  [SMALL_STATE(1920)] = 87066,
  [SMALL_STATE(1921)] = 87104,
  [SMALL_STATE(1922)] = 87121,
  [SMALL_STATE(1923)] = 87142,
  [SMALL_STATE(1924)] = 87165,
  [SMALL_STATE(1925)] = 87186,
  [SMALL_STATE(1926)] = 87207,
  [SMALL_STATE(1927)] = 87228,
  [SMALL_STATE(1928)] = 87251,
  [SMALL_STATE(1929)] = 87274,
  [SMALL_STATE(1930)] = 87291,
  [SMALL_STATE(1931)] = 87314,
  [SMALL_STATE(1932)] = 87337,
  [SMALL_STATE(1933)] = 87358,
  [SMALL_STATE(1934)] = 87377,
  [SMALL_STATE(1935)] = 87398,
  [SMALL_STATE(1936)] = 87416,
  [SMALL_STATE(1937)] = 87434,
  [SMALL_STATE(1938)] = 87452,
  [SMALL_STATE(1939)] = 87472,
  [SMALL_STATE(1940)] = 87490,
  [SMALL_STATE(1941)] = 87522,
  [SMALL_STATE(1942)] = 87540,
  [SMALL_STATE(1943)] = 87558,
  [SMALL_STATE(1944)] = 87592,
  [SMALL_STATE(1945)] = 87612,
  [SMALL_STATE(1946)] = 87646,
  [SMALL_STATE(1947)] = 87664,
  [SMALL_STATE(1948)] = 87682,
  [SMALL_STATE(1949)] = 87702,
  [SMALL_STATE(1950)] = 87720,
  [SMALL_STATE(1951)] = 87738,
  [SMALL_STATE(1952)] = 87756,
  [SMALL_STATE(1953)] = 87774,
  [SMALL_STATE(1954)] = 87806,
  [SMALL_STATE(1955)] = 87826,
  [SMALL_STATE(1956)] = 87860,
  [SMALL_STATE(1957)] = 87880,
  [SMALL_STATE(1958)] = 87914,
  [SMALL_STATE(1959)] = 87932,
  [SMALL_STATE(1960)] = 87950,
  [SMALL_STATE(1961)] = 87968,
  [SMALL_STATE(1962)] = 88002,
  [SMALL_STATE(1963)] = 88028,
  [SMALL_STATE(1964)] = 88058,
  [SMALL_STATE(1965)] = 88076,
  [SMALL_STATE(1966)] = 88108,
  [SMALL_STATE(1967)] = 88126,
  [SMALL_STATE(1968)] = 88144,
  [SMALL_STATE(1969)] = 88178,
  [SMALL_STATE(1970)] = 88212,
  [SMALL_STATE(1971)] = 88230,
  [SMALL_STATE(1972)] = 88248,
  [SMALL_STATE(1973)] = 88266,
  [SMALL_STATE(1974)] = 88292,
  [SMALL_STATE(1975)] = 88310,
  [SMALL_STATE(1976)] = 88328,
  [SMALL_STATE(1977)] = 88346,
  [SMALL_STATE(1978)] = 88366,
  [SMALL_STATE(1979)] = 88386,
  [SMALL_STATE(1980)] = 88406,
  [SMALL_STATE(1981)] = 88424,
  [SMALL_STATE(1982)] = 88458,
  [SMALL_STATE(1983)] = 88492,
  [SMALL_STATE(1984)] = 88526,
  [SMALL_STATE(1985)] = 88558,
  [SMALL_STATE(1986)] = 88590,
  [SMALL_STATE(1987)] = 88619,
  [SMALL_STATE(1988)] = 88650,
  [SMALL_STATE(1989)] = 88675,
  [SMALL_STATE(1990)] = 88706,
  [SMALL_STATE(1991)] = 88737,
  [SMALL_STATE(1992)] = 88766,
  [SMALL_STATE(1993)] = 88797,
  [SMALL_STATE(1994)] = 88822,
  [SMALL_STATE(1995)] = 88851,
  [SMALL_STATE(1996)] = 88876,
  [SMALL_STATE(1997)] = 88905,
  [SMALL_STATE(1998)] = 88934,
  [SMALL_STATE(1999)] = 88965,
  [SMALL_STATE(2000)] = 88994,
  [SMALL_STATE(2001)] = 89023,
  [SMALL_STATE(2002)] = 89048,
  [SMALL_STATE(2003)] = 89079,
  [SMALL_STATE(2004)] = 89108,
  [SMALL_STATE(2005)] = 89131,
  [SMALL_STATE(2006)] = 89160,
  [SMALL_STATE(2007)] = 89191,
  [SMALL_STATE(2008)] = 89222,
  [SMALL_STATE(2009)] = 89247,
  [SMALL_STATE(2010)] = 89278,
  [SMALL_STATE(2011)] = 89303,
  [SMALL_STATE(2012)] = 89332,
  [SMALL_STATE(2013)] = 89363,
  [SMALL_STATE(2014)] = 89388,
  [SMALL_STATE(2015)] = 89413,
  [SMALL_STATE(2016)] = 89444,
  [SMALL_STATE(2017)] = 89475,
  [SMALL_STATE(2018)] = 89506,
  [SMALL_STATE(2019)] = 89537,
  [SMALL_STATE(2020)] = 89562,
  [SMALL_STATE(2021)] = 89593,
  [SMALL_STATE(2022)] = 89618,
  [SMALL_STATE(2023)] = 89637,
  [SMALL_STATE(2024)] = 89662,
  [SMALL_STATE(2025)] = 89687,
  [SMALL_STATE(2026)] = 89718,
  [SMALL_STATE(2027)] = 89747,
  [SMALL_STATE(2028)] = 89769,
  [SMALL_STATE(2029)] = 89787,
  [SMALL_STATE(2030)] = 89809,
  [SMALL_STATE(2031)] = 89831,
  [SMALL_STATE(2032)] = 89853,
  [SMALL_STATE(2033)] = 89875,
  [SMALL_STATE(2034)] = 89897,
  [SMALL_STATE(2035)] = 89915,
  [SMALL_STATE(2036)] = 89931,
  [SMALL_STATE(2037)] = 89951,
  [SMALL_STATE(2038)] = 89973,
  [SMALL_STATE(2039)] = 89999,
  [SMALL_STATE(2040)] = 90021,
  [SMALL_STATE(2041)] = 90043,
  [SMALL_STATE(2042)] = 90065,
  [SMALL_STATE(2043)] = 90083,
  [SMALL_STATE(2044)] = 90105,
  [SMALL_STATE(2045)] = 90127,
  [SMALL_STATE(2046)] = 90153,
  [SMALL_STATE(2047)] = 90175,
  [SMALL_STATE(2048)] = 90193,
  [SMALL_STATE(2049)] = 90215,
  [SMALL_STATE(2050)] = 90232,
  [SMALL_STATE(2051)] = 90257,
  [SMALL_STATE(2052)] = 90282,
  [SMALL_STATE(2053)] = 90307,
  [SMALL_STATE(2054)] = 90332,
  [SMALL_STATE(2055)] = 90349,
  [SMALL_STATE(2056)] = 90362,
  [SMALL_STATE(2057)] = 90379,
  [SMALL_STATE(2058)] = 90404,
  [SMALL_STATE(2059)] = 90421,
  [SMALL_STATE(2060)] = 90438,
  [SMALL_STATE(2061)] = 90463,
  [SMALL_STATE(2062)] = 90488,
  [SMALL_STATE(2063)] = 90505,
  [SMALL_STATE(2064)] = 90522,
  [SMALL_STATE(2065)] = 90547,
  [SMALL_STATE(2066)] = 90562,
  [SMALL_STATE(2067)] = 90579,
  [SMALL_STATE(2068)] = 90600,
  [SMALL_STATE(2069)] = 90625,
  [SMALL_STATE(2070)] = 90646,
  [SMALL_STATE(2071)] = 90671,
  [SMALL_STATE(2072)] = 90696,
  [SMALL_STATE(2073)] = 90713,
  [SMALL_STATE(2074)] = 90738,
  [SMALL_STATE(2075)] = 90755,
  [SMALL_STATE(2076)] = 90770,
  [SMALL_STATE(2077)] = 90787,
  [SMALL_STATE(2078)] = 90804,
  [SMALL_STATE(2079)] = 90829,
  [SMALL_STATE(2080)] = 90854,
  [SMALL_STATE(2081)] = 90879,
  [SMALL_STATE(2082)] = 90904,
  [SMALL_STATE(2083)] = 90917,
  [SMALL_STATE(2084)] = 90942,
  [SMALL_STATE(2085)] = 90967,
  [SMALL_STATE(2086)] = 90992,
  [SMALL_STATE(2087)] = 91015,
  [SMALL_STATE(2088)] = 91040,
  [SMALL_STATE(2089)] = 91061,
  [SMALL_STATE(2090)] = 91082,
  [SMALL_STATE(2091)] = 91103,
  [SMALL_STATE(2092)] = 91122,
  [SMALL_STATE(2093)] = 91147,
  [SMALL_STATE(2094)] = 91172,
  [SMALL_STATE(2095)] = 91197,
  [SMALL_STATE(2096)] = 91222,
  [SMALL_STATE(2097)] = 91247,
  [SMALL_STATE(2098)] = 91272,
  [SMALL_STATE(2099)] = 91293,
  [SMALL_STATE(2100)] = 91318,
  [SMALL_STATE(2101)] = 91343,
  [SMALL_STATE(2102)] = 91368,
  [SMALL_STATE(2103)] = 91393,
  [SMALL_STATE(2104)] = 91418,
  [SMALL_STATE(2105)] = 91443,
  [SMALL_STATE(2106)] = 91464,
  [SMALL_STATE(2107)] = 91489,
  [SMALL_STATE(2108)] = 91514,
  [SMALL_STATE(2109)] = 91539,
  [SMALL_STATE(2110)] = 91564,
  [SMALL_STATE(2111)] = 91577,
  [SMALL_STATE(2112)] = 91602,
  [SMALL_STATE(2113)] = 91627,
  [SMALL_STATE(2114)] = 91652,
  [SMALL_STATE(2115)] = 91669,
  [SMALL_STATE(2116)] = 91686,
  [SMALL_STATE(2117)] = 91703,
  [SMALL_STATE(2118)] = 91716,
  [SMALL_STATE(2119)] = 91735,
  [SMALL_STATE(2120)] = 91760,
  [SMALL_STATE(2121)] = 91777,
  [SMALL_STATE(2122)] = 91802,
  [SMALL_STATE(2123)] = 91823,
  [SMALL_STATE(2124)] = 91840,
  [SMALL_STATE(2125)] = 91857,
  [SMALL_STATE(2126)] = 91870,
  [SMALL_STATE(2127)] = 91892,
  [SMALL_STATE(2128)] = 91914,
  [SMALL_STATE(2129)] = 91926,
  [SMALL_STATE(2130)] = 91948,
  [SMALL_STATE(2131)] = 91970,
  [SMALL_STATE(2132)] = 91992,
  [SMALL_STATE(2133)] = 92012,
  [SMALL_STATE(2134)] = 92034,
  [SMALL_STATE(2135)] = 92056,
  [SMALL_STATE(2136)] = 92078,
  [SMALL_STATE(2137)] = 92098,
  [SMALL_STATE(2138)] = 92120,
  [SMALL_STATE(2139)] = 92142,
  [SMALL_STATE(2140)] = 92164,
  [SMALL_STATE(2141)] = 92186,
  [SMALL_STATE(2142)] = 92208,
  [SMALL_STATE(2143)] = 92230,
  [SMALL_STATE(2144)] = 92252,
  [SMALL_STATE(2145)] = 92274,
  [SMALL_STATE(2146)] = 92288,
  [SMALL_STATE(2147)] = 92304,
  [SMALL_STATE(2148)] = 92326,
  [SMALL_STATE(2149)] = 92348,
  [SMALL_STATE(2150)] = 92366,
  [SMALL_STATE(2151)] = 92384,
  [SMALL_STATE(2152)] = 92406,
  [SMALL_STATE(2153)] = 92424,
  [SMALL_STATE(2154)] = 92446,
  [SMALL_STATE(2155)] = 92462,
  [SMALL_STATE(2156)] = 92478,
  [SMALL_STATE(2157)] = 92500,
  [SMALL_STATE(2158)] = 92522,
  [SMALL_STATE(2159)] = 92538,
  [SMALL_STATE(2160)] = 92554,
  [SMALL_STATE(2161)] = 92566,
  [SMALL_STATE(2162)] = 92588,
  [SMALL_STATE(2163)] = 92610,
  [SMALL_STATE(2164)] = 92626,
  [SMALL_STATE(2165)] = 92648,
  [SMALL_STATE(2166)] = 92664,
  [SMALL_STATE(2167)] = 92680,
  [SMALL_STATE(2168)] = 92698,
  [SMALL_STATE(2169)] = 92714,
  [SMALL_STATE(2170)] = 92736,
  [SMALL_STATE(2171)] = 92758,
  [SMALL_STATE(2172)] = 92780,
  [SMALL_STATE(2173)] = 92796,
  [SMALL_STATE(2174)] = 92818,
  [SMALL_STATE(2175)] = 92834,
  [SMALL_STATE(2176)] = 92856,
  [SMALL_STATE(2177)] = 92878,
  [SMALL_STATE(2178)] = 92900,
  [SMALL_STATE(2179)] = 92922,
  [SMALL_STATE(2180)] = 92944,
  [SMALL_STATE(2181)] = 92962,
  [SMALL_STATE(2182)] = 92984,
  [SMALL_STATE(2183)] = 93006,
  [SMALL_STATE(2184)] = 93024,
  [SMALL_STATE(2185)] = 93042,
  [SMALL_STATE(2186)] = 93064,
  [SMALL_STATE(2187)] = 93082,
  [SMALL_STATE(2188)] = 93104,
  [SMALL_STATE(2189)] = 93122,
  [SMALL_STATE(2190)] = 93138,
  [SMALL_STATE(2191)] = 93160,
  [SMALL_STATE(2192)] = 93182,
  [SMALL_STATE(2193)] = 93198,
  [SMALL_STATE(2194)] = 93220,
  [SMALL_STATE(2195)] = 93236,
  [SMALL_STATE(2196)] = 93258,
  [SMALL_STATE(2197)] = 93280,
  [SMALL_STATE(2198)] = 93300,
  [SMALL_STATE(2199)] = 93316,
  [SMALL_STATE(2200)] = 93328,
  [SMALL_STATE(2201)] = 93346,
  [SMALL_STATE(2202)] = 93368,
  [SMALL_STATE(2203)] = 93390,
  [SMALL_STATE(2204)] = 93406,
  [SMALL_STATE(2205)] = 93426,
  [SMALL_STATE(2206)] = 93448,
  [SMALL_STATE(2207)] = 93464,
  [SMALL_STATE(2208)] = 93480,
  [SMALL_STATE(2209)] = 93496,
  [SMALL_STATE(2210)] = 93512,
  [SMALL_STATE(2211)] = 93528,
  [SMALL_STATE(2212)] = 93550,
  [SMALL_STATE(2213)] = 93562,
  [SMALL_STATE(2214)] = 93578,
  [SMALL_STATE(2215)] = 93594,
  [SMALL_STATE(2216)] = 93605,
  [SMALL_STATE(2217)] = 93624,
  [SMALL_STATE(2218)] = 93643,
  [SMALL_STATE(2219)] = 93658,
  [SMALL_STATE(2220)] = 93677,
  [SMALL_STATE(2221)] = 93688,
  [SMALL_STATE(2222)] = 93707,
  [SMALL_STATE(2223)] = 93720,
  [SMALL_STATE(2224)] = 93739,
  [SMALL_STATE(2225)] = 93754,
  [SMALL_STATE(2226)] = 93765,
  [SMALL_STATE(2227)] = 93784,
  [SMALL_STATE(2228)] = 93801,
  [SMALL_STATE(2229)] = 93820,
  [SMALL_STATE(2230)] = 93835,
  [SMALL_STATE(2231)] = 93852,
  [SMALL_STATE(2232)] = 93871,
  [SMALL_STATE(2233)] = 93890,
  [SMALL_STATE(2234)] = 93909,
  [SMALL_STATE(2235)] = 93928,
  [SMALL_STATE(2236)] = 93943,
  [SMALL_STATE(2237)] = 93962,
  [SMALL_STATE(2238)] = 93973,
  [SMALL_STATE(2239)] = 93992,
  [SMALL_STATE(2240)] = 94007,
  [SMALL_STATE(2241)] = 94022,
  [SMALL_STATE(2242)] = 94033,
  [SMALL_STATE(2243)] = 94046,
  [SMALL_STATE(2244)] = 94061,
  [SMALL_STATE(2245)] = 94072,
  [SMALL_STATE(2246)] = 94083,
  [SMALL_STATE(2247)] = 94094,
  [SMALL_STATE(2248)] = 94113,
  [SMALL_STATE(2249)] = 94124,
  [SMALL_STATE(2250)] = 94135,
  [SMALL_STATE(2251)] = 94146,
  [SMALL_STATE(2252)] = 94165,
  [SMALL_STATE(2253)] = 94176,
  [SMALL_STATE(2254)] = 94195,
  [SMALL_STATE(2255)] = 94206,
  [SMALL_STATE(2256)] = 94219,
  [SMALL_STATE(2257)] = 94230,
  [SMALL_STATE(2258)] = 94241,
  [SMALL_STATE(2259)] = 94260,
  [SMALL_STATE(2260)] = 94279,
  [SMALL_STATE(2261)] = 94290,
  [SMALL_STATE(2262)] = 94301,
  [SMALL_STATE(2263)] = 94312,
  [SMALL_STATE(2264)] = 94323,
  [SMALL_STATE(2265)] = 94334,
  [SMALL_STATE(2266)] = 94353,
  [SMALL_STATE(2267)] = 94372,
  [SMALL_STATE(2268)] = 94383,
  [SMALL_STATE(2269)] = 94394,
  [SMALL_STATE(2270)] = 94405,
  [SMALL_STATE(2271)] = 94424,
  [SMALL_STATE(2272)] = 94435,
  [SMALL_STATE(2273)] = 94446,
  [SMALL_STATE(2274)] = 94465,
  [SMALL_STATE(2275)] = 94476,
  [SMALL_STATE(2276)] = 94495,
  [SMALL_STATE(2277)] = 94506,
  [SMALL_STATE(2278)] = 94525,
  [SMALL_STATE(2279)] = 94536,
  [SMALL_STATE(2280)] = 94547,
  [SMALL_STATE(2281)] = 94558,
  [SMALL_STATE(2282)] = 94577,
  [SMALL_STATE(2283)] = 94590,
  [SMALL_STATE(2284)] = 94601,
  [SMALL_STATE(2285)] = 94612,
  [SMALL_STATE(2286)] = 94631,
  [SMALL_STATE(2287)] = 94650,
  [SMALL_STATE(2288)] = 94661,
  [SMALL_STATE(2289)] = 94672,
  [SMALL_STATE(2290)] = 94691,
  [SMALL_STATE(2291)] = 94702,
  [SMALL_STATE(2292)] = 94713,
  [SMALL_STATE(2293)] = 94724,
  [SMALL_STATE(2294)] = 94735,
  [SMALL_STATE(2295)] = 94754,
  [SMALL_STATE(2296)] = 94769,
  [SMALL_STATE(2297)] = 94788,
  [SMALL_STATE(2298)] = 94807,
  [SMALL_STATE(2299)] = 94818,
  [SMALL_STATE(2300)] = 94837,
  [SMALL_STATE(2301)] = 94850,
  [SMALL_STATE(2302)] = 94865,
  [SMALL_STATE(2303)] = 94880,
  [SMALL_STATE(2304)] = 94899,
  [SMALL_STATE(2305)] = 94912,
  [SMALL_STATE(2306)] = 94927,
  [SMALL_STATE(2307)] = 94938,
  [SMALL_STATE(2308)] = 94949,
  [SMALL_STATE(2309)] = 94960,
  [SMALL_STATE(2310)] = 94979,
  [SMALL_STATE(2311)] = 94994,
  [SMALL_STATE(2312)] = 95005,
  [SMALL_STATE(2313)] = 95016,
  [SMALL_STATE(2314)] = 95027,
  [SMALL_STATE(2315)] = 95046,
  [SMALL_STATE(2316)] = 95057,
  [SMALL_STATE(2317)] = 95076,
  [SMALL_STATE(2318)] = 95087,
  [SMALL_STATE(2319)] = 95098,
  [SMALL_STATE(2320)] = 95117,
  [SMALL_STATE(2321)] = 95132,
  [SMALL_STATE(2322)] = 95143,
  [SMALL_STATE(2323)] = 95162,
  [SMALL_STATE(2324)] = 95175,
  [SMALL_STATE(2325)] = 95190,
  [SMALL_STATE(2326)] = 95201,
  [SMALL_STATE(2327)] = 95212,
  [SMALL_STATE(2328)] = 95231,
  [SMALL_STATE(2329)] = 95246,
  [SMALL_STATE(2330)] = 95265,
  [SMALL_STATE(2331)] = 95284,
  [SMALL_STATE(2332)] = 95303,
  [SMALL_STATE(2333)] = 95314,
  [SMALL_STATE(2334)] = 95325,
  [SMALL_STATE(2335)] = 95344,
  [SMALL_STATE(2336)] = 95359,
  [SMALL_STATE(2337)] = 95378,
  [SMALL_STATE(2338)] = 95397,
  [SMALL_STATE(2339)] = 95416,
  [SMALL_STATE(2340)] = 95435,
  [SMALL_STATE(2341)] = 95454,
  [SMALL_STATE(2342)] = 95465,
  [SMALL_STATE(2343)] = 95484,
  [SMALL_STATE(2344)] = 95495,
  [SMALL_STATE(2345)] = 95508,
  [SMALL_STATE(2346)] = 95521,
  [SMALL_STATE(2347)] = 95540,
  [SMALL_STATE(2348)] = 95551,
  [SMALL_STATE(2349)] = 95570,
  [SMALL_STATE(2350)] = 95581,
  [SMALL_STATE(2351)] = 95600,
  [SMALL_STATE(2352)] = 95611,
  [SMALL_STATE(2353)] = 95630,
  [SMALL_STATE(2354)] = 95641,
  [SMALL_STATE(2355)] = 95652,
  [SMALL_STATE(2356)] = 95671,
  [SMALL_STATE(2357)] = 95682,
  [SMALL_STATE(2358)] = 95695,
  [SMALL_STATE(2359)] = 95706,
  [SMALL_STATE(2360)] = 95717,
  [SMALL_STATE(2361)] = 95728,
  [SMALL_STATE(2362)] = 95739,
  [SMALL_STATE(2363)] = 95750,
  [SMALL_STATE(2364)] = 95765,
  [SMALL_STATE(2365)] = 95776,
  [SMALL_STATE(2366)] = 95787,
  [SMALL_STATE(2367)] = 95798,
  [SMALL_STATE(2368)] = 95809,
  [SMALL_STATE(2369)] = 95820,
  [SMALL_STATE(2370)] = 95831,
  [SMALL_STATE(2371)] = 95844,
  [SMALL_STATE(2372)] = 95863,
  [SMALL_STATE(2373)] = 95882,
  [SMALL_STATE(2374)] = 95893,
  [SMALL_STATE(2375)] = 95904,
  [SMALL_STATE(2376)] = 95919,
  [SMALL_STATE(2377)] = 95930,
  [SMALL_STATE(2378)] = 95943,
  [SMALL_STATE(2379)] = 95954,
  [SMALL_STATE(2380)] = 95965,
  [SMALL_STATE(2381)] = 95976,
  [SMALL_STATE(2382)] = 95995,
  [SMALL_STATE(2383)] = 96006,
  [SMALL_STATE(2384)] = 96017,
  [SMALL_STATE(2385)] = 96032,
  [SMALL_STATE(2386)] = 96051,
  [SMALL_STATE(2387)] = 96064,
  [SMALL_STATE(2388)] = 96077,
  [SMALL_STATE(2389)] = 96088,
  [SMALL_STATE(2390)] = 96099,
  [SMALL_STATE(2391)] = 96110,
  [SMALL_STATE(2392)] = 96129,
  [SMALL_STATE(2393)] = 96148,
  [SMALL_STATE(2394)] = 96167,
  [SMALL_STATE(2395)] = 96178,
  [SMALL_STATE(2396)] = 96189,
  [SMALL_STATE(2397)] = 96208,
  [SMALL_STATE(2398)] = 96221,
  [SMALL_STATE(2399)] = 96240,
  [SMALL_STATE(2400)] = 96251,
  [SMALL_STATE(2401)] = 96262,
  [SMALL_STATE(2402)] = 96281,
  [SMALL_STATE(2403)] = 96296,
  [SMALL_STATE(2404)] = 96315,
  [SMALL_STATE(2405)] = 96334,
  [SMALL_STATE(2406)] = 96345,
  [SMALL_STATE(2407)] = 96356,
  [SMALL_STATE(2408)] = 96375,
  [SMALL_STATE(2409)] = 96386,
  [SMALL_STATE(2410)] = 96405,
  [SMALL_STATE(2411)] = 96422,
  [SMALL_STATE(2412)] = 96441,
  [SMALL_STATE(2413)] = 96460,
  [SMALL_STATE(2414)] = 96473,
  [SMALL_STATE(2415)] = 96484,
  [SMALL_STATE(2416)] = 96495,
  [SMALL_STATE(2417)] = 96510,
  [SMALL_STATE(2418)] = 96525,
  [SMALL_STATE(2419)] = 96540,
  [SMALL_STATE(2420)] = 96559,
  [SMALL_STATE(2421)] = 96576,
  [SMALL_STATE(2422)] = 96587,
  [SMALL_STATE(2423)] = 96606,
  [SMALL_STATE(2424)] = 96625,
  [SMALL_STATE(2425)] = 96636,
  [SMALL_STATE(2426)] = 96649,
  [SMALL_STATE(2427)] = 96668,
  [SMALL_STATE(2428)] = 96679,
  [SMALL_STATE(2429)] = 96698,
  [SMALL_STATE(2430)] = 96717,
  [SMALL_STATE(2431)] = 96736,
  [SMALL_STATE(2432)] = 96747,
  [SMALL_STATE(2433)] = 96760,
  [SMALL_STATE(2434)] = 96779,
  [SMALL_STATE(2435)] = 96792,
  [SMALL_STATE(2436)] = 96803,
  [SMALL_STATE(2437)] = 96818,
  [SMALL_STATE(2438)] = 96833,
  [SMALL_STATE(2439)] = 96844,
  [SMALL_STATE(2440)] = 96861,
  [SMALL_STATE(2441)] = 96880,
  [SMALL_STATE(2442)] = 96895,
  [SMALL_STATE(2443)] = 96914,
  [SMALL_STATE(2444)] = 96929,
  [SMALL_STATE(2445)] = 96944,
  [SMALL_STATE(2446)] = 96959,
  [SMALL_STATE(2447)] = 96970,
  [SMALL_STATE(2448)] = 96989,
  [SMALL_STATE(2449)] = 97000,
  [SMALL_STATE(2450)] = 97019,
  [SMALL_STATE(2451)] = 97030,
  [SMALL_STATE(2452)] = 97049,
  [SMALL_STATE(2453)] = 97060,
  [SMALL_STATE(2454)] = 97071,
  [SMALL_STATE(2455)] = 97090,
  [SMALL_STATE(2456)] = 97109,
  [SMALL_STATE(2457)] = 97124,
  [SMALL_STATE(2458)] = 97139,
  [SMALL_STATE(2459)] = 97154,
  [SMALL_STATE(2460)] = 97165,
  [SMALL_STATE(2461)] = 97184,
  [SMALL_STATE(2462)] = 97198,
  [SMALL_STATE(2463)] = 97212,
  [SMALL_STATE(2464)] = 97226,
  [SMALL_STATE(2465)] = 97242,
  [SMALL_STATE(2466)] = 97258,
  [SMALL_STATE(2467)] = 97274,
  [SMALL_STATE(2468)] = 97288,
  [SMALL_STATE(2469)] = 97302,
  [SMALL_STATE(2470)] = 97314,
  [SMALL_STATE(2471)] = 97328,
  [SMALL_STATE(2472)] = 97344,
  [SMALL_STATE(2473)] = 97360,
  [SMALL_STATE(2474)] = 97374,
  [SMALL_STATE(2475)] = 97388,
  [SMALL_STATE(2476)] = 97404,
  [SMALL_STATE(2477)] = 97418,
  [SMALL_STATE(2478)] = 97434,
  [SMALL_STATE(2479)] = 97450,
  [SMALL_STATE(2480)] = 97466,
  [SMALL_STATE(2481)] = 97482,
  [SMALL_STATE(2482)] = 97498,
  [SMALL_STATE(2483)] = 97514,
  [SMALL_STATE(2484)] = 97530,
  [SMALL_STATE(2485)] = 97546,
  [SMALL_STATE(2486)] = 97562,
  [SMALL_STATE(2487)] = 97576,
  [SMALL_STATE(2488)] = 97592,
  [SMALL_STATE(2489)] = 97606,
  [SMALL_STATE(2490)] = 97622,
  [SMALL_STATE(2491)] = 97636,
  [SMALL_STATE(2492)] = 97652,
  [SMALL_STATE(2493)] = 97668,
  [SMALL_STATE(2494)] = 97684,
  [SMALL_STATE(2495)] = 97700,
  [SMALL_STATE(2496)] = 97716,
  [SMALL_STATE(2497)] = 97732,
  [SMALL_STATE(2498)] = 97748,
  [SMALL_STATE(2499)] = 97762,
  [SMALL_STATE(2500)] = 97778,
  [SMALL_STATE(2501)] = 97794,
  [SMALL_STATE(2502)] = 97810,
  [SMALL_STATE(2503)] = 97824,
  [SMALL_STATE(2504)] = 97840,
  [SMALL_STATE(2505)] = 97856,
  [SMALL_STATE(2506)] = 97870,
  [SMALL_STATE(2507)] = 97886,
  [SMALL_STATE(2508)] = 97900,
  [SMALL_STATE(2509)] = 97914,
  [SMALL_STATE(2510)] = 97930,
  [SMALL_STATE(2511)] = 97944,
  [SMALL_STATE(2512)] = 97958,
  [SMALL_STATE(2513)] = 97974,
  [SMALL_STATE(2514)] = 97986,
  [SMALL_STATE(2515)] = 98002,
  [SMALL_STATE(2516)] = 98016,
  [SMALL_STATE(2517)] = 98032,
  [SMALL_STATE(2518)] = 98046,
  [SMALL_STATE(2519)] = 98060,
  [SMALL_STATE(2520)] = 98074,
  [SMALL_STATE(2521)] = 98088,
  [SMALL_STATE(2522)] = 98102,
  [SMALL_STATE(2523)] = 98118,
  [SMALL_STATE(2524)] = 98132,
  [SMALL_STATE(2525)] = 98142,
  [SMALL_STATE(2526)] = 98158,
  [SMALL_STATE(2527)] = 98172,
  [SMALL_STATE(2528)] = 98186,
  [SMALL_STATE(2529)] = 98202,
  [SMALL_STATE(2530)] = 98218,
  [SMALL_STATE(2531)] = 98228,
  [SMALL_STATE(2532)] = 98244,
  [SMALL_STATE(2533)] = 98260,
  [SMALL_STATE(2534)] = 98276,
  [SMALL_STATE(2535)] = 98292,
  [SMALL_STATE(2536)] = 98308,
  [SMALL_STATE(2537)] = 98322,
  [SMALL_STATE(2538)] = 98336,
  [SMALL_STATE(2539)] = 98350,
  [SMALL_STATE(2540)] = 98366,
  [SMALL_STATE(2541)] = 98382,
  [SMALL_STATE(2542)] = 98396,
  [SMALL_STATE(2543)] = 98410,
  [SMALL_STATE(2544)] = 98426,
  [SMALL_STATE(2545)] = 98442,
  [SMALL_STATE(2546)] = 98458,
  [SMALL_STATE(2547)] = 98472,
  [SMALL_STATE(2548)] = 98486,
  [SMALL_STATE(2549)] = 98500,
  [SMALL_STATE(2550)] = 98514,
  [SMALL_STATE(2551)] = 98528,
  [SMALL_STATE(2552)] = 98544,
  [SMALL_STATE(2553)] = 98558,
  [SMALL_STATE(2554)] = 98572,
  [SMALL_STATE(2555)] = 98586,
  [SMALL_STATE(2556)] = 98602,
  [SMALL_STATE(2557)] = 98618,
  [SMALL_STATE(2558)] = 98632,
  [SMALL_STATE(2559)] = 98646,
  [SMALL_STATE(2560)] = 98662,
  [SMALL_STATE(2561)] = 98678,
  [SMALL_STATE(2562)] = 98694,
  [SMALL_STATE(2563)] = 98710,
  [SMALL_STATE(2564)] = 98723,
  [SMALL_STATE(2565)] = 98736,
  [SMALL_STATE(2566)] = 98749,
  [SMALL_STATE(2567)] = 98762,
  [SMALL_STATE(2568)] = 98775,
  [SMALL_STATE(2569)] = 98784,
  [SMALL_STATE(2570)] = 98797,
  [SMALL_STATE(2571)] = 98810,
  [SMALL_STATE(2572)] = 98821,
  [SMALL_STATE(2573)] = 98834,
  [SMALL_STATE(2574)] = 98847,
  [SMALL_STATE(2575)] = 98860,
  [SMALL_STATE(2576)] = 98869,
  [SMALL_STATE(2577)] = 98882,
  [SMALL_STATE(2578)] = 98895,
  [SMALL_STATE(2579)] = 98908,
  [SMALL_STATE(2580)] = 98921,
  [SMALL_STATE(2581)] = 98934,
  [SMALL_STATE(2582)] = 98943,
  [SMALL_STATE(2583)] = 98956,
  [SMALL_STATE(2584)] = 98969,
  [SMALL_STATE(2585)] = 98982,
  [SMALL_STATE(2586)] = 98995,
  [SMALL_STATE(2587)] = 99008,
  [SMALL_STATE(2588)] = 99021,
  [SMALL_STATE(2589)] = 99034,
  [SMALL_STATE(2590)] = 99047,
  [SMALL_STATE(2591)] = 99060,
  [SMALL_STATE(2592)] = 99069,
  [SMALL_STATE(2593)] = 99082,
  [SMALL_STATE(2594)] = 99095,
  [SMALL_STATE(2595)] = 99108,
  [SMALL_STATE(2596)] = 99121,
  [SMALL_STATE(2597)] = 99134,
  [SMALL_STATE(2598)] = 99147,
  [SMALL_STATE(2599)] = 99156,
  [SMALL_STATE(2600)] = 99169,
  [SMALL_STATE(2601)] = 99182,
  [SMALL_STATE(2602)] = 99191,
  [SMALL_STATE(2603)] = 99204,
  [SMALL_STATE(2604)] = 99217,
  [SMALL_STATE(2605)] = 99230,
  [SMALL_STATE(2606)] = 99243,
  [SMALL_STATE(2607)] = 99256,
  [SMALL_STATE(2608)] = 99267,
  [SMALL_STATE(2609)] = 99276,
  [SMALL_STATE(2610)] = 99289,
  [SMALL_STATE(2611)] = 99302,
  [SMALL_STATE(2612)] = 99315,
  [SMALL_STATE(2613)] = 99328,
  [SMALL_STATE(2614)] = 99341,
  [SMALL_STATE(2615)] = 99354,
  [SMALL_STATE(2616)] = 99365,
  [SMALL_STATE(2617)] = 99378,
  [SMALL_STATE(2618)] = 99391,
  [SMALL_STATE(2619)] = 99400,
  [SMALL_STATE(2620)] = 99413,
  [SMALL_STATE(2621)] = 99426,
  [SMALL_STATE(2622)] = 99439,
  [SMALL_STATE(2623)] = 99452,
  [SMALL_STATE(2624)] = 99465,
  [SMALL_STATE(2625)] = 99478,
  [SMALL_STATE(2626)] = 99491,
  [SMALL_STATE(2627)] = 99500,
  [SMALL_STATE(2628)] = 99511,
  [SMALL_STATE(2629)] = 99520,
  [SMALL_STATE(2630)] = 99529,
  [SMALL_STATE(2631)] = 99542,
  [SMALL_STATE(2632)] = 99555,
  [SMALL_STATE(2633)] = 99568,
  [SMALL_STATE(2634)] = 99577,
  [SMALL_STATE(2635)] = 99586,
  [SMALL_STATE(2636)] = 99597,
  [SMALL_STATE(2637)] = 99606,
  [SMALL_STATE(2638)] = 99615,
  [SMALL_STATE(2639)] = 99628,
  [SMALL_STATE(2640)] = 99641,
  [SMALL_STATE(2641)] = 99654,
  [SMALL_STATE(2642)] = 99663,
  [SMALL_STATE(2643)] = 99676,
  [SMALL_STATE(2644)] = 99685,
  [SMALL_STATE(2645)] = 99696,
  [SMALL_STATE(2646)] = 99705,
  [SMALL_STATE(2647)] = 99718,
  [SMALL_STATE(2648)] = 99731,
  [SMALL_STATE(2649)] = 99740,
  [SMALL_STATE(2650)] = 99753,
  [SMALL_STATE(2651)] = 99764,
  [SMALL_STATE(2652)] = 99777,
  [SMALL_STATE(2653)] = 99790,
  [SMALL_STATE(2654)] = 99799,
  [SMALL_STATE(2655)] = 99812,
  [SMALL_STATE(2656)] = 99823,
  [SMALL_STATE(2657)] = 99836,
  [SMALL_STATE(2658)] = 99849,
  [SMALL_STATE(2659)] = 99860,
  [SMALL_STATE(2660)] = 99869,
  [SMALL_STATE(2661)] = 99882,
  [SMALL_STATE(2662)] = 99891,
  [SMALL_STATE(2663)] = 99900,
  [SMALL_STATE(2664)] = 99913,
  [SMALL_STATE(2665)] = 99926,
  [SMALL_STATE(2666)] = 99939,
  [SMALL_STATE(2667)] = 99948,
  [SMALL_STATE(2668)] = 99961,
  [SMALL_STATE(2669)] = 99974,
  [SMALL_STATE(2670)] = 99987,
  [SMALL_STATE(2671)] = 99996,
  [SMALL_STATE(2672)] = 100005,
  [SMALL_STATE(2673)] = 100018,
  [SMALL_STATE(2674)] = 100031,
  [SMALL_STATE(2675)] = 100044,
  [SMALL_STATE(2676)] = 100057,
  [SMALL_STATE(2677)] = 100070,
  [SMALL_STATE(2678)] = 100083,
  [SMALL_STATE(2679)] = 100096,
  [SMALL_STATE(2680)] = 100107,
  [SMALL_STATE(2681)] = 100120,
  [SMALL_STATE(2682)] = 100133,
  [SMALL_STATE(2683)] = 100146,
  [SMALL_STATE(2684)] = 100159,
  [SMALL_STATE(2685)] = 100172,
  [SMALL_STATE(2686)] = 100185,
  [SMALL_STATE(2687)] = 100198,
  [SMALL_STATE(2688)] = 100207,
  [SMALL_STATE(2689)] = 100220,
  [SMALL_STATE(2690)] = 100233,
  [SMALL_STATE(2691)] = 100246,
  [SMALL_STATE(2692)] = 100255,
  [SMALL_STATE(2693)] = 100268,
  [SMALL_STATE(2694)] = 100281,
  [SMALL_STATE(2695)] = 100294,
  [SMALL_STATE(2696)] = 100307,
  [SMALL_STATE(2697)] = 100320,
  [SMALL_STATE(2698)] = 100333,
  [SMALL_STATE(2699)] = 100342,
  [SMALL_STATE(2700)] = 100351,
  [SMALL_STATE(2701)] = 100364,
  [SMALL_STATE(2702)] = 100377,
  [SMALL_STATE(2703)] = 100390,
  [SMALL_STATE(2704)] = 100399,
  [SMALL_STATE(2705)] = 100412,
  [SMALL_STATE(2706)] = 100421,
  [SMALL_STATE(2707)] = 100434,
  [SMALL_STATE(2708)] = 100447,
  [SMALL_STATE(2709)] = 100460,
  [SMALL_STATE(2710)] = 100471,
  [SMALL_STATE(2711)] = 100480,
  [SMALL_STATE(2712)] = 100489,
  [SMALL_STATE(2713)] = 100502,
  [SMALL_STATE(2714)] = 100515,
  [SMALL_STATE(2715)] = 100528,
  [SMALL_STATE(2716)] = 100541,
  [SMALL_STATE(2717)] = 100550,
  [SMALL_STATE(2718)] = 100559,
  [SMALL_STATE(2719)] = 100568,
  [SMALL_STATE(2720)] = 100581,
  [SMALL_STATE(2721)] = 100590,
  [SMALL_STATE(2722)] = 100603,
  [SMALL_STATE(2723)] = 100612,
  [SMALL_STATE(2724)] = 100621,
  [SMALL_STATE(2725)] = 100630,
  [SMALL_STATE(2726)] = 100639,
  [SMALL_STATE(2727)] = 100648,
  [SMALL_STATE(2728)] = 100661,
  [SMALL_STATE(2729)] = 100670,
  [SMALL_STATE(2730)] = 100679,
  [SMALL_STATE(2731)] = 100688,
  [SMALL_STATE(2732)] = 100701,
  [SMALL_STATE(2733)] = 100714,
  [SMALL_STATE(2734)] = 100727,
  [SMALL_STATE(2735)] = 100740,
  [SMALL_STATE(2736)] = 100753,
  [SMALL_STATE(2737)] = 100766,
  [SMALL_STATE(2738)] = 100779,
  [SMALL_STATE(2739)] = 100792,
  [SMALL_STATE(2740)] = 100805,
  [SMALL_STATE(2741)] = 100818,
  [SMALL_STATE(2742)] = 100827,
  [SMALL_STATE(2743)] = 100840,
  [SMALL_STATE(2744)] = 100849,
  [SMALL_STATE(2745)] = 100860,
  [SMALL_STATE(2746)] = 100873,
  [SMALL_STATE(2747)] = 100886,
  [SMALL_STATE(2748)] = 100899,
  [SMALL_STATE(2749)] = 100910,
  [SMALL_STATE(2750)] = 100923,
  [SMALL_STATE(2751)] = 100936,
  [SMALL_STATE(2752)] = 100949,
  [SMALL_STATE(2753)] = 100962,
  [SMALL_STATE(2754)] = 100971,
  [SMALL_STATE(2755)] = 100984,
  [SMALL_STATE(2756)] = 100993,
  [SMALL_STATE(2757)] = 101004,
  [SMALL_STATE(2758)] = 101017,
  [SMALL_STATE(2759)] = 101026,
  [SMALL_STATE(2760)] = 101039,
  [SMALL_STATE(2761)] = 101052,
  [SMALL_STATE(2762)] = 101065,
  [SMALL_STATE(2763)] = 101078,
  [SMALL_STATE(2764)] = 101087,
  [SMALL_STATE(2765)] = 101100,
  [SMALL_STATE(2766)] = 101111,
  [SMALL_STATE(2767)] = 101120,
  [SMALL_STATE(2768)] = 101130,
  [SMALL_STATE(2769)] = 101140,
  [SMALL_STATE(2770)] = 101150,
  [SMALL_STATE(2771)] = 101158,
  [SMALL_STATE(2772)] = 101168,
  [SMALL_STATE(2773)] = 101178,
  [SMALL_STATE(2774)] = 101186,
  [SMALL_STATE(2775)] = 101196,
  [SMALL_STATE(2776)] = 101206,
  [SMALL_STATE(2777)] = 101214,
  [SMALL_STATE(2778)] = 101224,
  [SMALL_STATE(2779)] = 101234,
  [SMALL_STATE(2780)] = 101242,
  [SMALL_STATE(2781)] = 101250,
  [SMALL_STATE(2782)] = 101260,
  [SMALL_STATE(2783)] = 101268,
  [SMALL_STATE(2784)] = 101278,
  [SMALL_STATE(2785)] = 101288,
  [SMALL_STATE(2786)] = 101298,
  [SMALL_STATE(2787)] = 101306,
  [SMALL_STATE(2788)] = 101316,
  [SMALL_STATE(2789)] = 101326,
  [SMALL_STATE(2790)] = 101336,
  [SMALL_STATE(2791)] = 101346,
  [SMALL_STATE(2792)] = 101356,
  [SMALL_STATE(2793)] = 101364,
  [SMALL_STATE(2794)] = 101374,
  [SMALL_STATE(2795)] = 101384,
  [SMALL_STATE(2796)] = 101392,
  [SMALL_STATE(2797)] = 101402,
  [SMALL_STATE(2798)] = 101410,
  [SMALL_STATE(2799)] = 101420,
  [SMALL_STATE(2800)] = 101430,
  [SMALL_STATE(2801)] = 101440,
  [SMALL_STATE(2802)] = 101450,
  [SMALL_STATE(2803)] = 101460,
  [SMALL_STATE(2804)] = 101470,
  [SMALL_STATE(2805)] = 101480,
  [SMALL_STATE(2806)] = 101490,
  [SMALL_STATE(2807)] = 101498,
  [SMALL_STATE(2808)] = 101508,
  [SMALL_STATE(2809)] = 101518,
  [SMALL_STATE(2810)] = 101528,
  [SMALL_STATE(2811)] = 101536,
  [SMALL_STATE(2812)] = 101546,
  [SMALL_STATE(2813)] = 101556,
  [SMALL_STATE(2814)] = 101564,
  [SMALL_STATE(2815)] = 101574,
  [SMALL_STATE(2816)] = 101584,
  [SMALL_STATE(2817)] = 101594,
  [SMALL_STATE(2818)] = 101604,
  [SMALL_STATE(2819)] = 101614,
  [SMALL_STATE(2820)] = 101624,
  [SMALL_STATE(2821)] = 101634,
  [SMALL_STATE(2822)] = 101642,
  [SMALL_STATE(2823)] = 101652,
  [SMALL_STATE(2824)] = 101660,
  [SMALL_STATE(2825)] = 101668,
  [SMALL_STATE(2826)] = 101678,
  [SMALL_STATE(2827)] = 101688,
  [SMALL_STATE(2828)] = 101698,
  [SMALL_STATE(2829)] = 101708,
  [SMALL_STATE(2830)] = 101718,
  [SMALL_STATE(2831)] = 101726,
  [SMALL_STATE(2832)] = 101736,
  [SMALL_STATE(2833)] = 101744,
  [SMALL_STATE(2834)] = 101752,
  [SMALL_STATE(2835)] = 101760,
  [SMALL_STATE(2836)] = 101770,
  [SMALL_STATE(2837)] = 101780,
  [SMALL_STATE(2838)] = 101790,
  [SMALL_STATE(2839)] = 101798,
  [SMALL_STATE(2840)] = 101808,
  [SMALL_STATE(2841)] = 101818,
  [SMALL_STATE(2842)] = 101828,
  [SMALL_STATE(2843)] = 101838,
  [SMALL_STATE(2844)] = 101846,
  [SMALL_STATE(2845)] = 101856,
  [SMALL_STATE(2846)] = 101866,
  [SMALL_STATE(2847)] = 101876,
  [SMALL_STATE(2848)] = 101886,
  [SMALL_STATE(2849)] = 101896,
  [SMALL_STATE(2850)] = 101906,
  [SMALL_STATE(2851)] = 101916,
  [SMALL_STATE(2852)] = 101926,
  [SMALL_STATE(2853)] = 101936,
  [SMALL_STATE(2854)] = 101946,
  [SMALL_STATE(2855)] = 101956,
  [SMALL_STATE(2856)] = 101966,
  [SMALL_STATE(2857)] = 101976,
  [SMALL_STATE(2858)] = 101986,
  [SMALL_STATE(2859)] = 101996,
  [SMALL_STATE(2860)] = 102006,
  [SMALL_STATE(2861)] = 102016,
  [SMALL_STATE(2862)] = 102024,
  [SMALL_STATE(2863)] = 102034,
  [SMALL_STATE(2864)] = 102042,
  [SMALL_STATE(2865)] = 102052,
  [SMALL_STATE(2866)] = 102060,
  [SMALL_STATE(2867)] = 102070,
  [SMALL_STATE(2868)] = 102080,
  [SMALL_STATE(2869)] = 102090,
  [SMALL_STATE(2870)] = 102100,
  [SMALL_STATE(2871)] = 102110,
  [SMALL_STATE(2872)] = 102120,
  [SMALL_STATE(2873)] = 102130,
  [SMALL_STATE(2874)] = 102138,
  [SMALL_STATE(2875)] = 102148,
  [SMALL_STATE(2876)] = 102158,
  [SMALL_STATE(2877)] = 102168,
  [SMALL_STATE(2878)] = 102178,
  [SMALL_STATE(2879)] = 102186,
  [SMALL_STATE(2880)] = 102196,
  [SMALL_STATE(2881)] = 102206,
  [SMALL_STATE(2882)] = 102216,
  [SMALL_STATE(2883)] = 102226,
  [SMALL_STATE(2884)] = 102234,
  [SMALL_STATE(2885)] = 102244,
  [SMALL_STATE(2886)] = 102254,
  [SMALL_STATE(2887)] = 102262,
  [SMALL_STATE(2888)] = 102272,
  [SMALL_STATE(2889)] = 102282,
  [SMALL_STATE(2890)] = 102292,
  [SMALL_STATE(2891)] = 102302,
  [SMALL_STATE(2892)] = 102312,
  [SMALL_STATE(2893)] = 102322,
  [SMALL_STATE(2894)] = 102332,
  [SMALL_STATE(2895)] = 102342,
  [SMALL_STATE(2896)] = 102352,
  [SMALL_STATE(2897)] = 102360,
  [SMALL_STATE(2898)] = 102370,
  [SMALL_STATE(2899)] = 102380,
  [SMALL_STATE(2900)] = 102390,
  [SMALL_STATE(2901)] = 102398,
  [SMALL_STATE(2902)] = 102408,
  [SMALL_STATE(2903)] = 102416,
  [SMALL_STATE(2904)] = 102426,
  [SMALL_STATE(2905)] = 102436,
  [SMALL_STATE(2906)] = 102446,
  [SMALL_STATE(2907)] = 102456,
  [SMALL_STATE(2908)] = 102466,
  [SMALL_STATE(2909)] = 102476,
  [SMALL_STATE(2910)] = 102486,
  [SMALL_STATE(2911)] = 102496,
  [SMALL_STATE(2912)] = 102506,
  [SMALL_STATE(2913)] = 102516,
  [SMALL_STATE(2914)] = 102526,
  [SMALL_STATE(2915)] = 102536,
  [SMALL_STATE(2916)] = 102546,
  [SMALL_STATE(2917)] = 102556,
  [SMALL_STATE(2918)] = 102566,
  [SMALL_STATE(2919)] = 102576,
  [SMALL_STATE(2920)] = 102586,
  [SMALL_STATE(2921)] = 102594,
  [SMALL_STATE(2922)] = 102604,
  [SMALL_STATE(2923)] = 102612,
  [SMALL_STATE(2924)] = 102622,
  [SMALL_STATE(2925)] = 102632,
  [SMALL_STATE(2926)] = 102642,
  [SMALL_STATE(2927)] = 102652,
  [SMALL_STATE(2928)] = 102662,
  [SMALL_STATE(2929)] = 102670,
  [SMALL_STATE(2930)] = 102680,
  [SMALL_STATE(2931)] = 102688,
  [SMALL_STATE(2932)] = 102698,
  [SMALL_STATE(2933)] = 102708,
  [SMALL_STATE(2934)] = 102716,
  [SMALL_STATE(2935)] = 102726,
  [SMALL_STATE(2936)] = 102734,
  [SMALL_STATE(2937)] = 102744,
  [SMALL_STATE(2938)] = 102752,
  [SMALL_STATE(2939)] = 102762,
  [SMALL_STATE(2940)] = 102772,
  [SMALL_STATE(2941)] = 102782,
  [SMALL_STATE(2942)] = 102792,
  [SMALL_STATE(2943)] = 102802,
  [SMALL_STATE(2944)] = 102812,
  [SMALL_STATE(2945)] = 102820,
  [SMALL_STATE(2946)] = 102830,
  [SMALL_STATE(2947)] = 102838,
  [SMALL_STATE(2948)] = 102848,
  [SMALL_STATE(2949)] = 102858,
  [SMALL_STATE(2950)] = 102868,
  [SMALL_STATE(2951)] = 102878,
  [SMALL_STATE(2952)] = 102888,
  [SMALL_STATE(2953)] = 102898,
  [SMALL_STATE(2954)] = 102906,
  [SMALL_STATE(2955)] = 102916,
  [SMALL_STATE(2956)] = 102926,
  [SMALL_STATE(2957)] = 102936,
  [SMALL_STATE(2958)] = 102946,
  [SMALL_STATE(2959)] = 102954,
  [SMALL_STATE(2960)] = 102964,
  [SMALL_STATE(2961)] = 102974,
  [SMALL_STATE(2962)] = 102982,
  [SMALL_STATE(2963)] = 102990,
  [SMALL_STATE(2964)] = 102998,
  [SMALL_STATE(2965)] = 103006,
  [SMALL_STATE(2966)] = 103016,
  [SMALL_STATE(2967)] = 103024,
  [SMALL_STATE(2968)] = 103034,
  [SMALL_STATE(2969)] = 103044,
  [SMALL_STATE(2970)] = 103054,
  [SMALL_STATE(2971)] = 103064,
  [SMALL_STATE(2972)] = 103072,
  [SMALL_STATE(2973)] = 103082,
  [SMALL_STATE(2974)] = 103092,
  [SMALL_STATE(2975)] = 103102,
  [SMALL_STATE(2976)] = 103112,
  [SMALL_STATE(2977)] = 103122,
  [SMALL_STATE(2978)] = 103132,
  [SMALL_STATE(2979)] = 103142,
  [SMALL_STATE(2980)] = 103150,
  [SMALL_STATE(2981)] = 103160,
  [SMALL_STATE(2982)] = 103170,
  [SMALL_STATE(2983)] = 103180,
  [SMALL_STATE(2984)] = 103190,
  [SMALL_STATE(2985)] = 103200,
  [SMALL_STATE(2986)] = 103210,
  [SMALL_STATE(2987)] = 103220,
  [SMALL_STATE(2988)] = 103227,
  [SMALL_STATE(2989)] = 103234,
  [SMALL_STATE(2990)] = 103241,
  [SMALL_STATE(2991)] = 103248,
  [SMALL_STATE(2992)] = 103255,
  [SMALL_STATE(2993)] = 103262,
  [SMALL_STATE(2994)] = 103269,
  [SMALL_STATE(2995)] = 103276,
  [SMALL_STATE(2996)] = 103283,
  [SMALL_STATE(2997)] = 103290,
  [SMALL_STATE(2998)] = 103297,
  [SMALL_STATE(2999)] = 103304,
  [SMALL_STATE(3000)] = 103311,
  [SMALL_STATE(3001)] = 103318,
  [SMALL_STATE(3002)] = 103325,
  [SMALL_STATE(3003)] = 103332,
  [SMALL_STATE(3004)] = 103339,
  [SMALL_STATE(3005)] = 103346,
  [SMALL_STATE(3006)] = 103353,
  [SMALL_STATE(3007)] = 103360,
  [SMALL_STATE(3008)] = 103367,
  [SMALL_STATE(3009)] = 103374,
  [SMALL_STATE(3010)] = 103381,
  [SMALL_STATE(3011)] = 103388,
  [SMALL_STATE(3012)] = 103395,
  [SMALL_STATE(3013)] = 103402,
  [SMALL_STATE(3014)] = 103409,
  [SMALL_STATE(3015)] = 103416,
  [SMALL_STATE(3016)] = 103423,
  [SMALL_STATE(3017)] = 103430,
  [SMALL_STATE(3018)] = 103437,
  [SMALL_STATE(3019)] = 103444,
  [SMALL_STATE(3020)] = 103451,
  [SMALL_STATE(3021)] = 103458,
  [SMALL_STATE(3022)] = 103465,
  [SMALL_STATE(3023)] = 103472,
  [SMALL_STATE(3024)] = 103479,
  [SMALL_STATE(3025)] = 103486,
  [SMALL_STATE(3026)] = 103493,
  [SMALL_STATE(3027)] = 103500,
  [SMALL_STATE(3028)] = 103507,
  [SMALL_STATE(3029)] = 103514,
  [SMALL_STATE(3030)] = 103521,
  [SMALL_STATE(3031)] = 103528,
  [SMALL_STATE(3032)] = 103535,
  [SMALL_STATE(3033)] = 103542,
  [SMALL_STATE(3034)] = 103549,
  [SMALL_STATE(3035)] = 103556,
  [SMALL_STATE(3036)] = 103563,
  [SMALL_STATE(3037)] = 103570,
  [SMALL_STATE(3038)] = 103577,
  [SMALL_STATE(3039)] = 103584,
  [SMALL_STATE(3040)] = 103591,
  [SMALL_STATE(3041)] = 103598,
  [SMALL_STATE(3042)] = 103605,
  [SMALL_STATE(3043)] = 103612,
  [SMALL_STATE(3044)] = 103619,
  [SMALL_STATE(3045)] = 103626,
  [SMALL_STATE(3046)] = 103633,
  [SMALL_STATE(3047)] = 103640,
  [SMALL_STATE(3048)] = 103647,
  [SMALL_STATE(3049)] = 103654,
  [SMALL_STATE(3050)] = 103661,
  [SMALL_STATE(3051)] = 103668,
  [SMALL_STATE(3052)] = 103675,
  [SMALL_STATE(3053)] = 103682,
  [SMALL_STATE(3054)] = 103689,
  [SMALL_STATE(3055)] = 103696,
  [SMALL_STATE(3056)] = 103703,
  [SMALL_STATE(3057)] = 103710,
  [SMALL_STATE(3058)] = 103717,
  [SMALL_STATE(3059)] = 103724,
  [SMALL_STATE(3060)] = 103731,
  [SMALL_STATE(3061)] = 103738,
  [SMALL_STATE(3062)] = 103745,
  [SMALL_STATE(3063)] = 103752,
  [SMALL_STATE(3064)] = 103759,
  [SMALL_STATE(3065)] = 103766,
  [SMALL_STATE(3066)] = 103773,
  [SMALL_STATE(3067)] = 103780,
  [SMALL_STATE(3068)] = 103787,
  [SMALL_STATE(3069)] = 103794,
  [SMALL_STATE(3070)] = 103801,
  [SMALL_STATE(3071)] = 103808,
  [SMALL_STATE(3072)] = 103815,
  [SMALL_STATE(3073)] = 103822,
  [SMALL_STATE(3074)] = 103829,
  [SMALL_STATE(3075)] = 103836,
  [SMALL_STATE(3076)] = 103843,
  [SMALL_STATE(3077)] = 103850,
  [SMALL_STATE(3078)] = 103857,
  [SMALL_STATE(3079)] = 103864,
  [SMALL_STATE(3080)] = 103871,
  [SMALL_STATE(3081)] = 103878,
  [SMALL_STATE(3082)] = 103885,
  [SMALL_STATE(3083)] = 103892,
  [SMALL_STATE(3084)] = 103899,
  [SMALL_STATE(3085)] = 103906,
  [SMALL_STATE(3086)] = 103913,
  [SMALL_STATE(3087)] = 103920,
  [SMALL_STATE(3088)] = 103927,
  [SMALL_STATE(3089)] = 103934,
  [SMALL_STATE(3090)] = 103941,
  [SMALL_STATE(3091)] = 103948,
  [SMALL_STATE(3092)] = 103955,
  [SMALL_STATE(3093)] = 103962,
  [SMALL_STATE(3094)] = 103969,
  [SMALL_STATE(3095)] = 103976,
  [SMALL_STATE(3096)] = 103983,
  [SMALL_STATE(3097)] = 103990,
  [SMALL_STATE(3098)] = 103997,
  [SMALL_STATE(3099)] = 104004,
  [SMALL_STATE(3100)] = 104011,
  [SMALL_STATE(3101)] = 104018,
  [SMALL_STATE(3102)] = 104025,
  [SMALL_STATE(3103)] = 104032,
  [SMALL_STATE(3104)] = 104039,
  [SMALL_STATE(3105)] = 104046,
  [SMALL_STATE(3106)] = 104053,
  [SMALL_STATE(3107)] = 104060,
  [SMALL_STATE(3108)] = 104067,
  [SMALL_STATE(3109)] = 104074,
  [SMALL_STATE(3110)] = 104081,
  [SMALL_STATE(3111)] = 104088,
  [SMALL_STATE(3112)] = 104095,
  [SMALL_STATE(3113)] = 104102,
  [SMALL_STATE(3114)] = 104109,
  [SMALL_STATE(3115)] = 104116,
  [SMALL_STATE(3116)] = 104123,
  [SMALL_STATE(3117)] = 104130,
  [SMALL_STATE(3118)] = 104137,
  [SMALL_STATE(3119)] = 104144,
  [SMALL_STATE(3120)] = 104151,
  [SMALL_STATE(3121)] = 104158,
  [SMALL_STATE(3122)] = 104165,
  [SMALL_STATE(3123)] = 104172,
  [SMALL_STATE(3124)] = 104179,
  [SMALL_STATE(3125)] = 104186,
  [SMALL_STATE(3126)] = 104193,
  [SMALL_STATE(3127)] = 104200,
  [SMALL_STATE(3128)] = 104207,
  [SMALL_STATE(3129)] = 104214,
  [SMALL_STATE(3130)] = 104221,
  [SMALL_STATE(3131)] = 104228,
  [SMALL_STATE(3132)] = 104235,
  [SMALL_STATE(3133)] = 104242,
  [SMALL_STATE(3134)] = 104249,
  [SMALL_STATE(3135)] = 104256,
  [SMALL_STATE(3136)] = 104263,
  [SMALL_STATE(3137)] = 104270,
  [SMALL_STATE(3138)] = 104277,
  [SMALL_STATE(3139)] = 104284,
  [SMALL_STATE(3140)] = 104291,
  [SMALL_STATE(3141)] = 104298,
  [SMALL_STATE(3142)] = 104305,
  [SMALL_STATE(3143)] = 104312,
  [SMALL_STATE(3144)] = 104319,
  [SMALL_STATE(3145)] = 104326,
  [SMALL_STATE(3146)] = 104333,
  [SMALL_STATE(3147)] = 104340,
  [SMALL_STATE(3148)] = 104347,
  [SMALL_STATE(3149)] = 104354,
  [SMALL_STATE(3150)] = 104361,
  [SMALL_STATE(3151)] = 104368,
  [SMALL_STATE(3152)] = 104375,
  [SMALL_STATE(3153)] = 104382,
  [SMALL_STATE(3154)] = 104389,
  [SMALL_STATE(3155)] = 104396,
  [SMALL_STATE(3156)] = 104403,
  [SMALL_STATE(3157)] = 104410,
  [SMALL_STATE(3158)] = 104417,
  [SMALL_STATE(3159)] = 104424,
  [SMALL_STATE(3160)] = 104431,
  [SMALL_STATE(3161)] = 104438,
  [SMALL_STATE(3162)] = 104445,
  [SMALL_STATE(3163)] = 104452,
  [SMALL_STATE(3164)] = 104459,
  [SMALL_STATE(3165)] = 104466,
  [SMALL_STATE(3166)] = 104473,
  [SMALL_STATE(3167)] = 104480,
  [SMALL_STATE(3168)] = 104487,
  [SMALL_STATE(3169)] = 104494,
  [SMALL_STATE(3170)] = 104501,
  [SMALL_STATE(3171)] = 104508,
  [SMALL_STATE(3172)] = 104515,
  [SMALL_STATE(3173)] = 104522,
  [SMALL_STATE(3174)] = 104529,
  [SMALL_STATE(3175)] = 104536,
  [SMALL_STATE(3176)] = 104543,
  [SMALL_STATE(3177)] = 104550,
  [SMALL_STATE(3178)] = 104557,
  [SMALL_STATE(3179)] = 104564,
  [SMALL_STATE(3180)] = 104571,
  [SMALL_STATE(3181)] = 104578,
  [SMALL_STATE(3182)] = 104585,
  [SMALL_STATE(3183)] = 104592,
  [SMALL_STATE(3184)] = 104599,
  [SMALL_STATE(3185)] = 104606,
  [SMALL_STATE(3186)] = 104613,
  [SMALL_STATE(3187)] = 104620,
  [SMALL_STATE(3188)] = 104627,
  [SMALL_STATE(3189)] = 104634,
  [SMALL_STATE(3190)] = 104641,
  [SMALL_STATE(3191)] = 104648,
  [SMALL_STATE(3192)] = 104655,
  [SMALL_STATE(3193)] = 104662,
  [SMALL_STATE(3194)] = 104669,
  [SMALL_STATE(3195)] = 104676,
  [SMALL_STATE(3196)] = 104683,
  [SMALL_STATE(3197)] = 104690,
  [SMALL_STATE(3198)] = 104697,
  [SMALL_STATE(3199)] = 104704,
  [SMALL_STATE(3200)] = 104711,
  [SMALL_STATE(3201)] = 104718,
  [SMALL_STATE(3202)] = 104725,
  [SMALL_STATE(3203)] = 104732,
  [SMALL_STATE(3204)] = 104739,
  [SMALL_STATE(3205)] = 104746,
  [SMALL_STATE(3206)] = 104753,
  [SMALL_STATE(3207)] = 104760,
  [SMALL_STATE(3208)] = 104767,
  [SMALL_STATE(3209)] = 104774,
  [SMALL_STATE(3210)] = 104781,
  [SMALL_STATE(3211)] = 104788,
  [SMALL_STATE(3212)] = 104795,
  [SMALL_STATE(3213)] = 104802,
  [SMALL_STATE(3214)] = 104809,
  [SMALL_STATE(3215)] = 104816,
  [SMALL_STATE(3216)] = 104823,
  [SMALL_STATE(3217)] = 104830,
  [SMALL_STATE(3218)] = 104837,
  [SMALL_STATE(3219)] = 104844,
  [SMALL_STATE(3220)] = 104851,
  [SMALL_STATE(3221)] = 104858,
  [SMALL_STATE(3222)] = 104865,
  [SMALL_STATE(3223)] = 104872,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(859),
  [9] = {.count = 1, .reusable = true}, SHIFT(28),
  [11] = {.count = 1, .reusable = false}, SHIFT(303),
  [13] = {.count = 1, .reusable = false}, SHIFT(644),
  [15] = {.count = 1, .reusable = true}, SHIFT(4),
  [17] = {.count = 1, .reusable = false}, SHIFT(734),
  [19] = {.count = 1, .reusable = false}, SHIFT(280),
  [21] = {.count = 1, .reusable = false}, SHIFT(928),
  [23] = {.count = 1, .reusable = false}, SHIFT(2134),
  [25] = {.count = 1, .reusable = false}, SHIFT(2211),
  [27] = {.count = 1, .reusable = false}, SHIFT(2111),
  [29] = {.count = 1, .reusable = false}, SHIFT(2772),
  [31] = {.count = 1, .reusable = false}, SHIFT(2777),
  [33] = {.count = 1, .reusable = false}, SHIFT(2764),
  [35] = {.count = 1, .reusable = true}, SHIFT(145),
  [37] = {.count = 1, .reusable = false}, SHIFT(287),
  [39] = {.count = 1, .reusable = false}, SHIFT(2784),
  [41] = {.count = 1, .reusable = false}, SHIFT(37),
  [43] = {.count = 1, .reusable = false}, SHIFT(2785),
  [45] = {.count = 1, .reusable = false}, SHIFT(2788),
  [47] = {.count = 1, .reusable = false}, SHIFT(2756),
  [49] = {.count = 1, .reusable = false}, SHIFT(2748),
  [51] = {.count = 1, .reusable = false}, SHIFT(2806),
  [53] = {.count = 1, .reusable = false}, SHIFT(168),
  [55] = {.count = 1, .reusable = false}, SHIFT(193),
  [57] = {.count = 1, .reusable = true}, SHIFT(528),
  [59] = {.count = 1, .reusable = false}, SHIFT(101),
  [61] = {.count = 1, .reusable = true}, SHIFT(152),
  [63] = {.count = 1, .reusable = true}, SHIFT(2176),
  [65] = {.count = 1, .reusable = false}, SHIFT(3184),
  [67] = {.count = 1, .reusable = false}, SHIFT(1957),
  [69] = {.count = 1, .reusable = false}, SHIFT(496),
  [71] = {.count = 1, .reusable = false}, SHIFT(2064),
  [73] = {.count = 1, .reusable = false}, SHIFT(216),
  [75] = {.count = 1, .reusable = false}, SHIFT(308),
  [77] = {.count = 1, .reusable = true}, SHIFT(310),
  [79] = {.count = 1, .reusable = false}, SHIFT(66),
  [81] = {.count = 1, .reusable = true}, SHIFT(312),
  [83] = {.count = 1, .reusable = true}, SHIFT(2545),
  [85] = {.count = 1, .reusable = true}, SHIFT(2544),
  [87] = {.count = 1, .reusable = true}, SHIFT(2167),
  [89] = {.count = 1, .reusable = true}, SHIFT(1270),
  [91] = {.count = 1, .reusable = false}, SHIFT(1270),
  [93] = {.count = 1, .reusable = false}, SHIFT(1148),
  [95] = {.count = 1, .reusable = true}, SHIFT(1868),
  [97] = {.count = 1, .reusable = false}, SHIFT(820),
  [99] = {.count = 1, .reusable = false}, SHIFT(3174),
  [101] = {.count = 1, .reusable = false}, SHIFT(424),
  [103] = {.count = 1, .reusable = false}, SHIFT(649),
  [105] = {.count = 1, .reusable = false}, SHIFT(3173),
  [107] = {.count = 1, .reusable = false}, SHIFT(3172),
  [109] = {.count = 1, .reusable = false}, SHIFT(691),
  [111] = {.count = 1, .reusable = false}, SHIFT(176),
  [113] = {.count = 1, .reusable = true}, SHIFT(1864),
  [115] = {.count = 1, .reusable = false}, SHIFT(633),
  [117] = {.count = 1, .reusable = true}, SHIFT(1310),
  [119] = {.count = 1, .reusable = true}, SHIFT(1397),
  [121] = {.count = 1, .reusable = false}, SHIFT(672),
  [123] = {.count = 1, .reusable = true}, SHIFT(148),
  [125] = {.count = 1, .reusable = false}, SHIFT(430),
  [127] = {.count = 1, .reusable = true}, SHIFT(378),
  [129] = {.count = 1, .reusable = false}, SHIFT(60),
  [131] = {.count = 1, .reusable = true}, SHIFT(1549),
  [133] = {.count = 1, .reusable = false}, SHIFT(457),
  [135] = {.count = 1, .reusable = false}, SHIFT(458),
  [137] = {.count = 1, .reusable = false}, SHIFT(382),
  [139] = {.count = 1, .reusable = false}, SHIFT(493),
  [141] = {.count = 1, .reusable = false}, SHIFT(634),
  [143] = {.count = 1, .reusable = false}, SHIFT(684),
  [145] = {.count = 1, .reusable = false}, SHIFT(463),
  [147] = {.count = 1, .reusable = true}, SHIFT(1290),
  [149] = {.count = 1, .reusable = true}, SHIFT(115),
  [151] = {.count = 1, .reusable = false}, SHIFT(688),
  [153] = {.count = 1, .reusable = false}, SHIFT(173),
  [155] = {.count = 1, .reusable = false}, SHIFT(632),
  [157] = {.count = 1, .reusable = true}, SHIFT(1379),
  [159] = {.count = 1, .reusable = false}, SHIFT(679),
  [161] = {.count = 1, .reusable = false}, SHIFT(428),
  [163] = {.count = 1, .reusable = false}, SHIFT(57),
  [165] = {.count = 1, .reusable = false}, SHIFT(461),
  [167] = {.count = 1, .reusable = false}, SHIFT(464),
  [169] = {.count = 1, .reusable = false}, SHIFT(387),
  [171] = {.count = 1, .reusable = false}, SHIFT(477),
  [173] = {.count = 1, .reusable = false}, SHIFT(636),
  [175] = {.count = 1, .reusable = false}, SHIFT(689),
  [177] = {.count = 1, .reusable = false}, SHIFT(459),
  [179] = {.count = 1, .reusable = false}, SHIFT(692),
  [181] = {.count = 1, .reusable = false}, SHIFT(174),
  [183] = {.count = 1, .reusable = false}, SHIFT(631),
  [185] = {.count = 1, .reusable = true}, SHIFT(966),
  [187] = {.count = 1, .reusable = false}, SHIFT(668),
  [189] = {.count = 1, .reusable = false}, SHIFT(426),
  [191] = {.count = 1, .reusable = false}, SHIFT(59),
  [193] = {.count = 1, .reusable = false}, SHIFT(460),
  [195] = {.count = 1, .reusable = false}, SHIFT(456),
  [197] = {.count = 1, .reusable = false}, SHIFT(399),
  [199] = {.count = 1, .reusable = false}, SHIFT(485),
  [201] = {.count = 1, .reusable = false}, SHIFT(635),
  [203] = {.count = 1, .reusable = false}, SHIFT(687),
  [205] = {.count = 1, .reusable = false}, SHIFT(462),
  [207] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [209] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(859),
  [212] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(303),
  [215] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [217] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(644),
  [220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(734),
  [226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(280),
  [229] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(928),
  [232] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2134),
  [235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2211),
  [238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2111),
  [241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2772),
  [244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2777),
  [247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2764),
  [250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(145),
  [253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(287),
  [256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2784),
  [259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2785),
  [265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2788),
  [268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2756),
  [271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2748),
  [274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2806),
  [277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(168),
  [280] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(193),
  [283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(528),
  [286] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(101),
  [289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(152),
  [292] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2176),
  [295] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3184),
  [298] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1957),
  [301] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(496),
  [304] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2064),
  [307] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(216),
  [310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(308),
  [313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(310),
  [316] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(66),
  [319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(312),
  [322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2545),
  [325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2544),
  [328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2167),
  [331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1270),
  [334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1270),
  [337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1148),
  [340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1868),
  [343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(820),
  [346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3174),
  [349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(424),
  [352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(649),
  [355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3173),
  [358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3172),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [365] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [369] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [373] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [377] = {.count = 1, .reusable = true}, SHIFT(137),
  [379] = {.count = 1, .reusable = true}, SHIFT(470),
  [381] = {.count = 1, .reusable = true}, SHIFT(471),
  [383] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [385] = {.count = 1, .reusable = true}, SHIFT(1222),
  [387] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [389] = {.count = 1, .reusable = true}, SHIFT(1494),
  [391] = {.count = 1, .reusable = true}, SHIFT(1793),
  [393] = {.count = 1, .reusable = true}, SHIFT(1466),
  [395] = {.count = 1, .reusable = true}, SHIFT(482),
  [397] = {.count = 1, .reusable = true}, SHIFT(475),
  [399] = {.count = 1, .reusable = true}, SHIFT(1801),
  [401] = {.count = 1, .reusable = true}, SHIFT(1013),
  [403] = {.count = 1, .reusable = true}, SHIFT(984),
  [405] = {.count = 1, .reusable = true}, SHIFT(1226),
  [407] = {.count = 1, .reusable = true}, SHIFT(120),
  [409] = {.count = 1, .reusable = false}, SHIFT(770),
  [411] = {.count = 1, .reusable = false}, SHIFT(314),
  [413] = {.count = 1, .reusable = false}, SHIFT(643),
  [415] = {.count = 1, .reusable = true}, SHIFT(3),
  [417] = {.count = 1, .reusable = false}, SHIFT(730),
  [419] = {.count = 1, .reusable = false}, SHIFT(2771),
  [421] = {.count = 1, .reusable = false}, SHIFT(2747),
  [423] = {.count = 1, .reusable = false}, SHIFT(2815),
  [425] = {.count = 1, .reusable = false}, SHIFT(2814),
  [427] = {.count = 1, .reusable = false}, SHIFT(1968),
  [429] = {.count = 1, .reusable = false}, SHIFT(502),
  [431] = {.count = 1, .reusable = false}, SHIFT(2108),
  [433] = {.count = 1, .reusable = false}, SHIFT(68),
  [435] = {.count = 1, .reusable = false}, SHIFT(764),
  [437] = {.count = 1, .reusable = false}, SHIFT(425),
  [439] = {.count = 1, .reusable = false}, SHIFT(645),
  [441] = {.count = 1, .reusable = false}, SHIFT(807),
  [443] = {.count = 1, .reusable = false}, SHIFT(406),
  [445] = {.count = 1, .reusable = false}, SHIFT(639),
  [447] = {.count = 1, .reusable = false}, SHIFT(698),
  [449] = {.count = 1, .reusable = false}, SHIFT(2800),
  [451] = {.count = 1, .reusable = false}, SHIFT(2745),
  [453] = {.count = 1, .reusable = false}, SHIFT(2804),
  [455] = {.count = 1, .reusable = false}, SHIFT(2805),
  [457] = {.count = 1, .reusable = false}, SHIFT(508),
  [459] = {.count = 1, .reusable = false}, SHIFT(67),
  [461] = {.count = 1, .reusable = false}, SHIFT(803),
  [463] = {.count = 1, .reusable = false}, SHIFT(423),
  [465] = {.count = 1, .reusable = false}, SHIFT(646),
  [467] = {.count = 1, .reusable = false}, SHIFT(819),
  [469] = {.count = 1, .reusable = false}, SHIFT(796),
  [471] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [473] = {.count = 1, .reusable = false}, SHIFT(313),
  [475] = {.count = 1, .reusable = false}, SHIFT(641),
  [477] = {.count = 1, .reusable = true}, SHIFT(1271),
  [479] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [481] = {.count = 1, .reusable = true}, SHIFT(1464),
  [483] = {.count = 1, .reusable = false}, SHIFT(1528),
  [485] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(44),
  [488] = {.count = 1, .reusable = false}, SHIFT(2176),
  [490] = {.count = 1, .reusable = false}, SHIFT(3134),
  [492] = {.count = 1, .reusable = false}, SHIFT(1943),
  [494] = {.count = 1, .reusable = false}, SHIFT(504),
  [496] = {.count = 1, .reusable = false}, SHIFT(2103),
  [498] = {.count = 1, .reusable = true}, SHIFT(232),
  [500] = {.count = 1, .reusable = true}, SHIFT(365),
  [502] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [505] = {.count = 1, .reusable = false}, SHIFT(310),
  [507] = {.count = 1, .reusable = false}, SHIFT(65),
  [509] = {.count = 1, .reusable = true}, SHIFT(1122),
  [511] = {.count = 1, .reusable = false}, SHIFT(1122),
  [513] = {.count = 1, .reusable = false}, SHIFT(871),
  [515] = {.count = 1, .reusable = false}, SHIFT(873),
  [517] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [519] = {.count = 1, .reusable = false}, SHIFT(297),
  [521] = {.count = 1, .reusable = false}, SHIFT(662),
  [523] = {.count = 1, .reusable = true}, SHIFT(1228),
  [525] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [527] = {.count = 1, .reusable = false}, SHIFT(404),
  [529] = {.count = 1, .reusable = false}, SHIFT(1034),
  [531] = {.count = 1, .reusable = false}, SHIFT(281),
  [533] = {.count = 1, .reusable = false}, SHIFT(109),
  [535] = {.count = 1, .reusable = false}, SHIFT(3079),
  [537] = {.count = 1, .reusable = false}, SHIFT(1961),
  [539] = {.count = 1, .reusable = false}, SHIFT(534),
  [541] = {.count = 1, .reusable = false}, SHIFT(2094),
  [543] = {.count = 1, .reusable = true}, SHIFT(251),
  [545] = {.count = 1, .reusable = false}, SHIFT(211),
  [547] = {.count = 1, .reusable = true}, SHIFT(298),
  [549] = {.count = 1, .reusable = true}, SHIFT(323),
  [551] = {.count = 1, .reusable = false}, SHIFT(73),
  [553] = {.count = 1, .reusable = true}, SHIFT(2489),
  [555] = {.count = 1, .reusable = true}, SHIFT(2509),
  [557] = {.count = 1, .reusable = true}, SHIFT(1245),
  [559] = {.count = 1, .reusable = false}, SHIFT(1245),
  [561] = {.count = 1, .reusable = false}, SHIFT(959),
  [563] = {.count = 1, .reusable = true}, SHIFT(970),
  [565] = {.count = 1, .reusable = true}, SHIFT(1164),
  [567] = {.count = 1, .reusable = false}, SHIFT(733),
  [569] = {.count = 1, .reusable = false}, SHIFT(715),
  [571] = {.count = 1, .reusable = false}, SHIFT(279),
  [573] = {.count = 1, .reusable = false}, SHIFT(638),
  [575] = {.count = 1, .reusable = false}, SHIFT(394),
  [577] = {.count = 1, .reusable = true}, SHIFT(144),
  [579] = {.count = 1, .reusable = false}, SHIFT(395),
  [581] = {.count = 1, .reusable = false}, SHIFT(100),
  [583] = {.count = 1, .reusable = true}, SHIFT(147),
  [585] = {.count = 1, .reusable = false}, SHIFT(2138),
  [587] = {.count = 1, .reusable = false}, SHIFT(3110),
  [589] = {.count = 1, .reusable = false}, SHIFT(478),
  [591] = {.count = 1, .reusable = false}, SHIFT(188),
  [593] = {.count = 1, .reusable = true}, SHIFT(275),
  [595] = {.count = 1, .reusable = false}, SHIFT(362),
  [597] = {.count = 1, .reusable = false}, SHIFT(259),
  [599] = {.count = 1, .reusable = true}, SHIFT(259),
  [601] = {.count = 1, .reusable = false}, SHIFT(61),
  [603] = {.count = 1, .reusable = true}, SHIFT(274),
  [605] = {.count = 1, .reusable = true}, SHIFT(2149),
  [607] = {.count = 1, .reusable = true}, SHIFT(979),
  [609] = {.count = 1, .reusable = false}, SHIFT(979),
  [611] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [614] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [617] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [619] = {.count = 1, .reusable = false}, SHIFT(373),
  [621] = {.count = 1, .reusable = true}, SHIFT(44),
  [623] = {.count = 1, .reusable = true}, SHIFT(42),
  [625] = {.count = 1, .reusable = true}, SHIFT(54),
  [627] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(254),
  [630] = {.count = 1, .reusable = false}, SHIFT(254),
  [632] = {.count = 1, .reusable = true}, SHIFT(199),
  [634] = {.count = 1, .reusable = false}, SHIFT(325),
  [636] = {.count = 1, .reusable = false}, SHIFT(323),
  [638] = {.count = 1, .reusable = true}, SHIFT(322),
  [640] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(279),
  [643] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [646] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [648] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [651] = {.count = 1, .reusable = true}, SHIFT(221),
  [653] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [657] = {.count = 1, .reusable = true}, SHIFT(248),
  [659] = {.count = 1, .reusable = true}, SHIFT(2075),
  [661] = {.count = 1, .reusable = false}, SHIFT(907),
  [663] = {.count = 1, .reusable = false}, SHIFT(910),
  [665] = {.count = 1, .reusable = false}, SHIFT(379),
  [667] = {.count = 1, .reusable = false}, SHIFT(664),
  [669] = {.count = 1, .reusable = false}, SHIFT(392),
  [671] = {.count = 1, .reusable = false}, SHIFT(391),
  [673] = {.count = 1, .reusable = false}, SHIFT(111),
  [675] = {.count = 1, .reusable = false}, SHIFT(582),
  [677] = {.count = 1, .reusable = false}, SHIFT(201),
  [679] = {.count = 1, .reusable = true}, SHIFT(380),
  [681] = {.count = 1, .reusable = false}, SHIFT(375),
  [683] = {.count = 1, .reusable = false}, SHIFT(371),
  [685] = {.count = 1, .reusable = true}, SHIFT(371),
  [687] = {.count = 1, .reusable = false}, SHIFT(88),
  [689] = {.count = 1, .reusable = true}, SHIFT(369),
  [691] = {.count = 1, .reusable = true}, SHIFT(1326),
  [693] = {.count = 1, .reusable = false}, SHIFT(1326),
  [695] = {.count = 1, .reusable = false}, SHIFT(3027),
  [697] = {.count = 1, .reusable = true}, SHIFT(208),
  [699] = {.count = 1, .reusable = false}, SHIFT(884),
  [701] = {.count = 1, .reusable = false}, SHIFT(886),
  [703] = {.count = 1, .reusable = false}, SHIFT(327),
  [705] = {.count = 1, .reusable = false}, SHIFT(661),
  [707] = {.count = 1, .reusable = false}, SHIFT(1300),
  [709] = {.count = 1, .reusable = false}, SHIFT(398),
  [711] = {.count = 1, .reusable = false}, SHIFT(1679),
  [713] = {.count = 1, .reusable = true}, SHIFT(143),
  [715] = {.count = 1, .reusable = false}, SHIFT(397),
  [717] = {.count = 1, .reusable = false}, SHIFT(110),
  [719] = {.count = 1, .reusable = true}, SHIFT(159),
  [721] = {.count = 1, .reusable = false}, SHIFT(2178),
  [723] = {.count = 1, .reusable = false}, SHIFT(3054),
  [725] = {.count = 1, .reusable = false}, SHIFT(1969),
  [727] = {.count = 1, .reusable = false}, SHIFT(519),
  [729] = {.count = 1, .reusable = false}, SHIFT(2061),
  [731] = {.count = 1, .reusable = false}, SHIFT(194),
  [733] = {.count = 1, .reusable = true}, SHIFT(326),
  [735] = {.count = 1, .reusable = false}, SHIFT(320),
  [737] = {.count = 1, .reusable = false}, SHIFT(321),
  [739] = {.count = 1, .reusable = true}, SHIFT(321),
  [741] = {.count = 1, .reusable = false}, SHIFT(83),
  [743] = {.count = 1, .reusable = true}, SHIFT(324),
  [745] = {.count = 1, .reusable = true}, SHIFT(2522),
  [747] = {.count = 1, .reusable = true}, SHIFT(2525),
  [749] = {.count = 1, .reusable = true}, SHIFT(2150),
  [751] = {.count = 1, .reusable = true}, SHIFT(1248),
  [753] = {.count = 1, .reusable = false}, SHIFT(1248),
  [755] = {.count = 1, .reusable = false}, SHIFT(1282),
  [757] = {.count = 1, .reusable = false}, SHIFT(893),
  [759] = {.count = 1, .reusable = false}, SHIFT(867),
  [761] = {.count = 1, .reusable = false}, SHIFT(345),
  [763] = {.count = 1, .reusable = false}, SHIFT(659),
  [765] = {.count = 1, .reusable = false}, SHIFT(403),
  [767] = {.count = 1, .reusable = false}, SHIFT(402),
  [769] = {.count = 1, .reusable = false}, SHIFT(112),
  [771] = {.count = 1, .reusable = false}, SHIFT(3006),
  [773] = {.count = 1, .reusable = false}, SHIFT(518),
  [775] = {.count = 1, .reusable = false}, SHIFT(180),
  [777] = {.count = 1, .reusable = true}, SHIFT(317),
  [779] = {.count = 1, .reusable = false}, SHIFT(305),
  [781] = {.count = 1, .reusable = false}, SHIFT(304),
  [783] = {.count = 1, .reusable = true}, SHIFT(304),
  [785] = {.count = 1, .reusable = false}, SHIFT(85),
  [787] = {.count = 1, .reusable = true}, SHIFT(300),
  [789] = {.count = 1, .reusable = true}, SHIFT(1289),
  [791] = {.count = 1, .reusable = false}, SHIFT(1289),
  [793] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(207),
  [796] = {.count = 1, .reusable = false}, SHIFT(207),
  [798] = {.count = 1, .reusable = false}, SHIFT(713),
  [800] = {.count = 1, .reusable = false}, SHIFT(868),
  [802] = {.count = 1, .reusable = true}, SHIFT(441),
  [804] = {.count = 1, .reusable = false}, SHIFT(657),
  [806] = {.count = 1, .reusable = false}, SHIFT(658),
  [808] = {.count = 1, .reusable = false}, SHIFT(203),
  [810] = {.count = 1, .reusable = true}, SHIFT(93),
  [812] = {.count = 1, .reusable = true}, SHIFT(2645),
  [814] = {.count = 1, .reusable = true}, SHIFT(98),
  [816] = {.count = 1, .reusable = true}, SHIFT(2138),
  [818] = {.count = 1, .reusable = false}, SHIFT(512),
  [820] = {.count = 1, .reusable = false}, SHIFT(209),
  [822] = {.count = 1, .reusable = true}, SHIFT(3030),
  [824] = {.count = 1, .reusable = true}, SHIFT(1036),
  [826] = {.count = 1, .reusable = true}, SHIFT(777),
  [828] = {.count = 1, .reusable = true}, SHIFT(772),
  [830] = {.count = 1, .reusable = false}, SHIFT(420),
  [832] = {.count = 1, .reusable = false}, SHIFT(77),
  [834] = {.count = 1, .reusable = true}, SHIFT(1564),
  [836] = {.count = 1, .reusable = false}, SHIFT(1424),
  [838] = {.count = 1, .reusable = false}, SHIFT(1564),
  [840] = {.count = 1, .reusable = false}, SHIFT(1124),
  [842] = {.count = 1, .reusable = false}, SHIFT(616),
  [844] = {.count = 1, .reusable = false}, SHIFT(875),
  [846] = {.count = 1, .reusable = false}, SHIFT(515),
  [848] = {.count = 1, .reusable = false}, SHIFT(2583),
  [850] = {.count = 1, .reusable = true}, SHIFT(926),
  [852] = {.count = 1, .reusable = false}, SHIFT(1169),
  [854] = {.count = 1, .reusable = false}, SHIFT(1025),
  [856] = {.count = 1, .reusable = false}, SHIFT(863),
  [858] = {.count = 1, .reusable = false}, SHIFT(656),
  [860] = {.count = 1, .reusable = true}, SHIFT(149),
  [862] = {.count = 1, .reusable = false}, SHIFT(192),
  [864] = {.count = 1, .reusable = true}, SHIFT(1080),
  [866] = {.count = 1, .reusable = false}, SHIFT(386),
  [868] = {.count = 1, .reusable = false}, SHIFT(86),
  [870] = {.count = 1, .reusable = true}, SHIFT(1729),
  [872] = {.count = 1, .reusable = false}, SHIFT(1714),
  [874] = {.count = 1, .reusable = false}, SHIFT(1729),
  [876] = {.count = 1, .reusable = false}, SHIFT(1264),
  [878] = {.count = 1, .reusable = false}, SHIFT(914),
  [880] = {.count = 1, .reusable = true}, SHIFT(971),
  [882] = {.count = 1, .reusable = false}, SHIFT(1231),
  [884] = {.count = 1, .reusable = true}, SHIFT(2333),
  [886] = {.count = 1, .reusable = false}, SHIFT(1293),
  [888] = {.count = 1, .reusable = true}, SHIFT(1461),
  [890] = {.count = 1, .reusable = false}, SHIFT(1302),
  [892] = {.count = 1, .reusable = false}, SHIFT(282),
  [894] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [896] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [898] = {.count = 1, .reusable = true}, SHIFT(1006),
  [900] = {.count = 1, .reusable = false}, SHIFT(1006),
  [902] = {.count = 1, .reusable = false}, SHIFT(377),
  [904] = {.count = 1, .reusable = true}, SHIFT(1100),
  [906] = {.count = 1, .reusable = false}, SHIFT(1100),
  [908] = {.count = 1, .reusable = false}, SHIFT(683),
  [910] = {.count = 1, .reusable = false}, SHIFT(650),
  [912] = {.count = 1, .reusable = false}, SHIFT(242),
  [914] = {.count = 1, .reusable = false}, SHIFT(236),
  [916] = {.count = 1, .reusable = false}, SHIFT(336),
  [918] = {.count = 1, .reusable = false}, SHIFT(71),
  [920] = {.count = 1, .reusable = true}, SHIFT(1470),
  [922] = {.count = 1, .reusable = false}, SHIFT(1469),
  [924] = {.count = 1, .reusable = false}, SHIFT(1470),
  [926] = {.count = 1, .reusable = false}, SHIFT(1190),
  [928] = {.count = 1, .reusable = false}, SHIFT(765),
  [930] = {.count = 1, .reusable = false}, SHIFT(728),
  [932] = {.count = 1, .reusable = false}, SHIFT(654),
  [934] = {.count = 1, .reusable = false}, SHIFT(234),
  [936] = {.count = 1, .reusable = true}, SHIFT(92),
  [938] = {.count = 1, .reusable = true}, SHIFT(95),
  [940] = {.count = 1, .reusable = false}, SHIFT(235),
  [942] = {.count = 1, .reusable = false}, SHIFT(331),
  [944] = {.count = 1, .reusable = false}, SHIFT(80),
  [946] = {.count = 1, .reusable = true}, SHIFT(1575),
  [948] = {.count = 1, .reusable = false}, SHIFT(1662),
  [950] = {.count = 1, .reusable = false}, SHIFT(1575),
  [952] = {.count = 1, .reusable = false}, SHIFT(1362),
  [954] = {.count = 1, .reusable = false}, SHIFT(894),
  [956] = {.count = 1, .reusable = false}, SHIFT(667),
  [958] = {.count = 1, .reusable = false}, SHIFT(204),
  [960] = {.count = 1, .reusable = false}, SHIFT(316),
  [962] = {.count = 1, .reusable = false}, SHIFT(63),
  [964] = {.count = 1, .reusable = true}, SHIFT(1147),
  [966] = {.count = 1, .reusable = false}, SHIFT(1145),
  [968] = {.count = 1, .reusable = false}, SHIFT(1147),
  [970] = {.count = 1, .reusable = false}, SHIFT(990),
  [972] = {.count = 1, .reusable = false}, SHIFT(702),
  [974] = {.count = 1, .reusable = false}, SHIFT(675),
  [976] = {.count = 1, .reusable = true}, SHIFT(1935),
  [978] = {.count = 1, .reusable = false}, SHIFT(655),
  [980] = {.count = 1, .reusable = false}, SHIFT(198),
  [982] = {.count = 1, .reusable = true}, SHIFT(91),
  [984] = {.count = 1, .reusable = true}, SHIFT(96),
  [986] = {.count = 1, .reusable = false}, SHIFT(202),
  [988] = {.count = 1, .reusable = true}, SHIFT(1039),
  [990] = {.count = 1, .reusable = true}, SHIFT(748),
  [992] = {.count = 1, .reusable = true}, SHIFT(751),
  [994] = {.count = 1, .reusable = false}, SHIFT(385),
  [996] = {.count = 1, .reusable = false}, SHIFT(64),
  [998] = {.count = 1, .reusable = true}, SHIFT(1374),
  [1000] = {.count = 1, .reusable = false}, SHIFT(1375),
  [1002] = {.count = 1, .reusable = false}, SHIFT(1374),
  [1004] = {.count = 1, .reusable = false}, SHIFT(1349),
  [1006] = {.count = 1, .reusable = false}, SHIFT(709),
  [1008] = {.count = 1, .reusable = false}, SHIFT(2597),
  [1010] = {.count = 1, .reusable = true}, SHIFT(933),
  [1012] = {.count = 1, .reusable = false}, SHIFT(682),
  [1014] = {.count = 1, .reusable = false}, SHIFT(187),
  [1016] = {.count = 1, .reusable = false}, SHIFT(177),
  [1018] = {.count = 1, .reusable = false}, SHIFT(388),
  [1020] = {.count = 1, .reusable = false}, SHIFT(72),
  [1022] = {.count = 1, .reusable = true}, SHIFT(1495),
  [1024] = {.count = 1, .reusable = false}, SHIFT(1500),
  [1026] = {.count = 1, .reusable = false}, SHIFT(1495),
  [1028] = {.count = 1, .reusable = false}, SHIFT(1135),
  [1030] = {.count = 1, .reusable = false}, SHIFT(759),
  [1032] = {.count = 1, .reusable = false}, SHIFT(714),
  [1034] = {.count = 1, .reusable = false}, SHIFT(651),
  [1036] = {.count = 1, .reusable = false}, SHIFT(225),
  [1038] = {.count = 1, .reusable = true}, SHIFT(94),
  [1040] = {.count = 1, .reusable = true}, SHIFT(99),
  [1042] = {.count = 1, .reusable = true}, SHIFT(2178),
  [1044] = {.count = 1, .reusable = false}, SHIFT(196),
  [1046] = {.count = 1, .reusable = false}, SHIFT(367),
  [1048] = {.count = 1, .reusable = false}, SHIFT(84),
  [1050] = {.count = 1, .reusable = true}, SHIFT(1670),
  [1052] = {.count = 1, .reusable = false}, SHIFT(1668),
  [1054] = {.count = 1, .reusable = false}, SHIFT(1670),
  [1056] = {.count = 1, .reusable = false}, SHIFT(1179),
  [1058] = {.count = 1, .reusable = false}, SHIFT(866),
  [1060] = {.count = 1, .reusable = false}, SHIFT(701),
  [1062] = {.count = 1, .reusable = false}, SHIFT(239),
  [1064] = {.count = 1, .reusable = false}, SHIFT(223),
  [1066] = {.count = 1, .reusable = false}, SHIFT(407),
  [1068] = {.count = 1, .reusable = false}, SHIFT(87),
  [1070] = {.count = 1, .reusable = false}, SHIFT(1267),
  [1072] = {.count = 1, .reusable = false}, SHIFT(879),
  [1074] = {.count = 1, .reusable = false}, SHIFT(288),
  [1076] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1078] = {.count = 1, .reusable = false}, SHIFT(1247),
  [1080] = {.count = 1, .reusable = false}, SHIFT(335),
  [1082] = {.count = 1, .reusable = true}, SHIFT(1230),
  [1084] = {.count = 1, .reusable = false}, SHIFT(1230),
  [1086] = {.count = 1, .reusable = false}, SHIFT(370),
  [1088] = {.count = 1, .reusable = true}, SHIFT(1324),
  [1090] = {.count = 1, .reusable = false}, SHIFT(1324),
  [1092] = {.count = 1, .reusable = false}, SHIFT(329),
  [1094] = {.count = 1, .reusable = true}, SHIFT(1268),
  [1096] = {.count = 1, .reusable = false}, SHIFT(1268),
  [1098] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 5),
  [1100] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 5),
  [1102] = {.count = 1, .reusable = true}, SHIFT(12),
  [1104] = {.count = 1, .reusable = false}, SHIFT(3080),
  [1106] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1108] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1110] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1112] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1114] = {.count = 1, .reusable = true}, SHIFT(491),
  [1116] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [1118] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [1120] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [1122] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [1124] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1126] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1128] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 94),
  [1130] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 94),
  [1132] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 94),
  [1134] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 94),
  [1136] = {.count = 1, .reusable = true}, SHIFT(578),
  [1138] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [1140] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [1142] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1144] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1146] = {.count = 1, .reusable = true}, SHIFT(138),
  [1148] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [1150] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [1152] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 157),
  [1154] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 157),
  [1156] = {.count = 1, .reusable = true}, SHIFT(581),
  [1158] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1160] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1162] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 28),
  [1164] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 28),
  [1166] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [1168] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [1170] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 134),
  [1172] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 134),
  [1174] = {.count = 1, .reusable = true}, SHIFT(588),
  [1176] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 154),
  [1178] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 154),
  [1180] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 154),
  [1182] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 154),
  [1184] = {.count = 1, .reusable = true}, SHIFT(611),
  [1186] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 103),
  [1188] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 103),
  [1190] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 103),
  [1192] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 103),
  [1194] = {.count = 1, .reusable = true}, SHIFT(565),
  [1196] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 125),
  [1198] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 125),
  [1200] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 125),
  [1202] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 125),
  [1204] = {.count = 1, .reusable = true}, SHIFT(585),
  [1206] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 95),
  [1208] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 95),
  [1210] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 95),
  [1212] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 95),
  [1214] = {.count = 1, .reusable = true}, SHIFT(579),
  [1216] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [1218] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [1220] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1222] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1224] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 135),
  [1226] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 135),
  [1228] = {.count = 1, .reusable = true}, SHIFT(584),
  [1230] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1232] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1234] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 106),
  [1236] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 106),
  [1238] = {.count = 1, .reusable = true}, SHIFT(590),
  [1240] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 129),
  [1242] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 129),
  [1244] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 129),
  [1246] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 129),
  [1248] = {.count = 1, .reusable = true}, SHIFT(605),
  [1250] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 129),
  [1252] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 129),
  [1254] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [1256] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [1258] = {.count = 1, .reusable = true}, SHIFT(604),
  [1260] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [1262] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [1264] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 50),
  [1266] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 50),
  [1268] = {.count = 1, .reusable = true}, SHIFT(556),
  [1270] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1272] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1274] = {.count = 1, .reusable = true}, SHIFT(121),
  [1276] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [1278] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [1280] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1282] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1284] = {.count = 1, .reusable = false}, SHIFT(785),
  [1286] = {.count = 1, .reusable = false}, SHIFT(856),
  [1288] = {.count = 1, .reusable = false}, SHIFT(642),
  [1290] = {.count = 1, .reusable = false}, SHIFT(220),
  [1292] = {.count = 1, .reusable = false}, SHIFT(219),
  [1294] = {.count = 1, .reusable = false}, SHIFT(507),
  [1296] = {.count = 1, .reusable = false}, SHIFT(69),
  [1298] = {.count = 1, .reusable = false}, SHIFT(872),
  [1300] = {.count = 1, .reusable = false}, SHIFT(76),
  [1302] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1304] = {.count = 1, .reusable = false}, SHIFT(1554),
  [1306] = {.count = 1, .reusable = true}, SHIFT(1124),
  [1308] = {.count = 1, .reusable = true}, SHIFT(1169),
  [1310] = {.count = 1, .reusable = false}, SHIFT(885),
  [1312] = {.count = 1, .reusable = false}, SHIFT(880),
  [1314] = {.count = 1, .reusable = false}, SHIFT(663),
  [1316] = {.count = 1, .reusable = false}, SHIFT(530),
  [1318] = {.count = 1, .reusable = false}, SHIFT(79),
  [1320] = {.count = 1, .reusable = true}, SHIFT(1237),
  [1322] = {.count = 1, .reusable = false}, SHIFT(1237),
  [1324] = {.count = 1, .reusable = true}, SHIFT(1231),
  [1326] = {.count = 1, .reusable = true}, SHIFT(1274),
  [1328] = {.count = 1, .reusable = false}, SHIFT(1274),
  [1330] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [1332] = {.count = 1, .reusable = true}, SHIFT(1304),
  [1334] = {.count = 1, .reusable = false}, SHIFT(1304),
  [1336] = {.count = 1, .reusable = true}, SHIFT(1456),
  [1338] = {.count = 1, .reusable = true}, SHIFT(1238),
  [1340] = {.count = 1, .reusable = false}, SHIFT(1238),
  [1342] = {.count = 1, .reusable = true}, SHIFT(1412),
  [1344] = {.count = 1, .reusable = false}, SHIFT(1412),
  [1346] = {.count = 1, .reusable = true}, SHIFT(1264),
  [1348] = {.count = 1, .reusable = true}, SHIFT(1568),
  [1350] = {.count = 1, .reusable = true}, SHIFT(1296),
  [1352] = {.count = 1, .reusable = false}, SHIFT(1296),
  [1354] = {.count = 1, .reusable = true}, SHIFT(1293),
  [1356] = {.count = 1, .reusable = true}, SHIFT(2351),
  [1358] = {.count = 1, .reusable = true}, SHIFT(1210),
  [1360] = {.count = 1, .reusable = false}, SHIFT(1210),
  [1362] = {.count = 1, .reusable = true}, SHIFT(1162),
  [1364] = {.count = 1, .reusable = true}, SHIFT(1200),
  [1366] = {.count = 1, .reusable = false}, SHIFT(1200),
  [1368] = {.count = 1, .reusable = true}, SHIFT(1779),
  [1370] = {.count = 1, .reusable = true}, SHIFT(1177),
  [1372] = {.count = 1, .reusable = false}, SHIFT(1177),
  [1374] = {.count = 1, .reusable = true}, SHIFT(1201),
  [1376] = {.count = 1, .reusable = false}, SHIFT(1201),
  [1378] = {.count = 1, .reusable = true}, SHIFT(1302),
  [1380] = {.count = 1, .reusable = true}, SHIFT(2608),
  [1382] = {.count = 1, .reusable = true}, SHIFT(366),
  [1384] = {.count = 1, .reusable = true}, SHIFT(1342),
  [1386] = {.count = 1, .reusable = false}, SHIFT(1342),
  [1388] = {.count = 1, .reusable = true}, SHIFT(2304),
  [1390] = {.count = 1, .reusable = true}, SHIFT(1354),
  [1392] = {.count = 1, .reusable = false}, SHIFT(1354),
  [1394] = {.count = 1, .reusable = false}, SHIFT(804),
  [1396] = {.count = 1, .reusable = true}, SHIFT(1300),
  [1398] = {.count = 1, .reusable = true}, SHIFT(1255),
  [1400] = {.count = 1, .reusable = false}, SHIFT(1255),
  [1402] = {.count = 1, .reusable = false}, SHIFT(719),
  [1404] = {.count = 1, .reusable = true}, SHIFT(1072),
  [1406] = {.count = 1, .reusable = false}, SHIFT(1072),
  [1408] = {.count = 1, .reusable = false}, SHIFT(704),
  [1410] = {.count = 1, .reusable = true}, SHIFT(1153),
  [1412] = {.count = 1, .reusable = false}, SHIFT(1153),
  [1414] = {.count = 1, .reusable = true}, SHIFT(553),
  [1416] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1418] = {.count = 1, .reusable = false}, SHIFT(1209),
  [1420] = {.count = 1, .reusable = false}, SHIFT(855),
  [1422] = {.count = 1, .reusable = true}, SHIFT(1292),
  [1424] = {.count = 1, .reusable = false}, SHIFT(1292),
  [1426] = {.count = 1, .reusable = false}, SHIFT(918),
  [1428] = {.count = 1, .reusable = false}, SHIFT(922),
  [1430] = {.count = 1, .reusable = false}, SHIFT(678),
  [1432] = {.count = 1, .reusable = false}, SHIFT(400),
  [1434] = {.count = 1, .reusable = false}, SHIFT(619),
  [1436] = {.count = 1, .reusable = false}, SHIFT(90),
  [1438] = {.count = 1, .reusable = true}, SHIFT(1619),
  [1440] = {.count = 1, .reusable = false}, SHIFT(1619),
  [1442] = {.count = 1, .reusable = true}, SHIFT(41),
  [1444] = {.count = 1, .reusable = true}, SHIFT(1307),
  [1446] = {.count = 1, .reusable = false}, SHIFT(1307),
  [1448] = {.count = 1, .reusable = true}, SHIFT(31),
  [1450] = {.count = 1, .reusable = true}, SHIFT(1392),
  [1452] = {.count = 1, .reusable = false}, SHIFT(1392),
  [1454] = {.count = 1, .reusable = false}, SHIFT(2842),
  [1456] = {.count = 1, .reusable = true}, SHIFT(339),
  [1458] = {.count = 1, .reusable = false}, SHIFT(307),
  [1460] = {.count = 1, .reusable = false}, SHIFT(3143),
  [1462] = {.count = 1, .reusable = true}, SHIFT(2137),
  [1464] = {.count = 1, .reusable = true}, SHIFT(2136),
  [1466] = {.count = 1, .reusable = true}, SHIFT(3140),
  [1468] = {.count = 1, .reusable = true}, SHIFT(3135),
  [1470] = {.count = 1, .reusable = true}, SHIFT(2134),
  [1472] = {.count = 1, .reusable = true}, SHIFT(2211),
  [1474] = {.count = 1, .reusable = true}, SHIFT(2111),
  [1476] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1479] = {.count = 1, .reusable = true}, SHIFT(3134),
  [1481] = {.count = 1, .reusable = true}, SHIFT(3133),
  [1483] = {.count = 1, .reusable = true}, SHIFT(3129),
  [1485] = {.count = 1, .reusable = true}, SHIFT(2852),
  [1487] = {.count = 1, .reusable = true}, SHIFT(3174),
  [1489] = {.count = 1, .reusable = true}, SHIFT(1766),
  [1491] = {.count = 1, .reusable = true}, SHIFT(2127),
  [1493] = {.count = 1, .reusable = true}, SHIFT(3173),
  [1495] = {.count = 1, .reusable = true}, SHIFT(3172),
  [1497] = {.count = 1, .reusable = true}, SHIFT(35),
  [1499] = {.count = 1, .reusable = true}, SHIFT(1321),
  [1501] = {.count = 1, .reusable = false}, SHIFT(1321),
  [1503] = {.count = 1, .reusable = false}, SHIFT(706),
  [1505] = {.count = 1, .reusable = false}, SHIFT(721),
  [1507] = {.count = 1, .reusable = false}, SHIFT(637),
  [1509] = {.count = 1, .reusable = false}, SHIFT(3032),
  [1511] = {.count = 1, .reusable = false}, SHIFT(487),
  [1513] = {.count = 1, .reusable = false}, SHIFT(62),
  [1515] = {.count = 1, .reusable = true}, SHIFT(1319),
  [1517] = {.count = 1, .reusable = false}, SHIFT(1319),
  [1519] = {.count = 1, .reusable = false}, SHIFT(1648),
  [1521] = {.count = 1, .reusable = true}, SHIFT(6),
  [1523] = {.count = 1, .reusable = true}, SHIFT(1284),
  [1525] = {.count = 1, .reusable = false}, SHIFT(1284),
  [1527] = {.count = 1, .reusable = true}, SHIFT(1259),
  [1529] = {.count = 1, .reusable = false}, SHIFT(1259),
  [1531] = {.count = 1, .reusable = false}, SHIFT(823),
  [1533] = {.count = 1, .reusable = false}, SHIFT(806),
  [1535] = {.count = 1, .reusable = false}, SHIFT(647),
  [1537] = {.count = 1, .reusable = false}, SHIFT(3111),
  [1539] = {.count = 1, .reusable = false}, SHIFT(509),
  [1541] = {.count = 1, .reusable = false}, SHIFT(78),
  [1543] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1545] = {.count = 1, .reusable = false}, SHIFT(1005),
  [1547] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1549] = {.count = 1, .reusable = false}, SHIFT(1009),
  [1551] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1553] = {.count = 1, .reusable = false}, SHIFT(1008),
  [1555] = {.count = 1, .reusable = true}, SHIFT(5),
  [1557] = {.count = 1, .reusable = true}, SHIFT(1283),
  [1559] = {.count = 1, .reusable = false}, SHIFT(1283),
  [1561] = {.count = 1, .reusable = true}, SHIFT(1007),
  [1563] = {.count = 1, .reusable = false}, SHIFT(1007),
  [1565] = {.count = 1, .reusable = true}, SHIFT(1393),
  [1567] = {.count = 1, .reusable = false}, SHIFT(1393),
  [1569] = {.count = 1, .reusable = true}, SHIFT(1394),
  [1571] = {.count = 1, .reusable = false}, SHIFT(1394),
  [1573] = {.count = 1, .reusable = false}, SHIFT(847),
  [1575] = {.count = 1, .reusable = false}, SHIFT(685),
  [1577] = {.count = 1, .reusable = false}, SHIFT(680),
  [1579] = {.count = 1, .reusable = false}, SHIFT(630),
  [1581] = {.count = 1, .reusable = false}, SHIFT(466),
  [1583] = {.count = 1, .reusable = false}, SHIFT(58),
  [1585] = {.count = 1, .reusable = true}, SHIFT(2),
  [1587] = {.count = 1, .reusable = true}, SHIFT(1079),
  [1589] = {.count = 1, .reusable = false}, SHIFT(1079),
  [1591] = {.count = 1, .reusable = true}, SHIFT(1082),
  [1593] = {.count = 1, .reusable = false}, SHIFT(1082),
  [1595] = {.count = 1, .reusable = true}, SHIFT(1087),
  [1597] = {.count = 1, .reusable = false}, SHIFT(1087),
  [1599] = {.count = 1, .reusable = false}, SHIFT(901),
  [1601] = {.count = 1, .reusable = true}, SHIFT(1234),
  [1603] = {.count = 1, .reusable = false}, SHIFT(1234),
  [1605] = {.count = 1, .reusable = false}, SHIFT(775),
  [1607] = {.count = 1, .reusable = false}, SHIFT(787),
  [1609] = {.count = 1, .reusable = false}, SHIFT(640),
  [1611] = {.count = 1, .reusable = false}, SHIFT(2992),
  [1613] = {.count = 1, .reusable = false}, SHIFT(505),
  [1615] = {.count = 1, .reusable = false}, SHIFT(81),
  [1617] = {.count = 1, .reusable = true}, SHIFT(1484),
  [1619] = {.count = 1, .reusable = false}, SHIFT(1484),
  [1621] = {.count = 1, .reusable = false}, SHIFT(1673),
  [1623] = {.count = 1, .reusable = true}, SHIFT(1220),
  [1625] = {.count = 1, .reusable = false}, SHIFT(1220),
  [1627] = {.count = 1, .reusable = false}, SHIFT(909),
  [1629] = {.count = 1, .reusable = false}, SHIFT(904),
  [1631] = {.count = 1, .reusable = false}, SHIFT(665),
  [1633] = {.count = 1, .reusable = false}, SHIFT(574),
  [1635] = {.count = 1, .reusable = false}, SHIFT(82),
  [1637] = {.count = 1, .reusable = true}, SHIFT(1439),
  [1639] = {.count = 1, .reusable = false}, SHIFT(1439),
  [1641] = {.count = 1, .reusable = false}, SHIFT(711),
  [1643] = {.count = 1, .reusable = true}, SHIFT(1251),
  [1645] = {.count = 1, .reusable = false}, SHIFT(1251),
  [1647] = {.count = 1, .reusable = true}, SHIFT(1391),
  [1649] = {.count = 1, .reusable = false}, SHIFT(1391),
  [1651] = {.count = 1, .reusable = false}, SHIFT(869),
  [1653] = {.count = 1, .reusable = false}, SHIFT(889),
  [1655] = {.count = 1, .reusable = false}, SHIFT(653),
  [1657] = {.count = 1, .reusable = false}, SHIFT(531),
  [1659] = {.count = 1, .reusable = false}, SHIFT(75),
  [1661] = {.count = 1, .reusable = false}, SHIFT(887),
  [1663] = {.count = 1, .reusable = false}, SHIFT(717),
  [1665] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1667] = {.count = 1, .reusable = false}, SHIFT(1000),
  [1669] = {.count = 1, .reusable = true}, SHIFT(1338),
  [1671] = {.count = 1, .reusable = false}, SHIFT(1338),
  [1673] = {.count = 1, .reusable = true}, SHIFT(1406),
  [1675] = {.count = 1, .reusable = false}, SHIFT(1406),
  [1677] = {.count = 1, .reusable = true}, SHIFT(1263),
  [1679] = {.count = 1, .reusable = false}, SHIFT(1263),
  [1681] = {.count = 1, .reusable = true}, SHIFT(1280),
  [1683] = {.count = 1, .reusable = false}, SHIFT(1280),
  [1685] = {.count = 1, .reusable = false}, SHIFT(813),
  [1687] = {.count = 1, .reusable = false}, SHIFT(743),
  [1689] = {.count = 1, .reusable = false}, SHIFT(648),
  [1691] = {.count = 1, .reusable = false}, SHIFT(500),
  [1693] = {.count = 1, .reusable = false}, SHIFT(70),
  [1695] = {.count = 1, .reusable = true}, SHIFT(1126),
  [1697] = {.count = 1, .reusable = false}, SHIFT(1126),
  [1699] = {.count = 1, .reusable = true}, SHIFT(989),
  [1701] = {.count = 1, .reusable = false}, SHIFT(989),
  [1703] = {.count = 1, .reusable = true}, SHIFT(1407),
  [1705] = {.count = 1, .reusable = false}, SHIFT(1407),
  [1707] = {.count = 1, .reusable = true}, SHIFT(1281),
  [1709] = {.count = 1, .reusable = false}, SHIFT(1281),
  [1711] = {.count = 1, .reusable = true}, SHIFT(986),
  [1713] = {.count = 1, .reusable = false}, SHIFT(986),
  [1715] = {.count = 1, .reusable = true}, SHIFT(1408),
  [1717] = {.count = 1, .reusable = false}, SHIFT(1408),
  [1719] = {.count = 1, .reusable = false}, SHIFT(674),
  [1721] = {.count = 1, .reusable = false}, SHIFT(919),
  [1723] = {.count = 1, .reusable = false}, SHIFT(671),
  [1725] = {.count = 1, .reusable = false}, SHIFT(618),
  [1727] = {.count = 1, .reusable = false}, SHIFT(89),
  [1729] = {.count = 1, .reusable = true}, SHIFT(1370),
  [1731] = {.count = 1, .reusable = false}, SHIFT(1370),
  [1733] = {.count = 1, .reusable = true}, SHIFT(1409),
  [1735] = {.count = 1, .reusable = false}, SHIFT(1409),
  [1737] = {.count = 1, .reusable = true}, SHIFT(1032),
  [1739] = {.count = 1, .reusable = false}, SHIFT(1032),
  [1741] = {.count = 1, .reusable = false}, SHIFT(865),
  [1743] = {.count = 1, .reusable = true}, SHIFT(1365),
  [1745] = {.count = 1, .reusable = false}, SHIFT(1365),
  [1747] = {.count = 1, .reusable = true}, SHIFT(1364),
  [1749] = {.count = 1, .reusable = false}, SHIFT(1364),
  [1751] = {.count = 1, .reusable = true}, SHIFT(1353),
  [1753] = {.count = 1, .reusable = false}, SHIFT(1353),
  [1755] = {.count = 1, .reusable = true}, SHIFT(1352),
  [1757] = {.count = 1, .reusable = false}, SHIFT(1352),
  [1759] = {.count = 1, .reusable = true}, SHIFT(1351),
  [1761] = {.count = 1, .reusable = false}, SHIFT(1351),
  [1763] = {.count = 1, .reusable = true}, SHIFT(1350),
  [1765] = {.count = 1, .reusable = false}, SHIFT(1350),
  [1767] = {.count = 1, .reusable = true}, SHIFT(1121),
  [1769] = {.count = 1, .reusable = false}, SHIFT(1121),
  [1771] = {.count = 1, .reusable = true}, SHIFT(1337),
  [1773] = {.count = 1, .reusable = false}, SHIFT(1337),
  [1775] = {.count = 1, .reusable = false}, SHIFT(870),
  [1777] = {.count = 1, .reusable = true}, SHIFT(1116),
  [1779] = {.count = 1, .reusable = false}, SHIFT(1116),
  [1781] = {.count = 1, .reusable = true}, SHIFT(1285),
  [1783] = {.count = 1, .reusable = false}, SHIFT(1285),
  [1785] = {.count = 1, .reusable = false}, SHIFT(883),
  [1787] = {.count = 1, .reusable = true}, SHIFT(1340),
  [1789] = {.count = 1, .reusable = false}, SHIFT(1340),
  [1791] = {.count = 1, .reusable = true}, SHIFT(1235),
  [1793] = {.count = 1, .reusable = false}, SHIFT(1235),
  [1795] = {.count = 1, .reusable = false}, SHIFT(816),
  [1797] = {.count = 1, .reusable = true}, SHIFT(1207),
  [1799] = {.count = 1, .reusable = false}, SHIFT(1207),
  [1801] = {.count = 1, .reusable = true}, SHIFT(1206),
  [1803] = {.count = 1, .reusable = false}, SHIFT(1206),
  [1805] = {.count = 1, .reusable = true}, SHIFT(1205),
  [1807] = {.count = 1, .reusable = false}, SHIFT(1205),
  [1809] = {.count = 1, .reusable = true}, SHIFT(1204),
  [1811] = {.count = 1, .reusable = false}, SHIFT(1204),
  [1813] = {.count = 1, .reusable = true}, SHIFT(1253),
  [1815] = {.count = 1, .reusable = false}, SHIFT(1253),
  [1817] = {.count = 1, .reusable = true}, SHIFT(1240),
  [1819] = {.count = 1, .reusable = false}, SHIFT(1240),
  [1821] = {.count = 1, .reusable = true}, SHIFT(1389),
  [1823] = {.count = 1, .reusable = false}, SHIFT(1389),
  [1825] = {.count = 1, .reusable = true}, SHIFT(1239),
  [1827] = {.count = 1, .reusable = false}, SHIFT(1239),
  [1829] = {.count = 1, .reusable = true}, SHIFT(981),
  [1831] = {.count = 1, .reusable = false}, SHIFT(981),
  [1833] = {.count = 1, .reusable = true}, SHIFT(1185),
  [1835] = {.count = 1, .reusable = false}, SHIFT(1185),
  [1837] = {.count = 1, .reusable = true}, SHIFT(1151),
  [1839] = {.count = 1, .reusable = false}, SHIFT(1151),
  [1841] = {.count = 1, .reusable = true}, SHIFT(1390),
  [1843] = {.count = 1, .reusable = false}, SHIFT(1390),
  [1845] = {.count = 1, .reusable = true}, SHIFT(1221),
  [1847] = {.count = 1, .reusable = false}, SHIFT(1221),
  [1849] = {.count = 1, .reusable = true}, SHIFT(1216),
  [1851] = {.count = 1, .reusable = false}, SHIFT(1216),
  [1853] = {.count = 1, .reusable = true}, SHIFT(1181),
  [1855] = {.count = 1, .reusable = false}, SHIFT(1181),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1135),
  [1859] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1861] = {.count = 1, .reusable = false}, SHIFT(1002),
  [1863] = {.count = 1, .reusable = true}, SHIFT(1534),
  [1865] = {.count = 1, .reusable = false}, SHIFT(1534),
  [1867] = {.count = 1, .reusable = true}, SHIFT(1138),
  [1869] = {.count = 1, .reusable = false}, SHIFT(1138),
  [1871] = {.count = 1, .reusable = true}, SHIFT(1140),
  [1873] = {.count = 1, .reusable = false}, SHIFT(1140),
  [1875] = {.count = 1, .reusable = true}, SHIFT(1141),
  [1877] = {.count = 1, .reusable = false}, SHIFT(1141),
  [1879] = {.count = 1, .reusable = true}, SHIFT(1142),
  [1881] = {.count = 1, .reusable = false}, SHIFT(1142),
  [1883] = {.count = 1, .reusable = true}, SHIFT(1143),
  [1885] = {.count = 1, .reusable = false}, SHIFT(1143),
  [1887] = {.count = 1, .reusable = true}, SHIFT(1193),
  [1889] = {.count = 1, .reusable = false}, SHIFT(1193),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1192),
  [1893] = {.count = 1, .reusable = false}, SHIFT(1192),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1144),
  [1897] = {.count = 1, .reusable = false}, SHIFT(1144),
  [1899] = {.count = 1, .reusable = true}, SHIFT(1146),
  [1901] = {.count = 1, .reusable = false}, SHIFT(1146),
  [1903] = {.count = 1, .reusable = true}, SHIFT(1133),
  [1905] = {.count = 1, .reusable = false}, SHIFT(1133),
  [1907] = {.count = 1, .reusable = true}, SHIFT(1190),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1187),
  [1911] = {.count = 1, .reusable = false}, SHIFT(1187),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1186),
  [1915] = {.count = 1, .reusable = false}, SHIFT(1186),
  [1917] = {.count = 1, .reusable = true}, SHIFT(962),
  [1919] = {.count = 1, .reusable = false}, SHIFT(962),
  [1921] = {.count = 1, .reusable = true}, SHIFT(982),
  [1923] = {.count = 1, .reusable = false}, SHIFT(982),
  [1925] = {.count = 1, .reusable = true}, SHIFT(1195),
  [1927] = {.count = 1, .reusable = false}, SHIFT(1195),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1183),
  [1931] = {.count = 1, .reusable = false}, SHIFT(1183),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1196),
  [1935] = {.count = 1, .reusable = false}, SHIFT(1196),
  [1937] = {.count = 1, .reusable = true}, SHIFT(980),
  [1939] = {.count = 1, .reusable = false}, SHIFT(980),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1246),
  [1943] = {.count = 1, .reusable = false}, SHIFT(1246),
  [1945] = {.count = 1, .reusable = true}, SHIFT(983),
  [1947] = {.count = 1, .reusable = false}, SHIFT(983),
  [1949] = {.count = 1, .reusable = true}, SHIFT(1485),
  [1951] = {.count = 1, .reusable = false}, SHIFT(1485),
  [1953] = {.count = 1, .reusable = true}, SHIFT(985),
  [1955] = {.count = 1, .reusable = false}, SHIFT(985),
  [1957] = {.count = 1, .reusable = true}, SHIFT(987),
  [1959] = {.count = 1, .reusable = false}, SHIFT(987),
  [1961] = {.count = 1, .reusable = true}, SHIFT(988),
  [1963] = {.count = 1, .reusable = false}, SHIFT(988),
  [1965] = {.count = 1, .reusable = true}, SHIFT(1167),
  [1967] = {.count = 1, .reusable = false}, SHIFT(1167),
  [1969] = {.count = 1, .reusable = true}, SHIFT(1182),
  [1971] = {.count = 1, .reusable = false}, SHIFT(1182),
  [1973] = {.count = 1, .reusable = true}, SHIFT(990),
  [1975] = {.count = 1, .reusable = true}, SHIFT(992),
  [1977] = {.count = 1, .reusable = false}, SHIFT(992),
  [1979] = {.count = 1, .reusable = true}, SHIFT(993),
  [1981] = {.count = 1, .reusable = false}, SHIFT(993),
  [1983] = {.count = 1, .reusable = true}, SHIFT(994),
  [1985] = {.count = 1, .reusable = false}, SHIFT(994),
  [1987] = {.count = 1, .reusable = true}, SHIFT(995),
  [1989] = {.count = 1, .reusable = false}, SHIFT(995),
  [1991] = {.count = 1, .reusable = true}, SHIFT(996),
  [1993] = {.count = 1, .reusable = false}, SHIFT(996),
  [1995] = {.count = 1, .reusable = true}, SHIFT(997),
  [1997] = {.count = 1, .reusable = false}, SHIFT(997),
  [1999] = {.count = 1, .reusable = true}, SHIFT(998),
  [2001] = {.count = 1, .reusable = false}, SHIFT(998),
  [2003] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2005] = {.count = 1, .reusable = false}, SHIFT(1233),
  [2007] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2009] = {.count = 1, .reusable = false}, SHIFT(1180),
  [2011] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2013] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2015] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2017] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2019] = {.count = 1, .reusable = true}, SHIFT(1530),
  [2021] = {.count = 1, .reusable = false}, SHIFT(1530),
  [2023] = {.count = 1, .reusable = false}, SHIFT(340),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2027] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2029] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2031] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2035] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2037] = {.count = 1, .reusable = false}, SHIFT(811),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2041] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2043] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2045] = {.count = 1, .reusable = false}, SHIFT(1110),
  [2047] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2049] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2051] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2053] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2055] = {.count = 1, .reusable = true}, SHIFT(1502),
  [2057] = {.count = 1, .reusable = false}, SHIFT(1502),
  [2059] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2061] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2063] = {.count = 1, .reusable = true}, SHIFT(1773),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1344),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2071] = {.count = 1, .reusable = false}, SHIFT(1003),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2075] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2079] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2081] = {.count = 1, .reusable = false}, SHIFT(739),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1386),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2089] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2091] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2095] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2097] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2099] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2101] = {.count = 1, .reusable = false}, SHIFT(1188),
  [2103] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2105] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2107] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2109] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2111] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2113] = {.count = 1, .reusable = false}, SHIFT(1260),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2117] = {.count = 1, .reusable = false}, SHIFT(1345),
  [2119] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2121] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2123] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2125] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2129] = {.count = 1, .reusable = false}, SHIFT(1323),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2133] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2135] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2137] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2139] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2141] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2145] = {.count = 1, .reusable = false}, SHIFT(1258),
  [2147] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2151] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2153] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2155] = {.count = 1, .reusable = false}, SHIFT(1320),
  [2157] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2159] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2163] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2165] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2167] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2169] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2171] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2177] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2181] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2183] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2185] = {.count = 1, .reusable = false}, SHIFT(1211),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2189] = {.count = 1, .reusable = false}, SHIFT(1355),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2193] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2195] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2197] = {.count = 1, .reusable = false}, SHIFT(1357),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2201] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2205] = {.count = 1, .reusable = false}, SHIFT(1359),
  [2207] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2209] = {.count = 1, .reusable = false}, SHIFT(1360),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2213] = {.count = 1, .reusable = false}, SHIFT(1361),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1435),
  [2217] = {.count = 1, .reusable = false}, SHIFT(1435),
  [2219] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2223] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2227] = {.count = 1, .reusable = false}, SHIFT(1212),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2231] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2233] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2235] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2237] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2241] = {.count = 1, .reusable = false}, SHIFT(1366),
  [2243] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2245] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2247] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2249] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2251] = {.count = 1, .reusable = true}, SHIFT(1471),
  [2253] = {.count = 1, .reusable = false}, SHIFT(1471),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1622),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2259] = {.count = 1, .reusable = false}, SHIFT(1227),
  [2261] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2263] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2265] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2267] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2269] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2271] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2275] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1323),
  [2279] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2281] = {.count = 1, .reusable = false}, SHIFT(1244),
  [2283] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2285] = {.count = 1, .reusable = false}, SHIFT(1137),
  [2287] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2289] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2291] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2293] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2295] = {.count = 1, .reusable = true}, SHIFT(1369),
  [2297] = {.count = 1, .reusable = false}, SHIFT(1369),
  [2299] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2301] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2303] = {.count = 1, .reusable = true}, SHIFT(2050),
  [2305] = {.count = 1, .reusable = true}, SHIFT(2936),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1070),
  [2311] = {.count = 1, .reusable = false}, SHIFT(857),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1698),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2319] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1257),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1372),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1017),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1452),
  [2339] = {.count = 1, .reusable = false}, SHIFT(1452),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2345] = {.count = 1, .reusable = false}, SHIFT(924),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1547),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1547),
  [2351] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2353] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2355] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2357] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2359] = {.count = 1, .reusable = true}, SHIFT(2139),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1776),
  [2363] = {.count = 1, .reusable = true}, SHIFT(2140),
  [2365] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2369] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2371] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2373] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2375] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2379] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2383] = {.count = 1, .reusable = false}, SHIFT(1388),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2387] = {.count = 1, .reusable = false}, SHIFT(1387),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2391] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2393] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2395] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2399] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2401] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2403] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2405] = {.count = 1, .reusable = false}, SHIFT(1265),
  [2407] = {.count = 1, .reusable = true}, SHIFT(1588),
  [2409] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2411] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2413] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2415] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2417] = {.count = 1, .reusable = true}, SHIFT(2113),
  [2419] = {.count = 1, .reusable = true}, SHIFT(2093),
  [2421] = {.count = 1, .reusable = false}, SHIFT(2469),
  [2423] = {.count = 1, .reusable = false}, SHIFT(2513),
  [2425] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1854),
  [2428] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1749),
  [2432] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(311),
  [2435] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2973),
  [2439] = {.count = 1, .reusable = false}, SHIFT(2060),
  [2441] = {.count = 1, .reusable = true}, SHIFT(2492),
  [2443] = {.count = 1, .reusable = true}, SHIFT(2493),
  [2445] = {.count = 1, .reusable = true}, SHIFT(2164),
  [2447] = {.count = 1, .reusable = false}, SHIFT(1785),
  [2449] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [2451] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [2453] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2455] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2457] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [2459] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [2461] = {.count = 1, .reusable = false}, SHIFT(3010),
  [2463] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2465] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2467] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2469] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2471] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [2473] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [2475] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2477] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2479] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2, .production_id = 8),
  [2481] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2, .production_id = 8),
  [2483] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2485] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2487] = {.count = 1, .reusable = true}, SHIFT(707),
  [2489] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [2491] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [2493] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [2495] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [2497] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2499] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2501] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [2503] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [2505] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [2507] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [2509] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [2511] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [2513] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [2515] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [2517] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [2519] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [2521] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [2523] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [2525] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [2527] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [2529] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [2531] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [2533] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [2535] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [2537] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [2539] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [2541] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [2543] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2545] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2547] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2549] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [2551] = {.count = 1, .reusable = false}, SHIFT(2160),
  [2553] = {.count = 1, .reusable = false}, SHIFT(1786),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1805),
  [2557] = {.count = 1, .reusable = false}, SHIFT(1788),
  [2559] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2561] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2563] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(738),
  [2566] = {.count = 1, .reusable = false}, SHIFT(762),
  [2568] = {.count = 1, .reusable = false}, SHIFT(3221),
  [2570] = {.count = 1, .reusable = false}, SHIFT(3165),
  [2572] = {.count = 1, .reusable = true}, SHIFT(3079),
  [2574] = {.count = 1, .reusable = false}, SHIFT(2078),
  [2576] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [2578] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [2580] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2582] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2584] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [2586] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [2588] = {.count = 1, .reusable = true}, SHIFT(492),
  [2590] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2592] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2594] = {.count = 1, .reusable = false}, SHIFT(2584),
  [2596] = {.count = 1, .reusable = false}, SHIFT(2819),
  [2598] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2600] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2602] = {.count = 1, .reusable = false}, SHIFT(2994),
  [2604] = {.count = 1, .reusable = true}, SHIFT(488),
  [2606] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [2608] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [2610] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1749),
  [2613] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2973),
  [2616] = {.count = 1, .reusable = false}, SHIFT(1898),
  [2618] = {.count = 1, .reusable = false}, SHIFT(2280),
  [2620] = {.count = 1, .reusable = false}, SHIFT(660),
  [2622] = {.count = 1, .reusable = false}, SHIFT(2904),
  [2624] = {.count = 1, .reusable = true}, SHIFT(481),
  [2626] = {.count = 1, .reusable = true}, SHIFT(97),
  [2628] = {.count = 1, .reusable = true}, SHIFT(2973),
  [2630] = {.count = 1, .reusable = false}, SHIFT(2559),
  [2632] = {.count = 1, .reusable = true}, SHIFT(3074),
  [2634] = {.count = 1, .reusable = false}, SHIFT(2028),
  [2636] = {.count = 1, .reusable = true}, SHIFT(451),
  [2638] = {.count = 1, .reusable = false}, SHIFT(2034),
  [2640] = {.count = 1, .reusable = false}, SHIFT(451),
  [2642] = {.count = 1, .reusable = false}, SHIFT(1841),
  [2644] = {.count = 1, .reusable = false}, SHIFT(1816),
  [2646] = {.count = 1, .reusable = true}, SHIFT(476),
  [2648] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [2650] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [2652] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(738),
  [2655] = {.count = 1, .reusable = false}, SHIFT(3049),
  [2657] = {.count = 1, .reusable = false}, SHIFT(3000),
  [2659] = {.count = 1, .reusable = false}, SHIFT(2079),
  [2661] = {.count = 1, .reusable = true}, SHIFT(13),
  [2663] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [2665] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [2667] = {.count = 1, .reusable = true}, SHIFT(760),
  [2669] = {.count = 1, .reusable = true}, SHIFT(757),
  [2671] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [2673] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [2675] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [2677] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [2679] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [2681] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [2683] = {.count = 1, .reusable = false}, SHIFT(3044),
  [2685] = {.count = 1, .reusable = false}, SHIFT(3043),
  [2687] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [2689] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [2691] = {.count = 1, .reusable = false}, SHIFT(2112),
  [2693] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 156),
  [2695] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 156),
  [2697] = {.count = 1, .reusable = false}, SHIFT(2998),
  [2699] = {.count = 1, .reusable = false}, SHIFT(2999),
  [2701] = {.count = 1, .reusable = true}, SHIFT(3027),
  [2703] = {.count = 1, .reusable = false}, SHIFT(2070),
  [2705] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2707] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2709] = {.count = 1, .reusable = false}, SHIFT(3022),
  [2711] = {.count = 1, .reusable = false}, SHIFT(3023),
  [2713] = {.count = 1, .reusable = false}, SHIFT(2245),
  [2715] = {.count = 1, .reusable = false}, SHIFT(2244),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2719] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(154),
  [2722] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2724] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2726] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [2728] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [2730] = {.count = 1, .reusable = false}, SHIFT(3119),
  [2732] = {.count = 1, .reusable = false}, SHIFT(3117),
  [2734] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [2736] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [2738] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [2740] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [2742] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [2744] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [2746] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 164),
  [2748] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 164),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [2752] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [2754] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2756] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2760] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2762] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2764] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2766] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2768] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2772] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 117),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 117),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2792] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2794] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 125),
  [2796] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 125),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2800] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [2802] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2804] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2806] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2808] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2810] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2812] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2814] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [2816] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [2818] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [2820] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [2822] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [2824] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [2826] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [2828] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [2830] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2832] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2834] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 131),
  [2836] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 131),
  [2838] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 130),
  [2840] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 130),
  [2842] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2844] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2846] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 103),
  [2848] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 103),
  [2850] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [2852] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [2854] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 163),
  [2856] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 163),
  [2858] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 94),
  [2860] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 94),
  [2862] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 105),
  [2864] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 105),
  [2866] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 128),
  [2868] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 128),
  [2870] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2872] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2874] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2876] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2878] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 133),
  [2880] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 133),
  [2882] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [2884] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [2886] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [2888] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [2890] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2892] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2894] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [2896] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [2900] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [2902] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [2904] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [2906] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [2908] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [2910] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [2912] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [2914] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [2916] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [2918] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 125),
  [2920] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 125),
  [2922] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2924] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2926] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2928] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2930] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [2932] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [2934] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [2936] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [2938] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2940] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2942] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [2944] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [2946] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2948] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2950] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 95),
  [2952] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 95),
  [2954] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [2956] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [2958] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 113),
  [2960] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 113),
  [2962] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [2964] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [2966] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [2968] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [2970] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [2972] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [2974] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [2976] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [2978] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 112),
  [2980] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 112),
  [2982] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 155),
  [2984] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 155),
  [2986] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2988] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2990] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 102),
  [2992] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 102),
  [2994] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [2996] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [2998] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 129),
  [3000] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 129),
  [3002] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [3004] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [3006] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [3008] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [3010] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 6),
  [3012] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 6),
  [3014] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [3016] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [3018] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 154),
  [3020] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 154),
  [3022] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [3024] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [3026] = {.count = 1, .reusable = false}, SHIFT(53),
  [3028] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 111),
  [3030] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 111),
  [3032] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 139),
  [3034] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 139),
  [3036] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [3038] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [3040] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [3042] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [3044] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3046] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3048] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 162),
  [3050] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 162),
  [3052] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3054] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3056] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 161),
  [3058] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 161),
  [3060] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 160),
  [3062] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 160),
  [3064] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3066] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3068] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 144),
  [3070] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 144),
  [3072] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [3074] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3076] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 143),
  [3078] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 143),
  [3080] = {.count = 1, .reusable = false}, SHIFT(1014),
  [3082] = {.count = 1, .reusable = true}, SHIFT(156),
  [3084] = {.count = 1, .reusable = false}, SHIFT(113),
  [3086] = {.count = 1, .reusable = true}, SHIFT(2480),
  [3088] = {.count = 1, .reusable = true}, SHIFT(2483),
  [3090] = {.count = 1, .reusable = false}, SHIFT(494),
  [3092] = {.count = 1, .reusable = true}, SHIFT(150),
  [3094] = {.count = 1, .reusable = false}, SHIFT(1011),
  [3096] = {.count = 1, .reusable = true}, SHIFT(153),
  [3098] = {.count = 1, .reusable = false}, SHIFT(2555),
  [3100] = {.count = 1, .reusable = false}, SHIFT(1925),
  [3102] = {.count = 1, .reusable = false}, SHIFT(927),
  [3104] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3106] = {.count = 1, .reusable = true}, SHIFT(690),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1010),
  [3110] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3112] = {.count = 1, .reusable = true}, SHIFT(956),
  [3114] = {.count = 1, .reusable = true}, SHIFT(146),
  [3116] = {.count = 1, .reusable = false}, SHIFT(1348),
  [3118] = {.count = 1, .reusable = false}, SHIFT(2512),
  [3120] = {.count = 1, .reusable = true}, SHIFT(2465),
  [3122] = {.count = 1, .reusable = true}, SHIFT(2464),
  [3124] = {.count = 1, .reusable = true}, SHIFT(1896),
  [3126] = {.count = 1, .reusable = false}, SHIFT(1347),
  [3128] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3130] = {.count = 1, .reusable = false}, SHIFT(1731),
  [3132] = {.count = 1, .reusable = false}, SHIFT(1346),
  [3134] = {.count = 1, .reusable = true}, SHIFT(454),
  [3136] = {.count = 1, .reusable = false}, SHIFT(1934),
  [3138] = {.count = 1, .reusable = false}, SHIFT(931),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3142] = {.count = 1, .reusable = false}, SHIFT(1313),
  [3144] = {.count = 1, .reusable = false}, SHIFT(1312),
  [3146] = {.count = 1, .reusable = false}, SHIFT(1546),
  [3148] = {.count = 1, .reusable = false}, SHIFT(1717),
  [3150] = {.count = 1, .reusable = false}, SHIFT(1311),
  [3152] = {.count = 1, .reusable = false}, SHIFT(1922),
  [3154] = {.count = 1, .reusable = false}, SHIFT(929),
  [3156] = {.count = 1, .reusable = true}, SHIFT(1380),
  [3158] = {.count = 1, .reusable = false}, SHIFT(1382),
  [3160] = {.count = 1, .reusable = false}, SHIFT(1383),
  [3162] = {.count = 1, .reusable = false}, SHIFT(1426),
  [3164] = {.count = 1, .reusable = false}, SHIFT(1712),
  [3166] = {.count = 1, .reusable = false}, SHIFT(1384),
  [3168] = {.count = 1, .reusable = true}, SHIFT(696),
  [3170] = {.count = 1, .reusable = true}, SHIFT(1236),
  [3172] = {.count = 1, .reusable = true}, SHIFT(955),
  [3174] = {.count = 1, .reusable = true}, SHIFT(1980),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3178] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3180] = {.count = 1, .reusable = false}, SHIFT(1932),
  [3182] = {.count = 1, .reusable = false}, SHIFT(934),
  [3184] = {.count = 1, .reusable = true}, SHIFT(2035),
  [3186] = {.count = 1, .reusable = false}, SHIFT(1318),
  [3188] = {.count = 1, .reusable = false}, SHIFT(1317),
  [3190] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3192] = {.count = 1, .reusable = false}, SHIFT(1733),
  [3194] = {.count = 1, .reusable = false}, SHIFT(1316),
  [3196] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3198] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3200] = {.count = 1, .reusable = false}, SHIFT(277),
  [3202] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3204] = {.count = 1, .reusable = true}, SHIFT(273),
  [3206] = {.count = 1, .reusable = false}, SHIFT(284),
  [3208] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3211] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(860),
  [3214] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3217] = {.count = 1, .reusable = true}, SHIFT(3038),
  [3219] = {.count = 1, .reusable = true}, SHIFT(217),
  [3221] = {.count = 1, .reusable = true}, SHIFT(285),
  [3223] = {.count = 1, .reusable = true}, SHIFT(784),
  [3225] = {.count = 1, .reusable = false}, SHIFT(2668),
  [3227] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 104),
  [3229] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 104),
  [3231] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [3233] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [3235] = {.count = 1, .reusable = false}, SHIFT(376),
  [3237] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [3239] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(214),
  [3242] = {.count = 1, .reusable = true}, SHIFT(214),
  [3244] = {.count = 1, .reusable = true}, SHIFT(846),
  [3246] = {.count = 1, .reusable = true}, SHIFT(3216),
  [3248] = {.count = 1, .reusable = true}, SHIFT(179),
  [3250] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(834),
  [3253] = {.count = 1, .reusable = true}, SHIFT(3192),
  [3255] = {.count = 1, .reusable = true}, SHIFT(808),
  [3257] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3259] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3261] = {.count = 1, .reusable = false}, SHIFT(1376),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3265] = {.count = 1, .reusable = false}, SHIFT(936),
  [3267] = {.count = 1, .reusable = false}, SHIFT(2847),
  [3269] = {.count = 1, .reusable = true}, SHIFT(490),
  [3271] = {.count = 1, .reusable = true}, SHIFT(747),
  [3273] = {.count = 1, .reusable = false}, SHIFT(2501),
  [3275] = {.count = 1, .reusable = true}, SHIFT(1106),
  [3277] = {.count = 1, .reusable = true}, SHIFT(774),
  [3279] = {.count = 1, .reusable = true}, SHIFT(773),
  [3281] = {.count = 1, .reusable = true}, SHIFT(3132),
  [3283] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3287] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3289] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3291] = {.count = 1, .reusable = false}, SHIFT(2689),
  [3293] = {.count = 1, .reusable = true}, SHIFT(936),
  [3295] = {.count = 1, .reusable = false}, SHIFT(333),
  [3297] = {.count = 1, .reusable = true}, SHIFT(3123),
  [3299] = {.count = 1, .reusable = true}, SHIFT(237),
  [3301] = {.count = 1, .reusable = true}, SHIFT(332),
  [3303] = {.count = 1, .reusable = true}, SHIFT(3102),
  [3305] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [3307] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [3309] = {.count = 1, .reusable = false}, SHIFT(330),
  [3311] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3314] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3317] = {.count = 1, .reusable = true}, SHIFT(3046),
  [3319] = {.count = 1, .reusable = false}, SHIFT(1948),
  [3321] = {.count = 1, .reusable = false}, SHIFT(938),
  [3323] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [3325] = {.count = 1, .reusable = false}, SHIFT(1501),
  [3327] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3329] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3331] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3333] = {.count = 1, .reusable = false}, SHIFT(1526),
  [3335] = {.count = 1, .reusable = false}, SHIFT(1191),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3339] = {.count = 1, .reusable = false}, SHIFT(932),
  [3341] = {.count = 1, .reusable = false}, SHIFT(2812),
  [3343] = {.count = 1, .reusable = true}, SHIFT(484),
  [3345] = {.count = 1, .reusable = true}, SHIFT(769),
  [3347] = {.count = 1, .reusable = false}, SHIFT(2516),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1152),
  [3351] = {.count = 1, .reusable = true}, SHIFT(780),
  [3353] = {.count = 1, .reusable = true}, SHIFT(783),
  [3355] = {.count = 1, .reusable = true}, SHIFT(3177),
  [3357] = {.count = 1, .reusable = false}, SHIFT(1432),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3361] = {.count = 1, .reusable = false}, SHIFT(1436),
  [3363] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3365] = {.count = 1, .reusable = false}, SHIFT(2746),
  [3367] = {.count = 1, .reusable = true}, SHIFT(932),
  [3369] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3372] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3375] = {.count = 1, .reusable = false}, SHIFT(964),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1030),
  [3379] = {.count = 1, .reusable = false}, SHIFT(930),
  [3381] = {.count = 1, .reusable = false}, SHIFT(2892),
  [3383] = {.count = 1, .reusable = true}, SHIFT(479),
  [3385] = {.count = 1, .reusable = true}, SHIFT(822),
  [3387] = {.count = 1, .reusable = false}, SHIFT(2484),
  [3389] = {.count = 1, .reusable = true}, SHIFT(1031),
  [3391] = {.count = 1, .reusable = true}, SHIFT(851),
  [3393] = {.count = 1, .reusable = true}, SHIFT(854),
  [3395] = {.count = 1, .reusable = true}, SHIFT(3090),
  [3397] = {.count = 1, .reusable = false}, SHIFT(1033),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1035),
  [3401] = {.count = 1, .reusable = false}, SHIFT(1037),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1035),
  [3405] = {.count = 1, .reusable = false}, SHIFT(2620),
  [3407] = {.count = 1, .reusable = true}, SHIFT(930),
  [3409] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [3412] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [3415] = {.count = 1, .reusable = false}, SHIFT(1878),
  [3417] = {.count = 1, .reusable = false}, SHIFT(926),
  [3419] = {.count = 1, .reusable = true}, SHIFT(782),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3423] = {.count = 1, .reusable = false}, SHIFT(449),
  [3425] = {.count = 1, .reusable = false}, SHIFT(455),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1950),
  [3429] = {.count = 1, .reusable = false}, SHIFT(390),
  [3431] = {.count = 1, .reusable = true}, SHIFT(252),
  [3433] = {.count = 1, .reusable = true}, SHIFT(422),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1094),
  [3437] = {.count = 1, .reusable = false}, SHIFT(341),
  [3439] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [3441] = {.count = 1, .reusable = true}, SHIFT(165),
  [3443] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(737),
  [3446] = {.count = 1, .reusable = true}, SHIFT(3160),
  [3448] = {.count = 1, .reusable = true}, SHIFT(183),
  [3450] = {.count = 1, .reusable = true}, SHIFT(342),
  [3452] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [3454] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3456] = {.count = 1, .reusable = true}, SHIFT(453),
  [3458] = {.count = 1, .reusable = true}, SHIFT(1078),
  [3460] = {.count = 1, .reusable = true}, SHIFT(1877),
  [3462] = {.count = 1, .reusable = true}, SHIFT(3198),
  [3464] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3466] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(284),
  [3469] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3472] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3476] = {.count = 1, .reusable = true}, SHIFT(3189),
  [3478] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3481] = {.count = 1, .reusable = true}, SHIFT(3195),
  [3483] = {.count = 1, .reusable = true}, SHIFT(469),
  [3485] = {.count = 1, .reusable = true}, SHIFT(3076),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3489] = {.count = 1, .reusable = true}, SHIFT(169),
  [3491] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(738),
  [3494] = {.count = 1, .reusable = true}, SHIFT(2989),
  [3496] = {.count = 1, .reusable = false}, SHIFT(1884),
  [3498] = {.count = 1, .reusable = true}, SHIFT(2145),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1939),
  [3502] = {.count = 1, .reusable = true}, SHIFT(467),
  [3504] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3506] = {.count = 1, .reusable = true}, SHIFT(1949),
  [3508] = {.count = 1, .reusable = true}, SHIFT(1876),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3512] = {.count = 1, .reusable = false}, SHIFT(363),
  [3514] = {.count = 1, .reusable = true}, SHIFT(3200),
  [3516] = {.count = 1, .reusable = true}, SHIFT(226),
  [3518] = {.count = 1, .reusable = true}, SHIFT(361),
  [3520] = {.count = 1, .reusable = true}, SHIFT(1074),
  [3522] = {.count = 1, .reusable = true}, SHIFT(2658),
  [3524] = {.count = 1, .reusable = true}, SHIFT(2655),
  [3526] = {.count = 1, .reusable = true}, SHIFT(2313),
  [3528] = {.count = 1, .reusable = false}, SHIFT(2004),
  [3530] = {.count = 1, .reusable = false}, SHIFT(2845),
  [3532] = {.count = 1, .reusable = false}, SHIFT(2560),
  [3534] = {.count = 1, .reusable = true}, SHIFT(1076),
  [3536] = {.count = 1, .reusable = true}, SHIFT(745),
  [3538] = {.count = 1, .reusable = true}, SHIFT(740),
  [3540] = {.count = 1, .reusable = false}, SHIFT(465),
  [3542] = {.count = 1, .reusable = false}, SHIFT(2496),
  [3544] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3546] = {.count = 1, .reusable = true}, SHIFT(849),
  [3548] = {.count = 1, .reusable = true}, SHIFT(858),
  [3550] = {.count = 1, .reusable = false}, SHIFT(1886),
  [3552] = {.count = 1, .reusable = false}, SHIFT(933),
  [3554] = {.count = 1, .reusable = false}, SHIFT(2981),
  [3556] = {.count = 1, .reusable = true}, SHIFT(486),
  [3558] = {.count = 1, .reusable = true}, SHIFT(835),
  [3560] = {.count = 1, .reusable = false}, SHIFT(2479),
  [3562] = {.count = 1, .reusable = true}, SHIFT(3002),
  [3564] = {.count = 1, .reusable = false}, SHIFT(1964),
  [3566] = {.count = 1, .reusable = true}, SHIFT(1971),
  [3568] = {.count = 1, .reusable = false}, SHIFT(1978),
  [3570] = {.count = 1, .reusable = false}, SHIFT(1971),
  [3572] = {.count = 1, .reusable = true}, SHIFT(2988),
  [3574] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(200),
  [3577] = {.count = 1, .reusable = true}, SHIFT(200),
  [3579] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [3581] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [3583] = {.count = 1, .reusable = true}, SHIFT(592),
  [3585] = {.count = 1, .reusable = true}, SHIFT(3056),
  [3587] = {.count = 1, .reusable = true}, SHIFT(3018),
  [3589] = {.count = 1, .reusable = true}, SHIFT(254),
  [3591] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3594] = {.count = 1, .reusable = true}, SHIFT(767),
  [3596] = {.count = 1, .reusable = true}, SHIFT(3219),
  [3598] = {.count = 1, .reusable = true}, SHIFT(3201),
  [3600] = {.count = 1, .reusable = true}, SHIFT(3203),
  [3602] = {.count = 1, .reusable = false}, SHIFT(744),
  [3604] = {.count = 1, .reusable = true}, SHIFT(2065),
  [3606] = {.count = 1, .reusable = true}, SHIFT(3115),
  [3608] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [3610] = {.count = 1, .reusable = true}, SHIFT(3182),
  [3612] = {.count = 1, .reusable = true}, SHIFT(207),
  [3614] = {.count = 1, .reusable = false}, SHIFT(1929),
  [3616] = {.count = 1, .reusable = false}, SHIFT(937),
  [3618] = {.count = 1, .reusable = true}, SHIFT(1851),
  [3620] = {.count = 1, .reusable = true}, SHIFT(197),
  [3622] = {.count = 1, .reusable = false}, SHIFT(1674),
  [3624] = {.count = 1, .reusable = true}, SHIFT(1889),
  [3626] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3628] = {.count = 1, .reusable = false}, SHIFT(1707),
  [3630] = {.count = 1, .reusable = false}, SHIFT(1623),
  [3632] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3634] = {.count = 1, .reusable = true}, SHIFT(2778),
  [3636] = {.count = 1, .reusable = true}, SHIFT(393),
  [3638] = {.count = 1, .reusable = true}, SHIFT(319),
  [3640] = {.count = 1, .reusable = false}, SHIFT(3107),
  [3642] = {.count = 1, .reusable = true}, SHIFT(2153),
  [3644] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3646] = {.count = 1, .reusable = true}, SHIFT(3208),
  [3648] = {.count = 1, .reusable = true}, SHIFT(3209),
  [3650] = {.count = 1, .reusable = true}, SHIFT(2195),
  [3652] = {.count = 1, .reusable = true}, SHIFT(2190),
  [3654] = {.count = 1, .reusable = true}, SHIFT(2092),
  [3656] = {.count = 1, .reusable = true}, SHIFT(3211),
  [3658] = {.count = 1, .reusable = true}, SHIFT(3210),
  [3660] = {.count = 1, .reusable = true}, SHIFT(2867),
  [3662] = {.count = 1, .reusable = true}, SHIFT(3101),
  [3664] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3666] = {.count = 1, .reusable = true}, SHIFT(2157),
  [3668] = {.count = 1, .reusable = true}, SHIFT(3214),
  [3670] = {.count = 1, .reusable = true}, SHIFT(3213),
  [3672] = {.count = 1, .reusable = false}, SHIFT(2660),
  [3674] = {.count = 1, .reusable = false}, SHIFT(3063),
  [3676] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [3678] = {.count = 1, .reusable = true}, SHIFT(2132),
  [3680] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [3682] = {.count = 1, .reusable = false}, SHIFT(1963),
  [3684] = {.count = 1, .reusable = true}, SHIFT(957),
  [3686] = {.count = 1, .reusable = true}, SHIFT(1042),
  [3688] = {.count = 1, .reusable = true}, SHIFT(961),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3692] = {.count = 1, .reusable = true}, SHIFT(958),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3696] = {.count = 1, .reusable = true}, SHIFT(3089),
  [3698] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [3701] = {.count = 1, .reusable = true}, SHIFT(1942),
  [3703] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3705] = {.count = 1, .reusable = true}, SHIFT(436),
  [3707] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3709] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1081),
  [3713] = {.count = 1, .reusable = true}, SHIFT(440),
  [3715] = {.count = 1, .reusable = true}, SHIFT(1947),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1946),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3723] = {.count = 1, .reusable = true}, SHIFT(448),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1101),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1097),
  [3731] = {.count = 1, .reusable = false}, SHIFT(860),
  [3733] = {.count = 1, .reusable = true}, SHIFT(227),
  [3735] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3737] = {.count = 1, .reusable = true}, SHIFT(695),
  [3739] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3741] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(799),
  [3744] = {.count = 1, .reusable = true}, SHIFT(3098),
  [3746] = {.count = 1, .reusable = true}, SHIFT(736),
  [3748] = {.count = 1, .reusable = true}, SHIFT(1029),
  [3750] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [3752] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [3754] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [3756] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [3758] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3760] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3762] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 29),
  [3764] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 29),
  [3766] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [3768] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [3770] = {.count = 1, .reusable = false}, SHIFT(306),
  [3772] = {.count = 1, .reusable = false}, SHIFT(309),
  [3774] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 29),
  [3776] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 29),
  [3778] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3780] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3782] = {.count = 1, .reusable = false}, SHIFT(286),
  [3784] = {.count = 1, .reusable = true}, SHIFT(151),
  [3786] = {.count = 1, .reusable = true}, SHIFT(896),
  [3788] = {.count = 1, .reusable = false}, SHIFT(289),
  [3790] = {.count = 1, .reusable = false}, SHIFT(104),
  [3792] = {.count = 1, .reusable = false}, SHIFT(356),
  [3794] = {.count = 1, .reusable = true}, SHIFT(290),
  [3796] = {.count = 1, .reusable = true}, SHIFT(291),
  [3798] = {.count = 1, .reusable = true}, SHIFT(286),
  [3800] = {.count = 1, .reusable = false}, SHIFT(290),
  [3802] = {.count = 1, .reusable = false}, SHIFT(291),
  [3804] = {.count = 1, .reusable = false}, SHIFT(292),
  [3806] = {.count = 1, .reusable = true}, SHIFT(293),
  [3808] = {.count = 1, .reusable = true}, SHIFT(289),
  [3810] = {.count = 1, .reusable = true}, SHIFT(294),
  [3812] = {.count = 1, .reusable = false}, SHIFT(1119),
  [3814] = {.count = 1, .reusable = true}, SHIFT(1021),
  [3816] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3818] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3820] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(104),
  [3823] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [3825] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [3827] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [3829] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1041),
  [3833] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [3835] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [3837] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [3839] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3841] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3843] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(104),
  [3846] = {.count = 1, .reusable = true}, SHIFT(213),
  [3848] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 57),
  [3850] = {.count = 1, .reusable = true}, SHIFT(686),
  [3852] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [3854] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3856] = {.count = 1, .reusable = true}, SHIFT(26),
  [3858] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3860] = {.count = 1, .reusable = false}, SHIFT(374),
  [3862] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3864] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(218),
  [3867] = {.count = 1, .reusable = true}, SHIFT(218),
  [3869] = {.count = 1, .reusable = false}, SHIFT(372),
  [3871] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3873] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(222),
  [3876] = {.count = 1, .reusable = true}, SHIFT(222),
  [3878] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [3880] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [3882] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [3884] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [3886] = {.count = 1, .reusable = true}, SHIFT(3085),
  [3888] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [3890] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [3892] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [3894] = {.count = 1, .reusable = true}, SHIFT(24),
  [3896] = {.count = 1, .reusable = true}, SHIFT(3121),
  [3898] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(799),
  [3901] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [3903] = {.count = 1, .reusable = true}, SHIFT(874),
  [3905] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 132),
  [3907] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3909] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3911] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3913] = {.count = 1, .reusable = true}, SHIFT(915),
  [3915] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [3917] = {.count = 1, .reusable = true}, SHIFT(853),
  [3919] = {.count = 1, .reusable = false}, SHIFT(1044),
  [3921] = {.count = 1, .reusable = true}, SHIFT(2861),
  [3923] = {.count = 1, .reusable = true}, SHIFT(778),
  [3925] = {.count = 1, .reusable = false}, SHIFT(439),
  [3927] = {.count = 1, .reusable = true}, SHIFT(729),
  [3929] = {.count = 1, .reusable = true}, SHIFT(795),
  [3931] = {.count = 1, .reusable = false}, SHIFT(1977),
  [3933] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [3936] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 6),
  [3938] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 6),
  [3940] = {.count = 1, .reusable = false}, SHIFT(841),
  [3942] = {.count = 1, .reusable = false}, SHIFT(839),
  [3944] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 136),
  [3946] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 136),
  [3948] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_closing_element, 4, .production_id = 119),
  [3950] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_closing_element, 4, .production_id = 119),
  [3952] = {.count = 1, .reusable = false}, SHIFT(270),
  [3954] = {.count = 1, .reusable = true}, SHIFT(693),
  [3956] = {.count = 1, .reusable = false}, SHIFT(258),
  [3958] = {.count = 1, .reusable = true}, SHIFT(240),
  [3960] = {.count = 1, .reusable = false}, SHIFT(106),
  [3962] = {.count = 1, .reusable = false}, SHIFT(260),
  [3964] = {.count = 1, .reusable = true}, SHIFT(261),
  [3966] = {.count = 1, .reusable = true}, SHIFT(262),
  [3968] = {.count = 1, .reusable = true}, SHIFT(270),
  [3970] = {.count = 1, .reusable = false}, SHIFT(261),
  [3972] = {.count = 1, .reusable = false}, SHIFT(262),
  [3974] = {.count = 1, .reusable = false}, SHIFT(263),
  [3976] = {.count = 1, .reusable = true}, SHIFT(264),
  [3978] = {.count = 1, .reusable = true}, SHIFT(258),
  [3980] = {.count = 1, .reusable = true}, SHIFT(265),
  [3982] = {.count = 1, .reusable = false}, SHIFT(1473),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3986] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 13),
  [3988] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 13),
  [3990] = {.count = 1, .reusable = false}, SHIFT(419),
  [3992] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [3994] = {.count = 1, .reusable = false}, SHIFT(418),
  [3996] = {.count = 1, .reusable = false}, SHIFT(108),
  [3998] = {.count = 1, .reusable = false}, SHIFT(401),
  [4000] = {.count = 1, .reusable = true}, SHIFT(417),
  [4002] = {.count = 1, .reusable = true}, SHIFT(416),
  [4004] = {.count = 1, .reusable = true}, SHIFT(419),
  [4006] = {.count = 1, .reusable = false}, SHIFT(417),
  [4008] = {.count = 1, .reusable = false}, SHIFT(416),
  [4010] = {.count = 1, .reusable = false}, SHIFT(415),
  [4012] = {.count = 1, .reusable = true}, SHIFT(411),
  [4014] = {.count = 1, .reusable = true}, SHIFT(418),
  [4016] = {.count = 1, .reusable = true}, SHIFT(410),
  [4018] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [4020] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [4022] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [4024] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [4026] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 89),
  [4028] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 89),
  [4030] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 5),
  [4032] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 5),
  [4034] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 108),
  [4036] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 108),
  [4038] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 107),
  [4040] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 107),
  [4042] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 99),
  [4044] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 99),
  [4046] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [4048] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [4050] = {.count = 1, .reusable = true}, SHIFT(768),
  [4052] = {.count = 1, .reusable = false}, SHIFT(1691),
  [4054] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [4056] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4058] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4060] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(106),
  [4063] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [4065] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 99),
  [4067] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 99),
  [4069] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [4071] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 97),
  [4073] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 97),
  [4075] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [4077] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [4079] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [4081] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [4083] = {.count = 1, .reusable = true}, SHIFT(669),
  [4085] = {.count = 1, .reusable = true}, SHIFT(628),
  [4087] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 92),
  [4089] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 92),
  [4091] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 47),
  [4093] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 47),
  [4095] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [4097] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(106),
  [4100] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [4102] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [4104] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4107] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4110] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4113] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4116] = {.count = 1, .reusable = true}, SHIFT(864),
  [4118] = {.count = 1, .reusable = false}, SHIFT(1518),
  [4120] = {.count = 1, .reusable = false}, SHIFT(343),
  [4122] = {.count = 1, .reusable = true}, SHIFT(681),
  [4124] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [4126] = {.count = 1, .reusable = false}, SHIFT(344),
  [4128] = {.count = 1, .reusable = true}, SHIFT(206),
  [4130] = {.count = 1, .reusable = false}, SHIFT(107),
  [4132] = {.count = 1, .reusable = false}, SHIFT(396),
  [4134] = {.count = 1, .reusable = true}, SHIFT(257),
  [4136] = {.count = 1, .reusable = true}, SHIFT(347),
  [4138] = {.count = 1, .reusable = true}, SHIFT(343),
  [4140] = {.count = 1, .reusable = false}, SHIFT(257),
  [4142] = {.count = 1, .reusable = false}, SHIFT(347),
  [4144] = {.count = 1, .reusable = false}, SHIFT(348),
  [4146] = {.count = 1, .reusable = true}, SHIFT(359),
  [4148] = {.count = 1, .reusable = true}, SHIFT(344),
  [4150] = {.count = 1, .reusable = true}, SHIFT(360),
  [4152] = {.count = 1, .reusable = false}, SHIFT(1667),
  [4154] = {.count = 1, .reusable = true}, SHIFT(1664),
  [4156] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 52),
  [4158] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 52),
  [4160] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 65), REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4163] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 65),
  [4165] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [4167] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [4169] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4172] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64),
  [4174] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 53),
  [4176] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 53),
  [4178] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4180] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4182] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [4184] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4187] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74),
  [4189] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [4191] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [4193] = {.count = 1, .reusable = true}, SHIFT(752),
  [4195] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4197] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4199] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [4201] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [4203] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4205] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4207] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 54),
  [4209] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 54),
  [4211] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [4214] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4216] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(107),
  [4219] = {.count = 1, .reusable = false}, SHIFT(272),
  [4221] = {.count = 1, .reusable = false}, SHIFT(271),
  [4223] = {.count = 1, .reusable = false}, SHIFT(102),
  [4225] = {.count = 1, .reusable = false}, SHIFT(302),
  [4227] = {.count = 1, .reusable = true}, SHIFT(267),
  [4229] = {.count = 1, .reusable = true}, SHIFT(266),
  [4231] = {.count = 1, .reusable = true}, SHIFT(272),
  [4233] = {.count = 1, .reusable = false}, SHIFT(267),
  [4235] = {.count = 1, .reusable = false}, SHIFT(266),
  [4237] = {.count = 1, .reusable = false}, SHIFT(276),
  [4239] = {.count = 1, .reusable = true}, SHIFT(278),
  [4241] = {.count = 1, .reusable = true}, SHIFT(271),
  [4243] = {.count = 1, .reusable = true}, SHIFT(299),
  [4245] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [4247] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(102),
  [4250] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(815),
  [4253] = {.count = 1, .reusable = true}, SHIFT(3125),
  [4255] = {.count = 1, .reusable = true}, SHIFT(840),
  [4257] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 78),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1102),
  [4261] = {.count = 1, .reusable = true}, SHIFT(2323),
  [4263] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 49),
  [4265] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 49),
  [4267] = {.count = 1, .reusable = false}, SHIFT(1128),
  [4269] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4271] = {.count = 1, .reusable = true}, SHIFT(195),
  [4273] = {.count = 1, .reusable = true}, SHIFT(555),
  [4275] = {.count = 1, .reusable = true}, SHIFT(2220),
  [4277] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(107),
  [4280] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4282] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(108),
  [4285] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4287] = {.count = 1, .reusable = true}, SHIFT(1224),
  [4289] = {.count = 1, .reusable = true}, SHIFT(1223),
  [4291] = {.count = 1, .reusable = false}, SHIFT(2033),
  [4293] = {.count = 1, .reusable = true}, SHIFT(975),
  [4295] = {.count = 1, .reusable = true}, SHIFT(158),
  [4297] = {.count = 1, .reusable = false}, SHIFT(1734),
  [4299] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4301] = {.count = 1, .reusable = false}, SHIFT(1735),
  [4303] = {.count = 1, .reusable = false}, SHIFT(1742),
  [4305] = {.count = 1, .reusable = false}, SHIFT(1769),
  [4307] = {.count = 1, .reusable = false}, SHIFT(1697),
  [4309] = {.count = 1, .reusable = false}, SHIFT(2044),
  [4311] = {.count = 1, .reusable = true}, SHIFT(2379),
  [4313] = {.count = 1, .reusable = false}, SHIFT(1719),
  [4315] = {.count = 1, .reusable = false}, SHIFT(1736),
  [4317] = {.count = 1, .reusable = false}, SHIFT(1741),
  [4319] = {.count = 1, .reusable = false}, SHIFT(1771),
  [4321] = {.count = 1, .reusable = false}, SHIFT(1696),
  [4323] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [4325] = {.count = 1, .reusable = true}, SHIFT(976),
  [4327] = {.count = 1, .reusable = true}, SHIFT(586),
  [4329] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1445),
  [4333] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [4335] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(102),
  [4338] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4340] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4342] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [4344] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [4346] = {.count = 1, .reusable = true}, SHIFT(1022),
  [4348] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(108),
  [4351] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [4353] = {.count = 1, .reusable = true}, SHIFT(532),
  [4355] = {.count = 1, .reusable = false}, SHIFT(2040),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1131),
  [4359] = {.count = 1, .reusable = false}, SHIFT(1716),
  [4361] = {.count = 1, .reusable = false}, SHIFT(1723),
  [4363] = {.count = 1, .reusable = false}, SHIFT(1754),
  [4365] = {.count = 1, .reusable = false}, SHIFT(1767),
  [4367] = {.count = 1, .reusable = false}, SHIFT(1725),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1343),
  [4371] = {.count = 1, .reusable = false}, SHIFT(2031),
  [4373] = {.count = 1, .reusable = true}, SHIFT(2378),
  [4375] = {.count = 1, .reusable = false}, SHIFT(1732),
  [4377] = {.count = 1, .reusable = false}, SHIFT(1728),
  [4379] = {.count = 1, .reusable = false}, SHIFT(1752),
  [4381] = {.count = 1, .reusable = false}, SHIFT(1765),
  [4383] = {.count = 1, .reusable = false}, SHIFT(1722),
  [4385] = {.count = 1, .reusable = true}, SHIFT(2399),
  [4387] = {.count = 1, .reusable = true}, SHIFT(1579),
  [4389] = {.count = 1, .reusable = false}, SHIFT(296),
  [4391] = {.count = 1, .reusable = false}, SHIFT(295),
  [4393] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4395] = {.count = 1, .reusable = true}, SHIFT(1467),
  [4397] = {.count = 1, .reusable = false}, SHIFT(1721),
  [4399] = {.count = 1, .reusable = false}, SHIFT(1710),
  [4401] = {.count = 1, .reusable = false}, SHIFT(1750),
  [4403] = {.count = 1, .reusable = false}, SHIFT(1772),
  [4405] = {.count = 1, .reusable = false}, SHIFT(1713),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1476),
  [4409] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 132),
  [4411] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [4413] = {.count = 1, .reusable = false}, SHIFT(358),
  [4415] = {.count = 1, .reusable = false}, SHIFT(357),
  [4417] = {.count = 1, .reusable = false}, SHIFT(103),
  [4419] = {.count = 1, .reusable = false}, SHIFT(283),
  [4421] = {.count = 1, .reusable = true}, SHIFT(355),
  [4423] = {.count = 1, .reusable = true}, SHIFT(354),
  [4425] = {.count = 1, .reusable = true}, SHIFT(358),
  [4427] = {.count = 1, .reusable = false}, SHIFT(355),
  [4429] = {.count = 1, .reusable = false}, SHIFT(354),
  [4431] = {.count = 1, .reusable = false}, SHIFT(353),
  [4433] = {.count = 1, .reusable = true}, SHIFT(352),
  [4435] = {.count = 1, .reusable = true}, SHIFT(357),
  [4437] = {.count = 1, .reusable = true}, SHIFT(351),
  [4439] = {.count = 1, .reusable = true}, SHIFT(40),
  [4441] = {.count = 1, .reusable = false}, SHIFT(268),
  [4443] = {.count = 1, .reusable = false}, SHIFT(269),
  [4445] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4447] = {.count = 1, .reusable = false}, SHIFT(1744),
  [4449] = {.count = 1, .reusable = false}, SHIFT(1747),
  [4451] = {.count = 1, .reusable = false}, SHIFT(1760),
  [4453] = {.count = 1, .reusable = false}, SHIFT(1781),
  [4455] = {.count = 1, .reusable = false}, SHIFT(1755),
  [4457] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4459] = {.count = 1, .reusable = true}, SHIFT(414),
  [4461] = {.count = 1, .reusable = true}, SHIFT(346),
  [4463] = {.count = 1, .reusable = false}, SHIFT(1651),
  [4465] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4467] = {.count = 1, .reusable = false}, SHIFT(1726),
  [4469] = {.count = 1, .reusable = false}, SHIFT(1624),
  [4471] = {.count = 1, .reusable = true}, SHIFT(311),
  [4473] = {.count = 1, .reusable = true}, SHIFT(2175),
  [4475] = {.count = 1, .reusable = false}, SHIFT(1798),
  [4477] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4479] = {.count = 1, .reusable = true}, SHIFT(1297),
  [4481] = {.count = 1, .reusable = false}, SHIFT(1563),
  [4483] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4485] = {.count = 1, .reusable = false}, SHIFT(1562),
  [4487] = {.count = 1, .reusable = false}, SHIFT(1833),
  [4489] = {.count = 1, .reusable = false}, SHIFT(1701),
  [4491] = {.count = 1, .reusable = false}, SHIFT(1418),
  [4493] = {.count = 1, .reusable = true}, SHIFT(539),
  [4495] = {.count = 1, .reusable = true}, SHIFT(34),
  [4497] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(103),
  [4500] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(186),
  [4503] = {.count = 1, .reusable = true}, SHIFT(186),
  [4505] = {.count = 1, .reusable = true}, SHIFT(1586),
  [4507] = {.count = 1, .reusable = true}, SHIFT(1566),
  [4509] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(185),
  [4512] = {.count = 1, .reusable = true}, SHIFT(185),
  [4514] = {.count = 1, .reusable = true}, SHIFT(545),
  [4516] = {.count = 1, .reusable = true}, SHIFT(541),
  [4518] = {.count = 1, .reusable = false}, SHIFT(1510),
  [4520] = {.count = 1, .reusable = true}, SHIFT(474),
  [4522] = {.count = 1, .reusable = true}, SHIFT(480),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1232),
  [4526] = {.count = 1, .reusable = true}, SHIFT(2524),
  [4528] = {.count = 1, .reusable = true}, SHIFT(903),
  [4530] = {.count = 1, .reusable = true}, SHIFT(116),
  [4532] = {.count = 1, .reusable = true}, SHIFT(821),
  [4534] = {.count = 1, .reusable = true}, SHIFT(119),
  [4536] = {.count = 1, .reusable = true}, SHIFT(2575),
  [4538] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4541] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [4543] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2326),
  [4548] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 75),
  [4550] = {.count = 1, .reusable = true}, SHIFT(2425),
  [4552] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(103),
  [4555] = {.count = 1, .reusable = true}, SHIFT(670),
  [4557] = {.count = 1, .reusable = true}, SHIFT(1127),
  [4559] = {.count = 1, .reusable = true}, SHIFT(2317),
  [4561] = {.count = 1, .reusable = true}, SHIFT(1149),
  [4563] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(735),
  [4566] = {.count = 1, .reusable = true}, SHIFT(3202),
  [4568] = {.count = 1, .reusable = true}, SHIFT(793),
  [4570] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1929),
  [4573] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1850),
  [4576] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4578] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(197),
  [4581] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1563),
  [4584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2465),
  [4587] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2464),
  [4590] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1879),
  [4593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1868),
  [4596] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1562),
  [4599] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1833),
  [4602] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1701),
  [4605] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1623),
  [4608] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1418),
  [4611] = {.count = 1, .reusable = true}, SHIFT(1654),
  [4613] = {.count = 1, .reusable = true}, SHIFT(573),
  [4615] = {.count = 1, .reusable = true}, SHIFT(10),
  [4617] = {.count = 1, .reusable = true}, SHIFT(621),
  [4619] = {.count = 1, .reusable = true}, SHIFT(623),
  [4621] = {.count = 1, .reusable = true}, SHIFT(43),
  [4623] = {.count = 1, .reusable = true}, SHIFT(629),
  [4625] = {.count = 1, .reusable = true}, SHIFT(627),
  [4627] = {.count = 1, .reusable = true}, SHIFT(626),
  [4629] = {.count = 1, .reusable = true}, SHIFT(625),
  [4631] = {.count = 1, .reusable = true}, SHIFT(624),
  [4633] = {.count = 1, .reusable = true}, SHIFT(622),
  [4635] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(815),
  [4638] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4640] = {.count = 1, .reusable = false}, SHIFT(1610),
  [4642] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4644] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4646] = {.count = 1, .reusable = false}, SHIFT(1703),
  [4648] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [4650] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4654] = {.count = 1, .reusable = true}, SHIFT(318),
  [4656] = {.count = 1, .reusable = true}, SHIFT(727),
  [4658] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4660] = {.count = 1, .reusable = true}, SHIFT(381),
  [4662] = {.count = 1, .reusable = false}, SHIFT(18),
  [4664] = {.count = 1, .reusable = true}, SHIFT(3222),
  [4666] = {.count = 1, .reusable = false}, SHIFT(408),
  [4668] = {.count = 1, .reusable = false}, SHIFT(409),
  [4670] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(295),
  [4673] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4676] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4678] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4681] = {.count = 1, .reusable = true}, SHIFT(1675),
  [4683] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(296),
  [4686] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4689] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4691] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4694] = {.count = 1, .reusable = true}, SHIFT(315),
  [4696] = {.count = 1, .reusable = false}, SHIFT(364),
  [4698] = {.count = 1, .reusable = false}, SHIFT(256),
  [4700] = {.count = 1, .reusable = false}, SHIFT(833),
  [4702] = {.count = 1, .reusable = false}, SHIFT(776),
  [4704] = {.count = 1, .reusable = true}, SHIFT(2212),
  [4706] = {.count = 1, .reusable = false}, SHIFT(1614),
  [4708] = {.count = 1, .reusable = false}, SHIFT(334),
  [4710] = {.count = 1, .reusable = false}, SHIFT(337),
  [4712] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4714] = {.count = 1, .reusable = false}, SHIFT(1660),
  [4716] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4718] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4720] = {.count = 1, .reusable = false}, SHIFT(1720),
  [4722] = {.count = 1, .reusable = true}, SHIFT(389),
  [4724] = {.count = 1, .reusable = true}, SHIFT(383),
  [4726] = {.count = 1, .reusable = true}, SHIFT(405),
  [4728] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4731] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [4733] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4736] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(735),
  [4739] = {.count = 1, .reusable = false}, SHIFT(1604),
  [4741] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4743] = {.count = 1, .reusable = false}, SHIFT(1791),
  [4745] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4747] = {.count = 1, .reusable = false}, SHIFT(1620),
  [4749] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4751] = {.count = 1, .reusable = false}, SHIFT(1730),
  [4753] = {.count = 1, .reusable = false}, SHIFT(1683),
  [4755] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4757] = {.count = 1, .reusable = false}, SHIFT(1658),
  [4759] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4761] = {.count = 1, .reusable = false}, SHIFT(1724),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2177),
  [4765] = {.count = 1, .reusable = false}, SHIFT(1812),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2193),
  [4769] = {.count = 1, .reusable = false}, SHIFT(1804),
  [4771] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4773] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4775] = {.count = 1, .reusable = false}, SHIFT(1797),
  [4777] = {.count = 1, .reusable = true}, SHIFT(1862),
  [4779] = {.count = 1, .reusable = false}, SHIFT(1647),
  [4781] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4783] = {.count = 1, .reusable = false}, SHIFT(1727),
  [4785] = {.count = 1, .reusable = false}, SHIFT(1578),
  [4787] = {.count = 1, .reusable = false}, SHIFT(781),
  [4789] = {.count = 1, .reusable = false}, SHIFT(779),
  [4791] = {.count = 1, .reusable = false}, SHIFT(350),
  [4793] = {.count = 1, .reusable = false}, SHIFT(349),
  [4795] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4799] = {.count = 1, .reusable = false}, SHIFT(1821),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4803] = {.count = 1, .reusable = false}, SHIFT(1808),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2171),
  [4807] = {.count = 1, .reusable = false}, SHIFT(1792),
  [4809] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4813] = {.count = 1, .reusable = false}, SHIFT(1822),
  [4815] = {.count = 1, .reusable = true}, SHIFT(705),
  [4817] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4819] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4821] = {.count = 1, .reusable = false}, SHIFT(1824),
  [4823] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2196),
  [4827] = {.count = 1, .reusable = false}, SHIFT(1799),
  [4829] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2170),
  [4833] = {.count = 1, .reusable = false}, SHIFT(1825),
  [4835] = {.count = 1, .reusable = false}, SHIFT(1669),
  [4837] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4839] = {.count = 1, .reusable = false}, SHIFT(1718),
  [4841] = {.count = 1, .reusable = false}, SHIFT(1687),
  [4843] = {.count = 1, .reusable = false}, SHIFT(1613),
  [4845] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4847] = {.count = 1, .reusable = false}, SHIFT(1711),
  [4849] = {.count = 1, .reusable = false}, SHIFT(1608),
  [4851] = {.count = 1, .reusable = false}, SHIFT(1643),
  [4853] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4855] = {.count = 1, .reusable = false}, SHIFT(1709),
  [4857] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2311),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4863] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4865] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2362),
  [4871] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4873] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4875] = {.count = 1, .reusable = true}, SHIFT(154),
  [4877] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2699),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4883] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4885] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2698),
  [4889] = {.count = 1, .reusable = true}, SHIFT(2666),
  [4891] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4893] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4895] = {.count = 1, .reusable = true}, SHIFT(157),
  [4897] = {.count = 1, .reusable = false}, SHIFT(3013),
  [4899] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [4901] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [4903] = {.count = 1, .reusable = false}, SHIFT(3015),
  [4905] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4907] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4909] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4911] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [4913] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [4915] = {.count = 1, .reusable = true}, SHIFT(421),
  [4917] = {.count = 1, .reusable = true}, SHIFT(328),
  [4919] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4921] = {.count = 1, .reusable = true}, SHIFT(2791),
  [4923] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [4925] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [4927] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4929] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4931] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4933] = {.count = 1, .reusable = false}, SHIFT(1789),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2202),
  [4937] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4939] = {.count = 1, .reusable = true}, SHIFT(191),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4943] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4945] = {.count = 1, .reusable = false}, SHIFT(1800),
  [4947] = {.count = 1, .reusable = false}, SHIFT(1787),
  [4949] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4951] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4953] = {.count = 1, .reusable = false}, SHIFT(1806),
  [4955] = {.count = 1, .reusable = false}, SHIFT(1784),
  [4957] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4959] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4961] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4963] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 129),
  [4965] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 129),
  [4967] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 138),
  [4969] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 138),
  [4971] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4973] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4975] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4977] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [4979] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [4981] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4983] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4985] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 183),
  [4987] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 183),
  [4989] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 184),
  [4991] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 184),
  [4993] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 188),
  [4995] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 188),
  [4997] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [4999] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [5001] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 154),
  [5003] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 154),
  [5005] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 103),
  [5007] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 103),
  [5009] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5011] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5013] = {.count = 1, .reusable = true}, SHIFT(1838),
  [5015] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [5017] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2169),
  [5021] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5023] = {.count = 1, .reusable = false}, SHIFT(2353),
  [5025] = {.count = 1, .reusable = false}, SHIFT(2343),
  [5027] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 18),
  [5029] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5035] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5037] = {.count = 1, .reusable = true}, SHIFT(546),
  [5039] = {.count = 1, .reusable = true}, SHIFT(2251),
  [5041] = {.count = 1, .reusable = false}, SHIFT(1605),
  [5043] = {.count = 1, .reusable = false}, SHIFT(1836),
  [5045] = {.count = 1, .reusable = false}, SHIFT(1529),
  [5047] = {.count = 1, .reusable = true}, SHIFT(599),
  [5049] = {.count = 1, .reusable = true}, SHIFT(615),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5053] = {.count = 1, .reusable = true}, SHIFT(1847),
  [5055] = {.count = 1, .reusable = true}, SHIFT(1883),
  [5057] = {.count = 1, .reusable = false}, SHIFT(1706),
  [5059] = {.count = 1, .reusable = false}, SHIFT(1699),
  [5061] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [5063] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [5065] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1868),
  [5068] = {.count = 1, .reusable = false}, SHIFT(1681),
  [5070] = {.count = 1, .reusable = true}, SHIFT(1848),
  [5072] = {.count = 1, .reusable = true}, SHIFT(1885),
  [5074] = {.count = 1, .reusable = false}, SHIFT(1705),
  [5076] = {.count = 1, .reusable = false}, SHIFT(1704),
  [5078] = {.count = 1, .reusable = false}, SHIFT(1790),
  [5080] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5082] = {.count = 1, .reusable = false}, SHIFT(1621),
  [5084] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5086] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5088] = {.count = 1, .reusable = false}, SHIFT(1823),
  [5090] = {.count = 1, .reusable = false}, SHIFT(1753),
  [5092] = {.count = 1, .reusable = false}, SHIFT(1751),
  [5094] = {.count = 1, .reusable = false}, SHIFT(2118),
  [5096] = {.count = 1, .reusable = true}, SHIFT(837),
  [5098] = {.count = 1, .reusable = true}, SHIFT(163),
  [5100] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5102] = {.count = 1, .reusable = true}, SHIFT(720),
  [5104] = {.count = 1, .reusable = true}, SHIFT(860),
  [5106] = {.count = 2, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14), SHIFT(2671),
  [5109] = {.count = 1, .reusable = false}, SHIFT(3116),
  [5111] = {.count = 1, .reusable = true}, SHIFT(2118),
  [5113] = {.count = 1, .reusable = true}, SHIFT(3212),
  [5115] = {.count = 1, .reusable = false}, SHIFT(838),
  [5117] = {.count = 1, .reusable = false}, SHIFT(3087),
  [5119] = {.count = 1, .reusable = false}, SHIFT(3193),
  [5121] = {.count = 1, .reusable = true}, SHIFT(3010),
  [5123] = {.count = 1, .reusable = true}, SHIFT(368),
  [5125] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5127] = {.count = 1, .reusable = true}, SHIFT(1900),
  [5129] = {.count = 1, .reusable = true}, SHIFT(2067),
  [5131] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 119),
  [5133] = {.count = 1, .reusable = true}, SHIFT(1906),
  [5135] = {.count = 1, .reusable = true}, SHIFT(2122),
  [5137] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 47),
  [5139] = {.count = 1, .reusable = true}, SHIFT(1916),
  [5141] = {.count = 1, .reusable = true}, SHIFT(2069),
  [5143] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 153),
  [5145] = {.count = 1, .reusable = true}, SHIFT(1914),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2098),
  [5149] = {.count = 1, .reusable = true}, SHIFT(1915),
  [5151] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_namespace_name, 3),
  [5153] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_namespace_name, 3),
  [5155] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_jsx_namespace_name, 3),
  [5158] = {.count = 1, .reusable = false}, SHIFT(784),
  [5160] = {.count = 1, .reusable = true}, SHIFT(1907),
  [5162] = {.count = 1, .reusable = true}, SHIFT(834),
  [5164] = {.count = 1, .reusable = true}, SHIFT(3033),
  [5166] = {.count = 1, .reusable = true}, SHIFT(2855),
  [5168] = {.count = 1, .reusable = true}, SHIFT(2671),
  [5170] = {.count = 1, .reusable = false}, SHIFT(3001),
  [5172] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 153),
  [5174] = {.count = 1, .reusable = true}, SHIFT(1901),
  [5176] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5178] = {.count = 1, .reusable = true}, SHIFT(1911),
  [5180] = {.count = 1, .reusable = false}, SHIFT(3130),
  [5182] = {.count = 1, .reusable = true}, SHIFT(1913),
  [5184] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 119),
  [5186] = {.count = 1, .reusable = true}, SHIFT(1902),
  [5188] = {.count = 1, .reusable = true}, SHIFT(1909),
  [5190] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 47),
  [5192] = {.count = 1, .reusable = true}, SHIFT(1910),
  [5194] = {.count = 1, .reusable = true}, SHIFT(105),
  [5196] = {.count = 1, .reusable = true}, SHIFT(1905),
  [5198] = {.count = 1, .reusable = true}, SHIFT(1899),
  [5200] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [5203] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 47),
  [5205] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5207] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 153),
  [5209] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 119),
  [5211] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5213] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 119),
  [5215] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 153),
  [5217] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 47),
  [5219] = {.count = 1, .reusable = true}, SHIFT(791),
  [5221] = {.count = 1, .reusable = true}, SHIFT(792),
  [5223] = {.count = 1, .reusable = true}, SHIFT(3185),
  [5225] = {.count = 1, .reusable = true}, SHIFT(810),
  [5227] = {.count = 1, .reusable = false}, SHIFT(812),
  [5229] = {.count = 1, .reusable = false}, SHIFT(1998),
  [5231] = {.count = 1, .reusable = true}, SHIFT(1314),
  [5233] = {.count = 1, .reusable = false}, SHIFT(844),
  [5235] = {.count = 1, .reusable = false}, SHIFT(166),
  [5237] = {.count = 1, .reusable = false}, SHIFT(2016),
  [5239] = {.count = 1, .reusable = false}, SHIFT(2002),
  [5241] = {.count = 1, .reusable = true}, SHIFT(1373),
  [5243] = {.count = 1, .reusable = false}, SHIFT(2012),
  [5245] = {.count = 1, .reusable = false}, SHIFT(2006),
  [5247] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5249] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5251] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5253] = {.count = 1, .reusable = true}, SHIFT(2715),
  [5255] = {.count = 1, .reusable = true}, SHIFT(3063),
  [5257] = {.count = 1, .reusable = false}, SHIFT(2020),
  [5259] = {.count = 1, .reusable = false}, SHIFT(2015),
  [5261] = {.count = 1, .reusable = true}, SHIFT(1329),
  [5263] = {.count = 1, .reusable = true}, SHIFT(700),
  [5265] = {.count = 1, .reusable = false}, SHIFT(2007),
  [5267] = {.count = 1, .reusable = false}, SHIFT(2017),
  [5269] = {.count = 1, .reusable = false}, SHIFT(2009),
  [5271] = {.count = 1, .reusable = true}, SHIFT(1335),
  [5273] = {.count = 1, .reusable = true}, SHIFT(844),
  [5275] = {.count = 1, .reusable = true}, SHIFT(166),
  [5277] = {.count = 1, .reusable = false}, SHIFT(162),
  [5279] = {.count = 1, .reusable = false}, SHIFT(2236),
  [5281] = {.count = 1, .reusable = false}, SHIFT(2027),
  [5283] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5285] = {.count = 1, .reusable = true}, SHIFT(2661),
  [5287] = {.count = 1, .reusable = false}, SHIFT(3019),
  [5289] = {.count = 1, .reusable = false}, SHIFT(3186),
  [5291] = {.count = 1, .reusable = false}, SHIFT(2228),
  [5293] = {.count = 1, .reusable = false}, SHIFT(3060),
  [5295] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(2118),
  [5298] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(163),
  [5301] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90),
  [5303] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90),
  [5305] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(2118),
  [5308] = {.count = 1, .reusable = false}, SHIFT(1995),
  [5310] = {.count = 1, .reusable = false}, SHIFT(3139),
  [5312] = {.count = 1, .reusable = true}, SHIFT(738),
  [5314] = {.count = 1, .reusable = true}, SHIFT(852),
  [5316] = {.count = 1, .reusable = false}, SHIFT(1988),
  [5318] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5320] = {.count = 1, .reusable = false}, SHIFT(2014),
  [5322] = {.count = 1, .reusable = true}, SHIFT(1341),
  [5324] = {.count = 1, .reusable = false}, SHIFT(2258),
  [5326] = {.count = 1, .reusable = true}, SHIFT(1332),
  [5328] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5330] = {.count = 1, .reusable = false}, SHIFT(2024),
  [5332] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [5334] = {.count = 1, .reusable = false}, SHIFT(2013),
  [5336] = {.count = 1, .reusable = false}, SHIFT(3095),
  [5338] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(162),
  [5341] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2471),
  [5344] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2027),
  [5347] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [5350] = {.count = 1, .reusable = false}, SHIFT(2396),
  [5352] = {.count = 1, .reusable = false}, SHIFT(2409),
  [5354] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5356] = {.count = 1, .reusable = false}, SHIFT(2029),
  [5358] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5361] = {.count = 1, .reusable = true}, SHIFT(21),
  [5363] = {.count = 1, .reusable = false}, SHIFT(2429),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2670),
  [5367] = {.count = 1, .reusable = false}, SHIFT(2216),
  [5369] = {.count = 1, .reusable = false}, SHIFT(2392),
  [5371] = {.count = 1, .reusable = false}, SHIFT(2039),
  [5373] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22),
  [5375] = {.count = 1, .reusable = false}, SHIFT(2334),
  [5377] = {.count = 1, .reusable = false}, SHIFT(2037),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2659),
  [5381] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5383] = {.count = 1, .reusable = false}, SHIFT(2393),
  [5385] = {.count = 1, .reusable = false}, SHIFT(2030),
  [5387] = {.count = 1, .reusable = true}, SHIFT(494),
  [5389] = {.count = 1, .reusable = true}, SHIFT(3016),
  [5391] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 146),
  [5393] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 145),
  [5395] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 93),
  [5397] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 128),
  [5399] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 102),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5405] = {.count = 1, .reusable = true}, SHIFT(1749),
  [5407] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2147),
  [5411] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 122),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2126),
  [5417] = {.count = 1, .reusable = true}, SHIFT(449),
  [5419] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [5421] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2144),
  [5425] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2829),
  [5429] = {.count = 1, .reusable = true}, SHIFT(167),
  [5431] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 167),
  [5433] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5435] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5439] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5441] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 115),
  [5443] = {.count = 1, .reusable = true}, SHIFT(301),
  [5445] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [5447] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5449] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [5451] = {.count = 1, .reusable = false}, SHIFT(2090),
  [5453] = {.count = 1, .reusable = true}, SHIFT(1229),
  [5455] = {.count = 1, .reusable = true}, SHIFT(155),
  [5457] = {.count = 1, .reusable = false}, SHIFT(3194),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2995),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5465] = {.count = 1, .reusable = true}, SHIFT(2036),
  [5467] = {.count = 1, .reusable = true}, SHIFT(3067),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5471] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5473] = {.count = 1, .reusable = true}, SHIFT(838),
  [5475] = {.count = 1, .reusable = true}, SHIFT(338),
  [5477] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5481] = {.count = 1, .reusable = true}, SHIFT(2133),
  [5483] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5485] = {.count = 1, .reusable = false}, SHIFT(3034),
  [5487] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5489] = {.count = 1, .reusable = true}, SHIFT(2130),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5493] = {.count = 1, .reusable = true}, SHIFT(3122),
  [5495] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 189),
  [5497] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 186),
  [5499] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 185),
  [5501] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5503] = {.count = 1, .reusable = true}, SHIFT(1962),
  [5505] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5507] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 178),
  [5509] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 177),
  [5511] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 168),
  [5513] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [5515] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5517] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 68),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5523] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5525] = {.count = 1, .reusable = false}, SHIFT(2571),
  [5527] = {.count = 1, .reusable = true}, SHIFT(3179),
  [5529] = {.count = 1, .reusable = true}, SHIFT(3181),
  [5531] = {.count = 1, .reusable = false}, SHIFT(3066),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2090),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5539] = {.count = 1, .reusable = true}, SHIFT(3058),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5543] = {.count = 1, .reusable = false}, SHIFT(1871),
  [5545] = {.count = 1, .reusable = true}, SHIFT(2043),
  [5547] = {.count = 1, .reusable = true}, SHIFT(1985),
  [5549] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5551] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5553] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5555] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5557] = {.count = 1, .reusable = true}, SHIFT(947),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2404),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5563] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5565] = {.count = 1, .reusable = true}, SHIFT(1104),
  [5567] = {.count = 1, .reusable = true}, SHIFT(233),
  [5569] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5571] = {.count = 1, .reusable = true}, SHIFT(1686),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5575] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5577] = {.count = 1, .reusable = true}, SHIFT(1481),
  [5579] = {.count = 1, .reusable = true}, SHIFT(941),
  [5581] = {.count = 1, .reusable = true}, SHIFT(940),
  [5583] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5585] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5587] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5591] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(960),
  [5594] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5596] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5598] = {.count = 1, .reusable = true}, SHIFT(945),
  [5600] = {.count = 1, .reusable = true}, SHIFT(943),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5604] = {.count = 1, .reusable = true}, SHIFT(1505),
  [5606] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5608] = {.count = 1, .reusable = true}, SHIFT(2277),
  [5610] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5612] = {.count = 1, .reusable = true}, SHIFT(950),
  [5614] = {.count = 1, .reusable = true}, SHIFT(444),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5618] = {.count = 1, .reusable = true}, SHIFT(949),
  [5620] = {.count = 1, .reusable = true}, SHIFT(1559),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5624] = {.count = 1, .reusable = false}, SHIFT(1869),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2032),
  [5628] = {.count = 1, .reusable = true}, SHIFT(1984),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5632] = {.count = 1, .reusable = false}, SHIFT(1870),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2048),
  [5636] = {.count = 1, .reusable = true}, SHIFT(1965),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5640] = {.count = 1, .reusable = true}, SHIFT(3142),
  [5642] = {.count = 1, .reusable = true}, SHIFT(589),
  [5644] = {.count = 1, .reusable = true}, SHIFT(249),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2253),
  [5650] = {.count = 1, .reusable = true}, SHIFT(1632),
  [5652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3142),
  [5655] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5657] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(249),
  [5660] = {.count = 1, .reusable = true}, SHIFT(540),
  [5662] = {.count = 1, .reusable = true}, SHIFT(737),
  [5664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2188),
  [5667] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5669] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(233),
  [5672] = {.count = 1, .reusable = true}, SHIFT(946),
  [5674] = {.count = 1, .reusable = true}, SHIFT(1960),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5678] = {.count = 1, .reusable = true}, SHIFT(939),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5682] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5684] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [5686] = {.count = 1, .reusable = true}, SHIFT(948),
  [5688] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [5690] = {.count = 1, .reusable = true}, SHIFT(1168),
  [5692] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5696] = {.count = 1, .reusable = true}, SHIFT(951),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2285),
  [5700] = {.count = 1, .reusable = true}, SHIFT(944),
  [5702] = {.count = 1, .reusable = true}, SHIFT(1056),
  [5704] = {.count = 1, .reusable = true}, SHIFT(953),
  [5706] = {.count = 1, .reusable = true}, SHIFT(952),
  [5708] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1),
  [5710] = {.count = 1, .reusable = true}, SHIFT(1973),
  [5712] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1),
  [5714] = {.count = 1, .reusable = true}, SHIFT(942),
  [5716] = {.count = 1, .reusable = true}, SHIFT(1644),
  [5718] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [5720] = {.count = 1, .reusable = false}, SHIFT(1887),
  [5722] = {.count = 1, .reusable = false}, SHIFT(3109),
  [5724] = {.count = 1, .reusable = true}, SHIFT(1940),
  [5726] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [5728] = {.count = 1, .reusable = true}, SHIFT(19),
  [5730] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 148),
  [5732] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5734] = {.count = 1, .reusable = true}, SHIFT(3055),
  [5736] = {.count = 1, .reusable = false}, SHIFT(2487),
  [5738] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(790),
  [5741] = {.count = 1, .reusable = true}, SHIFT(3204),
  [5743] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [5745] = {.count = 1, .reusable = true}, SHIFT(790),
  [5747] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [5749] = {.count = 1, .reusable = false}, SHIFT(2478),
  [5751] = {.count = 1, .reusable = true}, SHIFT(1768),
  [5753] = {.count = 1, .reusable = true}, SHIFT(1981),
  [5755] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [5757] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 174),
  [5759] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [5761] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 124),
  [5763] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [5765] = {.count = 1, .reusable = true}, SHIFT(1830),
  [5767] = {.count = 1, .reusable = true}, SHIFT(538),
  [5769] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 121),
  [5771] = {.count = 1, .reusable = false}, SHIFT(2466),
  [5773] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 150),
  [5775] = {.count = 1, .reusable = true}, SHIFT(724),
  [5777] = {.count = 1, .reusable = true}, SHIFT(1677),
  [5779] = {.count = 1, .reusable = true}, SHIFT(723),
  [5781] = {.count = 1, .reusable = true}, SHIFT(468),
  [5783] = {.count = 1, .reusable = true}, SHIFT(1764),
  [5785] = {.count = 1, .reusable = true}, SHIFT(1945),
  [5787] = {.count = 1, .reusable = true}, SHIFT(732),
  [5789] = {.count = 1, .reusable = true}, SHIFT(2644),
  [5791] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 174),
  [5793] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 18),
  [5795] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [5797] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 150),
  [5799] = {.count = 1, .reusable = true}, SHIFT(1958),
  [5801] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 148),
  [5803] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 2),
  [5805] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 2),
  [5807] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 170),
  [5809] = {.count = 1, .reusable = true}, SHIFT(1544),
  [5811] = {.count = 1, .reusable = false}, SHIFT(2497),
  [5813] = {.count = 1, .reusable = true}, SHIFT(1626),
  [5815] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [5817] = {.count = 1, .reusable = false}, SHIFT(3141),
  [5819] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 31),
  [5821] = {.count = 1, .reusable = false}, SHIFT(3077),
  [5823] = {.count = 1, .reusable = true}, SHIFT(1826),
  [5825] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5827] = {.count = 1, .reusable = true}, SHIFT(708),
  [5829] = {.count = 1, .reusable = true}, SHIFT(1054),
  [5831] = {.count = 1, .reusable = true}, SHIFT(718),
  [5833] = {.count = 1, .reusable = true}, SHIFT(1545),
  [5835] = {.count = 1, .reusable = false}, SHIFT(1890),
  [5837] = {.count = 1, .reusable = true}, SHIFT(2041),
  [5839] = {.count = 1, .reusable = true}, SHIFT(1953),
  [5841] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 84),
  [5843] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5845] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5847] = {.count = 1, .reusable = true}, SHIFT(1770),
  [5849] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [5851] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5853] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 85),
  [5855] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [5857] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 31),
  [5859] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3),
  [5861] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3),
  [5863] = {.count = 1, .reusable = true}, SHIFT(3155),
  [5865] = {.count = 1, .reusable = true}, SHIFT(798),
  [5867] = {.count = 1, .reusable = true}, SHIFT(766),
  [5869] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 48),
  [5871] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 48),
  [5873] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 181),
  [5875] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5877] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5879] = {.count = 1, .reusable = false}, SHIFT(3094),
  [5881] = {.count = 1, .reusable = false}, SHIFT(3011),
  [5883] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [5885] = {.count = 1, .reusable = false}, SHIFT(3138),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5889] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5891] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [5893] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5895] = {.count = 1, .reusable = false}, SHIFT(3048),
  [5897] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2633),
  [5901] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 181),
  [5903] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 3),
  [5905] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 3),
  [5907] = {.count = 1, .reusable = true}, SHIFT(726),
  [5909] = {.count = 1, .reusable = true}, SHIFT(1873),
  [5911] = {.count = 1, .reusable = false}, SHIFT(3093),
  [5913] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5915] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 121),
  [5917] = {.count = 1, .reusable = true}, SHIFT(447),
  [5919] = {.count = 1, .reusable = true}, SHIFT(1058),
  [5921] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 170),
  [5923] = {.count = 1, .reusable = true}, SHIFT(725),
  [5925] = {.count = 1, .reusable = true}, SHIFT(1966),
  [5927] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 124),
  [5929] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1, .production_id = 96),
  [5931] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5933] = {.count = 1, .reusable = true}, SHIFT(564),
  [5935] = {.count = 1, .reusable = true}, SHIFT(613),
  [5937] = {.count = 1, .reusable = true}, SHIFT(812),
  [5939] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(169),
  [5942] = {.count = 1, .reusable = false}, SHIFT(1874),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5946] = {.count = 1, .reusable = false}, SHIFT(2482),
  [5948] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5950] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5952] = {.count = 1, .reusable = false}, SHIFT(2580),
  [5954] = {.count = 1, .reusable = true}, SHIFT(2913),
  [5956] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [5958] = {.count = 1, .reusable = true}, SHIFT(607),
  [5960] = {.count = 1, .reusable = true}, SHIFT(190),
  [5962] = {.count = 1, .reusable = true}, SHIFT(570),
  [5964] = {.count = 1, .reusable = true}, SHIFT(1774),
  [5966] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [5968] = {.count = 1, .reusable = false}, SHIFT(1038),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5972] = {.count = 1, .reusable = false}, SHIFT(2532),
  [5974] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5978] = {.count = 1, .reusable = false}, SHIFT(2543),
  [5980] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5982] = {.count = 1, .reusable = true}, SHIFT(2948),
  [5984] = {.count = 1, .reusable = false}, SHIFT(123),
  [5986] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5988] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5990] = {.count = 1, .reusable = false}, SHIFT(1875),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5994] = {.count = 1, .reusable = false}, SHIFT(2561),
  [5996] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(165),
  [5999] = {.count = 1, .reusable = false}, SHIFT(2642),
  [6001] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6003] = {.count = 1, .reusable = false}, SHIFT(1026),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2477),
  [6007] = {.count = 1, .reusable = false}, SHIFT(2477),
  [6009] = {.count = 1, .reusable = true}, SHIFT(1982),
  [6011] = {.count = 1, .reusable = false}, SHIFT(429),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2500),
  [6015] = {.count = 1, .reusable = false}, SHIFT(2500),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2503),
  [6019] = {.count = 1, .reusable = false}, SHIFT(2503),
  [6021] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [6023] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [6025] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [6027] = {.count = 1, .reusable = false}, SHIFT(2684),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2564),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2308),
  [6035] = {.count = 1, .reusable = false}, SHIFT(2706),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6039] = {.count = 1, .reusable = false}, SHIFT(427),
  [6041] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [6043] = {.count = 1, .reusable = true}, SHIFT(1983),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2283),
  [6047] = {.count = 1, .reusable = true}, SHIFT(3078),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2389),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2475),
  [6053] = {.count = 1, .reusable = false}, SHIFT(2475),
  [6055] = {.count = 1, .reusable = true}, SHIFT(572),
  [6057] = {.count = 1, .reusable = true}, SHIFT(603),
  [6059] = {.count = 1, .reusable = true}, SHIFT(3158),
  [6061] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(149),
  [6064] = {.count = 1, .reusable = true}, SHIFT(2382),
  [6066] = {.count = 1, .reusable = true}, SHIFT(2364),
  [6068] = {.count = 1, .reusable = true}, SHIFT(2448),
  [6070] = {.count = 1, .reusable = false}, SHIFT(1653),
  [6072] = {.count = 1, .reusable = true}, SHIFT(2528),
  [6074] = {.count = 1, .reusable = false}, SHIFT(2528),
  [6076] = {.count = 1, .reusable = true}, SHIFT(2400),
  [6078] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [6080] = {.count = 1, .reusable = true}, SHIFT(2529),
  [6082] = {.count = 1, .reusable = false}, SHIFT(2529),
  [6084] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2185),
  [6087] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6089] = {.count = 1, .reusable = false}, SHIFT(1665),
  [6091] = {.count = 1, .reusable = false}, SHIFT(977),
  [6093] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [6095] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2532),
  [6098] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2532),
  [6101] = {.count = 1, .reusable = false}, SHIFT(2434),
  [6103] = {.count = 1, .reusable = true}, SHIFT(2539),
  [6105] = {.count = 1, .reusable = false}, SHIFT(2539),
  [6107] = {.count = 1, .reusable = true}, SHIFT(2540),
  [6109] = {.count = 1, .reusable = false}, SHIFT(2540),
  [6111] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [6113] = {.count = 1, .reusable = false}, SHIFT(2432),
  [6115] = {.count = 1, .reusable = true}, SHIFT(614),
  [6117] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [6119] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2543),
  [6122] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2543),
  [6125] = {.count = 1, .reusable = false}, SHIFT(965),
  [6127] = {.count = 1, .reusable = true}, SHIFT(2534),
  [6129] = {.count = 1, .reusable = false}, SHIFT(2534),
  [6131] = {.count = 1, .reusable = true}, SHIFT(2531),
  [6133] = {.count = 1, .reusable = false}, SHIFT(2531),
  [6135] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [6137] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [6139] = {.count = 1, .reusable = true}, SHIFT(544),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2347),
  [6143] = {.count = 1, .reusable = true}, SHIFT(2341),
  [6145] = {.count = 1, .reusable = true}, SHIFT(1955),
  [6147] = {.count = 1, .reusable = true}, SHIFT(554),
  [6149] = {.count = 1, .reusable = false}, SHIFT(139),
  [6151] = {.count = 1, .reusable = true}, SHIFT(974),
  [6153] = {.count = 1, .reusable = true}, SHIFT(1492),
  [6155] = {.count = 1, .reusable = true}, SHIFT(699),
  [6157] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [6159] = {.count = 1, .reusable = true}, SHIFT(1941),
  [6161] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(836),
  [6164] = {.count = 1, .reusable = true}, SHIFT(3050),
  [6166] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [6168] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(848),
  [6171] = {.count = 1, .reusable = true}, SHIFT(2420),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6175] = {.count = 1, .reusable = true}, SHIFT(443),
  [6177] = {.count = 1, .reusable = true}, SHIFT(1959),
  [6179] = {.count = 1, .reusable = true}, SHIFT(1937),
  [6181] = {.count = 1, .reusable = true}, SHIFT(710),
  [6183] = {.count = 1, .reusable = true}, SHIFT(1532),
  [6185] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(797),
  [6188] = {.count = 1, .reusable = true}, SHIFT(433),
  [6190] = {.count = 1, .reusable = true}, SHIFT(2372),
  [6192] = {.count = 1, .reusable = true}, SHIFT(1175),
  [6194] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6196] = {.count = 1, .reusable = true}, SHIFT(445),
  [6198] = {.count = 1, .reusable = true}, SHIFT(1831),
  [6200] = {.count = 1, .reusable = true}, SHIFT(1780),
  [6202] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 173),
  [6204] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [6206] = {.count = 1, .reusable = true}, SHIFT(2376),
  [6208] = {.count = 1, .reusable = true}, SHIFT(1926),
  [6210] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 73),
  [6212] = {.count = 1, .reusable = true}, SHIFT(967),
  [6214] = {.count = 1, .reusable = true}, SHIFT(969),
  [6216] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [6218] = {.count = 1, .reusable = true}, SHIFT(2395),
  [6220] = {.count = 1, .reusable = true}, SHIFT(2383),
  [6222] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6224] = {.count = 1, .reusable = true}, SHIFT(2415),
  [6226] = {.count = 1, .reusable = true}, SHIFT(2356),
  [6228] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [6230] = {.count = 1, .reusable = true}, SHIFT(446),
  [6232] = {.count = 1, .reusable = true}, SHIFT(968),
  [6234] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 79),
  [6236] = {.count = 1, .reusable = true}, SHIFT(1050),
  [6238] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 123),
  [6240] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 187),
  [6242] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 168),
  [6244] = {.count = 1, .reusable = true}, SHIFT(1057),
  [6246] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(788),
  [6249] = {.count = 1, .reusable = true}, SHIFT(1745),
  [6251] = {.count = 1, .reusable = true}, SHIFT(2743),
  [6253] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 73),
  [6255] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 102),
  [6257] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [6259] = {.count = 1, .reusable = true}, SHIFT(1561),
  [6261] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(826),
  [6264] = {.count = 1, .reusable = true}, SHIFT(722),
  [6266] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 177),
  [6268] = {.count = 1, .reusable = true}, SHIFT(1600),
  [6270] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 120),
  [6272] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2488),
  [6275] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6277] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2859),
  [6280] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6282] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [6284] = {.count = 1, .reusable = true}, SHIFT(1083),
  [6286] = {.count = 1, .reusable = true}, SHIFT(3092),
  [6288] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 47),
  [6290] = {.count = 1, .reusable = true}, SHIFT(1085),
  [6292] = {.count = 1, .reusable = true}, SHIFT(2657),
  [6294] = {.count = 1, .reusable = true}, SHIFT(2406),
  [6296] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 73),
  [6298] = {.count = 1, .reusable = true}, SHIFT(2439),
  [6300] = {.count = 1, .reusable = true}, SHIFT(2105),
  [6302] = {.count = 1, .reusable = true}, SHIFT(2394),
  [6304] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 91),
  [6306] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6308] = {.count = 1, .reusable = true}, SHIFT(2490),
  [6310] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [6312] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 89),
  [6314] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 182),
  [6316] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(831),
  [6319] = {.count = 1, .reusable = true}, SHIFT(1832),
  [6321] = {.count = 1, .reusable = true}, SHIFT(1465),
  [6323] = {.count = 1, .reusable = true}, SHIFT(758),
  [6325] = {.count = 1, .reusable = true}, SHIFT(1507),
  [6327] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1, .production_id = 118),
  [6329] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 47),
  [6331] = {.count = 1, .reusable = true}, SHIFT(1512),
  [6333] = {.count = 1, .reusable = true}, SHIFT(1158),
  [6335] = {.count = 1, .reusable = true}, SHIFT(1748),
  [6337] = {.count = 1, .reusable = true}, SHIFT(1024),
  [6339] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [6341] = {.count = 1, .reusable = true}, SHIFT(1479),
  [6343] = {.count = 1, .reusable = true}, SHIFT(1480),
  [6345] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [6347] = {.count = 1, .reusable = true}, SHIFT(1482),
  [6349] = {.count = 1, .reusable = true}, SHIFT(1069),
  [6351] = {.count = 1, .reusable = true}, SHIFT(2227),
  [6353] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(824),
  [6356] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 180),
  [6358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1763),
  [6361] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23),
  [6363] = {.count = 1, .reusable = true}, SHIFT(1682),
  [6365] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1310),
  [6368] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [6370] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 179),
  [6372] = {.count = 1, .reusable = true}, SHIFT(756),
  [6374] = {.count = 1, .reusable = true}, SHIFT(1637),
  [6376] = {.count = 1, .reusable = true}, SHIFT(716),
  [6378] = {.count = 1, .reusable = true}, SHIFT(1075),
  [6380] = {.count = 1, .reusable = true}, SHIFT(1120),
  [6382] = {.count = 1, .reusable = true}, SHIFT(1415),
  [6384] = {.count = 1, .reusable = true}, SHIFT(2279),
  [6386] = {.count = 1, .reusable = true}, SHIFT(703),
  [6388] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 169),
  [6390] = {.count = 1, .reusable = true}, SHIFT(2300),
  [6392] = {.count = 1, .reusable = true}, SHIFT(2615),
  [6394] = {.count = 1, .reusable = true}, SHIFT(1743),
  [6396] = {.count = 1, .reusable = true}, SHIFT(2453),
  [6398] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 167),
  [6400] = {.count = 1, .reusable = true}, SHIFT(1596),
  [6402] = {.count = 1, .reusable = true}, SHIFT(2230),
  [6404] = {.count = 1, .reusable = true}, SHIFT(3207),
  [6406] = {.count = 1, .reusable = true}, SHIFT(1595),
  [6408] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6410] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 147),
  [6412] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 81),
  [6414] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 171),
  [6416] = {.count = 1, .reusable = true}, SHIFT(1739),
  [6418] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 149),
  [6420] = {.count = 1, .reusable = true}, SHIFT(1738),
  [6422] = {.count = 1, .reusable = true}, SHIFT(2125),
  [6424] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 80),
  [6426] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 151),
  [6428] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 128),
  [6430] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 146),
  [6432] = {.count = 1, .reusable = false}, SHIFT(2744),
  [6434] = {.count = 1, .reusable = false}, SHIFT(3031),
  [6436] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 152),
  [6438] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 79),
  [6440] = {.count = 1, .reusable = true}, SHIFT(731),
  [6442] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(809),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6449] = {.count = 1, .reusable = true}, SHIFT(712),
  [6451] = {.count = 1, .reusable = true}, SHIFT(596),
  [6453] = {.count = 1, .reusable = true}, SHIFT(142),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6457] = {.count = 1, .reusable = true}, SHIFT(1524),
  [6459] = {.count = 1, .reusable = true}, SHIFT(140),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6465] = {.count = 1, .reusable = true}, SHIFT(558),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6469] = {.count = 1, .reusable = true}, SHIFT(2679),
  [6471] = {.count = 1, .reusable = true}, SHIFT(2354),
  [6473] = {.count = 1, .reusable = true}, SHIFT(1737),
  [6475] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [6477] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [6479] = {.count = 1, .reusable = true}, SHIFT(2961),
  [6481] = {.count = 1, .reusable = true}, SHIFT(560),
  [6483] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1839),
  [6486] = {.count = 1, .reusable = true}, SHIFT(2325),
  [6488] = {.count = 1, .reusable = true}, SHIFT(2321),
  [6490] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2474),
  [6493] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6495] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 172),
  [6497] = {.count = 1, .reusable = true}, SHIFT(141),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6501] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [6503] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [6505] = {.count = 1, .reusable = true}, SHIFT(212),
  [6507] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 41),
  [6509] = {.count = 1, .reusable = true}, SHIFT(600),
  [6511] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [6513] = {.count = 1, .reusable = true}, SHIFT(1828),
  [6515] = {.count = 1, .reusable = true}, SHIFT(1827),
  [6517] = {.count = 1, .reusable = true}, SHIFT(170),
  [6519] = {.count = 1, .reusable = true}, SHIFT(29),
  [6521] = {.count = 1, .reusable = true}, SHIFT(557),
  [6523] = {.count = 1, .reusable = true}, SHIFT(224),
  [6525] = {.count = 1, .reusable = true}, SHIFT(561),
  [6527] = {.count = 1, .reusable = true}, SHIFT(1517),
  [6529] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 77),
  [6531] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 114),
  [6533] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 116),
  [6535] = {.count = 1, .reusable = true}, SHIFT(36),
  [6537] = {.count = 1, .reusable = true}, SHIFT(2427),
  [6539] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [6541] = {.count = 1, .reusable = true}, SHIFT(473),
  [6543] = {.count = 1, .reusable = true}, SHIFT(1695),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2398),
  [6547] = {.count = 1, .reusable = true}, SHIFT(3218),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2232),
  [6551] = {.count = 1, .reusable = true}, SHIFT(3070),
  [6553] = {.count = 1, .reusable = false}, SHIFT(2145),
  [6555] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6557] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6559] = {.count = 1, .reusable = true}, SHIFT(2314),
  [6561] = {.count = 1, .reusable = true}, SHIFT(3215),
  [6563] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 73),
  [6565] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 109),
  [6567] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 87),
  [6569] = {.count = 1, .reusable = true}, SHIFT(1043),
  [6571] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 87),
  [6573] = {.count = 1, .reusable = true}, SHIFT(548),
  [6575] = {.count = 1, .reusable = true}, SHIFT(1917),
  [6577] = {.count = 1, .reusable = true}, SHIFT(2412),
  [6579] = {.count = 1, .reusable = true}, SHIFT(3053),
  [6581] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6583] = {.count = 1, .reusable = true}, SHIFT(18),
  [6585] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6587] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 41),
  [6589] = {.count = 1, .reusable = true}, SHIFT(580),
  [6591] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 70),
  [6593] = {.count = 1, .reusable = true}, SHIFT(551),
  [6595] = {.count = 1, .reusable = true}, SHIFT(2186),
  [6597] = {.count = 1, .reusable = true}, SHIFT(566),
  [6599] = {.count = 1, .reusable = true}, SHIFT(559),
  [6601] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 137),
  [6603] = {.count = 1, .reusable = true}, SHIFT(1924),
  [6605] = {.count = 1, .reusable = true}, SHIFT(905),
  [6607] = {.count = 1, .reusable = true}, SHIFT(916),
  [6609] = {.count = 1, .reusable = true}, SHIFT(848),
  [6611] = {.count = 1, .reusable = true}, SHIFT(1641),
  [6613] = {.count = 1, .reusable = true}, SHIFT(489),
  [6615] = {.count = 1, .reusable = true}, SHIFT(3017),
  [6617] = {.count = 1, .reusable = true}, SHIFT(677),
  [6619] = {.count = 1, .reusable = true}, SHIFT(241),
  [6621] = {.count = 1, .reusable = true}, SHIFT(247),
  [6623] = {.count = 1, .reusable = true}, SHIFT(250),
  [6625] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6627] = {.count = 1, .reusable = true}, SHIFT(1974),
  [6629] = {.count = 1, .reusable = false}, SHIFT(1478),
  [6631] = {.count = 1, .reusable = true}, SHIFT(809),
  [6633] = {.count = 1, .reusable = false}, SHIFT(3003),
  [6635] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6637] = {.count = 1, .reusable = false}, SHIFT(1333),
  [6639] = {.count = 1, .reusable = true}, SHIFT(836),
  [6641] = {.count = 1, .reusable = true}, SHIFT(431),
  [6643] = {.count = 1, .reusable = true}, SHIFT(1590),
  [6645] = {.count = 1, .reusable = true}, SHIFT(1761),
  [6647] = {.count = 1, .reusable = true}, SHIFT(189),
  [6649] = {.count = 1, .reusable = true}, SHIFT(1757),
  [6651] = {.count = 1, .reusable = true}, SHIFT(3051),
  [6653] = {.count = 1, .reusable = true}, SHIFT(741),
  [6655] = {.count = 1, .reusable = true}, SHIFT(878),
  [6657] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6659] = {.count = 1, .reusable = true}, SHIFT(243),
  [6661] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6663] = {.count = 1, .reusable = true}, SHIFT(244),
  [6665] = {.count = 1, .reusable = true}, SHIFT(245),
  [6667] = {.count = 1, .reusable = true}, SHIFT(246),
  [6669] = {.count = 1, .reusable = true}, SHIFT(824),
  [6671] = {.count = 1, .reusable = true}, SHIFT(899),
  [6673] = {.count = 1, .reusable = true}, SHIFT(255),
  [6675] = {.count = 1, .reusable = true}, SHIFT(2548),
  [6677] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6679] = {.count = 1, .reusable = true}, SHIFT(1430),
  [6681] = {.count = 1, .reusable = true}, SHIFT(1904),
  [6683] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6685] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6687] = {.count = 1, .reusable = true}, SHIFT(826),
  [6689] = {.count = 1, .reusable = true}, SHIFT(697),
  [6691] = {.count = 1, .reusable = true}, SHIFT(828),
  [6693] = {.count = 1, .reusable = true}, SHIFT(210),
  [6695] = {.count = 1, .reusable = true}, SHIFT(215),
  [6697] = {.count = 1, .reusable = true}, SHIFT(178),
  [6699] = {.count = 1, .reusable = true}, SHIFT(238),
  [6701] = {.count = 1, .reusable = true}, SHIFT(794),
  [6703] = {.count = 1, .reusable = true}, SHIFT(2018),
  [6705] = {.count = 1, .reusable = true}, SHIFT(1612),
  [6707] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6709] = {.count = 1, .reusable = true}, SHIFT(842),
  [6711] = {.count = 1, .reusable = true}, SHIFT(831),
  [6713] = {.count = 1, .reusable = true}, SHIFT(2422),
  [6715] = {.count = 1, .reusable = false}, SHIFT(3145),
  [6717] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 77),
  [6719] = {.count = 1, .reusable = true}, SHIFT(892),
  [6721] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6723] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6725] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6727] = {.count = 1, .reusable = true}, SHIFT(1477),
  [6729] = {.count = 1, .reusable = true}, SHIFT(3178),
  [6731] = {.count = 1, .reusable = true}, SHIFT(205),
  [6733] = {.count = 1, .reusable = true}, SHIFT(2650),
  [6735] = {.count = 1, .reusable = true}, SHIFT(3039),
  [6737] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [6739] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6741] = {.count = 1, .reusable = true}, SHIFT(2411),
  [6743] = {.count = 1, .reusable = true}, SHIFT(788),
  [6745] = {.count = 1, .reusable = true}, SHIFT(438),
  [6747] = {.count = 1, .reusable = true}, SHIFT(694),
  [6749] = {.count = 1, .reusable = true}, SHIFT(1472),
  [6751] = {.count = 1, .reusable = true}, SHIFT(1992),
  [6753] = {.count = 1, .reusable = true}, SHIFT(673),
  [6755] = {.count = 1, .reusable = true}, SHIFT(130),
  [6757] = {.count = 1, .reusable = true}, SHIFT(3152),
  [6759] = {.count = 1, .reusable = true}, SHIFT(825),
  [6761] = {.count = 1, .reusable = true}, SHIFT(1040),
  [6763] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6765] = {.count = 1, .reusable = true}, SHIFT(1692),
  [6767] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6769] = {.count = 1, .reusable = true}, SHIFT(1047),
  [6771] = {.count = 1, .reusable = true}, SHIFT(843),
  [6773] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6775] = {.count = 1, .reusable = true}, SHIFT(1060),
  [6777] = {.count = 1, .reusable = true}, SHIFT(2255),
  [6779] = {.count = 1, .reusable = true}, SHIFT(1645),
  [6781] = {.count = 1, .reusable = true}, SHIFT(827),
  [6783] = {.count = 1, .reusable = true}, SHIFT(1059),
  [6785] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6787] = {.count = 1, .reusable = true}, SHIFT(818),
  [6789] = {.count = 1, .reusable = true}, SHIFT(3180),
  [6791] = {.count = 1, .reusable = true}, SHIFT(877),
  [6793] = {.count = 1, .reusable = true}, SHIFT(413),
  [6795] = {.count = 1, .reusable = true}, SHIFT(412),
  [6797] = {.count = 1, .reusable = true}, SHIFT(228),
  [6799] = {.count = 1, .reusable = true}, SHIFT(3161),
  [6801] = {.count = 1, .reusable = true}, SHIFT(2282),
  [6803] = {.count = 1, .reusable = false}, SHIFT(3159),
  [6805] = {.count = 1, .reusable = true}, SHIFT(1172),
  [6807] = {.count = 1, .reusable = true}, SHIFT(805),
  [6809] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6811] = {.count = 1, .reusable = true}, SHIFT(817),
  [6813] = {.count = 1, .reusable = true}, SHIFT(913),
  [6815] = {.count = 1, .reusable = true}, SHIFT(1468),
  [6817] = {.count = 1, .reusable = true}, SHIFT(229),
  [6819] = {.count = 1, .reusable = true}, SHIFT(230),
  [6821] = {.count = 1, .reusable = true}, SHIFT(231),
  [6823] = {.count = 1, .reusable = true}, SHIFT(1107),
  [6825] = {.count = 1, .reusable = true}, SHIFT(3114),
  [6827] = {.count = 1, .reusable = true}, SHIFT(876),
  [6829] = {.count = 1, .reusable = true}, SHIFT(802),
  [6831] = {.count = 1, .reusable = true}, SHIFT(1542),
  [6833] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6835] = {.count = 1, .reusable = true}, SHIFT(897),
  [6837] = {.count = 1, .reusable = true}, SHIFT(845),
  [6839] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6841] = {.count = 1, .reusable = true}, SHIFT(2222),
  [6843] = {.count = 1, .reusable = true}, SHIFT(801),
  [6845] = {.count = 1, .reusable = true}, SHIFT(1685),
  [6847] = {.count = 1, .reusable = true}, SHIFT(1987),
  [6849] = {.count = 1, .reusable = true}, SHIFT(763),
  [6851] = {.count = 1, .reusable = true}, SHIFT(3069),
  [6853] = {.count = 1, .reusable = true}, SHIFT(771),
  [6855] = {.count = 1, .reusable = true}, SHIFT(1513),
  [6857] = {.count = 1, .reusable = true}, SHIFT(1088),
  [6859] = {.count = 1, .reusable = true}, SHIFT(2668),
  [6861] = {.count = 1, .reusable = true}, SHIFT(1089),
  [6863] = {.count = 1, .reusable = true}, SHIFT(8),
  [6865] = {.count = 1, .reusable = true}, SHIFT(3057),
  [6867] = {.count = 1, .reusable = true}, SHIFT(761),
  [6869] = {.count = 1, .reusable = false}, SHIFT(1509),
  [6871] = {.count = 1, .reusable = true}, SHIFT(797),
  [6873] = {.count = 1, .reusable = true}, SHIFT(862),
  [6875] = {.count = 1, .reusable = true}, SHIFT(800),
  [6877] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6879] = {.count = 1, .reusable = true}, SHIFT(749),
  [6881] = {.count = 1, .reusable = true}, SHIFT(2445),
  [6883] = {.count = 1, .reusable = true}, SHIFT(829),
  [6885] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6887] = {.count = 1, .reusable = true}, SHIFT(746),
  [6889] = {.count = 1, .reusable = true}, SHIFT(1990),
  [6891] = {.count = 1, .reusable = false}, SHIFT(1202),
  [6893] = {.count = 1, .reusable = true}, SHIFT(895),
  [6895] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6897] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [6899] = {.count = 1, .reusable = true}, SHIFT(184),
  [6901] = {.count = 1, .reusable = true}, SHIFT(253),
  [6903] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [6905] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6907] = {.count = 1, .reusable = true}, SHIFT(2073),
  [6909] = {.count = 1, .reusable = true}, SHIFT(3047),
  [6911] = {.count = 1, .reusable = true}, SHIFT(742),
  [6913] = {.count = 1, .reusable = true}, SHIFT(832),
  [6915] = {.count = 1, .reusable = true}, SHIFT(1521),
  [6917] = {.count = 1, .reusable = true}, SHIFT(3183),
  [6919] = {.count = 1, .reusable = true}, SHIFT(3197),
  [6921] = {.count = 1, .reusable = true}, SHIFT(2025),
  [6923] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [6925] = {.count = 1, .reusable = true}, SHIFT(920),
  [6927] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [6929] = {.count = 1, .reusable = false}, SHIFT(3008),
  [6931] = {.count = 1, .reusable = true}, SHIFT(1933),
  [6933] = {.count = 1, .reusable = true}, SHIFT(2242),
  [6935] = {.count = 1, .reusable = true}, SHIFT(786),
  [6937] = {.count = 1, .reusable = true}, SHIFT(906),
  [6939] = {.count = 1, .reusable = true}, SHIFT(753),
  [6941] = {.count = 1, .reusable = true}, SHIFT(755),
  [6943] = {.count = 1, .reusable = true}, SHIFT(1129),
  [6945] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6947] = {.count = 1, .reusable = true}, SHIFT(911),
  [6949] = {.count = 1, .reusable = true}, SHIFT(620),
  [6951] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [6953] = {.count = 1, .reusable = true}, SHIFT(850),
  [6955] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6957] = {.count = 1, .reusable = true}, SHIFT(898),
  [6959] = {.count = 1, .reusable = true}, SHIFT(900),
  [6961] = {.count = 1, .reusable = true}, SHIFT(1625),
  [6963] = {.count = 1, .reusable = true}, SHIFT(908),
  [6965] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 77),
  [6967] = {.count = 1, .reusable = true}, SHIFT(181),
  [6969] = {.count = 1, .reusable = true}, SHIFT(861),
  [6971] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 77),
  [6973] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6975] = {.count = 1, .reusable = true}, SHIFT(3126),
  [6977] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6979] = {.count = 1, .reusable = true}, SHIFT(1989),
  [6981] = {.count = 1, .reusable = true}, SHIFT(1872),
  [6983] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6985] = {.count = 1, .reusable = true}, SHIFT(2101),
  [6987] = {.count = 1, .reusable = true}, SHIFT(2309),
  [6989] = {.count = 1, .reusable = true}, SHIFT(676),
  [6991] = {.count = 1, .reusable = true}, SHIFT(754),
  [6993] = {.count = 1, .reusable = true}, SHIFT(2294),
  [6995] = {.count = 1, .reusable = true}, SHIFT(921),
  [6997] = {.count = 1, .reusable = true}, SHIFT(750),
  [6999] = {.count = 1, .reusable = true}, SHIFT(182),
  [7001] = {.count = 1, .reusable = true}, SHIFT(1672),
  [7003] = {.count = 1, .reusable = true}, SHIFT(814),
};

void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
  };
  return &language;
}
